#include <stdio.h>

#define dim 151

long long unsigned A[dim][dim][dim];

int N;

void get_data();
void dynamics();
void print();

int main()
{
    get_data();
    dynamics();
    print();

    return 0;
}

void get_data()
{
    freopen("munte.in", "r", stdin);

    scanf("%d", &N);

	N <<= 1; N -= 2;

    fclose(stdin);
}

void dynamics()
{
    int i, j, k;

	A[0][0][0] = 1;

	for(k=1; k<=N; ++k)
	{
		for(i=0; i<=N; ++i)
            for(j=0; j<=N; ++j)
				if(i == 0 && j >= 2)
				{
					A[i][j][k] += A[i][j-2][k-2];

					if(i+1 <= N)
					{
						A[i][j][k] += A[i+1][j-1][k-1];
						A[i][j][k] -= A[i][j-2][k-2];
					}
				}
				else
				{
					if(j-2 >= 0 && k-2 >= 0)
						A[i][j][k] += A[i][j-2][k-2];
					if(i-1 >= 0 && j-1 >= 0)
						A[i][j][k] += A[i-1][j-1][k-1];
					if(i+1 <= N && j-1 >= 0)
						A[i][j][k] += A[i+1][j-1][k-1];
				}
	}
}

void print()
{
    freopen("munte.out", "w", stdout);

    int i;

    long long unsigned ret = 0;

	for(i=0; i<=N; ++i)
		ret += A[0][i][N];

    printf("%llu", ret);

    fclose(stdout);
}
