#include <cstdio>

#define dim 100001
#define inf 0x3f3f3f3f3f

struct Punct
{   long x, y;
} A[dim];

long N, M;

void get_print_data();

long long unsigned solve(long);

int main()
{
    get_print_data();

    return 0;
}

void get_print_data()
{
    freopen("puncte.in", "r", stdin);
    freopen("puncte.out", "w", stdout);

    scanf("%ld %ld", &N, &M);

    long i, x;
    for(i=1; i<=N; ++i)
        scanf("%ld %ld", &A[i].x, &A[i].y);

    for(i=1; i<=M; ++i)
    {
        scanf("%ld", &x);
        printf("%llu\n", solve(x));
    }

    fclose(stdin);
    fclose(stdout);
}

long long unsigned solve(long x)
{
    long i;
    long long unsigned ret, d;
    for(i=1; i<=N; ++i)
    {
        d = A[i].x > x ? A[i].x - x : x - A[i].x;
        d *= d;
        d += A[i].y * A[i].y;

        if(d < ret) ret = d;
    }

    return ret;
}

