#include <stdio.h>
#include <iostream>

using namespace std;

const int maxN = 101;

typedef int lnum[101];
int n;

lnum t[ 2*maxN+20 ][ maxN+20 ];

int dx[] = {-2, -1, -1 };
int dy[] = { 0, -1,  1 };


void add( lnum &dest, lnum &a, lnum &b )
{
	int i;
	int n = max( a[0], b[0] );
	dest[0] = n;

	for ( i = 1; i <= n; i++ )
	{
		dest[i] = a[i] + b[i];
		if ( dest[i] > 9 )
		{
			dest[i+1] = dest[i]/10;
			dest[i] = dest[i]%10;
			if ( dest[i+1] && i == n ) dest[0]++;
		}
	}
}

void sub( lnum &dest, lnum &a, lnum &b )
{
	int i;
	int n = b[0];

	for ( i = 1; i <= n; i++ )
	{
		dest[i] = a[i] - b[i];
		if ( dest[i] < 0 ) { dest[i] += 10; dest[i+1] -= 1; }
	}
	while ( dest[ dest[0] ] == 0 ) dest[0]--;
}

int main()
{
	int i,j,l;
	int nx,ny;
	freopen("munte.in","r",stdin);
	freopen("munte.out","w",stdout);

	scanf("%d\n", &n);
	
	t[0][0][0] = t[0][0][1] = 1;

	for ( i = 0; i <= 2*n+10; i++ )
		for ( j = 0; j <= i+10; j++ )
	{
		for ( l = 0; l < 3; l++ )
		{
			nx = i + dx[l];
			ny = j + dy[l];
			
			if ( nx >= 0 && ny >= 0 )
			if ( t[nx][ny][0] )
				add( t[i][j], t[i][j], t[nx][ny] );

			if ( l == 2 && j == 0 && i >= 2 )
				sub( t[i][j], t[i][j], t[i-2][j] );
		}
	}

	for ( i = t[2*n-2][0][0]; i >= 1; i-- )
		printf("%d", t[2*n-2][0][i] );

	fclose(stdin);
	fclose(stdout);

	return 0;
}
	
