// dist
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>

const int MAX_L = 512; // lung max propozitie
const int MAX_S = 25; // lung max cuv.
const int MAX_W = 105; // nr. max cuv.
const int INF = 200000;

char ph1[MAX_L], ph2[MAX_L];
char W[MAX_W][MAX_S];
int N, A[MAX_W][MAX_L];

char S1[MAX_S];

inline int abs(int a) {
	if (a >= 0)
		return a;
	return a * (- 1);
}

int DIST(int st, int len, int iw) {
	int i, j, lenw = strlen(W[iw]);
	strcpy(S1, "");
	for (i = st; i < st + len; ++ i) {
		S1[i - st] = ph2[i];
		//printf("%c", ph2[i]);
	}
	//printf("\n");
	S1[i] = 0;
	
	int lmin = strlen(W[iw]), dif = 0;
	if (len < lmin)
		lmin = len;
	for (i = 0; i < lmin; ++ i) {
		//printf("%c %c %d\n", W[iw][i], S1[i], abs(W[iw][i] - S1[i]));
		dif += abs(W[iw][i] - S1[i]);
	}
	if (lenw == lmin) {
		for (; i < len; ++ i) {
			
			dif += S1[i] - '@';
			/*if (S1[i] - '@' < 0)
				printf(":%c", S1[i]);*/
		}
	} else {
		for (; i < lenw; ++ i) {
			//printf("%c %d\n", W[iw][i], W[iw][i] - '@');
			dif += W[iw][i] - '@';
		}
	}
	
	/*if (dif < 0)
		printf("%d ", dif);*/
	
	return dif;
}

int main(void) {
	FILE *in = fopen("dist.in", "r");
	fgets(ph1, MAX_L, in);
	int len1, len2;
	len1 = strlen(ph1);
	if (ph1[len1 - 1] == '\n')
		ph1[len1 - 1] = 0;
		
	fgets(ph2, MAX_L, in);
	len2 = strlen(ph2);
	if (ph2[len2 - 1] == '\n')
		ph2[len2 - 1] = 0;
	char *p;
	int i, j;
	for (i = 0, p = strtok(ph1, " "); p != NULL; p = strtok(NULL, " "), ++ i)
		strcpy(W[i], p);
	fclose(in);
	
	N = i;
	strcpy(ph1, ph2);
	strcpy(ph2, "");
	for (p = strtok(ph1, " "); p != NULL; p = strtok(NULL, " "))
		strcat(ph2, p);
	len2 = strlen(ph2);
	
	int c, k, dist, min, len, dn;
	for (c = 1; c <= N; ++ c)
		for (i = 1; i <= len2; ++ i)
			A[c][i] = INF;
	A[0][0] = 0;
	for (len = 0; len <= len2; ++ len) {
		dn = DIST(0, len, 0);
		if (dn < A[1][len])
			A[1][len] = dn;
	}
	for (c = 1; c <= N; ++ c) {
		for (i = 1; i <= len2; ++ i)
			for (len = 0; len <= len2 - i + 1; ++ len) {
				dn = A[c][i] + DIST(i, len, c);
				if (dn < A[c + 1][i + len])
					A[c + 1][i + len] = dn;
			}
	}
	
	//printf("%d\n", DIST(0, 1, 0));
	
	/*int c;
	for (c = 1; c <= N; ++ c) {
		for (j = 1; j <= len2; ++ j) {
			dist = DIST(j - 1, 1, i - 1);
			min = A[c - 1][j - 1] + dist;
		}
	}*/
	
	
	FILE *out = fopen("dist.out", "w");
	fprintf(out, "%d\n", A[N][len2]);
	fclose(out);
	
	/*for (i = 0; i <= N; ++ i) {
		for (j = 0; j <= len2; ++ j)
			printf("%3d ", A[i][j]);
		printf("\n");
	}*/
	
	return 0;
}
