#include <stdio.h>

#define NMAX 210
#define CMAX 20
#define BASE 100000000
#define FORMAT "%08d"

int N;

int din[NMAX][NMAX][CMAX];
int a[NMAX][2][CMAX];

inline void add(int a[], int b[])
{
	int t = 0, i;

	for (i = 1; i <= a[0] || i <= b[0] || t; i++, t /= BASE)
		a[i] = (t += a[i] + b[i]) % BASE;

	a[0] = i - 1;
}

void print(int a[])
{
	int i;

	printf("%d", a[a[0]]);

	for (i = a[0] - 1; i >= 1; i--)
		printf(FORMAT, a[i]);
	printf("\n");
}

int rez = 0;

int sol[20];

void back(int x, int y, int ant, int niv)
{
	if (x == 2 * N - 2) {
		rez += y == 0;
		if (!y) {
//			for (int i = 1; i < niv; i++) printf("%d ", sol[i]);
//			printf("\n");
		}
		return;
	}

	if (x > 2 * N - 2) return;

	sol[niv] = 0;
	back(x + 2, y, y == 0, niv + 1);
	sol[niv] = 1;
	back(x + 1, y + 1, y == 0, niv + 1);
	sol[niv] = -1;
	if (y > 0 && !ant) back(x + 1, y - 1, y == 0, niv + 1);
}

int main()
{
	int i, j;

	freopen("munte.in", "r", stdin);
	freopen("munte.out", "w", stdout);

	scanf("%d", &N);

	din[0][0][0] = 1;
	din[0][0][1] = 1;

	for (i = 1; i <= 2 * N - 2; i++) {
		for (j = 0; j <= i; j++) {
			if (j == 1) {
				if (i >= 2) {
//					a[i][0] += a[i - 2][0] + a[i - 2][1];
					add(a[i][0], a[i-2][0]);
					add(a[i][0], a[i-2][1]);
				}
//				a[i][0] += din[i-1][j + 1];
				add(a[i][0], din[i-1][j+1]);
		
//				a[i][1] += din[i-1][0];
				add(a[i][1], din[i-1][0]);
			} else {
				if (i >= 2) {
//					din[i][j] += din[i - 2][j];
					add(din[i][j], din[i-2][j]);
				}

				if (j == 0) {
//					din[i][j] += a[i-1][0];
					add(din[i][j], a[i-1][0]);
				} else {
//					din[i][j] += din[i-1][j + 1];
					add(din[i][j], din[i-1][j+1]);
				}

				if (j == 2) {
//					din[i][j] += a[i-1][0] + a[i-1][1];
					add(din[i][j], a[i-1][0]);
					add(din[i][j], a[i-1][1]);
				} else 
				if (j >= 1) {
//					din[i][j] += din[i-1][j-1];
					add(din[i][j], din[i-1][j-1]);
				}
			}
		}
	}

	print(din[2 * N - 2][0]);

//	back(0, 0, 1, 1);

//	printf("%d\n", rez);

fclose(stdin);
fclose(stdout);
return 0;
}

