#include <stdio.h>
#define NMAX 100002
#define INF 10000000

FILE *f = fopen("puncte.in","rt"), *g = fopen("puncte.out","wt");

struct punct{long int x,y;};

long int n,m,ab[2*NMAX],i,j,k,val[2*NMAX],pct1[NMAX*2];
punct pct[NMAX];

long int length(long int x, long int y)
{
return (ab[x]-pct[y].x)*(ab[x]-pct[y].x)+pct[y].y;
}


void citire()
{
fscanf(f,"%ld %ld",&n,&m);

for (i=1;i<=n;i++)
        fscanf(f,"%ld %ld",&pct[i].x,&pct[i].y);
for (i=1;i<=m;i++)
        fscanf(f,"%ld",&ab[i]);
}

long int MINN(long int a, long int b)
{
if (a<b) return a;
return b;
}

long int search(long int x)
{long int st,dr,mid;
st=1;dr=m;
while (st-dr>1)
        {
        mid=(st+dr)/2;
        if (ab[mid]<x) st=mid;
                else dr=mid;
        }
return dr;
}

void init()
{
long int i;
for (i=1;i<=m;i++)
        val[i]=INF;
}

void solve_brut()
{
long int min,j;
pct1[0]=1;
init();
for (i=1;i<=n;i++)
        {
        j=search(pct[i].x);
        if (j>1) j--;
        if (val[j]>length(ab[j],i)) {val[j]=length(j,i);
                                 pct1[j]=i;
                                 }
        if (j>1) j--;
        if (val[j]>length(ab[j],i)) {val[j]=length(ab[j],i);
                                 pct1[j]=i;
                                 }
        if (j<m-3) j+=3;
        if (val[j]>length(ab[j],i)) {val[j]=length(ab[j],i);
                                 pct1[j]=i;
                                 }
        if (j<m) j++;
        if (val[j]>length(ab[j],i)) {val[j]=length(ab[j],i);
                                 pct1[j]=i;
                                 }
        }

for (i=1;i<=m;i++)
        if (val[i]==INF)
        {
        min=INF;
        for (j=pct1[i-1];j<=n;j++)
                 if (val[i]>length(i,j)) {val[i]=length(i,j);
                                         pct1[i]=j;}
        }
}

void solve_kkt()
{
init();
long int cnt,dist,prec;
cnt=1;
for (i=1;i<=m;i++)
        {
        prec=INF;
        dist=length(i,cnt);
        while (dist<prec)
                {prec=dist;
                dist=length(i,cnt);
                cnt++;
                }
        val[i]=prec;
        }
        
}

void solve_brutf()
{
init();
for (i=1;i<=m;i++)
        if (val[i]==INF)
        {
        for (j=1;j<=n;j++)
                 if (val[i]>length(i,j)) {val[i]=length(i,j);
                                         pct1[i]=j;}
        }
}

int main()
{
citire();
if (n*m<10000000) solve_brutf();
   else if (n*m<200000000) solve_brut();
        else solve_kkt();
for (i=1;i<=m;i++)
        fprintf(g,"%ld\n",val[i]);
fclose(f);
fclose(g);
return 0;

}
