#include <cstdio>
#include <cstring>

#define FIN "dist.in"
#define FOUT "dist.out"
#define MAX 501
#define NRC 104
#define LEN 22
#define inf 0x3f3f

inline long abs(long x) {
	return x<0 ? -x : x;
}

long A[2][NRC][LEN], S[MAX];
char P1[MAX], P2[MAX];
long LC[NRC], LS[MAX];
long n,m, nr_cuv;
bool ok;

void read(char *s, long &n) {
	char buf[MAX];
   long t,i, len;
	fgets(buf, MAX, stdin);
	t = strlen(buf);
	LS[0] = 0;
	len= 0;
	for (i=0; i<t; ++i) {
		if ( buf[i]<='Z' && buf[i]>='A' ) {
			s[n++] = buf[i];
         len++;
		}
		if ( !ok )
			continue;
		if ( buf[i]==' ' && buf[i-1]<='Z' && buf[i-1]>='A' ) {
			LC[nr_cuv] = len;
			len = 0;
			LS[nr_cuv+1] = LS[nr_cuv] + LC[nr_cuv];
			++nr_cuv;
		}
	}
	if ( ok ) {
 		LC[nr_cuv] = len;
		len = 0;
		LS[nr_cuv+1] = LS[nr_cuv] + LC[nr_cuv];
		++nr_cuv;

   }
}

int main() {
	freopen(FIN, "r", stdin);
	ok = true;
	read(P1,n);
	ok = false;
	read(P2,m);
	fclose(stdin);

	long i,j, cuv, act,prev;

	for (i=0; i<m; ++i) {
		if ( i==0 ) {
			for (cuv=0; cuv<=nr_cuv; ++cuv)
				for (j=0; j<20; ++j)
					A[0][cuv][j] = inf;
			A[0][0][0] = abs(P1[0]-P2[0]);
			continue;
		}
		act = i%2;
		prev = (i-1)%2;
		for (cuv=0; cuv<=nr_cuv; ++cuv)
			for (j=0; j<20; ++j) {
				if ( i>LS[cuv]+j ) {		// il bagam prea aproapre
					A[act][cuv][j] = inf;
					continue;
				}
				if ( cuv==0 && j<i ){		// P2[0] sta sub P1[0] mereu
					A[act][cuv][j] = inf;
					continue;
				}
					
				if ( j==0 && cuv>0 ) {		// il adaug la un cuv nou
					if ( cuv>i ) {
						A[act][cuv][j] = inf;
						continue;
					}
					long x=inf, y, temp;
					for (y=0; y<20; ++y) {
						if ( x>A[prev][cuv-1][y] )
							x=A[prev][cuv-1][y];
					}
					A[act][cuv][j] = abs(P1[LS[cuv]]-P2[i])+x;
//					fprintf(stderr, "%ld %ld %ld - %ld %c %c\n",i,cuv,j,LS[cuv], P1[LS[cuv]], P2[i]);
					continue;
				}
				
				if ( j<LC[cuv] ) {
					A[act][cuv][j] = A[prev][cuv][j-1] + abs(P1[LS[cuv]+j]-P2[i]);
//					fprintf(stderr, "%ld %c\n", LS[cuv]+j, P1[LS[cuv]+j]);
				}
				else
					A[act][cuv][j] = A[prev][cuv][j-1] + abs(P2[i]-64);
			}
	}

/*	
	for (i=0; i<m; ++i) {
		printf("Pt litera %ld:\n", i);
		for (cuv=0; cuv<=nr_cuv; ++cuv) {
			for (j=0; j<20; ++j)
				printf("%7ld", A[i][cuv][j]);
			printf("\n");
		}
		printf("\n\n");
	}
*/
	long dist = inf;
	i=(m-1)%2;
	for (cuv=0; cuv<=nr_cuv; ++cuv)
		for (j=0; j<20; ++j)
			if ( A[i][cuv][j] < dist )
				dist = A[i][cuv][j];
	
	freopen(FOUT, "w", stdout); 
	printf("%ld\n", dist);
	fclose(stdout);
	return 0;
}
