#include <cstdio>

#define FIN "munte.in"
#define FOUT "munte.out"
#define MAX 300
#define tip numar
#define __debug__ 0

#define nrc 30
#define base 100000000

long n;

class numar {
	public:
	long A[nrc];
	numar() {
		A[0] = 0;
		A[1] = 0;
	}
	void operator=(long x) {
		for (A[0] = 1; x; A[0]++, x/=base)
			A[A[0]] = x%base;
      A[0]--;
	}
	void operator+=(numar B) {
		long i,t;
		for (i=1,t=0; i<=A[0] || i<=B.A[0] || t; ++i, t/=base)
			A[i] = (t+=A[i]+B.A[i]) % base;
		A[0] = i-1;
	}
	void write() {
		long i,p;
		printf("%ld", A[A[0]]);
		for (i=A[0]-1; i; --i) {
			for (p=base/10; p; p/=10)
				printf("%ld", (A[i]/p)%10);
		}
		printf("\n");
	}
};

tip S[MAX][MAX];

void dinamica() {
	long i,j;

	S[0][0] = 1;
	for (i=1; i<=n; ++i) 
		for (j=0; j<=n; ++j) {
			S[i][j] += S[i-1][j+1];
         if ( j )
             S[i][j] += S[i-1][j-1];

			if ( i>1 ) {
				if (j==0 && i%2==0)
					continue;
				S[i][j] += S[i-2][j];
			}
 		}
}

void debug() {
	long i,j;	
	for (i=n; i>=0; --i) {
		for (j=0; j<=n; ++j)
			S[i][j].write();
		printf("\n");
	}
}

int main() {
	freopen(FIN,"r", stdin);
	scanf("%ld", &n);
	fclose(stdin);

	n = 2*n-2;
	dinamica();
	if (__debug__)
		debug();

	freopen(FOUT, "w", stdout);
	S[n][0].write();
	//printf("%llu\n", S[n][0]);
	fclose(stdout);
	return 0;
}
