/*
   * * * * * * * * * * *
   * Alexandru Traista * 
   *                   *
   *    Baraj 1 P3     *
   * * * * * * * * * * *
*/
#include <stdio.h>
#define Nmax 100
#define Mmax 200
#define lim 300000
#define C1 2000
#define min(a,b)((a)>(b)?(b):(a))
#define max(a,b)((a)>(b)?(a):(b))

struct punct
{long x,y;
};

long n,m,M[Mmax];
punct N[Nmax];

void cit()
{FILE *f=fopen("puncte.in","r");
long i;
fscanf(f,"%ld %ld",&n,&m);
for(i=1;i<=n;i++)
 fscanf(f,"%ld %ld",&N[i].x,&N[i].y);
for(i=1;i<=m;i++)
 fscanf(f,"%ld",&M[i]);
fclose(f);
}

long long dist(punct m,long x)
{
 long a=m.x-x;
 return a*a+m.y*m.y;
}

void sol1()
{long long d,d2;
long i,j;
FILE *f=fopen("puncte.out","w");
for(i=1;i<=m;i++)
 {
  d=dist(N[1],M[i]);
  for(j=2;j<=n;j++)
   {
    d2=dist(N[j],M[i]);
    if(d>d2)
     d=d2;
   }
  fprintf(f,"%lld\n",d);
 }
fclose(f);
}

void sol2()
{FILE *f=fopen("puncte.out","w");
long long d,d2;
long i,j;
for(i=1;i<=m;i++)
 {
  d=dist(N[1],M[i]);
  for(j=i;j<=min(n,i+C1);j++)
   {
    d2=dist(N[j],M[i]);
    if(d>d2)
     d=d2;
   }
  for(j=i;j>=max(i-C1,0);j--)
   {
    d2=dist(N[j],M[i]);
    if(d>d2)
     d=d2;
   }
  fprintf(f,"%lld\n",d);
 }
fclose(f);
}

int large(long a,long b)
{if(a/100*b>lim)
 return 1;
if(a/10*b>lim)
 return 1;
if(a*b>lim)
 return 1;
return 0;
}

void rez()
{
if(!large(m,n))
  sol1();
 else
  sol2();
}

int main()
{
 cit();
 rez();
 return 0;
}
