#include<stdio.h>
#include<stdlib.h>
#define LMAXIM 4000001

short int val[LMAXIM]; //memoria e cu probleme . cand modific sa nu uit sa schimb si in main cnad initializez cu infinit

struct interval
{
	int st, dr;
} intervale[60001];

int cmp(const void *a, const void *b)
{
	if (((interval *)a)->st > ((interval *)b)->st) return 1;
	if ((((interval *)a)->st == ((interval *)b)->st) && (((interval *)a)->dr > ((interval *)b)->dr)) return 1;
	return 0;
}

void adauga(int unde, int va, int poz, int st, int dr)
{
	if ((st<=unde) && (unde<=dr))
	{
		if (va<val[poz]) val[poz]=va;
	}
	else return;
	if (st==dr) return;
	adauga(unde, va, poz*2, st, (st+dr)/2);
	adauga(unde, va, poz*2+1, (st+dr)/2+1, dr);
	return;
}

int afla (int L, int R, int poz, int st, int dr)
{
	if ((L>dr) || (R<st)) return 1040;
	if ( (L<=st) && (R>=dr) ) return val[poz]; 
	int a, b;
	a=afla(L, R, poz*2, st, (st+dr)/2);
	b=afla(L, R, poz*2+1, (st+dr)/2+1, dr);
	if (a<b) return a;
	else return b;
}

int main()
{
	freopen("cover.in", "r", stdin);
	freopen("cover.out", "w", stdout);
	int n, l, i, j, tmp, ls, ld;
	long long best[60001];
	scanf("%d%d", &n, &l);
	for (i=0; i<LMAXIM; i++)
		val[i]=1040;
	for (i=1; i<=l; i++)
	{
		scanf("%d", &tmp);
		adauga(i, tmp, 1, 1, l);
	}
	
	for (i=1; i<=n; i++)
		scanf("%d%d", &(intervale[i].st), &(intervale[i].dr));
	
	qsort (&(intervale[1]), n, sizeof(interval), cmp);
	
	for (i=1; i<=n; i++)
	{
		ls=intervale[i].st;
		ld=intervale[i].dr;
		best[i]=best[i-1]+afla(ls, ld, 1, 1, l);
		j=1;
		
		while (ls <= intervale[i-j].dr)
		{
			//aflu limita din stanga si limita din dreapta;
			if (intervale[i-j].st>ls) ls=intervale[i-j].st;
			if (intervale[i-j].dr<ld) ld=intervale[i-j].dr;
			tmp=afla(ls, ld, 1, 1, l); 
			if (best[i]>best[i-j-1]+tmp )
				best[i]=best[i-j-1]+tmp;
			++j;
		}
	}	
	printf("%lld", best[n]);
	return 0;
}
