#include <cstdio>

using namespace std;

#define INF 0x3f3f3f3f

int c[ 10000 ], A[ 1000 ], B[ 1000 ], mask[ 10000 ];
int N, L, best;

void cit() {
	int i;
	
	scanf( "%d%d", &N, &L );
	for( i = 1; i <= L; i++ )
		scanf( "%d", &c[i] );
	for( i = 1; i <= N; i++ )
		scanf( "%d%d", A + i, B + i );
}

void mark() {
	int i, j, bit;

	for( i = 1; i <= N; i++ ) {
		mask[ i ] = 0;
		for( j = A[i], bit = 1 << j; j <= B[i]; j++, bit <<= 1 )
			mask[ i ] |= bit;
	}
}

int cost( int x ) {
	int M = 1 << L, i, j, res = 0;

	for( i = 2, j = 1; i <= M; i <<= 1, j++ )
		if( x & i )
			res += c[ j ];
	return res;
}

bool check( int x ) {
	int i;

	for( i = 1; i <= N; i++ )
		if( ( x & mask[i] ) == 0 )
			return false;
	return true;
}

void umin( int& x, int y ) {
	if( x > y )
		x = y;
}

void brute() {
	int i, d, M = 1 << L;
	best = INF;

	for( i = 0; i < M; i++ )
		if( check( i ) ) {
			d = cost( i );
			umin( best, d );
		}
}

void rez() {
	if( L <= 32 ) {
		mark();
		brute();
	}
}

void scr() {
	printf( "%d\n", best );
}

int main() {
	freopen( "cover.in", "r", stdin );
	freopen( "cover.out", "w", stdout );

	cit();
	rez();
	scr();

	return 0;
}

