#include <cstdio>
#include <cstring>

using namespace std;

#define TOT 0
#define UP 1
#define DOWN 2
#define HOR 3

#define HMAX 200
#define MOD 10000

struct Huge {
	int v[ 30 ];

	Huge operator = ( int x ) {
		v[0] = v[1] = 1;
	}

	void operator += ( Huge x ) {
		int i, t;

		for( i = 1, t = 0; i <= v[0] || i <= x.v[0] || t; i++, t /= MOD )
			v[i] = ( t += v[i] + x.v[i] ) % MOD;
		v[0] = i-1;
	}

	void set() {
		memset( v, 0, sizeof( v ) );
	}

	void print() {
		int i;

		printf( "%d", v[v[0]] );
		for( i = v[0] - 1; i > 0; i-- )
			printf( "%04d", v[i] );
		printf( "\n" );
	}
};

Huge c[ 3 ][ HMAX ][ 4 ];
int N;

void cit() {
	scanf( "%d", &N );
}

inline int mod( int x, int n ) {
	return x < 0 ? ( x % n + n ) : ( x % n );
}

void rez() {
	int i, j, ii, i1i, i2i;
	
	c[0][0][TOT] = 1;
	c[0][0][UP] = 1;
	c[0][0][DOWN] = 1;
	c[0][0][HOR] = 1;

	for( i = 1; i <= 2 * N - 2; i++ ) {
		ii = mod( i, 3 ); i1i = mod( i-1, 3 ); i2i = mod( i-2, 3 );
		
		for( j = 0; j <= i; j++ ) {
			if( i > 1 ) {
				c[ii][j][HOR] = c[i2i][j][TOT];
				c[ii][j][TOT] = c[i2i][j][TOT];
			}
			else
				c[ii][j][TOT].set();

			if( j > 0 ) {
				c[ii][j][UP] = c[i1i][j-1][TOT];
				c[ii][j][DOWN] = c[i1i][j+1][TOT];
			}
			else {
				c[ii][j][UP].set();
				c[ii][j][DOWN] = c[i1i][j+1][HOR];
 				c[ii][j][DOWN] += c[i1i][j+1][DOWN];
			}
 			c[ii][j][TOT] += c[ii][j][DOWN];
			c[ii][j][TOT] += c[ii][j][UP];
		}
	}
}

void scr() {
	c[ (2 * N - 2) % 3 ][ 0 ][ TOT ].print();
}

int main() {
	freopen( "munte.in", "r", stdin );
	freopen( "munte.out", "w", stdout );

	cit();
	rez();
	scr();

	return 0;
}

