#include <cstdio>

using namespace std;

#define NX 90001
#define INF 0x3f3f3f3f

int N, M;
int X[ NX ], Y[ NX ];

inline long long dist( int x1, int y1, int x2, int y2 ) {
	return (long long)( x1 - x2 ) * ( x1 - x2 ) + ( y1 - y2 ) * (y1 - y2 );
}

void cit() {
	int i, x, pbest;
	long long best, d;

	scanf( "%d%d", &N, &M );

	for( i = 1; i <= N; i++ )
		scanf( "%d%d", X + i, Y + i );

	for( ; M; M-- ) {
		scanf( "%d", &x );
		best = INF;
		for( i = 1; i <= N; i++ ) {
			d = dist( x, 0, X[i], Y[i] );
			if( best > d )
				best = d;
		}
		printf( "%lld\n", best );
	}
}

int main() {
	freopen( "puncte.in", "r", stdin );
	freopen( "puncte.out", "w", stdout );

	cit();

	return 0;
}


