#include <cstdio>
#include <cstring>

const int NMAX = 512;
const int CMAX = 128;
const int LMAX = 24;

int N, M, stop;
char A[CMAX][LMAX], P[NMAX];
int DP[2][NMAX], C[2][NMAX];
int L[NMAX], PL, poz[NMAX];

int MAX(int a, int b) { return a > b ? a : b; }
int ABS(int x) { return x < 0 ? -x : x; }
bool litera(char c) { return c >= 'A' && c <= 'Z'; }

void read(void) {
	FILE *fin = fopen("dist.in", "rt");
	char S[NMAX], p[NMAX];
	int i, j, l;

	fgets(S, NMAX, fin);
	i = 0;
	while (S[i]) {
		
		while (S[i] && !litera(S[i])) ++i;
		if (!S[i]) break;
		
		while (litera(S[i]))
			p[L[N]++] = S[i++];
		p[L[N]] = 0;
			
		strcpy(A[N++], p);
//		printf("%s\n", p);
	}
	
	fgets(S, NMAX, fin);
	i = 0;
	while (S[i]) {

		while (S[i] && !litera(S[i])) ++i;
		if (!S[i]) break;
		
		l = 0;
		while (litera(S[i]))
			p[l++] = S[i++];
		p[l] = 0;
		
		for (j = 0; j < l; ++j)
			poz[PL + j] = M;
			
		strcat(P, p);
		PL += l;
		M++; 
//		printf("%s\n", p);
	}

//	printf("%d %d\n", N, PL);

	fclose(fin);
}

void cost(int i, int beg, int end, int &d, int &c) {
	int j, stop;
	
	d = 0;
	c = 0;
	
	stop = MAX(end - beg + 1, L[i]);

	for (j = 0; j < stop; ++j)
		if (beg + j > end) 
			d += A[i][j] - '@';
		else if (j >= L[i]) 
			d += P[beg + j] - '@',
			c += ABS(i - poz[beg + j]);
		else
			d += ABS(A[i][j] - P[beg + j]),
			c += ABS(i - poz[beg + j]);
}

void dinamica(void) {
	int i, j, t, t1, d, c, l;

	memset(DP, 0x3f, sizeof(DP));
	
	DP[1][0] = 0; C[1][0] = 0;
	
	stop = MAX(N, M);
	
	for (i = 0; i < stop; ++i) { // cuv din prima prop
		t = i & 1; t1 = t ^ 1;
		memset(DP[t], 0x3f, sizeof(DP[t]));

		for (j = i + 1; j <= PL; ++j) { // literele din a 2-a prop

			for (l = j == PL ? 0 : 1; l <= 20 && l <= j && j >= i + l; ++l) { // lungimea cuv din prop 2
				
				cost(i, j - l, j - 1, d, c);
			
				if ((DP[t1][j - l] + d < DP[t][j]) || 
				(DP[t1][j - l] + d == DP[t][j] && C[t1][j - l] + c < C[t][j])) {
					DP[t][j] = DP[t1][j - l] + d;
					C[t][j] = C[t1][j - l] + c;
				}
		 	}

//			printf("DP(%d, %d) = %d\t%d\n", i, j, DP[t][j], C[t][j]);
		
		}
	}
}

void write(void) {
	FILE *fout = fopen("dist.out", "wt");

	fprintf(fout, "%d %d\n", DP[(stop - 1) & 1][PL], C[(stop - 1) & 1][PL]);

	fclose(fout);
}

int main(void) {

	read();

	dinamica();

	write();

	return 0;
}

