#include <stdio.h>

#define NMAX 100001

int N;
int poz[NMAX], st[NMAX], rola[NMAX];
int liber;

void muta(int i1)
{
    int i2 = liber;
    printf("%d\n", i1);
    poz[rola[i1]] = i2;
    st[rola[i1]] = 1-st[rola[i1]];
    rola[i2] = rola[i1];
    rola[i1] = 0;
    liber = i1;
}

int main()
{
    freopen("role.in", "r", stdin);
    freopen("role.out", "w", stdout);

    scanf("%d", &N);

    for (int i = 1; i<=N; ++i)
    {
        scanf("%d %d", &poz[i], &st[i]);
        rola[poz[i]] = i;
    }

    for (int i = 0; i<=N; ++i)
    {
        if (!rola[i])
        {
            liber = i;
            break;
        }
    }

    // bag in pozitiile libere
    while (liber)
    {
        muta(poz[liber]);
    }

    // fac interschimbari
    for (int i = 1; i<=N; ++i)
    {
        if (poz[i] != i)
        {
            int x1 = poz[i];
            int x2 = i;
            muta(x1);
            muta(x2);
            muta(0);
        }
    }

    int last = 0;

    // rezolv pozitiile bandelor
    for (int i = 1; i<=N; ++i)
    {
        if (st[i])
        {
            if (last)
            {
                int x1 = poz[last];
                int x2 = poz[i];
                muta(x1);
                muta(x2);
                muta(0);
                muta(x1);
                muta(x2);
                muta(0);
                last = 0;
            }
            else
            {
                last = i;
            }
        }

    }

    if (last)
    {
        int x1 = last;
        int x2 = 0;
        int x3;
        for (int i = 1; i<=N; ++i)
        {
            if (st[i] == 0)
            {
                if (x2)
                {
                    x3 = i;
                    break;
                }
                else
                    x2 = i;
            }
        }
        muta(x1);
        muta(x2);
        muta(x3);
        muta(0);
        muta(x3);
        muta(x2);
        muta(x1);
        muta(0);
    }
    
}
