using namespace std;

#include <cstdio>
#include <cassert>
#include <string>
#include <algorithm>

#define FIN "cover.in"
#define FOUT "cover.out"
#define LMAX 10001
#define NMAX 1001
#define INF 0x3f3f3f3f

int N, L, v[LMAX], st[NMAX], dr[NMAX], ind[NMAX];
int mini[NMAX], disj[NMAX], S[NMAX], D[NMAX];
int MIN[NMAX];

void read ()
{
    scanf ("%d%d", &N, &L);

    for (int i = 1; i <= L; ++ i)
    {
        scanf ("%d", &v[i]);
        ind[i] = i;
    }

    for (int i = 1; i <= N; ++ i)
        scanf ("%d%d", &st[i], &dr[i]);
}

int cmp (const int a, const int b)
{
    return dr[a] < dr[b];
}

void solve ()
{
    int minim, sol = 0;
    
    for (int i = 1; i <= N; ++ i)
    {
        minim = INF;
        for (int j = st[i]; j <= dr[i]; ++ j)
            if (v[j] < minim)
                minim = v[j];
        mini[i] = minim;
    }

    sort (ind+1, ind+N+1, cmp);
    
    for (int i = 1; i <= N; ++ i)
    {
        S[i] = st[ind[i]];
        D[i] = dr[ind[i]];
        MIN[i] = mini[ind[i]];
    }

    int Nr = 0;

    for (int i = 1; i <= N; ++ i)
        if (S[i] > D[disj[Nr]])
            disj[++ Nr] = i;

    /*for (int i = 1; i <= N; ++ i)
        printf ("%d %d   ", S[i], D[i]);
    printf ("\n");

    for (int i = 1; i <= N; ++ i)
        printf ("%d ", MIN[i]);
    printf ("\n");

    for (int i = 1; i <= Nr; ++ i)
        printf ("%d ", disj[i]);
    printf ("\n");*/
    
    int minrez, lim;
    for (int i = 1; i <= Nr; ++ i)
    {
        minrez = MIN[disj[i]];
        if (i == Nr)
            lim = N + 1;
        else
            lim = disj[i+1];
            
        for (int j = disj[i]; j < lim; ++ j)
        {
            minim = INF;
            for (int x = S[j]; x <= D[i]; ++ x)
                if (minim > v[x])
                    minim = v[x];

            minrez += MIN[j];
            if (minim < MIN[i] + MIN[j])
            {
                minrez = minim;
                D[i] = D[j];
            }
        }
        sol += minrez;
    }

    printf ("%d\n", sol);
}

int
 main ()
{
    freopen (FIN, "rt", stdin);
    freopen (FOUT, "wt", stdout);

    read ();
    solve ();

    return 0;
}

