#include <cstdio>
#include <cassert>
#include <string>

#define FIN "munte.in"
#define FOUT "munte.out"
#define NMAX 201
#define INF 0x3f3f3f3f

int N, s[NMAX][128][75], alt;

void add (int A[], int B[])
{
    int i, t = 0;

    for (i = 1; i <= A[0] || i <= B[0] || t; ++ i, t /= 10)
        A[i] = (t += A[i] + B[i]) % 10;

    A[0] = i - 1;
}

void read ()
{
    scanf ("%d\n", &N);
    alt = N;
    N = 2*N - 2;
}

void solve ()
{
    if (N == 0)
    {
        printf ("1\n");
        return;
    }
    
    s[0][0][0] = 1;
    s[0][0][1] = 1;

    for (int i = 1; i <= N; ++ i)
        for (int j = 0; j <= alt ; ++ j)
        {
            if (j == 1)
            {
                add (s[i+2][j], s[i-1][j-1]);
                add (s[i+1][j+1], s[i-1][j-1]);
                add (s[i][j], s[i-1][j+1]);
                if (i > 1)
                    add (s[i][j], s[i-2][j]);
            }
            
            else if (j == 0)
            {
                if (i > 1)
                    add (s[i][j], s[i-2][j]);
                add (s[i][j], s[i-1][j+1]);
            }

            else if (j > 1)
            {
                if (i > 1)
                    add (s[i][j], s[i-2][j]);
                add (s[i][j], s[i-1][j+1]);
                add (s[i][j], s[i-1][j-1]);
            }
        }

    /*for (int i = 0; i <= N; ++ i)
    {
        printf ("\n");
        for (int j = 0; j <= alt ; ++ j)
            printf ("%d ", s[i][j]);
    } */


    for (int i = s[N][0][0]; i > 0; -- i)
        printf ("%d", s[N][0][i]);

    printf ("\n");
}

int
 main ()
{
    freopen (FIN, "rt", stdin);
    freopen (FOUT, "wt", stdout);

    read ();
    solve ();

    return 0;
}

