using namespace std;

#include <cstdio>
#include <cassert>
#include <vector>
#include <string>

#define FIN "promo.in"
#define FOUT "promo.out"
#define NMAX 4015
#define INF 0x3f3f3f3f
#define pb push_back

int M, K, N = 1, viz[NMAX], iter, lim;
int rez1[NMAX], rez2[NMAX], verif, j, P;
vector <int> a[NMAX];

int modul (int x)
{
    if (x > 0)
        return x;
    return -x;
}

void read ()
{
    scanf ("%d %d\n", &M, &K);

    int x, y;
    for (int i = 1; i <= K; ++ i)
    {
        scanf ("%d %d\n", &x, &y);
        a[x].pb (y);
        a[y].pb (x);
    }
}

void df (int i)
{
    verif = 0;
    if (viz[i] == iter)
        return;
    viz[i] = iter;

    if (!rez1[i])
    {
        rez1[i] = N;
        ++ N;
        P = 0;
    }
    else
        P = 2;


    lim = a[i].size ();
    for (j = 0; j < lim; ++ j)
        if (viz[a[i][j]] == iter && modul(rez1[i] - rez1[a[i][j]]) >= 2)
        {
            verif = 1;
            rez2[i] = rez1[a[i][j]];
        }

    if (verif == 1)
    {
        for (j = 0; j < lim; ++ j)
            if (viz[a[i][j]] != iter)
            {
                rez1[a[i][j]] = rez2[i];
                df (a[i][j]);
            }
    }
    else
    {
        for (j = 0; j < lim; ++ j)
            {
                rez2[i] = N;
                P = 2;
                df (a[i][j]);
            }
    }
}

void solve ()
{
    for (int i = 1; i <= M; ++ i)
    {
        if (!viz[i])
        {
            ++ iter;
            df (i);
            if (!rez2[i])
            {
                rez2[i] = N;
                ++ N;
            }
            else if (P == 2)
                ++ N;
        }
    }
    
    N = 0;
    for (int i = 1; i <= M; ++ i)
    {
        if (N < rez1[i])
            N = rez1[i];
        if (N < rez2[i])
            N = rez2[i];
    }

    printf ("%d\n", N);
    for (int i = 1; i <= M; ++ i)
        printf ("%d %d\n", rez1[i], rez2[i]);
}

int
 main ()
{
    freopen (FIN, "rt", stdin);
    freopen (FOUT, "wt", stdout);

    read ();
    solve ();

    return 0;
}

