#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

#define Lmax 512
#define Cmax 25
#define Nmax 105
#define INF 0x3f3f3f3f

int l, n, best, sol;
int sf[Lmax], lg[Nmax], d[Lmax][Nmax], c[Lmax][Nmax], mut[Lmax][Nmax];
int mut1[Lmax][Nmax], v[Nmax];
char prop1[Lmax], prop2[Lmax], sir[Lmax], cuv[Nmax][Cmax];

void citire()
{
    int i, j, p;
    
    fgets(prop1, Lmax, stdin);
    fgets(prop2, Lmax, stdin);

    p = strlen(prop1);
    while (!('A' <= prop1[p - 1] && prop1[p - 1] <= 'Z'))
        --p;

    n = 1;
    for (i = 0; i < p; ++i)
        if (prop1[i] == ' ' && prop1[i - 1] != ' ')
            ++n;
        else if ('A' <= prop1[i] && prop1[i] <= 'Z')
            cuv[n][++lg[n]] = prop1[i];

    p = strlen(prop2);
    for (i = 0; i < p; ++i)
        if (prop2[i] == ' ' && prop2[i - 1] != ' ')
            sf[l] = 1;
        else if ('A' <= prop2[i] && prop2[i] <= 'Z')
            sir[++l] = prop2[i];
    sf[l] = 1;
}

void solve()
{
    int i, j, k, p, cost, ct, cnt, lim, vl1, vl2, lim2;
    
    memset(d, 0x3f, sizeof(d));
    memset(c, 0x3f, sizeof(c));
    d[0][0] = c[0][0] = 0;


    for (i = 1; i <= l; ++i)
        for (j = 1; j <= n; ++j)
        {
            ct = cnt = 0;
            for (k = i; k <= l; ++k)
            {
                ++cnt;
                if (sf[k]) ++ct;
                if (ct >= j) break;
            }
            mut[i][j] = cnt - 1;
        }

    for (i = 1; i <= l; ++i)
        for (j = 1; j <= Nmax; ++j)
        {
            lim2 = min(20, i);
            for (k = 1; k <= lim2; ++k)
            {
                cost = 0;

                lim = min(k, lg[j]);
                for (p = 1; p <= lim; ++p)
                    cost += abs(sir[i - k + p] - cuv[j][p]);

                lim = lg[j];
                for (p = min(k, lg[j]) + 1; p <= lim; ++p)
                    cost += abs('@' - cuv[j][p]);

                for (p = min(k, lg[j]) + 1; p <= k; ++p)
                    cost += abs('@' - sir[i - k + p]);

                vl1 = d[i - k][j - 1];
                vl2 = c[i - k][j - 1];
                
                if (d[i][j] >= vl1 + cost)
                   if (d[i][j] > vl1 + cost)
                   {
                        d[i][j] = vl1 + cost;
                        c[i][j] = vl2 + mut[i][j];
                   }
                   else if (c[i][j] > vl2 + mut[i][j])
                        c[i][j] = vl2 + mut[i][j];
            }
            //printf("%d %d --> %d %d\n", i, j, d[i][j], c[i][j]);
        }

    for (i = n; i >= 1; --i)
    {
        v[i] = v[i + 1];
        for (j = 1; j <= lg[i]; ++j)
            v[i] += abs('@' - cuv[i][j]);
    }

    best = INF;

    for (i = 0; i <= Nmax; ++i)
        if (d[l][i]  + v[i + 1] <= best)
            if (d[l][i] + v[i + 1] < best)
            {
                best = d[l][i] + v[i + 1];
                sol = c[l][i];
            }
        else if (c[l][i] < sol)
            sol = c[l][i];

    printf("%d %d\n", best, sol);
}

int main()
{
    freopen("dist.in", "r", stdin);
    freopen("dist.out", "w", stdout);
    citire();
    solve();
    return 0;
}
