#include <cstdio>

#define Nmax 100005
#define Mmax 200005
#define INF 0x3f3f3f3f
#define sqr(a) ((a) * (a))
#define ll long long

int n, m;
ll dy[Nmax], x[Mmax], dx[Nmax];

void citire()
{
    int i;

    scanf("%d %d\n", &n, &m);
    for (i = 1; i <= n; ++i)
        scanf("%d %d\n", &dx[i], &dy[i]);
    for (i = 1; i <= m; ++i)
        scanf("%d\n", &x[i]);
}

void solve()
{
    int i, j;
    ll best;

    for (i = 1; i <= n; ++i)
        dy[i] *= dy[i];

    for (i = 1; i <= m; ++i)
    {
        best = INF;
        for (j = 1; j <= n; ++j)
            if (best > sqr(dx[j] - x[i]) + dy[j])
               best = sqr(dx[j] - x[i]) + dy[j];
        printf("%lld\n", best);
    }
}

int main()
{
    freopen("puncte.in", "r", stdin);
    freopen("puncte.out", "w", stdout);
    citire();
    solve();
    return 0;
}
