# include <stdio.h>
# include <stdlib.h>

const long int MAXL=1000000;
const long int MAXN=60000;
const long int INFINIT=2000000000;
long int v[MAXL+1];
long int n,l;
typedef struct SEGMENT {long int a,b,min;};
typedef struct NOD_AD {long int min; NOD_AD *stga,*drta;};
NOD_AD *radacina;
SEGMENT seg[MAXN+1];


void citire()
{
FILE *f=fopen("cover.in","r");
fscanf(f,"%ld%ld",&n,&l);
long int i;
for (i=1;i<=l;i++)
	fscanf(f,"%ld",&v[i]);
for (i=1;i<=n;i++)
	fscanf(f,"%ld%ld",&seg[i].a,&seg[i].b);
fclose(f);
}

void aloca_arbdint(long int li, long int lf, NOD_AD *p)
{
long int mij=(li+lf)/2;
NOD_AD *q;
if (li!=lf)
	{
	q=(NOD_AD*) malloc (sizeof(NOD_AD));
	(*q).min=INFINIT;
	(*q).drta=NULL;
	(*q).stga=NULL;
	(*p).stga=q;
	aloca_arbdint(li,mij,q);
	q=(NOD_AD*) malloc (sizeof(NOD_AD));
	(*q).min=INFINIT;
	(*q).drta=NULL;
	(*q).stga=NULL;
	(*p).drta=q;
	aloca_arbdint(mij+1,lf,q);
	}
}

long int min(long int a, long int b) {if (a>b) return b;return a;}

void update(long int li, long int lf, long int a, NOD_AD *p)
{
long int mij=(li+lf)/2;
(*p).min=min((*p).min,v[a]);
if (li!=lf)
	if (a<=mij) update(li,mij,a,(*p).stga);
	else update(mij+1,lf,a,(*p).drta);
}

void print_ad(long int li, long int lf, NOD_AD *p)
{
long int mij=(li+lf)/2;
printf("%ld %ld : %ld\n",li,lf,(*p).min);
if (li!=lf)
	{
	print_ad(li,mij,(*p).stga);
	print_ad(mij+1,lf,(*p).drta);
	}
}

long int querry(long int li, long int lf, long int a, long int b, NOD_AD *p)
{
if (a<=li&&lf<=b) return (*p).min;
long int ss=INFINIT,sd=INFINIT;
long int mij=(li+lf)/2;
if (a<=mij) ss=querry(li,mij,a,b,(*p).stga);
if (b>=mij+1) sd=querry(mij+1,lf,a,b,(*p).drta);
return min(ss,sd);
}

void scrie(long int sol)
{
FILE *g=fopen("cover.out","w");
fprintf(g,"%ld\n",sol);
fcloseall();
}

long int max(long int a, long int b) {if (a>b) return a; return b;}

long int cal_solutie()
{
long int sol=0,i,min2,j,aa,bb;
for (i=1;i<=n;i++) sol+=seg[i].min;
for (i=1;i<=n;i++)
for (j=i+1;j<=n;j++)
	{
	aa=max(seg[i].a,seg[j].a);
	bb=min(seg[i].b,seg[j].b);
	if (aa<=bb)
		{
		min2=querry(1,l,aa,bb,radacina);
		if (min2<=seg[i].min+seg[j].min)
			{
			sol=sol-seg[i].min-seg[j].min;
			sol+=min2;
/*			seg[i].min=min2;
			seg[j].min=min2;*/
			}
		}
	}
return sol;
}

int main()
{
citire();
radacina=(NOD_AD*) malloc (sizeof(NOD_AD));
(*radacina).min=INFINIT;
(*radacina).drta=NULL;
(*radacina).stga=NULL;
aloca_arbdint(1,l,radacina);
long int i;
for (i=1;i<=l;i++) update(1,l,i,radacina);
//print_ad(1,l,radacina);
for (i=1;i<=n;i++) seg[i].min=querry(1,l,seg[i].a,seg[i].b,radacina);
long int sol=cal_solutie();
scrie(sol);
return 0;
}
