#include <stdio.h>
#include <algorithm>

using namespace std;

#define nm 60100
#define lm 1000100
#define inf 2000000000

struct interv
{
	int x, y;
};

int n, l, v[lm], s[lm], t[lm], c[nm], dq[nm], ql, qr;
interv a[nm];

int cmp(interv a, interv b)
{
	return a.x < b.x || (a.x == b.x && a.y > b.y);
}

int main()
{
	int i, j, aux;

	freopen("cover.in", "r", stdin);
	freopen("cover.out", "w", stdout);

	scanf("%d%d", &n, &l);

	for (i = 1; i <= l; ++i)
		scanf("%d", &v[i]);

	for (i = 1; i <= n; ++i)
		scanf("%d%d", &a[i].x, &a[i].y);

	sort(a + 1, a + n + 1, cmp);

	for (j = 2, i = 2; i <= n; ++i)
    {
		while(j > 1 && a[j - 1].y >= a[i].y)
        	--j;

        a[j++] = a[i];
    }
    
    n = j - 1;
            
	for (j = 0, i = 1; i <= l; ++i)
	{
		while(j < n && a[j + 1].x <= i)
			++j;

		s[i] = j;
	}

	for (j = 0, i = 1; i <= l; ++i)
	{
		while(j < n && a[j + 1].y < i)
			++j;

		t[i] = j;
	}

	for (i = 1; i <= n; ++i)
		c[i] = inf;

	ql = qr = 1;

	for (i = 1; i <= a[n].y; ++i)
    {
    	for (j = s[i - 1]; j < s[i]; ++j)
        {
        	while(qr > ql && c[dq[qr - 1]] > c[j])
            	--qr;

            dq[qr++] = j;
        }

    	for (j = t[i - 1]; j < t[i]; ++j)
        	if (dq[ql] == j)
            	++ql;    

	    if (s[i] > t[i] && c[s[i]] > c[dq[ql]] + v[i])
            c[s[i]] = c[dq[ql]] + v[i];
    }
    
	printf("%d\n", c[n]);

	return 0;
}
