#include <stdio.h>
#include <string.h>

#define nm 101
#define lm 501
#define cm 21
#define inf 1000000000

int nr[2], len[2][nm], c[nm][lm], min[nm][lm], v[lm], lv, sol, sum[nm];
char s[2][nm][cm];

int abs(int x)
{
 	if (x > 0)
    	return x;
    else
    	return -x;
}

int dist(int cuv, int pos, int l)
{
	int i, rez = 0;

	if (l > len[0][cuv])
	{
		for (i = 0; i < len[0][cuv]; ++i)
			rez += abs(v[pos + i] - s[0][cuv][i]);

		for (; i < l; ++i)
			rez += abs(v[pos + i] - 64);
	}
	else
	{
		for (i = 0; i < l; ++i)
			rez += abs(v[pos + i] - s[0][cuv][i]);

		for (; i < len[0][cuv]; ++i)
			rez += abs(s[0][cuv][i] - 64);
	}

	return rez;
}

int main()
{
	int i, j, k, tmp;
	char ch;

	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	do
	{
		scanf(" %s", &s[0][++nr[0]]);
        len[0][nr[0]] = strlen(s[0][nr[0]]);
		scanf("%c", &ch);
	} while(ch == ' ');

	do
	{
		scanf(" %s", &s[1][++nr[1]]);
        len[1][nr[1]] = strlen(s[1][nr[1]]);
        sum[nr[1]] = sum[nr[1] - 1] + len[1][nr[1]];
	} while(!feof(stdin));
	
	for (i = 1; i <= nr[1]; ++i)
		for (len[1][i] = strlen(s[1][i]), j = 0; j < len[1][i]; ++j)
			v[++lv] = s[1][i][j];
	
	for (j = 1; j <= lv; ++j)
		c[0][j] = inf;
	c[0][0] = 0;
	
	for (sol = i = 1; i <= 100 && i <= nr[0] + 1; ++i)
	{
		for (j = 1; j <= lv; ++j)
			c[i][j] = inf;
	
		for (j = 1; j <= lv; ++j)
			for (k = 1; k <= 20 && k <= j - i + 1; ++k)
            {
            	tmp = dist(i, j - k + 1, k);
            
				if (c[i][j] > c[i - 1][j - k] + tmp || (c[i][j] == c[i - 1][j - k] + tmp && min[i][j] > min[i - 1][j - k] + abs(sum[i] - j)))
				{
					c[i][j] = c[i - 1][j - k] + tmp;
					min[i][j] = min[i - 1][j - k] + abs(sum[i] - j);
				}
	        }
            
		if (c[sol][lv] > c[i][lv])
			sol = i;
	}

	printf("%d %d\n", c[sol][lv], min[sol][lv]);

	return 0;
}
