#include <stdio.h>

#define nm 200
#define lm 100

int n;
char c[nm][nm][3][lm], sol[lm];

void copy(char a[lm], char b[lm])
{
	int i;

    for (i = 1; i <= b[0]; ++i)
    	a[i] = b[i];

    for (i = b[0] + 1; i <= a[0]; ++i)
    	a[i] = 0;

    a[0] = b[0];
}

void add(char a[lm], char b[lm])
{
	int i, t = 0;

    for (i = 1; i <= a[0] || i <= b[0] || t; ++i, t /= 10)
    	a[i] = (t += a[i] + b[i]) % 10;

    a[0] = i - 1;
}

int main()
{
	int i, j;

	freopen("munte.in", "r", stdin);
	freopen("munte.out", "w", stdout);

	scanf("%d", &n);

    if (n == 1)
    {
    	printf("1\n");
        return 0;
    }

	n = 2 * n - 2;

    c[2][0][0][0] = c[2][0][0][1] = c[1][1][1][0] = c[1][1][1][1] = c[2][2][1][0] = c[2][2][1][1] = 1;

	for (i = 3; i <= n; ++i)
	{
    	copy(c[i][0][0], c[i - 2][0][0]);
        add(c[i][0][0], c[i - 2][0][2]);
        copy(c[i][0][2], c[i - 1][1][0]);
        add(c[i][0][2], c[i - 1][1][2]);
        
		for (j = 1; j <= n; ++j)
        {
        	copy(c[i][j][0], c[i - 2][j][0]);
            add(c[i][j][0], c[i - 2][j][1]);
            add(c[i][j][0], c[i - 2][j][2]);
        
        	copy(c[i][j][1], c[i - 1][j - 1][0]);
            add(c[i][j][1], c[i - 1][j - 1][1]);
            add(c[i][j][1], c[i - 1][j - 1][2]);

        	copy(c[i][j][2], c[i - 1][j + 1][0]);
            add(c[i][j][2], c[i - 1][j + 1][1]);
            add(c[i][j][2], c[i - 1][j + 1][2]);
        }
	}

    copy(sol, c[n][0][0]);
    add(sol, c[n][0][2]);

    for (i = sol[0]; i; --i)
    	printf("%d", sol[i]);

    printf("\n");

	return 0;
}
