#include <stdio.h>

const char iname[] = "puncte.in";
const char oname[] = "puncte.out";

#define MAX_N 100000
#define MAX_M 200000

int N, M;

int xy[MAX_N][2], x[MAX_M];

void read_in(void) {
    scanf("%d %d", & N, & M);
    for (int i = 0; i < N; ++ i)
        scanf("%d %d", xy[i], xy[i] + 1);
    for (int i = 0; i < M; ++ i)
        scanf("%d", x + i);
}

typedef long long i64;

#define sqr(z) (((i64)(z)) * (z))

int main(void) {
    freopen(iname, "r", stdin);
    read_in();
    freopen(oname, "w", stdout);
    for (int i = 0; i < M; ++ i) {
        i64 ans = (i64)1e18;
        for (int j = 0; j < N; ++ j)
            if (ans > sqr(x[i] - xy[i][0]) + sqr(xy[i][1]))
                ans = sqr(x[i] - xy[i][0]) + sqr(xy[i][1]);
        printf("%lld\n", ans);
    }
    return 0;
}
