#include <stdio.h>

#define nmax 512
#define cmax 21
#define cvmax 101
#define inf (int)1e5

char a[nmax],b[nmax],binit[nmax],ch,cuv[cvmax][cmax],space[nmax],chr[nmax];
int n,m,minit,nrcuv,l[cvmax],c[cvmax][nmax],d[cvmax][nmax],crsp[nmax];

inline int max(int i,int j) {
	if(i > j) return i;
	else return j;
}

inline int min(int i,int j) {
	if(i > j) return j;
	else return i;
}

inline int absol(int x) {
	if(x > 0) return x;
	else return -x;
}

inline int di() {
	int tot = 0;
	for(int i = 1; i <= max(n,m); i++) 
		if(i <= n && i <= m) tot += absol((int)(a[i] - b[i]));
		else if(i <= n) tot += absol((int)(a[i] - '@'));
		else tot += absol((int)('@' - b[i]));
	return tot;
}

int dist(int i,int sx,int sy) {
	int tot = 0;
	for(int k = 1; k <= max(l[i],sy - sx + 1); k++)
		if(k <= l[i] && k <= sy - sx + 1) tot += absol((int)(cuv[i][k] - b[sx + k - 1]));
		else if(k <= l[i]) tot += absol((int)(cuv[i][k] - '@'));
		else tot += absol((int)('@' - b[k]));
	return tot;
}

int dist(int i,int j) {
	int tot = 0;
	for(int k = 1; k <= max(l[i],j); k++) 
		if(k <= l[i] && k <= j) tot += absol((int)(cuv[i][k] - b[k]));
		else if(k <= l[i]) tot += absol((int)(cuv[i][k] - '@'));
		else tot += absol((int)('@' - b[k]));
	return tot;	
}

int modi(int i,int j) {
	int tot = 0;
	i = crsp[i]; j = crsp[j];
	if(binit[i - 1] != ' ') {
		while(binit[i] != ' ' && i <= j) {
			tot++;
			i++;
		}
	}
	int ct = 1;
	for(int k = i + 1; k <= j; k++)
		if(binit[k] == ' ') ct++;
		else tot += ct;
	return tot;
}

int main() {
	freopen("dist.in","r",stdin);
	freopen("dist.out","w",stdout);

	scanf("%c",&ch);
	while(ch != '\n') {
		a[++n] = ch;
		scanf("%c",&ch);
	}
	scanf("%c",&ch);
	binit[0] = '@';
	while(ch != '\n') {
		if((ch == ' ' && binit[minit - 1] != ' ') || (ch >= 'A' && ch <= 'Z'))	binit[++minit] = ch;
		if(ch >= 'A' && ch <= 'Z') {
			b[++m] = ch;
			crsp[m] = minit;
		}
		scanf("%c",&ch);
	}
	binit[0] = ' ';
	
	int crt = 1;
	for(int i = 1; i <= n; i++)
		if(a[i] == ' ') {
			if(l[crt] > 0) crt++;
		}
		else cuv[crt][++l[crt]] = a[i];
	
	while(l[crt] == 0) crt--;

	for(int i = 0; i <= crt; i++)
		for(int j = 0; j <= m; j++) c[i][j] = inf;

	for(int i = 1; i <= crt; i++) 
		for(int j = 1; j <= m; j++) {
			c[i][j] = inf;
			if(i == 1 && j <= 20) {
				c[i][j] = dist(i,1,j);
				d[i][j] = 0;
			}
			else if(i >= 2) for(int k = 0; k <= min(j,20); k++) {
					int v1 = c[i - 1][j - k] + dist(i,j - k + 1,j);
					int v2 = 0;
					if(v1 <= c[i][j]) {
						v2 = d[i - 1][j - k] + modi(j - k + 1,j);
						if(v1 < c[i][j] || (v1 == c[i][j] && v2 < d[i][j])) {
							c[i][j] = v1;
							d[i][j] = v2;
						}
					}
				}
		}

	printf("%d %d\n",c[crt][m],d[crt][m]);

	return 0;
}
