#include <stdio.h>
#include <algorithm>

#define inf 2000000000
#define nmax 100005
#define mmax 200005
#define db double
#define ll long long

using namespace std;

int xm[mmax],place[mmax],x[nmax],y[nmax],i,n,m,x1,y1,stn = 0;
ll rez[mmax];
db poz[nmax];

inline db pz(int x1,int y1,int x2,int y2) {
	if(x1 == x2) return inf;
	else {
		db rez = db((db)x2 * x2 + (db)y2 * y2 - (db)y1 * y1 - (db)x1 * x1)/(db)(2 * x2 - 2 * x1);
		return rez;
	}
}

int cmp(int i,int j) {
	return xm[i] < xm[j];
}

inline ll dist(int x1,int y1,int x2,int y2) {
	return (ll)(x1 - x2) * (ll)(x1 - x2) + (ll)(y1 - y2) * (ll)(y1 - y2);
}

int main() {
	freopen("puncte.in","r",stdin);
	freopen("puncte.out","w",stdout);

	scanf("%d%d",&n,&m);
	for(int i = 1; i <= n; i++) {
		scanf("%d%d",&x1,&y1);
		while(stn > 0 && pz(x[stn],y[stn],x1,y1) <= poz[stn]) stn--;
		stn++; x[stn] = x1; y[stn] = y1; 
		if(stn > 1) poz[stn] = pz(x[stn - 1],y[stn - 1],x[stn],y[stn]);
	}

	for(int i = 1; i <= m; i++) {
		scanf("%d",&xm[i]);
		place[i] = i;
	}

	sort(place + 1,place + m + 1,cmp);

	int stgn = 1;
	for(int i = 1; i <= m; i++) {
		while(stgn < stn && xm[place[i]] >= poz[stgn + 1]) 	stgn++;
		rez[place[i]] = dist(xm[place[i]],0,x[stgn],y[stgn]);
	}

	for(int i = 1; i <= m; i++) printf("%lld\n",rez[i]);

	return 0;
}
