#include <stdio.h>
#define FOR(i, a, b) for (i = (a); i <= (b); ++i)
#define FORD(i, a, b) for (i = (a); i >= (b); i--)
#define MaxN 100033
#define MaxM 200033
#define INF 1000000033 // 1 miliard

struct Punct {
	int x, y;
} P[MaxN];

int N, M;
int Px[MaxM], ind[MaxM];
int bf[MaxM], af[MaxM];
long long int ans[MaxM];

//sortare N puncte pe axa OX
//sortare M puncte in plan


long long dist(long long x1, long long y1, long long x2, long long y2)
{
	return (x1 - x2)*(x1 - x2) + (y1 - y2)*(y1 - y2);
}

void quick(int lf, int rt)
{
	int i = lf - 1, j = rt + 1;
	if (lf >= rt) return;
	do
	{
		do { i++; } while (Px[lf] > Px[i]);
		do { j--; } while (Px[lf] < Px[j]);
		if (i < j)
		{
			int aux = Px[i]; Px[i] = Px[j]; Px[j] = aux;
			aux = ind[i]; ind[i] = ind[j]; ind[j] = aux;
		}
	} while (i < j);
	quick(lf, j);
	quick(j + 1, rt);
}


int main()
{
	int i;

	FILE *fin = fopen("puncte.in", "rt");
	fscanf(fin, "%d %d", &N, &M);
	FOR (i, 1, N)
		fscanf(fin, "%d %d", &P[i].x, &P[i].y);
	FOR (i, 1, M)
	{
		fscanf(fin, "%d", &Px[i]);
		ind[i] = i;
    }
	fclose(fin);

	quick(1, M);

	P[N+1].x = INF, P[N+1].y = INF;

	int cnt = 1;
	FOR(i, 1, N+1)
	{
		while (P[i].x > Px[cnt] && cnt <= M)
		{
			bf[cnt] = i - 1;
			cnt++;
		}
		if (cnt == M+1) break;
	}

	cnt = M;
	FORD (i, N, 0)
	{
		while (P[i].x < Px[cnt] && cnt > 0)
		{
			af[cnt] = i + 1;
			cnt--;
		}
		if (cnt == 0) break;
	}

	FILE *fout= fopen("puncte.out", "wt");

	FOR(i, 1, M)
	{
	    int nr = 0;
        long long dmin = (1 << 30), d;
		int pos = bf[i];
		while (pos >= 1 && nr < 100)
		{
			d = dist(P[pos].x, P[pos].y, Px[i], 0);
			if (d < dmin) dmin = d;
			nr++;
			pos--;
		}

		pos = af[i], nr = 0;
		while (pos <= N && nr < 100)
		{
			d = dist(P[pos].x, P[pos].y, Px[i], 0);
			if (d < dmin) dmin = d;
			nr++;
			pos++;
		}
		//fprintf(fout, "%d\n", dmin);
		ans[ind[i]] = dmin;
	}


	FOR(i, 1, M)
		fprintf(fout, "%lld\n", ans[i]);

	/*
		//DEBUG
	FOR(i, 1, N)
		fprintf(fout, "%d %d\n", P[i].x, P[i].y);
	FOR(i, 1, M)
		fprintf(fout, "%d ", Px[i]);
	FOR(i, 1, M)
		fprintf(fout, "%d %d\n", bf[i], af[i]);
		//DEBUG
    */
	fclose(fout);

	return 0;
}

