#include<stdio.h>
#include<stdlib.h>
#define Nm 60001
#define Lm 1000002
#define Inf 2000000000
#define max(a,b) ((a)>(b)?(a):(b))
int C[Lm],n,l;
int Cm[Nm],End[Lm];
struct interval
{
    int x,y;
} A[Nm];
struct nod
{
    int p;
    nod* next;
};
typedef nod* lista;
lista Prim[1025],Ultim[1025];

void read()
{
    int i;

    freopen("cover.in","r",stdin);
    scanf("%d%d",&n,&l);
    for(i=1;i<=l;i++)
        scanf("%d",C+i);
    for(i=0;i<n;i++)
        scanf("%d%d",&A[i].x,&A[i].y);
}

int cmp(const void *x, const void *y)
{
    return ((interval*)x)->y-((interval*)y)->y;
}

void Insert(lista &prim, lista &ultim, int p)
{
    lista q=new nod;

    q->p=p;
    if(prim)
        ultim->next=q;
    else
        prim=q;
    ultim=q;
}
        
void Delete(lista &prim)
{
    lista q=prim;

    prim=prim->next;
    delete q;
}

void solve()
{
    int i,j,ui,c;

    qsort(A,n,sizeof(interval),cmp);
    for(i=0;i<n;i++)
        End[A[i].y]++;
    for(i=l-1;i;i--)
        End[i]+=End[i+1];
    Cm[0]=0;
    ui=0;
    for(i=0;i<n;i++)
    {
        Cm[i]=Inf;
        for(j=(!i?1:A[i-1].y+1);j<=A[i].y;j++)
            Insert(Prim[C[j]],Ultim[C[j]],j);
        ui=max(ui,A[i].x);
        for(j=0;j<=1024;j++)
            while(Prim[j] && Prim[j]->p<ui)
                Delete(Prim[j]);
        for(j=0;j<=1024;j++)
            if(Prim[j])
            {
                c=j+Cm[i-End[Prim[j]->p]+End[A[i].y+1]];
                if(c<Cm[i])
                    Cm[i]=c;
            }
    }
}

void write()
{
    freopen("cover.out","w",stdout);
    printf("%d\n",Cm[n-1]);
}

int main()
{
    read();
    solve();
    write();
    return 0;
}

