#include <stdio.h>
#include <string.h>

#define MAX_N 202
#define MAX_K 102
#define MAX_C 10
#define base 1000000000

typedef int num[MAX_C];

int N, K;
num A[MAX_N][MAX_K];

void add(num A, num B)
{
    int i, t = 0;
    for(i = 1; i <= A[0] || i <= B[0] || t; i++, t /= base)
        A[i] = (t += A[i]+B[i]) % base;
    A[0] = i-1;
}

void solve(void)
{
    int n, k;

    A[0][0][0] = A[0][0][1] = 1;

    for(n = 1; n <= N; n++)
    {
        memcpy(A[n][0], A[n-1][1], sizeof(num));
        for(k = 1; k <= K; k++)
        {
            add(A[n][k], A[n-1][k-1]);
            if(n >= 2)
                add(A[n][k], A[n-2][k]),
            add(A[n][k], A[n-1][k+1]);
        }
    }
}

void read_data(void)
{
    scanf("%d\n", &N);
    N = 2*N-2, K = N/2;
}

void write_data(void)
{
    int i, len = A[N][0][0];

    printf("%d", A[N][0][len]);
    for(i = len-1; i >= 1; i--)
        printf("%09d", A[N][0][i]);

    printf("\n");
}

int main(void)
{
    freopen("munte.in", "rt", stdin);
    freopen("munte.out", "wt", stdout);

    read_data();
    solve();
    write_data();

    return 0;
}




    




