#include<stdio.h>
#include<stdlib.h>

#define LMAX 1000010
#define NMAX 60010
#define INF 1100000000
#define nd(a) (*(t_p *)(a))
#define fs (2 * nod)
#define fd (2 * nod + 1)
#define min(a,b) ((a) < (b) ? (a) : (b))

typedef struct t_p
{
	int x, y;
};
void read();
void solve();
int cmp(const void *a, const void *b);
int search(int x);
void update(int nod, int l, int s, int x);
int query(int nod, int l, int s);

int N, L, C[LMAX], nr, val[NMAX], V[NMAX], li, ls, A[131072], next[NMAX];
t_p v[NMAX], P[NMAX];

int main()
{
	freopen("cover.in", "r", stdin);
     freopen("cover.out", "w", stdout);

     read();
     solve();
	return 0;
}


void read()
{
	int i;
     
	scanf("%d%d", &N, &L);

     for(i = 0; i < L; i++)
     scanf("%d", C + i);

     for(i = 0; i < N; i++)
     {
     scanf("%d%d", &v[i].x, &v[i].y);
     v[i].x--, v[i].y--;
     }

     qsort(v, N, sizeof(t_p), cmp);

     for(i = 0; i < N; i++)
     if(i && v[i].x <= P[nr - 1].x) continue;
	else P[nr++] = v[i];
     N = nr;
     for(i = 0; i < N; i++)
     v[i].x = P[i].y, v[i].y = P[i].x;
}

int cmp(const void *a, const void *b)
{
	if(nd(a).y != nd(b).y)
     return nd(a).y - nd(b).y;
     else return nd(b).x - nd(a).x;
}

void solve()
{
	int i, j, z, min;

     for(i = 0; i < N - 1; i++)
     {
     	min = INF;
     	for(j = P[i].y + 1; j <= P[i + 1].y; j++)
          if(C[j] < min) min = C[j];
          li = i, ls = i;
		update(1, 0, N - 1, min);
     }

     qsort(v, N, sizeof(t_p), cmp);

     for(i = N - 1; i >= 0; i--)
     {
          z = search(P[i].x);
          next[i] = z;
          if(i < N - 1 && z == next[i + 1])
          {
          	for(j = P[i].x; j < P[i + 1].x; j++)
               if(C[j] < min)
               min = C[j];
          }
          else
          {
          	min = INF;
	          for(j = P[i].x; j <= P[z].y; j++)
     	     if(C[j] < min) min = C[j];
          }
          val[i] = min;
     }

     for(i = 0; i < N; i++)
     {
      	j = search(P[i].x);
          V[i] = val[i] + (j < 1 ? 0 : V[j - 1]);
          if(j != i)
          {
          	li = j, ls = i - 1;
          	z = query(1, 0, N - 1);
               if(z < V[i]) V[i] = z;
          }
          li = i, ls = i;
          update(1, 0, N - 1, V[i]);
     }
     printf("%d\n", V[N - 1]);
}

int search(int x)
{
	int i, step;

     for(step = 1; step <= N; step <<= 1);

     for(i = -1; step; step >>= 1)
     if(i + step < N && P[i + step].y < x)
     i += step;

     return i + 1;
}

void update(int nod, int l, int s, int x)
{
	if(l > s) return;
	if(l > ls || s < li) return;
     int key = (l + s) >> 1;

     if(li <= l && s <= ls)
     {
     	A[nod] += x;
          return;
     }
     update(fs, l, key, x);
     update(fd, key + 1, s, x);
     A[nod] = min(A[fs], A[fd]);
}

int query(int nod, int l, int s)
{
	if(l > ls || s < li) return INF;

     if(li <= l && s <= ls)
     	return A[nod];
          
	int key = (l + s) >> 1, a, b;
     
	a = query(fs, l, key);
     b = query(fd, key + 1, s);
     return min(a, b);
}
