#include<stdio.h>
#include<string.h>

#define NMAX 512
#define NRMAX 128
#define INF 1000000000
#define abs(a) ((a) < 0 ? -(a) : (a))

void read();
void solve();
void calc(int &a, int &b);
int cnt(int x);
void update(int &x, int &nr, int y, int z);

int b[NRMAX], e[NRMAX], la, lb, lima, V[NRMAX][NMAX], limb, cuv[NMAX], S[NRMAX][NMAX],
	nrb;
char A[NMAX], B[NMAX], G[NMAX];

int main()
{
	freopen("dist.in", "r", stdin);
     freopen("dist.out", "w", stdout);

     read();
     solve();
	return 0;
}

void read()
{
	fgets(A, NMAX, stdin);
	fgets(B, NMAX, stdin);
     la = strlen(A);
     lb = strlen(B);
	A[la - 1] = 0;
     B[lb - 1] = 0;
     la--, lb--;
}

void solve()
{
	int i, j, a, bb, z, t, u, rez;

     rez = INF;
     lima = 1;
     for(i = 0 ;i < la;)
     {
	     for(; i < la && A[i] == ' '; i++);
          if(i == la) break;
          
          b[lima] = i;
          for(; i < la && A[i] >= 'A' && A[i] <= 'Z'; i++);
          e[lima++] = i;
     }

     limb = 1;
	for(i = 0, j = 1; i < lb;)
     {
		for(; i < lb && B[i] == ' '; i++);

          for(; i < lb && B[i] >= 'A' && B[i] <= 'Z'; i++)
          cuv[limb] = j,
          G[limb++] = B[i];
          j++;
     }

	nrb = j;
     S[0][0] = 0;
     for(i = 1; i < nrb || i < lima; i++)
     S[i][0] = INF;
     
     for(i = 1; i < limb; i++)
 	S[0][i] = INF;
     
     for(j = 1; j < limb; j++)
     for(i = 1; i <= j && i < 100; i++)
     {
     	S[i][j] = INF;

     	for(z = 0; z < 20 && z <= j - i; z++)
          {
          	a = 0;
			for(t = j - z, u = b[i]; t <= j && u < e[i]; t++, u++)
			a += abs(A[u] - G[t]);

               for(; t <= j; t++)
               a += abs(G[t] - '@');

               for(; u < e[i]; u++)
               a += abs(A[u] - '@');

               if(S[i][j] > S[i - 1][j - z - 1] + a)
               {
                    S[i][j] = S[i - 1][j - z - 1] + a;
                    bb = 0;
	                    for(t = j - z; t <= j; t++)
				bb += abs(cuv[t] - i);

                    V[i][j] = V[i - 1][j - z - 1] + bb;
               }
               else
               if(S[i][j] == S[i - 1][j - z - 1] + a)
               {
                    bb = 0;
                    for(t = j - z; t <= j; t++)
				bb += abs(cuv[t] - i);
                    if(V[i][j] > V[i - 1][j - z - 1] + bb)
                    V[i][j] = V[i - 1][j - z - 1] + bb;
               }
               else;
          }
     }
     
     int nru = INF;
     
     for(i = 100 <= limb - 1 ? 100 : limb - 1; i >= 0; i--)
     update(rez, nru, S[i][limb - 1] + cnt(i), V[i][limb - 1]);

     printf("%d %d\n", rez, nru);
}

int cnt(int x)
{
	if(x >= lima - 1)
     return 0;
     
     int i, rez = 0, j;
     
     for(i = x; i < lima; i++)
     for(j = b[i]; j < e[i]; j++)
     rez += abs(B[j] - '@');

     return rez;
}

void update(int &x, int &nr, int y, int z)
{
	if(x > y) x = y, nr = z;
     else if(x == y && nr > z) nr = z;
}
