#include<stdio.h>
#include<stdlib.h>

#define NMAX 100000
#define nd(a) (*(t_p *)(a))

typedef struct t_p
{
	int x, y;
};

void read();
int cmp(const void *a, const void *b);
double inter(int x);

int N, M, st[NMAX], vf;
long long sol[2 * NMAX];
double ix[NMAX];
t_p V[NMAX], P[2 * NMAX];

int main()
{
	freopen("puncte.in", "r", stdin);
     freopen("puncte.out", "w", stdout);

     read();
	return 0;
}

void read()
{
	int a, b, i, j;
     double x;

     vf = -1;
	scanf("%d%d", &N, &M);
     for(i = 0; i < N; i++)
     {
     	scanf("%d%d", &a, &b);
		if(i && V[i - 1].x == a) i--, N--;
          else
			V[i].x = a, V[i].y = b;
     }
	st[++vf] = 0, st[++vf] = 1;

     ix[0] = inter(0);
     
     for(i = 2; i < N; i++)
     {
     	st[vf + 1] = i;
          
     	for(x = inter(vf); vf >= 1 && ix[vf - 1] > x; vf--)
          st[vf] = i, x = inter(vf - 1);
          
          ix[vf++] = x;
     }
     for(i = 0; i < M; i++)
     {
     scanf("%d", &a);
     P[i].x = a, P[i].y = i;
     }

     qsort(P, M, sizeof(t_p), cmp);
     
     for(i = 0, j = 0; i < M; i++)
     {
     	while(ix[j] < P[i].x && j < vf) j++;
          sol[P[i].y] = ((long long)P[i].x - V[st[j]].x) * ((long long)P[i].x - V[st[j]].x) + (long long)V[st[j]].y * (long long)V[st[j]].y;
     }
     
     for(i = 0; i < M; i++)
     printf("%lld\n", sol[i]);
}

int cmp(const void *a, const void *b)
{
	return nd(a).x - nd(b).x;
}

double inter(int x)
{
	int a, b;
     double rez;

     a = st[x], b = st[x + 1];
	rez = ((double)V[b].x * (double)V[b].x + (double)V[b].y * (double)V[b].y - (double)V[a].x * (double)V[a].x - (double)V[a].y * (double)V[a].y);
     rez /= 2 * (V[b].x - V[a].x);
     return rez;
}
