/*
mem :
*/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# define  _fin  "cover.in"
# define  _fout "cover.out"

# define  maxn  60006
# define  maxl  1000001


int c[maxl], a[maxn][2], n, l, i,
    b[maxl], crt, old, act, sol=-1;

int end[maxl];

char buf[5*maxl], beg[maxl];
int len;

int getnxt(int &poz)
{
    int i, ret=0;

    for (; buf[poz]>=0x30 && buf[poz]<=0x39 && poz < len; ++poz)
        ret = ret * 10 + buf[poz]-0x30;
    for (; buf[poz]==' ' && poz<len; ++poz);

    return ret;
}

void readf()
{
/*	freopen(_fin, "r", stdin);

	for (scanf("%d%d", &n, &l), i=1; i<=l; i++) scanf("%d", c+i);
	for (i=1; i<=n; i++)
		 scanf("%d%d", &a[i][0], &a[i][1]);*/
	FILE *fin = fopen(_fin, "r");
	fscanf(fin, "%d%d\n", &n, &l);
	fgets(buf, 5*maxl, fin), len=strlen(buf);

	int poz=0;

	for (i=1; i<=l; i++)
		 c[i] = getnxt(poz);
	for (i=1; i<=n; i++)
		 fscanf(fin, "%d%d", &a[i][0], &a[i][1]);
}

int qspoz(int st, int dr)
{
	int x=a[st][0], y=a[st][1];

	while ( st < dr ) {
		while ( st < dr && ( (a[dr][0]>x) || (a[dr][0]==x && a[dr][1]>=y) ) ) dr--;
		a[st][0]=a[dr][0], a[st][1]=a[dr][1];
		while ( st < dr && ( (a[st][0]<x) || (a[st][0]==x && a[st][1]<=y) ) ) st++;
		a[dr][0]=a[st][0], a[dr][1]=a[st][1];
	}
	a[st][0]=x, a[st][1]=y;
	return st;
}

void qs(int st, int dr)
{
    int p, m;
    if ( dr-st+1 ){
        p = rand()% (dr-st+1)+st;
        if ( p != st ) {
            a[st][0] ^= a[p][0] ^= a[st][0] ^= a[p][0];
            a[st][1] ^= a[p][1] ^= a[st][1] ^= a[p][1];
        }
    }

	m = qspoz(st, dr);
	if ( st < m ) qs(st, m-1);
	if ( m < dr ) qs(m+1, dr);
}

// minHEAP

inline int st(int x) { return x<<1; }
inline int dr(int x) { return (x<<1)|1; }
inline int pr(int x) { return x>>1; }

int h[maxl], pz[maxl];

void insert(int x)
{
	int i = ++h[0];

	while (  pr(i) && b[ h[pr(i)] ] > b[ x ] ) {
		h[i] = h[pr(i)];
		pz[ h[i] ]= i;
		i = pr(i);
	}

	h[i] = x; pz[x] = i;
}

int getmin()
{
	if ( !h[0] ) return 0;
	return b[ h[1] ];
}

void extr(int x)
{
	int i = pz[x], min;

	if (i==h[0]) --h[0];
	else {
		h[i] = h[h[0]--];
		pz[ h[i] ] = i;

		while ( 1 )
		{
			min = i;
			if ( st(i)<=h[0] && b[ h[ st(i) ] ] < b[ h[ min ] ] ) min=st(i);
			if ( dr(i)<=h[0] && b[ h[ dr(i) ] ] < b[ h[ min ] ] ) min=dr(i);

			if ( min == i ) break;

			h[i] ^= h[min] ^= h[i] ^= h[min];
			pz[ h[i] ] = i;
			pz[ h[min] ] = min;
			i = min;
		}
	}
}

void solve()
{
	qs(1, n);

	old = a[1][0]-1;
	insert( a[1][0]-1 );

	for (i=1; i<=n; i++) end[ a[i][1] ] = i, beg[ a[i][0] ] = 1;

	for (crt=1, act=0, i=a[1][0]; i<=l; i++) {
		if ( beg[ i ] ) ++act;

		b[i] = c[i] + getmin();

		if ( act == n && (b[i] < sol || sol==-1) ) sol = b[i];

		insert(i);

		if ( end[i] )
			for (; old < a[ end[i] ][ 0 ]; old++) extr(old);
	}
}

int main()
{
    freopen(_fout, "w", stdout);
        
    readf();
	solve();

	printf("%d\n", sol);

	return 0;
}

