# include <stdio.h>
# include <string.h>

# define  _fin  "munte.in"
# define  _fout "munte.out"

# define  maxn  102
# define  bign  88


int ways[3][maxn][bign];
int n, _1[bign], to;

int mod[ 2*maxn ];


void add(int a[], int b[])
{
	int i, t=0;

	for (i=1; i<=a[0] || i<=b[0] || t; i++, t/=10)
		a[i] = ( t += (a[i]+b[i]) ) % 10;

	a[0]=i-1;
}

void solve()
{
	int i, j;

	for (i=0; i<2*maxn; i++) mod[i] = i%3;

	_1[0]=_1[1]=1;

	memcpy(ways[0][0], _1, sizeof(_1));

# define  crt	ways[ mod[i] ]
# define  prv	ways[ mod[i-1] ]
# define  prv2	ways[ mod[i-2] ]

	for (i=1, to=2*n-2; i<=to; i++) {
		memset( ways[ mod[i] ], 0, sizeof( ways[ mod[i] ] ) );

		for (j=0; j<=n; j++) {
//			add(ways[i][j], ways[i-1][j+1]);
			add(crt[j], prv[j+1]);

			if ( j ) {
//				if ( i>1 ) add(ways[i][j], ways[i-2][j]);
//				add(ways[i][j], ways[i-1][j-1]);
				if ( i>1 ) add(crt[j], prv2[j]);
				add(crt[j], prv[j-1]);
			}
		}
	}
}

int main()
{
	freopen(_fin, "r", stdin);
	freopen(_fout,"w", stdout);

	scanf("%d", &n);
	solve();

	int i;

	for (i=ways[ mod[to] ][0][0]; i>=1; i--)
		printf("%d", ways[ mod[to] ][0][i]);

	printf("\n");

	return 0;
}

