# include <stdio.h>
# include <string.h>

# define  _fin  "promo.in"
# define  _fout "promo.out"

# define  maxm  2222
# define  maxk  100001


int bx[maxk], by[maxk], cnt[maxk],
    *v[maxm],
    cc[maxm], o[maxm], q[maxm], h, t, usd[maxm], nod,
    oa[maxm], ob[maxm],
    vls[2*maxm], viz[2*maxm];

int m, n, k,
    step, i, j, old, max1, max2, req;


void readf()
{
    freopen(_fin, "r", stdin);

    for (scanf("%d%d", &m, &k), i=1; i<=k; i++)
         scanf("%d%d", bx+i, by+i), ++cnt[bx[i]], ++cnt[by[i]];

    for (i=1; i<=m; i++)
         v[i] = new int[ cnt[i]+1 ], v[i][0]=0;

    for (i=1; i<=k; i++)
         v[ bx[i] ][ ++v[ bx[i] ][0] ] = by[i],
         v[ by[i] ][ ++v[ by[i] ][0] ] = bx[i];
}

inline int max(int x, int y) { return x>y?x:y; }
inline int min(int x, int y) { return x<y?x:y; }

void updtnode(int s)
{
    memset(viz, 0, sizeof(viz));

    for (req=0, i=1; i<=v[s][0]; i++)
        if ( oa[ v[s][i] ] )
            ++viz[ oa[ v[s][i] ] ], ++viz[ ob[ v[s][i] ] ], ++req;

    // alegem doar valorile care raman in interiorul multimii de vecini
    for (vls[0]=0, i=1; i<=n; i++)
        if ( usd[i]==viz[i] && usd[i] ) vls[ ++vls[0] ] = i;

    if ( !vls[0] ) {
        oa[s] = ++n, ob[s] = ++n;
        usd[n] = usd[n-1] = 1;
        return;
    }
    else if ( vls[0]==1 ) {
        ++usd[ oa[s] = vls[1] ], ob[s] = ++n, usd[n] = 1;
        return;
    }
    else {
        // >= 2 : alegem una sau 2 valori care acopera complet multimea de vecini
        for (i=1; i<=vls[0]; i++)
            if ( usd[ vls[i] ] == req ) {
                oa[s] = vls[i], ob[s] = ++n;
                ++usd[oa[s]], ++usd[ob[s]];
                return;
            }

        // trebuie sa alegem 2 valori
        if ( usd[ vls[1] ] > usd[ vls[2] ] )
            max1 = vls[1], max2 = vls[2];
        else
            max2 = vls[1], max1 = vls[2];

        for (i=3; i<=vls[0]; i++)
            if ( usd[vls[i]] > usd[max1] )
                max2=max1, max1=vls[i];
            else if ( usd[ vls[i] ] > usd[max2] )
                max2=vls[i];

        oa[s] = max1, ob[s] = max2, ++usd[max1], ++usd[max2];
    }
}

void solve()
{
    for (step=1; step<=m; step++)
        if ( !oa[step] ) updtnode(step);
}

void writef()
{
    freopen(_fout, "w", stdout);

    for (printf("%d\n", n), i=1; i<=m; i++)
         printf("%d %d\n", oa[i], ob[i]);
}

int main()
{
    readf();
    solve();
    writef();

    return 0;
}

