# include <stdio.h>
# include <string.h>

# define  _fin  "puncte.in"
# define  _fout "puncte.out"

# define  maxn  100001
# define  maxb  536870912
# define  maxc  1000000001


int x[maxn], y[maxn], n, m, pt,
	q[maxn], st[maxn],
	i, j, k;

int step, rez, p1, p2;
// st[x] = capatul stanga de unde acopera punctul q[x]
// punctul q[x] acopera intre [st[q[x]], st[q[x+1])

# define  ll	long long
inline ll dist(int a, int b)
{
	return ( (ll)(x[a])-(ll)(x[b]) ) * ( (ll)(x[a])-(ll)(x[b]) ) +
		   ( (ll)(y[a])-(ll)(y[b]) ) * ( (ll)(y[a])-(ll)(y[b]) );
}

int bs(int from)
{
	for (rez=maxc, step=maxb, p1=q[q[0]], p2=q[q[0]-1]; step; step>>=1)
		if ( rez-step>from ) {
			x[0] = rez-step;
			if ( dist(p1, 0)<=dist(p2, 0) ) rez -= step;
		}

	return rez;
}

ll query(int pt)
{
	for (step=1; step<q[0]; step<<=1);

	for (rez=1; step; step>>=1)
		if ( rez+step <= q[0] )
			if ( pt >= st[rez+step] )
				rez += step;

	return dist( q[rez], 0 );
}

int main()
{
	freopen(_fin, "r", stdin);
	freopen(_fout,"w", stdout);

	for (scanf("%d%d", &n, &m), i=pt=1; i<=n; i++) {
		 scanf("%d%d", x+pt, y+pt);
		 pt += ( pt==1 || x[pt]!=x[pt-1] );
	}
	n = pt-1;

	for (q[q[0]=1]=1, st[1]=0, i=2; i<=n; i++) {
		while ( q[0]>=1 ) {
			x[0] = st[ q[0] ];

			if ( dist( i, 0 ) <= dist( q[q[0]], 0 ) ) --q[0];
			else break;
		}

		// acum cautam o valoare intre st[ q[0] ] si maxc pe care o acopera
		// punctul i si nu o acopera punctul q[ q[0] ]
		if ( !q[0] )
			q[++q[0]]=i, st[1] = 0;
		else {
			x[0] = maxc;

//			p1 = dist(q[q[0]], 0);
//			p2 = dist(i, 0);

			if ( dist(q[q[0]], 0) > dist(i, 0 ) ) {
				q[++q[0] ] = i;
				st[ q[0] ] = bs( st[ q[0]-1 ]);
			}
		}
	}

	for (i=1; i<=m; i++)
		scanf("%d", x),
		printf("%lld\n", query(x[0]));


	return 0;
}
