#include <cstdio>
#include <cstring>

#define base 100000
#define Nmax 256

typedef int huge[20];

huge c[Nmax][Nmax];
int n, m;

void readdata()
{
	freopen("munte.in", "r", stdin);
    freopen("munte.out", "w", stdout);

    scanf("%d", &n);
    n = 2*n-2;
}

void aduna(huge a, huge b)
{
	int i, t = 0, aux;
    
    for (i = 1; (i <= a[0]) || (i <= b[0]) || (t > 0); ++i)
    {
    	aux = a[i] + b[i] + t;
    	a[i] = aux % base;
        if (aux >= base) t = 1;
        else t = 0;
    }
    a[0] = i-1;
}

void scade(huge a, huge b)
{
	int i;

    for (i = 1; i <= a[0]; ++i)
    {
    	if (a[i] >= b[i]) a[i] -= b[i];
        else
        {
        	--a[i+1];
            a[i] = base+a[i]-b[i];
        }
    }
    while (a[0] && a[ a[0] ] == 0) --a[0];
}

void solve()
{
	int i, j, aux;

	c[0][0][0] = c[0][0][1] = 1;
    m = n/2+1;
    for (i = 1; i <= n; ++i)
    {
    	for (j = 0; j <= m; ++j)
        {
        	if (i > 1) aduna(c[i][j], c[i-2][j]); //c[i][j] += c[i-2][j];
            
            aduna(c[i][j], c[i-1][j+1]); //c[i][j] += c[i-1][j+1];
            if (j == 0 && i > 1) scade(c[i][j], c[i-2][j]); //c[i][j] -= c[i-2][j];
            
            if (j > 0) aduna(c[i][j], c[i-1][j-1]); //c[i][j] += c[i-1][j-1];
        }
    }

    printf("%d", c[n][0][ c[n][0][0] ]);
	for (i = c[n][0][0]-1; i > 0; --i)
    {
    	aux = c[n][0][i];
    	if (aux < 10000) printf("0");
        if (aux < 1000) printf("0");
        if (aux < 100) printf("0");
        if (aux < 10) printf("0");
        printf("%d", aux);
    }
}

int main()
{
	readdata();
    solve();
	return 0;
}
