#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define sz size()
#define pb push_back
#define x first
#define y second

#define Nmax 2048

vector<int> vec[Nmax];
char ad[Nmax][Nmax];
char viz[Nmax];
int rest[Nmax];
pair<int, int> rez[Nmax];
int cnt;
int n, m;
int Q[Nmax], qe, qb;

void readdata()
{
	freopen("promo.in", "r", stdin);
    freopen("promo.out", "w", stdout);

    int i, a, b;

    scanf("%d %d", &n, &m);
    for (i = 1; i <= m; ++i)
    {
    	scanf("%d %d", &a, &b);
        ad[a][b] = ad[b][a] = 1;
        vec[a].pb(b), vec[b].pb(a);
    }
}

void rezolva(int k)
{
	int i, j;
	int n1, n2;
    int nod, nod2, nod3;
    char s1 = 0, s2 = 0;
    char sol1, sol2;

	viz[k] = 1;
    rez[k].x = ++cnt;
    rez[k].y = ++cnt;

    n1 = n2 = 0;
    for (i = 0; i < vec[k].sz && !n1; ++i)
    for (j = i+1; j < vec[k].sz && !n1; ++j)
    	if (!ad[ vec[k][i] ][ vec[k][j] ])
        {
        	n1 = vec[k][i];
            n2 = vec[k][j];
        }

    if (!n1)
    {
    	for (i = 0; i < vec[k].sz; ++i)
        {
        	nod = vec[k][i];
            
            rez[nod].x = rez[k].x;
            rez[nod].y = ++cnt;
            rest[nod] = cnt;
        }
    }
    else
    {
    	rez[n1].x = rez[k].x;
        rez[n1].y = ++cnt;
        rest[n1] = cnt;

        rez[n2].x = rez[k].y;
        rez[n2].y = ++cnt;
        rest[n2] = cnt;
        
    	for (i = 0; i < vec[k].sz; ++i)
        {
        	nod = vec[k][i];
            if (nod == n1 || nod == n2) continue;

            if (ad[nod][n1] && !ad[nod][n2])
            {
            	rez[nod].x = rez[n1].x;
                rez[nod].y = ++cnt;
                rest[nod] = cnt;
            }
            if (ad[nod][n2] && !ad[nod][n1])
            {
            	rez[nod].x = rez[n2].x;
                rez[nod].y = ++cnt;
                rest[nod] = cnt;
            }
            if (ad[nod][n1] && ad[nod][n2])
            {
            	for (j = 0; j < vec[n1].sz; ++j)
                {
                	nod2 = vec[n1][j];
                    if (!ad[k][nod2] && nod2 != k)
                    {
                    	if (ad[nod2][nod])
                        {
                        	rez[nod].x = rez[k].y;
                            rez[nod].y = rez[n1].y;
                            s1 = 1;
                        }
                        else
                        {
                        	rez[nod].x = rez[k].x;
                            rez[nod].y = rez[n2].y;
                            s2 = 1;
                        }
                    }
                }

            	for (j = 0; j < vec[n2].sz; ++j)
                {
                	nod2 = vec[n2][j];
                    if (!ad[k][nod2] && nod2 != k)
                    {
                    	if (!ad[nod2][nod])
                        {
                        	rez[nod].x = rez[k].y;
                            rez[nod].y = rez[n1].y;
                            s1 = 1;
                        }
                        else
                        {
                        	rez[nod].x = rez[k].x;
                            rez[nod].y = rez[n2].y;
                            s2 = 1;
                        }
                    }
                }
                
            }
        }
        for (i = 0; i < vec[k].sz; ++i)
        {
        	nod = vec[k][i];
            if (rez[nod].x == 0)
            {
            	sol1 = 1;
                sol2 = 1;
            	for (j = 0; j < vec[k].sz; ++j)
                {
                	nod2 = vec[k][j];
                    
                    if (rez[nod2].x == rez[k].y)
                    if (ad[nod2][nod] == 0) sol1 = 0;

                    if (rez[nod2].x == rez[k].x)
                    if (ad[nod2][nod] == 0) sol2 = 0;
                }

                if (!sol1)
                {
                	rez[nod].x = rez[k].x;
                    rez[nod].y = rez[n2].y;
                    s2 = 1;
                }
                if (!sol2)
                {
                	rez[nod].x = rez[k].y;
                    rez[nod].y = rez[n1].y;
                    s1 = 1;
                }
            }            
        }
        for (i = 0; i < vec[k].sz; ++i)
        {
        	nod = vec[k][i];
            if (rez[nod].x == 0)
            {
            	if (!s1)
                {
                	rez[nod].x = rez[k].y;
                    rez[nod].y = rez[n1].y;
                    s1 = 1;                
                }
                else
                {
                	rez[nod].x = rez[k].x;
                    rez[nod].y = rez[n2].y;
                    s2 = 1;                
                }
            }
        }
    }
    qb = 1;
    qe = 0;
    for (i = 0; i < vec[k].sz; ++i)
    {
    	nod = vec[k][i];
        viz[nod] = 1;
        Q[++qe] = nod;
    }
    while (qb <= qe)
    {
    	nod = Q[qb++];
        if (rez[nod].y == 0)
        {
        	rez[nod].y = ++cnt;
            rest[nod] = cnt;
        }

        for (i = 0; i < vec[nod].sz; ++i)
        {
        	nod2 = vec[nod][i];

            viz[nod2] = 1;
            if (rez[nod2].x == 0)
            {
            	rez[nod2].x = rest[nod];
                Q[++qe] = nod2;
            }
            else
            if (rez[nod2].y == 0)
            	rez[nod2].y = rest[nod];

        }
    }
}


void rezolva2(int k)
{
	int n1, n2;
    int next, ant;

	viz[k] = 1;
    rez[k].x = ++cnt;
    rez[k].y = ++cnt;

	n1 = vec[k][0];
    rez[n1].x = rez[k].x;
    rez[n1].y = ++cnt;
    viz[n1] = 1;

    n2 = vec[k][1];

    ant = k;
    
    while (1)
    {
    	if (vec[n1].sz == 1) break;
        
        next = vec[n1][0] + vec[n1][1] - ant;
        
        if (next == k)
        {
        	rez[n1].y = rez[k].y;
            --cnt;
            break;
        }

        viz[next] =1;
        rez[next].x = rez[n1].y;
        rez[next].y = ++cnt;

        ant = n1;
        n1 = next;
    }
    
    if (rez[n2].x == 0)
    {
    	n1 = n2;
        ant = k;

	    while (1)
	    {
	    	if (vec[n1].sz == 1) break;
        
	        next = vec[n1][0] + vec[n1][1] - ant;
        
	        if (next == k)
	        {
	        	rez[n1].y = rez[k].y;
		        --cnt;
	            break;
    	    }

            viz[next] = 1;
        	rez[next].x = rez[n1].y;
	        rez[next].y = ++cnt;

    	    ant = n1;
	        n1 = next;
    	}        
    }
}

void solve()
{
	int i;

    for (i = 1; i <= n; ++i)
    {
    	if (vec[i].sz == 0)
        {
        	rez[i].x = ++cnt;
            rez[i].y = ++cnt;
            viz[i] = 1;
        }
        if (vec[i].sz > 2 && !viz[i])
        	rezolva(i);
    }

    for (i = 1; i <= n; ++i)
    {
    	if (vec[i].sz == 2 && !viz[i])
        	rezolva2(i);
    }
    
    for (i = 1; i <= n; ++i)
    	if (vec[i].sz == 1 && !viz[i])
        {
        	rez[i].x = ++cnt;
            rez[i].y = ++cnt;

            rez[ vec[i][0] ].x = cnt;
            rez[ vec[i][0] ].y = ++cnt;

            viz[i] = 1;
            viz[ vec[i][0] ] = 1;
        }
}

void writedata()
{
	int i;

    printf("%d\n", cnt);
    for (i = 1; i <= n; ++i)
    	printf("%d %d\n", rez[i].x, rez[i].y);
}

int main()
{
	readdata();
    solve();
    writedata();
	return 0;
}
