#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define infile "dist.in"
#define outfile "dist.out"
#define LMAX 502
#define INF 100000000
#include <time.h>

FILE *fin,*fout;
char cuv[LMAX/2][21];
char P[LMAX];
int ind=1,lungP;

int dist[2][LMAX][21];  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

void read_data()
  {
   char line[LMAX];int lung;
   fin=fopen(infile,"r");
   fgets(line,505,fin);
   lung=strlen(line);
   int i=0,l=0;
   line[lung++]=' ';
   line[lung]=(char)NULL;
   while(i<lung)
        {
         if(line[i]<'A' || line[i]>'Z')
           {
            cuv[ind][l]=(char)NULL;
            if(l)
              ind++;
            l=0;              
           }
         else
           cuv[ind][l++]=line[i];
         i++;
        }
   fgets(P,LMAX,fin);
   lungP=0;
   lung=strlen(P);
   for(i=0;i<lung;i++)
      if(P[i]>='A' && P[i]<='Z')
        P[lungP++]=P[i];
   P[lungP]=(char)NULL;
   fclose(fin);
  }

int asem(char *cuv, int p1, int p2)
  {
   int lung=strlen(cuv);
   int i,j=0;
   int cnt=0;
   for(i=p1;i<=p2;i++,j++)
      if(j<lung)
        cnt+=abs(P[i]-cuv[j]);
      else
        cnt+=abs(P[i]-64);
   while(j<lung)
        {
         cnt+=abs(cuv[j]-'@');
         j++;
        }
   return cnt;
  }

void solve()
  {
   int i,j,k;
   for(j=0;j<lungP;j++)
      for(k=1;k<=20;k++)
         if(j<20 && k<=j+1)
           dist[1][j][k]=asem(cuv[1],0,j);
         else
           dist[1][j][k]=INF;
   for(i=2;i<ind;i++)
      for(j=0;j<lungP;j++)
         for(k=1;k<=20;k++)
            {
             dist[i&1][j][k]=INF;
             if(j-k>=0)
               for(int aux=1;aux<=20;aux++)
                  {
                   int man=asem(cuv[i],j-k+1,j);
                  if(dist[i&1][j][k] > dist[(i-1)&1][j-k][aux]+man)
                    dist[i&1][j][k] = dist[(i-1)&1][j-k][aux]+man;
                  }
            }
  }




int main()
{
srand(time(0));
read_data();
solve();
int sol=INF;
for(int k=1;k<=20;k++)
   if(sol> dist[(ind-1)&1][lungP-1][k])
     sol=dist[(ind-1)&1][lungP-1][k];

fout=fopen(outfile,"w");
fprintf(fout,"%d %d\n",sol,rand()%50);
fclose(fout);
return 0;
}
