#include <stdio.h>

#define infile "munte.in"
#define outfile "munte.out"
#define NMAX 105
#define dmax (2*n-2)
#define BAZA 1000
#define LMAX 50
struct NUMAR{int n; short int x[LMAX];};

FILE *fin,*fout;
int n;
NUMAR cnt[2*NMAX][2*NMAX];

NUMAR suma(NUMAR a, NUMAR b)
  {
   NUMAR c;
   int i=0,dim=a.n,in_minte=0;
   if(dim>b.n)
     dim=b.n;
   while(i<dim)
        {
         c.x[i]=a.x[i]+b.x[i]+in_minte;
         in_minte=c.x[i]/BAZA;
         c.x[i]%=BAZA;
         i++;
        }
   while(i<a.n)
        {
         c.x[i]=a.x[i]+in_minte;
         in_minte=c.x[i]/BAZA;
         c.x[i]%=BAZA;
         i++;
        }
   while(i<b.n)
        {
         c.x[i]=b.x[i]+in_minte;
         in_minte=c.x[i]/BAZA;
         c.x[i]%=BAZA;
         i++;
        }
   while(in_minte)
        {
         c.x[i]=in_minte%BAZA;
         in_minte/=BAZA;
         i++;
        }
   c.n=i;
   return c;
  }

void solve()
  {
   int x,y;
   cnt[dmax][0].n=cnt[dmax][0].x[0]=1;
   for(y=1;y<=dmax;y++)
      {
       cnt[dmax][y].n=1;
       cnt[dmax][y].x[0]=0;
      }
   for(x=dmax-1;x>=0;x--)
      {
       cnt[x][0].n=1;
       cnt[x][0].x[0]=0;
       if(x+2<=dmax)
         {
          cnt[x][0]=suma(cnt[x][0],cnt[x+2][0]);
          if(2<=dmax)
            cnt[x][0]=suma(cnt[x][0],cnt[x+2][2]);
         }
       if(x+3<=dmax && 1<=dmax)
         cnt[x][0]=suma(cnt[x][0],cnt[x+3][1]);
       for(y=1;y<=dmax;y++)
          {
           cnt[x][y]=cnt[x+1][y-1];
           if(x+2<=dmax)
             cnt[x][y]=suma(cnt[x][y],cnt[x+2][y]);
           if(y+1<=dmax)
             cnt[x][y]=suma(cnt[x][y],cnt[x+1][y+1]);
          }
      }
  }


void scrie(NUMAR a)
  {
   int i;
   fprintf(fout,"%d",a.x[a.n-1]);
   for(i=a.n-2;i>=0;i--)
      {
       fprintf(fout,"%d",a.x[i]/100);
       a.x[i]%=100;
       fprintf(fout,"%d",a.x[i]/10);
       a.x[i]%=10;
       fprintf(fout,"%d",a.x[i]);
      }
   fprintf(fout,"\n");
  }


int main()
{
fin=fopen(infile,"r");
fscanf(fin,"%d",&n);
fclose(fin);
solve();
fout=fopen(outfile,"w");
scrie(cnt[0][0]);
fclose(fout);
return 0;
}
