#include <stdio.h>
#define MAXL 1000001
#define MAXN 60000
#define IN1 1
#define IN2 2
#define INTERSECT1 3
#define INTERSECT2 4
#define MAX(q,r) (q)<(r)?(r):(q)
#define MIN(q,r) (q)<(r)?(q):(r)

using namespace std;

/*struct arb
{
    int a,b;
    arb *fiu, *frate;
} *root;
*/
struct lista
{
    int a,b;
    lista *next;    
} *root;

int n,l;
int ponderi[MAXL];

void citire();
void rezolvare();
void insert(int, int);
int min(int, int);
inline int intersect(lista *, int, int);

int main()
{
    citire();
    rezolvare();
    return 0;
}

void citire()
{
    FILE *f;
    int i,a,b;
    f=fopen("cover.in","r");
    fscanf(f,"%d %d",&n,&l);
    for (i=1; i<=l; i++)
	fscanf(f,"%d",&ponderi[i]);
    for (i=0; i<n; i++)
    {
	fscanf(f,"%d %d",&a,&b);
	insert(a,b);	
    }
    fclose(f);
}

void insert(int x, int y)
{
    if (!root)
    {
	root=new lista;
	root->a=x;
	root->b=y;
	root->next=NULL;
	return;
    }
    lista *i,*tmp, *j;
    i=j=root;
    int k;
    while (i && !(k=intersect(i,x,y)))
    {	j=i;
	i=i->next;
    }
    if (!i)
    {
	i=new lista;
	i->a=x;
	i->b=y;
	i->next=NULL;
	j->next=i;
	return;
    }
    
    switch(k)
    {
	case IN1: // p>
		i->a=x;
		i->b=y;
		break;
	case IN2: // p<
		
		break;
	case INTERSECT1:
	case INTERSECT2:
		tmp=new lista;
		tmp->a=x;
		tmp->b=y;
		tmp->next=i->next;
		i->next=tmp;
    }
}

inline int intersect(lista *p, int x, int y)
{
    if (x>=(*p).a && y<=(*p).b)
	return IN1;
    if (x<=(*p).a && y>=(*p).b)
	return IN2;
    if (x>=(*p).a && x<=(*p).b)
	return INTERSECT1;
    if (y>=(*p).a && y<=(*p).b)
	return INTERSECT2;
    return 0;
}

void rezolvare()
{
    lista *i;
    i=root;
    int s;
    s=0;
    int temp,temp1;
    while (i)
    {
	if (i->next && intersect(i->next, i->a, i->b))
	{
	    temp=min(i->a, i->b)+min(i->next->a, i->next->b);
	    temp1=min(MAX(i->a, i->next->a), MIN(i->b, i->next->b));
//	    temp=MIN(min(i->a), min(i->b))+MIN(min(i->next->a), min(i->next->b));
//	    temp1=MIN(min(MAX(i->a, i->next->a)), min(MIN(i->b, i->next->b)));
	    s+=MIN(temp1,temp);
	    i=i->next;
	}
	else
	{
	    s+=min(i->a, i->b);
	}
	//printf("%d %d\n",i->a,i->b);
	i=i->next;
    }
    FILE *f;
    f=fopen("cover.out","w");
    fprintf (f,"%d",s);
    fclose(f);
}

int min(int a, int b)
{
    int m=1000000;
    int i;
    for (i=a; i<=b; i++)
	if (ponderi[i]<m)
	    m=ponderi[i];
    return m;
}

