#include <stdio.h>
#include <vector>
#include <algorithm>

#define MAXN 100000
#define MAXM 200000
#define dist(idx,coordx) ((sx[(idx)].x-(coordx))*(sx[(idx)].x-(coordx)) + (sx[(idx)].y*sx[(idx)].y))

struct punct
{
    int x,y;
    int ind;
};

using namespace std;
int n,m;

vector <punct> sx;
vector <punct> sy;

inline int cautax(int);
inline int cautay(int);
inline int operator<(punct, punct);


int main()
{
    FILE *f;
    FILE *g;
    f=fopen("puncte.in","r");
    g=fopen("puncte.out","w");
    fscanf(f,"%d %d",&n,&m);
    int i,j;
    int nr;
    int temp;
    punct aux;
    
    int abs;
    nr=0;
    int lx=-1;
    for (i=0; i<n; i++)
    {
    	fscanf(f,"%d %d",&aux.x, &aux.y);
	if (lx!=aux.x)
	{
	    aux.ind=nr;
	    sx.push_back(aux);
	    sy.push_back(aux);
	    lx=aux.x;
	    nr++;	
	}
    }
    n=nr;
    sort(sy.begin(), sy.end());
    int minx=sy[0].x;
    int miny=sy[0].y;
    int min;
    int temp1;
    int x1,x2,y1;
    
    for (j=0; j<m; j++)
    {
	fscanf(f,"%d",&abs);
	min=(minx-abs)*(minx-abs)+miny*miny;
	temp1=cautax(abs);
	temp=dist(temp1,abs);
	if (temp<min)
	    min=temp;
	x1=cautax(abs-min);
	x2=cautax(abs+min);
	y1=cautay(min);
	if ((x2-x1)>y1)
	{
	    for (i=0; i<=y1; i++)
	    {
		temp=sy[i].ind;
		if (temp>=x1 && temp<=x2 && min>(temp1=dist(temp,abs)))
		    min=temp1;
	    }
	}
	else
	{
	    for (i=x1; i<=x2; i++)
		if (sx[y1].y>=sx[i].y && min>(temp1=dist(i,abs)))
		    min=temp1;
	}
	fprintf(g,"%d\n",min);
    }
    fclose(f);
    fclose(g);
    
    return 0;
    
}

inline int operator<(punct a, punct b)
{	
    if (a.y<b.y)
	return 1;
    if (a.y==b.y && a.x<b.x)
	return 1;
    return 0;
}

inline int cautax(int abs)
{
    int a,b,mid;
    a=0;
    b=n-1;
    
    while (a<b)
    {
    	mid=(a+b)>>1;
	if (sx[mid].x==abs)
	    return mid;
	if (sx[mid].x<abs)
	    a=mid+1;
	else
	    b=mid-1;
    }
/*    if (sx[a].x==abs)
	return a;
    if (sx[b].x==abs)
	return b;*/
    return a;
}

inline int cautay(int ord)
{
    int a,b,mid;
    a=0;
    b=n-1;
    while (a<b)
    {
    	mid=(a+b)>>1;
//	printf ("%d %d\n",a,b);
	if (sy[mid].y==ord)
	    return mid;
	if (sy[mid].y<ord)
	    a=mid+1;
	else
	    b=mid-1;
    }
/*    if (sy[a].y==ord)
	return a;
    if (sy[b].y==ord)
	return b;*/
    return a;
}
