#include <cstdio>
#include <cstring>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

typedef pair<int, int>sol;
const int WMAX = 210;

char s1[1000], s2[1000];
int cost2[500][20]; //Costul pentru a face un cuvant din secventa [i, i + j]

int mat[600][600], l1, l2;

inline int abs(int a) {
	return a < 0 ? -a : a;
}

int costSeparare(int i, int l) { //Incepe la i si are lungime x
	int ret = 0, k, j;
	for (; i < l2 && s2[i] == ' '; ++i);
	j = i + l - 1;
	for (k = 1; i - k >= 0 && s2[i - k] != ' '; ++k, ++ret);
	for (k = 0; j + k < l2 && s2[j + k] != ' '; ++k, ++ret);
	return ret;
}

int main() {
	FILE *fin = fopen ("dist.in", "r");
	FILE *fout = fopen ("dist.out", "w");
	fgets(s1, 1000, fin);
	fgets(s2, 1000, fin);
	l1 = strlen(s1);
	l2 = strlen(s2);
	if (s1[l1 - 1] == '\n') l1--;
	if (s2[l2 - 1] == '\n') l2--;
	mat[0][0] = 0;
	int i, j;
	vector<string>a;
	string b, buff;
	
	for (i = 0; i < l1; ++i) {
		if (s1[i] == ' ') {
			if (buff.size()) {
				a.push_back(buff);
				buff.clear();
			}
		} else {
			buff += s1[i];
		}
	}
	if (buff.size()) {
		a.push_back(buff);
	}
	int rs = a.size();
	for (i = 0; i < l2; ++i) {
		if (s2[i] != ' ') b += s2[i];
	}
	
	//Calculez cost2
	/*for (i = 0; i < l2; ++i) {
		vector<int>ll; //Lungimi
		int ls = 0;
		for (j = 0; j < 20; ++j) {
			if (s2[i + j] == ' ') {
				if (ls) {
					ll.push_back(ls);
				}
			} else {
				ls++;
			}
			//Calculul propriu-zis
			if (ls) {
				ll.push_back(ls);
			}
			if (ll.size() == 0) continue;
			int suma = 0, k;
			for (k = 0; k < ll.size(); ++k) {
				suma += ll[k];
			}
			//Caz special ... inceputul
			int ret = costSeparare(i, ll[0]) + suma - ll[0];
			for (k = 1; k + 1 < ll.size(); ++k) {
				ret = min(ret, suma - ll[0]);
			} 
			if (ls) {
				ret = min(ret, suma - ls + costSeparare(i
			}
		}
	*/	
	while (a.size() < WMAX) {
		a.push_back("");
	}
// 	printf ("Here\n");
	for (i = 0; i <= WMAX; ++i) {
		for (j = 0; j <= b.size(); ++j) {
			mat[i][j] = 1<<30;
		}
	}
	mat[0][0] = 0;
// 	printf ("Here\n");
	for (i = 0; i < a.size(); ++i) {
		int bcost = 0;
		for (j = 0; j < a[i].size(); ++j) {
			bcost += abs(a[i][j] - '@');
		}
		
		for (j = 0; j < b.size(); ++j) {
			if (mat[i][j] == (1<<30)) continue;
			int k, cost = bcost, cc;
			for (k = 1;k + j <= b.size() && k <= 20; ++k) {
				if (k <= a[i].size()) {
					cost -= abs(a[i][k - 1] - '@');
				}
				char c1 = k <= a[i].size() ? a[i][k - 1] : '@';
				char c2 = b[j + k - 1];
				cost += abs((int)c1 - (int)c2);
				mat[i + 1][j + k] = min(mat[i + 1][j + k], cost + mat[i][j]);
			}
		}
// 		printf ("\n");
	}
	int ret = 1<<30;
	for (; rs <= a.size(); ++rs) {
		ret = min(ret, mat[rs][b.size()]);
	}
	fprintf (fout, "%d 0\n", ret);
	fclose(fout);
	return 0;
}
