#include <cstdio>
#include <algorithm>
using namespace std;
typedef long long ll;

#define DEBUG 0

const int NMAX = 200002;
const ll INFI = (ll)2000000 * (ll)1000000 * (ll)1000000;
int x[NMAX], xx[NMAX / 2], yy[NMAX / 2];
ll dmin[NMAX];

int o[NMAX];

inline ll sqr(int x) {
	return (ll)x * (ll)x;
}

inline int cmp(int a, int b) {
	return x[a] < x[b] ? 1 : 0;
}

int main() {
	FILE *fin = fopen ("puncte.in", "r");
	FILE *fout = fopen ("puncte.out", "w");
	int n, m, i;
	fscanf (fin, "%d %d", &n, &m);
	for (i = 1; i <= n; ++i) {
		fscanf (fin, "%d %d", &xx[i], &yy[i]);
	}
	for (i = 1; i <= m; ++i) {
		o[i] = i;
		dmin[i] = INFI;
		fscanf (fin, "%d", &x[i]);
	}
	sort(o + 1, o + 1 + m, cmp);
	sort(x + 1, x + 1 + m);
	//The minimum from the left of the point (xx <= xPoint)
	int cp = 1, lpmin, cpmin; //Current Point
	ll cdmin = INFI;
	for (i = 1; i <= n; ++i) {
		while (xx[i] > x[cp]) {
			//Optimizez cu punctul din stanga
			if (cp > 1) {
				ll tt = sqr(xx[lpmin] - x[cp]) + sqr(yy[lpmin]);
				if (tt < cdmin) {
					cdmin = tt;
					cpmin = lpmin;
				}
			}
			if (cdmin < dmin[cp]) {
				dmin[cp] = cdmin;
			}
			cp++;
			lpmin = cpmin;
			cdmin = INFI;
			if (cp > m) {
				break;
			}
		}
		if (cp > m) break;
				if (cp > 1) {
				ll tt = sqr(xx[lpmin] - x[cp]) + sqr(yy[lpmin]);
				if (tt < cdmin) {
					cdmin = tt;
					cpmin = lpmin;
				}
			}
	
		if (sqr(x[cp] - xx[i]) + sqr(yy[i]) < cdmin) {
			cdmin = sqr(x[cp] - xx[i]) + sqr(yy[i]);
			cpmin = i;
		}
	}
	for (; cp <= m; ++cp) {
		dmin[cp] = min(dmin[cp], sqr(x[cp] - xx[cpmin]) + sqr(yy[cpmin]));
		dmin[cp] = min(dmin[cp], sqr(x[cp] - xx[lpmin]) + sqr(yy[lpmin]));
	}
	if (DEBUG) {
		int i;
		printf ("DEBUG==\n");
		for (i = 1; i <= m; ++i) {
			printf ("%lld ", dmin[i]);
		}
		printf ("\n");
	}
	// .. the same thing on the right of the point
	printf ("=============\n");
	cp = m;
	cdmin = INFI;
	for (i = n; i; --i) {
 		printf ("I = %d Cp = %d %d %d lpmin = %d\n", i, cp, xx[i], x[cp], lpmin);
		while (xx[i] < x[cp]) {
			//Optimizez cu punctul din dreapta
			if (cp < m) {
				ll tt = sqr(xx[lpmin] - x[cp]) + sqr(yy[lpmin]);
 				printf ("Try to expand %d with %d\n", cp, lpmin);
				if (tt < cdmin) {
					cdmin = tt;
					cpmin = lpmin;
				}
			}
			if (cdmin < dmin[cp]) {
				dmin[cp] = cdmin;
			}
			cp--;
			lpmin = cpmin;
			cdmin = INFI;
			if (cp == 0) {
				break;
			}
// 			printf ("Pop\n");
		}
		if (cp == 0) {
			break;
		}
		if (cp < m) {
			ll tt = sqr(xx[lpmin] - x[cp]) + sqr(yy[lpmin]);
 			printf ("Try to expand %d with %d\n", cp, lpmin);
			if (tt < cdmin) {
				cdmin = tt;
				cpmin = lpmin;
			}
		}

//  		printf ("I = %d Cp = %d\n", i, cp);
		if (sqr(x[cp] - xx[i]) + sqr(yy[i]) < cdmin) {
			cdmin = sqr(x[cp] - xx[i]) + sqr(yy[i]);
			cpmin = i;
//			printf ("Expanded\n");
		}
	}
// 	printf ("Cp = %d lpmin = %d\n", cp, lpmin);
	for (; cp; --cp) {
		printf ("Try to expand\n");
		dmin[cp] = min(dmin[cp], sqr(x[cp] - xx[cpmin]) + sqr(yy[cpmin]));
		dmin[cp] = min(dmin[cp], sqr(x[cp] - xx[lpmin]) + sqr(yy[lpmin]));
	}
	if (DEBUG) {
 		printf ("La stanga\n");
		for (i = 1; i <= m; ++i) {
			printf ("%lld at %d\n", dmin[i], 1);
		}
	}
	//Afisarea
	int io[NMAX];
	for (i = 1; i <= m; ++i) {
		io[o[i]] = i;
	}
	for (i = 1; i <= m; ++i) {
  		printf ("%d ", x[i]);
		fprintf (fout, "%lld\n", dmin[io[i]]);
	}
	fclose(fout);
	return 0;
}
