#include<stdio.h>
#include<string.h>

#define MAXN 128

int n;

const int base = 10000;
struct nrm
{
    int c[32];
    nrm()
    {
        memset(c, 0, sizeof(c));
    }
};

nrm d[2*MAXN][MAXN];
nrm zero;

nrm &get(int x, int y)
{
    if (x<0 || y<0) return zero;
    return d[x][y];
}

void add(nrm &a, const nrm &b)
{
    int t=0, n = a.c[0]>b.c[0]?a.c[0]:b.c[0];

    for (int i=1; i<=n; ++i)
    {
        t += a.c[i] + b.c[i];
        a.c[i] = t%base;
        t /= base;
    }
    a.c[0] = n;
    while (t) {a.c[++a.c[0]]=t%base; t/=base;}
}

void afiseaza(const nrm &a)
{
    printf("%d", a.c[a.c[0]]);
    for (int i=a.c[0]-1; i; --i)
        printf("%04d", a.c[i]);
    printf("\n");
}

int main(void)
{
    freopen("munte.in", "rt", stdin);
    freopen("munte.out", "wt", stdout);

    scanf("%d", &n);

    zero.c[0] = 1; zero.c[1] = 0;
    d[0][0].c[0] = d[0][0].c[1] = 1;

    for (int i=1; i<=2*n-2; ++i)
    {
        for (int j=0; j<n+3; ++j)
        {
            // jos
            add(d[i][j], get(i-1, j-1));
            // drept
            add(d[i][j], get(i-2, j));

            // sus
            if (j==0)
            {
                add(d[i][j], get(i-2, j+2));
                add(d[i][j], get(i-3, j+1));
            }
            else
                add(d[i][j], get(i-1, j+1));
            
        }
    }

    afiseaza(d[2*n-2][0]);
    
    return 0;
}

