#include <stdio.h>

short int pon[1000001];

struct interval {
	int start;
	int end;
	int best;
} inters[60000];
long long cost[60000];

int intercmp (const struct interval *a, const struct interval *b) {
	if (a->start == b->start) return a->end - b->end;
	return a->start - b->start;
}

FILE *in, *out;
int n, L;

int main () {
	int i, j, k;
	int dr;
	int best;
	
	in = fopen ("cover.in", "r");
	out = fopen ("cover.out", "w");

	fscanf (in, "%d %d", &n, &L);
	for (i=1;i<=L;i++) {
		fscanf (in, "%hd", &pon[i]);
	}

	for (i=0;i<n;i++) {
		fscanf (in, "%d %d", &inters[i].start, &inters[i].end);
		inters[i].best = inters[i].start;
		for (j=inters[i].start+1;j<=inters[i].end;j++) {
			if (pon[inters[i].best] > pon[j]) {
				inters[i].best = j;
			}
		}
	}
	qsort (inters, n, sizeof (struct interval), (int (*)(const void*,const void*))intercmp);

	cost[0] = pon[inters[0].best];
	for (i=1;i<n;i++) {
		cost[i] = cost[i-1] + pon[inters[i].best];
		dr = inters[i].end;
		for (j=i-1;j>=0;j--) {
			if (inters[j].end >= inters[i].start) {
				// cautam cel mai bun numar p-acilea
				if (dr > inters[j].end) dr = inters[j].end;
				best = inters[i].start;
				for (k=inters[i].start+1;k<=dr;k++) {
					if (pon[best] > pon[k]) {
						best = k;
					}
				}
				if (cost[i] > (j>0?cost[j-1]:0) + pon[best]) {
					cost[i] = (j>0?cost[j-1]:0) + pon[best];
				}
			}
		}
	}

	fprintf (out, "%lld\n", cost[n-1]);

	fclose (in);
	fclose (out);

	return 0;
}
