#include <fstream>

std::ifstream f1("puncte.in");
std::ofstream f2("puncte.out");
typedef struct{
  unsigned long elem;
  int poz;
}elem;

elem sir[10000];
unsigned long a[10000], b[10000], x, y;
int min, n, m, i, jos, sus, mij;

void merge(int jos, int mij, int sus);
void sort(int jos, int sus);

int main()
{
  f1>>n;
  f1>>m;
  for (i=0; i<n; i++)
  {
    f1>>a[i];
    f1>>b[i];
    sir[i].elem=(a[i]*a[i])+(b[i]*b[i]);
    sir[i].poz=i;
  }//for i
  sort(0, n-1);
  for (i=0; i<m; i++)
  {
    f1>>y;
    x=y*y;
    jos=0;
    sus=n-1;
    while (jos<sus)
    {
      mij=(jos+sus)/2;
      if (x<sir[mij].elem)
        sus=mij-1;
      else
        if (x>sir[mij].elem)
          jos=mij+1;
        else
        {
          jos=mij;
          sus=mij;
        }//else
    }//while
    min=jos;
    if (abs(sir[sus].elem-x)<abs(sir[min].elem-x))
      min=sus;
    if ((jos>0)&&(abs(sir[jos-1].elem-x)<abs(sir[min].elem-x)))
      min=jos-1;
    if ((sus<(n-1))&&(abs(sir[sus+1].elem-x)<abs(sir[min].elem-x)))
      min=sus+1;
    f2<<(((a[sir[min].poz]-y)*(a[sir[min].poz]-y))+(b[sir[min].poz]*b[sir[min].poz]))<<"\n";
  }//for i
  f1.close();
  f2.close();
  return 0;
}//main

void merge(int jos, int mij, int sus)
{
  int i1=jos, i2=mij+1, ib=jos;
  elem b[10000];
  while ((i1<=mij)&&(i2<=sus))
  {
    if (sir[i1].elem<sir[i2].elem)
    {
      b[ib]=sir[i1];
      i1++;
    }//if
    else
    {
      b[ib]=sir[i2];
      i2++;
    }//else
    ib++;
  }//while
  for (i=i1; i<=mij; i++)
    b[ib+i-i1]=sir[i];
  for (i=i2; i<=sus; i++)
    b[ib+i-i2]=sir[i];
  for (i=jos; i<=sus; i++)
    sir[i]=b[i];
}//merge

void sort(int jos, int sus)
{
  if (jos<sus)
  {
    int mij=(jos+sus)/2;
    sort(jos, mij);
    sort(mij+1, sus);
    merge(jos, mij, sus);
  }//if
}//sort

