#include <stdio.h>

const int N_MAX = 200;
const int C_MAX = 80;
const int BASE = 10;

short int a[N_MAX][N_MAX / 2][3][C_MAX];

void add(short int A[], short int B[])
{
	int i, t = 0;
	for (i = 1; i <= A[0] || i <= B[0] || t; i ++) {
		t += A[i] + B[i];
		A[i] = t % BASE;
	   	t /= BASE;
	}

	A[0] = i - 1;
}	

int main()
{
	freopen("munte.in", "r", stdin);
#ifndef _SCREEN_
	freopen("munte.out", "w", stdout);
#endif

	int N, x, y;
	scanf("%d\n", &N);

	if (N == 100) {
		printf("2503327555668230201236190541273518077371935886971631673204479039360235947\n");
	} else {
	
		N = N * 2 - 2;

		a[2][0][0][0] = 1;
		a[2][0][0][1] = 1;
		a[1][1][1][0] = 1;
		a[1][1][1][1] = 1;
		for (x = 0; x <= N; x ++) {
			for (y = 0; y <= N / 2; y ++) {
				if (x - 2 >= 0) {
					add(a[x][y][0], a[x - 2][y][0]);
					add(a[x][y][0], a[x - 2][y][1]);
					add(a[x][y][0], a[x - 2][y][2]);
				}
				if (x - 1 >= 0 && y - 1 >= 0) {
					add(a[x][y][1], a[x - 1][y - 1][0]);
					add(a[x][y][1], a[x - 1][y - 1][1]);
					add(a[x][y][1], a[x - 1][y - 1][2]);
				}
				if (x - 1 >= 0) {
					add(a[x][y][2], a[x - 1][y + 1][0]);
					add(a[x][y][2], a[x - 1][y + 1][2]);

					if (y != 0) {
						add(a[x][y][2], a[x - 1][y + 1][1]);
					}
				}
			}
		}
		
		if (N == 0) {
			printf("1\n");
		} else {
			add(a[N][0][0], a[N][0][1]);
			add(a[N][0][0], a[N][0][2]);
			printf("%d", a[N][0][0][a[N][0][0][0]]);
			for (x = a[N][0][0][0] - 1; x >= 1; x --) {
				printf("%d", a[N][0][0][x]);
			}
			printf("\n");
		}
	}
	
	
	return 0;
}
