#include <stdio.h>
#include <vector>

using namespace std;

const int M_MAX = 2010;

int a[M_MAX][M_MAX];
vector <int> G[M_MAX];

int of[2][M_MAX], nr[M_MAX], sol[M_MAX];

int main()
{
	freopen("promo.in", "r", stdin);
#ifndef _SCREEN_
	freopen("promo.out", "w", stdout);
#endif

	int M, K, i, x, y;
	
	scanf("%d %d\n", &M, &K);
	for (i = 1; i <= K; i ++) {
	
		scanf("%d %d\n", &x, &y);
		a[x][y] = 1;
		a[y][x] = 1;
		G[x].push_back(y);
		G[y].push_back(x);
	}

	int prod = 1, j, k;
	
	for (i = 1; i <= M; i ++) {

		vector <int>::iterator it;
		
		sol[0] = 1, sol[1] = i;
		for (it = G[i].begin(); it != G[i].end(); ++ it) {
			if (a[i][*it]) {
				sol[++ sol[0]] = *it;
				a[i][*it] = 0;
			}
		}

		for (j = 1; j <= sol[0]; j ++) {
			of[nr[sol[j]] ++][sol[j]] = prod;

			for (k = j + 1; k <= sol[0]; k ++) {
				a[sol[j]][sol[k]] = 0;
				a[sol[k]][sol[j]] = 0;
			}
		}
		
		prod ++;
	}

	for (j = 0; j < 2; j ++) {
		for (i = 1; i <= M; i ++) {
			if (!of[j][i]) {
//				printf("%d %d\n", i, j);
				of[j][i] = prod ++;
			}
		}
	}
	
	printf("%d\n", prod - 1);
	for (i = 1; i <= M; i ++) {
		printf("%d %d\n", of[0][i], of[1][i]);
	}
	
	return 0;
}
