// programare dinamica O(N*TMAX)

#include <stdio.h>

#define NMAX 3001
#define TMAX 3001
#define INF 1000000000

long smin[2][TMAX];
int E[NMAX];
char sens[NMAX];
int i, j, k, N, c, a;

int main()
{
  freopen("agitatie.in", "r", stdin);

  scanf("%d", &N);

  for (i = 1; i <= N; i++)
    scanf("%d %d", &E[i], &sens[i]);

  c = 0;

  for (j = 0; j < TMAX; j++)
    if (sens[N] > 0)
      smin[c][j] = E[N] + j;
    else
    if (E[N] >= j)
      smin[c][j] = 0;
    else
      smin[c][j] = j - E[N];

  for (i = N - 1; i >= 1; i--)
  {
    a = c;
    c = 1 - c;

    for (j = TMAX - 1; j >= 0; j--)
    {
      if (sens[i] > 0)
        smin[c][j] = E[i] + j + smin[a][j];
      else
      if (j >= E[i])
        smin[c][j] = (j - E[i]) + smin[a][j];
      else // 0 <= j <= E[i]
      if (smin[c][j + 1] < smin[a][j] + E[i] - j)
		  smin[c][j] = smin[c][j + 1];
	  else
		  smin[c][j] = smin[a][j] + E[i] - j;
	}
  }

  freopen("agitatie.out", "w", stdout);
  printf("%ld\n", smin[c][0]);

  return 0;
}
