{ XI ᨩ᪠  誮쭨  ଠ⨪ }
{                               }
{ 襭  "ࠫ쭠 ⠭"              }
{  : . 娭                             }
{  襭: . ஢                              }

{$A+,B-,D-,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}

const
  nMax = 1100;
  kMax = 6000;

var
  need : array[1..kMax] of boolean;     { 㦥  }
  timeCome : array[1..kMax] of integer; {  ਤ }
  micr : array[0..1] of record          { ⢮    }
                          local, change : integer;  { 䮭 }
                        end;
  micrWill : array[0..1, 1..nMax] of integer;{  䮭    }
  whereinHeap : array[1..kMax] of integer; {    䮭   }
                                           { ६ 室 }
  numberMicr, cntBlack : array[0..1] of integer;
  black : array[0..1,1..kMax] of integer;  {  ᯨ᮪ }
  n, k : integer;
  anyUse : integer;

procedure format(s : string; var A : char; var B : integer; var C, D : char);
var
  t : integer;
begin
  A := s[1];
  delete(s,1,2);
  val(copy(s, 1, pos(' ',s)-1), B, t);
  delete(s, 1, pos(' ',s));
  C := s[1];
  D := s[3];
end;

procedure readData;
var
  out : array[1..nMax] of char;         { 㤠 襫 }
  timeOut : array[1..nMax] of integer;  { ६ 室 }
  i, B : integer;
  s : string;
  A, C, D : char;
begin
  assign(input, 'input.txt');
  reset(input);

  fillchar(timeCome, sizeOf(timeCome), 0);
  fillChar(need, sizeOf(need), $FF);

  readLn(n, k);
  k := k * 2;
  for i := 1 to k do begin
    readln(s);
    format(s, A, B, C, D);
    if D = '' then
      if A = '+' then begin
        out[B] := C;
        timeOut[B] := i;
      end
      else begin
        if out[B] = C then begin
          need[timeOut[B]] := false;
          need[i] := false;
        end;

        timeCome[timeOut[B]] := i;
      end;
  end;

  close(input);
end;

procedure swap(side, i, j : integer);
var
  t : integer;
begin
  t := micrWill[side, i]; micrWill[side, i] := micrWill[side, j];
  micrWill
  [side, j] := t;
  t := whereinHeap[micrWill[side, i]];
  whereInheap[micrWill[side, i]] := whereInheap[micrWill[side, j]];
  whereInheap[micrWill[side, j]] := t;
end;

procedure insert(time, side : integer);
var
  i, t : integer;
begin
  i := micr[side].change;
  micrWill[side, i] := time;
  whereinHeap[time] := i;

  while (i > 1) do
    if micrWill[side, i] > micrWill[side, i div 2] then begin
      swap(side, i, i div 2);
      i := i div 2;
    end
    else
      break;
end;

function inOldFormat(sideChar : char) : byte;
begin
  if sideChar = '' then
    inOldFormat := 0
  else
    inOldFormat := 1;
end;

procedure delete(which, side : integer);
var
  i : integer;
begin
  i := whereinHeap[which];
  whereinHeap[which] := 0; { 塞 }
  if micr[side].change > 0 then begin
    micrWill[side, i] := micrWill[side, micr[side].change+1]; { ७ᨬ  }
    whereinHeap[micrWill[side, i]] := i;                      {     }
  end;

  while 2*i <= micr[side].change do
    if (2*i+1 <= micr[side].change) and
       (micrWill[side, 2*i+1] > micrWill[side, 2*i]) and
       (micrWill[side, i] < micrWill[side, 2*i+1]) then
      begin
        swap(side, i, 2*i+1);
        i := 2*i+1;
      end
    else
      if (micrWill[side, i] < micrWill[side, 2*i]) then begin
        swap(side, i, 2*i);
        i := 2*i;
      end
      else
        break;
end;

procedure outwithoutVoice(numOut, side : integer);
begin
  if micr[side].local > 0 then begin
    dec(micr[side].local);
    inc(micr[side].change);
    insert(timeCome[numOut], side);
  end
  else
  if (micr[side].change > 0) and (micrWill[side, 1] > timeCome[numOut]) then
    begin
      dec(micr[side].change);
      delete(micrWill[side, 1], side);
      inc(micr[side].change);
      insert(timeCome[numOut], side);
    end
  else
    whereinHeap[timeCome[numOut]] := 0;
end;

procedure outWithVoice(numOut, side : integer);
begin
  if micr[side].local > 0 then
    dec(micr[side].local)
  else
  if micr[side].change > 0 then begin
    dec(micr[side].change);
    delete(micrWill[side, 1], side);
  end
  else
  if anyUse > 0 then begin
    dec(anyUse);

    if cntBlack[side] = 0 then begin
      whereInheap[Black[1-side, cntBlack[1-side]]] := 0;
      dec(cntBlack[1-side]);
    end
    else 
      dec(cntBlack[side]);
  end
  else
    inc(numberMicr[side]);
end;

procedure comewithoutVoice(numCome, side : integer);
begin 
  if whereInheap[numCome] > 0 then begin
    inc(cntBlack[side]);
    Black[side, cntBlack[side]] := numCome;
    dec(micr[1-side].change);
    inc(anyUse);
    delete(numCome, 1-side);
    whereinHeap[numCome] := 1;
  end;
end;

procedure comewithVoice(numCome, side : integer);
begin
  inc(micr[side].local);
end;

procedure solve;
var
  i, B , side : integer;
  s : string;
  A, C, D : char;
begin
  assign(input, 'input.txt');
  reset(input);

  readLn(n, k);
  k := k * 2;
  numberMicr[0] := 0; numberMicr[1] := 0;
  cntBlack[0] := 0; cntBlack[1] := 0;
  fillChar(micr, sizeOf(micr), 0);
  fillChar(Black, sizeOf(Black), 0);
  fillChar(whereInHeap, sizeOf(whereInHeap), 0);
  anyUse := 0;

  for i := 1 to k do begin
    readLn(s);
    format(s, A, B, C, D);
    side := inOldFormat(C);

    if need[i] then
      case A of
        '+':case D of
              '' : outwithoutVoice(i, side);
              '' : outwithVoice(i, side);
            end;
        '-':case D of
              '' : comewithoutVoice(i, side);
              '' : comewithVoice(i, side);
            end;
      end;
  end;

  close(input);
end;

procedure printAnswer;
var
  i, B : integer;
  s : string;
  A, C, D : char;
begin
  assign(output, 'output.txt');
  reWrite(output);
  assign(input, 'input.txt');
  reSet(input);

  writeLn(numberMicr[0], ' ', numberMicr[1]);

  readLn(n, k);
  k := k * 2;
  for i := 1 to k do begin
    readLn(s);
    format(s, A, B, C, D);
    if A <> '-' then
      if (D = '') or
         (D = '') and (whereinHeap[timeCome[i]] = 1) then
        writeLn(1)
      else
        writeLn(0);
  end;

  close(input);
  close(outPut);
end;

Begin
  readData;
  solve;
  printAnswer;
End.
