// 07  1999 .
//  XIV   ଠ⨪ -࣠
//  ࠪ᪨ 
// 
// 襭   1 ("ﬠ").
//
// () ⠭⨭ 쪮, 1999
//
// ଠ 室  (input.txt):
//   楫 ᫠: X1, Y1, X2, Y2
//
// ଠ 室  (output.txt):
//   楫 ᥫ
//  (न   㣫   ⮢,
//           אַ).
//
// 窨  ⢥ 㯮冷祭  ⠭ न X,
//   ⥬ न Y.
//
#include <iostream.h>
#include <fstream.h>

ifstream fin ("input.txt");
ofstream fout("output.txt");

int X1, Y1, X2, Y2;
int Temp, Y;

inline void Swap(int &a, int &b)
{ Temp = a;
     a = b;
     b = Temp; }

#define MIN(A,B) ((A)<(B)) ? (A) : (B)
#define MAX(A,B) ((A)>(B)) ? (A) : (B)

void WriteAnswer(int X, int YLow, int YHigh)
{ //  ⨬ ࠡ ⮫ ⮪
  // YLow  -   ࠭
  // YHigh -   ࠭
  //
  //  ⠥  Y, 稭  YLow,  YHigh,
  //  ᪫ YHigh.

  for (Y = YLow; Y < YHigh; Y++)
    fout << X << " " << Y << endl;
}

void Solve()
{ if (X1 == X2)
  { // ⨪쭠 ﬠ. 
    //  Y2 >= Y1.
    if (Y1 > Y2) Swap(Y1, Y2);

    WriteAnswer(X1-1, Y1-1, Y2+1);
    WriteAnswer(X1  , Y1-1, Y2+1);
    return;
  }

  //  X2 > X1
  if (X2 < X1)
  { Swap(X1,X2);
    Swap(Y1,Y2);
  }

  WriteAnswer(X1-1, Y1-1, Y1+1);

int X;
                            //   ⮬,  ﬠ ᥪ ࠭ ⥪饣 ⮫
                            // (YLow, YHigh -    ࠭ ஭
                            //   祭 ⮪).
int YLowA, YHighA; // Left  //  ࠭ ⥪饣 ⮫ (  ।饣 蠣)
int YLowB, YHighB; // Right // ࠢ ࠭ ⥪饣 ⮫ (室   蠣)
int YLow,  YHigh;  // Combined

                  // Y 窨 祭  אַ  ⨪ X = const.
long Numerator;   // ᫨⥫ ஡
int  Denominator; // ⥫ ஡
long B, K;

  Denominator = X2 - X1;
  K           = Y2 - Y1;
  B           = X2*Y1 - X1*Y2;


  YLowA  = Y1-1;
  YHighA = Y1+1;

  for (X = X1+1; X <= X2; )
  { // YLowA, YHighA   ( ।饣 蠣).
    // YLowB, YHighB  .

    Numerator = K*X+B;

    YHighB = Numerator / Denominator  + 1;
    YLowB  = Numerator / Denominator;

    if (Numerator % Denominator == 0)
      YLowB--;

    //諨 YLowB, YHighB
    // ꥤ  'A'  'B',  ⠥ ⢥
    YLow  = MIN(YLowA,  YLowB);
    YHigh = MAX(YHighA, YHighB);

    //⠥ ⢥
    WriteAnswer(X-1, YLow, YHigh);

    //室  ᫥饬 祭 X ( ᫥饬 ⮫).
    X++;
    YLowA  = YLowB;
    YHighA = YHighB;
  }

  WriteAnswer(X2  , Y2-1, Y2+1);
}

int main()
{
  if (!fin)
  { cout << "Cannot open input.txt" << endl;
    return 1;
  }
  if (!fout)
  { cout << "Cannot open output.txt" << endl;
    return 1;
  }

  fin >> X1 >> Y1 >> X2 >> Y2;

  if (fin.fail())
  { cout << "Cannot read data" << endl;
    return 1;
  }

  Solve();

  return 0;
}