{  C " ࠠ"                                        }
{  ணࠬ: ⠭ ३                       }

program CheckC;

uses
  TestLib, Symbols;

const
  maxn = 20;

  dx: array [1..6] of integer = (1, -1, 0, 0, 0, 0);
  dy: array [1..6] of integer = (0, 0, 1, -1, 0, 0);
  dz: array [1..6] of integer = (0, 0, 0, 0, 1, -1);

type
  tpoint = record
    x, y, z: shortint;
  end;

var
  a: array [0..maxn+1, 0..maxn+1, 0..maxn+1] of char;
  i, j, k, l, m, n, r: longint;
  stx, sty, stz, finx, finy, finz: longint;
  broken, foundbroken: longint;
  c: char;
  que: array [0..maxn*maxn*maxn+1] of tpoint;
  h, t: longint;
  x, y, z: longint;

begin
  m := inf.readlongint;
  n := inf.readlongint;
  inf.nextline;

  fillchar(a, sizeof(a), '#');

  for k := 1 to m do
  begin
    for i := 1 to n do
    begin
      for j := 1 to n do
      begin
        a[i, j, k] := inf.nextchar;
        if a[i, j, k] = 'I' then
        begin
          stx := i;
          sty := j;
          stz := k;
        end;
        if a[i, j, k] = 'G' then
        begin
          finx := i;
          finy := j;
          finz := k;
        end;
      end;
      inf.nextline;
    end;
    inf.nextline;
  end;

  broken := ans.readlongint;
  r := ouf.readlongint;
  if r <> broken then
    quit(_wa, '⨬쭮 ⢮ ᫮ ⥭');

  if not ouf.seekeoln then
    quit(_pe, ' ଠ  ࢮ ப');
  ouf.nextline;

  foundbroken := 0;

  for k := 1 to m do
  begin
    for i := 1 to n do
    begin
      for j := 1 to n do
      begin
        if ouf.seekeoln or ouf.seekeof then
          quit(_pe, '誮  ᨬ  ப');
        c := ouf.nextchar;
        if c <> a[i, j, k] then
        begin
          if (a[i, j, k] = '#') and (c = '-') then
          begin
            a[i, j, k] := '.';
            inc(foundbroken);
          end
          else
          if c = '-' then
            quit(_wa, ' ࢠ ⥭  ᢮ ')
          else
          if c in ['#', '.', 'I', 'G'] then
            quit(_wa, 'ᮮ⢥⢨  ਭ ਣ')
          else
            quit(_pe, '⨬ ᨬ   ਭ');
        end;
      end;
      if not ouf.seekeoln then
        quit(_pe, '誮  ᨬ  ப');
      ouf.nextline;
    end;
    if (k <> m) and not (ouf.seekeoln) then
      quit(_pe, '  ப  ⠦');
    ouf.nextline;
  end;

  if broken <> foundbroken then
    quit(_wa, '⢮ ࢠ ⥭    ᮢ');

  a[stx, sty, stz] := '.';
  a[finx, finy, finz] := '.';

  h := 0;
  t := 1;
  que[0].x := stx;
  que[0].y := sty;
  que[0].z := stz;
  while h <> t do
  begin
    x := que[h].x;
    y := que[h].y;
    z := que[h].z;
    inc(h);
    for i := 1 to 6 do
      if a[x + dx[i], y + dy[i], z + dz[i]] = '.' then
      begin
        que[t].x := x + dx[i];
        que[t].y := y + dy[i];
        que[t].z := z + dz[i];
        a[x + dx[i], y + dy[i], z + dz[i]] := '!';
        inc(t);
      end;
  end;

  if a[finx, finy, finz] <> '!' then
    quit(_wa, '   ');

   { Wow ! }
  quit(_ok, '');
end.