{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 60384,0,655360}
Uses Crt;
Var
  a,b,c,i,j     : Integer;
  m,n           : Integer;
  Sizes         : Array [1..100] of REcord xr,yr : Integer;End;
  otkr          : Array [1..100] of Record
                                      num : Integer;
                                      kon : Array [1..100] of Byte;
                                    End;
  xr,yr         : Integer;
  Pairs         : Array [1..100] of Byte;
  UsedO,UsedK   : Array [1..100] of Boolean;
  Stop          : Boolean;


Function CanInsert(x1,y1,x2,y2 : Integer) : Boolean;
Var
  k1       : Integer;
  k,l      : Real;
  d,a1,b1  : Real;
  s,s1,s2  : REal;
Begin
  if x1<y1 then Begin
    k1:=x1;
    x1:=y1;
    y1:=k1;
  End;
  if x2<y2 then Begin
    k1:=x2;
    x2:=y2;
    y2:=k1;
  End;
  if (x1<=x2) and (y1<=y2) then Begin
    CanInsert:=True;
    Exit;
  End;
  if y1>=y2 then Begin
    CanInsert:=False;
    Exit;
  End;
  s:=y2/Sqrt(Sqr(0.1*10*x1)+Sqr(0.1*10*y1));
  if s>1 then Begin
    CanInsert:=False;
    Exit;
  End;
  s1:=y1/Sqrt(Sqr(0.1*10*x1)+Sqr(0.1*10*y1));
  s2:=s*Sqrt(1-Sqr(s1))+s1*Sqrt(1-Sqr(s));
  d:=y1*s2+x1*Sqrt(1-Sqr(s2));
  CanInsert:=x2>=d;
End;

Function SetOtkr(nn : Byte) : Boolean;Forward;

Function Good(ot,kon : Byte) : Boolean;
Var
  k,l : Integer;
Begin
  for k:=1 to otkr[ot].num do
    if otkr[ot].kon[k]=kon then Begin
      Good:=TRue;
      Exit;
    End;
  Good:=False;
End;

Function Free(nn : Byte) : Boolean;
Var
  k,l : Integer;
Begin
  for k:=1 to n do
    if Pairs[k]=nn then Break;
  if SetOtkr(k) then Begin
    Free:=True;
    Exit;
  End;
  Free:=False;
End;

Function SetOtkr(nn : Byte) : Boolean;
Var
  k,l : Integer;
Begin
  for k:=1 to otkr[nn].num do
    if not UsedK[otkr[nn].kon[k]] then Begin
      if Pairs[nn]<>0 then
        UsedK[Pairs[nn]]:=False;
      UsedK[otkr[nn].kon[k]]:=True;
      UsedO[nn]:=True;
      Pairs[nn]:=otkr[nn].kon[k];
      SetOtkr:=True;
      Exit;
    End;
  for k:=1 to otkr[nn].num do if Pairs[nn]<>otkr[nn].kon[k] then
    if Free(otkr[nn].kon[k]) then Begin
      if Pairs[nn]<>0 then
        UsedK[Pairs[nn]]:=False;
      UsedK[otkr[nn].kon[k]]:=True;
      UsedO[nn]:=True;
      Pairs[nn]:=otkr[nn].kon[k];
      SetOtkr:=True;
      Exit;
    End;
  SetOtkr:=False;
End;

Begin
  Assign(input,'input.txt');
  Reset(input);
  REadLn(m,n);
  FillChar(otkr,10200,0);
  FillChar(pairs,100,0);
  for a:=1 to m do
    Read(Sizes[a].xr,Sizes[a].yr);
  ReadLN;
  for a:=1 to n do Begin
    REad(xr,yr);
    for b:=1 to m do
      if CanInsert(xr,yr,Sizes[b].xr,Sizes[b].yr) then Begin
        Inc(otkr[a].num);
        otkr[a].kon[otkr[a].num]:=b;
      End;
  End;
  Close(input);
  FillChar(UsedO,100,0);
  FillChar(UsedK,100,0);
  REpeat
    Stop:=TRue;
    For a:=1 to n do
      if Pairs[a]=0 then
        if setOtkr(a) then Stop:=False;
  Until Stop;
  Assign(output,'output.txt');
  Rewrite(output);
  b:=0;
  for a:=1 to n do
    if Pairs[a]<>0 then Inc(b);
  WriteLn(b);
  for a:=1 to n do
    if Pairs[a]<>0 then
      Write(a,' ',Pairs[a],'  ');
  Close(output);
End.