{ ⨥ ﬨ }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

const MaxN = 30;
type TT = array [1..MaxN, 1..MaxN] of byte;
var c, v, t: TT;
    ff, ll, first, last: array [1..MaxN] of boolean;
    n: integer;
    p, q: array [1..MaxN] of integer;
    qh, qt, qn: integer;
    w: array [1..MaxN] of boolean;
    Timer: longint absolute $40: $6C;
    st: longint;
    x, y: array [1..1000] of integer;
    count: integer;

procedure ReadAll;
var i, j: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Read(n);
  while not SeekEof do begin
    Read(i, j);
    c[i, j] := 1;
  end;
end;

function NumFirst(var v: TT): Integer;
var i, j, c: integer;
label 1;
begin
  c := 0;
  for i := 1 to N do begin
    for j := 1 to N do
      if v[j, i] > 0 then goto 1;
    Inc(c);
1:
  end;
  NumFirst := c;
end;

function Optimize: boolean;
var i, j, k, l: integer;
    s: integer;
    changed: boolean;
label 1, 2;
begin
  Optimize := False;
  for i := 1 to N do begin
    last[i] := true;
    first[i] := true;
    for j := 1 to N do begin
      if v[i, j] > 0 then last[i] := false;
      if v[j, i] > 0 then first[i] := false;
    end;
  end;
  for i := 1 to n do
    if last[i] then
    for j := 1 to n do
      if first[j] and (c[i, j] > 0) and (v[i, j] = 0) then begin
        v[i, j] := 1;
        Optimize := True;
        Exit;
      end;
end;

procedure Out(i: integer);
var j: integer;
begin
  w[i] := True;
  Write(i, ' ');
  for j := 1 to N do
    if v[i, j] > 0 then Out(j);
end;

procedure FirstLast(var v: TT);
var i, j, k: integer;
begin
  for i := 1 to N do begin
    last[i] := true;
    first[i] := true;
    for j := 1 to N do begin
      if v[i, j] > 0 then last[i] := false;
      if v[j, i] > 0 then first[i] := false;
    end;
  end;
end;

procedure Shiza1;
var i, j, k, l: integer;
label 1;
begin
  st := timer;
  while timer - st < 70 do begin
    Fillchar(t, Sizeof(t), 0);
1:
    FirstLast(t);
    count := 0;
    for i := 1 to n do
      if last[i] then
      for j := 1 to n do
        if first[j] and (c[i, j] > 0) and (t[i, j] = 0) then
        begin
          Inc(count);
          x[count] := i;
          y[count] := j;
        end;
    if count <> 0 then begin
      i := random(count) + 1;
      t[x[i], y[i]] := 1;
      goto 1;
    end;
    if NumFirst(t) < NumFirst(v) then v := t;
  end;
end;

procedure Shiza2;
var b, x: array [1..MaxN] of byte;
    i, j, k, l: integer;
    o: array [1..MaxN] of byte;
  procedure Look(i: integer);
  var j: integer;
  begin
    b[i] := 1;
    x[i] := 0;
    for j := 1 to N do
      if (not w[j]) and (c[i,j] > 0) then begin
        Look(j);
        if b[i] < b[j]+1 then begin
          b[i] := b[j]+1;
          x[i] := j;
        end;
      end;
  end;

begin
  st := timer;
  for i := 1 to N do o[i] := i;
  while timer - st < 70 do begin
    Fillchar(t, Sizeof(t), 0);
    Fillchar(b, Sizeof(b), 0);
    Fillchar(x, Sizeof(x), 0);
    Fillchar(w, Sizeof(w), 0);
    for k := 1 to 50 do begin
      i := random(N) + 1;
      j := random(N) + 1;
      l := o[i]; o[i] := o[j]; o[j] := l;
    end;
    repeat
      for i := 1 to n do
        if not w[o[i]] then Break;
      if w[o[i]] then Break;
      i := o[i];
      Look(i);
      w[i] := true;
      while x[i] <> 0 do begin
        w[i] := true;
        t[i, x[i]] := 1;
        i := x[i];
      end;
      if i <> 0 then w[i] := true;
    until false;
    if NumFirst(t) < NumFirst(v) then v := t;
  end;
end;

procedure Solve;
var i, c: integer;
begin
  Fillchar(v, Sizeof(v), 0);
  Shiza1;
  Shiza2;
  FirstLast(v);

  c := 0;
  for i := 1 to N do
    if first[i] then Inc(c);
  Writeln(c);
  for i := 1 to N do
    if first[i] then begin
      Out(i);
      Writeln;
    end;
end;

begin
  ReadAll;
  Solve;
end.