{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  MaxN=50;
  Infinity=MaxLongInt Div 2;
Type
  TGraph=Array[1..MaxN,1..MaxN]Of LongInt;
  TThread=TGraph;
Var
  N,A,B:Byte;
  C,Q:TGraph;
  Res:Byte;
  N12:LongInt;
Procedure Load;
Var
  I,J:Byte;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  FillChar(C,SizeOf(C),0);
  Read(N,A,B);
  N12:=0;
  While Not SeekEOF Do Begin
    Read(I,J);
    If (I=A) And (J=B) Then Begin
      Inc(N12);
    End Else If (I<>J) And (J<>A) And (I<>B) Then C[I,J]:=1;
  End;
  Close(Input);
End;
Procedure Expand;
Var
  I,J:Byte;
  Last:Byte;
  NewIO:Byte;
Begin
  Last:=N;
  For I:=1 To N Do If (I<>A) And (I<>B) Then Begin
    Inc(Last);
    NewIO:=Last;
    For J:=1 To Last-2 Do If (C[I,J]>0) Then Begin
      C[NewIO,J]:=C[I,J];
      C[I,J]:=0;
    End;
    C[I,NewIO]:=1;
  End;
End;
Function MakeMaxThread(N:Byte; Const C:TGraph; S,T:Byte; Var Q:TThread):LongInt;
Var
  H:Array[1..MaxN]Of Byte;
  E:Array[1..MaxN]Of LongInt;
  L:Array[1..MaxN]Of Byte;
  I,J:Byte;
  Delta:LongInt;
  Ok:Boolean;
  MH:Byte;
  MI:Byte;
Function Min(A,B:LongInt):LongInt;
Begin
  If A<B Then Min:=A Else Min:=B;
End;
Begin
  FillChar(H,SizeOf(H),0);
  FillChar(Q,SizeOf(Q),0);
  FillChar(E,SizeOf(E),0);
  FillChar(L,SizeOf(L),0);
  E[S]:=Infinity;
  H[S]:=N;
  For I:=1 To N Do Begin
    Q[S,I]:=C[S,I];
    E[I]:=Q[S,I];
    L[I]:=1;
  End;
  Repeat
    Ok:=True;
    For I:=1 To N Do If (L[I]=1) And (E[I]>0) Then Begin
      For J:=1 To N Do If (H[I]=H[J]+1) Then
        If (Q[I,J]<C[I,J]) And (Q[J,I]=0) Then Begin
          Delta:=Min(E[I],C[I,J]-Q[I,J]);
          E[I]:=E[I]-Delta;
          Q[I,J]:=Q[I,J]+Delta;
          E[J]:=E[J]+Delta;
          L[J]:=1;
          Ok:=False;
{          WriteLn('Thread adjusted: +(',I,',',J,') by ',Delta,'! New E[',I,']=',E[I],', new E[',J,']=',E[J],'.');}
          If E[I]=0 Then Break;
        End Else If Q[J,I]>0 Then Begin
          Delta:=Min(E[I],Q[J,I]);
          E[I]:=E[I]-Delta;
          Q[J,I]:=Q[J,I]-Delta;
          E[J]:=E[J]+Delta;
          L[J]:=1;
          Ok:=False;
{          WriteLn('Thread adjusted: -(',J,',',I,') by ',Delta,'! New E[',J,']=',E[J],', new E[',I,']=',E[I],'.');}
          If E[I]=0 Then Break;
        End;
      If (E[I]>0) And (I<>S) And (I<>T) Then Begin
        MH:=2*N+1;
        For J:=1 To N Do If H[J]>=H[I] Then
          If Q[I,J]<C[I,J] Then Begin
            If H[J]<MH Then Begin
              MH:=H[J];
              MI:=J;
            End;
          End Else If Q[J,I]>0 Then Begin
            If H[J]<MH Then Begin
              MH:=H[J];
              MI:=J;
            End;
          End;
        If MH<=2*N Then Begin
          H[I]:=MH+1;
          Ok:=False;
{          WriteLn('Thread adjusted: ',I,' made higher to ',MI,'. New height=',H[I],'.');}
        End Else Begin
          L[I]:=2;
        End;
      End Else L[I]:=2;
    End;
  Until Ok;
  Delta:=0;
  For I:=1 To N Do Delta:=Delta+Q[I,T]-Q[T,I];
  MakeMaxThread:=Delta;
End;
Procedure Save;
Var
  Prefix:String;
  SS:String[4];
  I:LongInt;
Procedure FindAllPaths(V:Byte);
Var
  PL,I:Byte;
Begin
  PL:=Length(Prefix);
  If V<=N Then Begin
    Str(V,SS);
    Prefix:=Prefix+SS;
  End;
  If V=B Then Begin
    WriteLn(Prefix);
  End Else Begin
    If V<=N Then Prefix:=Prefix+' ';
    For I:=1 To N*2-2 Do If Q[V,I]>0 Then FindAllPaths(I);
  End;
  Prefix[0]:=Chr(PL);
End;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  WriteLn(N12+Res);
  Prefix:='';
  FindAllPaths(A);
  For I:=1 To N12 Do WriteLn(A,' ',B);
  Close(Output);
End;
Begin
  Load;
  Expand;
  Res:=MakeMaxThread(N*2-2,C,A,B,Q);
  Save;
End.