{$A+,B-,D-,E+,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
Program Paint_ride;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxN=25;
      Ogr=18.2*9.5;
Type Sset=Set Of 1..MaxN;
     TSol=Array[0..MaxN] Of Byte;
     BMasSol=Array[0..MaxN] Of TSol;

 Var IfP: Array[1..MaxN, 1..MaxN] Of Boolean;
     WhTo: Array[1..MaxN] Of Sset;
     sc, Insc: Array[1..MaxN] Of Integer;
     InSs: Array[1..Maxn] Of Sset;
     N: Integer;
     scRs, scNw: Integer;

     Timer: LongInt Absolute $0000: $046c;

     Rs, NwSl: BMasSol;
     OTm: LongInt;


 Procedure ReadData;
  Var k, p: Integer;
   Begin
     FillChar(WhTo, SizeOf(WhTo), 0);
     FillChar(IfP, SizeOf(IfP), False);
     FillChar(sc, SizeOf(sc), 0);
     FillChar(Insc, SizeOf(Insc), 0);
     FillChar(Inss, SizeOf(Inss), 0);
    Assign(Input, 'Input.TxT');
      Reset(Input);
       Read(N);
       While Not SeekEof Do Begin
        Read(k, p);
        IfP[k, p]:=True;
         Inc(sc[k]);
         Inc(Insc[p]);
        Include(WhTo[k], p);
        Include(Inss[p], k);
       End;
      Close(Input);
   End;

 Procedure Init;
  Var k, p: Integer;
   Begin
    FillChar(WhTo, SizeOf(WhTo), 0);
    FillChar(IfP, SizeOf(IfP), False);
    FillChar(sc, SizeOf(sc), 0);
    FillChar(Insc, SizeOf(Insc), 0);
    FillChar(Rs, SizeOf(Rs), 0);
    FillChar(NwSl, SizeOf(NwSl), 0);
    scRs:=0; scNw:=0;
    Assign(Input, InputFile);
     Reset(Input);
      Read(N);
      While Not SeekEof Do Begin
       Read(k, p);
       IfP[k, p]:=True;
        Inc(sc[k]);
        Inc(Insc[p]);
       Include(WhTo[k], p);
      End;
     Close(Input);
    OTm:=Timer;
   End;

Var Ls: Array[1..MaxN] Of Integer;
    Can: Array[1..MaxN] Of Boolean;


 Function GetWh: Integer;
  Var i: Integer;
   Begin
    i:=1;
     While (i<=N) And ((Insc[i]<>0) Or (Not Can[i])) Do Inc(i);
    If i>N Then GetWh:=0
      Else GetWh:=i;
   End;

 Procedure Del(Const k: Integer);
  Var i: Integer;
   Begin
    For i:=1 To N Do Begin
     If IfP[i, k] Then Begin
      IfP[i, k]:=False;
      Dec(sc[i]);
      Dec(Insc[k]);
     End;
     If IfP[k, i] Then Begin
      IfP[k, i]:=False;
      Dec(sc[k]);
      Dec(Insc[i]);
     End;
    End;
   End;

 Procedure Kill(Const a, k: Integer);
  Begin
   If k=0 Then Exit;
    Kill(a, Ls[k]);
    Del(k);
    Can[k]:=False;
    Rs[a, Rs[a, 0]+1]:=k;
    Inc(Rs[a, 0], 1);
  End;

 Procedure Obx(Const k: Integer);
  Var p, i, j, mx: Integer;
      Och: Array[1..MaxN*MaxN] Of Integer;
      A: Array[1..MaxN] Of Integer;
      dn, up: Integer;
   Begin
    FillChar(Och, SizeOf(Och), 0); dn:=1; Up:=1;
     FillChar(A, SizeOf(A), 0);
     FillChar(Ls, SizeOf(Ls), 0);
    Och[dn]:=k;
     Repeat
      p:=Och[Dn];
      For i:=1 To N Do
      If Can[i] Then
      If IfP[p, i] And (A[i]<A[p]+1) Then Begin
       A[i]:=A[p]+1;
       Inc(Up);
       Och[Up]:=i;
       Ls[i]:=p;
      End;
      Inc(Dn);
     Until Dn>up;

      mx:=0; p:=0;

     For i:=1 To N Do
     If Can[i] Then
     If A[i]>mx Then Begin
       mx:=A[i];
       p:=i;
     End;

    If p=0 Then Begin
     Inc(scRs);
     Rs[scRs, 0]:=1;
     Rs[scRs, 1]:=k;
     Can[k]:=False;
    End
    Else Begin
     Inc(scRs);
     Kill(scRs, p);
    End;
   End;

 Procedure PreSolve;
  Var i, j, k: Integer;
   Begin
    FillChar(Can, SizeOf(Can), True);
    Repeat
     k:=GetWh;
     If k<>0 Then Begin
      Obx(k);
     End;
    Until k=0;
   End;

 Procedure Done;
  Var i, j: Integer;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      WriteLn(scRs);
      For i:=1 To scRs Do Begin
       For j:=1 To Rs[i, 0] Do Write(Rs[i, j], ' ');
       WriteLn;
      End;
     Close(Output);
    Halt;
   End;

Var Use: Sset;

 Function GetNum: Integer;
  Var i: Integer;
   Begin
    i:=1;
     While (i<=N) And ((i In Use) Or (Inss[i]-Use<>[])) Do Inc(i);
    If i>N Then i:=0;
    GetNum:=i;
   End;

 Procedure Rec(Const k, mp: Integer;Const Cn: Sset);
  Var i: Integer;
      bb: Boolean;
   Begin
    If Timer-Otm>Ogr Then Done
     Else
    If k=1 Then Begin
     i:=GetNum;
     If i=0 Then Begin
      Rs:=NwSl;
      scRs:=mp-1;
     End
     Else Begin
      Include(Use, i);
       NwSl[mp, 1]:=i;
       Rec(k+1, mp, WhTo[i]-Use);
      NwSl[mp, 1]:=0;
      Exclude(Use, i);
     End;
    End
    Else
    If (mp>=scRs) Then Exit
    Else Begin
     bb:=False;
     For i:=1 To N Do
     If i In Cn Then Begin
      Include(Use, i);
       NwSl[mp, k]:=i;
        bb:=True;
       Rec(k+1, mp, WhTo[i]-Use);
       Exclude(Use, i);
      NwSl[mp, k]:=0;
     End;

     If Not bb Then Begin
      NwSl[mp, 0]:=k-1;
      Rec(1, mp+1, []);
     End;
    End;
   End;

 Procedure Solve;
  Begin
   PreSolve;
    ReadData;
   Use:=[];
   Rec(1, 1, []);
  End;

BEGIN
 Init;
  Solve;
 Done;
END.