Uses Crt;
Type
  TPoint = REcord x,y : Integer;End;

Var
  a,b,c                 : Integer;
  r                     : Real;
  n                     : Integer;
  nails                 : Array [1..500] of TPoint;
  p                     : TPoint;
  len                   : Integer;
  Orbit                 : Array [1..1000] of REcord p : TPoint;r,an : REal;End;
  curvec                : TPoint;
  Stop                  : Boolean;
  co1,cob               : Real;

Function GetAngle(v1,v2 : TPoint) : Real;
Var
  res,co,si   : Real;
  lens        : Real;
Begin
  lens:=Sqrt((Sqr(v1.x)+Sqr(v1.y))*(Sqr(v2.x)+Sqr(v2.y)));
  co:=(v1.x*v2.x+v1.y*v2.y)/lens;
  si:=(v1.x*v2.y-v1.y*v2.x)/lens;
  if co=0 then
    res:=pi/2
  else
    res := ArcTan (si/co);
  if res<0 then res:=res+pi;
  if si<0 then res:=2*pi-res;
  GetAngle:=REs;
End;

Procedure RideTheSky;
Var
  Way   : Real;
Begin
  Assign(output,'output.txt');
  rewrite(output);
  Way:=0;
  for a:=1 to len do
    Way:=Way+orbit[a].r*orbit[a].an;
  WriteLn(Way*2:0:2);
  close(output);
  Halt;
End;

Procedure GoToNextNail;
Var
  an,ban        : Real;
  pp,oldvec     : TPoint;
  k,l           : Integer;
Begin
  ban:=10000;
  b:=-1;
  for k:=1 to n do if (nails[k].x<>p.x) or (nails[k].y<>p.y) then
    if Sqr(nails[k].x-p.x)+Sqr(nails[k].y-p.y)<=Sqr(r) then Begin
      stop:=false;
      pp.x:=nails[k].x-p.x;
      pp.y:=nails[k].y-p.y;
      an:=GetAngle(curvec,pp);
      if an<ban then begin
        ban:=an;
        b:=k;
      end;
    End;
  if not stop then Begin
    oldvec:=curvec;
    curvec.x:=nails[b].x-p.x;
    curvec.y:=nails[b].y-p.y;
    if (p.y<=r) and (curvec.x*oldvec.x<0) and (p.y<>0) then Begin
      pp.x:=0;
      pp.y:=1;
      Orbit[len].an:=GetAngle(oldvec,pp);
      RideTheSky;
    End;
    Orbit[len].an:=ban;
    Inc(len);
    p:=nails[b];
    r:=r-Sqrt(Sqr(curvec.x)+Sqr(curvec.y));
    orbit[len].r:=r;
  End;
End;

Begin
  Assign(input,'input.txt');
  reset(input);
  ReadLN(n,r);
  for a:=1 to n do
    REadLN(nails[a].x,nails[a].y);
  close(input);
  p.x:=0;
  p.y:=0;
  len:=1;
  Orbit[1].r:=r;
  curvec.x:=-1;
  curvec.y:=0;
  repeat
    Stop:=true;
    GoToNextNail;
    if Stop then Begin
        Assign(output,'output.txt');
        rewrite(output);
        WriteLn(2*pi*r:0:2);
        close(output);
        Halt;
    End;
  Until False;
End.