{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Uses Crt;
Type
  TT =                                     Record
                                             x,y,v,l : LongInt;
                                           End;
Var
  a,b,c                 : Integer;
  n                     : Integer;
  Trees                 : Array [1..14] of TT;
  Cut,BC                : Array [1..14] of Boolean;
  lens                  : Array [1..14,1..14] of Real;
  NeedToCut             : Integer;
  curv,BV               : LongInt;
  curl,BL               : LongInt;
  Left                  : Real;
  tm1                   : LongInt;
  tm2                   : LongInt Absolute 0:$46c;

Function NeedL : Real;
Var
  k,l,i,j : LongInt;
  vx,vy   : LongInt;
  co1,cob : Real;
  len     : REal;
  curlen  : Real;
  p,p2    : ^TT;
  p1      : ^Boolean;
Begin
  l:=MaxInt;
  j:=0;
  p1:=Addr(Cut);
  p:=Addr(Trees);
  for k:=1 to n do Begin if not p1^ then Begin
    if l>p^.y then Begin
      l:=p^.y;
      i:=k;
    End;
    Inc(j);
  End;
  Inc(p1);
  Inc(p);
  End;
  if j=1 then Begin
    NeedL:=0;
    Exit;
  End;
  vx:=1;
  vy:=0;
  k:=i;
  len:=0;
  curlen:=1;
  repeat
    cob:=-20000000;
    p1:=Addr(Cut);
    p:=Addr(Trees);
    p2:=Addr(Trees[k]);
    for l:=1 to n do Begin if (not p1^) and (l<>k) then Begin
      co1:=(vx*(p^.x-p2^.x)+vy*(p^.y-p2^.y))/(curlen*lens[k,l]);
      if co1>cob then Begin
        cob:=co1;
        j:=l;
      end;
    End;
    Inc(p1);
    Inc(p);
    End;
    vx:=Trees[j].x-p2^.x;
    vy:=Trees[j].y-p2^.y;
    curlen:=lens[j,k];
    len:=len+curlen;
    k:=j;
  Until k=i;
  NeedL:=len;
End;

Procedure Search(nn : Byte);
Var
  k     : Integer;
  l     : Real;
  p     : ^Boolean;
  p1    : ^TT;
Begin
  if curv>=bv then Exit;
  if nn>NeedToCut then Begin
    l:=NeedL;
    if l<=curl then Begin
      BV:=curv;
      BL:=curl;
      Left:=Curl-l;
      BC:=Cut;
    End;
  End else Begin
    p:=Addr(cut);
    p1:=Addr(Trees);
    for k:=1 to n do Begin if not p^ then Begin
      p^:=True;
      inc(curv,p1^.v);
      Inc(curl,p1^.l);
      Search(nn+1);
      if tm2-tm1>170 then Exit;
      DEc(curl,p1^.l);
      dec(curv,p1^.v);
      p^:=False;
    End;
    inc(p);
    Inc(p1);
    end;
  End;
End;

Begin
  tm1:=tm2;
  Assign(input,'input.txt');
  reset(input);
  REadLn(n);
  for a:=1 to n do
    REadLn(Trees[a].x,Trees[a].y,Trees[a].v,Trees[a].l);
  Close(input);
  for a:=1 to n do
    for b:=1 to n do
      lens[a,b]:=Sqrt(Sqr(Trees[a].x-Trees[b].x)+Sqr(Trees[a].y-Trees[b].y));
  BV:=MaxLongInt;
  for NeedToCut:=1 to n-1 do Begin
    FillChar(Cut,n,0);
    curv:=0;
    curl:=0;
    Search(1);
    if tm2-tm1>170 then Break;
  End;
  Assign(output,'output.txt');
  rewrite(output);
  write('Cut these trees: ');
  for a:=1 to n do if BC[a] then
    Write(a,' ');
  WriteLn;
  WriteLn('Extra wood: ',Left);
  Close(output);
End.