{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
 var
   x, y: array [1..500] of extended;
   r, e, x0, y0, xx, yy: extended;
   n: integer;

 procedure ReadAll;
 var
   i,p: Integer;
   xx, yy: extended;
 begin
   Assign(Input, 'input.txt');
   Reset(Input);

   Read(n, r); p := 0;
   for i := 1 to n do begin
     Read(xx,yy);
     if (yy>0)or(sqrt((xx*xx)+(yy*yy))>=r) then dec(n) else begin
       inc(p);
       x[p] :=xx;y[p]:=yy;
     end;
   end;

   Close(Input);
 end;

 function sang(x,y: extended): extended;
 begin
   if (abs(x)<1e-6) then begin
     if y>0 then sang := 3*pi/2 else sang := pi/2;
   end;
   if (abs(y)<1e-6) then begin
     if x>0 then sang := pi else sang := 0;
   end;
   if (x>0)and(y>0) then sang := pi + arctan(y/x) else
   if (x>0)and(y<0) then sang := pi - arctan(-y/x) else
   if (x<0)and(y>0) then sang := (3*pi/2) + arctan(-x/y) else
   if (x<0)and(y<0) then sang := arctan(y/x);
 end;

 procedure Solve;
 var
   ax,ay,a,a0,ba,rr,cr,br,en,aa,baa: extended;
   f, k: integer;
 begin
   if n = 0 then begin
     e := 2*pi*r;
     exit;
   end;
   e := 0;
   xx := -r; yy := 0;
   x0 := 0; y0 := 0;

   repeat
     f := 0;
     a0 := sang(xx-x0,yy-y0);
     cr := sqrt(sqr(xx-x0)+sqr(yy-y0));

     for k := 1 to n do begin
       a := sang(x[k]-x0,y[k]-y0) + a0;
       aa := sang(x[k]-x0,y[k]-y0);
       if (aa-a0)<1e-5 then continue;
       while (a>2*pi) do a := a - (2*pi);
       while (a<0) do a := a + (2*pi);
       if abs(abs(a)-(2*pi))<1e-5 then a:= 0;
       rr := sqrt(sqr(x[k]-x0)+sqr(y[k]-y0));
       if (cr-rr)>1e-5 then begin
         en := y0-cr*sin(aa);
         if en<=0 then begin
           if (f=0) or ( (ba-a>1e-7) or ( (abs(a-ba)<1e-5) and (rr>br) )) then begin
             f := k; ba := a; br := rr; baa := aa;
           end;
         end;
       end;
     end;

     if f=0 then begin
       if (y0+cr<0) then begin
         e := 2*pi*cr;
         exit;
       end;

       ax := x0+sqrt(sqr(cr)-sqr(y0));
       ay := 0;
       aa := sang(ax-x0,ay-y0);
       e := e + cr*abs(aa-a0);

       e := e*2;
       exit;

     end else begin
       xx := x0-cr*cos(baa);
       yy := y0-cr*sin(baa);
       x0 := x[f];
       y0 := y[f];
       e := e + cr*abs(baa-a0);
     end;

   until 0=1;
 end;

 procedure Out;
 begin
   Assign(Output, 'output.txt');
   ReWrite(Output);

   WriteLn(e:0:2);

   Close(Output);
 end;

 begin
   ReadAll;
   Solve;
   Out;
 end.