{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
 var
   x,y,l,v: array [1..15] of longint;
   n: longint;
   r,p: array [1..15] of boolean;
   vr,vp,nr,np,cl:longint;
   ex, extra: extended;
   tm: longint absolute 0:$46c;
   stm: longint;

 procedure ReadAll;
 var
   I: Integer;
 begin
   Assign(input,'input.txt');
   Reset(Input);

   Read(n);
   for i := 1 to n do Read(x[i], y[i], v[i], l[i]);

   Close(Input);
 end;

 function min(a,b:longint): longint;
 begin
   if a>b then min := b else min := a;
 end;

 function max(a,b:longint): longint;
 begin
   if a>b then max := a else max := b;
 end;

 function btw(a,b,k: integer): boolean;
 var
   x1,x2,y1,y2: longint;
 begin
   x1 := min(x[a],x[b]);
   x2 := max(x[a],x[b]);

   y1 := min(y[a],y[b]);
   y2 := max(y[a],y[b]);

   btw := (x[k]>x2) or (x[k]<x1) or (y[k]>y2) or (y[k]<y1);
 end;

 function allok: boolean;
 var
   i, j, k: integer;
   a: array [1..15, 1..15] of boolean;
   ndd,x1,y1,x2,y2,xx,yy,vv,v1: extended;
   g,fv: boolean;
   cc: integer;
 begin
   fillchar(a, sizeof(a), 0);
   for i := 1 to n do if not p[i] then
     for j := i+1 to n do if not p[j] then begin
       x1 := x[i]; x2 := x[j]; y1 := y[i]; y2 := y[j];
       g := true; fv := false;

       for k := 1 to n do if (k<>i)and(k<>j)and(not p[k]) then begin
         xx := x[k]; yy := y[k];
         v1 := (xx-x1)*(y2-y1)-(yy-y1)*(x2-x1);

         if (abs(v1)>1e-6) then begin
           if fv then begin
             if (vv*v1)<0 then begin
               g := false; break;
             end;
           end else begin
             fv := true;
             vv := v1;
           end;
         end else begin
           if btw(i,j,k) then begin
             g := false; break;
           end;
         end;
       end;

       a[i,j] := g;
     end;

   ndd := 0; cc := 0;
   for i := 1 to n do for j := i+1 to n do if a[i,j] then begin
     x1 := x[i]; x2 := x[j]; y1 := y[i]; y2 := y[j];
     ndd := ndd + sqrt(sqr(x1-x2)+sqr(y1-y2));
     inc(cc);
   end;
   if cc=1 then ndd:=ndd*2;
   xx := cl;
   extra := xx-ndd;
   allok := (extra>0)or(abs(extra)<1e-6);
 end;

 procedure ck;
 begin
   if (vp<vr) then begin
     if (vp=vr)and(np>=nr) then exit;

     if allok then begin
       nr := np; r := p;
       vr := vp;
       ex := extra;
     end;

   end;
 end;

 procedure bld(k: integer);
 begin
   if tm>stm then exit;
   if np>nr then exit;

   if k>n then begin
     ck;
     exit;
   end;

   inc(np);
   p[k] := true;
   vp := vp + v[k];
   cl := cl+l[k];
   bld(k+1);

   p[k] := false;
   dec(np);
   vp := vp - v[k];
   cl := cl-l[k];
   bld(k+1);
 end;

 procedure Solve;
 var
   i: Integer;
 begin
   nr := n;
   fillchar(r, sizeof(r),1);
   vr := 0;
   for i := 1 to n do vr := vr+v[i];
   ex := 0;
   for i := 1 to n do ex := ex+l[i];

   np := 0;
   fillchar(p, sizeof(p), 0);

   bld(1);
 end;

 procedure Out;
 var i: Integer;
 begin
   Assign(Output, 'output.txt');
   ReWrite(Output);

   Write('Cut these trees:');
   for i := 1 to n do if r[i] then Write(' ', i);
   WriteLn;
   Write('Extra wood: ');
   WriteLn(ex:0:2);

   Close(Output);
 end;

 begin
   stm := tm+165;
   ReadAll;
   Solve;
   Out;
 end.