{ ࠤ ᠤ }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

type float = double;
const eps = 1.0e-10;
var i, n: integer;
    x, y, l, v: array [0..14] of longint;
    ll, vv, Minv: longint;
    f, minf: word;
    Mint, tt: integer;
    w: array [1..15] of boolean;

procedure ReadAll;
var i: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Read(n);
  for i := 0 to n-1 do
    Read(x[i], y[i], v[i], l[i]);
end;

function Fence: float;
var i, j, k, r: integer;
    len: float;
    d: longint;
begin
  r := -1;
  for j := 0 to n-1 do
    if (f and (1 shl j) = 0) then begin
      if (r = -1) or (x[j] > x[r]) or
         (x[j] = x[r]) and (y[j] > y[r]) then r := j;
    end;
  i := r;
  len := 0;
  repeat
    j := -1;
    for k := 0 to n-1 do
      if (k <> i) and (f and (1 shl k) = 0) then begin
        if (j = -1) then j := k else begin
          d := (x[k] - x[i])*(y[j] - y[i])-(x[j] - x[i])*(y[k] - y[i]);
          if (d < 0) or (d = 0) and
             (Sqr(x[k]-x[i])+Sqr(y[k]-y[i]) >
              Sqr(x[j]-x[i])+Sqr(y[j]-y[i])) then j := k;
        end;
      end;
    if j = -1 then Break;
    len := len + Sqrt(Sqr(1.0*x[i] - x[j]) + Sqr(1.0*y[i] - y[j]));
    i := j;
  until i = r;
  Fence := len;
end;

procedure WriteOut;
begin
  Write('Cut these trees: ');

  ll := 0;
  for i := 0 to n-1 do
    if minf and (1 shl i) > 0 then begin
      Write(i+1,' ');
      Inc(ll, l[i]);
    end;
  f := minf;
  Writeln;
  Write('Extra wood: ', ll-Fence:0:2);
  Halt;
end;

procedure Solve;
begin
  Minv := MaxInt;
  Mint := MaxInt;
  for f := 0 to 1 shl n - 1 do begin
    tt := 0;
    vv := 0;
    ll := 0;
    for i := 0 to n - 1 do
      if f and (1 shl i) > 0 then begin
        Inc(tt);
        Inc(vv, v[i]);
        Inc(ll, l[i]);
      end;
    if (vv < Minv) or ((vv = Minv) and (tt < Mint)) then begin
      if Fence <= ll+eps then begin
        minf := f;
        Minv := vv;
        Mint := tt;
      end;
    end;
  end;
  WriteOut;
end;

begin
  ReadAll;
  Solve;
end.