{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{$r+}

const
 ttttt=round(119318/65536*9.5);
 eps=1e-8;
 ddd0=1e-3;
 ddd=ddd0+eps;

type
 float=extended;
 tvec=array[0..1]of float;
 t3=array[0..2]of float;

var
 vs:array[0..7]of tvec;
 y:array[0..7]of float;
 sol:boolean;

 mina:array[1..7]of float;
 a:float;

 timer:longint absolute $40:$6C;
 start:longint;

 c3:integer;
 blf:array[0..7,0..7]of float;

procedure readin;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'input.txt'); reset(f);
  for i:=0 to 7 do
   read(f,vs[i,0],vs[i,1]);
  close(f);
 end;

procedure writeout;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'output.txt'); rewrite(f);
  if sol then begin
   for i:=0 to 7 do
    writeln(f,vs[i,0],' ',vs[i,1],' ',y[i]);
  end else writeln(f,'NO SOLUTIONS');
  close(f);
 end;

var
 s:array[0..5]of integer;
 used:array[0..7]of boolean;

procedure per(i:integer);
 var
  j,k:integer;
  found:boolean;
 begin
  if i>=3 then begin
   for j:=1 to 7 do if(not used[j])then begin
    s[i]:=j; inc(i);
    y[j]:=(2*sqr(a)-(blf[c3,j]+blf[0,0]-blf[0,c3]-blf[0,j]))/y[c3];
    if(i=4)then begin
     found:=false;
     for k:=0 to 2 do
      if(abs(sqrt(sqr(y[s[k]]-y[j])+(blf[s[k],s[k]]+blf[j,j]-2*blf[s[k],j]))-a)<ddd)then
       found:=true;
     if not found then exit;
    end;
    if abs(sqrt(sqr(y[j])+(blf[c3,c3]+blf[j,j]-2*blf[c3,j]))-a)>ddd then
     exit;
    for k:=3 to i-1 do
     if(abs(sqrt(
       sqr(y[s[k]]-y[j])+
       (blf[s[k],s[k]]+blf[j,j]-2*blf[s[k],j])
      )-a)>ddd)then
      exit;
   end;
   sol:=true;
   writeout;
   exit;
  end;
  for j:=1 to 7 do if(not used[j])then begin
   {y[j]:=sqr(vs[j,0]-vs[0,0])+sqr(vs[j,1]-vs[0,1])-sqr(a);
   if y[j]<0 then exit;
   y[j]:=sqrt(y[j]);}
   s[i]:=j;
   if y[c3]<>0 then
    y[j]:=(sqr(a)-(blf[c3,j]+blf[0,0]-blf[0,c3]-blf[0,j]))/y[c3]
   else
    continue;
   if abs(sqrt(sqr(y[j])+(blf[0,0]+blf[j,j]-2*blf[0,j]))-a)>ddd then
    continue;
   for k:=0 to i-1 do
    if(abs(sqrt(
      sqr(y[s[k]]-y[j])+
      (blf[s[k],s[k]]+blf[j,j]-2*blf[s[k],j])
     )-a)>ddd)then
     continue;
   per(i+1);
  end;
 end;

procedure check;
 begin
  if(sqr(vs[c3,0]-vs[0,0])+sqr(vs[c3,1]-vs[0,1])>3*sqr(a))then exit;
  y[c3]:=sqrt(3*sqr(a)-sqr(vs[c3,0]-vs[0,0])-sqr(vs[c3,1]-vs[0,1]));
  fillchar(used,sizeof(used),0);
  used[0]:=true; used[c3]:=true;
  per(0);
 end;

procedure solve;
 var
  i,j,k,l:integer;
  d:float;
  m:array[0..9]of float;
  mm:float;
  add:float;
 begin
  sol:=false;
  for i:=0 to 7 do
   for j:=0 to 7 do
    blf[i,j]:=vs[i,0]*vs[j,0]+vs[i,1]*vs[j,1];
  for k:=1 to 7 do begin
   fillchar(m,sizeof(m),0);
   m[0]:=sqr(vs[0,0]-vs[k,0])+sqr(vs[0,1]-vs[k,1]);
   for i:=1 to 6 do if i<>k then
    for j:=i+1 to 7 do if j<>k then begin
     l:=0;
     d:=sqr(vs[i,0]-vs[j,0])+sqr(vs[i,1]-vs[j,1]);
     while(l<9)and(m[l]>d)do inc(l);
     if l=10 then continue;
     if l<9 then move(m[l],m[l+1],sizeof(m[0])*(9-l));
     m[l]:=d;
    end;
   mina[k]:=trunc(sqrt(m[0]/3)-ddd)+1;
   mm:=trunc(sqrt(m[3]/2)-ddd)+1; if(mina[k]<mm)then mina[k]:=mm;
   mm:=trunc(sqrt(m[9])-ddd)+1; if(mina[k]<mm)then mina[k]:=mm;
  end;
  add:=0;
  while(timer<start) do begin
   for i:=1 to 7 do begin
    a:=mina[i]+add;
    c3:=i;
    check;
   end;
   add:=add+1;
  end;
 end;

begin
 start:=timer+ttttt;
 readin;
 solve;
 writeout;
end.