{$A+,B-,D-,E+,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
{$N+}
Program Kubs;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      RsNo='NO SOLUTIONS';
      N=8;
      Eps=1e-3;
      Ogr=9.5*18.2;
Type TPoint=Record x, y, z: Real; End;
 Var Rs, A: Array[1..N] Of TPoint;
     nbs: Integer;
     Rt: Array[1..N, 1..N] Of Real;
     CanRs: Boolean;
     Timer: LongInt absolute $0000:$046c;
     Tm: LongInt;

 Function Sqrt(Const a: Real): Real;
  Begin
   Sqrt:=system.Sqrt(Abs(a));
  End;

 Function Rast(Const a, b: TPoint): Real;
  Begin
   Rast:=(Sqr(a.x-b.x) + Sqr(a.y-b.y) + Sqr(a.z-b.z));{wht sqrt}
  End;

 Procedure Init;
  Var i, j: Integer;
   Begin
    Assign(Input, InputFile);
     Reset(Input);
      FillChar(A, SizeOf(A), 0);
      For i:=1 To N Do Read(A[i].x, A[i].y);
      For i:=1 To N Do
      For j:=1 To N Do Rt[i, j]:=Rast(A[i], A[j]);
     Close(Input);
    Tm:=Timer;
   End;

Var Can: Array[1..N] Of Boolean;
    Wy: Array[1..N] Of Integer;

 Procedure Done;
  Var i: Integer;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      If Not CanRs Then WriteLn(RsNo)
       Else
      For i:=1 to N Do WriteLn(Rs[i].x:0:5, ' ', Rs[i].y:0:5, ' ', Rs[i].z:0:5);
     Close(Output);
    Halt;
   End;

 Function Eq(Const a, b: Real): Boolean;
  Begin
   Eq:=Abs(a-b)<Eps;
  End;

 Function Less(Const a, b: Real): Boolean;
  Begin
   Less:=b-a>Eps;
  End;

 Function Cel(Const a: Real): Boolean;
  Begin
   Cel:=Eq(Frac(a), 0) Or (Eq(Frac(a)-1, 0));
  End;

 Function GetPol(Const a, b, c: Real; Var rs: Real): Boolean;
  Var dd: Real;
   Begin
    GetPol:=False;
     dd:=Sqr(b)-4*a*c;
     If Less(dd, 0) Then Exit;
    rs:=(-b+Sqrt(dd))/(2*a);
     If Less(rs, 0) Then Begin
       rs:=(-b-Sqrt(dd))/(2*a);
       If Less(rs, 0) Then Exit;
      End;
    GetPol:=True;
   End;

 Function Poss(Const a, b: Integer;Const c: Real): Boolean;
  Begin
   Poss:=Eq(Rt[a, b] + Sqr(Rs[a].z-Rs[b].z), c);
  End;

 Procedure Prov;
  Var aa, dd, aaa, bbb, ccc, rab: Real;
   Begin
    Rs:=A;
     Rs[wy[1]].z:=0;
    aa:=+Rt[wy[2], wy[1]]+Rt[wy[1], wy[3]]-Rt[wy[2], wy[3]];
    aaa:=4;
    bbb:=-4*(2*Rt[wy[2], wy[1]] + Rt[wy[1], wy[3]])+4*aa;
    ccc:=-Sqr(aa)+Rt[wy[2], wy[1]]*Rt[wy[1], wy[3]]*4;
    dd:=Sqr(bbb)-4*aaa*ccc;
    If Less(dd, 0) Then Exit;
      rab:=(-bbb+Sqrt(dd))/(2*aaa);
    If Less(rab, 0) Then Begin
       rab:=(-bbb-Sqrt(dd))/(2*aaa);
       If Less(rab, 0) Then Exit;
       If Not Cel(Sqrt(rab)) Then Exit;
      End
    Else Begin
     If Not Cel(Sqrt(rab)) Then Begin
      rab:=(-bbb-Sqrt(dd))/(2*aaa);
      If Less(rab, 0) Then Exit;
      If Not Cel(Sqrt(rab)) Then Exit;
     End;
    End;

     If Not GetPol(1, 0, Rt[wy[1], wy[2]]-rab, Rs[wy[2]].z) Then Exit;
     If Not GetPol(1, 0, Rt[wy[1], wy[3]]-2*rab, Rs[wy[3]].z) Then Exit;
     If Not GetPol(1, 0, Rt[wy[1], wy[4]]-rab, Rs[wy[4]].z) Then Exit;
     If Not GetPol(1, 0, Rt[wy[1], wy[5]]-rab, Rs[wy[5]].z) Then Exit;

     If Not GetPol(1, -2*Rs[wy[5]].z, Sqr(Rs[wy[5]].z)+Rt[wy[5], wy[6]]-rab, Rs[wy[6]].z)
      Then Exit;
     If Not GetPol(1, -2*Rs[wy[6]].z, Sqr(Rs[wy[6]].z)+Rt[wy[7], wy[6]]-rab, Rs[wy[7]].z)
      Then Exit;
     If Not GetPol(1, -2*Rs[wy[7]].z, Sqr(Rs[wy[7]].z)+Rt[wy[7], wy[8]]-rab, Rs[wy[8]].z)
      Then Exit;

      If Not Poss(1, 2, rab) Then Exit;
      If Not Poss(1, 3, 2*rab) Then Exit;
      If Not Poss(1, 4, rab) Then Exit;
      If Not Poss(1, 5, rab) Then Exit;
      If Not Poss(1, 6, 2*rab) Then Exit;
      If Not Poss(1, 7, 3*rab) Then Exit;
      If Not Poss(1, 8, 2*rab) Then Exit;
      If Not Poss(2, 3, rab) Then Exit;
      If Not Poss(2, 4, 2*rab) Then Exit;
      If Not Poss(2, 5, 2*rab) Then Exit;
      If Not Poss(2, 6, rab) Then Exit;
      If Not Poss(2, 7, 2*rab) Then Exit;
      If Not Poss(2, 8, 3*rab) Then Exit;
      If Not Poss(3, 4, rab) Then Exit;
      If Not Poss(3, 7, rab) Then Exit;
      If Not Poss(4, 8, rab) Then Exit;
      If Not Poss(5, 6, rab) Then Exit;
      If Not Poss(5, 8, rab) Then Exit;
      If Not Poss(6, 7, rab) Then Exit;
      If Not Poss(7, 8, rab) Then Exit;
    CanRs:=True;
   Done;
  End;

 Procedure Rec(Const k: Integer);
  Var i: Integer;
   Begin
    If Timer-Tm>Ogr Then Done
     Else
    If k>N Then Prov
     Else
    For i:=1 To N Do
    If Can[i] Then Begin
     Can[i]:=False;
      Wy[k]:=i;
      Rec(k+1);
     Can[i]:=True;
    End;
   End;

 Procedure Solve;
  Begin
   FillChar(Can, SizeOf(Can), True);
    CanRs:=False;
   Rec(1);
  End;

BEGIN
 Init;
  Solve;
 Done;
END.