{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
Type TPoint=Record X,Y:Real;End;
     TLine=Record A,B,C:Real;End;
Const Eps=0.001;
Var N:Integer;
    Gv:Array[1..510] Of TPoint;
    Pred:Integer;
    R,Otv:Real;

Procedure Input;
Var F:Text;
    I:Integer;
Begin
Assign(F,'Input.Txt');
Reset(F);
Read(F,N);Read(F,R);
For I:=1 To N Do Begin
Read(F,Gv[I].X,Gv[I].Y);
End;
Close(F);
End;

Procedure Out(T:Real);
Var F:Text;
Begin
Assign(F,'OutPut.Txt');
ReWrite(F);
WriteLn(F,T*2:2:2);
Close(F);
Halt(0);
End;

Function Rast(A,B:Tpoint):Real;
Begin
Rast:=Sqrt(Sqr(A.X-B.X)+Sqr(A.Y-B.Y));
End;

Procedure MakeLine(P1,P2:TPoint;Var L:TLine);
Begin
L.A:=P1.Y-P2.Y;
L.B:=P2.X-P1.X;
L.C:=P1.X*P2.Y-P2.X*P1.Y;
End;

Function Znak(P1,P2,P:TPoint):Byte;
Var L:TLine;
Begin
MakeLine(P1,P2,L);
If Abs(L.A*P.X+L.B*P.Y+L.C)<Eps Then Begin Znak:=2;Exit;End;
If L.A*P.X+L.B*P.Y+L.C>0 Then Znak:=1 Else
If L.A*P.X+L.B*P.Y+L.C<0 Then Znak:=0;
End;

Function ArcSin(X:Real):Real;
Begin
If 1-X*X<0 Then Begin ArcSin:=0;Exit;End;
If Sqrt(1-X*X)<1e-10 Then Begin ArcSin:=0;Exit;End;
ArcSin:=ArcTan(X/Sqrt(1-X*X));
End;

Function Ugol(A,B,C:TPoint):Real;
Var AB,AC,BC,Cosin:Real;
Begin
AB:=Rast(A,B);AC:=Rast(A,C);BC:=Rast(B,C);
If AB*BC=0 Then Cosin:=0 Else Cosin:=(AC*AC-AB*AB-BC*BC)/(-2*AB*BC);
Ugol:=Pi/2-ArcSin(Cosin);
End;

Function Segment(A,B,C:TPoint):Real;
Var R,Alf:Real;
Begin
R:=Rast(A,B);
Alf:=Ugol(B,A,C);
Segment:=R*Alf;
End;

Procedure BuildNail(Centre,Pol:TPoint);
Var Min,Dlin,Max,Temp,D:Real;
    Num:Integer;
    NewPol,TempP:TPoint;
    Zn:Array[0..2] Of Integer;
    I,Q:Integer;
    GVX,GVY:Real;
Begin
Dlin:=Rast(Centre,Pol);Num:=0;Min:=100000;

For I:=1 To N Do
If (Rast(Centre,Gv[I])-Dlin<Eps) And (Gv[I].X>=Pol.X) And (I<>Pred) Then
Begin
FillChar(Zn,SizeOf(Zn),0);
For Q:=1 To N Do
If (I<>Q) And (Rast(Centre,Gv[Q])-Dlin<Eps) Then Inc(Zn[Znak(Centre,Gv[I],Gv[Q])]);
{If ((Zn[0]=0) Or (Zn[0]=1)) And (Rast(Gv[I],Gv[Q])<Min) Then
              Begin Num:=I;Min:=(Rast(Gv[I],Gv[Q]));End;}
If ((Zn[0]=0) Or (Zn[0]=1)) And (Ugol(Gv[I],Centre,Gv[Q])<Min) Then
              Begin Num:=I;Min:=Ugol(Gv[I],Centre,Gv[Q]);End;
End;

If (Num=0) And (Dlin>Abs(Centre.Y)) Then Begin
TempP.X:=Sqrt(Sqr(Dlin)-Sqr(Centre.Y))+Centre.X;
TempP.Y:=0;
Otv:=Otv+Segment(Centre,Pol,TempP);
Out(Otv);
End;

If Num=0 Then
For I:=1 To N Do
If (Rast(Centre,Gv[I])-Dlin<Eps) And (I<>Pred) Then
Begin
FillChar(Zn,SizeOf(Zn),0);
For Q:=1 To N Do
If (I<>Q) And (Rast(Centre,Gv[Q])-Dlin<Eps) Then Inc(Zn[Znak(Centre,Gv[I],Gv[Q])]);
If ((Zn[0]=0) Or (Zn[0]=1)) And (Rast(Gv[I],Gv[Q])<Min) Then
              Begin Num:=I;Min:=(Rast(Gv[I],Gv[Q]));End;

End;

{⥫}
If Num=0 Then Begin
Out(Pi*Dlin);End;

Pred:=Num;
Max:=Rast(Centre,Gv[Num]);
GVX:=Gv[Num].X-Centre.X;GVY:=Gv[Num].Y-Centre.Y;
NewPol.X:=((GVX*Dlin)/Max)+Centre.X;NewPol.Y:=((GVY*Dlin)/Max)+Centre.Y;
Otv:=Otv+Segment(Centre,Pol,NewPol);
BuildNail(Gv[Num],NewPol);
End;

Procedure Work;
Var TekCent,TekPol:TPoint;
Begin
Otv:=0;Pred:=0;
TekCent.X:=0;TekCent.Y:=0;TekPol.X:=-R;TekPol.Y:=0;
BuildNail(TekCent,TekPol);
End;

Begin
Input;
Work;
End.