program Forest;
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

const
{$ifdef ILIA}
  InFile='c.in';
  OutFile='c.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type Real=Extended;
var n:byte;
    t:array[0..14] of record x,y,v,l:integer; name:byte; end;
var bestv:longint;
    besthas:byte;
    bestnum:longint;
    bestxtra:real;

procedure ReadData;
  var i:byte;
  begin
  Assign(input,InFile);
  Reset(Input);
  read(N);
  for i:=1 to N do
    with t[i] do begin
      read(x,y,v,l);
      name:=i;
    end;
  Close(Input);
  end;

procedure WriteSol;
  var i:byte;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  write('Cut these trees:');
  for i:=1 to N do
    if (bestnum and (1 shl (i-1))<>0) then
      write(' ',t[i].name);
  writeln;
  writeln('Extra wood: ',bestxtra:4:4);
  Close(Output);
  end;

(*function angle(a,b:byte):real;
  begin

  end;

procedure FillShoulds;
  var i,j:byte;
      alpha:array[1..14] of real;
      done:boolean;
  begin
  repeat
    done:=true;
    for i:=1 to N-1 do
      if (t[i].x>t[i+1].x) or
         ((t[i].x=t[i+1].x) and (t[i].y>t[i+1].y)) then begin
        t[0]:=t[i];
        t[i]:=t[i+1];
        t[i+1]:=t[0];
        done:=false;
      end;
  until done;
  for i:=1 to N do begin
    for j:=1 to N do
      if i<>j then
        alpha[j]:=angle(i,j);
    for j:=1 to N do
      should[i,j-ord(j>i)]:=j;
    repeat
      done:=true;
      for j:=1 to N-1 do
        if angle[j]>angle[j+1] then begin
          angle[0]:=angle[j];
          angle[j]:=angle[j+1];
          angle[j+1]:=angle[0];
          done:=false;
          should[i,j]
        end;

    until done;
  end;
  end;*)

procedure SortByY;
  var i,j:byte;
      done:boolean;
  begin
  repeat
    done:=true;
    for i:=1 to N-1 do
      if (t[i].y>t[i+1].y) or
         ((t[i].y=t[i+1].y) and (t[i].x>t[i+1].x)) then begin
        t[0]:=t[i];
        t[i]:=t[i+1];
        t[i+1]:=t[0];
        done:=false;
      end;
  until done;
  end;

var por:array[1..14,1..14] of byte;

function anglecos(a,b:byte):real;
  begin
  anglecos:=(t[b].x-t[a].y)/sqrt(sqr(t[b].x-t[a].x)+sqr(t[b].y-t[a].y));
  end;

procedure SortByAngle;
  var i,j:byte;
      tmp:byte;
    done:boolean;
  begin
  for i:=1 to N-1 do begin
    for j:=1 to N-i do
      por[i,j]:=i+j;
    repeat
      done:=true;
      for j:=1 to N-i-1 do
        if anglecos(i,por[i,j])<anglecos(i,por[i,j+1]) then begin
          tmp:=por[i,j];
          por[i,j]:=por[i,j+1];
          por[i,j+1]:=tmp;
          done:=false;
        end;
    until done;
  end;
  end;

var d:array[1..14,1..14] of real;

function sameside(a,b,c,d:byte):boolean;
  begin
  sameside := ((t[c].x*(t[b].y-t[a].y)-t[a].x*(t[b].y-t[a].y)-
      t[c].y*(t[b].x-t[a].x)-t[a].y*(t[b].x-t[a].x))>0)=
     ((t[d].x*(t[b].y-t[a].y)-t[a].x*(t[b].y-t[a].y)-
      t[d].y*(t[b].x-t[a].x)-t[a].y*(t[b].x-t[a].x))>0);
  end;


procedure Run;
  var has:array[1..14] of boolean;
      L:real;
  procedure Grahem;
    var i,j:shortint;
        s:array[1..14] of byte;
        sc:byte;
    begin
    L:=0;
    for i:=1 to N-1 do
      if has[i] then begin
        sc:=0;
        for j:=1 to N-i do
          if has[por[i,j]] then begin
            while (sc>=2) and (not sameside(s[sc],s[sc-1],i,por[i,j])) do
              dec(sc);
            inc(sc);
            s[sc]:=por[i,j];
          end;
        if sc>0 then L:=d[i,s[sc]]+d[s[1],i];
        for j:=1 to sc-1 do
          L:=L+d[s[j],s[j+1]];
        exit;
      end;
    end;

  var num:LONGINT;
      VV,LL:longint;
      cnt:byte;
  var i,j:byte;
  begin
  SortByY;
  SortByAngle;
  for i:=1 to N do
    for j:=1 to N do
      d[i,j]:=sqrt(sqr(t[i].x-t[j].x)+sqr(t[i].y-t[j].y));
(*  FillShoulds;*)
  bestv:=2000000000;
  for num:=1 to (1 shl N)-2 do begin
    VV:=0;
    cnt:=0;
    for i:=1 to N do begin
      has[i]:=(num and (1 shl (i-1)))=0;
      inc(cnt,ord(has[i]));
    end;
    for i:=1 to N do
      if not has[i] then
        inc(VV,t[i].v);
    if VV>bestV then
      continue;
    LL:=0;
    for i:=1 to N do
      if not has[i] then
        inc(LL,t[i].l);
    Grahem;
    if L<=LL then
      if (VV<bestv) or ((VV=bestv) and (cnt<besthas)) then begin
        besthas:=cnt;
        bestnum:=num;
        bestv:=VV;
        bestxtra:=LL-L;
      end;
  end;
  end;

begin
ReadData;
Run;
WriteSol;
end.