Program Markup;

Const _ : Char = '\'; Dot : Char = '.';

Var Inp,Out : File Of Char;

Procedure Init;
Begin
  Assign(Inp,'Input.Txt');
  Reset(Inp);
  Assign(Out,'Output.Txt');
  Rewrite(Out);
End;

Function SkipNumber : Boolean;
Var C : Char;
    Digs,Dots : Integer;
Begin
  SkipNumber:=True;
  Digs:=0; Dots:=0;
  Repeat
    If Eof(Inp) Then
    Begin
      If (Digs=0) And (Dots>0) Then Write(Out,Dot);
      Exit;
    End;
    Read(Inp,C);
    If C In ['0'..'9'] Then Inc(Digs);
    If C=Dot Then Inc(Dots);
  Until Not ((C In ['0'..'9']) Or (C=Dot) And (Dots=1));
  If (Digs=0) And (Dots>0) Then Write(Out,Dot);
  If C=_ Then SkipNumber:=False Else Write(Out,C);
End;

Procedure Solve;
Var C : Char;
    State,F : Boolean;
Begin
  State:=True;
  While Not Eof(Inp) Do
  Begin
    Read(Inp,C);
    If State Then
      Repeat
        F:=True;
        If (C<>_) Or Eof(Inp) Then Write(Out,C)
        Else Begin
          Read(Inp,C);
          If C='*' Then State:=False
          Else If C In ['b','i'] Then { Nothing }
          Else If C='s' Then Begin C:=_; F:=SkipNumber End
          Else Write(Out,C);
        End
      Until F
    Else Begin
      F:=False;
      While (C=_) And Not Eof(Inp) Do
      Begin
        F:=True;
        Read(Inp,C);
        If C=_ Then Write(Out,_);
      End;
      If Not F Then Write(Out,C)
      Else If C='*' Then State:=True
      Else If C=_ Then Write(Out,_)
      Else Write(Out,_,C);
    End;
  End;
End;

Procedure Done;
Begin
  Close(Inp);
  Close(Out);
End;

Begin
  Init;
  Solve;
  Done;
End.