{ ⠬ }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
const INfile = 'input.txt';
type Event = (
       _out_room,
       _out_elev,
       _entry_start,
       _entry_end,
       _in_elevq,
       _in_roomq,
       _in_room,
       _in_elev,
       _exit_end
     );

     TState = (
       _none,
       _gotoelev,
       _gotoroom,
       _stayelev,
       _stayroom,
       _inroom,
       _inelev,
       _gotoexit,
       _dead
     );

const MaxEvents = 7280;
type TEvent = record
       e: Event;
       t: longint;
       man, room: integer;
     end;

     TList = array [1..MaxEvents] of TEvent;
     PList = ^TList;

var code: array [1..26] of char;
    st: array [1..26] of longint;
    visN: array [0..26] of integer;
    vis: array [1..26, 1..100] of integer;
    vist: array [0..26, 1..100] of longint;
    N: integer;
    e, next: TEvent;
    roomt: array [0..99] of longint;
    roomu: array [0..99] of boolean;
    elevt: array [0..9] of longint;
    dests, stage, plan: array [0..26] of integer;
    { -1 - no, 0 - entry, n - n'th cab }
    state: array [1..26] of TState;
    last: array [1..26] of longint;
    CT: longint;
    ncab: integer;
    list: array [0..2] of PList;
    count: integer;

procedure W2(i: integer);
begin
  if i < 10 then Write('0');
  Write(i);
end;

procedure Wcab(i: integer);
begin
  W2(i div 10 + 1);
  W2(i mod 10 + 1);
end;

function Pcab(i: integer): integer;
begin
  Pcab := 10 * (i div 100 - 1) + i mod 100 - 1;
end;

procedure WriteTime(l: Longint);
begin
{  write(l, ' '); exit; }
  W2(l div 3600);
  Write(':');
  W2((l div 60) mod 60);
  Write(':');
  W2(l mod 60);
end;

procedure ReadAll;
var p: integer;
    s: String;
  function Get2(q: integer): longint;
  begin
    Get2 := (Ord(s[q])-$30)*10 + Ord(s[q+1])-$30;
  end;
begin
  Assign(input, INfile); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  N := 0;
  repeat
    Readln(s);
    if s  = '.' then Break;
    Inc(N);
    p := 1;
    while s[p] = ' ' do Inc(p);
    code[N] := s[p];
    Inc(p);
    while s[p] = ' ' do Inc(p);
    st[N] := 3600*Get2(p) + 60*Get2(p+3) + get2(p+6);
    repeat
      Read(p);
      if p = 0 then Break;
      Inc(visN[N]);
      vis[n, visn[n]] := Pcab(p);
      Read(vist[n, visn[n]]);
    until false;
    Readln;
  until false;
end;

procedure Try;
begin
  if ((e.T < next.T) or
      (e.T = Next.T) and (e.e < Next.e)) then
  begin
    next := e;
  end;
end;

procedure FindNext;
var i, j: integer;
label 1, 2;
begin
  for i := 1 to N do begin
    e.Man := i;
    case state[i] of
      _inroom:
      begin
        e.room := vis[i, plan[i]];
        e.e := _out_room;
        e.T := roomt[e.room];
        Try;
      end;
      _inelev:
      begin
        e.e := _out_elev;
        e.T := last[i] + 30 * Abs(dests[i] - stage[i]);
        Try;
      end;
      _gotoroom:
      begin
        e.e := _in_roomq;
        if (plan[i] = 1) and (stage[i] = 0) then
          e.T := last[i]
        else
          e.T := last[i] + 10;
        e.room := vis[i, plan[i]];
        Try;
      end;
      _gotoelev:
      begin
        e.e := _in_elevq;
        if plan[i] = 1 then
          e.T := last[i]
        else
          e.T := last[i] + 10;
        e.room := -1;
        Try;
      end;
      _stayroom:
      begin
        e.room := vis[i, plan[i]];
        if roomu[e.room] then goto 1;
        for j := 1 to N do
          if (state[j] = _stayroom) and
             (code[j] < code[i]) and
             (vis[j,plan[j]] = e.room) then goto 1;
        e.e := _in_room;
        e.T := roomt[e.room];
        Try;
1:
      end;
      _stayelev:
      begin
        for j := 1 to N do
          if (state[j] = _stayelev) and
             (stage[j] = stage[i]) and
             (code[j] < code[i]) then goto 2;
        e.e := _in_elev;
        e.T := elevt[stage[i]];
        Try;
2:
      end;
      _gotoexit:
      begin
        e.e := _exit_end;
        e.T := last[i] + 30;
        Try;
      end;
    end;
    if plan[i] = -1 then begin
      e.e := _entry_start;
      e.T := st[i];
      Try;
    end;
    if plan[i] = 0 then begin
      e.e := _entry_end;
      e.T := st[i] + 30;
      Try;
    end;
  end;
end;

procedure Update(m: integer);
begin
  last[m] := CT;
  if plan[m] > visn[m] then begin
    if stage[m] = 0 then
      state[m] := _gotoexit
    else begin
      dests[m] := 0;
      state[m] := _gotoelev;
    end;
  end else begin
    case state[m] of
      _none:
      begin
        ncab := vis[m,plan[m]];
        if (ncab div 10 = stage[m]) then
          state[m] := _gotoroom
        else begin
          state[m] := _gotoelev;
          dests[m] := ncab div 10;
        end;
      end;
    end;
  end;
end;

procedure HandleEvent;
begin
  with next do
  if t < Maxlongint then begin
    case e of
      _entry_start:
      begin
        plan[man] := 0;
      end;
      _entry_end:
      begin
        Inc(plan[man]);
        stage[man] := 0;
        state[man] := _none;
        Update(man);
      end;
      _in_roomq:
      begin
        if roomt[next.room] < CT then
          roomt[next.room] := CT;
        state[man] := _stayroom;
      end;
      _in_elevq:
      begin
        if elevt[stage[man]] < CT then
          elevt[stage[man]] := ((CT+4) div 5)*5;
        state[man] := _stayelev;
      end;
      _in_elev:
      begin
        last[man] := CT;
        elevt[stage[man]] := CT + 5;
        state[man] := _inelev;
      end;
      _out_elev:
      begin
        stage[man] := dests[man];
        state[man] := _none;
        Update(man);
      end;
      _out_room:
      begin
        roomu[next.room] := False;
        Inc(plan[man]);
        state[man] := _none;
        Update(man);
      end;
      _in_room:
      begin
        ncab := vis[man, plan[man]];
        roomt[ncab] := CT + visT[man, plan[man]];
        state[man] := _inroom;
        roomu[ncab] := True;
      end;
      _exit_end:
      begin
        state[man] := _dead;
      end;
    end;
  end;
end;

procedure WriteOut;
var cd: char;
    prr, i, j: integer;
    prev: longint;
    pre: Event;
    b: boolean;
  procedure Transfer;
  begin
    Write('Transfer from ');
    if (pre = _out_room) or (pre = _entry_end) then begin
      Write('room ');
      Wcab(prr);
    end else
    if (pre = _out_elev) then begin
      Write('elevator');
    end;
  end;
begin
  b := False;
  for cd := 'A' to 'Z' do
    for i := 1 to N do if code[i] = cd then begin
      if b then Writeln;
      b := True;
      Writeln(cd);
      prev := st[i];
      for j := 0 to count-1 do
      with list[j div MaxEvents]^[j mod MaxEvents] do
      if (man = i) and (T <> prev) then
      begin
        WriteTime(prev);
        Write(' ');
        WriteTime(T);
        Write(' ');
        case e of
          _entry_end: Writeln('Entry');
          _in_elevq:
          if pre <> _entry_end then begin
            Transfer;
            Writeln(' to elevator');
          end;
          _out_elev: writeln('Stay in elevator');
          _in_elev:
          begin
            Writeln('Waiting in elevator queue');
          end;
          _in_roomq:
          if pre <> _entry_end then begin
            Transfer;
            Write(' to room ');
            Wcab(room);
            Writeln;
          end;
          _in_room:
          begin
            Write('Waiting in front of room ');
            Wcab(room);
            Writeln;
          end;
          _out_room:
          begin
            Write('Stay in room ');
            Wcab(room);
            Writeln;
          end;
          _exit_end:
          begin
            Writeln('Exit');
          end;
        end;
        pre := e;
        prr := room;
        prev := T;
      end;
    end;
end;

procedure Solve;
var i: integer;
begin
  CT := -1;
  Fillchar(plan, Sizeof(plan), $FF);
  for i := 0 to 2 do New(list[i]);
  count := 0;
  repeat
    next.T := Maxlongint;
    next.Man := -1;
    FindNext;
    CT := next.T;
    HandleEvent;
    if (next.e in [_entry_end, _in_roomq, _in_room, _out_room,
                   _exit_end, _in_elevq, _in_elev, _out_elev]) then
    begin
      list[count div MaxEvents]^[count mod MaxEvents] := Next;
      Inc(count);
    end;
  until CT = MaxLongint;
end;

begin
  ReadAll;
  Solve;
  WriteOut;
end.