{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}

{ $DEFINE DEBUG}

const
  NMax = 500;

type
   integer = longint;

var
  i,j,max,N:integer;
  a:array[1..NMax] of record
                     x, y, R : longInt;
                   end;
  numIn:array[1..NMax] of integer;
  lenWay:array[1..NMax] of integer;
  pred:array[1..NMax] of integer;
  weight:array[1..NMax] of integer;
  B : Boolean;
  q,qmax:integer;

function inSide(i,j:longint):boolean;
var r1,r2,r3 : double;
begin
  r1 := a[i].x;
  r2 := a[i].y;
  r3 := a[i].r;
  if ( sqr(r1-a[j].x) + sqr(r2-a[j].y) <= sqr(r3 - a[j].R) ) and
     (r3 - a[j].R >= 0) then
    inSide := true
  else
    inSide := false;
end;

function Equal(i,j:integer):boolean;
begin
  if (a[i].X = a[j].X) and (a[i].Y = a[j].Y) and
     (a[i].R = a[j].R) then
    Equal := true
  else
    Equal := false;
end;

Begin
  assign(input,'c.in');
  reset(input);

  read(N);
  for i:=1 to N do
    read(a[i].x, a[i].y, a[i].R);

  fillChar(lenWay, sizeOf(lenWay), 0);
  fillChar(weight, sizeOf(weight), 0);
  for i:=1 to N do
    for j:=1 to N do
      if (i<>j) and Equal(i,j) then
        inc(weight[i])
      else
        if inSide(i,j) then
          inc(numIn[i]);

  repeat
    B := true;
    for i:=1 to N do
      if numIn[i] = 1 then begin
        B := false;
        numIn[i] := -2*N;
        inc(lenWay[i], weight[i]);
        for j:=1 to N do
          if (i<>j) and inSide(j, i) then begin
            dec(numIn[j], weight[i]+1);
            if lenWay[j] < lenWay[i]+1 then begin
              lenWay[j] := lenWay[i]+1;
              pred[j] := i;
            end;
          end;
      end;
  until B;

  max := 0;
  for i:=1 to N do
    if (max = 0) or (lenWay[i] > lenWay[max]) and (numIn[i] = -2*N) then
      max := i;

{$IFNDEF DEBUG}
  assign(output,'c.out');
  rewrite(output);
{$ENDIF}
  q:=0;
  qmax:=max;
  inc(q);
  for i:=1 to N do
    if (i<>max) and Equal(i,max) then
      inc(q);

  while pred[max]<>0 do begin
    max := pred[max];

    inc(q);
    for i:=1 to N do
      if (i<>max) and Equal(i,max) then
        inc(q);
  end;

  writeLn(q);


  max:=qmax;
  write(max,' ');
  for i:=1 to N do
    if (i<>max) and Equal(i,max) then
      write(i,' ');

  while pred[max]<>0 do begin
    max := pred[max];

    write(max,' ');
    for i:=1 to N do
      if (i<>max) and Equal(i,max) then
        write(i,' ');
  end;

  writeLn;
End.
