{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65384,0,655360}
Program HRUHRU;

Const InputFile='A.In';
      OutputFile='A.Out';
      Max=33000;
      Cns: Array[1..5] Of String=('"', 'HRU', '-', 'HRU', '"');
Type Sset=Set Of Char;
 Var F: File;
     Buf: Array[1..Max] Of Char;
     ReadNum: Integer;

 Procedure Init;
  Begin
   Assign(F, InputFile);
   Assign(Output, OutputFile);
    Reset(F, 1);
    Rewrite(Output);
  End;

 Function Eoln(Const uk: Integer): Boolean;
  Begin
   Eoln:=(uk>=ReadNum) Or ((Buf[uk]=#13) And (Buf[uk+1]=#10));
  End;

 Procedure Swap(Var uk: Integer;Const sp: Sset);
  Begin
   While (uk<=ReadNum) And (Buf[uk] In sp) Do Inc(uk);
  End;

 Function CanP(Var uk: Integer;Const sp: String): Boolean;
  Var i: Integer;
   Begin
    CanP:=False;
     For i:=1 To Length(sp) Do Begin
      If (uk>ReadNum) Or (UpCase(Buf[uk])<>sp[i]) Then Exit;
      Inc(uk);
     End;
    CanP:=True;
   End;

 Function Possible(uk: Integer): Boolean;
  Var i: Integer;
   Begin
    Possible:=False;
    For i:=1 To 5 Do Begin
     Swap(uk, [#32, #9]);
     If Not CanP(uk, Cns[i]) Then Exit;
    End;
    Possible:=True;
   End;

 Procedure Solve;
  Var uk: Integer;
   Begin
    BlockRead(F, Buf, SizeOF(Buf), ReadNum);
     uk:=1;
    While uk<=ReadNum Do Begin
     If Possible(uk) Then Begin
       While (Not Eoln(uk)) Do Inc(uk);
       Inc(uk, 2);
     End
      Else Begin
       While Not Eoln(uk) Do Begin
        Write(Buf[uk]);
        Inc(uk);
       End;
       WriteLn;
       Inc(uk, 2);
      End;
    End;
   End;

 Procedure Done;
  Begin
   Close(F);
   Close(Output);
  End;

BEGIN
 Init;
  Solve;
 Done;
END.