program C;
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,250000,655360}

const
  InFile='c.in';
  OutFile='c.out';

type TRecord = record x,y,r:integer; rnum:word; end;
var data:array[0..500] of TRecord;
    NN:word;

procedure ReadData;
  var i,j:word;
      ins:word;
  begin
  Assign(input,InFile);
  Reset(Input);
  readln(NN);
  for I:=1 to NN do begin
    with data[i] do begin
      readln(x,y,r);
      rnum:=i;
    end;
    j:=i;
    while (j>1) and (data[j].r>data[j-1].r) do begin
      data[0]:=data[j];
      data[j]:=data[j-1];
      data[j-1]:=data[0];
      dec(j);
    end;
  end;
  Close(Input);
  end;

const zc=(500*256) DIV 4;
type TBig=array[0..zc-1] of word;
     PWord=^word;
var tbl1,tbl2,tbl3,tbl4: ^TBig;

var ofs:array[1..500] of longint;

procedure cofs;
  var i:word;
  begin
  ofs[1]:=0;
  for i:=2 to 500 do
    ofs[i]:=ofs[i-1]+501-i;
  end;

function p(m,n:word):pWord;
  var c:longint;
  begin
  c:=ofs[m]+n;
  if c<zc then p:=@tbl1^[c] else
    if c<zc*2 then p:=@tbl2^[c-zc] else
    if c<zc*3 then p:=@tbl3^[c-2*zc] else
    p:=@tbl4^[c-3*zc];
  end;

function k_in(a,b:word):boolean;
  begin
  k_in:=(sqr(data[a].x-data[b].x)+sqr(data[a].y-data[b].y))<=sqr(data[b].r-data[a].r);
  end;

function  max(a,b:word):word;
  begin
  if a>b then max:=a else max:=b;
  end;

procedure WriteSol;
  var _m,_n,_max:word;
      m,n:word;
      i,j:word;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  _max:=0;
  for n:=1 to NN do
    for m:=1 to n-1 do
      if p(m,n)^>_max then begin
        _max:=p(m,n)^;
        _m:=m;
        _n:=n;
      end;
  writeln(_max);
  write(data[_n].rnum);
  for i:=2 to _max do
    for j:=1 to NN do begin
      if (p(_m,j)^=_max+1-i) and (k_in(_n,j)) then begin
        _n:=j;
        write(' ',data[j].rnum);
        break;
      end;
    end;
  writeln;
  Close(Output);
  end;

procedure Run;
  var pmn:pWord;
      m,n,cur:word;
  begin
  new(tbl1);
  new(tbl2);
  new(tbl3);
  new(tbl4);
  for n:=1 to NN do begin
    p(n,n)^:=1;
    for m:=1 to n-1 do begin
      pmn:=p(m,n);
      pmn^:=0;
      if k_in(n,m) then begin
        pmn^:=2;
        for cur:=m+1 to n-1 do
          if k_in(n,cur) then
            pmn^:=max(pmn^,p(m,cur)^+1);
      end;
    end;
  end;
  end;

begin
cofs;
ReadData;
Run;
WriteSol;
end.