{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  MaxN=10000;
Var
  Res:LongInt;
  X,Y:Array[1..MaxN]Of Integer;
  N:Word;
  Timer:LongInt Absolute $0040:$006C;
  Finish:LongInt;
Procedure Load;
Var
  I:Word;
Begin
  Assign(Input,'D.IN');
  ReSet(Input);
  Read(N);
  For I:=1 To N Do If Not SeekEOF Then Read(X[I],Y[I]);
  Close(Input);
End;
Procedure Try;
Type
  TSeqElem=Record Num:Word; Value:LongInt; End;
  TSequence=Array[1..MaxN]Of TSeqElem;
  PSequence=^TSequence;
Var
  Seq,Seq2:PSequence;
  ResX,ResY:LongInt;
  NRes,CRes,AX,AY:LongInt;
  I:Word;
Procedure QSort(Seq:PSequence; A,B:Word);
Var
  I,J:Word;
  X:LongInt;
  Y:TSeqElem;
Begin
  X:=Seq^[(A+B) Div 2].Value;
  I:=A;
  J:=B;
  Repeat
    While Seq^[I].Value<X Do Inc(I);
    While Seq^[J].Value>X Do Dec(J);
    If I<J Then Begin
      Y:=Seq^[I];
      Seq^[I]:=Seq^[J];
      Seq^[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  Until I>=J;
  If I>A Then QSort(Seq,A,I-1);
  If J<B Then QSort(Seq,J+1,B);
End;
Begin
  New(Seq);
  New(Seq2);
  For I:=1 To N Do With Seq^[I] Do Begin
    Num:=I;
    Value:=X[I];
  End;
  QSort(Seq,1,N);
  ResX:=Seq^[(N+1) Div 2].Value;
  Res:=0;
  For I:=1 To N Do Res:=Res+Abs(ResX-X[I]);
  Finish:=Timer+18;
  I:=0;
  While Timer<Finish Do Begin
    Inc(I);
    If I>32767 Then Break;
    AX:=ResX+I;
    CRes:=0;
    For I:=1 To N Do CRes:=CRes+Abs(AX-X[I]);
    If CRes<Res Then Res:=CRes;
    AX:=ResX-I;
    CRes:=0;
    For I:=1 To N Do CRes:=CRes+Abs(AX-X[I]);
    If CRes<Res Then Res:=CRes;
  End;
  For I:=1 To N Do With Seq^[I] Do Begin
    Num:=I;
    Value:=Y[I];
  End;
  QSort(Seq,1,N);
  For I:=1 To N Do With Seq2^[I] Do Begin
    Num:=I;
    Value:=Seq^[I].Value-I;
  End;
  QSort(Seq2,1,N);
  ResY:=Seq^[Seq2^[(N+1) Div 2].Num].Value-Seq2^[(N+1) Div 2].Num+1;
  NRes:=0;
  For I:=1 To N Do NRes:=NRes+Abs(Seq^[I].Value-(ResY+I-1));
  Finish:=Timer+18;
  While Timer<Finish Do Begin
    Inc(I);
    If I>32767 Then Break;
    AY:=ResY+I;
    CRes:=0;
    For I:=1 To N Do CRes:=CRes+Abs(Seq^[I].Value-(AY+I-1));
    If CRes<NRes Then NRes:=CRes;
    AY:=ResY-I;
    CRes:=0;
    For I:=1 To N Do CRes:=CRes+Abs(Seq^[I].Value-(AY+I-1));
    If CRes<NRes Then NRes:=CRes;
  End;
  Res:=Res+NRes;
  Dispose(Seq);
  Dispose(Seq2);
End;
Procedure Run;
Var
  RSave:LongInt;
  I:Word;
  T:Integer;
Begin
  Try;
  RSave:=Res;
  For I:=1 To N Do Begin
    T:=X[I];
    X[I]:=Y[I];
    Y[I]:=T;
  End;
  Try;
  If Res>RSave Then Res:=RSave;
End;
Procedure Save;
Begin
  Assign(Output,'D.OUT');
  ReWrite(Output);
  WriteLn(Res);
  Close(Output);
End;
Begin
  Load;
  Run;
  Save;
End.