{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{$undef debug}
{ $define debug}

{$ifdef debug}
{$r+}
{$endif}

const
 maxn=10;
 maxl=90;
 maxc=(maxl+4)div 5*maxn;
 ttttt=round(1193180/65536*9.5);

type
{$ifdef debug}
 tl=char;
{$else}
 tl=#128..#192;
{$endif}
 sl=set of tl;
 tc=record
  s:byte; (* 0-c; 1-c{0;n}; 2-c{0;} *)
  c:sl;
  n:integer;
 end;
 tcs=record
  n:integer;
  c:array[0..maxc-1]of tc;
 end;

const
{$ifdef debug}
 letter=[#0..#255];
{$else}
 letter=[#128..#192];
{$endif}

var
 s:array[0..1]of string;
 cs:array[0..1]of tcs;
 res:string; {? res:pchar}
 timer:longint absolute $40:$6C;
 start:longint;

function fix(c:char):char;
 begin
  if c in [#$E0..#$F0] then dec(c,$30);
  fix:=c;
 end;

function unf(c:char):char;
 begin
  if c in [#$B0..#$C0] then inc(c,$30);
  unf:=c;
 end;

var found:boolean;
function minch(s:sl):tl;
 var
  i:tl;
 begin
  for i:=low(tl) to high(tl) do
   if i in s then begin
    found:=true;
    minch:=i;
    exit;
   end;
  found:=false;
 end;

procedure ps(s:string; var p:tcs);
 var
  i,j,k:integer;
  vs:sl;
 procedure readset;
  var
   p:integer;
   nt:boolean;
  begin
   vs:=[];
   p:=2;
   nt:=s[p]='!';
   if nt then inc(p);
   while(s[p]<>']')do begin
    if(s[p+1]='-')then begin vs:=vs+[s[p]..s[p+2]]; inc(p,3); end
    else begin vs:=vs+[s[p]]; inc(p); end;
    if s[p]=',' then inc(p);
   end;
   if nt then vs:=letter-vs;
   inc(p); delete(s,1,p-1);
  end;
 function readint:integer;
  var
   p,r,i:integer;
  begin
   p:=1;
   while(s[p] in ['0'..'9'])do inc(p);
   val(copy(s,1,p-1),r,i);
   delete(s,1,p-1);
   readint:=r;
  end;
 begin
  p.n:=0;
  for i:=1 to length(s) do
   s[i]:=fix(s[i]);
  while(length(s)>0)do begin
   case s[1] of
    '?':begin
     p.c[p.n].c:=letter;
     p.c[p.n].s:=0;
     delete(s,1,1);
    end;
    '*':begin
     p.c[p.n].c:=letter;
     p.c[p.n].s:=2;
     delete(s,1,1);
    end;
    '[':begin
     readset;
     p.c[p.n].c:=vs;
     if s[1]='@' then begin
      p.c[p.n].s:=0;
      p.c[p.n+1]:=p.c[p.n]; inc(p.n);
      p.c[p.n].s:=2;
      delete(s,1,1);
     end else if s[1]='{' then begin
      delete(s,1,1);
      i:=readint;
      p.c[p.n].s:=0;
      for j:=1 to i-1 do
       p.c[p.n+j]:=p.c[p.n];
      inc(p.n,i-1);
      if s[1]=';' then begin
       delete(s,1,1);
       if s[1]='}' then begin
        p.c[p.n+1]:=p.c[p.n]; inc(p.n);
        p.c[p.n].s:=2;
        delete(s,1,1);
       end else begin
        i:=readint-i;
        p.c[p.n+1]:=p.c[p.n]; inc(p.n);
        p.c[p.n].s:=1;
        p.c[p.n].n:=i;
        delete(s,1,1);
        if i<0 then dec(p.n);
       end;
      end else begin
       delete(s,1,1); {read bracket}
      end;
     end else p.c[p.n].s:=0;
    end;
   else
    p.c[p.n].c:=[s[1]];
    delete(s,1,1);
   end;
   inc(p.n);
  end;
 end;

procedure readin;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'input.txt'); reset(f);
  readln(f,s[0]); ps(s[0],cs[0]);
  readln(f,s[1]); ps(s[1],cs[1]);
  close(f);
 end;

procedure writeout;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'output.txt'); rewrite(f);
  writeln(f,res); {?}
  close(f);
 end;

procedure check;
 begin
  if(timer<start)then exit;
  writeout;
  halt;
 end;

procedure solve;
 var
  i,j:integer;
 begin
  res:='NO SOLUTION';
  i:=0; while(i<cs[0].n)and(cs[0].c[i].s=0)do inc(i);
  j:=0; while(j<cs[1].n)and(cs[1].c[j].s=0)do inc(j);
  if(i>=cs[0].n)and(j>=cs[1].n)then begin
   if i<>j then exit;
   res:='';
   for i:=0 to j-1 do begin
    res:=res+unf(minch(cs[0].c[i].c*cs[1].c[i].c));
    if not found then begin
     res:='NO SOLUTION';
     exit;
    end;
   end;
   exit;
  end;
  {if(i=0)then begin
   res:='';
   for i:=0 to j-1 do begin

    res:=res+unf(minch(cs[0].c[i].c);
    if not found then begin
     res:='NO SOLUTION';
     exit;
    end;
   end;
   exit;
  end;}
  {???}
 end;

begin
 start:=timer+ttttt;
 readin;
 solve;
 writeout;
end.