#define MAX_LENGTH 100

#include <conio.h>
#include <stdio.h>
#include <string.h>


char templ1 [MAX_LENGTH], templ2 [MAX_LENGTH], result [MAX_LENGTH];
int error;
char next;


int solve (int start1, int start2, int res_len);
void input ();
void output ();
int letter (char symbol);

main ()
 {
   error = 0;
   input ();
   solve (0, 0, 0);
   output ();

   return (0);
 }


void input ()
 {
	FILE * file = fopen ("input.txt", "r");

	fscanf (file, "%s\n%s", templ1, templ2);

	fclose (file);
 }



void output ()
 {
	int index;

	FILE * file = fopen ("output.txt", "w");

   if (result [0] == '!')
    {
      fprintf (file, "-1");
      fclose (file);
      return;
    }

	for (index = 0; index < strlen (result); index ++)
    switch (result [index])
     {
       case '*':
        continue;
       case '?':
        fprintf (file, "a");
        break;
       default:
        fprintf (file, "%c", result [index]);
     }

	fclose (file);
 }


int solve (int start1, int start2, int res_len)
 {
	int length, min = 30000, index, temp, min_index;
	char ch1, ch2;

	if ((strlen (templ1) <= start1) && (strlen (templ2) <= start2))
	 {
		result [res_len] = 0;
		return (0);
	 }

	if (strlen (templ1) <= start1)
	 {
		if (templ2 [start2] == '*')
		 result [res_len] = 0;
		else
		 strcpy (result + res_len, "!");
	 }

	if (strlen (templ2) <= start2)
	 {
		if (templ1 [start1] == '*')
		 result [res_len] = 0;
		else
		 strcpy (result + res_len, "!");
	 }


	ch1 = templ1 [start1], ch2 = templ2 [start2];

	if ((ch1 != '*') && (ch2 != '*'))
	 {
		if ((letter (ch1)) && (letter (ch2)))
		 if (ch1 == ch2)
		  result [res_len] = ch1;
		 else
			{
				strcpy (result + res_len, "!");
				return (0);
			}
		else if (letter (ch1))
		 result [res_len] = ch1;
		else if (letter (ch2))
		 result [res_len] = ch2;
		else
		 result [res_len] = '';

		length = solve (start1 + 1, start2 + 1, res_len + 1) + 1;
	 }
	else
	 {
		if (ch1 == '*')
		 for (index = start2; index < strlen (templ2); index ++)
		  if ((min > (temp = solve (start1 + 1, index, res_len))) &&
			  (result [res_len] != '!'))
			{
				min = temp;
				min_index = index;
			}

		if (min != 30000)
		 {
			memcpy (result + res_len, templ2 + start2, min_index - start2);
			result [res_len + min_index - start2] = 0;
			length = solve (start1 + 1, min_index, res_len + min_index - start2) + min_index - start2;
			min = 20000;
		 }
		else
		 strcpy (result + res_len, "!");

		if (ch2 == '*')
		 for (index = start1; index < strlen (templ1); index ++)
		  if ((min > (temp = solve (index, start2 + 1, res_len))) &&
			  (result [res_len] != '!'))
			{
				min = temp;
				min_index = index;
			}

		if ((min != 30000) && (min != 20000))
		 {
			memcpy (result + res_len, templ1 + start1, min_index - start1);
			result [res_len + min_index - start1] = 0;
			length = solve (min_index, start2 + 1, res_len + min_index - start1) + min_index - start1;
		 }

		else if (min != 20000)
		 strcpy (result + res_len, "!");
	 }

	return (length);
 }


int letter (char symbol)
 {
	return ((symbol >=  '') && (symbol <= ''));
 }