program Lab;

{$A+,B-,D-,E+,F-,G+,I+,L-,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y-}
{$M 16384,0,655360}(**)

const
{$ifdef ILIA}
  InFile='3.in';
  OutFile='con';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type dir=(_L,_U,_D,_R);
var M,N:byte;
    data:array[0..51,0..51,_L.._R] of boolean;

procedure ReadData;
  var st:string;
      i,x,y:byte;
  begin
  fillchar(data,sizeof(data),false);
  Assign(input,InFile);
  Reset(Input);
  readln(M,N);
  for y:=1 to M do
    for x:=1 to N do begin
      readln(st);
      for i:=1 to length(st) do
        case st[i] of
          'U': data[x,y,_U]:=true;
          'L': data[x,y,_L]:=true;
          'R': data[x,y,_R]:=true;
          'D': data[x,y,_D]:=true;
        end;
    end;
  for i:=1 to N do
    data[i,M+1,_U]:=data[i,M,_D];
  for i:=1 to N do
    data[i,0,_D]:=data[i,1,_U];
  for i:=1 to M do
    data[0,i,_R]:=data[1,i,_L];
  for i:=1 to M do
    data[N+1,i,_L]:=data[N,i,_R];
  Close(Input);
  end;

function hwall(is:boolean;out:boolean):char;
  begin
  if is then
    if out then
      hwall:=''
    else
      hwall:=''
  else
    hwall:=' ';
  end;

function vwall(is:boolean;out:boolean):char;
  begin
  if is then
    if out then
      vwall:=''
    else
      vwall:=''
  else
    vwall:=' ';
  end;

function kkorner(xf,yf:boolean):char;
  const LU:array[false..true,false..true] of char =
          ((' ',''),('',''));
  const LD:array[false..true,false..true] of char =
          ((' ',''),('',''));
  const RU:array[false..true,false..true] of char =
          ((' ',''),('',''));
  const RD:array[false..true,false..true] of char =
          ((' ',''),('',''));

  begin
  if xf then
    if yf then
      kkorner:=lu[data[1,1,_U],data[1,1,_L]]
    else
      kkorner:=ld[data[1,M,_D],data[1,1,_L]]
  else
    if yf then
      kkorner:=ru[data[N,1,_U],data[N,1,_R]]
    else
      kkorner:=rd[data[N,M,_D],data[N,M,_R]]
  end;

function korner(x,y:byte):char;
  const symb:array[0..15] of char= (
          {-} {d} {u} {ud}
          ' ','','','',
          '','','','', {+r}
          '','','','', {+l}
          '','','','');{+rl}
  const symbv:array[0..15] of char= (
          {-} {d} {u} {ud}
          ' ','','','',
          '','','','', {+r}
          '','','','', {+l}
          ' ',' ',' ',' ');{+rl}
  const symbh:array[0..15] of char= (
          {-} {d} {u} {ud}
          ' ','','',' ',
          '','','',' ', {+r}
          '','','',' ', {+l}
          '','','',' ');{+rl}
  var l,r,u,d:boolean;
      ov,oh:boolean;
      s:byte;
  begin
  ov:=(x=1) or (x=N+1);
  oh:=(y=1) or (y=M+1);
  l:=data[x-1,y,_U];
  r:=data[x,y,_U];
  u:=data[x,y-1,_L];
  d:=data[x,y,_L];
  s:=8*ord(l)+4*ord(r)+2*ord(u)+ord(d);
  if not (ov or oh) then
    korner:=symb[s]
  else if ov then
    korner:=symbv[s]
  else
    korner:=symbh[s];
  end;

procedure WriteSol;
  var x,y:byte;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  for y:=1 to 2*M+1 do begin
    for x:=1 to 2*N+1 do
      if (y mod 2=1) then
        if (x mod 2=0) then
          write(hwall(data[x div 2,(y+1) div 2,_U],(y=1) or (y=2*M+1)))
        else
          if ((y=1) or (y=2*M+1)) and ((x=1) or (x=2*N+1)) then
            write(kkorner(x=1,y=1))
          else
            write(korner((x+1) div 2,(y+1) div 2))
      else if (x mod 2=0) then
          write(' ')
        else
          write(vwall(data[(x+1) div 2,y div 2,_L],(x=1) or (x=2*N+1)));
    writeln;
  end;
  Close(Output);
  end;

begin
ReadData;
WriteSol;
end.