{   窮 }
{ fixed }
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

const Full = [''..''];
      No = 10000;
      MaxN = 180;

type LSet = set of ''..'';
     What = (_set, _ast);
type TStr = record
       N: integer;
       w: array [1..MaxN] of What;
       se: array [1..MaxN] of LSet;
       rept, unnec: array[1..MaxN] of boolean;
     end;
type TArr = array [0..MaxN, 0..MaxN] of integer;
     PArr = ^TArr;
     TBytes = array [0..MaxN, 0..MaxN] of byte;
     PBytes = ^TBytes;

var t: PArr;
    ii, jj: PBytes;
    cc: array [0..MaxN, 0..MaxN] of Char;
    a, b: TStr;
    s: String;
    p: integer;
    i, j: integer;
    c: Char;

function UpRus(c: Char): Char;
begin
  if c in [''..''] then Dec(c, 32);
  if c in [''..''] then Dec(c, 80);
  UpRus := c;
end;

function GetInt: integer;
var i: integer;
begin
  i := 0;
  while (p <= Length(s)) and (s[p] in ['0'..'9']) do begin
    i := i*10 + (Ord(s[p])-$30);
    Inc(p);
  end;
  GetInt := i;
end;

procedure RepeatIt(var a: TStr; ss: LSet; l, h: integer);
var i: integer;
begin
  if l > h then begin
    i := l; l := h; h := i;
  end;
  with a do begin
    Dec(N);
    for i := 1 to l do begin { necessary part }
      Inc(N);
      w[N] := _set;
      se[N] := ss;
    end;
    if h = MaxInt then begin { repeatable symbol }
      Inc(N);
      w[N] := _set;
      se[N] := ss;
      rept[N] := true;
      unnec[N] := true;
    end else
    for i := 1 to h-l do begin { unnecessary part }
      Inc(N);
      w[N] := _set;
      se[N] := ss;
      unnec[N] := true;
    end;
  end;
end;

procedure ReadStr(var a: TStr);
var min, max, i: integer;
    Inv: boolean;
begin
  Readln(s);
  s := s + #0;
  with a do begin
    N := 0;
    p := 1;
    while s[p] <> #0 do begin
      Inc(N);
      if s[p] in [''..'', ''..'', ''..''] then begin
        w[N] := _set;
        se[N] := [Uprus(s[p])];
        Inc(p);
      end else
      if s[p] = '*' then begin
        w[N] := _ast;
        se[N] := Full;
        Inc(p);
      end else
      if s[p] = '?' then begin
        w[N] := _set;
        se[N] := Full;
        Inc(p);
      end else
      if s[p] = '[' then begin
        w[N] := _set;
        Inc(p);
        Inv := (s[p] = '!');
        if Inv then Inc(p);
        se[N] := [];
        while s[p] <> ']' do begin
          if s[p+1] = '-' then begin
            se[N] := se[N] + [Uprus(s[p])..Uprus(s[p+2])];
            Inc(p, 2);
          end else begin
            Include(se[N], Uprus(s[p]));
            Inc(p);
          end;
          if s[p] = ',' then Inc(p);
        end;
        Inc(p); { ] }
        if Inv then se[N] := Full - se[N];
      end else
      if s[p] = '{' then begin
        Dec(N);
        Inc(p);
        i := GetInt;
        min := i;
        if s[p] = '}' then
          max := i
        else
        if s[p] = ';' then begin
          Inc(p);
          if s[p] = '}' then
            max := MaxInt
          else
            max := GetInt;
        end;
        if w[N] <> _ast then
          RepeatIt(a, se[N], min, max);
        Inc(p);
      end else
      if s[p] = '@' then begin
        Dec(N);
        Inc(p);
        if w[N] <> _ast then
          RepeatIt(a, se[N], 1, MaxInt);
      end;
    end;
  end;
end;

procedure ReadAll;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  ReadStr(a);
  ReadStr(b);
end;

function Getc(const se: LSet): char;
var c: char;
begin
  for c := '' to '' do
    if c in se then begin
      Getc := c;
      Exit;
    end;
  Getc := #255;
end;

procedure Try(f, i1, j1: integer; ch: char);
var i2, j2,k2: integer;
    ck: char;
begin
  i2 := i1;
  j2 := j1;
  ck := ch;
  while (ck = #0) and (i2 > 0) and (j2 > 0) and (t^[i2,j2] <> No) do begin
    k2 := ii^[i2,j2];
    j2 := jj^[i2,j2];
    i2 := k2;
    ck := cc[i2,j2];
  end;
  if ch <> #255 then
  if (t^[i,j] > f) or ((t^[i,j] = f) and (cc[i,j] > ck) and (ck <> #0)) then
  begin
    t^[i,j] := f;
    ii^[i, j] := i1;
    jj^[i, j] := j1;
    cc[i, j] := ch;
  end;
end;

procedure Solve;
var s: String;
    k, l: integer;
begin
  New(t);
  New(ii);
  New(jj);

  for i := 0 to a.N do
    for j := 0 to b.N do
      t^[i, j] := No;
  t^[0, 0] := 0;
  i := 1;
  while (i <= a.N) and ((a.w[i] = _ast) or (a.unnec[i])) do begin
    t^[i, 0] := 0;
    inc(i);
  end;
  i := 1;
  while (i <= b.N) and ((b.w[i] = _ast) or (b.unnec[i])) do begin
    t^[0, i] := 0;
    inc(i);
  end;

  for i := 1 to a.N do
    for j := 1 to b.N do begin
      t^[i,j] := No;
      if (a.w[i] = _set) and (b.w[j] = _set) then begin
        Try(t^[i-1,j-1]+1, i-1, j-1, Getc(a.se[i]*b.se[j]));
        if a.rept[i] then
          Try(t^[i,j-1]+1, i, j-1, Getc(a.se[i]*b.se[j]));
        if b.rept[j] then
          Try(t^[i-1,j]+1, i-1, j, Getc(a.se[i]*b.se[j]));
      end;
      if a.unnec[i] then Try(t^[i-1, j], i-1, j, #0);
      if b.unnec[j] then Try(t^[i, j-1], i, j-1, #0);
      if a.w[i] = _ast then Try(t^[i-1,j], i-1, j, #0);
      if b.w[j] = _ast then Try(t^[i,j-1], i, j-1, #0);
      if (a.w[i] = _set) and (b.w[j] = _ast) then begin
        Try(t^[i-1,j]+1, i-1, j, Getc(a.se[i]));
      end else
      if (a.w[i] = _ast) and (b.w[j] = _set) then begin
        Try(t^[i,j-1]+1, i, j-1, Getc(b.se[j]));
      end;
    end;
  if t^[i, j] = No then
    Writeln('NO SOLUTION')
  else begin
    i := a.N;
    j := b.N;
    s[0] := Char(t^[i, j]);
    k := t^[i, j];
    while (k > 0) do begin
      if cc[i, j] <> #0 then begin
        s[k] := cc[i, j];
        Dec(k);
      end;
      l := ii^[i, j];
      j := jj^[i, j];
      i := l;
    end;
    Writeln(s);
  end;
end;

begin
  ReadAll;
  Solve;
end.