{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
 type
   tsc = record
     cin: boolean;
     no: longint;
     bk: byte;
     need: boolean;
   end;

   tx = array [1..6100, 0..1] of integer;
   tcry = record
     st, fn: integer;
   end;
   tca = array [1..3100, 0..1] of tcry;
   aar = array [1..6100] of integer;

 var
   sc: array [1..6100] of tsc;
   f: array [1..6100] of integer;
   t: array [1..6100] of boolean;
   r, r0, nc: array [0..1] of integer;
   n, k: longint;
   x: ^tx;
   crr: ^tca;
   mn: ^aar;

 procedure ReadAll;
 var
   i, cd: Integer;
   s: string;
 begin
   Assign(Input, 'input.txt');
   Reset(Input);

   ReadLn(n);
   ReadLn(k);
   for i := 1 to 2*k do begin
     ReadLn(s);
     while pos(' ', s)<>0 do delete(s, pos(' ',s), 1);
     if s[1] = '+' then sc[i].cin := true else sc[i].cin := false;
     delete(s, 1, 1);
     if s[length(s)] in ['',''] then sc[i].need := true else sc[i].need := false;
     delete(s, length(s), 1);
     if s[length(s)] in ['',''] then sc[i].bk := 0 else sc[i].bk := 1;
     delete(s, length(s), 1);
     val(s, sc[i].no, cd);
   end;

   Close(Input);
 end;

 procedure Give(bk: byte; tm: integer); { get a hat to <bk> at time <tm> }
 var
   i, j, m: Integer;
 begin
   fillchar(mn^, sizeof(mn^), 0);
   m := x^[tm,1-bk];

   for i := tm downto 1 do begin
     if m>x^[i,1-bk] then m := x^[i, 1-bk];
     mn^[i] := m;
   end;

   for i := 1 to nc[bk] do begin
     if (mn^[crr^[i,bk].st]>0) and (crr^[i,bk].fn<tm) then begin
       { Move'em }
       dec(r[1-bk]);
       for j := crr^[i,bk].st to tm do dec(x^[j,1-bk]);
       inc(r[bk]);
       for j := crr^[i,bk].fn to tm do inc(x^[j, bk]);
       t[crr^[i,bk].st] := true;
       exit;
     end;
   end;

   { Can't move }
   inc(r0[bk]);
   inc(r[bk]);
   for i := 1 to tm do inc(x^[i,bk]);
 end;

 procedure Solve;
 var
   i, j: longint;
   h: byte;
 begin
   new(x); new(crr); new(mn);
   fillchar(x^, sizeof(x^), 0);
   fillchar(crr^, sizeof(crr^), 0);
   fillchar(f, sizeof(f), 0);
   fillchar(t, sizeof(t), 0);
   fillchar(r, sizeof(r), 0);
   fillchar(r0, sizeof(r0), 0);
   fillchar(nc, sizeof(nc), 0);

   for i := 1 to 2*k do begin

     x^[i,0] := r[0]; x^[i,1] := r[1];

     if sc[i].cin then begin

       { In +}

       if sc[i].need then begin
         if r[sc[i].bk]>0 then begin
           dec(r[sc[i].bk]);
           t[i] := true;
           dec(x^[i,sc[i].bk]);
           f[sc[i].no] := i;
         end else begin
           Give(sc[i].bk, i);
           dec(r[sc[i].bk]);
           dec(x^[i,sc[i].bk]);
           f[sc[i].no] := i;
           t[i] := true;
         end;
       end else begin
         f[sc[i].no] := i;
       end;

     end else begin
       { Out +}
       if sc[i].need then begin
         f[sc[i].no] := 0;
         inc(r[sc[i].bk]);
       end else begin
         if sc[f[sc[i].no]].bk <> sc[i].bk then begin
           h := sc[i].bk;
           inc(nc[h]);
           crr^[nc[h], h].st := f[sc[i].no];
           if (crr^[nc[h], h].st=0) then Write(' Err ');
           crr^[nc[h], h].fn := i;
           f[sc[i].no] := 0;
         end;
       end;
     end;

   end;

   dispose(x); dispose(crr); dispose(mn);
 end;

 procedure Out;
 var
   i: Integer;
 begin
   Assign(Output, 'output.txt');
   ReWrite(Output);

   WriteLn(r0[0], ' ', r0[1]);
   for i := 1 to 2*k do if sc[i].cin then begin
     if t[i] then writeln(1) else writeln(0);
   end;

   Close(Output);
 end;

 begin
   ReadAll;
   Solve;
   Out;
 end.