{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
 type
  longnum = array [0..50] of byte;
 const
   PbNm = 'ᢨ';
   AuNm = '';
 var
   nm: array [1..100] of string[15];
   md: array [1..100,1..100] of boolean;
   ms: array [1..100] of integer;
   d: array [1..100] of longnum;
   di: array [1..100] of boolean;
   a: array [1..100,1..100] of boolean;
   l, k, i: longint;
   pb, au: integer;

 function Id(const s:string): integer;
 var  i: Integer;
 begin
   for i := 1 to k do if (nm[i]=s) then begin
     Id := i;
     exit;
   end;
   Id := 0;
 end;

 procedure ReadAll;
 var
   ss: array [0..2000] of char;
   cp, i: integer;
   as: string;
 begin
   Assign(Input, 'input.txt');
   Reset(Input);

   ReadLn(k);
   fillchar(ss, sizeof(ss), 0);
   ReadLn(ss);
   cp := 0; i:=0;
   repeat
     while ss[cp]=' ' do inc(cp);
     as := '';
     if ss[cp]=#0 then break;
     while (ss[cp]<>' ')and(ss[cp]<>#0) do begin
       as := as + ss[cp];
       inc(cp);
     end;
     inc(i);
     nm[i] := as;
     if as = PbNm then pb := i;
     if as = AuNm then au := i;
   until ss[cp] = #0;

   ReadLn(l);
   fillchar(md, sizeof(md), 0);
   fillchar(ms, sizeof(ms), 0);
   for i := 1 to l do begin
     ReadLn(as);
     while pos(' ', as) <> 0 do delete(as, pos(' ', as), 1);
     ms[i] := Id(as);

     fillchar(ss, sizeof(ss), 0);
     ReadLn(ss);
     cp := 0;
     repeat
       while ss[cp]=' ' do inc(cp);
       as := '';
       if ss[cp]=#0 then break;
       while (ss[cp]<>' ')and(ss[cp]<>#0) do begin
         as := as + ss[cp];
         inc(cp);
       end;

       md[i,Id(as)] := true;
     until ss[cp] = #0;
   end;

   Close(Input);
 end;

 procedure Addd(var x: longnum; const a: longnum);
 var
   i, z, xx: integer;
 begin
   if a[0] = 0 then exit;
   i := 1;
   z := 0;
   while (i<=a[0])or(z>0) do begin
     xx := x[i]+a[i]+z;
     z := xx div 10;
     x[i] := xx mod 10;
     inc(i);
   end;
   x[0] := 50;
   while x[x[0]]=0 do dec(x[0]);
 end;

 function More(const a, b: longnum): boolean;
 var  i: Integer;
 begin
   if a[0]>b[0] then begin
     more := true; exit;
   end;
   if a[0]<b[0] then begin
     more := false; exit;
   end;
   for i := a[0] downto 1 do begin
     if a[i]>b[i] then begin
       more := true; exit;
     end;
     if a[i]<b[i] then begin
       more := false; exit;
     end;
   end;
   more := false; { eq }
 end;

 procedure mulx(var x: longnum; m: longint);
 var
   i, z, xx: longint;
 begin
   i := 1; z := 0;
   while (i<=x[0]) or (z>0) do begin
     xx := x[i]*m + z;
     z := xx div 10;
     x[i] := xx mod 10;
     inc(i);
   end;
   x[0] := i;
   while x[x[0]]=0 do dec(x[0]);
 end;

 procedure mul(var x:longnum; const a,b: longnum);
 var
   i: Integer;
   h, hh: longnum;
 begin
   fillchar(x, sizeof(x), 0);
   if (a[0]+b[0])>48 then begin
     fillchar(x, sizeof(x), 30);
     exit;
   end;

   hh := a;
   for i := 1 to b[0] do begin
     h := hh;
     mulx(h, b[i]);
     addd(x, h);
     mulx(hh,10);
   end;
 end;

 procedure Solve;
 var
   i, j, m: Integer;
   dn: boolean;
   x: longnum;
   inf, self: boolean;
 begin
   fillchar(a, sizeof(a), 0);
   for i := 1 to l do for j := 1 to k do if md[i,j] then a[ms[i],j] := true;
   for m := 1 to k do
     for i := 1 to k do
       for j := 1 to k do a[i,j] := a[i,j] or (a[i,m] and a[m,j]);

   fillchar(d, sizeof(d), 0);
   fillchar(di, sizeof(di), 0);

{   for i := 1 to l do if md[l,au] then begin
     d[ms[i]][0] := 1;
     d[ms[i]][1] := 1;
   end;}
   for i := 1 to k do if a[i,au] then begin
     d[i][0] := 1;
     d[i][1] := 1;
   end;

   d[au][0] := 1;
   d[au][1] := 1;

   repeat
     dn := true;

     for i := 1 to l do if not di[ms[i]] then begin
       fillchar(x, sizeof(x), 0); inf := false; self := false;
       for j := 1 to k do if md[i,j] then begin
         Addd(x, d[j]);
         if a[j,ms[i]] then self := true;
         if di[j] then inf := true;
       end;
       if inf then begin
         dn := false;
         di[ms[i]] := true;
         d[ms[i]][0] := 1;
       end else if self and (x[0]>0) then begin
         dn := false;
         di[ms[i]] := true;
         d[ms[i]][0] := 1;
       end else if more(x,d[ms[i]]) then begin
         dn := false;
         d[ms[i]] := x;
       end;
     end;

     if di[pb] then exit;

   until dn;
 end;

 procedure Out;
 var
   i: Integer;
 begin
   Assign(Output, 'output.txt');
   ReWrite(Output);

   if di[pb] then WriteLn('QUANTUM SATIS') else begin
     if d[pb][0]=0 then writeln(0) else begin
       for i := d[pb][0] downto 1 do Write(d[pb][i]);
       WriteLn;
     end;
   end;

   Close(Output);
 end;

 begin
   ReadAll;
   Solve;
   Out;
 end.
