{   }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

program XPEH;

type TLong = array [0..10] of longint;

var Names: array [1..100] of string[10];
    N, L: integer;
    Re: array [1..100, 0..100] of byte;
    d: array [1..100] of TLong;
    state: array [1..100] of byte;
    Pb, Au: integer;
    e: array [1..100, 1..100] of byte;

procedure AddL(var a, b: TLong);
var i, q: Word;
begin
  if a[0] < b[0] then a[0] := b[0];
  q := 0;
  for i := 1 to a[0] do begin
    q := q + a[i] + b[i];
    a[i] := q mod 10000;
    q := q div 10000;
  end;
  if q > 0 then begin
    Inc(a[0]);
    a[a[0]] := q;
  end;
end;

function Compare(var a, b: TLong): integer;
var i, l: integer;
begin
  l := a[0] - b[0];
  if l = 0 then begin
    for i := a[0] downto 1 do begin
      l := a[i] - b[i];
      if l <> 0 then Break;
    end;
  end;
  Compare := l;
end;

function Reads: String;
var ch: Char;
    s: string;
begin
  repeat
    if Eoln then begin
      Reads := '';
      Exit;
    end;
    Read(ch);
  until ch > ' ';
  s := '';
  while (ch <> ' ') do begin
    s := s + ch;
    if Eoln then Break;
    Read(ch);
  end;
  Reads := s;
end;

function Find: integer;
var s: string[10];
    i: integer;
begin
  s := Reads;
  Find := 0;
  if s <> '' then
  for i := 1 to N do
    if Names[i] = s then begin
      Find := i;
      Exit;
    end;
end;

procedure ReadAll;
var i, j: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Readln(N);
  for i := 1 to N do begin
    Names[i] := Reads;
    if Names[i] = 'ᢨ' then pb := i;
    if Names[i] = '' then au := i;
  end;
  Readln;
  Readln(L);
  for i := 1 to L do begin
    Re[i,0] := Find;
    Readln;
    repeat
      j := Find;
      if j = 0 then Break;
      Re[i,j] := 1;
    until false;
    Readln;
  end;
end;

procedure Look(i: integer);
var r, j: integer;
    cur: TLong;
begin
  if State[i] > 0 then Exit;
  State[i] := 1;
  Fillchar(d[i], Sizeof(d[i]), 0);
  if i = Au then begin
    d[i,0] := 1;
    d[i,1] := 1;
  end;

  for r := 1 to L do
  if Re[r,0] = i then begin
    Fillchar(cur, Sizeof(cur), 0);
    for j := 1 to N do
    if Re[r,j] = 1 then begin
      Look(j);
      AddL(cur, d[j]);
    end;
    if Compare(cur, d[i]) > 0 then d[i] := cur;
  end;
  state[i] := 2;
end;

procedure CheckQuantum;
var c, i, j, k: integer;
begin
  for i := 1 to N do begin
    for k := 1 to L do
      if Re[k, 0] = i then begin
        c := 0;
        for j := 1 to N do
          if (Re[k, j] = 1) then begin
            if e[i, j] < 1 then e[i, j] := 1;
            if d[j, 0] > 0 then Inc(c);
          end;
        for j := 1 to N do
          if (Re[k, j] = 1) and ((c >= 2) or (d[j, 0] = 0)) then begin
            if e[i, j] < 2 then e[i, j] := 2;
          end;
      end;
  end;

  for k := 1 to N do
    for i := 1 to N do
      for j := 1 to N do
      if (e[i, j] < 2) and (e[i,k] >= 1) and (e[k, j] >= 1) then
      begin
        if (e[i, k] = 1) and (e[k, j] = 1) then
          e[i, j] := 1
        else
          e[i, j] := 2;
      end;

  for i := 1 to N do
    if (e[i, i] = 2) and (State[i] > 0) then begin
      Writeln('QUANTUM SATIS');
      Halt;
    end;
end;

procedure Solve;
var i, l: integer;
begin
{  pb := 1;
  au := 100; }

  Look(Pb);
  CheckQuantum;

  Write(d[Pb,d[Pb,0]]);
  for i := d[Pb,0]-1 downto 1 do begin
    l := d[pb,i];
    if l < 1000 then Write('0');
    if l < 100 then Write('0');
    if l < 10 then Write('0');
    Write(l);
  end;
  Writeln;
end;

begin
  ReadAll;
  Solve;
end.