
{.$define Debug}
{$define Optimized}

program Solution;
{$M 64000,0,0}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN				= 20;
  maxK				= 256;

type
  TLine				= record
    sch				: string;
    tag				: integer;
    ansLen			: integer;
    ans				: array[1..maxK] of longint;
    built			: boolean;
  end;

  TNum				= record
    sch				: string[10];
    name			: longint;
    ref				: integer;
  end;

const
  nNums				= 94;
  nums				: array[1..nNums] of TNum =
    ( ( sch : '~'''; name : 1; ref : 1 ),
      ( sch : ''''; name : 2; ref : 2 ),
      ( sch : '~'; name : 2; ref : 2 ),
      ( sch : ''''; name : 3; ref : 4 ),
      ( sch : '~'; name : 3; ref : 4 ),
      ( sch : '~''~'; name : 4; ref : 6 ),
      ( sch : ''''; name : 5; ref : 7 ),
      ( sch : '''~'; name : 9; ref : 8 ),
      ( sch : '''~'; name : 10; ref : 9 ),
      ( sch : '~''~~'; name : 11; ref : 10 ),
      ( sch : '~''~'; name : 12; ref : 11 ),
      ( sch : '~''~'; name : 13; ref : 12 ),
      ( sch : '~''~~'; name : 14; ref : 13 ),
      ( sch : '~~'''; name : 50; ref : 14 ),
      ( sch : '~~'''; name : 60; ref : 15 ),
      ( sch : ''''; name : 100; ref : 16 ),
      ( sch : '~'; name : 100; ref : 16 ),
      ( sch : '~''~'; name : 15; ref : 18 ),
      ( sch : '~''~'; name : 16; ref : 19 ),
      ( sch : '~''~'; name : 17; ref : 20 ),
      ( sch : '~~''~'; name : 18; ref : 21 ),
      ( sch : '~~''~'; name : 19; ref : 22 ),
      ( sch : '''~'; name : 8; ref : 23 ),
      ( sch : '~'''; name : 500; ref : 24 ),
      ( sch : '~'''; name : 600; ref : 25 ),
      ( sch : '''~~'; name : 1000; ref : 26 ),
      ( sch : '~'; name : 5; ref : 7 ),
      ( sch : '~~'''; name : 1000000; ref : 27 ),
      ( sch : ''''; name : 0; ref : 28 ),
      ( sch : '~'; name : 0; ref : 28 ),
      ( sch : '~~'''; name : 800; ref : 30 ),
      ( sch : '~~'''; name : 900; ref : 31 ),
      ( sch : ''''; name : 6; ref : 32 ),
      ( sch : '~'; name : 6; ref : 32 ),
      ( sch : ''''; name : 7; ref : 33 ),
      ( sch : '~'; name : 7; ref : 33 ),
      ( sch : '''~'; name : 20; ref : 34 ),
      ( sch : '''~~'; name : 22; ref : 54 ),
      ( sch : '''~'''; name : 22; ref : 54 ),
      ( sch : '''~~'; name : 23; ref : 55 ),
      ( sch : '''~'''; name : 23; ref : 55 ),
      ( sch : '''~~'; name : 25; ref : 56 ),
      ( sch : '''~'''; name : 25; ref : 56 ),
      ( sch : '''~'''; name : 26; ref : 57 ),
      ( sch : '''~'''; name : 26; ref : 57 ),
      ( sch : '''~'''; name : 27; ref : 58 ),
      ( sch : '''~'''; name : 27; ref : 58 ),
      ( sch : ''''''; name : 102; ref : 35 ),
      ( sch : '~'''; name : 102; ref : 35 ),
      ( sch : '''~'; name : 102; ref : 35 ),
      ( sch : '~~'; name : 102; ref : 35 ),
      ( sch : ''''''; name : 107; ref : 36 ),
      ( sch : '~'''; name : 107; ref : 36 ),
      ( sch : '''~'; name : 107; ref : 36 ),
      ( sch : '~~'; name : 107; ref : 36 ),
      ( sch : ''''''; name : 103; ref : 37 ),
      ( sch : '~'''; name : 103; ref : 37 ),
      ( sch : '''~'; name : 103; ref : 37 ),
      ( sch : '~~'; name : 103; ref : 37 ),
      ( sch : ''''''; name : 105; ref : 38 ),
      ( sch : '~'''; name : 105; ref : 38 ),
      ( sch : '''~'; name : 105; ref : 38 ),
      ( sch : '~~'; name : 105; ref : 38 ),
      ( sch : ''''''; name : 106; ref : 39 ),
      ( sch : '~'''; name : 106; ref : 39 ),
      ( sch : '''~'; name : 106; ref : 39 ),
      ( sch : '~~'; name : 106; ref : 39 ),
      ( sch : '''~'; name : 300; ref : 40 ),
      ( sch : '''~'''; name : 302; ref : 41 ),
      ( sch : '''~~'; name : 302; ref : 41 ),
      ( sch : '''~'''; name : 303; ref : 42 ),
      ( sch : '''~~'; name : 303; ref : 42 ),
      ( sch : '''~'''; name : 305; ref : 43 ),
      ( sch : '''~~'; name : 305; ref : 43 ),
      ( sch : '''~'''; name : 307; ref : 44 ),
      ( sch : '''~~'; name : 307; ref : 44 ),
      ( sch : '~'''''; name : 502; ref : 45 ),
      ( sch : '~''~'; name : 502; ref : 45 ),
      ( sch : '~'''''; name : 503; ref : 46 ),
      ( sch : '~''~'; name : 503; ref : 46 ),
      ( sch : '~'''''; name : 505; ref : 47 ),
      ( sch : '~''~'; name : 505; ref : 47 ),
      ( sch : '~'''''; name : 507; ref : 48 ),
      ( sch : '~''~'; name : 507; ref : 48 ),
      ( sch : '~''~~'''; name : 402; ref : 49 ),
      ( sch : '~''~~~'; name : 402; ref : 49 ),
      ( sch : '~''~~'''; name : 403; ref : 50 ),
      ( sch : '~''~~~'; name : 403; ref : 50 ),
      ( sch : '~''~~'''; name : 405; ref : 51 ),
      ( sch : '~''~~~'; name : 405; ref : 51 ),
      ( sch : '~''~~'''; name : 406; ref : 52 ),
      ( sch : '~''~~~'; name : 406; ref : 52 ),
      ( sch : '~''~~'''; name : 407; ref : 53 ),
      ( sch : '~''~~~'; name : 407; ref : 53 ) );

type
  TBoolArray			= array[1..nNums] of boolean;
  TSet				= set of 1..nNums;

const
  nRythms			= 3;
  rythms			: array[1..nRythms] of TSet =
  ( [11,12,18,19,20,21,22,37],
    [24,25],
    [14,15] );

var
  n				: integer;
  l				: array[1..maxN] of TLine;
  used				: TBoolArray;
  endings			: array[1..maxN,1..nNums] of boolean;

function Compose( sch : string; ln : integer ) : boolean;
var
  len				: integer;
  used				: TBoolArray;

  function Rec( i : integer ) : boolean;
  var
    j				: integer;
    newLen			: integer;
    flag1			: boolean;
    flag2			: boolean;

  begin
    Rec := false;
    if i > len then begin
      Rec := true;
      exit;
    end;
    flag1 := false;
    flag2 := false;
    for j := 1 to nNums do
      if not used[nums[j].ref] then begin
        {$ifdef Optimized}
        if (nums[j].sch = '''') and flag1 then continue;
        if (nums[j].sch = '~') and flag2 then continue;
        {$endif}
        newLen := length( nums[j].sch );
        if newLen <= len - i + 1 then
          if nums[j].sch = copy( sch, i, newLen ) then begin
            inc( l[ln].ansLen );
            l[ln].ans[l[ln].ansLen] := nums[j].name;
            used[nums[j].ref] := true;
            if Rec( i + newLen ) then begin
              Rec := true;
              exit;
            end;
            {$ifdef Optimized}
            if nums[j].sch = '''' then flag1 := true;
            if nums[j].sch = '~' then flag1 := true;
            {$endif}
            used[nums[j].ref] := false;
            dec( l[ln].ansLen );
          end;
      end;
  end;

begin
  len := length( sch );
  l[ln].ansLen := 0;
  used := Solution.used;
  Compose := Rec( 1 );
end;

procedure Solve;
var
  i,j				: integer;
  nLines			: integer;
  lines				: array[1..maxN] of integer;
  q				: array[1..maxN] of integer;

  procedure ProcessLines;
  label next;
  var
    i,j,k			: integer;


    function Rec( i, j  : integer ) : boolean;
    var
      k				: integer;

    begin
      if j > nLines then begin
        Rec := true;
        exit;
      end;
      Rec := false;
      for k := 1 to nNums do
        if k in rythms[i] then begin
          if (j > 1) and (nums[q[j-1]].ref = nums[k].ref) then continue;
          if not endings[lines[j],k] then continue;
          q[j] := k;
          if Rec( i, j + 1 ) then begin
            Rec := true;
            exit;
          end;
        end;
    end;

  begin

    if nLines = 1 then begin
      fillchar( used, sizeof(used), false );
      Compose( l[lines[1]].sch, lines[1] );
      exit;
    end;

    for i := 1 to nRythms do
      if Rec( i, 1 ) then begin
        for j := 1 to nLines do begin
          k := q[j];
          fillchar( used, sizeof(used), false );
          used[k] := true;
          if not Compose( copy( l[lines[j]].sch, 1,
                 length( l[lines[j]].sch ) -
		 length( nums[k].sch ) ), lines[j] ) then goto next;
          inc( l[lines[j]].ansLen );
          l[lines[j]].ans[l[lines[j]].ansLen] := nums[k].name;
        end;
        exit;
        next :
      end;

  end;

begin
  {
  for i := 1 to n do begin
    fillchar( used, sizeof(used), false );
    Compose( l[i].sch, i );
  end;
  }

  for i := 1 to n do
    for j := 1 to nNums do begin
      endings[i,j] := false;
      if length( nums[j].sch ) > length( l[i].sch ) then continue;
      endings[i,j] := copy( l[i].sch, length( l[i].sch ) -
                      length( nums[j].sch ) + 1, length( nums[j].sch ) ) =
                      nums[j].sch;
    end;

  for i := 1 to n do l[i].built := false;
  for i := 1 to n do
    if not l[i].built then begin
      nLines := 0;
      for j := i to n do
        if l[j].tag = l[i].tag then begin
          l[j].built := true;
          inc( nLines );
          lines[nLines] := j;
        end;
      ProcessLines;
    end;
end;

function strtok( var s : string ) : string;
var
  i				: integer;

begin
  while s[1] = ' ' do delete( s, 1, 1 );
  i := pos( ' ', s );
  if i = 0 then begin
    strtok := s;
    s := '';
    exit;
  end;
  strtok := copy( s, 1, i - 1 );
  delete( s, 1, i );
end;

function str2int( s : string ) : integer;
var
  x                             : integer;
  code                          : integer;

begin
  val( s, x, code );
  str2int := x;
end;

procedure ReadData;
var
  i				: integer;
  s				: string;

begin
  readln( n );
  for i := 1 to n do begin
    readln( s );
    l[i].tag := str2int( strtok( s ) );
    l[i].sch := strtok( s );
  end;
end;

procedure WriteData;
var
  i,j				: integer;

begin
  for i := 1 to n do begin
    for j := 1 to l[i].ansLen do write( l[i].ans[j], ' ' );
    writeln;
  end;
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.
