{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}

program p28_06_A;

type
	vihod_rec = record
    				number : integer;
                    goes_in : boolean;
                    must_take : boolean;
                    must_nottake : boolean;
                    right : boolean;
                end;

	vihodi_arr = array [1..6000] of vihod_rec;
    takes_arr = array [1..3000] of boolean;

    hats_array = array [1..6000] of record
    								left, right : integer;
    							   end;

	holds_arr = array [1..1000] of boolean;

var
	num_vihod : integer;
    num : integer;
	vihodi : ^vihodi_arr;

    i, j, k, bad : integer;

    s, s1 : string;

    vihod_num : integer;
    takes_num : integer;
    takes : ^takes_arr;

    holds : ^holds_arr;

    hats_left, hats_right : integer;
    hats : ^hats_array;

    best_left, best_right : integer;
    best_takes : ^takes_arr;

    timer : longint absolute $0040:$006C;
    timer1 : longint;

procedure DisposeArrays;
    begin
		dispose (vihodi);
	    dispose (hats);
	    dispose (takes);
	    dispose (holds);
    	dispose (best_takes);
    end;

procedure WriteSolution;
	var
    	i : integer;

	begin
    	Assign (output, 'output.txt');
        rewrite (output);
        Writeln (best_left, ' ', best_right);
        for i := 1 to num_vihod do
        	if best_takes^[i]
            	then Writeln ('1')
                else Writeln ('0');
        close (output);
    end;

procedure CheckSolution;
	var
    	min_left, min_right : integer;
        i : integer;

    begin
    	min_left := 0;
        min_right := 0;

        for i := 1 to 2*num_vihod do
        	if min_left > hats^[i].left
            	then min_left := hats^[i].left;
        for i := 1 to 2*num_vihod do
        	if min_right > hats^[i].right
            	then min_right := hats^[i].right;

        min_left := abs (min_left);
        min_right := abs (min_right);

        if (min_left + min_right) < (best_left + best_right)
        	then
            	begin
                	best_left := min_left;
                    best_right := min_right;
                    best_takes^ := takes^;
                end;
    end;


procedure FindRec;
	begin
    	if vihod_num > 2*num_vihod
        	then begin
            	CheckSolution;
                Exit;
                if (timer - timer1 > 170)
                	then
                    	begin
                        	WriteSolution;
                            DisposeArrays;
                            Halt (0);
                        end;
            end;
        if vihodi^[vihod_num].goes_in
        	then
            	begin
                	inc (takes_num);
                    if vihodi^[vihod_num].must_take
                    	then
                        	begin
                            	takes^[takes_num] := true;
                                holds^[vihodi^[vihod_num].number] := true;

                            	if vihodi^[vihod_num].right
                                	then dec (hats_right)
                                    else dec (hats_left);

                                hats^[vihod_num].left := hats_left;
                                hats^[vihod_num].right := hats_right;

                                inc (vihod_num);
                                FindRec;
                                dec (vihod_num);

                                holds^[vihodi^[vihod_num].number] := false;

                            	if vihodi^[vihod_num].right
                                	then inc (hats_right)
                                    else inc (hats_left);

                                hats^[vihod_num].left := hats_left;
                                hats^[vihod_num].right := hats_right;
                            end
	                    else
							begin
                            	takes^[takes_num] := false;
                                holds^[vihodi^[vihod_num].number] := false;

                                hats^[vihod_num].left := hats_left;
                                hats^[vihod_num].right := hats_right;

                                inc (vihod_num);
                                FindRec;
                                dec (vihod_num);

                                if not (vihodi^[vihod_num].must_nottake)
                                	then
                                    	begin
			                            	takes^[takes_num] := true;
			                                holds^[vihodi^[vihod_num].number] := true;

			                            	if vihodi^[vihod_num].right
            			                    	then dec (hats_right)
                        			            else dec (hats_left);

            			                    hats^[vihod_num].left := hats_left;
			                                hats^[vihod_num].right := hats_right;

			                                inc (vihod_num);
			                                FindRec;
            			                    dec (vihod_num);

			                            	if vihodi^[vihod_num].right
            			                    	then inc (hats_right)
                        			            else inc (hats_left);

			                                holds^[vihodi^[vihod_num].number] := false;

            			                    hats^[vihod_num].left := hats_left;
			                                hats^[vihod_num].right := hats_right;
                        			    end;
                            end;
                    dec (takes_num);
                end
            else
            	begin
                	if holds^[vihodi^[vihod_num].number]
                    	then
                        	begin
                                holds^[vihodi^[vihod_num].number] := false;

                            	if vihodi^[vihod_num].right
   			                    	then inc (hats_right)
               			            else inc (hats_left);

   			                    hats^[vihod_num].left := hats_left;
                                hats^[vihod_num].right := hats_right;

                                inc (vihod_num);
                                FindRec;
                                dec (vihod_num);

                            	if vihodi^[vihod_num].right
   			                    	then dec (hats_right)
               			            else dec (hats_left);

   			                    hats^[vihod_num].left := hats_left;
                                hats^[vihod_num].right := hats_right;

                                holds^[vihodi^[vihod_num].number] := true;
                            end
                        else
                        	begin
   			                    hats^[vihod_num].left := hats_left;
                                hats^[vihod_num].right := hats_right;

                                inc (vihod_num);
                                FindRec;
                                dec (vihod_num);
                            end;
                end;
    end;

begin
	timer1 := timer;


	new (vihodi);
    new (hats);
    new (takes);
    new (holds);
    new (best_takes);

    assign (input, 'input.txt');
    reset (input);
    readln (num);
	readln (num_vihod);
    for i := 1 to 2*num_vihod do
    	begin
        	readln (s);

            s1 := copy (s, 1, pos (' ', s) - 1);
            s := copy (s, pos (' ', s) + 1, length (s));
            if s1 = '+'
            	then vihodi^[i].goes_in := true
                else vihodi^[i].goes_in := false;

            s1 := copy (s, 1, pos (' ', s) - 1);
            s := copy (s, pos (' ', s) + 1, length (s));
            val (s1, vihodi^[i].number, bad);

            s1 := copy (s, 1, pos (' ', s) - 1);
            s := copy (s, pos (' ', s) + 1, length (s));
            if s1 = ''
				then vihodi^[i].right := true
                else vihodi^[i].right := false;

            if s = ''
				then vihodi^[i].must_take := true
                else vihodi^[i].must_take := false;
        end;
    close (input);

    for i := 1 to 2*num_vihod do
		vihodi^[i].must_nottake := false;

    for i := 1 to num do
    	if (vihodi^[i].goes_in) and (not vihodi^[i].must_take)
        	then
            	begin
                	j := i + 1;
                    k := vihodi^[i].number;
                    while vihodi^[j].number <> k do
                    	inc (j);
                    if vihodi^[i].right = vihodi^[j].right
                    	then vihodi^[i].must_nottake := true;
                end;

    fillchar (hats^, sizeof (hats^), 0);
    fillchar (takes^, sizeof (takes^), 0);
    fillchar (holds^, sizeof (holds^), 0);

    hats_left := 0;
    hats_right := 0;

    vihod_num := 1;
    takes_num := 0;

    best_left := 7000;
    best_right := 7000;
    FindRec;

    WriteSolution;
    DisposeArrays;
end.