{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}

program alchemist;

type
	substances = array [1..100] of string [10];
	reactions = array [1..100] of record
							out_r : array [1..100] of integer;
    						in_r : integer;
                            out_num : integer;
								end;

	warr = array [1..100] of longint;

var
	num : integer;
    subst : ^substances;
    gold : integer;
    lead : integer;

    num_react : integer;
    react : ^reactions;

    f : file of byte;

    bad : integer;
    i : integer;

    s : string;
    b : byte;

    this : array [1..1500] of pointer;
    level : integer;
    level_comp : integer;

    quantum_satis : array [1..100] of boolean;
    QS2GOLD : array [1..100] of boolean;
    best_gold : longint;

procedure WriteQS;
	begin
		assign (output, 'output.txt');
		rewrite (output);
		Writeln ('QUANTUM SATIS');
		close (output);
    end;

procedure DisposeArrays;
	var
    	i : integer;

	begin
    	for i := 1 to 1500 do
        	FreeMem (this [i], 4*num);
		dispose (react);
	    dispose (subst);
    end;

procedure makeAllQS;
	var
    	QS : array [1..100, 1..100] of boolean;
        seen, reach : array [1..100] of boolean;
        new : array [1..100] of integer;
        a, z : integer;

        i, j, k : integer;

    begin
        fillChar (QS, sizeof (QS), 0);
		for i := 1 to num do
			begin
				for j := 1 to num_react do
					if (react^[j].in_r = i)
						then for k := 1 to react^[j].out_num do
                            QS [react^[j].out_r [k], i] := true;
            end;

        fillChar (seen, sizeof (seen), 0);
        fillChar (reach, sizeof (reach), 0);
        seen [gold] := true;
        reach [gold] := true;
    	a := 1;
        z := 1;
        new [1] := gold;
        while (a <= z) do
        	begin
            	for k := 1 to num do
                	if (QS [new [a], k]) and (not seen [k])
						then
							begin
								seen [k] := true;
                                reach [k] := true;
                                inc (z);
                                new [z] := k;
							end;
                inc (a);
            end;

        for i := 1 to num do
			QS2Gold [i] := reach [i];
    end;


function Compare : integer;
	var
    	more : boolean;
        less : boolean;
        equal : boolean;
        k : integer;
        lev : integer;

	begin
        for lev := level - 1 downto 1 do
        	begin
		    	more := true;
        		less := true;
                equal := true;
		        for k := 1 to num do
		        	if warr (this [lev]^) [k] > warr (this [level]^) [k]
		            	then
							begin
								more := false;
                                equal := false;
                            end
			            else if warr (this [lev]^) [k] < warr (this [level]^) [k]
			            	then
								begin
									less := false;
                                    equal := false;
                                end;
		        if (more)
		        	then
						begin
							Compare := 1;
                            level_comp := lev;
                            Exit;
                        end
					else if (less) or (equal)
            			then
							begin
								Compare := -1;
                                Exit;
                            end;
            end;
		Compare := 0;
    end;

procedure CountGold;
	var
    	i, j, k : integer;

	begin
    	if (level >= 1500)
        	then
            	begin
                	WriteQS;
                    DisposeArrays;
                    Halt (0);
                end;
		if (warr (this [level]^) [gold] > best_gold)
        	then best_gold := warr (this [level]^) [gold];
    	for i := 1 to num_react do
        	if warr (this [level]^) [react^[i].in_r] > 0
            	then
                	begin
                    	dec (warr (this [level]^) [react^[i].in_r]);
                        for j := 1 to react^[i].out_num do
                        	inc (warr (this [level]^) [react^[i].out_r [j]]);
                        move (this [level]^, this [level + 1]^, 4*num);

                        j := Compare;
                        if (j = 0)
                        	then
                            	begin
			                        inc (level);
			                        CountGold;
			                        dec (level);
                                end
                            else if (j = 1)
                            	then
                                	begin
                                    	for k := 1 to num do
                                        	if warr (this [level_comp]^) [k] < warr (this [level]^) [k]
                                            	then quantum_satis [k] := true;
                                        for k := 1 to num do
                                        	if quantum_satis [k] and QS2GOLD [k]
                                            	then quantum_satis [gold] := true;
                                        if quantum_satis [gold]
                                        	then
                                            	begin
                                                	WriteQS;
                                                    DisposeArrays;
                                                    Halt (0);
                                                end;
                                    end;
                    	inc (warr (this [level]^) [react^[i].in_r]);
                        for j := 1 to react^[i].out_num do
                        	dec (warr (this [level]^) [react^[i].out_r [j]]);
                    end;
    end;

begin
	new (react);
    new (subst);

	assign (f, 'input.txt');
    reset (f);
   	read (f, b);

    s := '';
    while (b <> 13) and (b <> 10) do
    	begin
	        s := s + chr (b);
		   	read (f, b);
        end;
    while (b = 13) or (b = 10) do
    	read (f, b);

    val (s, num, bad);

    for i := 1 to num do
    	begin
		   	s := '';
        	while (b <> 13) and (b <> 10) and (b <> 32) do
            	begin
                	s := s + chr (b);
                    read (f, b);
                end;
            subst^[i] := s;
            if s = 'ᢨ'
            	then lead := i
                else if s = ''
                	then gold := i;
        	while (b = 13) or (b = 10) or (b = 32) do
                read (f, b);
		end;

    s := '';
    while (b <> 13) and (b <> 10) and (b <> 26) do
    	begin
	        s := s + chr (b);
		   	read (f, b);
        end;

    while (not eof (f)) and ((b = 13) or (b = 10)) do
    	read (f, b);

    val (s, num_react, bad);

	for i := 1 to num_react do
    	begin
		   	s := '';
        	while (b <> 13) and (b <> 10) do
            	begin
                	s := s + chr (b);
                    read (f, b);
                end;

            react^[i].in_r := 1;
            while (subst^[react^[i].in_r]) <> s do
            	inc (react^[i].in_r);

        	while (b = 13) or (b = 10) do
                read (f, b);

            react^[i].out_num := 0;

            while (not eof (f)) and (b <> 13) and (b <> 10) do
				begin
                	inc (react^[i].out_num);
                    s := '';
                    while (b <> 32) and (b <> 10) and (b <> 13) do
                    	begin
                        	s := s + chr (b);
                            read (f, b);
                        end;
                    react^[i].out_r [react^[i].out_num] := 1;
		            while (subst^[react^[i].out_r [react^[i].out_num]]) <> s do
		            	inc (react^[i].out_r [react^[i].out_num]);

                    while (b = 32) do
                    	read (f, b);
            	end;

   		while (not eof (f)) and ((b = 13) or (b = 10)) do
	    	read (f, b);
        end;

    fillchar (quantum_satis, sizeof (quantum_satis), 0);

    for level := 1 to 1500 do
    	begin
	    	GetMem (this [level], 4*num);
		    fillchar (this [level]^, 4*num, 0);
        end;

    MakeAllQS;

    level := 1;
    warr (this [1]^) [lead] := 1;
    best_gold := 0;
    CountGold;

    { Gold is not Quantum Satis }

    DisposeArrays;

    Assign (output, 'output.txt');
    rewrite (output);
	Writeln (best_gold);
    close (output);
end.
