{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
type    TWhat = (_One, _Thous, _Mln, _Mlr);
var     N: integer;
        S: array [1..25] of string;
        R: array [1..25] of Byte;
const   Sc1:array [0..19] of string=
        ('',
         '~`','`','`','~`~','`','`','`','`~','`~','`~',
         '~`~~','~`~','~`~','~`~~','~`~','~`~','~`~','~~`~','~~`~');
{       ('','','','ਭ','ୠ',
         '⭠','⭠','ᥬ','ᥬ','⭠');}
        Sc10:array [0..9] of string=
        ('',
         '`~','`~','`~','`~','~~`','~~`',
         '`~~','`~~~','~~`~');
{        ('','','ਤ','ப','줥','줥',
         'ᥬ줥','c줥','ﭮ');}
        Sc100:array [0..9] of string=
        ('',
         '`','`~','~`','~`~~','~`','~`','~`',
         '~~`','~~`');
{        ('','','','','','','ᥬ',
         'ᥬ','');}
        Sc1000:array [0..3] of string=
{        ('','','');}
        ('',
         '`~~','`~~','`~');
        ScMln:array [0..3] of string=
{       ('','','');}
        ('',
         '~~`','~~`~','~~`~');
        ScMlr:array [0..3] of string=
{       ('','ठ','म');}
        ('',
         '~~`','~~`~','~~`~');
        CDD: array [0..3] of set of 0..20 =
        ([0..19],
        [1],
        [2,3,4],
        [0,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19]);
{100  9?, 100 and 100}
{Spell:
 0..19 - 0..19
 20..29 - 10,20,30,40,50,60,70,80,90
 31..39 - 100,200,300,400,500,600,700,800,900
 41..43 - 1000i
 44..46 - MLNi
 47..49 - MLRi
}
var    Rifm: array [0..48] of set of 0..48;
var     A: array [1..20,0..100] of LongInt;

procedure ReadIn;
var       C: Char;
          I: Integer;
begin
 Assign (Input,'input.txt'); Reset (Input);
 ReadLn (N);
 for I := 1 to N do
 begin
  Read (R[I]); Read (C);
  ReadLn (S[I]);
 end;
 Close (input);
end;

procedure WriteOut;
var       I, J: Integer;
begin
 assign (output,'output.txt'); Rewrite (output);
 for I := 1 to N do
 begin
  for J := A[I,0] downto 1 do Write (A[I,J],' '); WriteLn;
 end;
 Close(output);
 Halt;
end;

procedure Solve;
var       I: Integer;
          Last: array [1..25] of Integer;
          Spell: array [0..25] of LongInt;

procedure Rec (St: Integer; X: Integer; What: TWhat; CD: Byte; Y: Byte);
var       I, J: Integer;
          FI1, TI1, I1,I2,I3: Integer;
label     Fail1,Fail2,Fail3,Fail4,FF;

function Cmp (var C: string): Boolean;
var      K, J: Integer;
begin
 K := X-Length(C)+1; if K<1 then begin Cmp:=False; Exit; end;
 if Length(C)=1 then begin Cmp:=True; Exit; end;
 for J := 1 to Length(C) do
  if C[J]<>S[St,K] then begin Cmp:=False; Exit; end else Inc (K);
 Cmp := True;
end;

function NChk: Boolean;
begin
 NChk := (Spell[St]=Spell[Last[R[St]]]) or
         (not (Spell[St] in Rifm[Spell[Last[R[St]]]]));
end;

begin
 if St=N+1 then WriteOut;
 if X=0 then
 begin
  for J := 1 to Y-1 do
   if A[St,Y]=A[St,J] then Exit;
  if A[St,Y]=0 then A[St,0]:=Y-1 else A[St,0]:=Y;
  Last[R[St]]:=St;
  Rec (St+1, Length(S[St+1]),_One,0,1);
 end;
 for I:=0 to 19 do if (I<>10) and (I in CDD[CD]) then {1}
 begin
  if I<>0 then
   if not Cmp (Sc1[I]) then goto Fail1;
  Spell[St] := I; if NChk then goto Fail1;
  Dec (X, Length(Sc1[I]));
  {}if I<10 then begin FI1:=0; TI1:=9; end else
                 begin FI1:=1; TI1:=1; end;
    for I1 := FI1 to TI1 do{10}
    begin
      if I1<>0 then
       if not Cmp (Sc10[I1]) then goto Fail2;
       if NChk then goto Fail2;
      if (Spell[St]=0) and (I1<>0) then Spell[St]:=20+I1; Dec (X, Length(Sc10[I1]));
      {}for I2 := 0 to 9 do{100}
        begin
         if I2<>0 then
          if not Cmp (Sc100[I2]) then goto Fail3;
          if NChk then goto Fail3;
          if (Spell[St]=0) and (I2<>0) then Spell[St]:=I2+30; Dec (X, Length(Sc100[I2]));
         {}case What of
            _One: A[St,Y]:=I+I1*10+I2*100;
            _Thous:Inc (A[St,Y],(LongInt(I)+I1*10+I2*100)*1000);
            _Mln:Inc (A[St,Y],(LongInt(I)+I1*10+I2*100)*1000000);
            _Mlr:Inc (A[St,Y],(LongInt(I)+I1*10+I2*100)*1000000000);
           end;
           if What=_One then
           begin
            for I3 := 1 to 3 do
             if X>=Length(Sc1000[I3]) then
             if Cmp(Sc1000[I3]) then
             begin
              if Spell[St]=0 then Spell[St]:=40+I3;
              if not NChk then
              Rec (St, X-Length(Sc1000[I3]),_Thous,I3,Y);
             end;
           end;
           if What<_Mln then
           begin
            for I3 := 1 to 3 do
             if X>=Length(ScMln[I3]) then
             if Cmp (ScMln[I3]) then
             begin
              if Spell[St]=0 then Spell[St]:=43+I3;
              if not NChk then
              Rec (St, X-Length(ScMln[I3]),_Mln,I3,Y);
             end;
           end;
           if What<_Mlr then
           begin
            for I3 := 1 to 3 do
             if X>=Length(ScMlr[I3]) then
             if cmp (ScMlr[I3]) then
             begin
              if Spell[St]=0 then Spell[St]:=46+I3;
              if not NChk then
              Rec (St, X-Length(ScMlr[I3]),_Mlr,I3,Y);
             end;
           end;
         for J := 1 to Y-1 do
          if A[St,Y]=A[St,J] then goto FF;
         if A[St,y]<>0 then
          Rec(St,X,_One,0,Y+1);
         FF:
         Inc (X, Length(Sc100[I2]));
         Fail3:
        end;
      Inc (X, Length(Sc10[I1]));
      Fail2:
    end;
  Inc (X, Length(Sc1[I]));
  Fail1:
 end;
 if Y=1 then
 begin
  for J := 1 to N do Last[j]:=0;
  for J := 1 to ST-2 do Last[R[J]]:=J;
 end;
end;

begin
 FillChar (Last, SizeOf (Last), 0);
 Spell[0]:=0;
 Rec (1, Length(S[1]), _One, 0, 1);
end;

procedure InitRifm;
var       K, I, J: Integer;
begin
 for I := 1 to 48 do Rifm[I]:=[0]; Rifm[0]:=[0..48];
 {1..10 -   }
 for I := 11 to 19 do Rifm[I]:=[11..19]-[I];
 Rifm[22]:=[23];
 Rifm[23]:=[22];
 Rifm[25]:=[26];
 Rifm[26]:=[25];
 Rifm[29]:=[31];
 Rifm[31]:=[29];

 Rifm[35]:=[36,37,38,39];
 Rifm[36]:=[35,37,38,39];
 Rifm[37]:=[35,36,38,39];
 Rifm[38]:=[35,36,37,39];
 Rifm[39]:=[35,36,37,38];
end;

begin
 ReadIn;
 InitRifm;
 solve;
end.