
#include <conio.h>
#include <stdio.h>
#include <string.h>


#define K  3010
#define N  1010


void solve (int param);
void input ();
void output (int out);
void store_best_data ();


char data [K], best_data [K];
char masks [N], men [N];

struct structure
        {
            int who;
            char down;
            char side, hair;
        } program [K * 2];

int left, right, k, n;
int counter;
int best_left, best_right, min;
int changes;


main ()
 {
   input ();
   solve (0);
   output (1);

   return (0);
 }


void input ()
 {
   char down, side, hair;

   FILE * file = fopen ("input.txt", "r");

   fscanf (file, "%d %d\n", & n, & k);

   for (int index = 0; index < (k << 1); index ++)
    {
      fscanf (file, "%c %d %c %c\n", & down, & program [index]. who, & side, & hair);
       program [index]. down = (down == '+');
       program [index]. hair = (hair == '');
       program [index]. who --;
       program [index]. side = (side == '');
    }

   left = 0;
   right = 0;
   counter = 0;
   changes = 0;
   min = n + 1;
   memset (masks, 0, n);

   fclose (file);
 }



void output (int out)
 {
   FILE * file = fopen ("output.txt", "w");

   fprintf (file, "%d %d\n", best_left, best_right);

   for (int index = 0; index < k; index ++)
    {
      fprintf (file, "%d\n", best_data [index]);
    }

   fclose (file);
 }


void solve (int param)
 {
   int save = counter, r = right;
   int l = left;
   int right_addit, left_addit;
   int temp_data = changes;

   for (param = param; param < (k << 1); param ++)
    {
      if (program [param]. down)
       {
          men [program [param]. who] =
                program [param]. side;

         if (program [param]. hair)
          {
            masks [program [param]. who] = 1;
          data [counter ++] = 1;
             if (program [param]. side)
               { if (left) left --; }
            else
               { if (right) right --; }
          }
         else
          {
            masks [program [param]. who] = 0;
            data [counter ++] = 0; solve (param + 1);

            left_addit = left;     right_addit = right;

            if (program [param]. side)
             { if (left) left --; }
            else
             { if (right) right --; }

            masks [program [param]. who] = 1;
            data [counter - 1] = 1;   solve (param + 1);
            left = left_addit;   right = right_addit;
          }
       }
      else
       {
         if (masks [program [param]. who])
          {
            if (program [param]. side)
             {
              left ++;

              if (! men [program [param]. who])
               changes --;
             }
            else
             {
              right ++;

              if (men [program [param]. who])
               changes ++;

             }

          }
       }
    }

   if ((left + right) < min)
    {
      min = left + right; best_left = left + changes;
      best_right = right - changes;
      store_best_data ();
    }
   counter = save;    changes = temp_data;
   left = l; right = r;
 }


void store_best_data ()
 {
   memcpy (best_data, data, k);
 }