program Alhimik;

{$A+,B-,D+,E+,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}(**)

const
{$ifdef ILIA}
  InFile='c.in';
  OutFile='c.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

const LL=16;
type TLong = array[1..LL] of byte;

procedure LInit(var l:TLong; x:byte);
  begin
  fillchar(l,sizeof(l),0);
  l[1]:=x mod 100;
  l[2]:=x div 100;
  end;

procedure LAdd(const x,y:TLong; var z:TLong);
  var c:byte;
      i:byte;
  begin
  c:=0;
  for i:=1 to LL do begin
    z[i]:=x[i]+y[i]+c;
    c:=z[i] div 100;
    z[i]:=z[i] mod 100;
  end;
  end;

var c:byte;
    i:byte;
    s:byte;

procedure LInc(var x:TLong; const y:TLong);
  begin
  c:=0;
  for i:=1 to LL do begin
    s:=x[i];
    inc(s,y[i]);
    inc(s,c);
    c:=s div 100;
    x[i]:=s mod 100;
  end;
  end;

procedure LWrite(const x:TLong);
  var last:byte;
      i:byte;
  begin
  for last:=LL downto 1 do
    if (last=1) or (x[last]<>0) then break;
  for i:=last downto 1 do begin
    if x[i]<=9 then write('0');
    write(x[i]);
  end;
  end;

function LComp(const x,y:TLong):shortint;
  var i:byte;
  begin
  for i:=LL downto 1 do
    if x[i]<y[i] then begin
      LComp:=-1;
      exit;
    end else if x[i]>y[i] then begin
      LComp:=1;
      exit;
    end;
  LComp:=0;
  end;

function getFirst(var b:boolean):string;
  var st:string;
      ch:char;
  begin
  st:='';
  read(ch);
  while ch in [#9,#32] do read(ch);
  while not (ch in [#9,#13,#32,#26]) do begin
    st:=st+ch;
    read(ch);
  end;
  b:=(ch in [#13,#26]);
  if ch=#13 then read(ch);
  getFirst:=st;
  end;

type TList=array[1..100] of word;

var
  names: array[1..100] of string[10];
  react: array[1..100,-1..100] of byte;
  K,L:byte;

function getCode(const name:string):byte;
  var i:byte;
  begin
  for I:=1 to K do
    if name=names[i] then begin
      getCode:=i;
      exit;
    end;
  getCode:=0;
  end;

procedure ReadData;
  var i,j,ii:byte;
      st1:string;
      b:boolean;
  begin
  Assign(Input,InFile);
  Reset(Input);
  readln(K);
  names[1]:='ᢨ';
  names[2]:='';
  ii:=3;
  for i:=1 to K do begin
    st1:=getFirst(b);
    if (st1<>names[1]) and (st1<>names[2]) then begin
      names[ii]:=st1;
      inc(ii);
    end;
  end;
  readln(L);
  for I:=1 to L do begin
    react[i,-1]:=getCode(getFirst(b));
    ii:=0;
    repeat
      inc(ii);
      react[i,ii]:=getCode(getFirst(b));
      if react[i,ii]=0 then dec(ii);
    until b;
    react[i,0]:=ii;
  end;
  Close(Input);
  end;

var can:array[1..100] of TLong;

var timer:longint absolute $0:$46c;
    tmold:longint;
    lowtime:boolean;

var old:^TLong;
    iii:byte;
procedure Run;
  var i:byte;
      new,oldz:TLong;
    procedure count;
      var cnt:byte;
          i,j:byte;
      begin
      for cnt:=1 to K do begin
        if timer>=tmold then begin lowtime:=true; exit;end;
        for i:=1 to L do begin
          LInit(new,0);
          for j:=1 to react[i,0] do begin
            old:=@can[react[i,j]];
            c:=0;
            for iii:=1 to LL do begin
              s:=old^[iii];
              inc(s,new[iii]);
              inc(s,c);
              c:=s div 100;
              new[iii]:=s mod 100;
            end;
          end;
{            LInc(new,can[react[i,j]]);}
          if LComp(can[react[i,-1]],new)=-1 then begin
{            changed[react[i,-1]]:=true;}
            can[react[i,-1]]:=new;
          end;
        end;
      end;
      end;
  begin
  for i:=1 to K do LInit(can[i],0);
  LInit(can[2],1);
  count;
  if not lowtime then begin
    oldz:=can[1];
    count;
    if lowtime then lowtime:=false;
  end;
  if (not lowtime) and (LComp(can[1],oldz)=0) then
    LWrite(can[1])
  else
    write('QUANTUM SATIS');
  writeln;
  end;

begin
tmold:=timer+trunc(10*18.2)-3;
ReadData;
  Assign(Output,OutFile);
  Rewrite(Output);
Run;
  Close(Output);
end.