{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
program   TaskA;
type      TDush = (_Left, _Right);
          TStatus= (_LR, _L, _R, _FromL, _FromR, _Pool);

var     E:array [1..6010] of record
                              Dush: TDush;
                              Plov: Integer;
                              Need: Boolean;
                              Next: Integer;
                             end;

var       N, K: Integer;
          T: array [1..6010] of Byte; {  }

procedure ReadIn;
var       V: array [1..1010] of Integer;
          I: Integer;
          C: Char;
begin
 Assign (Input,'input.txt'); reset (Input);
 FillChar (V, SizeOF(V), 0);
 ReadLn (N);
 ReadLn (K);
 for I := 1 to 2*K do
 begin
  repeat Read (c); until C<>' ';
  Read (E[I].Plov);
  if C='+' then V[E[I].Plov]:=I else
  begin
   E[V[E[I].Plov]].Next:=I;
   E[I].Next := 0;
  end;
  repeat Read (C); until C<>' ';
  if C in ['',''] then E[I].Dush:=_Left else E[I].Dush:=_Right;
  repeat Read (C); until C<>' ';
  E[I].Need := (C in ['','']);
  ReadLn;
 end;
 close (input);
end;

procedure Solve;
var       I: Integer;
          S: array [1..6010] of TStatus;
          W: array [1..6010] of Integer; {  蠯 i}
          V: array [1..6010] of Integer; {   蠯}
          F: array [TStatus] of Integer; {ࢠ ⠪ 蠯}
          R: array [1..6010] of Integer; { ୥}
          WT: array [1..6010] of Integer; { 﫨}
          MaxUsed: Integer;

procedure Upd (St: TStatus);
var       I: Integer;
begin
 for I := F[St] to MaxUsed+1 do
  if S[I]=St then begin F[st]:=I; Exit; end;
 F[St]:=MaxInt;
end;

function GetLast (St: TStatus): integer;
var      J, I: integer;
begin
 J := F[St];
 for I := F[St]+1 to MaxUsed do
  if S[I]=St then if R[I]>R[J] then J := I;
 GetLast := J;
end;

procedure TakeNeed (_Side, _FromSide: TStatus);
var       H: Integer;
begin
 if F[_Side]<MaxInt then
 begin
  H := F[_Side];
  S[H]:=_Pool; W[H]:=E[I].Plov; V[E[I].Plov] := H; R[H]:=E[I].Next; WT[H]:=I; T[I]:=1;
  Upd (_Side);
 end else
 if F[_FromSide]<MaxInt then
 begin
  H := GetLast (_FromSide);
  V[W[H]]:=0; {⡨}
  S[H] := _Pool; W[H]:=E[I].Plov; V[E[I].Plov] := H;R[H]:=E[I].Next; WT[H]:=I; T[I]:=1;
  Upd (_FromSide);
 end else
 begin
  H := F[_LR];
  if H>MaxUsed then MaxUsed := H;
  if W[H]>0 then
  begin
   if V[W[H]] = H then V[W[H]]:=0;
   W[H]:=0;
   if E[WT[H]].Dush<>E[I].Dush then
    begin T[WT[H]]:=1; T[E[WT[H]].Next]:=1; end else
    begin T[WT[H]]:=0; T[E[WT[H]].Next]:=0; end;
  end;
  S[H]:=_Pool; W[H] := E[I].Plov; V[E[I].Plov] := H;R[H]:=E[I].Next; Wt[H]:=I; T[I]:=1;
  Upd (_LR);
 end;
end;

procedure TakeNoNeed (_Side, _FromSide: TStatus);
var       H: Integer;
begin
 if F[_Side]<MaxInt then
 begin
  H := F[_Side];
  S[H]:=_FromSide; W[H] := E[I].Plov; V[E[I].Plov] := H; R[H]:=E[I].Next; WT[H]:=i;
  Upd (_Side); if H<F[_FromSide] then F[_FromSide]:=H;
 end else
 if F[_FromSide]<MaxInt then
 begin
  H := GetLast (_FromSide);
  if R[H]<=E[I].Next then Exit;
  V[W[H]]:=0; {⡨}
  S[H]:=_FromSide; W[H] := E[I].Plov; V[E[I].Plov] := H; R[H]:=E[I].Next; Wt[H]:=i;
  Upd (_FromSide); if H<F[_FromSide] then F[_FromSide]:=H;
 end else V[E[I].Plov] := 0;
end;

procedure ReturnNeed (St: TStatus);
var       H: Integer;
begin
 H := V[E[I].Plov]; V[E[I].Plov]:=0; W[H] := 0; R[H]:=0; WT[H]:=0;
 T[I] := 1;
 S[H]:=St; if H<F[St] then F[St]:=H;
end;

procedure ReturnNoNeed;
var       H: Integer;
          Old: TStatus;
begin
 H := V[E[I].Plov]; R[H]:=0;
 Old := S[H]; S[H] := _LR;
 Upd (Old); if H<F[_LR] then F[_LR]:=H;
end;


begin
 for S[1] := Low(F) to High(F) do F[S[1]]:=MaxInt;
 Fillchar (S, SizeOf (S), _LR);
 FillChar (W, SizeOF (W), 0);
 FillChar (V, SizeOf (V), 0);
 FillChar (T, SizeOf (T), 0);
 F[_LR]:=1; MaxUsed := 0;

 for I := 1 to 2*K do
  if E[I].Next>0 then
   if E[I].Need then
    case E[I].Dush of
     _Left:TakeNeed (_L, _FromL);
     _Right:TakeNeed (_R, _FromR);
    end else
    begin
     if E[I].Dush<>E[E[I].Next].Dush then
     case E[I].Dush of
      _Left:TakeNoNeed (_L, _FromL);
      _Right:TakeNoNeed (_R, _FromR);
     end
    end else
   if E[I].Need then
    case E[I].Dush of
     _Left:ReturnNeed (_L);
     _Right:ReturnNeed (_R);
    end else
    if V[E[I].Plov]>0 then ReturnNoNeed;
end;

procedure WriteOut;
var       I: Integer;
          L, R, ML, MR: Integer;
begin
 assign (output,'output.txt'); rewrite (output);
 L:=0; R:=0; ML:=0; MR := 0;
 for I := 1 to 2*K do
  if T[I]=1 then
   if E[I].Next>0 then
    case E[I].dush of
     _Left:begin Dec (L); if L<ML then ML:=L; end;
     _Right:begin Dec (R); if R<MR then MR:=R; end;
    end else
    case E[I].dush of
     _Left:Inc (L);
     _Right:Inc (R);
    end;
 WriteLn (-ML, ' ', -MR);
 for I := 1 to 2*K do
  if E[I].Next>0 then WriteLn (T[I]);
 Close(output);
end;

begin
 ReadIn;
 solve;
 WriteOut;
end.