{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
 type
   tp = array [1..60000] of byte;
 var
   x,y: array [1..50] of extended;
   xx,yy: extended;
   p: array [1..4] of ^tp;
   n,np: longint;
   ok: boolean;

 procedure ReadAll;
 var  i: Integer;
 begin
   Assign(Input, 'input.txt');
   Reset(Input);
   Read(n,xx,yy);

   for i := 1 to n do Read(x[i],y[i]);

   Close(Input);
 end;

 procedure Sim(a,b: integer);
 var
   x1,x2,y1,y2,ax,ay,x0,y0: extended;
   v1,v2: extended;
   i: integer;
 begin
   x1 := x[a];
   x2 := x[b];
   y1 := y[a];
   y2 := y[b];
   x0 := (x1+x2)/2;
   y0 := (x1+x2)/2;
   for i := 1 to n do begin
     ax := x[i]; ay := y[i];

     ax := 2*x0-ax;
     ay := 2*y0-ay;

     x[i] := ax; y[i] := ay;
   end;
 end;

 function os(a,b:integer): boolean;
 var
   x1,x2,y1,y2,ax,ay: extended;
   v1,v2: extended;
 begin
   x1 := x[a];
   x2 := x[b];
   y1 := y[a];
   y2 := y[b];
   ax := xx;
   ay := yy;
   v1 := (ax-x1)*(y2-y1)-(ay-y1)*(x2-x1);
   ax := x[(b mod n) + 1];
   ay := x[(b mod n) + 1];
   v2 := (ax-x1)*(y2-y1)-(ay-y1)*(x2-x1);

   if ((v1*v2)<0) and (abs(v1-v2)>1e-8) then os := true else os := false;
 end;

 procedure solve;
 var
  g: boolean;
   i: longInt;
   cp,cs: longint;
 begin
   ok := false;
   np := 0;

   new(p[1]);
   new(p[2]);
   new(p[3]);
   new(p[4]);
   cp:=0;cs:=1;

   repeat
     g := true;
     for i := 1 to n do if os(i,(i mod n)+1) then begin
       inc(np);
       inc(cp);
       if cp>60000 then begin
         inc(cs);
         cp := 1;
       end;

       p[cs]^[cp] := i;
       sim(i,(i mod n)+1);
       if np>200000 then exit;
       g := false;
     end;
   until g;
   ok := true;
 end;

 procedure Out;
 var
   cs,cp,i:longint;
 begin
   Assign(Output, 'output.txt');
   ReWrite(Output);
   if not ok then writeln('IMPOSSIBLE') else begin
     cs := 1;
     cp := 1;
     for i := 1 to np do begin
       WriteLn(p[cs]^[cp],' ',(p[cs]^[cp] mod n) +1);
       inc(cp);
       if cp>60000 then begin
         cp := 1;
         inc(cs);
       end;
     end;
   end;
   Close(Output);
 end;

 begin
   ReadAll;
   Solve;
   Out;
   dispose(p[1]);
   dispose(p[2]);
   dispose(p[3]);
   dispose(p[4]);
 end.