{ ࠭ ࠪ }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}

{$M 16384,0,655360}


const Tenpow: array [0..9] of longint =
       (1,
        10,
        100,
        1000,
        10000,
        100000,
        1000000,
        10000000,
        100000000,
        1000000000);
type TArr = array [0..$1FFF] of longint;
     PArr = ^TArr;
var N: longint;
    d: array [0..9] of PArr;
    buf: pointer;

procedure Sort(l, r: longint);
var i, j, x, y: longint;
begin
  x := d[((l+r) div 2) shr 13]^[((l+r) div 2)and $1Fff];
  i := l;
  j := r;
  repeat
    while d[i shr 13]^[i and $1fff] < x do Inc(i);
    while d[j shr 13]^[j and $1fff] > x do Dec(j);
    if i <= j then begin
      y := d[i shr 13]^[i and $1fff];
      d[i shr 13]^[i and $1fff] := d[j shr 13]^[j and $1fff];
      d[j shr 13]^[j and $1fff] := y;
      inc(i);
      dec(j);
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure ReadAll;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Read(N);
end;

procedure Solve1;
const tab: array [0..10] of integer =
  (0, 0, 1, 3, 6, 10, 15, 21, 28, 36, 45);
var p: integer;
    c, pr, pa, i, k, ans: longint;
    max: longint;
begin
  if N > 82000 then begin
    Writeln('0');
    Halt;
  end;

  for i := 0 to 10 do
    New(d[i]);
  max := 0;
  for i := 0 to N-1 do begin
    Read(d[i shr 13]^[i and $1fff]);
    if d[i shr 13]^[i and $1fff] > max then max := d[i shr 13]^[i and $1fff];
  end;
  Sort(0, N-1);

  ans := 0;
  p := 0;
  while max > 0 do begin
    i := 0;
    pr := -Maxlongint;
    c := 0;
    while i < N do begin
      pa := (d[i shr 13]^[i and $1fff] div (tenpow[p+1])) * tenpow[p] +
            (d[i shr 13]^[i and $1fff]) mod tenpow[p];
      Inc(i);
      if pa = pr then begin
        inc(c);
      end else begin
        if c > 1 then Inc(ans, tab[c]);
        c := 1;
      end;
      if c > 1 then Inc(ans, tab[c]);
      pr := pa;
    end;
    Inc(p);
    max := max div 10;
  end;
  Writeln(ans);
end;

function f(i: longint; j, k: integer): string;
begin
  if k = 0 then f := '' else begin
    f := f(i div 10, i mod 10, k-1)
          + Char($30 + (i + j) mod 10);
  end;
end;

procedure Solve2;
var i: Longint;
begin
  SetTextBuf(output, buf^, 65520);
  for i := 0 to N-1 do begin
    Writeln(f(i, 0, 6));
  end;
  Close(output);
end;

begin
  GetMem(buf, 65520);
  ReadAll;
  if SeekEof then Solve2 else Solve1;
  FreeMem(buf, 65520);
end.