{ 騩 㣮쭨 }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

type float = double;
const eps = 1.0e-10;
      MaxDepth = 6;
var x, y: array [1..20] of longint;
    x0, y0, n: integer;
    xt, yt: longint;
    sg: integer;
    depth: integer;
    stack: array [1..MaxDepth] of integer;

procedure ReadAll;
var i: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Read(n, x0, y0);
  for i := 1 to n do Read(x[i], y[i]);
end;

procedure CheckEnd;
var i, j, s, ss: integer;
    t, xi, yi, xj, yj: longint;
begin
  s := 0;
  for i := 1 to N do begin
    j := i mod N + 1;
    t := (x[j]-x[i])*(y0-sg*y[i]-yt) -
     (y[j] - y[i])*(x0-sg*x[i]-xt);
    if t > 0 then ss := 1 else
    if t < 0 then ss := -1 else
      ss := 0;
    if s = 0 then s := ss else
    if (ss <> 0) and (ss <> s) then Exit;
  end;
  for i := 1 to depth do begin
    Writeln(stack[i], ' ',stack[i] mod N + 1);
  end;
  Halt;
end;

procedure Go;
var xt_s, yt_s: longint;
    i, j: integer;
begin
  if Depth > MaxDepth then Exit;
  CheckEnd;
  xt_s := xt;
  yt_s := yt;
  Inc(depth);
  for i := 1 to N do begin
    stack[depth] := i;
    j := i mod N + 1;
    xt := xt_s + sg * (x[i] + x[i mod N + 1]);
    yt := yt_s + sg * (y[i] + y[i mod N + 1]);
    sg := -sg;
    Go;
    sg := -sg;
  end;
  Dec(depth);
end;

procedure Solve;
var i, j, k, l: integer;
    t1,t2,x1,y1,x2,y2: longint;
    d, xp,yp,k1,k2,cx,cy: float;
label 1, 2;
begin
  cx := 0;
  cy := 0;
  for i := 1 to N do begin
    cx := cx + x[i];
    cy := cy + y[i];
  end;
  cx := cx / N;
  cy := cy / N;

  for i := 1 to N do
    for j := 1 to N do
      for k := 1 to N do
        for l := 1 to N do begin
          x1 := x[i]+x[i mod N+1]-x[j]-x[j mod N+1];
          y1 := y[i]+y[i mod N+1]-y[j]-y[j mod N+1];
          x2 := x[k]+x[k mod N+1]-x[l]-x[l mod N+1];
          y2 := y[k]+y[k mod N+1]-y[l]-y[l mod N+1];
{          if Inside(0,0,x1,y1,x2,y2) then begin }
          d := 1.0*x1*y2-1.0*x2*y1;
          xp := x0-cx;
          yp := y0-cy;
          if Abs(d) > eps then begin
            k1 := (xp*y2-yp*x2)/d;
            k2 := (yp*x1-xp*y1)/d;
            goto 1;
          end;
        end;
  goto 2;
1:
  if k1 >= 0 then t1 := Trunc(k1) else t1 := Trunc(k1)-1;
  if k2 >= 0 then t2 := Trunc(k2) else t2 := Trunc(k2)-1;
  xt := x1*t1+x2*t2;
  yt := y1*t1+y2*t2;
  while t1 > 0 do begin
    Writeln(i, ' ', i mod N + 1);
    Writeln(j, ' ', j mod N + 1);
    Dec(t1);
  end;
  while t1 < 0 do begin
    Writeln(j, ' ', j mod N + 1);
    Writeln(i, ' ', i mod N + 1);
    Inc(t1);
  end;
  while t2 > 0 do begin
    Writeln(k, ' ', k mod N + 1);
    Writeln(l, ' ', l mod N + 1);
    Dec(t2);
  end;
  while t2 < 0 do begin
    Writeln(l, ' ', l mod N + 1);
    Writeln(k, ' ', k mod N + 1);
    Inc(t2);
  end;
  sg := 1;
  Go;
2:
  Rewrite(output);
  Writeln('IMPOSSIBLE');
end;

begin
  ReadAll;
  Solve;
end.