{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
type               Float = Real;
var PX, PY: LongInt;
    X, Y: array [1..30] of LongInt;
    N: Integer;
    Buf: array [0..64000] of Byte;

procedure ReadIn;
var       I: Integer;
begin
 Assign (Input,'input.txt'); reset (Input);
 Read (N, PX, PY);
 for I := 1 to N do Read(X[I],Y[I]);
 close (input);
end;

procedure Impossible;
begin
 assign (output,'output.txt'); rewrite (output);
 WriteLn ('IMPOSSIBLE');
 Close(output);
end;

procedure Solve;
var       I, J, K: Integer;
          D1: Real;
          D2: Real;

procedure MoveIt (A, B: Integer);
var       X0, Y0, I: LongInt;
begin
 WriteLn (A, ' ', B);
 X0 := (X[A]+X[B]); Y0 := (Y[A]+Y[B]);
 for I := 1 to N do begin X[I]:=X0-X[I]; Y[I]:=Y0-Y[I]; end;
end;

function Det (X0, Y0, X1, Y1, X2, Y2: LongInt): Float;
begin
 Det := (X1-X0)*(Y2-Y0)-(X2-X0)*(Y1-Y0);
end;
var     F: Boolean;

begin
 repeat
  F := True;
  J := 2; K := 3;
  for I := 1 to N do
  begin
   D1:=Det (X[I],Y[I],X[J],Y[J],PX,PY);
   D2:=Det (X[I],Y[I],X[J],Y[J],X[K],Y[K]);
   if ((D1>0) and (D2<0)) or ((D1<0) and (D2>0)) then
   begin
    MoveIt (I,J); F:= False;
    Break;
   end;
   if J=N then J :=1 else Inc (J);
   if K=N then K:=1 else Inc (K);
  end;

 until F;
end;

begin
 ReadIn;
 Assign (output,'output.txt'); rewrite (output);
 settextbuf (output,buf,64000);
 Solve;
 close (output);
end.