{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
Uses Crt;
Const Eps=0.001;
Type  TPoint=Record X,Y:Real;End;
      TLine=Record A,B,C:Real;End;
      TSegment=Record A,B:TPoint;End;
      Mnog=Array[1..20] Of TPoint;

Var N:Integer;
    Timer:LongInt Absolute $000:$46C;
    Time:LongInt;
    P:TPoint;
    K:Mnog;
    f1:Text;
    KolOtv:Integer;
{    Otv:Array[1..10000,1..2] Of Byte;}

Function Compare(A1,A2:Real):ShortInt;
Begin
If A1-A2>Eps Then Compare:=1 Else
  If A2-A1>Eps Then Compare:=-1 Else Compare:=0;
End;
Procedure MakeLine(Var L:TLine;P1,P2:TPoint);
Begin
 L.A:=P1.Y-P2.Y;
 L.B:=P2.X-P1.X;
 L.C:=P1.X*P2.Y-P2.X*P1.Y;
End;
Function EqlPoints(P1,P2:TPoint):Boolean;
Begin
EqlPoints:=(Compare(P1.X,P2.X)=0) And (Compare(P1.Y,P2.Y)=0);
End;
Function CrossLines(Var P:TPoint;L1,L2:TLine):Boolean;
Var D:Real;
Begin
D:=L1.A*L2.B-L2.A*L1.B;
If Compare(D,0)=0 Then CrossLines:=False Else
Begin
 CrossLines:=True;
 P.X:=(L2.C*L1.B-L1.C*L2.B)/D;
 P.Y:=(L2.A*L1.C-L1.A*L2.C)/D;
End;
End;
Function CrossSL(Var P:TPoint;S:TSegment;L:TLine):Boolean;
Var L1:TLine;
Begin
If Compare((L.A*S.A.X+L.B*S.A.Y+L.C)*(L.A*S.B.X+L.B*S.B.Y+L.C),0)=1 Then
Begin CrossSL:=False End Else
Begin
 CrossSL:=True;
 MakeLine(L1,S.A,S.B);
 CrossLines(P,L,L1);
End;
End;

Function Rast(A,B:TPoint):Real;
Begin
Rast:=Sqrt(Sqr(A.X-B.X)+Sqr(A.Y-B.Y));
End;

Function InSideSeg(P,B,C:TPoint):Boolean;
Begin
InSideSeg:=Compare(Rast(P,B)+Rast(P,C),Rast(B,C))=0;
End;

Function InSidePoly(Poly:Mnog;P:TPoint):Boolean;
Var I,K:Integer;
    O,M:TPoint;
    L:TLine;
    S:TSegment;
Begin
InSidePoly:=False;
For I:=1 To N Do
If EqlPoints(Poly[I],P) Then Begin InSidePoly:=True;Exit;End;
For I:=1 To N-1 Do
If InSideSeg(P,Poly[I],Poly[I+1]) Then Begin InSidePoly:=True;Exit;End;

If InSideSeg(P,Poly[1],Poly[N]) Then Begin InSidePoly:=True;Exit;End;
L.A:=0;L.B:=1;L.C:=-P.Y;
K:=0;
S.A:=Poly[N];
For I:=1 To N Do Begin
  S.B:=Poly[I];
   If Compare(S.A.Y,S.B.Y)=1 Then M:=S.A Else M:=S.B;
   If CrossSL(O,S,L) Then
     If Not EqlPoints(O,M) And (Compare(O.X,P.X)>0) Then Inc(K);
  S.A:=S.B;
End;
InSidePoly:=K And 1=1;
End;

Procedure Impos;
Begin
Close(F1);
Assign(F1,'OutPut.Txt');
ReWrite(F1);
WriteLn(F1,'IMPOSSIBLE');
Close(F1);
Halt(0);
End;

Procedure Input;
Var F:Text;
    I:Integer;
Begin
Assign(F,'Input.Txt');
Reset(F);
Assign(F1,'OutPut.Txt');
ReWrite(F1);
Read(F,N);
RandSeed:=N;
Read(F,P.X,P.Y);
For I:=1 To N Do Read(F,K[I].X,K[I].Y);
Close(F);
End;

Procedure Work;
Var Temp:Array[1..20] Of Mnog;
    Tek:Mnog;
    KolTemp,TTT,I:Integer;
    Min,PredMin,FFF:Real;

Function AllRast(A:Mnog;B:TPoint):Real;
Var Z,FFF:Real;
    I:Integer;
Begin
Z:=0;
For I:=1 To N Do Z:=Z+Sqrt(Sqr(A[I].X-B.X)+Sqr(A[I].Y-B.Y));
AllRast:=Z;
End;
Procedure Pr(Var A:TPoint;B:TPoint);
Var T:TPoint;
Begin
T.X:=B.X-(A.X-B.X);
T.Y:=B.Y+B.Y-A.Y;
A:=T;
End;
Procedure BuildTemp(A,B:Byte);
Var Z:TPoint;I:Integer;
Begin
Inc(KolTemp);
Z.X:=(Tek[A].X+Tek[B].X)/2;Z.Y:=(Tek[A].Y+Tek[B].Y)/2;
For I:=1 To N Do Begin Temp[KolTemp,I]:=Tek[I];Pr(Temp[KolTemp,I],Z);End;
End;

Begin
Tek:=K;
While Not InSidePoly(Tek,P) Do Begin
KolTemp:=0;FillChar(Temp,SizeOf(Temp),0);
For I:=1 To N-1 Do BuildTemp(I,I+1);BuildTemp(1,N);
Min:=10000000;TTT:=0;
PredMin:=Min;

For I:=1 To KolTemp Do
Begin
FFF:=AllRast(Temp[I],P);
If FFF<Min Then Begin Min:=FFF;TTT:=I;End;
End;
If {(KolOtv=10000) Or }(Abs(Time-Timer)>172) Then Impos;
Tek:=Temp[TTT];
{Inc(KolOtv);}
If Random(20)=1 Then TTT:=Random(N)+1;
{If TTT=N Then Begin Otv[KolOtv,1]:=1;Otv[KolOtv,2]:=N;End Else Begin Otv[KolOtv,1]:=TTT;Otv[KolOtv,2]:=TTT+1;End;}
If TTT=N Then WriteLn(F1,1,' ',N) Else WriteLn(F1,TTT,' ',TTT+1);
End;
End;

{Procedure Out;
Var F:Text;
    I:Integer;
Begin
Assign(F,'OutPut.Txt');
ReWrite(F);
For I:=1 To KolOtv Do Begin WriteLn(F,Otv[I,1],' ',Otv[I,2]);End;
Close(F);
End;}

Begin
Time:=Timer;
Input;
Work;
Close(F1);
End.