program LandOfFools;
{$M 16384,361000,655360}
{$A+,B-,D-,E+,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}(**)

const
{$ifdef ILIA}
  InFile='a.in';
  OutFile='con';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type T10000=array[0..9999] of longint;
const PunktB:boolean=false;
var
  tbl0:T10000;
  tbl:array[0..9] of ^T10000;
  N:longint;

procedure ReadData;
  var i:longint;
  begin
  Assign(input,InFile);
  Reset(Input);
  readln(N);
  if seekeof(Input) then
    PunktB:=true
  else begin
    for i:=0 to N-1 do
      read(tbl[i div 10000]^[i mod 10000]);
  end;
  Close(Input);
  end;

{ QSORT }
procedure swap(var x,y:longint);
  var tmp:longint;
  begin
  tmp:=x;
  x:=y;
  y:=tmp;
  end;

procedure qsort;
  procedure sort(l,r:longint);
    var b:longint;
        ll,mm,rr:longint;
        s:longint;
        ptr:^Longint;
    begin
      if r-l=2 then begin
        if tbl[(l+1) div 10000]^[(l+1) mod 10000]>
           tbl[r div 10000]^[r mod 10000] then
             swap(tbl[(l+1) div 10000]^[(l+1) mod 10000],
                  tbl[r div 10000]^[r mod 10000]);
      end;
      if (r>l+2) then begin
        s:=l+((r-l)div 2)+1;
        b:=tbl[s div 10000]^[s mod 10000];
        ll:=l;
        mm:=l;
        rr:=r;
        while mm<>rr do begin
          ptr:=@tbl[(mm+1) div 10000]^[(mm+1) mod 10000];
          if ptr^=b then
            inc(mm)
          else if ptr^> b then begin
            swap(ptr^,tbl[rr div 10000]^[rr mod 10000]);
            dec(rr);
          end else begin
            swap(ptr^,tbl[(ll+1) div 10000]^[(ll+1) mod 10000]);
            inc(mm);
            inc(ll);
          end;
        end;
        sort(l,ll);
        sort(rr,r);
      end;
    end;
begin
sort(-1,N-1);
end;

procedure RunA;
  var c:byte;
      s:longint;
      i:longint;
      count:longint;
      last:longint;
      curn:byte;
  const add:array[0..10] of longint = (0,0,1,3,4*3 div 2,5*4 div 2,6*5 div 2,7*6 div 2,8*7 div 2,9*8 div 2,10*9 div 2);
  begin
  count:=0;
  for c:=1 to 9 do begin
{    write('*');}
    qsort;
{    write('->');}
    last:=0;
    curn:=0;
    for i:=0 to N-1 do begin
      if last=tbl[i div 10000]^[i mod 10000] div 10 then
        inc(curn)
      else begin
        inc(count,add[curn]);
        last:=tbl[i div 10000]^[i mod 10000] div 10;
        curn:=1;
      end;
    end;
{    write('.');}
    inc(count,add[curn]);
    for i:=0 to N-1 do begin
      s:=tbl[i div 10000]^[i mod 10000];
      tbl[i div 10000]^[i mod 10000]:=(s div 100000000)+10*(s mod 100000000);
    end;
  end;
  writeln(count);
  end;

function sc(x:longint):byte;
  begin
  if x=0 then
    sc:=0
  else
    sc:=(x+longint(sc(x div 10))) mod 10;
  end;

procedure RunB;
  var i:longint;
  begin
  if N=1 then writeln(0) else
    for I:=0 to N-1 do
      writeln(i,sc(i));
  end;

var i:byte;
begin
for i:=1 to 9 do new(tbl[i]);
tbl[0]:=@tbl0;
ReadData;
Assign(Output,OutFile);
Rewrite(Output);
if PunktB then
  RunB
else
  RunA;
Close(Output);
for i:=1 to 9 do dispose(tbl[i]);
end.