program Scaner;
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

const
{$ifdef ILIA}
  InFile='c.in';
  OutFile='c.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type TChar = array[1..3,1..3] of char;
const cif: array[0..9] of TChar =
(
     ((' ','_',' '),
      ('|',' ','|'),
      ('|','_','|')),

     ((' ',' ',' '),
      (' ',' ','|'),
      (' ',' ','|')),

     ((' ','_',' '),
      (' ','_','|'),
      ('|','_',' ')),

     ((' ','_',' '),
      (' ','_','|'),
      (' ','_','|')),

     ((' ',' ',' '),
      ('|','_','|'),
      (' ',' ','|')),

     ((' ','_',' '),
      ('|','_',' '),
      (' ','_','|')),

     ((' ','_',' '),
      ('|','_',' '),
      ('|','_','|')),

     ((' ','_',' '),
      (' ',' ','|'),
      (' ',' ','|')),

     ((' ','_',' '),
      ('|','_','|'),
      ('|','_','|')),

     ((' ','_',' '),
      ('|','_','|'),
      (' ','_','|'))
);


var ch:array[1..9] of TChar;


procedure ReadData;
  var i,j,k:byte;
  begin
  Assign(input,InFile);
  Reset(Input);
  for j:=1 to 3 do begin
    for i:=1 to 9 do
      for k:=1 to 3 do
        if eoln then
          ch[i,j,k]:=' '
        else
          read(ch[i,j,k]);
    readln;
  end;
  Close(Input);
  end;

var code:array[1..9] of shortint;
    error:byte;

procedure WriteSol;
  var i:byte;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  case error of
    0: begin for i:=1 to 9 do write(code[i]); writeln; end;
    1: writeln('failure');
    2: writeln('ambiguous');
  end;
  Close(Output);
  end;

function char_in(const a,b:TCHar):boolean;
  var i,j:byte;
  begin
  char_in:=false;
  for i:=1 to 3 do
    for j:=1 to 3 do
      if (a[i,j]<>' ') and (b[i,j]<>a[i,j]) then
        exit;
  char_in:=true;
  end;

procedure Run;
  var same:boolean;
      bad:byte;
      sum:byte;
      i,j,ii,jj:byte;
{  var tr,old:array[0..10] of byte;
      add:byte;
      how:array[0..10,1..9] of byte;}
      hown:byte;
      howto:byte;
  begin
  error:=0;
  bad:=0;
  for i:=1 to 9 do begin
    code[i]:=-1;
    for j:=0 to 9 do begin
      same:=true;
      for ii:=1 to 3 do
        for jj:=1 to 3 do
          if ch[i,ii,jj]<>cif[j,ii,jj] then begin
            same:=false;
            break;
          end;
      if same then begin
        code[i]:=j;
        break;
      end;
    end;
    if code[i]=-1 then
      if bad=0 then
        bad:=i
      else begin
        error:=1;
        exit;
      end;
  end;

  sum:=0;
  if bad<>0 then code[bad]:=0;
  for i:=1 to 9 do
    sum:=(sum+(10-i)*code[i]) mod 11;
  if sum<>0 then
    sum:=11-sum;
  if (bad=0) and (sum=0) then
    exit;
  if bad<>0 then begin
     for i:=0 to 10 do
       if ((10-bad)*i) mod 11 = sum then begin
         code[bad]:=i;
         break;
       end;
     if code[bad]=10 then begin
       error:=1;
       exit;
     end;
     if char_in(ch[bad],cif[code[bad]]) then
       error:=0
     else
       error:=1;
     exit;
  end;

  hown:=0;
  for i:=1 to 9 do
    for j:=0 to 9 do
      if char_in(ch[i],cif[j]) then
        if ((j-code[i]+11)*(10-i) mod 11=sum) then
          if hown<>0 then begin
            error:=2;
            exit;
          end else begin
            hown:=i;
            howto:=j;
          end;
  if hown=0 then
    error:=1
  else
    code[hown]:=howto;
  end;

begin
ReadData;
Run;
WriteSol;
end.