{ XII ᨩ᪠  誮쭨  ଠ⨪ }
{ (c) 2000,   . }
{  "UP" }
{ :    娭 }
{ 襭: ᨬ  }
{ 室 䠩: INPUT.TXT, 室: OUTPUT.TXT }

{.$define DEBUG}
{$M 64000,300000,300000}

{.$define DUMP_FIND}

program Solution;

{$ifndef DEBUG}
{$A-,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile                        = 'input.txt';
  {$ifndef BUILD_ANSWER}
  outFile                       = 'output.txt';
  {$else}
  outFile                       = 'answer.txt';
  {$endif}
{$else}
{$A-,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile                        = 'input.txt';
  outFile                       = 'con';
  dbgFile                       = 'con';
var
  dbg                           : Text;
{$endif}

const
  maxM                          = 500;
  maxL                          = 16;
  infinity                      = maxint;

type
  TParam                        = array[1..4] of byte;

  TTask                         = record
    req                         : TParam;
    makes                       : TParam;
  end;

  TPiece                        = array[1..maxL,1..maxL] of record
    len                         : integer;
    using                       : integer;
  end;

  PPiece                        = ^TPiece;

var
  m                             : integer;
  t                             : integer;
  l                             : integer;
  task                          : array[1..maxM] of TTask;
  ansLen                        : integer;
  answer                        : array[1..maxM] of integer;
  w                             : array[1..maxL,1..maxL] of PPiece;
  used                          : array[1..maxM] of boolean;
  ok                            : boolean;

function Find( p : TParam ) : integer;
label next_task;

var
  i,j                           : integer;
  upgrade                       : boolean;
  min                           : integer;
  _p                            : TParam;
  _using                        : integer;
  q                             : integer;

begin
  {$ifdef DEBUG}
  {$ifdef DUMP_FIND}
  write( 'Find( ' );
  for i := 1 to 4 do write( p[i], ' ' );
  writeln( ')' );
  {$endif}
  {$endif}

  if w[p[1],p[2]]^[p[3],p[4]].len <> -1  then begin
    Find := w[p[1],p[2]]^[p[3],p[4]].len;
    exit;
  end;

  min := infinity;

  for i := 1 to m do begin
    upgrade := false;
    for j := 1 to 4 do begin
      if p[j] < task[i].req[j] then goto next_task;
      if p[j] < task[i].makes[j] then upgrade := true;
    end;

    if upgrade then begin
      for j := 1 to 4 do
        if task[i].makes[j] > p[j] then
          _p[j] := task[i].makes[j]
        else
          _p[j] := p[j];
      q := Find( _p );
      if (q <> infinity) and (q + 1 < min) then begin
        min    := q + 1;
        _using := i;
      end;
    end;

    next_task:
  end;

  w[p[1],p[2]]^[p[3],p[4]].len   := min;
  w[p[1],p[2]]^[p[3],p[4]].using := _using;
  Find := min;

end;

procedure WriteData; forward;
procedure Finalize; forward;

procedure Solve;
var
  i,j                           : integer;
  p                             : TParam;
  q                             : integer;

begin

  w[l,l]^[l,l].len   := 0;
  w[l,l]^[l,l].using := -1;

  for i := 1 to 4 do p[i] := 1;
  q := Find( p );
  if (q = infinity) or (q * 2 > t) then begin
    ok := false;
    exit;
  end;

  ok := true;
  ansLen := 0;
  fillchar( used, sizeof(used), false );

  for i := 1 to 4 do p[i] := 1;
  while w[p[1],p[2]]^[p[3],p[4]].using <> -1 do begin
    inc( ansLen );
    i := w[p[1],p[2]]^[p[3],p[4]].using;
    answer[ansLen] := i;
    used[i] := true;
    for j := 1 to 4 do
      if task[i].makes[j] > p[j] then p[j] := task[i].makes[j];
  end;

  dec( t, ansLen * 2 );
  for i := 1 to m do begin
    if t = 0 then exit;
    if not used[i] then begin
      inc( ansLen );
      answer[ansLen] := i;
      dec( t, 1 );
    end;
  end;

end;

procedure ReadData;
var
  i,j                           : integer;

begin
  read( t, l, m );
  for i := 1 to m do begin
    for j := 1 to 4 do read( task[i].req[j] );
    for j := 1 to 4 do read( task[i].makes[j] );
  end;
end;

procedure WriteData;
var
  i                             : integer;

begin
  if ok then begin
    writeln( ansLen );
    for i := 1 to ansLen do write( answer[i], ' ' );
    writeln;
  end else
    writeln( 0 );
end;

procedure Initialize;
var
  i,j                           : integer;

begin

  for i := 1 to maxL do
    for j := 1 to maxL do begin
      new( w[i,j] );
      fillchar( w[i,j]^, sizeof(w[i,j]^), $ff );
    end;

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef DEBUG}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef DEBUG}
  writeln( '----Finalized----' );
  close( dbg );
  {$endif}

  close( input );
  close( output );

  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.
