{XII ᨩ᪠  誮쭨  ଠ⨪

: " ⢠"  ࣥ 쥢 祭

襭: ⮫ ॢ

}

{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+}
{$M 16384,0,655360}


Const
  Max=102;
  eps=1e-9;
Type
  real=extended;
  TPoint=record
               x,y:real;
  end;
  TLine=record
               a,b,c:real;
  end;
  TPoly=record
              n:integer;
              t:array[0..Max+1] of TPoint;
  end;

var
  King,KingTown:TPoly;
  Res1,Res2:TPoint;

procedure TwoPointLine(t1,t2:TPoint;var l:TLine);
begin
  l.a:=(t2.y-t1.y);
  l.b:=-(t2.x-t1.x);
  l.c:=-(l.a*t1.x+l.b*t1.y);
end;

function Dist(t1,t2:TPoint):real;
begin
  Dist:=sqrt(sqr(t1.x-t2.x)+sqr(t1.y-t2.y));
end;

function InSide(t1,t2,t3:TPoint):boolean;
begin
  if abs(Dist(t1,t3)-(Dist(t1,t2)+Dist(t2,t3)))<eps then InSide:=true
                                                    else InSide:=false;
end;

function EqPoint(t1,t2:TPoint):boolean;
begin
  if (abs(t1.x-t2.x)<eps) and (abs(t1.y-t2.y)<eps) then EqPoint:=true
                                                   else EqPoint:=false;
end;

function S3(t1,t2,t3:TPoint):real;
begin
  s3:=1/2*((t2.x-t1.x)*(t3.y-t1.y)-(t2.y-t1.y)*(t3.x-t1.x));
end;

function TwoPointLinePoint(p1,p2:TPoint;l2:TLine;var p:TPoint):boolean;
var
  d:real;
  l1:TLine;
begin
  TwoPointLine(p1,p2,l1);
  d:=l1.a*l2.b-l1.b*l2.a;
  if abs(d)<eps then
  begin
    if (abs(l1.c*l2.b-l2.c*l1.b)<eps)  and (abs(l1.c*l2.a-l2.c*l1.a)<eps) then
    begin
      p:=p2;
      TwoPointLinePoint:=true;exit;
    end
       else
    begin
      TwoPointLinePoint:=false;exit;
    end;
  end;
  p.x:=-(l1.c*l2.b-l1.b*l2.c)/d;
  p.y:=-(l1.a*l2.c-l1.c*l2.a)/d;
  if InSide(p1,p,p2) and (not EqPoint(p1,p)) then TwoPointLinePoint:=true
                                             else TwoPointLinePoint:=false;
end;

function SPoly(a:TPoly):real;
var
  i:integer;
  s:real;
begin
  s:=0;
  for i:=1 to a.n do
    s:=s+S3(a.t[1],a.t[i],a.t[i+1]);
  SPoly:=s;
end;

function PolyLineTwoPoint(a:TPoly;l:TLine;var p1,p2:TPoint):boolean;
var
  f1,f2:boolean;
  i:integer;
  p:TPoint;
begin
  f1:=false;
  f2:=false;
  for i:=1 to a.n do
    if TwoPointLinePoint(a.t[i],a.t[i+1],l,p) then
    begin
      if (f1) and (f2) then
      begin
           writeln('Error in program');
           halt;
      end;
      if (not f1) then begin p1:=p;f1:=true;end
                  else
      if (f1) and (not f2) then begin p2:=p;f2:=true;end;
    end;
end;

procedure CountDownUp(a:TPoly;l:TLine;var up,down:integer);
var
  d:real;
  i:integer;
begin
  up:=0;
  down:=0;
  for i:=1 to a.n do
  begin
    d:=l.a*a.t[i].x+l.b*a.t[i].y+l.c;
    if d<-eps then inc(down);
    if d>eps  then inc(up);
  end;
end;

procedure PolyLineTwoPoly(a:TPoly;l:TLine;var a1,a2:TPoly);
var
  f1,f2:boolean;
  i:integer;
  p:TPoint;
  L1:TLine;
  up,down:integer;
begin
  f1:=false;
  f2:=false;
  a1.n:=0;
  a2.n:=0;
  CountDownUp(a,l,up,down);
  if (up=0) or (down=0) then
  begin
    a1:=a;
    exit;
  end;
  for i:=1 to a.n do
  begin
    if ((not f1) and (not f2)) or (f1 and f2) then
    begin
      inc(a1.n);
      a1.t[a1.n]:=a.t[i];
    end;
    if (f1 and (not f2)) then
    begin
      inc(a2.n);
      a2.t[a2.n]:=a.t[i];
    end;
    if TwoPointLinePoint(a.t[i],a.t[i+1],l,p) then
    begin
      if (f1) and (f2) then
      begin
        writeln('Error in program');
        halt;
      end;
      inc(a1.n);
      a1.t[a1.n]:=p;
      inc(a2.n);
      a2.t[a2.n]:=p;
      if (not f1) then f1:=true
                  else
      if (f1) and (not f2) then f2:=true;
    end;
  end;
  a1.t[a1.n+1]:=a1.t[1];
  a2.t[a2.n+1]:=a2.t[1];
end;

procedure MakeDevidePolyAndCount(a:TPoly;alfa:real;var l:TLine;var dint:integer;var sum:integer);
var
  c,cmin,cmax,s1,s2:real;
  i:integer;
  a1,a2:TPoly;
  l1,l2:TLine;
  ds1,ds2,ds:real;
  up,down:integer;
begin
  l.a:=sin(alfa);
  l.b:=-cos(alfa);
  cmin:=-(l.a*a.t[1].x+l.b*a.t[1].y);
  cmax:=-(l.a*a.t[1].x+l.b*a.t[1].y);
  for i:=2 to a.n do
  begin
    c:=-(l.a*a.t[i].x+l.b*a.t[i].y);
    if c>cmax then cmax:=c;
    if c<cmin then cmin:=c;
  end;
  l1:=l;l1.c:=cmin;
  l2:=l;l2.c:=cmax;
  PolyLineTwoPoly(King,l1,a1,a2);
  CountDownUp(a1,l1,up,down);
  if down>0 then begin a:=a1;a1:=a2;a2:=a;end;

  s1:=SPoly(a1);s2:=SPoly(a2);ds1:=s2-s1;

  PolyLineTwoPoly(King,l2,a1,a2);
  CountDownUp(a1,l2,up,down);
  if down>0 then begin a:=a1;a1:=a2;a2:=a;end;
  s1:=SPoly(a1);s2:=SPoly(a2);ds2:=s2-s1;

  repeat
    l.c:=(l1.c+l2.c)/2;
    PolyLineTwoPoly(King,l,a1,a2);
    CountDownUp(a1,l,up,down);
    if down>0 then begin a:=a1;a1:=a2;a2:=a;end;
    s1:=SPoly(a1);s2:=SPoly(a2);ds:=s2-s1;
    if ((ds>0) and (ds1>0)) or ((ds<0) and (ds1<0)) then l1:=l
                                                    else l2:=l;
  until (abs(ds)<100*eps);

  CountDownUp(KingTown,l,up,down);
  dint:=up-down;
  sum:=up+down;
end;

procedure ReadData;
var
  i:integer;
  F:Text;
begin
  Assign(F,'input.txt');
  Reset(F);
  Read(F,King.n);
  for i:=1 to King.N do
    Read(F,King.t[i].x,King.t[i].y);
  King.t[King.N+1]:=King.t[1];
  Read(F,KingTown.n);
  for i:=1 to KingTown.N do
    Read(F,KingTown.t[i].x,KingTown.t[i].y);
  Close(F);
end;

procedure Solve;
var
  alfa1,alfa2,alfa:real;
  dint1,dint2,dint,sum1,sum2,sum:integer;
  l1,l2,l:TLine;
begin
  alfa1:=0;
  alfa2:=pi;
  MakeDevidePolyAndCount(King,alfa1,l1,dint1,sum1);
  MakeDevidePolyAndCount(King,alfa2,l2,dint2,sum2);
  repeat
    alfa:=(alfa2+alfa1)/2;
    MakeDevidePolyAndCount(King,alfa,l,dint,sum);
    if (dint=0) then begin alfa1:=alfa;alfa2:=alfa;end;
    if (dint*dint1)>0 then begin alfa1:=alfa;dint1:=dint;sum1:=sum;end
                      else begin alfa2:=alfa;dint2:=dint;sum2:=sum;end;
  until abs(alfa1-alfa2)<eps;
  PolyLineTwoPoint(King,l,Res1,Res2);
end;

procedure OutData;
var
  F:text;
begin
  Assign(F,'output.txt');
  ReWrite(F);
  Writeln(F,Res1.x:0:8,' ',Res1.y:0:8);
  Writeln(F,Res2.x:0:8,' ',Res2.y:0:8);
  Close(F);
end;

begin
  ReadData;
  Solve;
  OutData;
end.
