{ XII ᨩ᪠  誮쭨  ଠ⨪ }
{ (c) 2000,   . }
{  "᪠!" }
{ :   . ॥ }
{ 襭: ⠫ ஢ }
{ 室 䠩: INPUT.TXT, 室: OUTPUT.TXT }

{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}

{.$DEFINE debug}

const
  nMax = 100;

type
  tAllStat = (_basic, _neg, _and, _or, _iff, _if);

  tStatement = record
                 tp : tAllStat;
                 case byte of
                   _basic : (stat:string);
                   _neg   : (arg:char);
                   _and, _or, _iff, _if  : (left, right : char);
               end;

const
  ops : array[_basic.._if] of string = ('FUI', '!', '&', '|', '<=>', '=>');
  speak : array[_basic.._if] of string = ('FUI', 'FUI', ' ', ' ',
          ' ⮣  ⮫쪮 ⮣, ', ', ');

var
  a : array[1..nMax] of tStatement;
  let : array['A'..'Z'] of integer;
  back : array[1..nMax] of char;
  N : integer;

procedure Init;
var
  s : string;
begin
  assign(input, 'input.txt');
  reSet(input);
  readLN;

  N := 0;
  while not seekEof do begin
    readLn(s);
    inc(N);
    let[s[1]] := N;
    back[N] := s[1];
    delete(s, 1, 2);

    if Pos('(', s) <> 0 then begin
      a[N].tp := _basic;
      a[N].stat := s;
    end
    else
      if s[1] = '!' then begin
        a[N].tp := _neg;
        a[N].arg := s[2];
      end
      else begin
        case s[2] of
          '&':begin
                a[N].tp := _and; a[N].right := s[3];
              end;
          '|':begin
                a[N].tp := _or; a[N].right := s[3];
              end;
          '=':begin
                a[N].tp := _if; a[N].right := s[4];
              end;
          '<':begin
                a[N].tp := _iff; a[N].right := s[5];
              end;
        end;

        a[N].left := s[1];
      end;
  end;
end;

procedure Solve1(k : integer);
begin
  if a[k].tp <> _basic then write('(');
  case a[k].tp of
    _basic:begin write(back[k]); exit; end;
	_neg:begin
		   write('!');
		   Solve1(let[a[k].arg]);
		 end;
    _and, _or, _if, _iff:
         begin
           solve1(let[a[k].left]);
           write(ops[a[k].tp]);
           solve1(let[a[k].right]);
         end;
    else
      RunError(1);
  end;
  if a[k].tp <> _basic then write(')');
end;

procedure Solve2(k : integer; neg : boolean);
begin
  if a[k].tp <> _basic then write('(');
  case a[k].tp of
    _basic:begin
             if neg then write('!');
             write(back[k]);
           end;
    _neg:Solve2(let[a[k].arg], not neg);
    _and:begin
           solve2(let[a[k].left], neg);
           if neg then
             write(ops[_or])
           else
             write(ops[_and]);
           solve2(let[a[k].right], neg);
         end;
    _or:begin
          solve2(let[a[k].left], neg);
          if neg then
            write(ops[_and])
          else
            write(ops[_or]);
          solve2(let[a[k].right], neg);
        end;
    _iff:begin
           if not neg then begin
             solve2(let[a[k].left], neg);
             write(ops[_iff]);
             solve2(let[a[k].right], neg);
           end
           else begin
             solve2(let[a[k].left], true);
             write(ops[_and]);
             solve2(let[a[k].right], false);
             write(ops[_or]);
             solve2(let[a[k].left], false);
             write(ops[_and]);
             solve2(let[a[k].right], true);
           end;
         end;
    _if:begin
          if neg then begin
            solve2(let[a[k].left], false);
            write(ops[_and]);
            solve2(let[a[k].right], true);
          end
          else begin
            solve2(let[a[k].left], false);
            write(ops[_if]);
            solve2(let[a[k].right], false);
          end;
        end;
    else
      RunError(2);
  end;

  if a[k].tp <> _basic then write(')');
end;

procedure printSentence(const s : string; const neg : boolean);
const
  was:boolean = false;
var
  i, old : integer;
begin
  if not was then was := true
  else write(' ');

  i := 1;
  while i <= length(s) do begin
    if (s[i] = '(') then
      if neg then write(' ')
      else
    else
      if s[i] <> ')' then write(s[i]);
    inc(i);
  end;
end;

procedure Solve3(k : integer; neg : boolean);
begin
  case a[k].tp of
    _basic:begin printSentence(a[k].stat, neg); exit; end;
    _neg:Solve3(let[a[k].arg], not neg);
    _and:begin
           solve3(let[a[k].left], neg);
           if neg then
             write(speak[_or])
           else
             write(speak[_and]);
           solve3(let[a[k].right], neg);
         end;
    _or:begin
          solve3(let[a[k].left], neg);
          if neg then
            write(speak[_and])
          else
            write(speak[_or]);
          solve3(let[a[k].right], neg);
        end;
    _iff:begin
           if not neg then begin
             solve3(let[a[k].left], neg);
             write(speak[_iff]);
             solve3(let[a[k].right], neg);
           end
           else begin
             solve3(let[a[k].left], true);
             write(speak[_and]);
             solve3(let[a[k].right], false);
             write(speak[_or]);
             solve3(let[a[k].left], false);
             write(speak[_and]);
             solve3(let[a[k].right], true);
           end;
         end;
    _if:begin
          if neg then begin
            solve3(let[a[k].left], false);
            write(speak[_and]);
            solve3(let[a[k].right], true);
          end
          else begin
            printSentence('᫨', false);
            solve3(let[a[k].left], false);
            write(speak[_if]);
            solve3(let[a[k].right], false);
          end;
        end;
    else
      RunError(3);
  end;
end;


Begin
  Init;

{$IFNDEF debug}
  assign(output, 'output.txt');
  reWrite(output);
{$ENDIF}

  Solve1(N); writeln;
  Solve2(N, false); writeLn;
  Solve3(N, false); writeLn;
End.
