{ ᨩ   誮쭨  ணࠬ஢ }
{ :  "஧"                                              }
{ :                                               }
{ 襭: ३ ⠭                                       }

{$DEFINE MOREINFO}
{$DEFINE OUTGRAPH}

program Furrows;

procedure arrange(var x, y: longint);
var
  t: longint;
begin
  if x > y then
  begin
    t := x;
    x := y;
    y := t;
  end;
end;

const
  _up = 1;
  _down = 2;
  _left = 4;
  _right = 8;

type
  tvert = record
    x, y: longint;
    d: longint;
  end;

var
  n: longint;
  i, j, k, l, m1, m2: longint;
  x1, y1, x2, y2: array [1..100] of longint;
  v: array [1..3000] of tvert;
  can: array [1..100, 1..100] of boolean;
  u: array [1..100] of boolean;

procedure ins(x, y: longint; d: longint);
var
  i: longint;
begin
  for i := 1 to l do
    if (v[i].x = x) and (v[i].y = y) then
    begin
      v[i].d := v[i].d or d;
      exit;
    end;
  inc(l);
  v[l].x := x;
  v[l].y := y;
  v[l].d := d;
end;

function between(x, y, z: longint): boolean;
begin
  between := (x < y) and (y < z);
end;

function inside(x, y, z: longint): boolean;
begin
  inside := (x <= y) and (y <= z);
end;

function touch(x, y: longint): boolean;
begin
  if x1[x] = x2[x] then
    if x1[y] = x2[y] then
      touch := (x1[x] = x1[y]) and
        (inside(y1[x], y1[y], y2[x]) or inside(y1[x], y2[y], y2[x]))
    else
      touch := inside(x1[y], x1[x], x2[y]) and inside(y1[x], y1[y], y2[x])
  else
    if y1[y] = y2[y] then
      touch := (y1[x] = y1[y]) and
        (inside(x1[x], x1[y], x2[x]) or inside(x1[x], x2[y], x2[x]))
    else
      touch := touch(y, x);
end;

procedure check(x: longint);
var
  i: longint;
begin
  u[x] := true;
  for i := 1 to n do
    if not u[i] and can[x][i] then
      check(i);
end;

function str(i: longint): string;
var
  r: string;
begin
  system.str(i, r);
  str := r;
end;

procedure quit(s1, s2: string);
begin
  assign(output, 'output.txt');
  rewrite(output);
  writeln(s1);
  {$IFDEF MOREINFO}
  writeln;
  writeln(s2);
  {$ENDIF}
  halt(0);
end;

procedure quit1(s1: string; vx, vy: longint; s2: string);
begin
  assign(output, 'output.txt');
  rewrite(output);
  writeln(s1);
  writeln(vx, ' ', vy);
  {$IFDEF MOREINFO}
  writeln;
  writeln(s2);
  {$ENDIF}
  halt(0);
end;

begin
  assign(input, 'input.txt');
  reset(input);
  {$IFDEF OUTGRAPH}
  assign(output, 'graph.dat');
  rewrite(output);
  {$ENDIF}

  read(n);
  for i := 1 to n do
  begin
    read(x1[i], y1[i], x2[i], y2[i]);
    arrange(x1[i], x2[i]);
    arrange(y1[i], y2[i]);
  end;

  { ஢ઠ  吝 }
  fillchar(can, sizeof(can), 0);
  for i := 1 to n do
    for j := 1 to n do
      can[i][j] := touch(i, j);
  check(1);
  for i := 1 to n do
    if not u[i] then
      quit('NO', 'not connected');

  { ஢ઠ ⭮ }
  l := 0;
  for i := 1 to n do
  begin
    if x1[i] = x2[i] then
    begin
      ins(x1[i], y1[i], _up);
      ins(x2[i], y2[i], _down);
      for j := 1 to n do
        if y1[j] = y2[j] then
        begin
          if (x1[i] = x1[j]) or (x2[i] = x2[j]) then
            if between(y1[i], y1[j], y2[i]) then
              ins(x1[i], y1[j], _up or _down);
        end
        else
        begin
          if (x1[i] = x1[j]) and between(y1[i], y1[j], y2[i]) then
            ins(x1[j], y1[j], _up or _down);
          if (x1[i] = x1[j]) and between(y1[i], y2[j], y2[i]) then
            ins(x2[j], y2[j], _up or _down);
        end;
    end
    else
    begin
      ins(x1[i], y1[i], _right);
      ins(x2[i], y2[i], _left);
      for j := 1 to n do
        if x1[j] = x2[j] then
        begin
          if (y1[i] = y1[j]) or (y2[i] = y2[j]) then
            if between(x1[i], x1[j], x2[i]) then
              ins(x1[j], y1[i], _left or _right);
        end
        else
        begin
          if (y1[i] = y1[j]) and between(x1[i], x1[j], x2[i]) then
            ins(x1[j], y1[j], _left or _right);
          if (y1[i] = y1[j]) and between(x1[i], x2[j], x2[i]) then
            ins(x2[j], y2[j], _left or _right);
        end;
    end;
  end;

  k := 0; m1 := 0; m2 := 0;
  {$IFDEF OUTGRAPH}
  writeln(l);
  {$ENDIF}
  for i := 1 to l do
  begin
    j := 0;
    {$IFDEF OUTGRAPH}
    writeln(v[i].x, ' ', v[i].y, ' ', v[i].d);
    {$ENDIF}
    if v[i].d and _up    <> 0 then inc(j);
    if v[i].d and _down  <> 0 then inc(j);
    if v[i].d and _left  <> 0 then inc(j);
    if v[i].d and _right <> 0 then inc(j);
    if j mod 2 <> 0 then
    begin
      inc(k);
      if m1 = 0 then m1 := i else m2 := i;
    end;
  end;
  {$IFDEF OUTGRAPH}
  close(output);
  {$ENDIF}
  if k = 0 then
    quit1('YES', x1[1], y1[1], 'all vertexes even')
  else
  if k = 2 then
    quit1('YES', v[m1].x, v[m1].y,
      '2 odd vertexes'#13#10+
        str(v[m1].x)+' '+str(v[m1].y)+#13#10+
        str(v[m2].x)+' '+str(v[m2].y))
  else
    quit('NO', str(k)+' odd vertexes');
end.