{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P+,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

program Web;

procedure trim(var s: string);
var
  i: longint;
begin
  while s[1] = ' ' do delete(s, 1, 1);
  while (length(s) <> 0) and (s[length(s)] = ' ') do dec(s[0]);
{  while pos(' >', s) <> 0 do delete(s, pos(' >', s), 1);
  while pos('< ', s) <> 0 do delete(s, pos('< ', s)+1, 1);}
  for i := 1 to length(s) do
    s[i] := upcase(s[i]);
end;

procedure fronttoken(var s, p: string);
var
  i: longint;
begin
  trim(s);
  p := '';
  i := 1;
  while (i <= length(s)) and not (s[i] in [' ', '>']) do
  begin
    p := p + s[i];
    inc(i);
  end;
  if s[i] = '>' then p := p + '>';
  delete(s, 1, i);
end;

var
  i, j, k, n: longint;
  name, s, p: string;
  docs: array [0..101] of string[80];
  a: array [1..100, 1..100] of boolean;
  f: boolean;
  u: array [1..100] of boolean;
  wrong, ok: longint;

function try(x: longint): longint;
var
  i: longint;
  r: longint;
begin
  u[x] := true;
  r := 1;
  for i := 1 to n do
    if a[x][i] and not u[i] then
      r := r + try(i);
  try := r;
end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);
  readln(n);
  for i := 1 to n do
  begin
    readln(docs[i]);
    trim(docs[i]);
    readln(s); trim(s);
    while s <> '<END>' do
    begin
      readln(s);
      trim(s);
    end;
  end;
  reset(input);
  readln(n);
  for i := 1 to n do
  begin
    readln(s);
    readln(s); trim(s);
    while s <> '<END>' do
    begin
      while s <> '' do
      begin
        fronttoken(s, p);
        if (p = '<A') and (s <> '') then
        begin
          fronttoken(s, p);
          if (copy(p, 1, 6) = 'HREF="') then
          begin
            delete(p, 1, 6);
            if pos('"', p) <> 0 then
            begin
              name := copy(p, 1, pos('"', p)-1);
              trim(name);
              delete(p, 1, pos('"', p));
              if (p = '>') and (name <> '') then
              begin
                f := false;
                for j := 1 to n do
                  if docs[j] = name then
                  begin
                    a[i][j] := true;
                    f := true;
                  end;
                if not f then inc(wrong);
              end;
            end;
          end;
        end;
      end;
      readln(s);
      trim(s);
    end;
  end;
  ok := try(1);
  writeln(wrong, ' ', n-ok);
end.
