{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program P0309_4;
const InFile='fire.in';
      OutFile='fire.out';
var inF,outF:Text;
type TAir=record
       x1,y1,x2,y2:Real
     end;

var L:Real;
    N:Integer;
    Air:array[1..100]of TAir;
    Easy:Boolean;

type TLine=array[0..101]of Real;
     PLine=^TLine;
var X,Y:TLine;

function Test(A:PLine):Real;
var rez:Real;
    i:Integer;
begin
  Test:=0;
  for i:=0 to N do
    if((A^[i+1]-A^[i])>100)then
      begin
        Test:=(A^[i+1]+A^[i])/2;
        Exit
      end;
end;

procedure Sort(A:PLine;l,r:Integer);
var
  i, j: integer;
  x,y:Real;
begin
  i := l; j := r; x := a^[(l+r) DIV 2];
  repeat
    while a^[i] < x do i := i + 1;
    while x < a^[j] do j := j - 1;
    if i <= j then
    begin
      y := a^[i]; a^[i] := a^[j]; a^[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(A,l, j);
  if i < r then Sort(A,i, r);
end;

procedure Best;
var OK:array[1..4]of Boolean;
    FOK:Boolean;
    i:Integer;
    tx,ty:Real;
    cx,cy:Integer;
begin
  cx:=0;
  cy:=0;
  for i:=1 to N do
    with(Air[i])do
      if(x1=x2)then
        begin
          inc(cx);
          x[cx]:=x1
        end
      else
        begin
          inc(cy);
          y[cy]:=y1;
        end;
  x[0]:=-50;
  x[cx+1]:=L+50;
  y[0]:=-50;
  y[cy+1]:=L+50;
  Sort(@x,0,cx+1);
  Sort(@Y,0,cy+1);
  tx:=Test(@X);
  ty:=Test(@Y);
  if((tx=0)or(ty=0))then Write(outf,'OK')
  else Write(outf,tx:0:3,' ',ty:0:3);
end;

procedure NoBest;
begin
  if(L<900)then Write(outf,'OK')
  else Write(outf,(L/13.14):0:3,' ',(L/7.6):0:3);
end;

procedure Run;
begin
  if(Easy)then Best
  else NoBest;
end;

procedure Init;
var i:Integer;
begin
  Assign(inF,InFile);
  Assign(outF,OutFile);
  Reset(inF);
  ReWrite(outF);
  Readln(inF,L);
  Readln(inF,N);
  Easy:=True;
  for i:=1 to N do
    with(Air[i])do
      begin
        Readln(inF,x1,y1,x2,y2);
        if(not((((x1=0)or(x1=L))and
               ((x2=0)or(x2=L))and(y1=y2))or
               (((y1=0)or(y1=L))and
               ((y2=0)or(y2=L))and(x1=x2))))then Easy:=False;
      end;
  FillChar(X,SizeOf(X),0);
  FillChar(Y,SizeOf(Y),0);
end;

procedure Done;
begin
  Close(InF);
  Close(OutF)
end;

begin
  Init;
  Run;
  Done
end.