{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  fix = 100;

type
  tplane = record
    xb, yb, xe, ye, x1, y1, x2, y2, x3, y3, x4, y4: real;
  end;

var
  pc: integer;
  p: array[1..100] of tplane;
  c1, c2, c3: longint;
  t: boolean;
  a, b, c, d, e: real;
  l: longint;

function min(a, b: real): real;
begin
  if a < b then min := a else min := b;
end;

function max(a, b: real): real;
begin
  if a > b then max := a else max := b;
end;

begin
  assign(input, 'fire.in'); reset(input);
  assign(output, 'fire.out'); rewrite(output);
  read(l, pc);
  for c1 := 1 to pc do begin
    read(p[c1].xb, p[c1].yb, p[c1].xe, p[c1].ye);
    p[c1].xb := p[c1].xb*1000; p[c1].yb := p[c1].yb*1000;
    p[c1].xe := p[c1].xe*1000; p[c1].ye := p[c1].ye*1000;
    if p[c1].yb <> p[c1].ye then begin
    if p[c1].xe <> p[c1].xb then begin
      e := (p[c1].ye-p[c1].yb)/(p[c1].xe-p[c1].xb); a := arctan(e);
      p[c1].x1 := p[c1].xb-50000/sin(pi/2-a);
      p[c1].x2 := p[c1].xe-50000/sin(pi/2-a);
      p[c1].x3 := p[c1].xb+50000/sin(a);
      p[c1].x4 := p[c1].xe+50000/sin(a);
      d := p[c1].yb-(p[c1].ye-p[c1].yb)/(p[c1].xe-p[c1].xb)*p[c1].xb;
      p[c1].y1 := e*p[c1].x1+d+50000/sin(pi/2-a);
      p[c1].y2 := e*p[c1].x2+d+50000/sin(pi/2-a);
      p[c1].y3 := e*p[c1].x3+d-50000/sin(pi/2-a);
      p[c1].y4 := e*p[c1].x4+d-50000/sin(pi/2-a);
    end else begin
      p[c1].x1 := p[c1].xb-50000; p[c1].x2 := p[c1].xe-50000;
      p[c1].x3 := p[c1].xb+50000; p[c1].x4 := p[c1].xe+50000;
      p[c1].y1 := p[c1].yb; p[c1].y2 := p[c1].ye;
      p[c1].y3 := p[c1].yb; p[c1].y4 := p[c1].ye;
    end;
    end else begin
      p[c1].x1 := p[c1].xb; p[c1].x2 := p[c1].xe;
      p[c1].x3 := p[c1].xb; p[c1].x4 := p[c1].xe;
      p[c1].y1 := p[c1].yb-50000; p[c1].y2 := p[c1].ye-50000;
      p[c1].y3 := p[c1].yb+50000; p[c1].y4 := p[c1].ye+50000;
    end;
  end;
  l := (l*1000) div fix;
  for c1 := 0 to l do begin
    for c2 := 0 to l do begin
      t := true;
      for c3 := 1 to pc do begin
        b := (c1*fix-p[c3].x1)*(p[c3].y2-p[c3].y1)-
             (c2*fix-p[c3].y1)*(p[c3].x2-p[c3].x1);
        c := (c1*fix-p[c3].x3)*(p[c3].y4-p[c3].y3)-
             (c2*fix-p[c3].y3)*(p[c3].x4-p[c3].x3);
        if c*b <= 0 then begin
          t := false;
          if p[c3].xb = p[c3].xe then begin
            c1 := trunc(max(p[c3].x1, p[c3].x3)) div fix;
            if c1 > l then c1 := l;
            c2 := l;
          end else
            if p[c3].yb = p[c3].ye then begin
              c2 := trunc(max(p[c3].y1, p[c3].y3)) div fix;
              if c2 > l then c2 := l;
            end else begin
              c2 := round(((p[c3].y2-p[c3].y1)/(p[c3].x2-p[c3].x1)*c1*fix+
                p[c3].y1-(p[c3].y2-p[c3].y1)/(p[c3].x2-p[c3].x1)*p[c3].x1)/fix)+1;
              if c2 > l then c2 := l;
            end;
          break;
        end;
      end;
      if t then begin
        writeln((c1/(1000/fix)):1:3, ' ', (c2/(1000/fix)):1:3); halt;
      end;
    end;
  end;
  writeln('OK');
end.