{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
const
    InFile='olymp.in';
    OutFile='olymp.out';
    max=1000;

type
    Ttime=record
            t,num:integer;
        end;
    Tstep=record
            u1,u2,d:integer;
        end;
    Tsteps=array[1..max]of Tstep;

var
    n:integer;
    MinTime:longint;
    k:array[1..max]of integer;
    b:array[1..max]of boolean;
    t:array[1..max]of Ttime;
    s,best:Tsteps;

procedure ReadData;
var
    f:text;
    i:integer;
begin
    assign(f,InFile);
    reset(f);
    readln(f,n);
    for i:=1 to n do begin
        readln(f,t[i].t);
        t[i].num:=i;
    end;
    close(f);
end;

procedure Result;
var
    f:text;
    i:integer;
begin
    assign(f,OutFile);
    rewrite(f);
    writeln(f,MinTime);
    for i:=1 to (n-2)do
        writeln(f,t[best[i].u1].num,' ',t[best[i].u2].num,' ',t[best[i].d].num);
    writeln(f,t[best[n-1].u1].num,' ',t[best[n-1].u2].num);
    close(f);
end;

procedure Sort(l,r:integer);
var
    i,j,x:integer;
    y:Ttime;
begin
    i:=l;
    j:=r;
    x:=t[(l+r) div 2].t;
  repeat
    while t[i].t<x do inc(i);
    while x<t[j].t do dec(j);
    if i<=j then
    begin
      y:=t[i];
      t[i]:=t[j];
      t[j]:=y;
      inc(i);
      dec(j);
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

function xT(a:Tsteps):longint;
var
    x:longint;
    i:integer;
begin
    x:=0;
    for i:=1 to (n-2) do begin
        x:=x+t[a[i].u2].t+t[a[i].d].t;
    end;
    x:=x+t[a[n-1].u2].t;
    xT:=x;
end;

procedure Proverka;
var
    CurrTime:longint;
begin
    CurrTime:=xT(s);
    if CurrTime<MinTime then begin
        MinTime:=CurrTime;
        best:=s;
        Result;
    end;
end;

procedure Solve;
var
    i,j:integer;
    n1,n2,nn,nn1,ex:integer;{1,2,n,n-1}
begin
    Sort(1,n);
    for i:=1 to (n-1) do begin
        best[i].u1:=1;
        best[i].u2:=i+1;
        best[i].d:=1;
    end;
    MinTime:=xT(best);
    Result;
    if N<=3 then exit;
    for i:=1 to n do b[i]:=false;
    s[1].u1:=1;
    s[1].u2:=2;
    s[1].d:=1;
    b[2]:=true;
    for i:=2 to (n-2) do begin
        ex:=1;
        while not(b[ex]) do inc(ex);
        n1:=1;
        while b[n1] do inc(n1);
        n2:=n1+1;
        while b[n2] do inc(n2);
        nn:=n;
        while b[nn] do dec(nn);
        nn1:=nn-1;
        while b[nn1] do dec(nn1);
        if ex>nn1 then begin    {nn,n1}
            s[i].u1:=n1; {n1=1}
            s[i].u2:=n2; {n2=2}
            s[i].d:=n1;
            b[n2]:=true;
        end
         else begin
            if (t[nn].t+t[n1].t+t[nn1].t)>(t[nn].t+2*t[ex].t) then begin
                s[i].u1:=nn1;
                s[i].u2:=nn;
                s[i].d:=ex;
                b[nn1]:=true;
                b[nn]:=true;
                b[ex]:=false;
            end
             else begin
                s[i].u1:=n1;
                s[i].u2:=nn;
                s[i].d:=n1;
                b[nn]:=true;
            end;
        end;
    end;
    n1:=1;
    while b[n1] do inc(n1);
    n2:=n1+1;
    while b[n2] do inc(n2);
    s[n-1].u1:=n1;
    s[n-1].u2:=n2;
    Proverka;
end;

begin
    ReadData;
    Solve;
end.