{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}

program P0606_3;
{Written by 0606}
const
 MaxD = 1000;
 MaxC = 10000;
 MaxN = 24;
 IName = 'tele.in';
 OName = 'tele.out';
type
 TCom = record n:integer;d:byte;end;{d = 0 -  d=1 +}
 TPos = array[1..MaxN] of integer;
VAR
 D:array[1..MaxD] of integer;{start positions}
 R:array[1..MaxD] of integer;{dimensions}
 NC:integer;
 NG:array[1..14] of integer;{numbers of real groups}
 Path:array[1..MaxC] of TCom;{Path}
 PC:integer;
 Now:TPos;
 N:integer;{number of signal boxes}
 PTwo:array[1..MaxC] of TCom;
 PTC,PTI:integer;

 procedure Input;
 var f:text;
 i:integer;
 begin
   assign(f,IName);
   reset(F);
   readln(f,N);
   for i:=1 to N do begin
     read(f,R[i]);
   end;
   readln(f);
   for i:=1 to N do begin
     read(f,D[i]);
   end;
   close(F);
 end;
 procedure Print;
 var i:integer;f:text;
 begin
  assign(f,OName);
  rewrite(f);
  if PC=-1 then write(f,'No') else
  begin
    write(f,'Yes');
    for i:=1 to PC do begin
      writeln(f);
      write(f,Path[i].n,' ');
      if Path[i].d=0 then write(f,'-') else write(f,'+');
    end;
  end;
  close(f);
 end;
 procedure Findreal;
 var i,j:integer;
 begin
   NC:=0;
   for i:=1 to N do begin
     if R[i]>1 then begin
       inc(NC);
       NG[NC]:=i;
     end;
   end;
 end;
 procedure SortBin;
 var i,j,k:integer;
 begin
   for i:=1 to NC-1 do begin
     k:=0;
     for j:=NC downto i+1 do begin
       if (R[NG[j]] mod 2 = 0) and (R[NG[j-1]] mod 2 <>0) then begin
         k:=NG[j];
         Ng[j]:=NG[j-1];
         NG[j-1]:=k;
         k:=1;
       end;
     end;
     if k=0 then exit;
   end;
 end;
 procedure Go(age:integer);
 var i:integer;
 begin
   if age>NC then exit;
   if Now[age]=1 then begin
     for i:=1 to R[NG[age]]-1 do begin
       Go(age+1);
       inc(PC);
       Path[PC].D:=1;
       Path[PC].n:=NG[age];
       inc(Now[age]);


     end;
     Go(age+1);
   end else begin
     for i:=1 to R[NG[age]]-1 do begin
       Go(age+1);
       inc(PC);
       Path[pc].D:=0;
       Path[pc].n:=NG[age];
       dec(Now[age]);
     end;
     Go(age+1);
   end;
 end;
 procedure GenerateTwo;
 var i,j:integer;a,b:integer;s,t:integer;ll:integer;
 begin
   PTI:=0;
   PTC:=0;
   s:=1;
   t:=1;
   a:=R[NG[1]];
   b:=R[NG[2]];
   for i:=1 to b-1 do begin
     inc(PTC);
     PTwo[PTC].n:=NG[2];
     PTwo[PTC].d:=1;
     inc(t);
   end;
   for i:=1 to a-1 do begin
     inc(PTC);
     PTwo[PTC].n:=NG[1];
     PTwo[PTC].d:=1;
     inc(s);
   end;

   for i:=a downto 2 do begin
     if t>1 then begin
       ll:=t-1;
       for j:=1 to ll do begin
         inc(PTC);
         PTwo[PTC].n:=NG[2];
         PTwo[PTC].d:=0;
         dec(t);
       end;
     end else begin
       ll:=b-2;
       for j:=1 to ll do begin
          inc(PTC);
          PTwo[PTC].n:=NG[2];
          PTwo[PTC].d:=1;
          inc(t);
       end;
     end;
     dec(s);
     inc(PTC);
     PTwo[PTC].n:=NG[1];
     PTwo[PTC].d:=0;
   end;
 end;
 procedure SolveNotBin;
 begin
   PC:=-1;
 end;
 function NextTwo:integer;
 var i,j:integer;
 begin
   if PTI>=PTC then begin NextTwo:=0;exit;end;
   inc(PTI);
   inc(PC);
   Path[PC].N:=PTwo[PTI].N;
   Path[PC].D:=PTwo[PTI].D;
   if PTI=PTC then NextTwo:=0 else NextTwo:=1;
 end;
 function Yes:boolean;
 var i,j:integer;
 begin
   for i:=1 to NC do if D[NG[i]]<>Now[i] then begin Yes:=false;exit;end;
   Yes:=true;
 end;
 function F(a:integer):integer;
 var i:integer;
 begin
   for i:=1 to NC do if NG[i]=a then F:=i;

 end;
 procedure EvaluatePath;
 var i,j,k:integer;
 begin
   for i:=1 to PC do PTwo[i]:=Path[i];
   for i:=1 to NC do Now[i]:=1;
   k:=1;
   for i:=1 to PC do begin
     if PTwo[i].D=0 then dec(Now[F(Ptwo[i].n)]) else inc(Now[F(Ptwo[i].n)]);
     if Yes then k:=i;
   end;
   PTC:=0;
   for i:=k+1 to PC do begin
     inc(PTC);
     Path[PTC]:=PTwo[i];
   end;
   for i:=1 to k do begin{!!}
     inc(PTC);
     Path[PTC]:=Ptwo[i];
   end;
   PC:=PTC;
 end;
 procedure SolveBin;
 var i,j:integer;
 begin
{   NC:=0;}
   GenerateTwo;
   for i:=1 to NC do Now[i]:=1;
   j:=1;
   while j>=1 do begin
     if NC>2 then Go(3);
     j:=NextTwo;
   end;
   EvaluatePath;
 end;
 procedure Solve;
 begin
   FindReal;
   if NC=0 then begin
     PC:=0;
     exit;
   end;
   if (NC=1) and (R[NG[1]]>2) then begin
     PC:=-1;
     exit;
   end;
   if (NC=1) and (R[NG[1]]=2) then begin
     PC:=2;
     Path[1].n:=NG[1];
     Path[2].n:=NG[1];
     if D[NG[1]]=1 then begin path[1].d:=1;path[2].d:=0;end else
     begin  path[1].d:=0;path[2].d:=1;end;
     exit;
   end;
   SortBin;
   if R[NG[1]] mod 2 = 0 then SolveBin else SolveNotBin;
 end;
 begin
   Input;
   Solve;
   Print;
 end.