{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
program P0606_4;
{Written by 0606}
const
LineMax = 100;
NMax = 1000;
dx = 1E-6;
s = 50;
maxpc = 150;
IName = 'fire.in';
OName = 'fire.out';
type
dd = real;
TLine = record a,b,c:dd;end;
TPoint = record x,y:dd;end;
Polyg = record
V:array[1..LineMax+4] of TPoint;
C:integer;
end;
tar = array[1..30] of Polyg;
par = ^tar;
var
Sos:boolean;
LC:integer;
N:integer;
L:integer;
Lines:array[1..LineMax*2] of TLine;
G,P:array[1..5] of par;
PC:integer;{How many polygons}
POut:TPoint;
function Equal(a,b:dd):boolean;
begin
 if abs(a-b)<=dx then Equal:=true else equal:=false;
end;
function Lin(A:Tpoint;L:TLine):dd;
begin
 Lin:=L.a*A.x+L.b*a.y+L.c;
end;
procedure GetParal(A:TLine;var B,C:TLine);
var K,cs,l:dd;
begin
  if not (Equal(A.a,0) or Equal(A.b,0)) then begin
    B.a:=A.a;
    B.b:=A.b;
    C:=B;
    l:=abs(A.C)*sqrt(sqr(1/A.a)+sqr(1/A.b));
    cs:=-a.c/(a.a*l);
    K:=s/cs;
    B.c:=A.c+K;
    C.c:=A.c-K;
  end else begin
    if EquaL(a.a,0) then begin
      K:=s;
      B.a:=A.a;
      B.b:=a.b;
      C:=B;
      B.c:=a.c+K;
      C.c:=a.c-K;
    end else begin
      K:=A.a*S;
      B.a:=A.a;
      B.b:=a.b;
      C:=B;
      B.c:=a.c+K;
      C.c:=a.c-K;
    end;
  end;
end;
function Hatch(A,B:TLine;var P:TPoint):boolean;
var C:TLine;
begin
  if Equal(A.a*B.b-B.a*A.b,0) then begin
    Hatch:=false;
  end else begin
    Hatch:=true;
    if Equal(a.a,0) then begin C:=a;a:=b;b:=c;end;
    b.a:=b.a*a.a;
    b.b:=b.b*a.a;
    b.c:=b.c*a.a;
    C:=a;
    c.a:=c.a*b.a;
    c.b:=c.b*b.a;
    c.c:=c.c*b.a;
    c.a:=0;
    c.b:=c.b-b.b;
    c.c:=c.c-b.c;
    P.y:=-c.c/c.b;
    P.x:=-(a.b*P.y+a.c)/a.a;
  end;
end;
procedure GetLine(A,B:TPoint;var C:TLine);
begin
 if Equal(a.x,b.x) then begin
   C.b:=0;
   C.a:=1;
   C.c:=-C.a*a.x;
 end else begin
   C.b:=1;
   C.a:=(a.y-b.y)/(b.x-a.x);
   C.c:=-(c.a*a.x+c.b*a.y);
 end;
end;
procedure Pt(x,y:dd;var P:Tpoint);
begin
  P.x:=x;
  P.y:=y;
end;
procedure AddPolygon(aP:Polyg);
var i,j:integer;
begin
  if PC=Maxpc then exit;{ 졠!}
  inc(PC);
  i:=((PC-1) div 30)+1;
  j:=((PC-1) mod 30)+1;
  P[i]^[j]:=aP;
end;
procedure Input;
var f:text;
i:integer;
x1,y1,x2,y2:dd;
a,b,c:TLine;
P1,P2:TPoint;
K:Polyg;
begin
  for i:=1 to 5 do New(P[i]);
  for i:=1 to 5 do New(G[i]);
  assign(f,Iname);
  reset(f);
  LC:=0;
  readln(f,L);
  readln(f,N);
  for i:=1 to N do begin
   readln(f,P1.x,P1.y,P2.x,P2.y);
   GetLine(P1,P2,A);
   inc(LC);
   Lines[LC]:=A;
  end;
  K.C:=4;
  Pt(0,0,P1);
  K.V[1]:=P1;
  Pt(0,L,P1);
  K.V[2]:=P1;
  Pt(L,L,P1);
  K.V[3]:=P1;
  Pt(L,0,P1);
  K.V[4]:=P1;
  AddPolygon(K);

  close(f);
  Sos:=false;{Point not found}
end;
procedure Print;
var f:text;
begin
 assign(f,OName);
 rewrite(f);
 if Sos then begin
   write(f,POut.x:9:3,' ',Pout.y:9:3);
 end else write(f,'OK');
 close(f);
end;
procedure GetPolygG(num:integer;var P1:Polyg);
var i,j:integer;
begin
  i:=((Num-1) div 30)+1;
  j:=((Num-1) mod 30)+1;
  P1:=G[i]^[j];
end;
function DistL(L:TLine;P:TPoint):dd;
begin
   DistL:=abs(L.a*P.x+L.b*P.y+L.c)/sqrt(sqr(L.a)+sqr(L.b));
end;
function MoreE(a,b:dd):boolean;
begin
  if (a>b) or (Equal(a,b)) then MoreE:=true else MoreE:=false;
end;
function Dist(a,b:TPoint):dd;
begin
  Dist:=sqrt(sqr(a.X-b.x)+sqr(b.y-a.y));
end;
function InOtr(P1,p2,p3:TPoint):boolean;
var d1,d2,d3:dd;
begin
  d1:=Dist(p1,p2);
  d2:=Dist(p1,p3);
  d3:=Dist(p2,p3);
  if Equal(D1+D2,D3) then InOtr:=true else InOtr:=false;
end;
function EqualP(p1,p2:TPoint):boolean;
begin
 if Equal(p1.x,p2.x) and Equal(p1.y,p2.y) then EqualP:=true else EqualP:=false;
end;
procedure Work(pn,ln:integer);
var A,B,C,D:TLine;
P1:Polyg;
P2,P3,P4:TPoint;
i,j:integer;
O:array[1..4] of TPoint;
I1:array[1..4] of integer;
L2:Polyg;
OC:integer;
R,R1,R2:array[1..LineMax+4] of boolean;
dub:boolean;
BB:boolean;
nn:integer;
begin
  OC:=0;
  A:=Lines[ln];
  GetPolygG(pn,P1);
  GetParal(A,B,C);
  for i:=1 to P1.C do begin
    if MoreE(DistL(A,P1.V[i]),s) then R[i]:=true else R[i]:=false;
  end;
  for i:=1 to P1.C do begin
    if i<P1.C then begin
     nn:=i+1;
    end else begin
      nn:=1;
    end;
    GetLine(P1.V[i],P1.V[nn],D);
    R1[i]:=Hatch(d,b,p2);
    if R1[i] and InOtr(p2,P1.V[i],P1.V[nn]) then
    begin
      if EqualP(p2,P1.V[i]) then begin
        {窠 祭 ᮢ  設}
         bb:=true;
        if oc>0 then if I1[oc-1]=i then bb:=false;
        if bb then begin

        INC(oc);
        O[oc]:=p2;
        I1[oc]:=i;
        R1[i]:=true;
        R1[nn]:=false;
        end;
      end;
      if EqualP(p2,P1.V[nn]) then begin
        bb:=true;
        if oc>0 then if I1[oc-1]=nn then bb:=false;
        if bb then begin
        INC(oc);
        O[oc]:=p2;
        I1[oc]:=nn;
        R1[nn]:=true;
        R1[i]:=false;
        end;
      end;
      if not (EqualP(p2,P1.V[i]) or EqualP(p2,P1.V[nn])) then begin
        inc(oc);
        O[oc]:=p2;
        R1[nn]:=false;
        R1[i]:=false;

        if MoreE(Lin(p1.V[i],B),0) then begin
          I1[oc]:=i;
        end else I1[oc]:=nn;
      end;
    end else R1[i]:=false;
    end;
    if oc=2 then begin
      L2.C:=0;
      if not R1[I1[1]] then begin
        inc(L2.c);
        L2.V[L2.c]:=O[1];
      end;
      if I1[1]<P1.C then nn:=I1[1]+1 else nn:=1;

      dub:=true;
      if not (r[nn] and Equal(DistL(c,O[1])+DistL(b,P1.V[nn]),DistL(c,P1.V[nn]))) then dub:=false;

      if dub then begin
        i:=nn;
        while r[i] and (i<>i1[2]) do begin
          inc(L2.c);
          L2.v[L2.c]:=P1.V[i];
          r[i]:=false;
          inc(i);
          if i>P1.C then i:=1;
        end;
        if not R1[I1[2]] then begin
          inc(L2.C);
          L2.V[L2.C]:=O[2];
        end;
      end else begin
        nn:=nn-2;
        if nn=0 then nn:=P1.C;
        if nn=-1 then nn:=P1.C-1;
        i:=nn;
        while r[i] and (i<>i1[2]) do begin
          inc(L2.c);
          L2.v[L2.c]:=P1.V[i];
          r[i]:=false;
          dec(i);
          if i<1 then i:=P1.C;
        end;
        if not R1[I1[2]] then begin
          inc(L2.C);
          L2.V[L2.C]:=O[2];
        end;

      end;

    end;
  if L2.C>2 then AddPolygon(L2);
  oc:=0;

  for i:=1 to P1.C do begin
    if i<P1.C then begin
     nn:=i+1;
    end else begin
      nn:=1;
    end;
    GetLine(P1.V[i],P1.V[nn],D);
    R1[i]:=Hatch(d,c,p2);
    if R1[i] and InOtr(p2,P1.V[i],P1.V[nn]) then
    begin
      if EqualP(p2,P1.V[i]) then begin
        {窠 祭 ᮢ  設}
        bb:=true;
        if (oc>0) then if I1[oc-1]=i then bb:=false;
        if bb then begin

        INC(oc);
        O[oc]:=p2;
        I1[oc]:=i;
        R1[i]:=true;
        R1[nn]:=false;
        end;
      end;
      if EqualP(p2,P1.V[nn]) then begin
        bb:=true;
        if (oc>0) then if I1[oc-1]=nn then bb:=false;
        if bb then begin
        INC(oc);
        O[oc]:=p2;
        I1[oc]:=nn;
        R1[nn]:=true;
        R1[i]:=false;
        end;
      end;
      if not (EqualP(p2,P1.V[i]) or EqualP(p2,P1.V[nn])) then begin
        inc(oc);
        O[oc]:=p2;
        R1[nn]:=false;
        R1[i]:=false;

        if MoreE(Lin(p1.V[i],B),0) then begin
          I1[oc]:=i;
        end else I1[oc]:=nn;
      end;
    end else R1[i]:=false;
    end;
    if oc=2 then begin
      L2.C:=0;
      if not R1[I1[1]] then begin
        inc(L2.c);
        L2.V[L2.c]:=O[1];
      end;
      if I1[1]<P1.C then nn:=I1[1]+1 else nn:=1;
            dub:=true;
      if not (r[nn] and Equal(DistL(b,O[1])+DistL(c,P1.V[nn]),DistL(b,P1.V[nn]))) then dub:=false;

      if dub then begin
        i:=nn;
        while r[i] and (i<>i1[2]) do begin
          inc(L2.c);
          L2.v[L2.c]:=P1.V[i];
          r[i]:=false;
          inc(i);
          if i>P1.C then i:=1;
        end;
        if not R1[I1[2]] then begin
          inc(L2.C);
          L2.V[L2.C]:=O[2];
        end;
      end else begin
        nn:=nn-2;
        if nn=0 then nn:=P1.C;
        if nn=-1 then nn:=P1.C-1;
        i:=nn;
        while r[i] and (i<>i1[2]) do begin
          inc(L2.c);
          L2.v[L2.c]:=P1.V[i];
          r[i]:=false;
          dec(i);
          if i<1 then i:=P1.C;
        end;
        if not R1[I1[2]] then begin
          inc(L2.C);
          L2.V[L2.C]:=O[2];
        end;

      end;
    end;

    if L2.C>2 then AddPolygon(L2);
{    R2[i]:=Hatch(d,c,p3);
    if  R2[i] and InOtr(p3,P1.V[i],P1.V[nn]) then begin

    end else R2[i]:=false;}

end;
procedure Proceed(num:integer);
 var
 i,j,k:integer;
begin
  k:=PC;
  for i:=1 to 5 do G[i]^:=P[i]^;
  PC:=0;
  for i:=1 to K do begin
    Work(i,num);
  end;
end;
procedure FindPoint;
var i:integer;
P1:TPoint;
df:dd;
begin
  sos:=true;
  P1.x:=0;
  P1.y:=0;
  for i:=1 to P[1]^[1].C do begin
    P1.x:=P1.x+P[1]^[1].V[i].x;
    P1.y:=P1.y+P[1]^[1].V[i].y;
  end;
  P1.x:=P1.x/P[1]^[1].c;
  P1.y:=P1.y/P[1]^[1].c;
  POut:=P1;
  df:=DistL(Lines[1],P1);
  for i:=1 to 5 do Dispose(P[i]);
  for i:=1 to 5 do Dispose(G[i]);
end;
procedure Solve;
var i,j:integer;
begin
  for i:=1 to LC do Proceed(i);
  if PC>0 then FindPoint;
end;
begin
  Input;
  Solve;
  Print;
end.