#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>

typedef unsigned bool;

FILE *fin, *fout;

#define NMAX 80
bool fld[3][NMAX];
unsigned N;

bool was[3][NMAX];
#define MMAX 240
unsigned moves[MMAX], cmoves = 0;
unsigned best[MMAX], cbest = 0;
long bestsum = 0;

int dx[4] = {0, 1, 0, -1};
int dy[4] = {-1, 0, 1, 0};
char dc[4] = {'U', 'R', 'D', 'L'};


void out(const char *fmt, ...)
{
	va_list va;
    va_start(va, fmt);

    vfprintf(fout, fmt, va);
    //vprintf(fmt, va);

    va_end(va);
}

char *in()
{
	static char buf[256];
    fgets(buf, 256, fin);
    return buf;
}

void run();

void main()
{
	fin = fopen("class.in", "rt");
	fout = fopen("class.out", "wr");

    run();

    fclose(fin);
    fclose(fout);
}


void go(int ox, int oy, long sum)
{
    int x, y;
    unsigned mv = cmoves++;
    for( unsigned dir = 0; dir <= 3; ++dir )
	{
    	x = ox; y = oy;
        x += dx[dir];
        y += dy[dir];
        moves[mv] = dir;
        if( x >= 1 && x <= N && y >= 1 && y <= 3 )
    		if( !was[y - 1][x - 1] )
            {
            	was[y - 1][x - 1] = 1;
				go( x, y, sum * 2 + fld[y - 1][x - 1] );
                was[y - 1][x - 1] = 0;
            }

    }
    --cmoves;

	if( sum > bestsum )
	{
    	for( unsigned i = 0; i < cmoves; ++i )
        	best[i] = moves[i];
        bestsum = sum;
        cbest = cmoves;
    }
}



void run()
{
	char *s;
    unsigned i, j, n;
    s = in();
    sscanf(s, "%u", &N);
    for( i = 0; i < 3; ++i )
    {
	    s = in();
        for( j = 0; j < N; ++j )
        {
    		sscanf(s, "%u%n", &fld[i][j], &n);
            s += n;
        }
    }

    unsigned y0 = 1;
    was[0][0] = 1;
    go( 1, 1, 0 );
    long sum0 = bestsum;
    was[0][0] = 0;
    was[2][0] = 1;
    go( 1, 3, 0 );
    if( bestsum != sum0 ) y0 = 3;



    if( bestsum == 0 )
    	return;
    else
    {
		out( "%u\n", y0 );
        for( i = 0; i < cbest; ++i )
        	out("%c", dc[best[i]]);
        out("\n");
    }
}