#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>

FILE *fin, *fout;

unsigned L;
#define MAXN 100
unsigned N;
float coord[MAXN][4];
struct O
{
	float b, e;
};
O xo[105], yo[105];
unsigned cx, cy;


void out(const char *fmt, ...)
{
	va_list va;
    va_start(va, fmt);

    vfprintf(fout, fmt, va);
    //vprintf(fmt, va);

    va_end(va);
}

char *in()
{
	static char buf[10000];
    fgets(buf, 10000, fin);
    return buf;
}

void run();

void main()
{
	fin = fopen("fire.in", "rt");
	fout = fopen("fire.out", "wt");

    run();

    fclose(fin);
    fclose(fout);
}


template <class T>
inline void swap(T &a, T &b)
{
	T t = a;
    a = b;
    b = t;
}

unsigned betw(float v, float a, float b)
{
	return (v >= a && v <= b);
}


void run()
{
	char *s;
    unsigned i, j;
    s = in();
    sscanf(s, "%u", &L);
    s = in();
    sscanf(s, "%u", &N);
    for( i = 0; i < N; ++i )
    {
    	s = in();
    	sscanf(s, "%f %f %f %f", &coord[i][0], &coord[i][1], &coord[i][2], &coord[i][3]);
    }

    cx = cy = 1;
    xo[0].b = 0;
    xo[0].e = L;
    yo[0].b = 0;
    yo[0].e = L;

    float *c;
    float d, b, e;
    unsigned up;


    for( j = 0; j < N; ++j )
    {
		c = coord[j];
        if( c[0] == c[2] )
        {
        	d = c[0];
            b = d - 50;
            e = d + 50;

            up = cx;

            for( i = 0; i < up; ++i )
            {
            	if( betw(xo[i].b, b, e) )
                	if( betw(xo[i].e, b, e) )
                	{
                    	if(i < cx - 1)
                        	swap(xo[i], xo[cx-1]);
                        --cx;
                        --up;
                        if( cx == 0 )
                        {
                        	out("OK\n");
                            return;
                        }
                    }
                    else
                    	xo[i].b = e;
                else
                	if( betw(xo[i].e, b, e) )
                    	xo[i].e = b;
                	else
                    {
                    	if( betw(b, xo[i].b, xo[i].e) &&
                        	betw(e, xo[i].b, xo[i].e) )
                        {
                        	xo[cx].b = e;
                            xo[cx++].e = xo[i].e;
                            xo[i].e = b;
                        }

                    }
            }
        }
        else if (c[1] == c[3])
        {
        	d = c[1];
            b = d - 50;
            e = d + 50;

            up = cy;

            for( i = 0; i < up; ++i )
            {
            	if( betw(yo[i].b, b, e) )
                	if( betw(yo[i].e, b, e) )
                	{
                    	if(i < cy - 1)
                        	swap(yo[i], yo[cy-1]);
                        --cy;
                        --up;
                        if( cy == 0 )
                        {
                        	out("OK\n");
                            return;
                        }
                    }
                    else
                    	yo[i].b = e;
                else
                	if( betw(yo[i].e, b, e) )
                    	yo[i].e = b;
                	else
                    {
                    	if( betw(b, yo[i].b, yo[i].e) &&
                        	betw(e, yo[i].b, yo[i].e) )
                        {
                        	yo[cy].b = e;
                            yo[cy++].e = yo[i].e;
                            yo[i].e = b;
                        }

                    }
            }
        }
        else
        {
        	out("OK\n");
            return;
        }
    }


    float x, y;
    x = .5 * (xo[0].b + xo[0].e);
    y = .5 * (yo[0].b + yo[0].e);
    out("%f %f\n", x, y);
}