#include <process.h>
#include <fstream.h>
#include <math.h>

const float eps=0.0001;
const float deps=0.01;
const float unl=pow10(38);
const float dxy=0.003;
float ax[200];
float ay[200];
float Dx[200];
float Dy[200];
int xpos;
int ypos;
float L;
int N;

void delint(float* src,int *srcl,int pos)
	{
	for (int i=2*pos;i<(*srcl)*2;i++)
		{
		src[i]=src[i+2];
		}
	*srcl--;
	}
void addint(float*src, int *srcl, int a1, int a2, int pos)
	{
	for (int i=(*srcl)*2+1;i>2*pos;i--)
		{
		src[i]=src[i-2];
		}
	src[2*pos+1]=a1;
	src[2*pos+2]=a2;
	(*srcl)++;

	}


int Makey()
	{
	for (int i=0;i<N;i++)
		{
		if (fabs(ay[2*i])<eps && fabs(ay[2*i+1])<eps ) continue;


		for (int j=0;j<ypos;j++)
			{
			if (Dy[2*j]>ay[2*i] && Dy[2*j+1]<ay[2*i+1]) {delint(Dy,&ypos,j);j=0-1;continue;}
			if (Dy[2*j]<=ay[2*i] && Dy[2*j+1]>=2*j+ay[2*i+1]) {addint(Dy,&ypos,ay[2*i],ay[2*i+1],j);j=-1;continue;}

			if (Dy[2*j]>ay[2*i] && Dy[2*j+1]>ay[2*i]) Dy[2*j+1]=ay[2*i];
			if (Dy[2*j]>ay[2*i+1] && Dy[2*j+1]>ay[2*i+1]) Dy[2*j]=ay[2*i+1];







			}


		}

return +1;
	}
int Makex()
	{
	for (int i=0;i<N;i++)
		{
		if (fabs(ax[2*i])<eps && fabs(ax[2*i+1])<eps ) continue;


		for (int j=0;j<xpos;j++)
			{
			if (Dx[2*j]>ax[2*i] && Dx[2*j+1]<ax[2*i+1]) {delint(Dx,&xpos,j);j=0-1;continue;}
			if (Dx[2*j]<=ax[2*i] && Dx[2*j+1]>=2*j+ax[2*i+1]) {addint(Dx,&xpos,ax[2*i],ax[2*i+1],j);j=-1;continue;}

			if (Dx[2*j]>ax[2*i] && Dx[2*j+1]>ax[2*i]) Dx[2*j+1]=ax[2*i+1];
			if (Dx[2*j]>ax[2*i+1] && Dx[2*j+1]>ax[2*i+1]) Dx[2*j]=ax[2*i];







			}


		}

return +1;
	}


void main(void)
	{
	ifstream file("fire.in");
	file >> L;
	file >> N;
	for (int i=0;i<N;i++)
		{
		float x0,x1,y0,y1;
		file >> x0;
		file >> y0;
		file >> x1;
		file >> y1;
		float dx=x0-x1;
		float dy=y0-y1;
		if (fabs(dx)>deps && fabs(dy)>deps)
				{

				file.close();
				ofstream out("fire.out");
				out<<"OK";
				out.close();
				exit(1);
				}
		if (fabs(dy)<eps)
				{
				ay[2*i]=y1-50;
				ay[2*i+1]=y1+50;
				ax[2*i]=0;
				ax[2*i+1]=0;
				}
		if (fabs(dx)<eps)
				{
				ax[2*i]=x1-50;
				ax[2*i+1]=x1+50;
				ay[2*i]=0;
				ay[2*i+1]=0;
				}
		}
Dx[0]=0;
Dx[1]=L;
Dy[0]=0;
Dy[1]=L;
xpos=1;
ypos=1;
Makex();
Makey();
			     float xx=-1;
for (int x=0;x<xpos*2;x+=2)
	{
	if(Dx[x]!=Dx[x+1]) xx=(Dx[0]+Dx[1])/2.;
	}
if (xx==-1) xpos=0;
float yy=-1;
for (int y=0;y<ypos*2;y+=2)
	{
	if(Dy[y]<Dy[y+1]) yy=(Dy[0]+Dy[1])/2.;
	}
if (yy==-1) ypos=0;


ofstream out("fire.out");
if (xpos==0 || ypos==0)
		{
		out << "OK";
		out.close();
		exit(1);
		}
out << xx << " " << yy;
out.close();




	}


