{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}
Program Opposition;
Const
  InFile='ORG.IN';
  OutFile='ORG.OUT';
  MaxK=10002;
  MaxN=10002;
Var
  K,N:Word;
  Parent:Array[1..MaxN]Of Word;
  Result:LongInt;
  ResSeq:Array[1..MaxN]Of Word;
  Weight:Array[1..MaxN]Of Word;
Procedure Load;
Var
  I:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(K);
  If Not SeekEOF Then Read(N);
  Parent[1]:=0;
  For I:=2 To N Do If Not SeekEOF Then Read(Parent[I]);
  Close(Input);
End;
Procedure Solve;
Var
  I,J:LongInt;
Begin
  Result:=0;
  For I:=1 To N Do Weight[I]:=1;
  For I:=N DownTo 1 Do Begin
    If Weight[I]>=K Then Begin
      Inc(Result);
      ResSeq[Result]:=I;
      Weight[I]:=0;
    End Else If I>1 Then Inc(Weight[Parent[I]],Weight[I]);
  End;
End;
Procedure Save;
Var
  I:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Result);
  For I:=1 To Result Do Begin
    If I>1 Then Write(' ');
    Write(ResSeq[I]);
  End;
  WriteLn;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.