{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}
Program Telemetry;
Const
  InFile='TELE.IN';
  OutFile='TELE.OUT';
  MaxN=1002;
  MaxSeq=10002;
  Step:Array[-1..1]Of Char='- +';
Type
  TSeq=Array[1..MaxSeq]Of Record
    What:Word;
    By:ShortInt;
  End;
Var
  N:LongInt;
  P:Array[1..MaxN]Of LongInt;
  Src:Array[1..MaxN]Of LongInt;
  Ps:Array[1..MaxN]Of LongInt;
  Used:Array[1..MaxN]Of Boolean;
  Seq,Seq2:^TSeq;
  NSeq,NSeq2:LongInt;
  Left:LongInt;
Procedure Load;
Var
  I:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do If Not SeekEOF Then Read(P[I]);
  For I:=1 To N Do If Not SeekEOF Then Read(Src[I]);
  Close(Input);
End;
Function FindAnyOdd:LongInt;
Var
  I:LongInt;
Begin
  For I:=1 To N Do If Odd(P[I]) And Not Used[I] Then Begin FindAnyOdd:=I; Exit; End;
  FindAnyOdd:=0;
End;
Function FindAnyEven:LongInt;
Var
  I:LongInt;
Begin
  For I:=1 To N Do If Not Odd(P[I]) And Not Used[I] Then Begin FindAnyEven:=I; Exit; End;
  FindAnyEven:=0;
End;
Function FindAny:LongInt;
Var
  Tmp:LongInt;
Begin
  Tmp:=FindAnyOdd;
  If Tmp=0 Then
    Tmp:=FindAnyEven;
  FindAny:=Tmp;
End;
Procedure FindHam(From:LongInt);
Var
  I,J,K,L:LongInt;
Procedure Push(What:LongInt; By:LongInt);
Begin
  Inc(NSeq2);
  Seq2^[NSeq2].What:=What;
  Seq2^[NSeq2].By:=By;
End;
Begin
  If Left=2 Then Begin
    NSeq2:=0;
    J:=FindAnyEven;
    Used[J]:=True;
    K:=FindAny;
    Used[J]:=False;
    Push(K,1);
    For I:=1 To P[J] Do Begin
      If Odd(I) Then
        For L:=2 To P[K]-1 Do Push(K,1)
      Else
        For L:=P[K]-1 DownTo 2 Do Push(K,-1);
      If I<P[J] Then Push(J,1);
    End;
    Push(K,-1);
    For I:=P[J]-1 DownTo 1 Do Push(J,-1);
    Move(Seq2^,Seq^,SizeOf(Seq^));
    NSeq:=NSeq2;
    Exit;
  End;
  Used[From]:=True;
  Dec(Left);
  I:=FindAny;
  FindHam(I);
  NSeq2:=0;
  Push(Seq^[1].What,Seq^[1].By);
  For I:=1 To P[From] Do Begin
    If Odd(I) Then
      For J:=2 To NSeq-1 Do Push(Seq^[J].What,Seq^[J].By)
    Else
      For J:=NSeq-1 DownTo 2 Do Push(Seq^[J].What,-Seq^[J].By);
    If I<P[From] Then Push(From,1);
  End;
  If Odd(P[From]) Then Begin
    Push(Seq^[NSeq].What,Seq^[NSeq].By);
  End Else Begin
    Push(Seq^[1].What,-Seq^[1].By);
  End;
  For I:=P[From] DownTo 2 Do
    Push(From,-1);
  Move(Seq2^,Seq^,SizeOf(Seq^));
  NSeq:=NSeq2;
  Used[From]:=False;
  Inc(Left);
End;
Procedure Solve;
Var
  I,J:LongInt;
  Ok:Boolean;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  FillChar(Used,SizeOf(Used),False);
  Left:=N;
  For I:=1 To N Do If P[I]=1 Then Begin
    Used[I]:=True;
    Dec(Left);
  End;
  If Left=1 Then Begin
    I:=FindAny;
    If P[I]=2 Then Begin
      WriteLn('Yes');
      If Src[I]=1 Then Begin
        WriteLn(I,' +');
        WriteLn(I,' -');
      End Else Begin
        WriteLn(I,' -');
        WriteLn(I,' +');
      End;
    End Else WriteLn('No');
    Exit;
  End;
  If FindAnyEven=0 Then Begin
    If Left>0 Then
      WriteLn('No')
    Else
      WriteLn('Yes');
    Close(Output);
    Exit;
  End;
  WriteLn('Yes');
  NSeq:=0;
  New(Seq);
  New(Seq2);
  I:=FindAny;
  FindHam(I);
  For I:=1 To N Do Ps[I]:=1;
  For I:=1 To NSeq Do Begin
    Ps[Seq^[I].What]:=Ps[Seq^[I].What]+Seq^[I].By;
    Ok:=True;
    For J:=1 To N Do If Ps[J]<>Src[J] Then Begin Ok:=False; Break; End;
    If Ok Then Break;
  End;
  For J:=I+1 To NSeq Do WriteLn(Seq^[J].What,' ',Step[Seq^[J].By]);
  For J:=1 To I Do WriteLn(Seq^[J].What,' ',Step[Seq^[J].By]);
  Close(Output);
End;
Begin
  Load;
  Solve;
End.