{XIII ᨩ᪠  쭨  ଠ⨪}
{ ⠭⨭, . ஢}
{  4, ᭮ }

{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}

Program Task_4;

Const
 Inp='fire.in';
 Outp='fire.out';
 MaxN=100;
 MaxL=1000;
 Eps=1e-11;

Type
  Real=Extended;
  TFly=Record X1, Y1, X2, Y2: Real End;

Var
 N, L: Word;
 A: Array [1..MaxN] of TFly;

Function More(Const A, B: Real):Boolean;
 Begin
  More:=(A-B) > -Eps;
 End;

Procedure Swap(Var A, B: Real);
 Var Tmp: Real;
 Begin
  Tmp:=A;
  A:=B;
  B:=Tmp;
 End;


Function See(X, Y: Real; F: TFly): Boolean;
 Var S, L: Real;
 Begin
  with F do Begin
   S:=Abs(X1*(Y2-Y) + X2*(Y-Y1) + X*(Y1-Y2));
   L:=Sqrt((X1-X2)*(X1-X2) + (Y1-Y2)*(Y1-Y2));
   if L > Eps then begin
    L:=S/L;
    See:=More(50, L);
   end else begin
    L:=Sqrt((X1-X)*(X1-X) + (Y1-Y)*(Y1-Y));
    See:=More(50, L);
   end;
  end;
 End;

Procedure Init;
 Var i: word;
 Begin
  Assign(Input, Inp);
  Assign(Output, Outp);
  Reset(Input);
  Rewrite(Output);
  Read(L);
  Read(N);
  For i:=1 to N do
   With A[i] do
    Read(X1, Y1, X2, Y2);
 end;


Procedure Done;
 Begin
  Close(Input);
  Close(Output);
 end;

Procedure Ok;
 Begin
  WriteLn('OK');
  Done;
  Halt(0);
 End;

Procedure No(X, Y: Real);
 Begin
  WriteLn(X, ' ', Y);
  Done;
  Halt(0);
 End;

Procedure Solve;


 Procedure Find(X1, Y1, X2, Y2: Real);
  Var X3, Y3: Real;
      i: Word;
      Ok, Need: Boolean;
  Begin
   X3:=(X1+X2)/2;
   Y3:=(Y1+Y2)/2;

   Ok:=False;
   Need:=True;
   For i:=1 to N do begin
    Ok:=Ok or See(X3, Y3, A[i]);
    if See(X1, Y1, A[i]) And See(X2, Y2, A[i]) and
       See(X1, Y2, A[i]) And See(X2, Y1, A[i]) then
     Need:=False;
   end;

   if Not Ok Then
    No(X3, Y3);

   if Need Then begin
    Find(X1, Y1, X3, Y3);
    Find(X1, Y3, X3, Y2);
    Find(X3, Y3, X2, Y2);
    Find(X3, Y1, X2, Y3);
   End;

  end;

 Begin
  Find(0, 0, L, L);
  Ok;
 end;


Begin
 Init;
 Solve;
End.