#define MAX				10100

#include <stdio.h>
#include <mem.h>


void input ();
void solve ();
void output ();


int ans = 0, off [MAX], parent [MAX], n, k, ptr = 1, summa [MAX], huge stack [MAX + MAX + MAX];


main ()
 {
	input ();
	solve ();
	output ();

	return (0);
 }


void input ()
 {
	FILE * file = fopen ("org.in", "r");
	fscanf (file, "%d %d", & k, & n);

	for (int i = 0; i < n - 1; i ++)
	 {
		fscanf (file, "%d", & parent [i + 1]);
		parent [i + 1] --; summa [i] = 1;
	 }

	summa [n - 1] = 1;

	fclose (file);
 }


void solve ()
 {
	int vertex;

	stack [0] = 1;

	while (ptr)
	 {
		if (stack [ptr - 1] > 0)
		 {
		  vertex = stack [ptr - 1] - 1;
		  stack [ptr - 1]	= -stack [ptr - 1];

		 for (int i = 1; i < n; i ++)
		  if (parent [i] == vertex)
			stack [ptr ++] = i + 1;
		 }
		else
		 {
			vertex = -stack [-- ptr] - 1;

		  if (summa [vertex] >= k)
			off [vertex] = 1, ans ++;
		  else
			{
			  off [vertex] = 0;

			  if (vertex)
				summa [parent [vertex]] += summa [vertex];
			}
		 }
	 }
 }


void output ()
 {
	FILE * file = fopen ("org.out", "w");
	fprintf (file, "%d\n", ans);

	for (int i = 0; i < n; i ++)
	 if (off [i])
	  fprintf (file, "%d ", i + 1);

	fclose (file);
 }
