{ : 1115; : 5; }
{ 宦 ᯮᮡ ᯠᥭ   㢥ୠ⪨. }
program P1115_5;

const
  INPUT_FILE_NAME = 'castle.in';
  OUTPUT_FILE_NAME = 'castle.out';

type
  TRoom = record
    Size: Word;
    Connect: Pointer;
  end;
  TArr = array [1..1000] of Integer;
  PWay = ^TWay;
  TWay = record
    Room: Integer;
    Next: PWay;
  end;

var
  InOutFile: Text;
  Castle, Disabled: array [0..1000] of TRoom;
  OldC, OldD: Pointer;
  N, K, Counter, Count, Num, Steps, LatestSt: Integer;
  Yes: Boolean;
  Way, LastRoom, LatestRoom: PWay;

function GetSize(Room: Integer): Integer;
begin
  GetSize:= Castle[Room].Size shr 1;
end;

function GetConnection(Room, Index: Integer): Integer;
begin
  GetConnection:= Integer(Pointer(Longint(Castle[Room].Connect) + Index*2)^);
end;

function GetDisabled(Room, Index: Integer): Integer;
begin
  GetDisabled:= Integer(Pointer(Longint(Disabled[Room].Connect) + Index*2)^);
end;
procedure SetDisabled(Room, Index, Dis: Integer);
var
  R1, I1: Integer;
begin
  Integer(Pointer(Longint(Disabled[Room].Connect) + Index*2)^):= Dis;
  R1:= GetConnection(Room, Index);

  for I1:= 0 to GetSize(R1) - 2 do
  begin
    if GetConnection(R1, I1) = Room then
      Integer(Pointer(Longint(Disabled[R1].Connect) + I1*2)^):= Dis;
  end;
end;

function FindWay(A, B: Integer; Way1: PWay): Boolean;
var
  C: Integer;
begin
  if A = B then
  begin
    FindWay:= True;
    Way1^.Room:= A;
    Way1^.Next:= nil;
    LastRoom:= Way1;
    Exit;
  end;

  New(Way1^.Next);
  for C:= 0 to GetSize(A) - 2 do
  begin
    if GetDisabled(A, C) <> 1 then
    begin
      SetDisabled(A, C, 1);
      if FindWay(GetConnection(A, C), B, Way1^.Next) then
      begin
        FindWay:= True;
        Way1^.Room:= A;
        Inc(Steps);
        Exit;
      end;
      SetDisabled(A, C, 0);
    end;
  end;
  Dispose(Way1^.Next); Way1^.Next:= nil;
  FindWay:= False;
end;

procedure MakeCycle;
var
  C: Integer;
begin
  for C:= 0 to GetSize(Counter) - 2 do
  begin
    if GetDisabled(Counter, C) <> 1 then
    begin
      SetDisabled(Counter, C, 1);
      New(LastRoom^.Next);
      if not FindWay(GetConnection(Counter, C), Counter, LastRoom^.Next) then
      begin
        SetDisabled(Counter, C, 0);
        Dispose(LastRoom^.Next);
      end else Inc(Steps);
    end;
  end;
  LatestRoom:= LastRoom;
  LatestSt:= Counter;
end;

begin
  {  室 䠩: }
  Assign(InOutFile, INPUT_FILE_NAME);
  Reset(InOutFile);

  Read(InOutFile, N);
  Read(InOutFile, K);

  for Counter:= 1 to N do
  begin
    repeat
      Read(InOutFile, Num);
      GetMem(OldC, Castle[Counter].Size + 1);
      GetMem(OldD, Castle[Counter].Size + 1);
      if Castle[Counter].Connect <> nil then
      begin
        Move(Castle[Counter].Connect^, OldC^, Castle[Counter].Size);
        FreeMem(Castle[Counter].Connect, Castle[Counter].Size);
        Move(Disabled[Counter].Connect^, OldD^, Castle[Counter].Size);
        FreeMem(Disabled[Counter].Connect, Castle[Counter].Size);
      end;
      GetMem(Castle[Counter].Connect, Castle[Counter].Size + SizeOf(Integer));
      Move(OldC^, Castle[Counter].Connect^, Castle[Counter].Size);
      GetMem(Disabled[Counter].Connect, Castle[Counter].Size + SizeOf(Integer));
      Move(OldD^, Disabled[Counter].Connect^, Castle[Counter].Size);
      FreeMem(OldC, Castle[Counter].Size + 1);
      FreeMem(OldD, Castle[Counter].Size + 1);

      Integer(Pointer(Longint(Castle[Counter].Connect) + Castle[Counter].Size)^):=
        Num;
      Integer(Pointer(Longint(Disabled[Counter].Connect) + Castle[Counter].Size)^):=
        0;
      Inc(Castle[Counter].Size, SizeOf(Integer));
    until Num = 0;
  end;

  {  室 䠩: }
  Close(InOutFile);
  Yes:= False;

  New(Way);
  LatestRoom:= Way;
  LatestSt:= K;
  for Counter:= 1 to N do
  begin
    if GetSize(Counter) mod 2 = 0 then
    begin
      if Counter <> LatestSt then
      begin
        New(LatestRoom^.Next);
        if FindWay(LatestSt, Counter, LatestRoom^.Next) then
        begin
          Yes:= True;
          MakeCycle;
        end else begin Dispose(LatestRoom^.Next); LatestRoom^.Next:= nil; end;
      end;
    end;
  end;

  {  室 䠩: }
  Assign(InOutFile, OUTPUT_FILE_NAME);
  Rewrite(InOutFile);


  if Yes then
  begin
    WriteLn(InOutFile, 'Yes');
    WriteLn(InOutFile, Steps);
    LastRoom:= Way^.Next;
    Dispose(Way);
    Way:= LastRoom;
    while Way <> nil do
    begin
      Write(InOutFile, Way^.Room, ' ');
      LastRoom:= Way^.Next;
      Dispose(Way);
      Way:= LastRoom;
    end;
  end
  else
  begin
    WriteLn(InOutFile, 'No');
  end;

  { ࠭ 室 䠩: }
  Close(InOutFile);
  for Counter:= 1 to N do
  begin
    FreeMem(Castle[Counter].Connect, Castle[Counter].Size);
    FreeMem(Disabled[Counter].Connect, Castle[Counter].Size);
  end;
end.