#include <stdlib.h>
#include <stdio.h>
#include <Fstream.h>
#include <math.h>
#include <dos.h>
#include <string.h>

/*  very crappy algorithm */

typedef struct
{
  float x,y;
}Point;

class CLine
{
 public:
   CLine()
     { ye=xe=ys=xs=0; vert=0; }
   ~CLine()
     {  }
   void set(int x1, int y1, int x2, int y2)
   {
     xs = x1; ys = y1;
     xe = x2; ye = y2;
   }
   void precalc()
   {
      if (xs-xe)
      {
	vert = 0;
	k = (float)(ye-ys)/(float)(xe-xs);
	b = ys-k*xs;
      }else vert = 1;
   }
   float dist(Point p)
   {
      float d2;
      if(vert)
      {
	d2 = abs(xs-p.x);
      }else
      if (k==0)
      {
	d2 = abs(ys-p.y);
      }else
      {
	float b2 = p.y+1/k*p.x;           // normal
	float xcr = (b2-b)/(k+1/k)  -p.x; // cross - p
	float ycr = k*xcr+b  -p.y;
	d2 = sqrt(xcr*xcr+ ycr*ycr);
      }
      return d2;
   }
 public:
   int xs, ys, xe, ye;
   char vert;
   float k, b;
};

int N, L;

CLine * wayz;
long far* mtimer;
long start, timeOut;
char timeok = 1;
float mind = 1e7;
Point mpf;

unsigned int seed;

void msrand(long x)
{
  seed = x;
}

float mrand(float max)
{
  seed = (((seed*97)>>1)+23573)*5;
  return ((float)seed)/65535.0*max;
}

void init()
{
   ifstream infile("fire.in");
   infile>>L;
   infile>>N;
   wayz = new CLine[N];
   for (int i=0;i<N;i++)
   {
     float a,b,c,d;
     infile >> a;
     infile >> b;
     infile >> c;
     infile >> d;
     wayz[i].set(a,b,c,d);
     wayz[i].precalc();
   }
   mtimer = (long far *)(0x0000046c);
   start = *mtimer;
   msrand(((long)N)*L);
   timeOut = 5*18-4;
}

void solve()
{
  Point test = {1000, 1000};
  while(test.x>L || test.y>L)
  {
    test.x = mrand(L);
    test.y = mrand(L);
  }
  mind = 1e7;
  for (int i=0;i<N;i++)
  {
    float d = wayz[i].dist(test);
    if (d<mind) mind = d;
  }
  if (mind>50)
    {
      timeok = 0;
      mpf = test;
      mind = 0;
    }
  if ((*mtimer)-start>timeOut)
  {
    timeok = 0;
    mind = 1e5;
  }
}

void done()
{            
  FILE *f = fopen("fire.out", "wt");
  char b[64];
  if (mind == 1e5)
  {
     fprintf(f, "OK");
  }
  if (mind<50)
  {
     sprintf(b, "%.3f %.3f", mpf.x, mpf.y);
     fwrite(b, strlen(b), 1, f);
  }
  fclose(f);

  delete [] wayz;
}

int main()
{
   init();
   while (timeok)
      solve();
   done();

   return 0;
}