const maxLong=100;

type tLong=array[1..maxLong]of shortInt;
tmoveType=(upToDown,downToUp);
var n,i,j:integer;
rubl:array[1..81,1..3]of integer;
din:array[1..3,0..81]of
  record
    x1:integer;
    start:integer;
    cost:tLong;
  end;
fin,fout:text;
procedure longDouble(var l:tLong);
var i:integer;
begin
  for i:=1 to maxLong do
    l[i]:=l[i]+l[i];
  for i:=1 to maxLong-1 do
    begin
      l[i+1]:=l[i+1]+l[i]div 10;
      l[i]:=l[i] mod 10;
    end;
end;
procedure longInc(var l:tLong);
var i:integer;
begin
  l[1]:=l[1]+1;
  for i:=1 to maxLong-1 do
    begin
      l[i+1]:=l[i+1]+l[i]div 10;
      l[i]:=l[i] mod 10;
    end;
end;
function longCmp(l1,l2:tLong):integer;
var i:integer;
begin
  longCmp:=0;
  for i:=maxLong downto 1 do
    case l1[i]-l2[i] of
      1..100:
        begin
          longCmp:=1;exit;
        end;
      -100..-1:
        begin
          longCmp:=-1;exit;
        end;
    end;
end;
procedure longInit(var l:tLong;n:integer);
var i:integer;
begin
  for i:=1 to maxLong do
    l[i]:=0;
  for i:=1 to n do
    longInc(l);
end;
procedure walkWay(var l:tLong;x1,x2:integer;start,finish:integer;var st:string);
var i,j:integer;
begin
  st:='';
  case start*10+finish of
    13:
      begin
       for i:=x1 to x2 do
         begin
           longDouble(l);
           if rubl[i,1]=1 then longInc(l);
           st:=st+'R';
         end;
         st[length(st)]:='D';
         for i:=x2 downto x1 do
           begin
             longDouble(l);
             if rubl[i,2]=1 then longInc(l);
             st:=st+'L';
           end;
         st[length(st)]:='D';
         for i:=x1 to x2 do
           begin
             longDouble(l);
             if rubl[i,3]=1 then longInc(l);
             st:=st+'R';
           end;
      end;
    31:
      begin
       for i:=x1 to x2 do
         begin
           longDouble(l);
           if rubl[i,3]=1 then longInc(l);
           st:=st+'R';
         end;
         st[length(st)]:='U';
         for i:=x2 downto x1 do
           begin
             longDouble(l);
             if rubl[i,2]=1 then longInc(l);
             st:=st+'L';
           end;
         st[length(st)]:='U';
         for i:=x1 to x2 do
           begin
             longDouble(l);
             if rubl[i,1]=1 then longInc(l);
             st:=st+'R';
           end;
      end;
  end;
end;
procedure filldin;
var i,j,maxi:integer;
max,cur:tLong;
st,stTmp:string;
flagChar:string;
leftCost:tLong;
prevJ:integer;
begin
  st:='';
{  flagChar:='';
  longInit(leftCost,0);
  while (rubl[i,1]+rubl[i,3]=0)or(n=0) do
    begin
      n:=n-1;
      longDouble(leftCost);
      if rubl[1,2]=1 then longInc(leftCost);
      flagChar:=flagChar+'R';
      for i:=1 to n do
        begin
          rubl[i,1]:=rubl[i+1,1];
          rubl[i,2]:=rubl[i+1,2];
          rubl[i,3]:=rubl[i+1,3];
        end;
    end;}
{  flagStr:='';}
  for i:=1 to 3 do
    with din[i,0] do
      begin
        longInit(cost,0);start:=i;
      end;
  for i:=1 to maxLong do
    din[2,0].cost[i]:=9;
  for i:=1 to n do
    begin
      longInit(max,0);
      for j:=0 to i-1 do
        begin
          cur:=din[3,j].cost;
          walkWay(cur,j+1,i,din[3,j].start,1,stTmp);
          if longCmp(max,cur)=-1 then
            begin
              max:=cur;
              din[1,i].cost:=max;
              din[1,i].x1:=j+1;
              din[1,i].start:=3;
            end;
        end;
      longInit(max,0);
      for j:=0 to i-1 do
        begin
          cur:=din[1,j].cost;
          walkWay(cur,j+1,i,din[1,j].start,3,stTmp);
          if longCmp(max,cur)=-1 then
            begin
              max:=cur;
              din[3,i].cost:=max;
              din[3,i].x1:=j+1;
              din[3,i].start:=1;
            end;
        end;
    end;
  maxi:=1;
  for i:=2 to 3 do
    if longCmp(din[maxi,n].cost,din[i,n].cost)=-1 then
      maxi:=i;
  i:=maxi;
  j:=n;
  while j<>0 do
    begin
      walkWay(max,din[i,j].x1,j,din[i,j].start,i,stTmp);
      st:=stTmp+st;
      maxi:=i;
      i:=din[i,j].start;
      j:=din[maxi,j].x1-1;
    end;
  writeln(fout,i);
  writeln(fout,copy(st,1,length(st)-1));
end;
begin
  assign(fin,'class.in');
  reset(fin);
  readln(fin,n);
  for j:=1 to 3 do
    begin
      for i:=1 to n do read(fin,rubl[i,j]);
      readln(fin);
    end;
  assign(fout,'class.out');
  rewrite(fout);
  fillDin;
  close(fout);
end.



