{       (C) 2001, 쥢 . . ( 146, . ).  1.  2.      }
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program         P1405_2;

type
  TM            = array[2..10000] of Integer;

var
  N, K          : Integer;
  Master        : ^TM;
  DCC, TCC      : array[1..10000] of Integer;
  TT            : Word;
  S             : array[1..2500] of Integer;

procedure       OpenFiles;
begin
  Assign(Input, 'ORG.IN');
  Reset(Input);
  Assign(Output, 'ORG.OUT');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : Integer;
begin
  ReadLn(K);
  ReadLn(N);
  if N > 1 then
    for I := 2 to N do
      Read(Master^[I]);
  ReadLn;
end;

function        SpecialCases: Boolean;
begin
  if N = 1 then begin
    if K = 1 then begin
      WriteLn(1);
      WriteLn(1);
    end else begin
      WriteLn(0);
      WriteLn;
    end;
    SpecialCases := True
  end else
    SpecialCases := False;
end;

function        IsChild(A, B: Integer): Boolean;
begin
  IsChild := Master^[A] = B;
end;

procedure       BuildTCC(L: Integer);
var
  I             : Integer;
begin
  TCC[L] := 0;
  if N <> L then
    for I := L to N do
      if Master^[I] = L then
        Inc(TCC[L], 1 + TCC[I]);
end;

procedure       RebuildTCC;
var
  I             : Integer;
begin
  for I := N downto 1 do
    BuildTCC(I);
end;

procedure       Go(X: Integer);
var
  I             : Integer;
begin
  while TCC[X] > K do begin
    for I := X to N do
      if Master^[I] = X then
        Go(I);
  end;
  if (TCC[X] = K) or (TCC[X] = K - 1) then begin
    Inc(TT);
    S[TT] := X;
    Master^[X] := 0;
    for I := X to N do
      if Master^[I] = X then
        Master^[I] := 0;
    RebuildTCC;
  end;
end;

procedure       Solve;
var
  I, J          : Integer;
begin
  if SpecialCases then
    Exit;
  for I := 1 to N do begin
    DCC[I] := 0;
    for J := 2 to N do
      if Master^[J] = I then
        Inc(DCC[I]);
  end;
  RebuildTCC;
  TT := 0;
  Go(1);
  WriteLn(TT);
  if TT <> 0 then begin
    if TT > 1 then
      for I := 1 to TT - 1 do
        Write(S[I], ' ');
      WriteLn(S[TT]);
  end else
    WriteLn;
end;

begin
  New(Master);
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
  Dispose(Master);
end.