{       (C) 2001, 쥢 . . ( 146, . ).  2.  5.      }
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program         P1405_5;

type
  TDoor         = record
    F, T        : Integer;
    Closed      : Boolean;
  end;

var
  N, SR         : Integer;
  Door          : array[1..5000] of TDoor;
  DS            : array[1..1000] of Integer;
  DC            : Integer;
  C             : array[1..1000] of Integer;
  CC, DD        : Integer;
  U             : array[1..1000] of Boolean;

procedure       OpenFiles;
begin
  Assign(Input, 'CASTLE.IN');
  Reset(Input);
  Assign(Output, 'CASTLE.OUT');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I, J, K       : Integer;
begin
  FillChar(DS, SizeOf(DS), 0);
  ReadLn(N);
  ReadLn(SR);
  DC := 0;
  for I := 1 to N do begin
    repeat
      Read(K);
      if K = 0 then
        Break;
      Inc(DC);
      if DS[I] = 0 then
        DS[I] := DC;
      Door[DC].F := I;
      Door[DC].T := K;
      Door[DC].Closed := False;
    until False;
  end;
  DS[N + 1] := DC + 1;
end;

procedure       ToggleDoor(L, V: Integer);
var
  I             : Integer;
begin
  for I := 1 to DC do
    if ((Door[I].F = L) and (Door[I].T = V)) or ((Door[I].F = V) and (Door[I].T = L)) then
      Door[I].Closed := not Door[I].Closed;
end;

function        CanGo(V, L: Integer): Boolean;
var
  I             : Integer;
begin
  for I := DS[V] to DS[V + 1] do
    if (Door[I].F = V) and (Door[I].T = L) and not Door[I].Closed then begin
      CanGo := True;
      Exit;
    end;
  CanGo := False;
end;

function        Acc(V, L: Integer): Boolean;
var
  I             : Integer;
begin
  if U[V] then
    Exit;
  U[V] := True;
  Acc := False;
  for I := 1 to N do
    if CanGo(V, I) then
      if I = L then begin
        Acc := True;
        Exit;
      end else begin
        if Acc(I, L) then begin
          Acc := True;
          Exit;
        end;
      end;
end;

procedure       Rec(V, L: Integer);
var
  I             : Integer;
begin
  Inc(CC);
  C[CC] := V;
  if L <> 0 then begin
    ToggleDoor(L, V);
    Inc(DD);
  end;
  FillChar(U, SizeOf(U), 0);
  if V <> SR then
    if not Acc(SR, V) then begin
      WriteLn('Yes');
      WriteLn(DD);
      for I := 1 to CC - 1 do
        Write(C[I], ' ');
      WriteLn(C[CC]);
      CloseFiles;
      Halt;
    end;
  for I := 1 to N do
    if CanGo(V, I) then
      Rec(I, V);
  if L <> 0 then begin
    ToggleDoor(L, V);
    Dec(DD);
  end;
  Dec(CC);
end;

procedure       Solve;
var
  I, J          : Integer;
begin
  DD := 0;
  Rec(SR, 0);
  WriteLn('No');
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.