{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
program P2606_5;

uses crt;

{type
  TGraf = Array [0..0, 0..0] of Byte;
  PGraf = ^TGraf;
}
const
  M = 146;
  EndFlag : Boolean = False;
  EndFlagR : Boolean = False;

var
  i, j : Word;
  N, K, B : Word;
  Graf : Array [1..M, 1..M] of Byte;
  Room : Word;
  Rooms, RoomsR : Array [1..M] of Word;
  OldRooms, OldRoomsR : Array [1..M, 1..M] of Boolean;
  R1, R2, R1R, R2R : Word;
  RoomCount, RoomCountR : Word;
  P : Pointer;
  AnsStr : String;

function GetNextRoom (X : Word) : Word;
var
  i, j : Word;
begin
  j := N + 1;
  for i := 1 to N do
    if (Graf [i, X] = 1) and (OldRooms [i, X] = False) then begin
      j := i;
      Break;
    end;
  if j < N + 1 then begin
    OldRooms [j, X] := True;
    Inc (RoomCount);
    Rooms [RoomCount] := j;
    GetNextRoom := j;
    Graf [j, X] := 0;
    Graf [X, j] := 0;
  end
  else begin
    Dec (RoomCount);
    if RoomCount = 0 then
      EndFlag := True
    else begin
      j := Rooms [RoomCount];
      Graf [X, j] := 1;
      Graf [j, X] := 1;
      GetNextRoom := j;
    end;
  end;
end;

function GetNextRoomR (X : Word) : Word;
var
  i, j : Word;
begin
  j := N + 1;
  for i := 1 to N do
    if (Graf [i, X] = 1) and (OldRoomsR [i, X] = False) then begin
      j := i;
      Break;
    end;
  if j < N + 1 then begin
    OldRoomsR [j, X] := True;
    Inc (RoomCountR);
    RoomsR [RoomCountR] := j;
    GetNextRoomR := j;
  end
  else begin
    Dec (RoomCountR);
    if RoomCountR = 0 then
      EndFlagR := True
    else begin
      j := RoomsR [RoomCountR];
      GetNextRoomR := j;
    end;
  end;
end;

function PathPresent (B, E : Word) : Boolean;
begin
  RoomCountR := 1; RoomsR [1] := B;
  FillChar (OldRoomsR, SizeOf (OldRoomsR), False);
  for i := 1 to N do begin
    OldRoomsR [i, i] := True;
    OldRoomsR [K, i] := True;
  end;
  R1R := B; PathPresent := False;
  if B = E then
    PathPresent := False
  else
    repeat
      R2R := N + 1;
      R2R := GetNextRoomR (R1R);
      if R2R = E then begin
        PathPresent := True;
        Exit;
      end;
      if not EndFlagR then
        R1R := R2R
      else begin
        Exit;
        PathPresent := True;
      end;
    until False;
end;

begin
  Assign (Input, 'Castle.in');
  ReSet (Input);
  Assign (Output, 'Castle.out');
  ReWrite (Output);

  N := 0; K := 0;
  FillChar (Graf, SizeOf (Graf), 0);
  Fillchar (OldRooms, SizeOf (OldRooms), False);

  ReadLn (N);
  ReadLn (K);

{  GetMem (P, SizeOf (TGraf) * N * N);
  if P = nil then
    Halt (255);
}
  for i := 1 to N do
    repeat
      Read (j);
      if j <> 0 then begin
        Graf [i, j] := 1;
        Graf [j, i] := 1;
      end;
    until j = 0;

  RoomCount := 1; Rooms [1] := K;
  R1 := K; AnsStr := 'Yes';
  for i := 1 to N do begin
    OldRooms [i, i] := True;
    OldRooms [K, i] := True;
  end;
  repeat
    R2 := N + 1;
    R2 := GetNextRoom (R1);
    if not PathPresent (K, R2) then begin
      Room := R2;
      Break;
    end;
    if not EndFlag then
      R1 := R2
    else begin
      AnsStr := 'No';
      Break;
    end;
  until False;

  WriteLn (AnsStr);
  if AnsStr = 'Yes' then begin
    WriteLn (RoomCount);
    for i := 1 to RoomCount do
      Write (Rooms [i], ' ');
  end;

{  FreeMem (P, SizeOf (TGraf) * N * N);
}
end.