program P2606_6;

uses crt;

type
  THod = Record
    In1, In2, Out : Word;
  end;

var
  i, j : Word;
  N : Word;
  Times : Array [1..1000] of Word;
  InMen, InTimes : Array [1..2] of Word;
  OutMan, OutTime : Word;
  Time : LongInt;
  Hody : Array [1..1005] of THod;
  HCount : Word;

procedure GetInMen;
var
  i : Word;
  MinT1, MinT2 : Word;
  MaxTime : Word;
begin
  MinT1 := 10000; MinT2 := 10000;
  for i := 1 to N do
    if Times [i] <= MinT1 then begin
      MinT1 := Times [i];
      InMen [1] := i;
    end;
  for i := 1 to N do begin
    if i = InMen [1] then
      Continue;
    if Times [i] <= MinT2 then begin
      MinT2 := Times [i];
      InMen [2] := i;
    end;
  end;
  Times [InMen [1]] := 10001;
  Times [InMen [2]] := 10001;
  InTimes [1] := MinT1;
  InTimes [2] := MinT2;
  if InTimes [1] > InTimes [2] then
    MaxTime := InTimes [1]
  else
    MaxTime := InTimes [2];
  Time := Time + MaxTime;
end;

procedure GetOutMan;
begin
  if InTimes [1] < InTimes [2] then begin
    OutTime := InTimes [1];
    OutMan := InMen [1];
  end
  else begin
    OutTime := InTimes [2];
    OutMan := InMen [2];
  end;
  HCount := HCount + 1;
  Times [OutMan] := OutTime;
  with Hody [HCount] do begin
    In1 := InMen [1];
    In2 := InMen [2];
    if HCount < N - 1 then begin
      Out := OutMan;
      Time := Time + OutTime;
    end;
  end;
end;

begin
  Assign (Input, 'Olymp.in');
  ReSet (Input);
  Assign (Output, 'Olymp.out');
  ReWrite (Output);

  ReadLn (N);
  for i := 1 to N do
    ReadLn (Times [i]);

  Time := 0;
  HCount := 0;
  for i := 1 to N - 1 do begin
    GetInMen;
    GetOutMan;
  end;

  WriteLn (Time);
  for i := 1 to HCount do
    if i < HCount then
      WriteLn (Hody [i].In1, ' ', Hody [i].In2, ' ', Hody [i].Out)
    else
      WriteLn (Hody [i].In1, ' ', Hody [i].In2);
end.