#include <stdio.h>

int N;
int P[1000], A[1000];
int YES;
int R[10010], L[10010], NR;

void input()
{
  int i;
  FILE *f = fopen("tele.in", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) fscanf(f, "%d", &P[i]);
  for (i = 0; i < N; i++)
  {
    fscanf(f, "%d", &A[i]);
    A[i]--;
  }
  fclose(f);
}

void output()
{
  int i;
  FILE *f = fopen("tele.out", "wt");
  if (YES)
  {
    fprintf(f, "Yes\n");
    for (i = 0; i < NR; i++)
    {
      fprintf(f, "%d %c\n", R[i] + 1, L[i] ? '+' : '-');
    }
  }
  else fprintf(f, "No");
  fclose(f);
}

int rr1 = -1, rl1;
void ringkr(int k)
{
  int PN = NR;
  int i, j;
  for (i = 1; i < P[k]; i++)
  {
    R[NR] = k; L[NR] = 1; NR++;
    if (i % 2) for (j = PN - 1; j > 0; j--)
    {
      R[NR] = R[j]; L[NR] = !L[j]; NR++;
    }
    else for (j = 1; j < PN; j++)
    {
      R[NR] = R[j]; L[NR] = L[j]; NR++;
    }
  }
  if (P[k] % 2) {R[NR] = rr1; L[NR] = !rl1; NR++;}
  else {R[NR] = R[0]; L[NR] = !L[0]; NR++;}
  for (i = 0; i < P[k] - 2; i++)
  {
    R[NR] = k; L[NR] = 0; NR++;
  }
  rr1 = k; rl1 = 0;
}

int ring()
{
  int i, j;
  int V = -1;
  for (i = 0; i < N; i++) if (P[i] % 2 == 0) {V = i; break;}
  if (V < 0) return 0;
  for (i = 0; i < N; i++) if (i != V) break;
  if (i < N)
  {
    NR = P[i]-1;
    for (j = 0; j < NR; j++) R[j] = i;
    for (j = 0; j < NR; j++) L[j] = 1;
    ringkr(V);
    for (i++; i < N; i++) if (i != V) ringkr(i);
    R[NR] = rr1; L[NR] = rl1; NR++;
  }
  return 1;
}

int main()
{
  int i, j;
  input();
  if (N == 1)
  {
    if (P[0] == 2)
    {
      if (A[0] == 0)
      {
	R[0] = 0; L[0] = 1;
	R[1] = 0; L[1] = 0;
      }
      else
      {
	R[0] = 0; L[0] = 0;
	R[1] = 0; L[1] = 1;
      }
      NR = 2; YES = 1;
    }
    else YES = 0;
  }
  else
  {
    int B[1000];
    YES = ring();
    for (i = 0; i < N; i++) B[i] = 0;
    for (i = 0; i < NR; i++)
    {
      for (j = 0; j < N; j++) if (A[j] != B[j]) break;
      if (j == N) break;
      if (L[i]) B[R[i]]++; else B[R[i]]--;
    }
    if (i >= NR) YES = 0;
    else
    {
      int mr[10010], ml[10010], mk;
      for (j = 0; j < NR; j++) {mr[j] = R[j]; ml[j] = L[j];}
      mk = 0;
      for (j = i; j < NR; j++) {R[mk] = mr[j]; L[mk] = ml[j]; mk++;}
      for (j = 0; j < i; j++) {R[mk] = mr[j]; L[mk] = ml[j]; mk++;}
    }
  }
  output();
  return 0;
}