#include <stdio.h>

int N;
long t[1000];
int p[1000];
int A[3010], M = 0;

void input()
{
  int i;
  FILE *f = fopen("olymp.in", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) fscanf(f, "%ld", &t[i]);
  fclose(f);
}

void output()
{
  int i;
  long CT = 0;
  FILE *f = fopen("olymp.out", "wt");
  for (i = 0; i < M; i += 3)
  {
    if (t[A[i+1]] > t[A[i]]) CT += t[A[i+1]]; else CT += t[A[i]];
    if (i + 2 < M) CT += t[A[i+2]];
  }
  fprintf(f, "%ld\n", CT);
  for (i = 0; i < M; i++)
  {
    fprintf(f, "%d", A[i] + 1);
    if (i % 3 == 2) fprintf(f, "\n"); else fprintf(f, " ");
  }
  fclose(f);
}

int main()
{
  int i, j, k, L;
  input();
  for (i = 0; i < N; i++) p[i] = i;
  for (i = 0; i < N; i++)
  {
    k = i;
    for (j = i + 1; j < N; j++) if (t[p[j]] < t[p[k]]) k = j;
    L = p[i]; p[i] = p[k]; p[k] = L;
  }
  A[M++] = p[0]; A[M++] = p[1];
  for (k = N - 1; k >= 2 && t[p[0]] + t[p[k-1]] > 2 * t[p[1]]; k -= 2)
  {
    A[M++] = p[0];
    A[M++] = p[k-1]; A[M++] = p[k];
    A[M++] = p[1];
    A[M++] = p[0]; A[M++] = p[1];
  }
  for (;k >= 2; k--)
  {
    A[M++] = p[0];
    A[M++] = p[0]; A[M++] = p[k];
  }
  output();
  return 0;
}