{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
var timer : longint absolute 0000:$046C;
type
real=single;
const
timeron=false;
const VIEW=50;
   VIEW2  =  VIEW * VIEW;

Function PointInLine(x,y,a,b,c:real):boolean;
begin
 PointInLine := abs (A*x + B*y + C) < 0.001;
end;

Procedure Line2Points(x1,y1,x2,y2:real;var A,B,C:real);
var
 delta : real;
begin
 if y1=y2 then
 begin
  A := 0;
  B := 1;
  C := (-y1);
 end else
 begin
  A := 1;
  delta := (y1-y2);
  B := (x2-x1) / delta;
  C := (x1*y2-x2*y1) / delta;
 end;
end;

Procedure Point2Lines (A1,B1,C1,A2,B2,C2 : real; var X,Y : real);
 var delta:real;
begin
 delta := A1 * B2  -  A2 * B1;
 if delta = 0 then
 begin
  X := 1E+19;
  Y := 1E+19;
 end else
 begin
  X := (C2 * B1  -  C1 * B2)  /  delta;
  Y := (A2 * C1  -  A1 * C2)  /  delta;
 end;
end;

type
 AirPlane = record
  x1,y1,x2,y2:real;
  A,B,C,k:real;
  A1,B1,C1,A2,B2,C2:real;
 end;

 tPoint = record
  X,Y : real;
 end;

 tPArr = array [1..1000] of tPoint;

var
    q : longint;
    N,L,i,j,k : word;
    A : array [1..100] of AirPlane;
    Points : array[1..20] of ^tPArr;


Function PointOk(x,y : real; j : byte):boolean;
begin
 PointOK := abs(A[j].A * x + A[j].B * y + A[j].C) <= A[j].K;
end;

Function QPointOk(x,y : real; j : byte):boolean;
begin
 QPointOK := abs(A[j].A * x + A[j].B * y + A[j].C)+0.001 <= A[j].K;
end;


Function PointMegaOk(x,y : real):boolean;
 var i : longint;
begin
 if (x<0) or (y<0) or (x>L) or (y>L) then PointMegaOk := true else
 begin
  i := 1;
  while (i<=N) and (not QPointOk(x,y,i)) do inc(i);
  PointMegaOk := i <= N;
 end;
end;

Function SUXXPointMegaOk(x,y : real):boolean;
 var i : longint;
begin
 if (x<0) or (y<0) or (x>L) or (y>L) then SUXXPointMegaOk := true else
 begin
  i := 1;
  while (i<=N) and (not PointOk(x,y,i)) do inc(i);
  SUXXPointMegaOk := i <= N;
 end;
end;



var
 OldTimer,xx,yy,t,tt:longint;
 flag : boolean;
 np,nt : word;

Procedure ExplorePoint(X,Y : real);
var a,b:longint;
begin
 for a := -4 to 4 do
 for b := -4 to 4 do
 if not SUXXPointMegaOk(x+a*0.0008,y+b*0.0008) then
 begin
  writeln(x+a*0.0008:5:5,' ',y+b*0.0008:5:5);
  close(output);
  for i := 1 to 20 do dispose(points[i]);
  halt;
 end;
end;

begin
if timeron then
 OldTimer := Timer;
 assign(input,'fire.in');
 reset(input);
 assign(output,'fire.out');
 rewrite(output);
 read(L,N);
 if L=0 then
 begin
  writeln('OK');
  halt;
 end;
 if N=0 then
 begin
  writeln('0.5 0.5');
  halt;
 end;



 for i := 1 to 20 do New(Points[i]);

 for i := 1 to N do

 read(A[i].x1,A[i].y1,A[i].x2,A[i].y2);
 for i := 1 to N do
 begin
  Line2Points(A[i].x1,A[i].y1,A[i].x2,A[i].y2,A[i].A,A[i].B,A[i].C);
  A[i].k := sqrt(sqr(a[i].a) + sqr(a[i].b)) * VIEW;

  Line2Points(A[i].x1 + A[i].A*VIEW2 / A[i].K , A[i].y1 + A[i].B*VIEW2/A[i].K,
  A[i].x2+A[i].A*VIEW2/A[i].K,A[i].y2 + A[i].B*VIEW2/A[i].K,A[i].A1,A[i].B1,A[i].C1);

  Line2Points(A[i].x1 - A[i].A*VIEW2 / A[i].K , A[i].y1 - A[i].B*VIEW2/A[i].K,
  A[i].x2 - A[i].A*VIEW2/A[i].K , A[i].y2 - A[i].B*VIEW2/A[i].K,A[i].A2,A[i].B2,A[i].C2);
 end;
 close(input);

 np := 1;
 nt := 1;

 for i := 1 to N do
 begin

  ExplorePoint(A[i].x1 + A[i].A*VIEW2 / A[i].K , A[i].y1 + A[i].B*VIEW2/A[i].K);
  ExplorePoint(A[i].x1 - A[i].A*VIEW2 / A[i].K , A[i].y1 - A[i].B*VIEW2/A[i].K);

  ExplorePoint(A[i].x2 + A[i].A*VIEW2 / A[i].K , A[i].y2 + A[i].B*VIEW2/A[i].K);
  ExplorePoint(A[i].x2 - A[i].A*VIEW2 / A[i].K , A[i].y2 - A[i].B*VIEW2/A[i].K);

  ExplorePoint((A[i].x1+A[i].x2) / 2 + A[i].A*VIEW2 / A[i].K ,
  (A[i].y1+A[i].y2) / 2 + A[i].B*VIEW2/A[i].K);
  ExplorePoint((A[i].x1+A[i].x2) / 2 - A[i].A*VIEW2 / A[i].K ,
  (A[i].y1+A[i].y2) / 2 - A[i].B*VIEW2/A[i].K);
 end;

 if N <> 1 then
 for i := 1 to N-1 do
 for j := i+1 to N do
 begin
  inc(np);if np=1001 then begin np:=1; inc(nt); end;
  Point2Lines(A[i].a1,A[i].b1,A[i].c1,A[j].a1,A[j].b1,A[j].c1,
  Points[nt]^[np].x,Points[nt]^[np].y);
  inc(np);if np=1001 then begin np:=1; inc(nt); end;
  Point2Lines(A[i].a2,A[i].b2,A[i].c2,A[j].a1,A[j].b1,A[j].c1,
  Points[nt]^[np].x,Points[nt]^[np].y);
  inc(np);if np=1001 then begin np:=1; inc(nt); end;
  Point2Lines(A[i].a1,A[i].b1,A[i].c1,A[j].a2,A[j].b2,A[j].c2,
  Points[nt]^[np].x,Points[nt]^[np].y);
  inc(np);if np=1001 then begin np:=1; inc(nt); end;
  Point2Lines(A[i].a2,A[i].b2,A[i].c2,A[j].a2,A[j].b2,A[j].c2,
  Points[nt]^[np].x,Points[nt]^[np].y);
 end;
 dec(np);

 if nt<>1 then for i := 1 to nt-1 do
 for j := 1 to 1000 do
 if not PointMegaOk(Points[i]^[j].x,Points[i]^[j].y) then
 ExplorePoint(Points[i]^[j].x,Points[i]^[j].y);
 i := nt;
 for j := 1 to np do
 if not PointMegaOk(Points[i]^[j].x,Points[i]^[j].y) then
 ExplorePoint(Points[i]^[j].x,Points[i]^[j].y);

 (*
 for xx := 1 to L do
 for yy := 1 to L do
 begin
  if timer - OldTimer > 80 then
  begin
   writeln('OK');
   halt;
  end;

  flag := false;
  for i := 1 to N do
  flag :=  flag OR PointOK(xx,yy,i);
  if not flag then
  begin
   writeln(xx,' ',yy);
   for i := 1 to 20 do dispose(points[i]);
   halt;
  end;
 end;
 *)

 writeln('OK');
 if timeron then writeln((timer-oldtimer)*0.055);
 close(output);
 for i := 1 to 20 do dispose(points[i]);
end.
