{$N+}
Const
 F_I='fire.in';
 F_O='Fire.out';
 Unknown=1e6;
 Eps=1e-4;
 Sh=4;
Type
 XY=Record
  X,Y:Single;
 end;
 Mnogoug=Record
  N:Integer;
  M:Array [0..50] Of XY;
 end;
 Pr=Array [1..6] Of XY;
 Otr=Record
  X1,Y1,X2,Y2:Single;
 end;
Var
 F:Text;
 C:Array [1..100] OF Otr;
 Time:LongInt;
 Timer:LongInt absolute $0:$046c;
 Rec:Array [1..100] Of Pr;
 Per:Array [1..100] Of Mnogoug;
 L:Single;
 N,NPer:LongInt;
Procedure SwapSingle(var A,B:Single);
Var c:Single; begin C:=A;A:=B;B:=C end;
Procedure Swap(var A,B:Single);
Var c:Single; begin C:=A;A:=B;B:=C end;
Procedure GetKof(X1,Y1,X2,y2:Single;var K,B:Single);
 begin
  If X1=X2 then begin K:=Unknown;B:=X1 end else
   begin K:=(Y2-Y1)/(X2-X1);B:=Y1-k*X1 end;
 end;
Function PointOnLine(X1,Y1,X2,Y2,X,Y:Single):boolean;
 begin
  PointOnLine:=Abs((X2-X1)*(Y-Y1)-(X-X1)*(Y2-Y1))<Eps;
 end;
Function PointOnOtr(X1,Y1,X2,Y2,X,Y:Single):Boolean;
 begin
  PointOnOtr:=False;
  If PointOnLine(X1,Y1,X2,Y2,X,Y) then
   begin
    If X1>X2 then SwapSingle(X1,X2);If y1>y2 then SwapSingle(y1,y2);
    If (X-X1>=-Eps)and(X-X2<=Eps)and(Y-Y1>=-Eps)and(Y-Y2<=Eps)
     then PointOnOtr:=True;
   end;
 end;
Procedure OutPut(N:byte;X,Y:Single);
 begin
  Assign(F,F_O);ReWrite(F);
  If N=0 then Write(F,'OK')
   else
    begin
     Write(F,X:8:3,Y:8:3);
    end;
  Close(F);
  Halt;
 end;
Procedure ReadFile;
  Var
   I:Integer;
 begin
  Assign(F,F_I);Reset(F);
  Read(F,L,N);
  For I:=1 to N do Read(F,C[I].X1,C[I].Y1,C[I].X2,C[I].Y2);
  Close(F);
 end;
Procedure GetPr;
 Var
  I:Integer;
  K,S,A,B:single;
 begin
  For I:=1 to N do
   begin
    IF C[I].Y1=C[I].Y2  then A:=50 else
     begin
      K:=((C[I].X1-C[I].X2)/(C[I].Y1-C[I].Y2));
      S:=Sqrt(1/(1+K*K));
      A:=50/S;
      If A<0 then A:=-A;
     end;
    GetKof(C[I].X1,C[I].Y1,C[I].X2,C[I].Y2,K,B);
    If K<>Unknown then
     begin
      C[I].X1:=-5000;C[I].Y1:=C[I].X1*K+B;
      C[I].X2:=5000;C[I].Y2:=C[I].X2*K+B;
     end
    else
     begin
      C[I].Y1:=-5000;C[I].Y2:=5000;
     end;
    If Abs(K)>Eps then
     begin
      Rec[I,1].X:=C[I].X1+A;Rec[I,1].Y:=C[I].Y1;
      Rec[I,2].X:=C[I].X2+A;Rec[I,2].Y:=C[I].Y2;
      Rec[I,3].X:=C[I].X2-A;Rec[I,3].Y:=C[I].Y2;
      Rec[I,4].X:=C[I].X1-A;Rec[I,4].Y:=C[I].Y1;
     end
    else
     begin
      Rec[I,1].X:=C[I].X1;Rec[I,1].Y:=C[I].Y1+A;
      Rec[I,2].X:=C[I].X2;Rec[I,2].Y:=C[I].Y2+A;
      Rec[I,3].X:=C[I].X2;Rec[I,3].Y:=C[I].Y2-A;
      Rec[I,4].X:=C[I].X1;Rec[I,4].Y:=C[I].Y1-A;
     end;
   end;
 end;
Function Rav(a,B:single):Boolean;
 begin
  Rav:= Abs(A-B)<Eps
 end;
Function Max(A,B:Single):Single;
 begin
  If A>B then Max:=A else Max:=B;
 end;
Function PIn(X,Y:Single;N:Integer):Boolean;
 Var
  X_,Y_:Single;
  I,J:Integer;
 Function OtP(X1,Y1,X2,Y2:Single):Boolean;
  Var K,B:Single;
  begin
   Otp:=False;
   GetKof(X1,Y1,X2,Y2,K,B);
   If K=Unknown then
    begin
     If Y1>Y2 then Swap(Y1,Y2);
     If X>X1 then Exit;
     If (Y>=Y1)and(Y<=Y2) then begin OtP:=True;Exit end;
    end
   else
    begin
     If K=0 then Exit;
     If Y1>Y2 then Swap(Y1,Y2);
     If X1>X2 then Swap(X1,X2);
     If (Y>=Y1)and(Y<=Y2) then If (X>=X1)and (Y<=Y2) then else Exit;
     X_:=(Y-B)/K;
     If X_<=X then begin OtP:=True;Exit end;
    end;
  end;
 begin
  PIn:=True;
  Rec[N,5]:=Rec[N,1];J:=0;
  For I:=1 to 4 do
   begin
    If PointOnOtr(Rec[N,I].X,Rec[N,I].Y,Rec[N,I+1].X,Rec[N,I+1].Y,X,Y) then Exit;

    If Otp(Rec[N,I].X,Rec[N,I].Y,Rec[N,I+1].X,Rec[N,I+1].Y) then Inc(J);
   end;
  PIn:=Odd(J);
 end;
Function Ok(X,Y:Single):Boolean;
 Var
  I:Integer;
 begin
  Ok:=False;
  For I:=1 to N do
   If PIn(X,Y,I) then Exit;
  Ok:=True;
 end;
Procedure Find(Sh:Single);
 Var
  X,Y:Single;
 begin
  X:=0;Y:=0;
  While X<=L do
   begin
    Y:=0;
    While Y<=L do
     begin
      If Timer>Time then Exit;
      If Ok(X,Y) then
       begin
        OutPut(1,X,Y);
       end;
      Y:=Y+Sh;
     end;
    X:=X+Sh;
   end;
 end;
Procedure RND;
 Var
  X,Y:Single;
  K:Integer;
 begin
  Time:=Timer+Round(18.2*0.8);K:=0;
  Repeat
   X:=Random*L;Y:=Random*L;
   Inc(K);
   If Ok(X,Y) then begin OutPut(1,X,Y); end;
   If Timer>Time then begin OutPut(0,0,0) end;
  Until 1=0;
 end;
Procedure Solve;
 Var
  I,J:Integer;
  X,Y:Single;
 begin
  GetPr;NPer:=1;Per[1].N:=4;
  Per[1].M[1].X:=0;  Per[1].M[1].Y:=0;
  Per[1].m[2].X:=0;  Per[1].m[2].Y:=L;
  Per[1].m[3].X:=L;  Per[1].m[3].Y:=L;
  Per[1].m[4].X:=L;  Per[1].m[4].Y:=0;
  X:=Sh;
  Repeat
   If Timer>Time then begin RND end;
   fIND(X);X:=X/2;
  Until 1=0
 end;
BEGIN
 Randomize;
 Time:=Timer+Round(18.2*4);
 ReadFile;Solve;
END.