{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Type
    TClosed             =       Array[1..14000] of Word;
Var
   F                    :       Text;
   N                    :       Word;
   Col                  :       Word;
   Way                  :       Array[1..2, 1..14000] of Word;
   K                    :       Word;
   I                    :       Word;
   J                    :       Word;
   Wave                 :       array[1..1000] of Word;
   Done                 :       Boolean;
   Moves                :       Array[1..1000] of Word;
   Del                  :       Array[1..1000] of Word;
   Closed               :       ^TClosed;
   Temp                 :       Array[0..1000] of Word;
   Bad                  :       Boolean;
Function TheresAWay(I, J : Word) : Boolean;
Var
   X            :       Word;
Begin
     TheresAWay := False;
     For X := 1 to Col do
         If ((Way[1, X] = I) and (Way[2, X] = J)) or ((Way[1, X] = J) and (Way[2, X] = I)) then TheresAWay := True;
End;
Procedure Move(Loc : Word; MoveCol : Word; DelCol : Word; ClosedCol : Word);
Var
   J            :       Word;
   X            :       Word;
   I            :       Word;
Procedure DelAll(Loc : Integer);
Var
   I            :       Integer;
Begin
     For I := 1 to N do if Wave[I] <> Loc then
         Begin
              Inc(DelCol);
              Del[DelCol] := I;
         End;
End;
Function Deleted(I : Word) : Boolean;
Var
   X            :       Word;
Begin
     Deleted := False;
     For X := 1 to DelCol do If Del[X] = I then Deleted := True;
End;
Function Open(Num : Word) : Boolean;
Var
   I            :       Word;
Begin
     Open := True;
     For I := 1 to ClosedCol do
         If Closed^[I] = Num then Open := False;
End;
Function NoWay(Loc : Word) : Boolean;
Var
   I            :       Word;
Begin
     NoWay := True;
     For I := 1 to Col do
         Begin
              If (Way[1, I] = Loc) and (Not Deleted(Way[2, I])) and Open(I) then NoWay := False;
              If (Way[2, I] = Loc) and (Not Deleted(Way[1, I])) and Open(I) then NoWay := False;
         End;
End;
Function FindWay(I : Word; Var Num : Word) : Word;
Var
   X                    :       Word;
Begin
     For X := 1 to Col do
         Begin
              If (Way[1, X] = I) and (Not Deleted(Way[1, X])) and (Open(X)) then
                 Begin
                      FindWay := Way[2, X];
                      Num := X;
                      Exit;
                 End;
              If (Way[2, X] = I) and (Not Deleted(Way[2, X])) and (Open(X)) then
                 Begin
                      FindWay := Way[1, X];
                      Num := X;
                      Exit;
                 End;
         End;
End;
Procedure WaveFrom(Room, Count : Word);
Var
   I            :       Word;
Begin
     If Wave[Room] <> 0 then Exit;
     Wave[Room] := Count;
     For I := 1 to Col do
         Begin
              If (Way[1, I] = Room) and (Not Deleted(Way[2, I])) and Open(I) then
                 WaveFrom(Way[2, I], Count);
              If (Way[2, I] = Room) and (Not Deleted(Way[1, I])) and Open(I) then
                 WaveFrom(Way[1, I], Count);
         End;
End;
Function BreakInGraph : Boolean;
Var
   Room                 :       Word;
   Count                :       Word;
Begin
     FillChar(Wave, SizeOf(Wave), 0);
     Count := 0;
     For Room := 1 to N do
         If (Wave[Room] = 0) and (Not Deleted(Room)) then
            Begin
                 Inc(Count);
                 WaveFrom(Room, Count);
            End;
     If Count > 1 then BreakInGraph := True Else
        BreakInGraph := False;
End;
Procedure CloseDoor(Num : Word);
Begin
     Inc(ClosedCol);
     Closed^[ClosedCol] := Num;
End;
Procedure FoundEm;
Var
   X                    :       Word;
   I                    :       Word;
Begin
     Assign(F, 'castle.out');
     ReWrite(F);
     WriteLn(F, 'Yes');
     WriteLn(F, ClosedCol);
     For I := 1 to MoveCol do
         Begin
              Bad := False;
              For X := 1 to Temp[0] do If Temp[X] = Moves[I] Then Bad := True;
              If Not Bad then
                 Begin
                      Inc(Temp[0]);
                      Temp[Temp[0]] := Moves[I];
                      Write(F, Moves[I], ' ');
                 End;
         End;
     If J <> Moves[MoveCol] then Write(F, J);
     Close(F);
     Dispose(Closed);
     Halt;
End;
Begin
     If BreakInGraph then
        Begin
             If Wave[Loc] <> Wave[K] then
                Begin
                     J := Moves[MoveCol];
                     FoundEm;
                End
             Else DelAll(Wave[Loc]);
        End;
     While Not NoWay(Loc) do
           Begin
                J := FindWay(Loc, X);
                CloseDoor(X);
                If BreakInGraph then
                   Begin
                        If Wave[J] <> Wave[K] then FoundEm;
                        Dec(ClosedCol);
                        For I := 1 to Col do
                            Begin
                                 If (Way[1, I] = Loc) and (Not Deleted(Way[2, I])) and Open(I) then
                                    Begin
                                         Inc(MoveCol);
                                         Moves[MoveCol] := Way[2, I];
                                         CloseDoor(I);
                                         Move(Way[2, I], MoveCol, DelCol, ClosedCol);
                                         Dec(MoveCol);
                                         Dec(ClosedCol);
                                    End;
                                 If (Way[2, I] = Loc) and (Not Deleted(Way[1, I])) and Open(I) then
                                    Begin
                                         Inc(MoveCol);
                                         Moves[MoveCol] := Way[1, I];
                                         CloseDoor(I);
                                         Move(Way[1, I], MoveCol, DelCol, ClosedCol);
                                         Dec(MoveCol);
                                         Dec(ClosedCol);
                                    End;
                            End;
                        Exit;
                   End;
                Inc(MoveCol);
                Moves[MoveCol] := J;
                Loc := J;
           End;
End;
Begin
     New(Closed);
     Assign(F, 'castle.in');
     Reset(F);
     Read(F, N, K);
     While (Not EOF(F)) do
           Begin
                Read(F, I);
                Repeat
                      Read(F, J);
                      If (J <> 0) and (Not TheresAWay(I, J)) then
                         Begin
                              Inc(Col);
                              Way[1, Col] := I;
                              Way[2, Col] := J;
                         End;
                Until J = 0;
           End;
     Close(F);
     Done := False;
     Moves[1] := K;
     Move(K, 1, 0, 0);
     Assign(F, 'castle.out');
     ReWrite(F);
     WriteLn(F, 'No');
     Close(F);
     Dispose(Closed);
End.