{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$M 65520,0,655360}
program macro;
type int = longint;
		 SInt = integer;
const
	inFile = 'castle.in';
	outFile = 'castle.out';
	maxx = 1024;
	nsubar = 256;
	zu : array[0..7] of sint = (1,2,4,8,16,32,64,128);

type
	list = ^el;
	el = record
				 inf : sint;
				 next : list;
			 end;
	subar = array[0..maxx-1] of byte;
	bigar = array[0..nsubar-1] of ^subar;

var
	v : list;
	n,i,x : sint;
	num : int;
	k : sint;
	a : bigar;
	paint : array[1..1001] of sint;
	t,t1,t2,t3,t4 : int;
	vect : array[1..1001] of sint;
	count : sint;
	edin : array[1..1001] of sint;
	st : list;
	path : list;
	pa : list;
	pathlen : int;

procedure init;
var
	i : sint;
begin
	for i:=0 to nsubar-1 do
	begin
		new(a[i]);
		fillchar(a[i]^,sizeof(a[i]^),0);
	end;
end;

procedure disp;
var
	i : sint;
begin
	for i:=0 to nsubar-1 do
		dispose(a[i]);
end;

procedure push(x,y : sint;z : boolean);
begin
	t:=((x shl 10)+y) shr 3;
	t1:=(y) and (7);
	t2:=(t) shr 10;
	t3:=(t) and (1023);
	t4:=a[t2]^[t3];
	if (z) then
		t4:=(t4) or (zu[t1])
	else
		t4:=(t4) and (not zu[t1]);
	a[t2]^[t3]:=t4;
end;

function pop(x,y : sint) : boolean;
begin
	t:=((x shl 10)+y) shr 3;
	t1:=(y) and (7);
	t2:=(t) shr 10;
	t3:=(t) and (1023);
	pop:=((a[t2]^[t3]) and (zu[t1]))<>0;
end;

procedure stpush(var st : list;x : sint);
begin
	new(v);
	v^.inf:=x;
	v^.next:=st;
	st:=v;
end;

function stpop(var st : list) : sint;
begin
	v:=st^.next;
	stpop:=st^.inf;
	dispose(st);
	st:=v;
end;

function findfirstsm(x,except : sint) : sint;
var
	i : sint;
begin
	i:=1;
	while (i<=n) and (((not pop(x,i)) or (i=x)) or (i=except)) do inc(i);
	findfirstsm:=i;
end;

procedure writepath;
var
	x : sint;
begin
	while (path<>nil) do
	begin
		x:=stpop(path);
		stpush(pa,x);
	end;
	assign(output,outFile);
	rewrite(output);
	writeln('Yes');
	writeln(pathlen);
	write(stpop(pa));
	while (pa<>nil) do
		write(' ',stpop(pa));
	close(output);
	disp;
	halt(0);
end;

procedure tryit;
var
	i,j,x,y : sint;
function isit(d : sint) : boolean;
var
	i,j,x,y : sint;
begin
	fillchar(paint,sizeof(paint),0);
	st:=nil;
	stpush(st,k);
	paint[k]:=maxint;
	while (st<>nil) do
	begin
		x:=stpop(st);
		for j:=1 to n do
			if (paint[j]=0) and (pop(x,j)) then
			begin
				paint[j]:=x;
				stpush(st,j);
			end;
	end;
	isit:=(paint[d]=0);
end;
procedure deep(d : sint);
var
	j : sint;
begin
	fillchar(paint,sizeof(paint),0);
	st:=nil;
	stpush(st,k);
	paint[k]:=maxint;
	while (st<>nil) do
	begin
		x:=stpop(st);
		for j:=1 to n do
			if (paint[j]=0) and (pop(x,j)) then
			begin
				paint[j]:=x;
				stpush(st,j);
			end;
	end;
	if (paint[d]=0) then exit;
	x:=d;
	num:=0;
	stpush(st,x);
	while (paint[x]<>maxint) do
	begin
		x:=paint[x];
		stpush(st,x);
		inc(num);
	end;
	assign(output,outFile);
	rewrite(output);
	writeln('Yes');
	writeln(num);
	write(stpop(st));
	while (st<>nil) do write(' ',stpop(st));
	writeln;
	close(output);
	disp;
	halt(0);
end;
begin
	count:=0;
	for i:=1 to n do
		if (vect[i]=1) then
		begin
			inc(count);
			edin[count]:=i;
		end;
	if (vect[k]=1) then
	begin
		assign(output,outFile);
		rewrite(output);
		writeln('Yes');
		writeln(1);
		writeln(k,' ',findfirstsm(k,0));
		close(output);
		disp;
		halt(0);
	end;
	for i:=1 to count do deep(edin[i]);
	x:=k;
	path:=nil;
	pathlen:=0;
	stpush(path,k);
	while (x<>n+1) do
	begin
		y:=findfirstsm(x,0);
		if (y=n+1) then
		begin
			x:=stpop(path);
			x:=path^.inf;
			push(x,y,true);
			push(y,x,true);
			dec(pathlen);
			y:=findfirstsm(x,y);
			if (y=n+1) then exit;
		end;
		stpush(path,y);
		inc(pathlen);
		push(x,y,false);
		push(y,x,false);
		dec(vect[x]);
		dec(vect[y]);
		if (isit(y)) then writepath;
		x:=y;
	end;
end;

begin
	init;
	fillchar(vect,sizeof(vect),0);
	assign(input,inFile);
	reset(input);
	readln(n);
	readln(k);
	for i:=1 to n do
	begin
		read(x);
		while (x<>0) do
		begin
			{add(i,x);}
			push(i,x,true);
			inc(vect[i]);
			read(x);
		end;
		readln;
	end;
	close(input);
	tryit;
	fillchar(paint,sizeof(paint),0);
	assign(output,outFile);
	rewrite(output);
	writeln('No');
	close(output);
	disp;
end.