{$A+,B-,D+,E+,F+,G+,I+,L+,N+,O+,P+,Q+,R+,S+,T+,V+,X+,Y+}
{$M 65520,0,300000}
const eps=1e-4;

type point = record x1, x2 : extended end;
     vect  = record bx, by, ex, ey : extended end;
     line  = record a, b, c :extended end;
     mas   = array[1..11]of point;

var l, n, i, j, k     : word;
    sm                : extended;
    v                 : vect;
    m                 : array[0..1000] of ^mas;
    m_c               : array[0..1000]of byte;
    d                 : line;
    t, t1             : point;
    ok                : boolean;

procedure getline(w : vect; var q : line);
begin
 q.a:=w.ey-w.by;
 q.b:=w.bx-w.ex;
 q.c:=w.ex*w.by-w.bx*w.ey;
end;

function eq(e, f : extended): boolean;
begin
 if abs(e-f)<eps then eq:=true else eq:=false;
end;

function big(e, f : extended): boolean; {e>=f}
begin
  if eq(e,f)or(e>f) then big:=true else big:=false;
end;

function compare(w1, w2 : point; var res : point) : boolean;
 var p : array[1..4]of extended;
     c : word;
begin
 c:=0;
 p[1]:=w1.x1; p[2]:=w1.x2;
 if not (big(w1.x1, w2.x1)and(big(w2.x2, w1.x1))) then
 {if w1.x1}
   begin inc(c); p[c]:=w1.x1 end;
 if not (big(w1.x2, w2.x1)and(big(w2.x2, w1.x2))) then
   begin inc(c); p[c]:=w1.x2 end;
 if not (big(w2.x1, w1.x1)and(big(w1.x2, w2.x1))) then
   begin inc(c); p[c]:=w2.x1 end;
 if not (big(w2.x2, w1.x1)and(big(w1.x2, w2.x2))) then
   begin inc(c); p[c]:=w2.x2 end;
 res.x1:=p[1];
 res.x2:=p[2];
 if big(res.x1, res.x2) then begin
  p[1]:=res.x1;
  res.x2:=res.x1;
  res.x1:=p[1];
 end;
 if c<4 then compare:=true else compare:=false;
end;

function dist(w : vect) : extended;
begin
 dist:=sqrt( sqr(w.bx-w.ex) + sqr(w.by-w.ey) );
end;

BEGIN
 assign(input, 'fire.in'); reset(input);
  readln(l); readln(n);
  fillchar(m_c, sizeof(m_c), 0);
  for j:=0 to l do begin new(m[j]);fillchar(m[j]^, sizeof(m[j]^), 0) end;
  for i:=1 to n do begin
    readln(v.bx, v.by, v.ex, v.ey);
    getline(v, d);
    sm:=abs(v.by-v.ey)/dist(v)*50;
    for j:=0 to l do begin
     if d.a=0 then begin t.x1:=0; t.x2:=l end
     else begin t.x1:=-(d.b*j+d.c)/d.a-sm; t.x2:=-(d.b*j+d.c)/d.a+sm end;
     if t.x1<0 then t.x1:=0;
     if t.x2<0 then t.x2:=0;
     if t.x2>l then t.x2:=l;
     if t.x1>l then t.x1:=l;
    if ((d.a=0)and((j>v.by-50)and(j<v.by+50)))or(d.a<>0) then begin
     k:=1;
     while k<=m_c[j] do begin
      if compare(m[j]^[k], t, t1) then begin
        m[j]^[k]:=m[j]^[m_c[j]];
        t:=t1; dec(k);
        dec(m_c[j]);
      end;
      inc(k);
     end;
     m_c[j]:=k;
     m[j]^[k]:=t;
    end;
    end;
  end;
 close(input);
 ok:=true;
 for j:=l downto 0 do begin
  if (m[j]^[1].x1>0) or (m[j]^[1].x2<l) then begin
   ok:=false;
   if m_c[j]=0 then t.x1:=0;
   t.x2:=j;
   if m_c[j]>1 then t.x1:=(m[j]^[1].x2+m[j]^[2].x1)/2
    else if m_c[j]=1 then t.x1:=(m[j]^[1].x2+l)/2;
  end;
  dispose(m[j]);
 end;
 assign(output, 'fire.out'); rewrite(output);
  {if n>=10 then write('OK') else write(0,' ',0);}
  if ok then write('OK') else write(t.x1:0:3,' ',t.x2:0:3);
 close(output);
END.