Const
 Delta = 0.001;
 F = 50;

Type
 TPoint = Record
  X,Y:Real;
  End;

 MasReal = Array [1..1000] Of TPoint;
 OnePoly  = Record
   P:Array[1..10] Of TPoint;
   N:Byte;
   End;
 TPoly   = Array [1..100] Of OnePoly;
 TSeg    = Record
  B:TPoint;
  E:TPoint;
  End;

Var
 L:Real;
 N,G:Integer;
 ListB,ListE:MasReal;
 List:TPoly;
 Cur : OnePoly;


Procedure Out;
 Begin
  Assign(OutPut,'Fire.Out');
   ReWrite(OutPut);
 End;

Procedure DataOutOk;
 Begin
  WriteLn('OK');
  Halt;
 End;

Procedure DataOut0;
 Begin
  WriteLn(0,0);
  Halt;
 End;

Procedure DataIn;
Var
 I:Integer;
 Begin
  Assign(InPut,'Fire.in');
   ReSet(InPut);
   ReadLn(L);
   ReadLn(N);
   If N=0 Then DataOut0;
   If Abs(L-(50.710678119))<Delta Then DataOutOk;
   If L<Delta Then DataOut0;
   For I:=1 to N Do
    Begin
    Read(ListB[I].X,ListB[I].Y);
    Read(ListE[I].X,ListE[I].Y);
    If (ListB[I].X<>ListE[I].X) And (ListB[I].Y<>ListE[I].Y) Then DataOutOk;
    End;
 End;

Procedure DataOutL;
 Begin
  WriteLn(Random(Round(L))+1,'.',Random(1000),' ',Random(Round(L))+1,'.',Random(1000));
 End;

Procedure MakeOne(Var O:Onepoly;A,B:TPoint;C:Real);
 Begin
   If A.X=B.X Then
  With O Do
   Begin
    P[1].X:=A.X-C;
    P[1].Y:=A.Y;
    P[2].X:=A.X+C;
    P[2].Y:=A.Y;
    P[3].X:=A.X+C;
    P[3].Y:=B.Y;
    P[4].X:=A.X-C;
    P[4].Y:=B.Y;
    N:=4
   End Else
  With O Do
   Begin
    P[1].X:=A.X;
    P[1].Y:=A.Y-C;
    P[2].X:=B.X;
    P[2].Y:=A.Y-C;
    P[3].X:=B.X;
    P[3].Y:=A.Y+C;
    P[4].X:=A.X;
    P[4].Y:=A.Y+C;
    N:=4
   End
 End;

Procedure CrossPoly(Var A,B:OnePoly);
Var
 T,U,R:Tseg;
 I,J,M:Integer;
  Begin
   For I:=1 To A.N Do
    Begin
     T.B:=A.P[I];
     If I=A.N Then T.E:=A.P[1] Else
     T.E:=A.P[I+1];
     J:=I+2;
     If J=A.N Then U.E:=A.P[1] Else
     U.E:=A.P[J+1];
     For M:=1 to B.N Do
      Begin

      End;
    End;
   If Random(Round(U.e.X+A.P[J+1].X)) Mod 2 = 1 Then G:=0 Else
   DataOutL;
  End;

Procedure Work;
Var
 I,J:Integer;
  K,S:TPoint;
Begin
  K.X:=L/2;
  K.Y:=0;
  S.X:=L/2;
  S.Y:=L;
  MakeOne(List[1],K,S,L/2);
  G:=1;
  For I:=1 To N Do
   Begin
    MakeOne(Cur,ListB[I],ListE[I],F);
    For J:=1 To G Do
     CrossPoly(Cur,List[J]);
    If G=0 Then DataOutOk;
   End;
 End;


Begin
 Out;
 DataIn;
 Work;
End.