{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

program BusinessClassics;

const
	dr:array[1..4] of shortint = ( 1 , 0 , -1, 0  );
	dc:array[1..4] of shortint = ( 0 , 1 , 0 , -1 );
	ds:array[1..4] of char     = ('D','R','U','L' );

type
	Solution = record
		sx:byte;
		st:string;
	end;
	TVertex = record
		c,r:byte;
	end;
	TVisited = array[1..80,1..3] of byte;
	TWay = record
		v:TVisited;
		s:String;
		f:TVertex;
	end;
	TColumnWays = array[1..3] of TWay;
	pColumnWays = ^TColumnWays;
	TWays{.Ru} = array[1..80] of pColumnWays;

function strle(s,s1:string):boolean;
var
	i:byte;
	min:byte;
begin
	if length(S)<length(s1) then begin strle:=false; exit end;
	strle:=true;
	if length(s)>length(s1) then exit;
	if length(s1)=0 then exit;
	if length(s)<length(s1) then min:=length(s) else min:=length(s1);
	for i:=1 to min do
		if s[i]<s1[i] then exit;
	strle:=false;
end;

var
	w:TWays;
	Best:Solution;
	a:array[1..80,1..3] of byte;
	n:byte;

procedure read_Data;
var
	i,j:byte;
begin
	assign(input,'class.in');
	reset(input);
	read(n);
	for j:=1 to 3 do
		for i:=1 to n do read(a[i,j]);
	close(input);
end;

procedure out_data;
var
	i:byte;
begin
	assign(output,'class.out');
	rewrite(output);
	writeln(Best.sx);
	Writeln(Best.st);
	flush(output);
	close(output);
end;

type
	pString = ^string;

var
	q,qa:array[1..10000] of TVertex;
	ql,qcl:byte;
	d:array[1..80,1..3] of pstring;
	f:array[1..80,1..3] of Tvertex;
	vs:array[1..80,1..3] of byte;

procedure wave(sv:byte);
var
	i,j:byte;
	v,p:TVertex;
	s,ss:string;

begin
	for i:=1 to n do
		for j:=1 to 3 do d[i,j]^:='';
	fillchar(vs,sizeof(Vs),0);
	fillchar(f,sizeof(f),0);
	d[1,1]^:='0';
	repeat
		s:='';
		for i:=1 to n do
			for j:=1 to 3 do
				if (vs[i,j]=0)and(strle(d[i,j]^,s)) then begin
					s:=d[i,j]^;
					v.c:=i; v.r:=j;
				end;
		if s='' then break;
		vs[v.c,v.r]:=1;
		for i:=1 to 4 do begin
			p.c:=v.c+dc[i];
			p.r:=v.r+dr[i];
			if (p.c>=1)and(p.c<=n)and(p.r>=1)and(p.r<=3) then begin
				ss:=s+chr(48+a[p.c,p.r]);
				if strle(ss,d[p.c,p.r]^) then begin
					d[p.c,p.r]^:=ss;
					if vs[p.c,p.r]=0 then f[p.c,p.r]:=v;
				end;
			end;
		end;
	until false;

end;

var
	i,j,k:byte;
	v,p:TVertex;
	max:string;
	ss:string;

begin
	read_data;
	{ Solution }
	for i:=1 to n do
		for j:=1 to 3 do begin
			a[i,j]:=1-a[i,j];
			new(d[i,j]);
		end;
	max:='';
	for i:=1 to 3 do begin
		wave(i);
		for j:=1 to 3 do
			if strle(copy(d[n,j]^,1,n),max) then begin
				max:=d[n,j]^;
				v.c:=n;
				v.r:=j;
				Best.sx:=i;
			end;
	end;
	max:='';
	p:=v;
	repeat
		p:=f[v.c,v.r];
		for k:=1 to 4 do
			if ((v.c-p.c)=dc[k]) and (v.r-p.r=dr[k]) then begin
				max:=max+ds[k]; break;
			end;
		v:=p;
	until f[v.c,v.r].c=0;
	ss:='';
	for i:=1 to length(max) do ss:=max[i]+ss;
	Best.st:=ss;
	out_data;
	for i:=1 to n do
		for j:=1 to 3 do dispose(d[i,j]);
end.