program Fire;
{$B-}
{$N+}
const
	MaxN = 100;
    IFN = 'fire.in';
    OFN = 'fire.out';

type
	TSam = record
		X1, Y1, X2, Y2: Single;
    end;
    TNV = record
        Dead: Boolean;
		X1, Y1, X2, Y2: Single;
    end;

var
	N, L, NNV: Word;
	S: array [1..MaxN] of TSam;
    NV: array [1..MaxN] of TNV;
    X, Y: Single;
    Ok: Boolean;

    procedure Input;
    var
        F: Text;
        i: Word;
        T: Single;
    begin
		Assign(F, IFN);
        ReSet(F);
        ReadLn(F, L);
        ReadLn(F, N);
        for i := 1 to N do
        begin
        	with S[i] do
            begin
	        	Read(F, X1, Y1, X2, Y2);
                if X1 > X2 then
                begin
                	T := X1;
                    X1 := X2;
                    X2 := T;
                end;
                if Y1 > Y2 then
                begin
                	T := Y1;
                    Y1 := Y2;
                    Y2 := T;
                end;
            end;
            if not EoF(F) then ReadLn(F);
        end;
        Close(F);
    end;

    procedure Proceed;
    var
    	i, j: Word;
    begin
		NNV := 1;
        NV[NNV].X1 := 0;
        NV[NNV].Y1 := 0;
        NV[NNV].X2 := L;
        NV[NNV].Y2 := L;
        NV[NNV].Dead := False;
        for i := 1 to N do
        begin
        	for j := 1 to NNV do
            begin
                if not NV[j].Dead then
                begin
                	if S[i].X1 = S[i].X2 then
                    begin
                        if (S[i].X1-50 < NV[j].X2) and (S[i].X1+50 > NV[j].X1) then
                        begin
                        	if S[i].X1-50 > NV[j].X1 then
                            begin
                            	if S[i].X1+50 > NV[j].X2 then
                                begin
                                	NV[j].X2 := S[i].X1-50;
                                end
                                else
                                begin
 	                              	Inc(NNV);
	                                NV[NNV].X1 := S[i].X1+50;
                                    NV[NNV].Y1 := NV[j].Y1;
                                    NV[NNV].X2 := NV[j].X2;
                                    NV[NNV].Y2 := NV[j].Y2;
                                    NV[NNV].Dead := False;
                                    NV[j].X2 := S[i].X1-50;
                                end;
                            end
                            else
                            begin
                            	if S[i].X1+50 > NV[j].X2 then
                                begin
                                	NV[j].Dead := True;
                                end
                                else
                                begin
                                	NV[j].X2 := S[i].X1+50;
                                end;
                            end;
                        end;
                    end
                    else
                    begin
                        if (S[i].Y1-50 < NV[j].Y2) and (S[i].Y1+50 > NV[j].Y1) then
                        begin
                        	if S[i].Y1-50 > NV[j].Y1 then
                            begin
                            	if S[i].Y1+50 > NV[j].Y2 then
                                begin
                                	NV[j].Y2 := S[i].Y1-50;
                                end
                                else
                                begin
 	                              	Inc(NNV);
	                                NV[NNV].Y1 := S[i].Y1+50;
                                    NV[NNV].X1 := NV[j].X1;
                                    NV[NNV].Y2 := NV[j].Y2;
                                    NV[NNV].X2 := NV[j].X2;
                                    NV[NNV].Dead := False;
                                    NV[j].Y2 := S[i].Y1-50;
                                end;
                            end
                            else
                            begin
                            	if S[i].Y1+50 > NV[j].Y2 then
                                begin
                                	NV[j].Dead := True;
                                end
                                else
                                begin
                                	NV[j].Y2 := S[i].Y1+50;
                                end;
                            end;
                        end;
                    end;
                end;
            end;
        end;
		Ok := True;
        if not Ok then
        begin
            for i := 1 to NNV do
        	    if not NV[i].Dead then
                begin
                    X := NV[i].X1+0.001;
					Y := NV[i].Y1+0.001;
                    if (X < NV[i].X2) and (Y < NV[i].Y2) then
                    begin
                    	Ok := False;
						Break;
                    end;
                end;

        end;
    end;

    procedure OutPut;
    var
    	F: Text;
        S: String;
    begin
    	Assign(F, OFN);
        ReWrite(F);
        if Ok then
        begin
            WriteLn(F, 'Ok');
        end
        else
        begin
        	Str(X:10:3, S);
            while S[1] = ' ' do
            	Delete(S, 1, 1);
        	Write(F, S, ' ');
        	Str(Y:10:3, S);
            while S[1] = ' ' do
            	Delete(S, 1, 1);
        	WriteLn(F, S);
        end;
        Close(F);
    end;

begin
	InPut;
    Proceed;
    OutPut;
end.