program Olymp;
{$B-}
const
	MaxN = 1000;
    IFN = 'olymp.in';
    OFN = 'olymp.out';
var
	N, Fastest: Word;
    MinT: LongInt;
    A: array [1..MaxN] of Word;

    procedure Input;
    var
    	i: Word;
        F: Text;
    begin
		Assign(F, IFN);
        ReSet(F);
        ReadLn(F, N);
        for i := 1 to N do
        begin
           	Read(F, A[i]);
            if not EoF(F) then ReadLn(F);
        end;
        Close(F);
    end;

    procedure Proceed;
    var
	    i: Word;
    begin
    	Fastest := 1;
        for i := 2 to N do
        	if A[i] < A[Fastest] then
            	Fastest := i;
        MinT := A[Fastest]*(N-2);						{outs F (N-2)}
        for i := 1 to N do
        	MinT := MinT+A[i];
        MinT := MinT-A[Fastest];                    {ins all (not F)}
    end;

    procedure OutPut;
    var
    	F: Text;
        i: LongInt;
    begin
    	Assign(F, OFN);
        ReWrite(F);
		WriteLn(F, MinT);
    	for i := 1 to Fastest-1 do
        begin
        	Write(F, i);
			Write(F, ' ');
			Write(F, Fastest);
			Write(F, ' ');
			WriteLn(F, Fastest);
        end;
    	for i := Fastest+1 to N-1 do
    	begin
        	Write(F, i);
			Write(F, ' ');
			Write(F, Fastest);
			Write(F, ' ');
			WriteLn(F, Fastest);
        end;
        WriteLn(F, Fastest, ' ', N);
        Close(F);
    end;

begin
	InPut;
    Proceed;
    OutPut;
end.