type tline = record
                    x1, y1: real;
                    x2, y2: real;
             end;

     tpoint = record
                    x, y: real;
              end;

     tabc = record
                  a, b, c: real;
            end;

     tpoly = record
                   nv: integer;
                   v: array[1..100] of record
                                             x: real;
                                             y: real;
                                       end;
             end;

     ppoly = ^tpoly;

var  poly: array[1..200] of ppoly;
     pf: array[1..200] of boolean;
     np: integer;
     nabc: tabc;
     cpoint: tpoint;

function findpoint(line1, line2: tabc): boolean;
var       i, j: integer;
          a1, b1, c1: real;
          a2, b2, c2: real;
          x, y: real;
begin
     a1 := line1.a;
     b1 := line1.b;
     c1 := line1.c;
     a2 := line2.a;
     b2 := line2.b;
     c2 := line2.c;
     if (a1 = 0) and (a2 = 0) then
     begin
          findpoint := false;
          exit;
     end;
     if (b1 = 0) and (b2 = 0) then
     begin
          findpoint := false;
          exit;
     end;
              if b2 <> b1 then
              begin
                   x := (c1 * a2 - c2 * a1) / (b2 * a1 - b1 * a2);
                   if a1 <> 0 then
                      y := -(b1 * x + c1) / a1
                   else
                       y := -(b2 * x + c2) / a2;
              end;

              cpoint.x := x;
              cpoint.y := y;
              findpoint := true;

end;

procedure getabc(x1, y1, x2, y2: real);
var      dy, dx: real;
         k: real;
         a, b, c: real;
begin
     dy := y2 - y1;
     dx := x2 - x1;
     if dx <> 0 then
     begin
          a := 1;
          k := dy / dx;
          b := -k;
          c := -(a * y1 + b * x1);
     end
     else
     begin
          a := 0;
          b := 1;
          c := -x1;
     end;
     nabc.a := a;
     nabc.b := b;
     nabc.c := c;
end;

function newpoly: integer;
var      i: integer;
begin
     if np < 200 then
        for i := 1 to 200 do
            if pf[i] = false then
            begin
                 new(poly[i]);
                 pf[i] := true;
                 inc(np);
                 newpoly := i;
                 exit;
            end;
     newpoly := -1;
end;

procedure cut(npoly: integer; x1, y1, x2, y2: real);
var       i, j: integer;
          line: tabc;
          st: tabc;
          vx1, vx2, vy1, vy2: real;
          f: boolean;
          rl, rs: real;
          rl1, rl2, rs1, rs2: real;
          x, y: real;
          np1, np2: integer;
          p1, p2: array[1..2] of tpoint;
          s1, s2: array[1..2] of integer;
          disp: boolean;
          now: integer;
          dy1: real;
          go: integer;
          g, k1, k2, cs, sn, dc: real;
begin
     getabc(x1, y1, x2, y2);
     line := nabc;
     g := sqrt(sqr(x1 - x2) + sqr(y1 - y2));
     k1 := abs(x2 - x1);
     k2 := abs(y2 - y1);
     cs := k2 / g;
     if cs <> 0 then
          dc := 50 / cs
     else
         dc := 50;
     {dc := 50 * cs;}
     line.c := line.c + dc;
     np1 := 0;
     for i := 1 to poly[npoly]^.nv do
     begin
          vx1 := poly[npoly]^.v[i].x;
          vy1 := poly[npoly]^.v[i].y;
          vx2 := poly[npoly]^.v[i + 1].x;
          vy2 := poly[npoly]^.v[i + 1].y;
          getabc(vx1, vy1, vx2, vy2);
          st := nabc;
          f := findpoint(line, st);
          x := cpoint.x;
          y := cpoint.y;
          if f = true then
          begin
               rl := sqrt(sqr(x1 - x2) + sqr(y1 - y2));
               rs := sqrt(sqr(vx1 - vx2) + sqr(vy1 - vy2));
               rl1 := sqrt(sqr(x1 - x) + sqr(y1 - y));
               rl2 := sqrt(sqr(x2 - x) + sqr(y2 - y));
               rs1 := sqrt(sqr(vx1 - x) + sqr(vy1 - y));
               rs2 := sqrt(sqr(vx2 - x) + sqr(vy2 - y));
               {if (rl1 <= rl) and (rl2 <= rl) then}
                  if (rs1 <= rs) and (rs2 <= rs) then
                  begin
                       inc(np1);
                       p1[np1].x := x;
                       p1[np1].y := y;
                       s1[np1] := i;
                  end;
          end;
     end;
     line.c := line.c - dc * 2;
     np2 := 0;
     for i := 1 to poly[npoly]^.nv do
     begin
          vx1 := poly[npoly]^.v[i].x;
          vy1 := poly[npoly]^.v[i].y;
          vx2 := poly[npoly]^.v[i + 1].x;
          vy2 := poly[npoly]^.v[i + 1].y;
          getabc(vx1, vy1, vx2, vy2);
          st := nabc;
          f := findpoint(line, st);
          x := cpoint.x;
          y := cpoint.y;
          if f = true then
          begin
               rl := sqrt(sqr(x1 - x2) + sqr(y1 - y2));
               rs := sqrt(sqr(vx1 - vx2) + sqr(vy1 - vy2));
               rl1 := sqrt(sqr(x1 - x) + sqr(y1 - y));
               rl2 := sqrt(sqr(x2 - x) + sqr(y2 - y));
               rs1 := sqrt(sqr(vx1 - x) + sqr(vy1 - y));
               rs2 := sqrt(sqr(vx2 - x) + sqr(vy2 - y));
               {if (rl1 <= rl) and (rl2 <= rl) then}
                  if (rs1 <= rs) and (rs2 <= rs) then
                  begin
                       inc(np2);
                       p2[np2].x := x;
                       p2[np2].y := y;
                       s2[np2] := i;
                  end;
          end;
     end;
     if np1 = 2 then
     begin
          now := newpoly;
          if now <> -1 then
          begin
               poly[now]^.nv := s1[2] - s1[1] + 2;
               poly[now]^.v[1].x := p1[1].x;
               poly[now]^.v[1].y := p1[1].y;
               i := s1[1];
               go := 2;
               repeat
                     inc(i);
                     if i > poly[now]^.nv then
                        i := 1;
                    poly[now]^.v[go].x := poly[npoly]^.v[i].x;
                    poly[now]^.v[go].y := poly[npoly]^.v[i].y;
                    inc(go);
               until i = s1[2];
               poly[now]^.v[go].x := p1[2].x;
               poly[now]^.v[go].y := p1[2].y;
               poly[now]^.v[go + 1].x := p1[1].x;
               poly[now]^.v[go + 1].y := p1[1].y;
          end;
     end;
     if np2 = 2 then
     begin
          now := newpoly;
          if now <> -1 then
          begin
               poly[now]^.nv := s2[2] - s2[1] + 2;
               poly[now]^.v[1].x := p1[1].x;
               poly[now]^.v[1].y := p1[1].y;
               i := s2[1];
               go := 2;
               repeat
                     inc(i);
                     if i > poly[now]^.nv then
                        i := 1;
                    poly[now]^.v[go].x := poly[npoly]^.v[i].x;
                    poly[now]^.v[go].y := poly[npoly]^.v[i].y;
                    inc(go);
               until i = s2[2];
               poly[now]^.v[go].x := p2[2].x;
               poly[now]^.v[go].y := p2[2].y;
               poly[now]^.v[go + 1].x := p1[1].x;
               poly[now]^.v[go + 1].y := p1[1].y;
          end;
     end;
     disp := false;
     if (np1 = 0) and (np2 = 0) then
     begin
          dy1 := -(poly[now]^.v[1].x * line.b + line.c);
          if line.b < 0 then
          begin
             if dy1 < poly[now]^.v[1].y then
             begin
                  dispose(poly[npoly]);
                  dec(np);
                  pf[npoly] := false;
                  disp := true;
             end;
          end
          else if line.b > 0 then
               begin
                  if dy1 > poly[now]^.v[1].y then
                  begin
                       dispose(poly[npoly]);
                       dec(np);
                       pf[npoly] := false;
                       disp := true;
                  end;
               end;
     end
     else
         if ((np1 = 2) and (np2 = 2)) and (disp = false) then
         begin
              dispose(poly[npoly]);
              dec(np);
              pf[npoly] := false;
         end;

end;

procedure solve;
var       i, j: integer;
          l: real;
          n: integer;
          x1, y1, x2, y2: real;

begin
     for i := 1 to 200 do
         pf[i] := false;
     readln(l);
     readln(n);
     new(poly[1]);
     pf[1] := true;
     poly[1]^.nv := 4;
     poly[1]^.v[1].x := 0;
     poly[1]^.v[1].y := 0;
     poly[1]^.v[2].x := 0;
     poly[1]^.v[2].y := l;
     poly[1]^.v[3].x := l;
     poly[1]^.v[3].y := l;
     poly[1]^.v[4].x := l;
     poly[1]^.v[4].y := 0;
     poly[1]^.v[5].x := 0;
     poly[1]^.v[5].y := 0;
     np := 1;
     for i := 1 to n do
     begin
          readln(x1, y1, x2, y2);
          for i := 1 to np do
              if pf[i] = true then
                   cut(i, x1, y1, x2, y2);
     end;
end;

var     i, j: integer;
        l1, l2: tabc;
        f: boolean;
        xa, ya: real;
begin
     assign(input, 'fire.in'); reset(input);
     assign(output, 'fire.out'); rewrite(output);
     solve;
     if np = 0 then
        writeln('OK');
     if np > 0 then
     for i := 1 to np do
         if pf[i] = true then
         begin
              xa := 0;
              ya := 0;
              for j := 1 to poly[i]^.nv do
              begin
                   xa := xa + poly[i]^.v[j].x;
                   ya := ya + poly[i]^.v[j].y;
              end;
              xa := xa / poly[i]^.nv;
              ya := ya / poly[i]^.nv;
              writeln(xa:0:3, ' ', ya:0:3);
              halt;
         end;
     {getabc(4, 1, 10, 4);
     writeln(nabc.a:0:3, ' ', nabc.b:0:3, ' ', nabc.c:0:3);
     l1 := nabc;
     getabc(5, 5, 5, 0);
     writeln(nabc.a:0:3, ' ', nabc.b:0:3, ' ', nabc.c:0:3);
     l2 := nabc;
     f := findpoint(l2, l1);
     if f then
        writeln(cpoint.x:0:3,  ' ', cpoint.y:0:3);}
     {solve;}
end.