{$A+,B-,D-,E-,F-,G-,I+,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
{task 4 day 2 Klimov M. 10 cl. Perm}
const
 inputfile='fire.in';
 outputfile='fire.out';
 ep=0.0001;
type
 real=extended;
var
 r:array[1..100]of record
  xb,yb,xe,ye:real;
 end;
 p:array[1..200]of record
  a,b,c:real;
 end;
 t:array[1..2500]of record
  x,y:real;
 end;
 x,y,z,sa,l:real;
 i,j,k,v,n:longint;
 b:boolean;
function inpl(x,y:real):boolean;
 var
  i:longint;
  x1,y1,x2,y2:real;
 begin
  inpl:=true;
  for i:=1 to n do
   if abs(p[i*2].b)>ep then
    begin
     y1:=-(p[i*2-1].c+p[i*2-1].a*x)/p[i*2].b;
     y2:=-(p[i*2].c+p[i*2].a*x)/p[i*2].b;
     if ((y1-y<ep)and(y-y2<ep))or((y2-y<ep)and(y-y1<ep)) then exit;
    end
   else
    begin
     x1:=-(p[i*2-1].c+p[i*2-1].b*y)/p[i*2].a;
     x2:=-(p[i*2].c+p[i*2].b*y)/p[i*2].a;
     if ((x1-x<ep)and(x-x2<ep))or((x2-x<ep)and(x-x1<ep)) then exit;
    end;
  inpl:=false;
 end;
begin
 assign(input,inputfile);
 assign(output,outputfile);
 reset(input);
 rewrite(output);
 read(l,n);
 for i:=1 to n do
  begin
   read(r[i].xb,r[i].yb,r[i].xe,r[i].ye);
   if r[i].ye<>r[i].yb then
    begin
     sa:=abs((r[i].ye-r[i].yb)/sqrt(sqr(r[i].xb-r[i].xe)+sqr(r[i].yb-r[i].ye)));
     z:=50/sa;
     p[i*2-1].a:=r[i].ye-r[i].yb;
     p[i*2-1].b:=r[i].xb-r[i].xe;
     p[i*2-1].c:=(r[i].xe-z)*r[i].yb-(r[i].xb-z)*r[i].ye;
     p[i*2].a:=r[i].ye-r[i].yb;
     p[i*2].b:=r[i].xb-r[i].xe;
     p[i*2].c:=(r[i].xe+z)*r[i].yb-(r[i].xb+z)*r[i].ye;
    end
   else
    begin
     sa:=abs((r[i].xe-r[i].xb)/sqrt(sqr(r[i].xb-r[i].xe)+sqr(r[i].yb-r[i].ye)));
     z:=50/sa;
     p[i*2-1].a:=r[i].ye-r[i].yb;
     p[i*2-1].b:=r[i].xb-r[i].xe;
     p[i*2-1].c:=r[i].xe*(r[i].yb-z)-r[i].xb*(r[i].ye-z);
     p[i*2].a:=r[i].ye-r[i].yb;
     p[i*2].b:=r[i].xb-r[i].xe;
     p[i*2].c:=r[i].xe*(r[i].yb+z)-r[i].xb*(r[i].ye+z);
    end
  end;
 p[n*2+1].a:=0;
 p[n*2+1].b:=l;
 p[n*2+1].c:=0;
 p[n*2+2].a:=0;
 p[n*2+2].b:=l;
 p[n*2+2].c:=-l*l;
 p[n*2+3].a:=l;
 p[n*2+3].b:=0;
 p[n*2+3].c:=0;
 p[n*2+4].a:=l;
 p[n*2+4].b:=0;
 p[n*2+4].c:=-l*l;
 v:=4;
 t[1].x:=0;
 t[1].y:=0;
 t[2].x:=l;
 t[2].y:=0;
 t[3].x:=l;
 t[3].y:=l;
 t[4].x:=0;
 t[4].y:=l;
 for i:=1 to 2*n+3 do
  for j:=i+1 to 2*n+4 do
   begin
    z:=p[i].a*p[j].b-p[j].a*p[i].b;
    if abs(z)>ep then
     begin
      x:=(p[i].b*p[j].c-p[j].b*p[i].c)/z;
      y:=(p[j].a*p[i].c-p[i].a*p[j].c)/z;
      if inpl(x,y) then
       begin
        b:=true;
        for k:=1 to v do
         if (abs(t[k].x-x)<ep)and(abs(t[k].y-y)<ep)then
          b:=false;
        if b and(v<2500)and(x>-ep)and(x-l<ep)and(y>-ep)and(y-l<ep) then
         begin
          inc(v);
          t[v].x:=x;
          t[v].y:=y;
         end;
       end;
     end;
   end;
 for i:=1 to v-2 do
  for j:=i+1 to v-1 do
   for k:=j+1 to v do
    begin
     x:=(t[i].x+t[j].x+t[k].x)/3;
     y:=(t[i].y+t[j].y+t[k].y)/3;
     if not inpl(x,y) then
      begin
       writeln('Yes');
       write(x:0:3,' ',y:0:3);
       close(input);
       close(output);
       halt;
      end;
    end;
 writeln('No');
 close(input);
 close(output);
end.
