{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q+,R-,S-,T-,V+,X+,Y-}
{$M 16384,0,655360}
program p1116_4;
const
	inpfile = 'fire.in';
	outfile = 'fire.out';
type
	TPoint = Record
		x, y : Real;
	end;
	TVector = Record
		b, e : TPoint;
	end;
var
	l : Word;
	n, i, dx, dy : Byte;
	x1, y1, x2, y2 : Real;
	x, y, tt : array [1..200] of Real;
	xm, ym, tm : array [1..200] of ShortInt;
	k : Integer;

procedure Sort (var t : array of Real; var m : array of ShortInt; l, r : Word);
var
	i, j : Word;
	k : ShortInt;
	p : Real;
begin
	if l >= r - 1 then
	begin
		if t [l] > t [r] then
		begin
			p := t [l];
			t [l] := t [r];
			t [r] := p;
			k := m [l];
			m [l] := m [r];
			m [r] := k;
		end;
	end
	else
	begin
		Sort (t, m, l, (r + l) div 2);
		Sort (t, m, (r + l) div 2 + 1, r);
		i := l;
		j := (r + l) div 2 + 1;
		for k := 1 to r - l + 1 do
		begin
			if i < (r + l) div 2 + 1 then
			begin
				if (j < r + 1) and (t [j] < t [i]) then
				begin
					tt [k] := t [j];
					tm [k] := m [j];
					Inc (j);
				end
				else
				begin
					tt [k] := t [i];
					tm [k] := m [i];
					Inc (i);
				end;
			end
			else
			begin
				tt [k] := t [j];
				tm [k] := m [j];
				Inc (j);
			end;
		end;
		Move (tt [1], t [l], (r - l + 1) * 2);
		Move (tm [1], m [l], (r - l + 1) * 2);
	end;
end;

begin
	Assign (input, inpfile);
	Reset (input);
	ReadLn (l);
	ReadLn (n);
	dx := 0;
	dy := 0;
	for i := 1 to n do
	begin
		ReadLn (x1, y1, x2, y2);
		if x1 = x2 then
		begin
			Inc (dx);
			x [dx] := x1 - 50;
			xm [dx] := 1;
			Inc (dx);
			x [dx] := x1 + 50;
			xm [dx] := -1;
		end
		else if y1 = y2 then
		begin
			Inc (dy);
			y [dy] := y1 - 50;
			ym [dy] := 1;
			Inc (dy);
			y [dy] := y1 + 50;
			ym [dy] := -1;
		end;
	end;
	Close (input);
	if dx > 0 then Sort (x, xm, 0, dx - 1);
	if dy > 0 then Sort (y, ym, 0, dy - 1);
	if (x [1] > 0) or (dx = 0) then
	begin
		x1 := 0;
	end
	else
	if (x [dx] < l) then
	begin
		x1 := l;
	end
	else
	begin
		x1 := -1;
		k := 0;
		for i := 1 to dx do
		begin
			k := k + xm [i];
			if (k = 0) and not (x [i] > l) then
				if (i < dx) and (x [i + 1] > x [i]) then
				begin
					x1 := (x [i + 1] + x [i]) / 2;
					break;
				end;
		end;
	end;
	if x1 < 0 then
	begin
		Assign (output, outfile);
		Rewrite (output);
		Write ('OK');
		Close (output);
		halt (0);
	end;
	if (y [1] > 0) or (dy = 0) then
	begin
		y1 := 0;
	end
	else
	if (y [dy] < l) then
	begin
		y1 := l;
	end
	else
	begin
		y1 := -1;
		k := 0;
		for i := 1 to dy do
		begin
			k := k + ym [i];
			if (k = 0) and not (y [i] > l) then
				if (i < dy) and (y [i + 1] > y [i]) then
				begin
					y1 := (y [i + 1] + y [i]) / 2;
					break;
				end;
		end;
	end;
	if y1 < 0 then
	begin
		Assign (output, outfile);
		Rewrite (output);
		Write ('OK');
		Close (output);
		halt (0);
	end;
	Assign (output, outfile);
	Rewrite (output);
	WriteLn (x1 : 0 : 3, ' ', y1 : 0 : 3);
	Close (output);
end.