#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>

int *parent, *size, *brother, *lastson, *firstson, *arrested;
int arr_no;

int K;
void parse( int i )
{
  int son, par;

  if (size[i] < K)
    return;
  son = firstson[i];
  while (son != 0)
  {
    parse(son);
    son = brother[son];
  }
  if (size[i] < K)
    return;
  arrested[arr_no++] = i;
  par = parent[i];
  while (par != 0)
  {
    size[par] -= size[i];
    par = parent[par];
  }
}

void fillsize( int i )
{
  int son = firstson[i];

  size[i] = 1;
  while (son != 0)
  {
    fillsize(son);
    size[i] += size[son];
    son = brother[son];
  }
}

int main( void )
{
  int N, i;

  freopen("org.in", "r", stdin);
  freopen("org.out", "w", stdout);
  scanf("%i %i", &K, &N);
  parent = calloc(N + 1, 2);
  size = calloc(N + 1, 2);
  brother = calloc(N + 1, 2);
  lastson = calloc(N + 1, 2);
  firstson = calloc(N + 1, 2);
  arrested = calloc(N + 1, 2);
  if (!(parent && size && brother && lastson && firstson && arrested))
    return 0;
  for (i = 2; i <= N; i++)
  {
    int par;

    scanf("%i", &par);
    parent[i] = par;
    size[i]++;
    if (firstson[par] == 0)
      firstson[par] = i;
    else
      brother[lastson[par]] = i;
    lastson[par] = i;
  }
  fillsize(1);
  parse(1);
  printf("%i\n", arr_no);
  for (i = 0; i < arr_no; i++)
    printf("%i ", arrested[i]);
  return 0;
}
