#include <stdio.h>

int g[100][100], G[100][100];
int N, K;

int seq[1000], size;
int bt( int i )
{
  int j;

  seq[size++] = i;
  for (j = 1; j <= N; j++)
    if (g[i][j])
  {
    int k, l, m;

    g[i][j] = g[j][i] = 0;
    for (k = 1; k <= N; k++)
      for (l = 1; l <= N; l++)
        G[k][l] = g[k][l];
    for (k = 1; k <= N; k++)
      for (l = 1; l <= N; l++)
        for (m = 1; m <= N; m++)
          if (G[l][k] && G[k][m])
            G[m][l] = G[l][m] = 1;
    if (!G[K][j] && (j != K))
    {
      seq[size++] = j;
      return 1;
    }
    else if (bt(j))
      return 1;
    g[i][j] = g[j][i] = 1;
  }
  size--;
  return 0;
}

int main( void )
{
  int i;

  freopen("castle.in", "r", stdin);
  freopen("castle.out", "w", stdout);
  scanf("%i %i", &N, &K);
  for (i = 1; i <= N; i++)
  {
    int x;

    while (1)
    {
      scanf("%i", &x);
      if (x == 0)
        break;
      g[i][x] = 1;
    }
  }
  if (bt(K))
  {
    printf("Yes\n"
           "%i\n", size);
    for (i = 0; i < size; i++)
      printf("%i ", seq[i]);
  }
  else
    printf("No\n");
  return 0;
}
