{ த᪠  誮쭨 -࣠ 2001   }
{ ࠪ᪨                                            }
{ : "㣮쭨"                                    }
{ : ३ ⠭                                    }
{ 襭: ⠭⨭ 襢                               }
{ :                                         }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P+,Q+,R+,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}
type
  real=extended;
const
  eps=1e-5;
type
  TPoint=record
    x,y:real;
    end;
  TLine=record
    a,b,c:real;
    end;
var
  N:integer;
  data:array[1..101]of TPoint;
  best:integer;
  sol:TPoint;
  s:real;
procedure Make(p:integer;z:TPoint;var l:TLine);
  begin
  with l do
    begin
    a:=data[p+1].x-data[p].x;
    b:=data[p+1].y-data[p].y;
    c:=-a*z.x-b*z.y;
    end;
  end;
function Det(a,b,c,d:real):real;
  begin
  Det:=a*d-b*c;
  end;
function Bet(a,b,c:real):boolean;
  begin
  Bet:=abs(abs(a-b)+abs(b-c)-abs(a-c))<eps;
  end;
procedure Check(z:TPoint);
  var
    cnt:integer;
    i:integer;
    l,l1:TLine;
    z1:TPoint;
    d,dx,dy:real;
  begin
  cnt:=0;
  for i:=1 to N do
    begin
    Make(i,z,l);
    with l1 do
      begin
      a:=data[i+1].y-data[i].y;
      b:=data[i].x-data[i+1].x;
      c:=-a*data[i].x-b*data[i].y;
      end;
    if abs(l1.a*z.x+l1.b*z.y+l1.c)<eps then
      z1:=z
    else
      begin
      d:=Det(l.a,l.b,l1.a,l1.b);
      dx:=Det(l.c,l.b,l1.c,l1.b);
      dy:=Det(l.a,l.c,l1.a,l1.c);
      if abs(d)<eps then continue; {}
      z1.x:=-dx/d;
      z1.y:=-dy/d;
      end;
    if Bet(data[i].x,z1.x,data[i+1].x) and
       Bet(data[i].y,z1.y,data[i+1].y) then
         inc(cnt);
    end;

  if cnt>best then
    begin
    best:=cnt;
    sol:=z;
    end;
  end;
procedure Check1(z:TPoint);
  var
    i:integer;
    s:real;
  begin
  for i:=1 to N do
    begin
    s:=z.x*data[i].y-z.y*data[i].x
       +data[i].x*data[i+1].y-data[i].y*data[i+1].x
       +data[i+1].x*z.y-data[i+1].y*z.x;
    if s<-eps then
      exit;
    end;
  Check(z);
  end;
var
  i,j,di,dj:integer;
  l1,l2:TLine;
  d,dx,dy:real;
  z:TPoint;
begin
assign(input,'input.txt');
reset(input);
assign(output,'output.txt');
rewrite(output);
read(N);
for i:=1 to N do
  read(data[i].x,data[i].y);
data[N+1]:=data[1];

best:=-1;
for i:=1 to N do
  Check(data[i]);
for i:=1 to N do
  for j:=i+1 to N do
    for di:=0 to 1 do
      for dj:=0 to 1 do
        begin
        Make(i,data[i+di],l1);
        Make(j,data[j+dj],l2);
        d:=Det(l1.a,l1.b,l2.a,l2.b);
        dx:=Det(l1.c,l1.b,l2.c,l2.b);
        dy:=Det(l1.a,l1.c,l2.a,l2.c);
        if abs(d)>eps then
          begin
          z.x:=-dx/d;
          z.y:=-dy/d;
          Check1(z);
          end;
        end;

writeln(best);
writeln(sol.x:0:5,' ',sol.y:0:5);
end.