program StringComparing;



type pLttr = ^Lttr;
     Lttr = record
      c: char;
      next: pLttr;
     end;



function H (hd1, hd2: pLttr): word;

var curH: word;
    a, b: char;

begin
 curH := 0;
 while ((hd1 <> nil) or (hd2 <> nil)) do
 begin
  if (hd1 <> nil) then
  begin
   a := hd1^.c;
   hd1 := hd1^.next;
  end
  else
   a := '*';
  if (hd2 <> nil) then
  begin
   b := hd2^.c;
   hd2 := hd2^.next;
  end
  else
   b := '*';
  if (a <> b) then curH := curH + 1;
 end;
 H := curH;
end;

procedure AddStarAfter (n: word; head: pLttr);

var i: word;
    cur: pLttr;

begin
 for i := 1 to n - 1 do
 begin
  head := head^.next;
 end;
 cur := head^.next;
 new (head^.next);
 head^.next^.c := '*';
 head^.next^.next := cur;
end;


procedure NoStars (var head: pLttr);

var cur: pLttr;

begin
 while ((head <> nil) and (head^.c = '*')) do
 begin
  cur := head^.next;
  dispose (head);
  head := cur;
 end;
 cur := head;
 while (cur^.next <> nil) do
  if (cur^.next^.c = '*') then
  begin
   head := cur^.next^.next;
   dispose (cur^.next);
   cur^.next := head;
  end
  else
   cur := cur^.next;
end;

procedure AddToEnd (var head: pLttr; newLttr: char);

var cur: pLttr;

begin
 if (head = nil) then
 begin
  new (head);
  head^.c := newLttr;
  head^.next := nil;
 end
 else
 begin
  cur := head;
  while (cur^.next <> nil) do
   cur := cur^.next;
  new (cur^.next);
  cur^.next^.c := newLttr;
  cur^.next^.next := nil;
 end;
end;


procedure print (var f: text; head: pLttr);

begin
 while (head <> nil) do
 begin
  write (f, head^.c);
  head := head^.next;
 end;
 writeln (f, '');
end;


var f: text;
    temp3, temp2, len1, len2, l1, l2, minRES, RES: word;
    head1, head2: pLttr;
    temp1: char;


procedure Check;

var tmpC: word;

begin
 if (H (head1, head2) = minRES) then
 begin
  if (l1 < l2) then for tmpC := 1 to l2 - l1 do addtoend (head1, '*');
  if (l2 < l1) then for tmpC := 1 to l1 - l2 do addtoend (head2, '*');
  rewrite (f);
  writeln (f, minRES);
  print (f, head1);
  print (f, head2);
  close (f);
  halt (0);
 end;
end;


begin
 head1 := nil;
 head2 := nil;
 assign (f, 'input.txt');
 reset (f);
 read (f, len1);
 l1 := len1;
 readln (f, len2);
 l2 := len2;
 repeat
  read (f, temp1);
  if (temp1 > #13) then AddToEnd (head1, temp1);
 until (temp1 = #13);
 repeat
  read(f, temp1);
  if (temp1 > #13) then AddToEnd (head2, temp1);
 until (temp1 = #13);
 close (f);
 assign (f, 'output.txt');
 rewrite (f);
 close (f);
 minRES := abs (len1 - len2);
 check;
 if (len1 = len2 - 1) then
 for temp2 := 1 to len1 - 1 do
  begin
   AddStarAfter (temp2, head1);
   l1 := len1 + 1;
   Check;
   NoStars (head1);
   l1 := len1;
  end;
 if (len2 = len1 - 1) then
 for temp2 := 1 to len2 - 1 do
  begin
   AddStarAfter (temp2, head2);
   l2 := len2 + 1;
   Check;
   NoStars (head2);
   l2 := len2;
  end;
 if (len1 = len2) then
 for temp2 := 1 to len1 do
 for temp3 := 1 to len1 do
 begin
  AddStarAfter (temp2, head1);
  AddStarAfter (temp3, head2);
  l1 := len1 + 1;
  l2 := len1 + 1;
  Check;
  NoStars (head1);
  NoStars (head2);
  l1 := len1;
  l2 := len1;
 end;
end.