#include <stdio.h>

#define MAXL 250
int M, N;
char s1[MAXL+2], s2[MAXL+2];
char a[MAXL][MAXL];

int ga(int i, int j)
{
  if ((i >= M) && (j >= N)) return 0;
  if (i >= M) return N-j;
  if (j >= N) return M-i;
  return a[i][j];
}

int main(void)
{
  FILE *fi, *fo;
  int i, j;
  int d1, d2, d3;
  fi = fopen("input.txt", "rt");
  fscanf(fi, "%d %d\n", &M, &N);
  if (M > MAXL) return 0;
  if (N > MAXL) return 0;
  fgets(s1, MAXL+2, fi);
  fgets(s2, MAXL+2, fi);
  fclose(fi);

  for (i=M-1; i>=0; i--)
  for (j=N-1; j>=0; j--) {
    d1 = ga(i+1, j+1);
    if (s1[i] != s2[j]) d1++;
    d2 = 1+ga(i+1, j);
    d3 = 1+ga(i, j+1);
    if (d2 < d1) d1 = d2;
    if (d3 < d1) d1 = d3;
    a[i][j] = d1;
  }

  fo = fopen("output.txt", "wt");
  fprintf(fo, "%d\n", a[0][0]);
  i = 0;
  j = 0;
  while ((i < M) || (j < N)) {
    if (i >= M) {
      fputc('*', fo);
      j++;
    } else
    if (j >= N) {
      fputc(s1[i], fo);
      i++;
    } else {
     d1 = ga(i+1, j+1);
     if (s1[i] != s2[j]) d1++;
     d2 = 1+ga(i+1, j);
     d3 = 1+ga(i, j+1);
     if (a[i][j] == d1) {
       fputc(s1[i], fo);
       i++;
       j++;
     } else
     if (a[i][j] == d2) {
       fputc(s1[i], fo);
       i++;
     } else
     if (a[i][j] == d3) {
       fputc('*', fo);
       j++;
     }
    }
  }
  fputc('\n', fo);
  i = 0;
  j = 0;
  while ((i < M) || (j < N)) {
    if (i >= M) {
      fputc(s2[j], fo);
      j++;
    } else
    if (j >= N) {
      fputc('*', fo);
      i++;
    } else {
     d1 = ga(i+1, j+1);
     if (s1[i] != s2[j]) d1++;
     d2 = 1+ga(i+1, j);
     d3 = 1+ga(i, j+1);
     if (a[i][j] == d1) {
       fputc(s2[j], fo);
       i++;
       j++;
     } else
     if (a[i][j] == d2) {
       fputc('*', fo);
       i++;
     } else
     if (a[i][j] == d3) {
       fputc(s2[j], fo);
       j++;
     }
    }
  }
  fclose(fo);
  return 0;
}