#define MAX             11

#include <stdio.h>


void input ();
void solve ();
void output ();
int goes (int num);
int recurs (int fig);


int a [MAX], array [128] [2], ans, matrix [MAX] [MAX], n, m, p;


main ()
 {
   input ();
   solve ();
   output ();

   return (0);
 }


void input ()
 {
   char chr;

   FILE * file = fopen ("input.txt", "r");

   fscanf (file, "%d %d %d", & n, & m, & p);

   for (int i = 0; i < p; i ++)
    fscanf (file, "%d", & a [i]);

   for (i = 0; i < m * n; i ++)
    {
      fscanf (file, "\n%c%d", & chr, & array [i] [1]);
      array [i] [0] = chr - 'a';
      array [i] [1] --;
    }

   fclose (file);

   for (i = p - 1; i >= 0; i --)
    for (int j = 0; j < p; j ++)
     if (a [j] < a [j + 1])
      a [j] ^= a [j + 1], a [j + 1] ^= a [j], a [j] ^= a [j + 1];
 }


void solve ()
 {
   int start = 0, end = m * n, mid;

   if (! goes (0))
    {
      ans = 0;
      return;
    }

   while (end - start > 1)
    {
      mid = (start + end) / 2;

      if (goes (mid))
       start = mid;
      else end = mid;
    }

   if (goes (end))
    ans = end + 1;
   else
    {
      goes (start);
      ans = start + 1;
    }
 }


void output ()
 {
   FILE * file = fopen ("output.txt", "w");
   fprintf (file, "%d\n", ans);

   if (ans)
    {
      for (int i = 0; i < m; i ++)
       {
        for (int j = 0; j < n; j ++)
         if (matrix [j] [i] < 0)
          fprintf (file, "%d", -matrix [j] [i]);
         else fprintf (file, "0");

        fprintf (file, "\n");
       }
    }

   fclose (file);
 }


int goes (int num)
 {
   for (int i = 0; i < n; i ++)
    for (int j = 0; j < m; j ++)
     matrix [i] [j] = 0;

   for (i = 0; i < num; i ++)
    matrix [array [i] [0]] [array [i] [1]] = 1;

   return (recurs (0));
 }


int recurs (int fig)
 {
   int space;
   if (fig == p) return (1);

   for (int i = 0; i < m; i ++)
    {
      space = 0;

    for (int j = 0; j < n; j ++)
     {
       if (matrix [i] [j]) space = 0;
       else space ++;

       if (space == a [fig])
        {
          for (int k = -1; k <= space; k ++)
           if ((j - space + k + 1 >= 0) && (j - space + k + 1 < n))
            {
              if ((k == -1) || (k == space))
               matrix [i] [j - space + k + 1] ++;
              else matrix [i] [j - space + k + 1] = - a [fig];

              if (i > 0) matrix [i - 1] [j - space + k + 1] ++;
              if (i < m - 1) matrix [i + 1] [j - space + k + 1] ++;
            }

          if (recurs (fig + 1)) return (1);

          for (k = -1; k <= space; k ++)
           if ((j - space + k + 1 >= 0) && (j - space + k + 1 < n))
            {
              if ((k == -1) || (k == space))
               matrix [i] [j - space + k + 1] --;
              else matrix [i] [j - space + k + 1] = 0;

              if (i > 0) matrix [i - 1] [j - space + k + 1] --;
              if (i < m - 1) matrix [i + 1] [j - space + k + 1] --;
            }
        }
     }
    }

   for (int j = 0; j < n; j ++)
    {
      space = 0;

    for (int i = 0; i < m; i ++)
     {
       if (matrix [i] [j]) space = 0;
       else space ++;

       if (space == a [fig])
        {
          for (int k = -1; k <= space; k ++)
           if ((i - space + k + 1 >= 0) && (i - space + k + 1 < m))
            {
              if ((k == -1) || (k == space))
               matrix [i - space + k + 1] [j] ++;
              else matrix [i - space + k + 1] [j] = - a [fig];

              if (j > 0) matrix [i - space + k + 1] [j - 1] ++;
              if (j < n - 1) matrix [i - space + k + 1] [j + 1] ++;
            }

          if (recurs (fig + 1)) return (1);

          for (k = -1; k <= space; k ++)
           if ((i - space + k + 1 >= 0) && (i - space + k + 1 < m))
            {
              if ((k == -1) || (k == space))
               matrix [i - space + k + 1] [j] --;
              else matrix [i - space + k + 1] [j] = 0;

              if (j > 0) matrix [i - space + k + 1] [j - 1] --;
              if (j < n - 1) matrix [i - space + k + 1] [j - 1] --;
            }
        }
     }
    }

   return (0);
 }