{.$UNDEF DEBUG}

Uses SysUtils, CRT;

Const
  InpF='INPUT.TXT';
  OutpF='OUTPUT.TXT';
  DebugPath='c:\work\1\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
Const
 MaxN=500;
 MaxL=255;
 Let:Set Of Char= ['a'..'z'];
 Num:Set Of Char= ['0'..'9'];

Type
 TVar=record
       Count:Integer;
       Values: Array [1..30] of Longint;
       Names: Array [1..30] of Char;
       Index: Array ['a'..'z'] of Byte;
      End;

Type
 OpType=(_set, _print, _if, _return);

Type
 TProc=Record
        Name: Char;
        Params: TVar;
        beg, en: Integer;
       End;

Var
 Task: String;
 P: Array [1..MaxN] of TProc;
 N, M: Integer;
 A, Source: Array [1..MaxN] of String[MaxL];
 SSize: Integer;
 Link: Array [1..MaxN] of Integer;
 Out: Text;
 CurPos: Integer;
 isDebug: Boolean;
 GoToPoint : Integer;
 Next:Array[0..MaxN] of Integer;
 GoToStack, Stack: Longint;
 CurVar: TVar;
 OldVar, NewVar: Longint;

Procedure Stop(Op: OpType; Q: Char; X, Y: Longint); forward;


Procedure SetVar(var V: TVar; Name: Char; Value: Longint);
 Begin
  if V.Index[Name]=0 Then begin
   Inc(V.Count);
   V.names[V.Count]:=name;
   V.Index[Name]:=V.Count;
   V.values[V.Count]:=Value
  end else
   V.Values[V.Index[Name]]:=Value;
 End;

Function isNum(var S: String): Boolean;
 var
  i: Integer;
  q: Boolean;
 Begin
  q:=True;
  for i:=1 to Length(S) do q:=q and (S[i] in Num);
  isNum:=q;
 End;

Function GetVar(var V: TVar; Name: Char): Longint;
 begin
  if V.Index[Name]=0 Then
   SetVar(V, Name, 0);
  GetVar:=V.Values[V.Index[Name]];
 end;

Procedure delall(var S:String; A: String);
 Var i, j: Integer;
     ok: Boolean;
 begin
  i:=1;
  While i<=Length(S) do begin
   ok:=True;
   for j:=1 to Length(A) do
    if S[i]=A[j] then begin
     delete(S, i, 1);
     ok:=False;
     break;
    end;
   if ok Then
    Inc(i);
  End;
 end;


Procedure init;
 Var i, j: Integer;
     S: String;
     Main: Array [1..MaxN] of String[MaxL];
     MainLink: array [1..MaxN] of Integer;
     isFunc: Boolean;
     Pr: Integer;
 Begin
  Assign(Input, Inp);
  Reset(input);
  ReadLn(Task);
  Task:=AnsiLowerCase(Task);
  N:=0;
  SSize:=0;
  Pr:=0;
  While Not Eof(Input) do begin
   ReadLn(S);
   Inc(SSize);
   Source[SSize]:=S;
   S:=AnsiLowerCase(S);
   delAll(S, ' ');
   if (S<>'') and (S[1]<>'#') then begin
    Inc(N);
    A[N]:=S;
    if (S<>'}') Then begin
     Link[N]:=SSize;
     Next[Pr]:=SSize;
     Pr:=SSize;
    End;
   End;
  End;
  i:=1;
  M:=0;
  isFunc:=False;
  While i<=N do Begin
   if isFunc then
    Inc(i);
   if copy(A[i], 1, 8)='function' then isFunc:=True;
   if Not isFunc Then Begin
    Inc(M);
    Main[M]:=A[i];
    MainLink[M]:=Link[i];
    for j:=i to N-1 do begin
     A[j]:=A[j+1];
     Link[j]:=Link[j+1];
    End;
    Dec(N);
   End;
   if copy(A[i], 1, 1)='}' then begin
    isFunc:=False;
    Inc(i);
   end;
  End;
  Inc(N);
  A[N]:='function?(){';
  Link[N]:=MainLink[1];
  for i:=1 to M do begin
   Inc(N);
   A[N]:=main[i];
   Link[N]:=MainLink[i];
  end;
  Inc(N);
  A[N]:='}';
  M:=0;
  j:=0;
  i:=1;
  FillChar(P, sizeOf(P), 0);
  While i<=N do begin
   if copy(A[i], 1, 8)='function' then begin
    Inc(M);
    j:=i+1;
    While A[j]<>'}' do Inc(j);
    P[M].Name:=Copy(A[i], 9, 1)[1];
    P[M].Beg:=i+1;
    P[M].En:=j-1;
    S:=Copy(A[i], 10, Length(A[i]));
    DelAll(S, '(){},');
    P[M].Params.Count:=0;
    for j:=1 to Length(S) do
     SetVar(P[M].Params, S[i], 0);
   end;
   Inc(i);
  end;
  Close(Input);
  Assign(Out, Outp);
  rewrite(Out);
 End;

Function FindFunc(X: Char; var Index: Integer): Integer;
 var i: Integer;

 Begin
  Index:=-1;
  For i:=1 to M do
   if P[i].name=X Then
    Index:=i;
  FindFunc:=Index;
 End;

Function ExecFunc(Var V: TVar; Var P: TProc; S: String): Longint; forward;

Function Calc(Var V: TVar; S: String):Longint;
 var i, j: Integer;
     Y: TProc;
     R: Longint;
 Begin
  Inc(Stack);
  if (Length(S)=1) and (S[1] in Let) Then begin
   R:=GetVar(V, S[1]);
   calc:=R;
   Setvar(CurVar, S[1], R);
   Dec(Stack);
   exit;
  end;

  if isNum(S) Then  begin
   Calc:=StrToInt(S);
   Dec(Stack);
   exit;
  end;

  i:=pos('+', S);
  if i<>0 Then begin
   calc:=calc(V, copy(S, 1, i-1))+calc(V, copy(S, i+1, Length(S)));
   Dec(Stack);
   exit;
  end;

  i:=pos('-', S);
  if i<>0 Then begin
   calc:=calc(V, copy(S, 1, i-1))-calc(V, copy(S, i+1, Length(S)));
   Dec(Stack);
   exit;
  end;

  i:=pos('*', S);
  if i<>0 Then begin
   calc:=calc(V, copy(S, 1, i-1))*calc(V, copy(S, i+1, Length(S)));
   Dec(Stack);
   exit;
  end;

  i:=pos('<', S);
  if i<>0 Then begin
   calc:=Longint(calc(V, copy(S, 1, i-1))<calc(V, copy(S, i+1, Length(S))));
   Dec(Stack);
   exit;
  end;

  i:=pos('=', S);
  if i<>0 Then begin
   calc:=Longint(calc(V, copy(S, 1, i-1))=calc(V, copy(S, i+1, Length(S))));
   Dec(Stack);
   exit;
  end;

  i:=pos('>', S);
  if i<>0 Then begin
   calc:=Longint(calc(V, copy(S, 1, i-1))>calc(V, copy(S, i+1, Length(S))));
   Dec(Stack);
   exit;
  end;

  if (pos('(', S)<>0)and(FindFunc(S[1], i)<>-1) Then begin
   R:=ExecFunc(V, P[i], S);
   calc:=R;
   Dec(Stack);
   exit;
  End;
  Dec(Stack);
 End;


Function RunFunc(var X: TProc): Longint;
 Var V: TVar;
     i: Integer;
     Ret: Longint;

  Function RunCommand(S:String; Var Ret: Longint): Boolean;
   var R : Longint;
       P: Integer;
   Begin
    RunCommand:=True;
    if S[2]='=' Then begin
     P:=CurPos;
     R:=Calc(V, Copy(S, 3, length(S)));
     Curpos:=P;
     Stop(_Set, S[1], GetVar(V, S[1]), R);
     SetVar(V, S[1], R);
    End;
    if Copy(S, 1, 5)='print' then begin
     R:=Calc(V, Copy(S, 6, Length(S)));
     Stop(_print, ' ', R, 0);
     WriteLn(Out, R);
    End;

    if Copy(S, 1, 2)='if' then begin
     r:=Getvar(V, S[3]);
     Stop(_if, ' ', r, 0);
     if r<>0 Then begin
      R:=CurPos;
      RunCommand:=RunCommand(Copy(S, 8, Length(S)), ret);
      Curpos:=R;
     end;
    End;

    if Copy(S, 1, 6)='return' then begin
     P:=CurPos;
     ret:=calc(V, Copy(S, 7, Length(S)));
     CurPos:=P;
     Stop(_return, ' ', ret, 0);
     RunCommand:=false;
    End;
   End;

 Begin
  V:=X.Params;
  i:=X.Beg;
  While (i<=X.En) do begin
   CurPos:=Link[i];
   if not RunCommand(A[i], Ret) Then Break;
   Inc(i);
  end;
  RunFunc:=Ret;
 End;

 Function ExecFunc(Var V: TVar; Var P: TProc; S: String): Longint;
  var i, j: Integer;
      Q: String;
  Begin
    S:=Copy(S, pos('(', S), Length(S))+',';
    delAll(S, '()');
    i:=1;
    While S<>'' do begin
     Q:=Copy(S, 1, Pos(',', S)-1);
     if q<>'' Then Begin
      P.Params.Values[i]:=Calc(V, Q);
      Inc(i);
     end;
     Delete(S, 1, Length(Q)+1);
    end;
{   Write('Exec ',P.Name,'(');
    For i:=1 to P.Params.Count do write(P.params.Names[i],' ',P.params.values[i],',');
    WriteLn(')');}
//    FillChar(CurVar, SizeOf(Curvar), 0);
    ExecFunc:=RunFunc(P);
  End;

procedure done; forward;

Procedure Stop(Op: OpType; Q: Char; X, Y: Longint);
 var Key: Byte;

 Procedure Print;
  var i: Integer;
  Begin
   ClrScr;
   for i:=CurPos-5 to CurPos+5 do
    if i>=1 Then begin
     if CurPos=i Then writeLn('> ', Source[i])
                 else writeLn('  ',Source[i]);
    End else
     WriteLn;

    WriteLn('------------------------------------------------------------------');
    for i:=1 to CurVar.Count do
     WriteLn(CurVar.Names[i], ' = ', Curvar.Values[i]);
    case Op of
     _set : WriteLn(Q, ': old = ',X,' new = ',y);
     _return:WriteLn('return ', X);
     _print:WriteLn('print ', X);
     _if:WriteLn('if ', X);
    end;
  End;

 Begin
  if isDebug and (((CurPos=GotoPoint)And(GotoStack=Stack)) or (Gotopoint=0)) Then begin
   Print;
   FillChar(CurVar, SizeOf(Curvar), 0);
   repeat
    Key:=Byte(Readkey);
    Case key of
     65:GoToPoint:=0;
     66:begin gotoPoint:=Next[CurPos]; GoToStack:=Stack end;
     95:done;
    end;
   Until (key=65)or(key=66)or(key=95);
  End;
 End;


Procedure Debug;
 Var i: Integer;
 Begin
  isDebug:=True;
  GoToPoint:=0;
  RunFunc(P[FindFunc('?', i)]);
 End;

Procedure solve;
 var i: Integer;
 Begin
  Stack:=0;
  isDebug:=False;
  if task='run' then
   RunFunc(P[FindFunc('?', i)]);
  if task='debug' then Debug;

 End;

procedure done;
 var i, j : Integer;
 Begin
{  For i:=1 to N do
   WriteLn(Out, Link[i], ' ', A[i]);}
  close(Out);
  halt(0);
 End;

begin
 Init;
 Solve;
 Done;
End.
