#define MAX					256

#include <stdio.h>

void input ();
void solve ();
void output ();

int n, t [MAX], r [MAX], ptr = 0, dynamics [MAX], last [MAX], answer [MAX], been [MAX];

main ()
 {
   input ();
   solve ();
   output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("u2.dat", "r");
   fscanf (file, "%d", & n);

   for (int i = 0; i < n; i ++)
    fscanf (file, "%d", & t [i]);

   for (int i = 0; i < n - 1; i ++)
    fscanf (file, "%d", & r [i]);
    
   fclose (file);
 }

 
void solve ()
 {
 	dynamics [0] = t [0];
   dynamics [1] = t [0] + t [1];
   last [0] = 0; last [1] = 0;
   been [0] = 1;
   been [1] = 2;

   if (r [0] < dynamics [1])
    dynamics [1] = r [0], last [1] = 1, been [1] = 1;

   for (int i = 2; i < n; i ++)
    if (dynamics [i - 1] + t [been [i - 1]] < dynamics [i - 2] + r [been [i - 2]])
     {
       dynamics [i] = dynamics [i - 1] + t [been [i - 1]];
       been [i] = been [i - 1] + 1;
       last [i] = 0;
     }
    else
     {
       dynamics [i] = dynamics [i - 2] + r [been [i - 2]];
       been [i] = been [i - 2] + 1;
       last [i] = 1;
     }

   for (int i = n - 1; i >= 0;)
    if (last [i])
     {
     	 answer [ptr ++] = 2;
       i -= 2;
     }
    else
     {
     	 answer [ptr ++] = 1;
       i --;
     }
 }

 
void output ()
 {
 	FILE * file = fopen ("u2.sol", "w");
   fprintf (file, "%d\n", dynamics [n - 1]);

   for (ptr --; ptr >= 0; ptr --)
    fprintf (file, "%d ", answer [ptr]);
    
   fclose (file);
 }
 
