#include <stdio.h>

int n;
int g[105][105];
int dir[105], del[105], blocked;
int passed[200];
int fr, re;
int q[200], qdir[200];
void bfs( void )
{
  while (fr < re)
  {
    int cur = q[fr], curdir = qdir[fr];
    int i;

    fr++;

    passed[cur] = 1;
    dir[cur] = curdir;
    for (i = 1; i <= n; i++)
      if (g[i][cur])
	if (passed[i])
	  if (curdir == -dir[i])
	    ;
	  else
	  {
	    int i;

	    blocked = 1;
	    del[cur] = 1;
	    for (i = 1; i <= n; i++)
	      g[i][cur] = g[cur][i] = 0;
	  }
	else
	{
	  q[re] = i;
	  qdir[re] = -curdir;
	  re++;
	}
  }
}

int main( void )
{
  int m, i, d;
  char dr;
  freopen("tmission.dat", "r", stdin);
  freopen("tmission.sol", "w", stdout);
  scanf("%i %i", &n, &m);
  for (i = 0; i < m; i++)
  {
    int x, y;

    scanf("%i %i", &x, &y);
    g[x][y] = g[y][x] = 1;
  }
  scanf("%i %c", &i, &dr);
  if (dr == 'C')
    d = 1;
  else
    d = -1;
  fr = 0;
  re = 1;
  q[0] = i;
  qdir[0] = d;
  bfs();
  if (blocked)
    printf("B\n");
  else
    printf("W\n");
  for (i = 1; i <= n; i++)
    if ((dir[i] == 1) && !del[i])
      printf("%i ", i);
  printf("\n");
  for (i = 1; i <= n; i++)
    if ((dir[i] == -1) && !del[i])
      printf("%i ", i);
  printf("\n");
  for (i = 1; i <= n; i++)
    if (del[i])
      printf("%i ", i);
  printf("\n");
  return 0;
}
