#define MAX							11000

#include <stdio.h>
#include <string.h>


void input ();
int solve ();
void output ();
void add (int cur);
int get_start ();

int answer, n, p [MAX], act [MAX], mover [MAX], side [MAX], even, len = 0, start;


main ()
 {
 	input ();
   answer = solve ();
   output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("tele.in", "r");
   fscanf (file, "%d", & n);

   for (int i = 0; i < n; i ++)
    fscanf (file, "%d", & p [i]);

   for (int i = 0; i < n; i ++)
    {
    	fscanf (file, "%d", & act [i]);
      act [i] --;
    }

   fclose (file);
 }


int solve ()
 {
   int i, one = -1, two = -1;
   
 	for (i = 0; i < n; i ++)
    if (p [i] > 1)
     {
       one = i;
       break;
     }

 	for (i ++; i < n; i ++)
    if (p [i] > 1)
     {
       two = i;
       break;
     }

   if (one == -1)
    return (1);
   else if (two == -1)
    {
      if (act [one] == 0)
       {
         for (int i = 0; i < p [one]; i ++)
          mover [len] = one, side [len ++] = 1;

         return (1);
       }
      else if (act [one] == p [one] - 1)
       {
         for (int i = 0; i < p [one]; i ++)
          mover [len] = one, side [len ++] = 0;

         return (1);
       }
      else return (0);
    }
   
 	for (i = 0; i < n; i ++)
    if (p [i] % 2 == 0)
     {
     	 even = i;
       break;
     }

   if (i == n) return (0);

   if (even != 1)
    {
    	p [1] ^= p [even]; p [even] ^= p [1]; p [1] ^= p [even];
      act [1] ^= act [even]; act [even] ^= act [1]; act [1] ^= act [even];
    }

   if (one != 0)
    {
    	p [0] ^= p [one]; p [one] ^= p [0]; p [0] ^= p [one];
      act [0] ^= act [one]; act [one] ^= act [0]; act [0] ^= act [one];
    }

   for (i = 0; i < p [0] - 1; i ++)
    mover [i + 1] = 0, side [i + 1] = 1;

   mover [0] = 0; side [0] = 0;
   len = p [0];

   for (i = 1; i < n; i ++)
    if (p [i] > 1)
     add (i);

   start = get_start ();

   for (i = 0; i < len; i ++)
    {
     if (mover [i] == 1)
      mover [i] = even;
     else if (mover [i] == even)
      mover [i] = 1;

     if (mover [i] == 0)
      mover [i] = one;
     else if (mover [i] == one)
      mover [i] = 0;
    }

    return (1);
 }


void output ()
 {
   FILE * file = fopen ("tele.out", "w");

   if (answer)
    {
    	fprintf (file, "Yes\n");

      if (start)
      for (int i = start; i < len; i ++)
       fprintf (file, "%d %c\n", mover [i] + 1, side [i] ? '+' : '-');
      else
      for (int i = start; i < len - 1; i ++)
       fprintf (file, "%d %c\n", mover [i] + 1, side [i] ? '+' : '-');

      for (int i = 0; i < start - 1; i ++)
       fprintf (file, "%d %c\n", mover [i] + 1, side [i] ? '+' : '-');
    }
   else fprintf (file, "No");
    
   fclose (file);
 }


void add (int cur)
 {
 	int cur_mover [MAX], cur_side [MAX], length = len - 1;

   memcpy (cur_mover, mover, (length + 1) << 2);
   memcpy (cur_side, side, (length + 1) << 2);
   memcpy (mover, cur_mover + 1, length << 2);
   memcpy (side, cur_side + 1, length << 2); len --;

   for (int i = 0; i < p [cur] - 1; i ++)
    {
      mover [len] = cur;
      side [len ++] = 1;

      for (int j = 1; j < length; j ++)
       if (i % 2)
        mover [len] = cur_mover [j + 1], side [len ++] = cur_side [j + 1];
       else mover [len] = cur_mover [length - j + 1], side [len ++] = ! cur_side [length - j + 1];
    }
    
   if (p [cur] % 2)
    mover [len] == cur_mover [0], side [len ++] = cur_side [0];
   else mover [len] == cur_mover [1], side [len ++] = ! cur_side [1];

   for (int i = 0; i < p [cur] - 1; i ++)
    mover [len] = cur, side [len ++] = 0;
 }


int get_start ()
 {
 	int cur [MAX], start, ballance = 0, min = 1;
   memset (cur, 0, n << 2);

   for (int i = 0; i < len; i ++)
    {
     if (ballance < min)
      min = ballance, start = i;

     if (side [i]) ballance ++;
     else ballance --;
    }

   for (int i = start; i < len; i ++)
    {
     if (! memcmp (cur, act, n << 2)) return (i);

     if (side [i])
      cur [mover [i]] ++;
     else cur [mover [i]] --;
    }

   for (int i = 0; i < start; i ++)
    {
     if (! memcmp (cur, act, n << 2)) return (i);

     if (side [i])
      cur [mover [i]] ++;
     else cur [mover [i]] --;
    }
 }
