{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
Type
 Ext=Extended;
 TPointInt = Record
  X,Y:Integer;
  End;
 TPoint = Record
  X,Y:Ext;
  End;
 TLine = Record
  A,B,C:Ext;
  End;
 TSeg = Record
  A,B:TPoint;
  End;
 TCircle = Record
  X,Y,R :Ext;
  End;
Const
 Eps = 0.0001;
 Dx  = 0.1;


Var
  L: Array [1..500] Of TSeg;
  Max,N,K: Integer;
  P:TPoint;
  S:TSeg;
Procedure DataIn;
 Var
  St : Array [1..1000] of TPointInt;
  I,A,B:Integer;
 Begin
  Assign(Input,'InPut.txt');
   Reset(InPut);
    ReadLn(N);
     For I:=1 to N Do
      Read(St[I].X,St[I].Y);
    ReadLn(K);
     For I:=1 to K Do
      Begin
       Read(A,B);
       L[I].A.X:=St[A].X;
       L[I].A.Y:=St[A].Y;
       L[I].B.X:=St[B].X;
       L[I].B.Y:=St[B].Y;
      End;
 End;

Procedure DataOut;
 Begin
  Assign(OutPut,'OutPut.txt');
   ReWrite(OutPut);
    WriteLn(Max);
 End;

Procedure MakeMid(Var P:TPoint;S:TSeg);
 Begin
  P.X:=( S.A.X+S.B.X )/2;
  P.Y:=( S.A.Y+S.B.Y )/2;
 End;

Function Compare(A1,A2:ext):Integer;
 Begin
  If A1-A2>Eps Then Compare:=1 Else
  If A2-A1>Eps Then Compare:=-1 Else
  Compare:=0;
 End;

Procedure MakeLine(P1,P2:TPoint;Var L:TLine);
 Begin
  L.A:=P1.Y-P2.Y;
  L.B:=P2.X-P1.X;
  L.C:=P1.X*P2.Y-P2.X*P1.Y;
 End;


Function InSideLine (P:TPoint;L:TLine): Boolean;
  Begin
   InSideLine:=(Compare(L.A*P.X+L.B*P.Y+L.C,0)=0)
  End;



Function InSideSeg(P:TPoint;S:TSeg):Boolean;
  Var
   L:TLine;
 Function ASD:Ext;
  Begin
   ASD:=Abs(S.A.X-P.X)+Abs(S.B.X-P.X)
  End;

 Function SAD:Ext;
  Begin
   SAD:=Abs(S.A.X-S.B.X);
  End;

 Function DSA:Ext;
  Begin
   DSA:=Abs(S.A.Y-P.Y)+Abs(S.B.Y-P.Y);
  End;

 Function SDA:Ext;
  Begin
   SDA:=Abs(S.A.Y-S.B.Y);
  End;

Begin
    MakeLine(S.A,S.B,L);
     InSideSeg:=InSideLine(P,L) And (Compare(ASD,SAD)=0) And (Compare(DSA,SDA)=0)
  End;

Procedure MakeNext(Var P:TPoint; S:TSeg);
 Var
  C:TCircle;
  A,B,CC,D:Ext;
  L:TLine;
  S1:TSeg;
  E:Integer;
  P1,p2:TPoint;
 Begin
  C.X:=P.X;
  C.Y:=P.Y;
  C.R:=Dx;
  S1.B:=S.B;
  S1.A:=P;
  MakeLine(S.A,S.B,L);
  A:=L.B*L.B+L.A*L.A;
  B:=L.A*L.B*C.X+L.B*L.C-L.A*L.A*C.Y;
  CC:=L.A*L.A*C.X*C.X+2*L.A*L.C*C.X+L.C*L.C+L.A*L.A*C.Y*C.Y-C.R*C.R*L.A*L.A;
  D:=B*B-A*CC;
  P1.Y:=(-B+Sqrt(D))/A;
  If L.A<>0 Then P1.X:=-(L.C+L.B*P1.Y)/L.A Else P1.X:=P1.X+Dx*Compare(S.B.X,S.A.X);
  If InSideSeg(P1,S1) Then P:=P1 Else
  Begin
  P2.Y:=(-B-Sqrt(D))/A;
  If L.A<>0 Then P2.X:=-(L.C+L.B*P2.Y)/L.A Else P2.X:=P2.X+Dx*Compare(S.B.X,S.A.X);
  P:=P2;
  End;

 End;

Function CrossSL(S:TSeg;L:TLine):Boolean;
 Begin
  If Compare((L.A*S.A.X+L.B*S.A.Y+L.C)*(L.A*S.B.X+L.B*S.B.Y+L.C),0)=1 Then
   CrossSL:=False Else
   CrossSL:=True;
 End;

Procedure Work;
 var
  S,I,J,G:Integer;
  P2,P1:TPoint;
  L1:TLine;
 Begin
  Max:=0;
  For I:=1 to K Do
   For J:=1 to K Do
    If I<>J Then Begin
     MakeMid(P1,L[I]);
     P2:=L[J].A;
     While True Do
      begin
     MakeNext(P2,L[J]);
     MakeLine(P1,P2,L1);
     If Compare(P2.X,L[J].B.X)=0 Then If
     Compare(P2.Y,L[J].B.Y)=0 Then Break;
     S:=2;
     For G:=1 to K Do
      If (G<>I) And (G<>J) Then
       If CrossSL(L[G],L1) Then Inc(S);
     If S>Max Then Max:=S;
      End;
                 End;
 End;

Begin
 DataIn;
  Work;
 DataOut;
End.