{$I-,Q-,R-,S-,V-,X-}
var
  n, nm, cn, sm, nmd: longint;
  m: array [1..50] of longint;
  no, p, s, s0: array [1..50] of longint;
  w: array [0..30000] of boolean;
  mv: array [1..30000] of integer;
  ok: boolean;

procedure ReadAll;
var
  x, k: integer;
  i, m: longint;
begin
  Assign(Input, 'tele.in'); Reset(Input);

  Read(m); n := 0;
  for i := 1 to m do begin
    Read(x);
    if (x>1) then begin
      inc(n);
      no[n] := i;
      p[n] := x;
    end;
  end;

  k := 1;
  for i := 1 to m do begin
    Read(x);
    if (i=no[k]) then begin
      s[k] := x;
      inc(k);
    end;
  end;

  Close(Input);

  s0 := s;
end;

procedure Out;
var  i: longint;
begin
  Assign(Output, 'tele.out'); ReWrite(Output);

  if (nmd < 1) then nmd := nm;

  if (ok) then begin
    WriteLn('Yes');
    for i := 1 to nm do begin
      if (mv[sm]>0) then WriteLn(no[abs(mv[sm])]:1, ' ', '+')
      else               WriteLn(no[abs(mv[sm])]:1, ' ', '-');
      sm := (sm mod nmd) + 1;
    end;
  end else WriteLn('No');

  Close(Output);
end;

procedure GetN;
var  i: integer;
begin
  cn := 0;
  for i := 1 to n do cn := cn + (s[i]-1)*m[i];
end;

procedure SolveG;
var
  i, j, f: longint;
  d: array [1..50] of integer;
begin
  m[1] := 1;
  for i := 2 to n+1 do m[i] := m[i-1]*p[i-1];
  fillchar(w, sizeof(w), 0);

  GetN; w[cn] := true;

  nm := 0;
  for i := 1 to n do d[i] := 1;
  while (nm<(m[n+1]-1)) do begin
    j := 1;
    while ( ((s[j]+d[j])<1) or ((s[j]+d[j])>p[j]) ) do begin
      d[j] := -d[j];
      j := (j mod n) + 1;
    end;

    s[j] := s[j] + d[j];
    GetN;
    if not w[cn] then begin
      inc(nm);
      mv[nm] := j*d[j];
      w[cn] := true;
    end else exit;
  end;
  ok := true; sm := 1;
end;

procedure SolveM;
var
  am, i, j: longint;
  dn: boolean;
begin
  m[1] := 1;
  for i := 2 to n+1 do m[i] := m[i-1]*p[i-1];
  fillchar(w, sizeof(w), 0);

  GetN; w[cn] := true;

  nm := 0;
  while (nm<(m[n+1]-1)) do begin
    dn := true;
    for am := 1 to n do begin
      if (s[am]<p[am]) then begin
        inc(s[am]); GetN;
        if (w[cn]) then dec(s[am]) else begin
          inc(nm);
          mv[nm] := am;
          w[cn] := true;
          dn := false;
        end;
      end;
    end;
    for am := 1 to n do begin
      if (s[am]>1) then begin
        dec(s[am]); GetN;
        if (w[cn]) then inc(s[am]) else begin
          inc(nm);
          mv[nm] := -am;
          w[cn] := true;
          dn := false;
        end;
      end;
    end;

    if dn then exit;
  end;
  ok := true; sm := 1;
end;

var
  ig: integer;
  d: array [1..50] of integer;

function ck: boolean;
var  i: integer;
begin
  ck := false;
  for i := 1 to n do if (s[i] <> s0[i]) then exit;
  ck := true;
end;

procedure gray(sk: integer);
var  i, j: integer;
begin
  while (true) do begin
    j := 1;
    while (j<=n) and ( (j=ig) or ((s[j]+d[j])<1) or ((s[j]+d[j])>p[j]) ) do begin
      d[j] := -d[j];
      inc(j);
    end;
    if (j>n) then exit;

    s[j] := s[j] + d[j];
    if (sk>0) then dec(sk) else begin
      inc(nm);
      mv[nm] := j*d[j];
    end;
  end;
end;

procedure Solve0;
var  i: integer;
begin
  for ig := 1 to n do if ((p[ig] and 1)=0) then begin
    for i := 1 to n do s[i] := 1;
    for i := 1 to n do d[i] := 1;
    nm := 0;
    Gray(0);

    while (s[ig]<(p[ig]-1)) do begin
      inc(nm);
      mv[nm] := ig;
      inc(s[ig]);
      Gray(0); dec(nm);
      inc(nm);
      mv[nm] := ig;
      inc(s[ig]);
      Gray(1);
    end;
    inc(nm);
    mv[nm] := ig;
    inc(s[ig]);
    Gray(0);
    for i := 1 to p[ig]-1 do begin
      inc(nm);
      mv[nm] := -ig;
      dec(s[ig]);
    end;

    for i := 1 to n do s[i] := 1;
    sm := 1;
    repeat
      if (ck) then begin
        ok := true;
        nmd := nm; dec(nm);
        exit;
      end;
      if (mv[sm]>0) then inc(s[abs(mv[sm])]) else dec(s[abs(mv[sm])]);
      inc(sm);
      if (sm>nm) then exit;
    until false;
  end;
end;

begin
  ReadAll;
  ok := false;
  nmd := 0;
  if (n>1) then Solve0;
  s := s0;
  if not ok then SolveG;
  s := s0;
  if not ok then SolveM;
  Out;
end.

