#include <stdio.h>
#include <stdlib.h>

int N, K;
struct XStr {int x, g;} X[10000];
double Y[10000];

void input()
{
  int i;
  FILE *f = fopen("Phone.in", "rt");
  fscanf(f, "%d%d", &N, &K);
  for (i = 0; i < N; i++) fscanf(f, "%d", &X[i].x);
  for (i = 0; i < N; i++) fscanf(f, "%d", &X[i].g);
  fclose(f);
}

void output()
{
  int i;
  FILE *f = fopen("Phone.out", "wt");
  for (i = 0; i < K; i++) fprintf(f, "%lf ", Y[i]);
  fclose(f);
}

int GetK(double U)
{
  int a = 0, i;
  Y[0] = X[0].x + U / X[0].g;
  for (i = 1; i < N; i++) if (Y[a] > X[i].x)
  {
    if ((Y[a] - X[i].x) * X[i].g > U) Y[a] = X[i].x + U / X[i].g;
  }
  else if ((X[i].x - Y[a]) * X[i].g > U)
  {
    a++;
    Y[a] = X[i].x + U / X[i].g;
  }
  return a + 1;
}

int cmp(const void *e1, const void *e2)
{
  int a = ((XStr*)e1)->x, b = ((XStr*)e2)->x;
  if (a > b) return 1;
  else if (a < b) return -1;
  else return 0;
}

int main()
{
  double d, y0, y1;
  int i;
  input();
  qsort(X, N, sizeof(XStr), cmp);
  y0 = double(X[0].x + X[N-1].x) / 2;
  y1 = 0;
  for (i = 0; i < N; i++)
  {
    d = fabs(y0 - X[i].x) * X[i].g;
    if (d > y1) y1 = d;
  }
  y0 = 0;
  do
  {
    d = (y1 + y0) / 2;
    i = GetK(d);
    if (i > K) y0 = d;
    else y1 = d;
  }
  while(y1 - y0 > 2E-5);
  i = GetK(y1);
  while(i < K) Y[i++] = 0;
  output();
  return 0;
}
