Program Village;
Uses Crt;
Type
    Punkt = 1..10000;
Var
   F1,F2 : Text;
   L : Array [1..10000] of 1..100;
   Nearest : Array [1..10000] of Punkt;
   P,G : Array [1..10000] of Real;
   i,j,k,n : Punkt;
   Delta,s1,s2 : Real;

   Procedure ReadData;
    Var i : Punkt;
    Begin
     ClrScr;
     Assign (F1,'Phone.In'); Reset (F1);
     ReadLn (F1,n,k);

     For i:= 1 to n Do
      Read (F1,P[i]);
     ReadLn (F1);

     For i:= 1 to n Do
      Read (F1,L[i]);

     Close (F1);
    End;

   Procedure WriteData;
    Begin
     Assign (F2,'phone.out'); Rewrite (F2);

      For i:= 1 to k Do Write (F2,G[i] :5 :2);

     Close (F2);
    End;

   Procedure Sortir;
    Var i,j : Punkt;
        x : Real;
     Begin
      For i:= 1 to n-1 Do
       For j:= 1 to n-i Do
        If P[j]>P[j+1] Then Begin
                             x:= P[j];
                             P[j]:= P[j+1];
                             P[j+1]:= x;
                            End;
     End;


    Procedure Near;
     Var i,j,pmin : Punkt;
         min : Real;
     Begin

      For i:= 1 to n Do
       Begin
        min:= Abs(G[1]- P[i]); pmin:= 1;
        For j:= 1 to k Do
          If Abs(G[j]-P[i])<min Then Begin min:= Abs(G[j]-P[i]); pmin:= j; End;
        Nearest[i]:= pmin;
       End;

     End;

 BEGIN
  ReadData;
  Sortir;


  Delta:= (P[n]-P[1])/(k+1);

  For i:= 1 to k Do
   G[i]:= P[1] + i*Delta;

  Near;

  For i:= 1 to k Do
   Begin
    s1:= 0; s2:= 0;

    For j:= 1 to n Do
     If Nearest[j]= i Then Begin s1:= s1 + P[j]*L[j]; s2:= s2 + L[j]; End;

    G[i]:= s1 / s2;
   End;

  WriteData;
 END.









