{$IFDEF NORMAL}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I+,Q+,R+,S-,V-,X-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF RELEASE}
Program Buisness;
 Type
   Ar = Array [0..100] of Integer;
 Var
   Inp, Out     : Text;
   Mat          : Array [1..60, 1..60] of Byte;
   N, M, K, A, B: Integer;
   N1, N2       : Integer;
   I, G         : Integer;
   C, WW        : Byte;
   R            : Array [1..60] of Ar;
   W            : Array [1..60] of Boolean;
   S            : Array [1..60] of Integer;
   Count        : Integer;
   Stop         : Boolean;
   Cost         : Integer;
   O, P         : Ar;
   Changed      : Array [1..60, 1..100] of Boolean;

Procedure Init;
Begin
  Assign(Inp, 'input.doc');
  Assign(Out, 'output.doc');
  Reset(Inp);
  ReWrite(Out);
End;

Procedure Done;
Begin
  Close(Inp);
  Close(Out);
End;

Procedure Invert(Var AAA: Ar);
 Var
   I, T: Integer;
Begin
  For I:=1 To AAA[0] div 2 Do
  Begin
    T:=AAA[I];
    AAA[I]:=AAA[AAA[0] - I + 1];
    AAA[AAA[0] - I + 1]:=T;
  End;
End;

Function Min(A, B: Integer): Integer;
Begin
  If A < B Then Min:=A
           Else Min:=B;
End;

Procedure Max(P, O: Ar);
 Var
   I: Integer;
Begin
  Invert(O);
  Invert(P);
  For I:=1 To Min(P[0], O[0]) Do
   If O[I] > P[I] Then
   Begin
     P:=O;
     Exit;
   End;
  Invert(P);
End;

Function INN(C: Integer; A: Ar): Boolean;
 Var
   I: Integer;
Begin
 For I:=1 To A[0] Do
  If A[I] = C Then
  Begin
    INN:=True;
    Exit;
  End;
  INN:=False;
End;

Procedure Rec(V, CC: Integer; Var AA: Ar);
 Var
   I   : Integer;
   O, Z: Ar;
   Q   : Integer;
Begin
 If V = A Then
 Begin
   Inc(AA[0]);
   AA[AA[0]]:=A;
   If C = 0
   Then Begin
     P:=AA;
     Inc(C);
   End Else
   Begin
     Max(P, AA);
     Inc(C);
   End;
   If C = (K - WW) Then
   Begin
     Invert(P);
     For I:=1 To P[0] Do
      Write(Out, P[I], ' ');
     Done;
     Halt(0);
   End;
 End Else
 Begin
   Q:=0;
  For I:=1 To N Do
   If (INN(CC - Mat[I, V], R[I]))and(Mat[I, V] <> 0)
   Then Begin
     Inc(AA[0]);
     AA[AA[0]]:=V;
     Rec(I, CC - Mat[I, V], AA);
   End;
 End;
End;

Procedure Add(N, M: Integer);
 Var
   I, J: Integer;
   H   : Integer;
Begin
  J:=1;
 For I:=1 To R[M, 0] Do
 If Changed[M, I] Then
 Begin
   While (R[M, I] + Mat[M, N] > R[N, J])and(J <= R[N, 0])
    Do Inc(J);
   For H:=Min(K - 1, R[N, 0]) DownTo J Do
   Begin
     Changed[N, H + 1]:=Changed[N, H];
     R[N, H + 1]:=R[N, H];
   End;
    R[N, J]:=R[M, I] + Mat[M, N];
    Changed[N, J]:=True;
   If K - 1 >= R[N, 0] Then Inc(R[N, 0]);
 End;
End;

Procedure Run;
Begin
  Readln(Inp, N, M, A, B, K);
  FillChar(Mat, SizeOf(Mat), 0);
  FillChar(W, SizeOf(W), False);
  FillChar(S, SizeOf(S), 0);
  FillChar(Changed, SizeOf(Changed), False);
 For I:=1 To N Do
  R[N, 0]:=0;
 For I:=1 To M Do
 Begin
   Read(Inp, N1, N2, C);
   Mat[N1, N2]:=C;
 End;
  Stop:=False;
  C:=A;
  Count:=0;
  R[A, 0]:=1;
  Changed[1, 1]:=True;
 While Not Stop Do
 Begin
   W[C]:=True;
  For I:=1 To N Do
   If Mat[C, I] <> 0 Then
   Begin
     Inc(Count);
     S[Count]:=I;
     W[I]:=False;
     Add(I, C);
   End;
   For I:=1 To R[C, 0] Do
    Changed[C, I]:=False;
   If Count = 0
    Then Stop:=True
    Else Begin
      C:=S[Count];
      Dec(Count);
    End;
 End;
  Cost:=R[B, K];
  WW:=0;
 For I:=1 To R[B, 0] Do
  If R[B, I] < Cost Then Inc(WW);
  C:=0;
 For I:=1 To N Do
  If (INN(Cost - Mat[I, B], R[I]))and(Mat[I, B] <> 0)
  Then
  Begin
    O[0]:=1;
    O[1]:=B;
    Rec(I, Cost - Mat[I, B], O);
  End;
End;

Begin
  Init;
  Run;
  Done;
End.
