{$I-,Q-,R-,S-,V-,X-}
Program AYoungDriver;
Const
  InFile='INPUT.DOC';
  OutFile='OUTPUT.DOC';
  MaxN=62;
  MaxPrice=12;
  MaxCost=MaxN*MaxPrice;
Var
  A,B,N:Byte;
  K:QWord;
  Amount:Array[1..MaxN,0..MaxCost]Of QWord;
  NInr:Array[1..MaxN]Of Byte;
  Seq:Array[1..MaxN]Of Byte;
  Inr:Array[1..MaxN,1..MaxN]Of Record
    Src:Byte;
    Cost:Byte;
  End;
  NOur:Array[1..MaxN]Of Byte;
  Our:Array[1..MaxN,1..MaxN]Of Record
    Dest:Byte;
    Cost:Byte;
  End;
  IsWay:Array[1..MaxN,1..MaxN]Of Byte;
  ResLen:Byte;
  Res:Array[1..MaxN]Of Byte;
Procedure Load;
Var
  I,M:Word;
  AA,BB,CC:Byte;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M,A,B,K);
  FillChar(NInr,SizeOf(NInr),0);
  FillChar(NOur,SizeOf(NOur),0);
  FillChar(IsWay,SizeOf(IsWay),0);
  For I:=1 To M Do Begin
    If Not SeekEOF Then Read(AA,BB,CC);
    Inc(NOur[AA]);
    Our[AA,NOur[AA]].Dest:=BB;
    Our[AA,NOur[AA]].Cost:=CC;
    Inc(NInr[BB]);
    Inr[BB,NInr[BB]].Src:=AA;
    Inr[BB,NInr[BB]].Cost:=CC;
    IsWay[AA,BB]:=CC;
  End;
  Close(Input);
End;
Procedure SortCities;
Var
  I,J,JJ:Byte;
  COur:Array[1..MaxN]Of ShortInt;
Begin
  For I:=1 To N Do
    COur[I]:=NOur[I];
  For I:=1 To N Do Begin
    For J:=1 To N Do If COur[J]=0 Then Begin
      COur[J]:=-1;
      Seq[I]:=J;
      For JJ:=1 To NInr[J] Do Dec(COur[Inr[J,JJ].Src]);
      Break;
    End;
  End;
End;
Procedure Solve;
Var
  I,J,JJ:Word;
  II:Word;
  Cur:Byte;
Begin
  SortCities;
  FillChar(Amount,SizeOf(Amount),0);
  Amount[B,0]:=1;
  For I:=1 To N Do Begin
    J:=Seq[I];
    For II:=0 To MaxCost Do If Amount[J,II]>0 Then
      For JJ:=1 To NInr[J] Do
        Inc(Amount[Inr[J,JJ].Src,II+Inr[J,JJ].Cost],Amount[J,II]);
  End;
  Cur:=A;
  ResLen:=1;
  Res[1]:=A;
  For II:=0 To MaxCost Do If Amount[Cur,II]>0 Then
    If (K<=Amount[Cur,II]) Then Break Else Dec(K,Amount[Cur,II]);
  Repeat
    For J:=1 To N Do If (IsWay[Cur,J]>0) And (II>=IsWay[Cur,J]) And (Amount[J,II-IsWay[Cur,J]]>0) Then
      If K<=Amount[J,II-IsWay[Cur,J]] Then
        Break
      Else
        Dec(K,Amount[J,II-IsWay[Cur,J]]);
    Inc(ResLen);
    Res[ResLen]:=J;
    Dec(II,IsWay[Cur,J]);
    Cur:=J;
  Until Cur=B;
End;
Procedure Save;
Var
  I:Byte;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To ResLen Do Begin
    If I>1 Then Write(' ');
    Write(Res[I]);
  End;
  WriteLn;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
