{$I-,Q-,R-,S-,V-,X-}
type  float = real;
var
  p, c, r: array [1..11000] of float;
  n, k, k0: longint;

procedure ReadAll;
var  i: longint;
begin
  Assign(Input, 'Phone.in'); Reset(Input);

  Read(n, k);
  for i := 1 to n do Read(p[i]);
  for i := 1 to n do Read(c[i]);

  Close(Input);
end;

procedure Out;
var  i: integer;
begin
  Assign(Output, 'Phone.out'); ReWrite(Output);

  for i := k0 downto 1 do begin
    if (i<k0) then Write(' ');
    Write(r[i]:1:4);
  end;
  WriteLn;

  Close(Output);
end;

type
  tar = array [0..11000] of float;
var
  d, nd, dd: tar;
  h: array [0..11000] of integer;
  cr: integer;

function getm(a, b: integer): float;
var  aa, bb: float;
begin
  aa := c[a]; bb := c[b];
  while (a<b) do begin
    if (aa>bb) then begin
      dec(b); bb := bb + c[b];
    end else begin
      inc(a); aa := aa + c[a];
    end;
  end;

  getm := p[a];
end;

function ht(a, b: integer): float;
var
  i: integer;
  ms, x, t, r: float;
begin
  t := getm(a, b);
  r := 0;
  for i := a to b do r := r + (c[i]*abs(p[i]-t));

  ht := r;
end;

procedure Sort(l, r: integer);
var
  m: float;
  h: float;
  i, j: integer;
begin
  m := p[(l+r) div 2]; i := l; j := r;
  repeat
    while (i<r) and (p[i] < m) do inc(i);
    while (j>l) and (p[j] > m) do dec(j);
    if (i<=j) then begin
      h := p[i]; p[i] := p[j]; p[j] := h;
      h := c[i]; c[i] := c[j]; c[j] := h;
      inc(i); dec(j);
    end;
  until (i>j);

  if (i<r) then Sort(i, r);
  if (l<j) then Sort(l, j);
end;

procedure Solve1;
var
  i, j, u, a, b: integer;
  ms, x, t: float;
begin
  if (n=k) then begin
    while (k>0) do begin
      r[cr] := p[n]; dec(n); dec(k); inc(cr);
    end;
    exit;
  end;

  if (n=0) then begin
    while (k>0) do begin
      r[cr] := p[1]; dec(k); inc(cr);
    end;
    exit;
  end;

  ms := 0; x := 0;
  for i := 1 to n do begin
    t := getm(1, i);
    h[i] := i;
    d[i] := 0;
    for j := 1 to i do d[i] := d[i] + (c[i]*abs(p[i]-t));
  end;

  for u := 2 to k do begin
    nd[1] := 0;
    j := 1;
    for i := 2 to n do begin
      nd[i] := d[j] + ht(j+1, i);
      repeat
        inc(j);
        t := d[j] + ht(j+1, i);
        if (nd[i] > t) then nd[i] := t;
      until (j>=i) or (nd[i] < t);
      dec(j);
      h[i] := i-j;
    end;
    d := nd;
  end;


  b := n; a := n-h[i]+1;

  t := getm(a, b);

  r[cr] := t;
  inc(cr);
  n := a-1;
  dec(k);
  if (k > 0) then Solve1;
end;

procedure Prep;
var  i, j: integer;
begin
  i := 1;
  while (i<n) do begin
    if (abs(p[i]-p[i+1]) < 10e-8) then begin
      c[i] := c[i] + c[i+1];
      for j := i+1 to n-1 do begin
        p[j] := p[j+1];
        c[j] := c[j+1];
      end;
      dec(n);
    end else inc(i);
  end;
end;

procedure Solve2;
var
  l: float;
  i, j, u, a, b: integer;
  ms, x, t: float;
begin
  if (n=k) then begin
    while (k>0) do begin
      r[cr] := p[n]; dec(n); dec(k); inc(cr);
    end;
    exit;
  end;
  if (n=0) then begin
    while (k>0) do begin
      r[cr] := p[1]; dec(k); inc(cr);
    end;
    exit;
  end;

  l := (p[n] - p[1])/k;
  b := n; a := n;
  while (a>k) and ((p[n]-p[a])<l) do dec(a);

  t := getm(a, b);

  r[cr] := t;
  inc(cr);
  n := a-1;
  dec(k);
  if (k > 0) then begin
    if ((n*k)<50000) then Solve1 else Solve2;
  end;
end;

begin
  ReadAll; k0 := k;
  Sort(1, n);
  Prep;
  cr := 1;
  while (k>n) do begin
    dec(k); r[cr] := p[n]; inc(cr);
  end;
  if ((n*k)<66666) then Solve1 else Solve2;
  Out;
end.
