Uses Sysutils;
Const
 Inp='Phone.In';
 Outp='Phone.Out';
 MaxN=10000;
 MaxK=100;
 TimeLimit=12;

Type
 Real=Extended;

var
 N, K: Word;
 P: array [1..MaxN] of Longint;
 A: Array [1..maxn] of Word;
 B: Array [1..MaxK] of Real;
 Break: TDateTime;

Procedure Init;
 var i: Integer;

    Procedure Swap(q, w: Word);
     var X: Word;
         Y: word;
     begin
      X:=P[q];
      P[q]:=P[w];
      P[w]:=X;
      Y:=A[q];
      A[q]:=A[w];
      A[w]:=Y;
     End;

    procedure sort(l,r: longint);
      var
         i,j, y: longint;
         x: Real;
      begin
         i:=l;
         j:=r;
         x:=P[(l+r) div 2];
         repeat
           while P[i]<x do
            inc(i);
           while x<P[j] do
            dec(j);
           if not(i>j) then
             begin
                Swap(i, j);
                inc(i);
                j:=j-1;
             end;
         until i>j;
         if l<j then
           sort(l,j);
         if i<r then
           sort(i,r);
      end;

 Begin
  Break:=Time+(TimeLimit/24/3600);
  Assign(Input, Inp);
  Reset(Input);
  Read(N, K);
  for i:=1 to N do
   Read(P[i]);
  for i:=1 to N do
   Read(A[i]);
  Sort(1, N);
  Close(Input);
 End;

Procedure Done;
 var i, j: Integer;
 begin
  Assign(Output, Outp);
  Rewrite(Output);
  for i:=1 to K do
   Write(B[i]:0:4, ' ');
  Close(Output);
 end;

Procedure Solve;
 Var U, D, C: Real;
     i, j: Integer;
     dB, Pr: Real;
 Begin
  U:=0;
  D:=0;
  for i:=1 to N do
   U:=U+P[i]*A[i];
  dB:=1;
  While (Time<Break){ and (dB>0.000001)} do Begin
   dB:=0;
   C:=(U+D)/2;
   i:=1;
   j:=0;
   while (i<=N) and (j<K) do begin
    Inc(j);
    Pr:=B[j];
    B[j]:=P[i]+C/A[i];
    if B[j]>P[N] Then
     B[j]:=P[N];
    Pr:=Abs(Pr-B[j]);
    if Pr>dB Then
     dB:=Pr;
    While (i<N) and (Abs(P[i+1]-B[j])*A[i+1]<=C) do Inc(i);
    inc(i);
   End;
   if i>N Then
    U:=C
   else
    D:=C;
  End;
 End;

Begin
 Init;
 Solve;
 Done;
End.
