#define MAX					12000

#include <stdio.h>

void input ();
void solve ();
void output ();
void get_to ();

int n, k, ways [MAX] [30], start [MAX], end [MAX], list [MAX];
int from [MAX], to [MAX], answer = 1;
//int value [MAX], next [MAX], ptr = 0;


main ()
 {
   input ();
   solve ();
   output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("Input.TXT", "r");
   fscanf (file, "%d %d", & k, & n);

   for (int i = 0; i < n; i ++)
    from [i] = to [i] = 0;

   for (int i = 0; i < n; i ++)
	 for (int j = 0; j < k; j ++)
     {
      fscanf (file, "%d", & ways [i] [j]);
      
      if (ways [i] [j] != -1)
       from [i] ++, to [-- ways [i] [j]] ++;
     }

   fclose (file);
 }

 
void solve ()
 {
//   get_to ();
   int max, best;
   
   for (int i = 0; i < n; i ++)
    {
      max = -1;
      
      for (int j = 0; j < n; j ++)
       if ((to [j] <= k) && (to [j] > max))
        max = to [j], best = j;

      if (max == -1)
       {
         answer = 0;
         break;
       }

      list [i] = best;
      to [best] = -1;
      
      for (int j = 0; j < k; j ++)
       if (ways [best] [j] != -1)
        to [ways [best] [j]] --;
    }
 }

 
void output ()
 {
 	FILE * file = fopen ("Output.TXT", "w");

   if (! answer)
    fprintf (file, "NO\n");
   else
    {
	   for (int i = n - 1; i >= 0; i --)
	    fprintf (file, "%d ", list [i] + 1);
    }
    
   fclose (file);
 }


/*
void get_to ()
 {
   memset (start, -1, n << 2);
   memset (end, -1, n << 2);
   
   for (int i = 0; i < n; i ++)
    for (int j = 0; j < k; j ++)
     {
       if (end [ways [i] [j]]] == -1)
        {
          end [ways [i] [j]] = ptr ++;
          value [ptr] = i;
        }
       else
        {
          next [end [ways [i] [j]] = ptr;
          value [ptr] = i;
          end [ways [i] [j]] = ptr ++;
        }
     }
 }
*/
