#include <stdio.h>

int N;
int A[16][16];

void input()
{
  int i, j;
  FILE *f = fopen("INPUT.TXT", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) for (j = 0; j < N; j++) fscanf(f, "%d", &A[i][j]);
  fclose(f);
}

int NM = 1;
int NR = 0, RR[10000], KR[10000];

void output()
{
  int i, j;
  FILE *f = fopen("OUTPUT.TXT", "wt");
  fprintf(f, "%d\n", NM);
  for (i = 0; i < NR; i++)
  {
    for (j = KR[i]; j <= NM; j++)
    {
      fprintf(f, "%d %d\n", j, RR[i]+1);
    }
  }
  fprintf(f, "0 0\n");
  fclose(f);
}

int B[20];

int Rev1(int k)
{
  if (B[k])
  {
  int i;
  B[k] = 0;
  if (k == 0) return 1;
  else for (i = 0; i < N; i++) if (A[i][k])
  {
    if (Rev1(i))
    {
      RR[NR] = k;
      KR[NR] = 1;
      NR++;
      return 1;
    }
  }
  }else return 0;
}

void Rev2(int k, int M)
{
  if (B[k])
  {
    int i;
    B[k] = 0;
    int S = 0, S1 = 0;
    for (i = 0; i < N; i++) if (A[i][k] && B[i]) S++;
    for (i = 0; i < N; i++) if (A[i][k] && B[i])
    {
      S1++;
      if (S1 != S && NM <= M) NM = M + 1;
      RR[NR] = i;
      KR[NR] = (S1 == S) ? M : (M + 1);
      NR++;
      Rev2(i, (S1 == S) ? M : (M + 1));
      RR[NR] = k;
      KR[NR] = (S1 == S) ? M : (M + 1);
      NR++;
    }
  }
}

int main()
{
  int i, j, k, zm;
  input();
  k = -1;
  for (i = 0; i < N; i++)
  {
    int Z = 0;
    for (j = 0; j < N; j++) if (A[i][j]) Z++;
    if (k == -1 || Z < zm) {k = i; zm = Z;}
  }
  for (i = 0; i < N; i++) B[i] = 1;
  Rev1(k);
  for (i = 0; i < N; i++) B[i] = 1;
  Rev2(k, 1);
  output();
  return 0;
}
