#include <stdio.h>
#include <stdlib.h>

int b[15][15], bb[15][15];
int N;
int mark[15];
int best, best_val;
void dfs( int i )
{
  int j, k = 0;
  
  if (mark[i])
    return;
  mark[i] = 1;
  for (j = 0; j < N; j++)
    if (b[i][j] == 1)
      k++;
  if (k > best_val)
    best_val = k, best = i;
  for (j = 0; j < N; j++)
    if (b[i][j] == 1)
      dfs(j);
}

int make( int i )
{
  int j, max = 0, be;

  best_val = -1;
  dfs(i);
  be = best;
  if (best_val < 3)
    return 1;
  memset(mark, 0, sizeof(mark));
  for (j = 0; j < N; j++)
    if (b[be][j])
      b[be][j] = -1, b[j][be] = 0;
  for (j = 0; j < N; j++)
    if (b[be][j])
    {
      int k = make(j);

      if (k > max)
        max = k;
    }
  return max + 1;
}

void go( int i, int j, int k )
{
  int l;

  for (l = i; l <= j; l++)
    printf("%i %i\n", l, k + 1);
}

int xpath[20], xpath_len;
int cpath[20], cpath_len;

void pdfs( int i )
{
  int j, k = 0;
  
  if (mark[i])
    return;
  mark[i] = 1;
  cpath[cpath_len++] = i;
  for (j = 0; j < N; j++)
    if (b[i][j] == 1)
      k++;
  if (k > best_val)
  {
    best_val = k, best = i;
    xpath_len = cpath_len;
    memcpy(xpath, cpath, sizeof(cpath));
  }
  for (j = 0; j < N; j++)
    if (b[i][j] == 1)
      pdfs(j);
  cpath[--cpath_len] = i;
}

void ppdfs( int i )
{
  int j;
  
  cpath[cpath_len++] = i;
  for (j = 0; j < N; j++)
    if (b[i][j] == 1)
    {
      b[i][j] = b[j][i] = 0;
      ppdfs(j);
      return;
    }
}

void fmake( int i, int s, int e )
{
  int j, max = 0, be;
  int *path, path_len;

  best_val = -1;
  xpath_len = cpath_len = 0;
  pdfs(i);
  be = best;
  if (best_val < 3)
  {
    cpath_len = 0;
    ppdfs(i);
    for (j = 1; j < cpath_len; j++)
      go(s, s, cpath[j]);
    for (j = cpath_len - 2; j >= 0; j--)
      go(s, s, cpath[j]);      
    cpath_len = 0;
    ppdfs(i);
    for (j = 1; j < cpath_len; j++)
      go(s, s, cpath[j]);
    for (j = cpath_len - 2; j >= 0; j--)
      go(s, s, cpath[j]);
    return;
  }
  /* Go to best */
  path_len = xpath_len;
  path = malloc(path_len * sizeof(int));
  memcpy(path, xpath, path_len * sizeof(int));
  for (j = 1; j < path_len; j++)
    go(s, e, path[j]);
  memset(mark, 0, sizeof(mark));
  for (j = 0; j < N; j++)
    if (b[be][j])
      b[be][j] = -1, b[j][be] = 0;
  for (j = 0; j < N; j++)
    if (b[be][j])
    {
      go(s + 1, e, j);
      fmake(j, s + 1, e);
      go(s + 1, e, be);
    }
  /* Go to s */
  for (j = path_len - 2; j >= 0; j--)
    go(s, e, path[j]);
  free(path);
}

int main( void )
{
  int i, j;
  
  freopen("INPUT.TXT", "r", stdin);
  freopen("OUTPUT.TXT", "w", stdout);
  scanf("%i", &N);
  for (i = 0; i < N; i++)
    for (j = 0; j < N; j++)
      scanf("%i", &b[i][j]);
  memcpy(bb, b, sizeof(b));
  printf("%i\n", i = make(0));
  memcpy(b, bb, sizeof(bb));
  fmake(0, 1, i);
  printf("0 0\n");
  return 0;
}

