{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 64384,0,655360}
Program Secret;
 Var
   Inp, Out: Text;
   C       : Array [1..15] of Integer;
   Mat     : Array [1..15, 1..15] of Integer;
   W       : Array [1..15] of Boolean;
   I, G, N : Integer;
   Mat2    : Array [1..15, 1..15] of Integer;
   Stop    : Boolean;
   M       : Integer;
   Count   : Integer;
   CC, CCC : Array [1..15] of Integer;
   T, H    : Integer;
   WalkMen : Integer;
   S       : Integer;
   R       : Array [1..15] of Integer;
   WWW     : Array [1..15] of Boolean;
   Flag    : Boolean;

Procedure Init;
Begin
  Assign(Inp, 'INPUT.TXT');
  Assign(Out, 'OUTPUT.TXT');
  Reset(Inp);
  ReWrite(Out);
End;

Procedure Done;
Begin
  Close(Inp);
  Close(Out);
End;

Procedure Rec(V, I, P: Integer);
 Var
   H: Integer;
Begin
  W[V]:=True;
 For H:=1 To N Do
  If (Mat[V, H] = 1)and(H <> I)and(Not W[H]) Then
   Rec(H, I, V);
  If (Mat[V, I] = 1)and(I <> P) Then Inc(C[I]);
  W[V]:=False;
End;

Procedure Go(NN, V, WW: Integer);
Procedure Rec2(V, I, P: Integer; Var Stop: Boolean);
 Var
   H: Integer;
Begin
 If (V <> I)and(Not Stop) Then
 Begin
   W[V]:=True;
  For H:=1 To N Do
   If (Mat2[V, H] = 1)and(Not W[H])and(Not Stop) Then
    Rec2(H, I, V, Stop);
   W[V]:=False;
  If Stop Then
   Begin
     Inc(S);
     R[S]:=V;
   End;
 End Else
 Begin
   If V = I Then
   Begin
     Stop:=True;
     S:=1;
     R[S]:=I;
   End Else
   Begin
     Inc(S);
     R[S]:=V;
   End;
 End;
End;

 Var
   I   : Integer;
   Stop: Boolean;
Begin
  If WW <> V Then
  Begin
   For I:=1 To N Do
    If Mat2[V, I] = 1 Then
    Begin
      Stop:=False;
      Rec2(V, WW, V, Stop);
    End;
   For I:=S - 1 DownTo 1 Do
    Writeln(Out, NN, ' ', R[I]);
  End;
End;

Procedure Rec3(V, P: Integer);
 Var
   I, G: Integer;
   Flag: Boolean;
Begin
  If W[V] Then WWW[V]:=True;
  For I:=1 To N Do
   If (Not W[I])And(Not WWW[I])and(Mat2[V, I] = 1)and(I <> P)
   Then Begin
     Writeln(Out, Count + WalkMen, ' ', I);
     Flag:=True;
    For G:=I + 1 To N Do
    If (Mat2[V, G] = 1)And(Not W[G])And(Not WWW[G])
     Then Flag:=False;
     If Flag Then WWW[V]:=True;
     Rec3(I, V);
   End;
  WWW[V]:=True;
  Flag:=True;
 For I:=1 To N Do
  If Not (WWW[I] or W[I]) Then Flag:=False;
 If Flag Then
 Begin
   Writeln(Out, 0, ' ', 0);
   Done;
   Halt(0);
 End;
  For I:=1 To N Do
   If (W[I])And(Not WWW[I])and(Mat2[V, I] = 1)and(I <> P)
   Then Begin
     Writeln(Out, Count + WalkMen, ' ', I);
     Rec3(I, V);
   End;
  WWW[V]:=True;
  Flag:=True;
 For I:=1 To N Do
  If Not (WWW[I] or W[I]) Then Flag:=False;
 If Flag Then
 Begin
   Writeln(Out, 0, ' ', 0);
   Done;
   Halt(0);
 End;
  Writeln(Out, Count + WalkMen, ' ', P);
End;

Procedure Run;
Begin
  FillChar(W, SizeOf(W), False);
  FillChar(C, SizeOf(C), 0);
  Readln(Inp, N);
 For I:=1 To N Do
  For G:=1 To N Do
  Begin
    Read(Inp, Mat[I, G]);
    Mat2[I, G]:=Mat[I, G];
  End;
  Stop:=False;
  Count:=0;
 While Not Stop Do
 Begin
  For I:=1 To N Do
   C[I]:=0;
  For I:=1 To N Do
   Rec(I, I, I);
  M:=1;
  For I:=2 To N Do
   If C[I] > C[M] Then M:=I;
  If C[M] = 0
   Then Stop:=True
   Else Begin
     For I:=1 To N Do
     Begin
       Mat[I, M]:=0;
       Mat[M, I]:=0;
     End;
     Inc(Count);
     CC[Count]:=M;
   End;
 End;
  WalkMen:=1;
 For I:=1 To N Do
 Begin
   T:=0;
   Flag:=False;
  For G:=1 To N Do
   If Mat[I, G] = 1 Then Inc(T);
  For H:=1 To Count Do
  For H:=1 To WalkMen - 1 Do
   If Mat[I, CCC[H]] = 1 Then
    Flag:=True;
   If (T >= 3)And(Not Flag)
   Then Begin
     Inc(WalkMen);
     CCC[WalkMen - 1]:=I;
   End;
 End;
  Writeln(Out, Count + WalkMen);
 For I:=1 To Count Do
  Go(I, 1, CC[I]);
 For I:=1 To WalkMen - 1 Do
  Go(Count + I, 1, CCC[I]);
 For I:=1 To N Do
  W[I]:=False;
 For I:=1 To Count Do
  W[CC[I]]:=True;
 For I:=1 To WalkMen - 1 Do
  W[CCC[I]]:=True;
  FillChar(WWW, SizeOf(WWW), False);
  Rec3(1, 1);
End;

Begin
  Init;
  Run;
  Done;
End.
