{$I-,Q-,R-,S-,V-,X-}
type
  tlong = array[0..$ff] of byte;
var
  n,q,p,c,d: tlong;
procedure readlong(var a: tlong);
var
   w: char;
   i,j: integer;
begin c[0]:= 0;
  while not seekeoln do
  begin
    inc(c[0]);
    read(w);
    c[c[0]]:= byte(w)-48;
  end;
  readln;
  a[0]:= (c[0]+1)shr 1; j:= 1;
  for i:= c[0] downto 1 do
  begin
    if (c[0]-i) and 1=0 then a[j]:= c[i] else
    begin inc(a[j],c[i]*10); inc(j); end;
  end;
end;
procedure init;
begin
  assign(input,'Input.txT'); reset(input);
  readlong(n);
  readlong(p);
  readlong(q);
  close(input);
end;
procedure lmul(var a,b: tlong);
var i,j: integer;
  w: word;
begin fillchar(c,sizeof(c),0); c[0]:= 1;
  for i:= 1 to b[0] do
  begin
    for j:= 1 to a[0] do
    begin
      w:= integer(c[i+j-1])+integer(a[i])*integer(b[j]);
      inc(c[i+j], w div 100);
      c[i+j-1]:= w mod 100;
      if(c[0]<i+j)and(c[i+j]<>0)then c[0]:= i+j;
    end;
  end;
  while c[c[0]]>100 do
  begin
    c[c[0]+1]:= c[c[0]] div 100;
    c[c[0]]:= c[c[0]] mod 100;
    inc(c[0]);
  end;
  a:= c;
end;
procedure lwrite(var a: tlong);
var i: integer;
begin
  write(a[a[0]]);
  for i:= a[0]-1 downto 1 do
  begin
    if a[i]<10 then write('0');
    write(a[i]);
  end;
  writeln;
end;
procedure ladd(var a,b: tlong);
var o,i: integer;
begin o:= 0; i:= 1;
  repeat
    inc(o,integer(a[i])+integer(b[i]));
    a[i]:= o mod 100;
    o:= o div 100;
    inc(i);
  until(o=0)and(i>=b[0]);
  if i-1>a[0] then a[0]:= i-1;
end;
procedure lsub(var a,b: tlong);
var i,o: integer;
begin
  o:= 0; i:= 1;
  repeat
    o:= -o;
    inc(o,a[i]);
    dec(o,b[i]);
    if o>=0 then
    begin
      a[i]:= o; o:= 0;
    end else begin
      a[i]:= 100+o; o:= 1;
    end;
    inc(i);
  until(o=0)and(i>b[0]);
  while(a[a[0]]=0)and(a[0]<>1)do dec(a[0]);
end;
function grte(var a,b: tlong): boolean;
var i: integer;
begin grte:= a[0]>=b[0];
  if a[0]<>b[0] then exit;
  for i:= a[0] downto 1 do
    if a[i]>b[i] then exit else if a[i]<b[i] then
    begin grte:= false; exit; end;
end;
function lequ(var a,b: tlong): boolean;
var i: integer;
begin
  lequ:= false;
  if a[0]<>b[0] then exit;
  for i:= a[0] downto 1 do
    if a[i]<>b[i] then exit;
  lequ:= true;
end;
procedure lnod(var a,b: tlong);
begin
  if not grte(a,b) then
  begin
    c:= a; a:= b; b:= c;
  end;
  while(b[0]>1)or(b[1]<>0)do
  begin
    lsub(a,b);
    if lequ(a,b) then
    begin
      c:= a; exit;
    end;
    if grte(b,a) then begin c:= a; a:= b; b:= c; end;
  end;
  c:= a;
end;
function sdiv(var a,b: tlong): integer;
var d: integer;
begin d:= 0;
  while(grte(a,b))do
  begin
    lsub(a,b);
    inc(d);
  end;
  sdiv:= d;
end;
procedure ldiv(var a,b: tlong);
var i: integer;
begin
  i:= a[0]-b[0]+1;
  move(a[i],d[1],sizeof(a[0])*b[0]); d[0]:= b[0];
  c[0]:=0;
  while i>0 do
  begin
    inc(c[0]);
    c[c[0]]:= sdiv(d,b);
    move(d[1],d[2],sizeof(d[0])*d[0]);
    inc(d[0]); dec(i);
    if i<>0 then d[1]:= a[i];
  end;
  a[0]:= c[0]; for i:= a[0] downto 1 do a[i]:= c[a[0]-i+1];
  while(a[a[0]]=0)and(a[0]>1)do dec(a[0]);
end;
procedure solve;
var
  a,b,oa,ob,oc: tlong;
begin
  a:= p; lmul(a,n);
  b:= q; lmul(b,n);
  repeat
    ladd(a,q);
    oa:= a; ob:= b;
    lnod(a,b);
    a:= oa; b:= ob;
  until grte(c,q);
  while(c[1]<>1)or(c[0]<>1)do
  begin oc:= c;
    ldiv(a,oc);
    ldiv(b,oc);
    oa:= a; ob:= b;
    lnod(a,b);
    a:= oa; b:= ob;
  end;
  p:= a; q:= b;
end;
procedure done;
begin
  assign(output,'Output.txT'); rewrite(output);
  lwrite(p);
  lwrite(q);
  close(output);
end;
begin
  init;
  solve;
  done;
end.
