{$I-,Q-,R-,S-,V-,X-}
type
  tlong = array [0..1000] of integer;
  plong = ^tlong;
  tmatr = array [1..100, 1..100] of longint;
var
  k, m, b, r: longint;
  a: array [1..1000] of longint;
  x, xx: array [1..5000] of longint;
  w, wpn, hh: tmatr;
  n: tlong;

procedure ReadL(x: plong);
var
  s: string;
  c: char;
  i: integer;
begin
  repeat Read(c); until (c in ['0'..'9']) or (SeekEof);
  s := '';
  while (c in ['0'..'9']) do begin
    s := s + c;
    if (Eof) then c := #0 else Read(c);
  end;

  fillchar(x^, sizeof(x^), 0);
  x^[0] := length(s);
  for i := 1 to length(s) do x^[length(s)-i+1] := ord(s[i]) - ord('0');
  while ((x^[0]>0) and (x^[x^[0]] < 1)) do dec(x^[0]);
end;

procedure lsub(a: plong; t: integer);
var
  z, cp, x: integer;
begin
  cp := 1; z := t;
  while (z<>0) do begin
    x := a^[cp] - z;
    if (x>=0) then begin a^[cp] := x; z := 0; end else begin
      z := abs(x) div 10;
      x := x + (z*10);
      while (x<0) do begin x := x + 10; inc(z); end;
      a^[cp] := x;
    end;
    inc(cp);
  end;
end;

procedure ldiv2(a: plong);
var
  i: integer;
begin
  for i := 1 to a^[0] do begin
    if ((odd(a^[i])) and (i>1)) then a^[i-1] := a^[i-1] + 5;
    a^[i] := a^[i] shr 1;
  end;
  while ((a^[0]>0) and (a^[a^[0]] < 1)) do dec(a^[0]);
end;

procedure ReadAll;
var  i: longint;
begin
  Assign(Input, 'INPUT.TXT'); Reset(Input);

  Read(k, m);
  for i := 1 to k do Read(a[i]);
  Read(b);
  for i := 1 to k do Read(x[i]);
  ReadL(@n);

  Close(Input);
end;

procedure Out;
begin
  Assign(Output, 'OUTPUT.TXT'); ReWrite(Output);

  WriteLn(r:1);

  Close(Output);
end;

procedure mulmatr(var a, b, c: tmatr);
var
  i, j, q: integer;
begin
  fillchar(c, sizeof(c), 0);
  for i := 1 to k+1 do for j := 1 to k+1 do begin
    for q := 1 to k+1 do begin
      c[i, j] := (c[i, j] + (a[i, q]*b[q, j])) mod m;
    end;
  end;
end;

var
  d: array [1..10000] of boolean;
  nd: integer;

procedure Solve;
var
  i, j, q: integer;
  ml, nn: longint;
begin
{
  for i := k+1 to nn do begin
    x[i] := b;
    for j := 1 to k do x[i] := (x[i] + (a[j]*x[i-j])) mod m;
    x[i] := x[i] mod m;
  end;
  r := x[nn];
  exit;}

  fillchar(w, sizeof(w), 0);

  for i := 1 to k-1 do begin
    w[i+1][i] := 1;
  end;

  for i := 1 to k do begin
    w[i][k] := a[k+1-i];
  end;
  w[k+1][k] := b;
  w[k+1][k+1] := 1;


  nd := 0;
  fillchar(d, sizeof(d), 0);

  if (n[0]<4) then begin
    nn := 0; ml := 1;
    for i := 1 to n[0] do begin
      nn := nn + ml*n[i];
      ml := ml*10;
    end;
    if (nn<=k) then begin
      r := x[nn] mod m;
      exit;
    end else lsub(@n, k);
  end else lsub(@n, k);

  while (n[0]>0) do begin
    inc(nd);
    if ((n[1] and 1) > 0) then d[nd] := true;
    ldiv2(@n);
  end;

  fillchar(wpn, sizeof(wpn), 0);
  for i := 1 to k+1 do wpn[i][i] := 1;

  while (nd>0) do begin
    mulmatr(wpn, wpn, hh);
    wpn := hh;
    if (d[nd]) then begin
      mulmatr(wpn, w, hh);
      wpn := hh;
    end;
    dec(nd);
  end;

  x[k+1] := 1;
  for i := 1 to k+1 do begin
    xx[i] := 0;
    for q := 1 to k+1 do xx[i] := (xx[i] + (x[q]*wpn[q][i])) mod m;
  end;

  r := xx[k];
end;

begin
  ReadAll;
  Solve;
  Out;
end.
