{$I-,Q-,R-,S-,V-,X-}
var
  n: integer;
  a, e: array [1..20, 1..20] of boolean;
  b, bc: longint;

procedure ReadAll;
var i, j, x: integer;
begin
  Assign(Input, 'INPUT.TXT'); Reset(Input);

  Read(n);
  for i := 1 to n do for j := 1 to n do begin
    Read(x);
    if (x=1) then a[i, j] := true else a[i, j] := false;
  end;

  Close(Input);
end;

var
  u: array [1..20] of boolean;
  p: array [1..20] of integer;
  pp: longint;

procedure walk(v: integer);
var
  k: integer;
begin
  while (p[v] > 0) do begin
    k := 1;
    while ((k<=n) and ((u[k]) or (not e[v, k]))) do inc(k);
    if (k>n) then exit;
    dec(p[v]); dec(pp);
    dec(p[k]); dec(pp);
    e[v, k] := false;
    e[k, v] := false;
    v := k;
  end;
end;

procedure walkwo(w, v: integer);
var
  k: integer;
begin
  while (p[v] > 0) do begin
    k := 1;
    while ((k<=n) and ((u[k]) or (not e[v, k]))) do inc(k);
    if (k>n) then exit;
    dec(p[v]); dec(pp);
    dec(p[k]); dec(pp);
    e[v, k] := false;
    e[k, v] := false;
    v := k;
    WriteLn(w:1, ' ', v:1);
  end;
end;

procedure Try(t: longint);
var
  i, j, c: integer;
  x: longint;
begin
  fillchar(u, sizeof(u), 0);
  c := 0;
  x := t;
  for i := 1 to n do begin
    if ((x and 1)>0) then begin
      inc(c);
      u[i] := true;
    end;
    x := x shr 1;
  end;

  if (c>=bc) then exit;

  fillchar(p, sizeof(p), 0);
  pp := 0;
  for i := 1 to n do if (not u[i]) then
  for j := 1 to n do if (not u[j]) then begin
    if a[i, j] then begin inc(p[i]); inc(pp); end;
  end;

  for i := 1 to n do if (p[i] > 2) then exit;

  e := a;
  while (pp>0) do begin
    j := 1;
    while ((j<=n) and (p[j] <> 1)) do inc(j);
    if (j>n) then exit;
    walk(j);
  end;

  if (pp<1) then begin
    if (c<bc) then begin
      bc := c;
      b := t;
    end;
  end;
end;

procedure Solve;
var
  i, m: longint;
begin
  m := 1;
  for i := 1 to n do m := m*2;

  b := m-1;
  bc := n;

  for i := 0 to (m-1) do Try(i);
end;

procedure moveto(w, s, d: integer);
var
  st, fr, p: array [1..30] of integer;
  i, h, t, l: integer;
  v: array [1..30] of boolean;
begin
  fillchar(v, sizeof(v), 0);
  h := 1; t := 1; st[1] := s; fr[1] := 0; v[s] := true;
  while (h<=t) and (not v[d]) do begin
    for i := 1 to n do if (a[st[h], i]) and (not v[i]) then begin
      inc(t);
      st[t] := i; fr[t] := st[h]; v[i] := true;
    end;
    inc(h);
  end;

  i := 1;
  while ((i<=t) and (st[i] <> d)) do inc(i);

  l := 0;
  while (i>0) do begin
    inc(l); p[l] := st[i]; i := fr[i];
  end;

  for i := l-1 downto 1 do begin
    WriteLn(w:1, ' ', p[i]:1);
  end;
end;

procedure Out;
var
  i, j, k, cp: integer;
  x: longint;
begin
  Assign(Output, 'OUTPUT.TXT'); ReWrite(Output);

  WriteLn((bc+1):1);

  fillchar(u, sizeof(u), 0);
  x := b;
  for i := 1 to n do begin
    if ((x and 1)>0) then u[i] := true;
    x := x shr 1;
  end;

  k := 0;
  for i := 1 to n do if u[i] then begin
    inc(k);
    moveto(k, 1, i);
  end;

  fillchar(p, sizeof(p), 0);
  pp := 0;
  for i := 1 to n do if (not u[i]) then
  for j := 1 to n do if (not u[j]) then begin
    if a[i, j] then begin inc(p[i]); inc(pp); end;
  end;

  e := a; cp := 1; inc(k);
  while (pp>0) do begin
    j := 1;
    while ((j<=n) and (p[j] <> 1)) do inc(j);
    if (j>n) then break;
    moveto(k, cp, j);
    walkwo(k, j);
  end;

  WriteLn('0 0');

  Close(Output);
end;

begin
  ReadAll;
  Solve;
  Out;
end.
