var 
  fin, fout :text;
  n :integer;
  base, spyPlan :array[1..15,1..15]of integer;
  power :array[1..15]of integer;
  blocked :array[1..15]of boolean;
  waveCost :array[1..15]of integer;
  waveNext :array[1..15]of integer;
  k :integer;
  i, j ,m :integer;
procedure findBlockRooms;
var i,j :integer;
    maxPower,maxPowerIndex:integer;
begin
  for i:=1 to n do 
    begin
      blocked[i]:=false;
      power[i]:=0;
    end;
  spyPlan:=base;
  for i:=1 to n do
    for j:=1 to n do
      inc(power[i],spyPlan[i,j]);
  k:=1;
  repeat
    maxPower:=-1;
    for i:=1 to n do if (power[i]>maxPower) then
      begin
        maxPower:=power[i];maxPowerIndex:=i;
      end;
    if maxPower<3 then break;
    inc(k);
    for i:=1 to n do 
      begin
        dec(power[i],spyPlan[i,maxPowerIndex]);
        spyPlan[i,maxPowerIndex]:=0;
        spyPlan[maxPowerIndex,i]:=0;
      end;
    blocked[maxPowerIndex]:=true;
    power[maxPowerIndex]:=0;
  until false;
{  for i:=1 to n do writeln(blocked[i]);
  writeln(k);}
end;
procedure spyWave(deep,a,prev:integer);
var i:integer;
begin
  if (waveCost[a]<>0)and(waveCost[a]<=deep) then exit;
  waveCost[a]:=deep;
  waveNext[a]:=prev;
  for i:=1 to n do if base[a,i]=1 then spyWave(deep+1,i,a);
end;
procedure findCycles;
var i,j,h:integer;
begin
  for i:=1 to n do
    for j:=1 to n do
      if (spyPlan[i,j]<>0)and(not blocked[i])and(not blocked[j]) then
        begin
          spyplan[i,j]:=0;
          spyplan[j,i]:=0;
          for h:=1 to n do waveCost[i]:=0;
          spyWave(1,i,0);
          spyplan[i,j]:=1;
          spyplan[j,i]:=1;
          if waveCost[j]<>0 then
            begin
              for h:=1 to n do spyPlan[h,j]:=0;
              for h:=1 to n do spyPlan[j,h]:=0;
              blocked[j]:=true;
            end
        end;
end;
procedure wave(deep,a,prev:integer);
var i:integer;
begin
  if (waveCost[a]<>0)and(waveCost[a]<=deep) then exit;
  waveCost[a]:=deep;
  waveNext[a]:=prev;
  for i:=1 to n do if base[a,i]=1 then wave(deep+1,i,a);
end;
procedure moveBlockers;
var i,j,point:integer;
begin
  m:=1;
  writeln(fout,k);
  for i:=1 to n do
    if blocked[i] then
      begin
        for j:=1 to n do waveCost[j]:=0;
        wave(1,i,0);
        point:=1;
        while waveNext[point]<>0 do
          begin
            point:=waveNext[point];
            writeln(fout,m,' ',point);
          end;
        inc(m);
      end;
end;
procedure lookOut;
var i,j:integer;
point:integer;
begin
  point:=1;
  for i:=1 to n do
    begin
      for j:=1 to n do waveCost[j]:=0;
      wave(1,i,0);
      while waveNext[point]<>0 do
        begin
          point:=waveNext[point];
          writeln(fout,k,' ',point);
        end;
    end;
end;
begin
  assign(fin,'INPUT.TXT');
  reset(fin);
  read(fin,n);
  for i:=1 to n do for j:=1 to n do read(fin,base[i,j]);
  close(fin);
  assign(fout,'OUTPUT.TXT');
  rewrite(fout);

  findBlockRooms;
{  findCycles;}
  moveBlockers;
  lookOut;

  close(fout);
end.