{$UNDEF DEBUG}
{$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}

Const
 {$IFDEF DEBUG}
  Inp='c:\work\day26\INPUT.TXT';
  Outp='c:\work\day26\OUTPUT.TXT';
 {$ELSE}
  Inp='Input.TXT';
  Outp='Output.TXT';
 {$ENDIF}
 MaxK=20;
 MaxN=100;
 TimeLimit=3;

var
 K, N: Word;
 A: Array [1..MaxN, 0..MaxK] of Integer;
 C: Array [1..MaxN] of Boolean;
 B, D: Array [1..MaxN] of Word;
 {$IFDEF TIMELIMIT}
 Break: TDatetime;
 {$ENDIF}
 Ok: Boolean;

Procedure init;
 Var X: Array [1..MaxK] of Integer;
     i, j, l: Integer;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  Read(k, N);
  for i:=1 to N do begin
   l:=0;
   for j:=1 to K do begin
    read(X[j]);
    if X[j]<>-1 Then begin
     Inc(l);
     A[i, l]:=X[j];
    End;
   end;
   A[i, 0]:=L;
  End;
  close(Input);
 End;

Procedure solve;
 var i, j, l, q: Integer;
     can: Boolean;
 Begin
  i:=0;
  FillChar(C, SizeOf(C), True);
  FillChar(D, SizeOf(D), 0);
  j:=0;
  Ok:=False;
  While
   {$IFDEF TIMELIMIT}
   (Time<Break) and
   {$ENDIF}
   (I<N) do begin
   Inc(j);
   if j<=N Then Begin
    if C[j] Then begin
     Can:=True;
     for q:=1 to A[j, 0] do
      if C[A[j, q]] and (D[A[j, q]]>=K) Then
       can:=False;
     if can Then begin
      for q:=1 to A[j, 0] do
       if C[A[j, q]]  Then
        Inc(D[A[j, q]]);
      C[j]:=false;
      Inc(i);
      B[i]:=j;
      j:=0;
     End;
    End;
   End else begin
    j:=B[i];
    for q:=1 to A[j, 0] do
     if C[A[j, q]]  Then
      dec(D[A[j, q]]);
    C[j]:=True;
    dec(i);
   End;
  end;
  Ok:=(I=N);
 End;

procedure done;
 Var i: Integer;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  if Ok Then
   For i:=1 to N do
    Write(B[i], ' ')
  Else
   Write('NO');
  close(Output);
 End;

begin
 Init;
 Solve;
 Done;
End.
