{$UNDEF DEBUG}
{$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}

Const
  InpF='INPUT.TXT';
  OutpF='OUTPUT.TXT';
  DebugPath='c:\work\day27\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=10;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}
 Const
  MaxN=10;

var
 N, M: Word;
 A, D: Array [0..MaxN, 0..MaxN] of Integer;
 C, E, Z: Array [0..2] of Integer;
 B: Array [0..MaxN, 0..MaxN, 1..2] of Integer;



Procedure init;
 Begin
  Break:=Time+TimeLimit/24/3600;
  Assign(Input, Inp);
  reset(input);
  Read(N, M);
  close(Input);
 End;

procedure done;
 Var i, j: Integer;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  WriteLn(E[1]+E[2]);
  for i:=0 to N-1 do begin
   for j:=0 to M-1 do Write(D[j, i], ' ');
   WriteLn;
  End;
  close(Output);
  Halt(0);
 End;


Procedure solve;
 var i, ee: Integer;

 Procedure Add(x, y, t, q: Integer);
  var i, x1, x2: Integer;
  Begin
   for i:=0 to M-1 do Inc(B[i, y, t], q);
   for i:=0 to N-1 do Inc(B[x, i, t], q);

   x1:=x-y;
   if x1<0 Then x1:=0;
   x2:=N-1+x-y;
   if x2>M Then x1:=M-1;
   for i:=x1 to x2 do
    Inc(B[i, i-x+y, t], q);

   x1:=x+y-n+1;
   if x1<0 Then x1:=0;
   x2:=x+y;
   if x2>M Then x1:=M-1;
   for i:=x1 to x2 do
    Inc(B[i, x+y-i, t], q);
  End;

  Procedure Find(x, y: Word);
  var i: Integer;
      x1, y1: Integer;
  Begin
   if (y<N) Then begin
    FillChar(Z, SizeOf(Z), 0);
    for x1:=0 to M-1 do
     for y1:=0 to N-1 do begin
      if B[x1, y1, 1]=0 Then
       Inc(Z[2]);
      if B[x1, y1, 2]=0 Then
       Inc(Z[1]);
     end;
    x1:=(x+1) mod M;
    y1:=y+((x+1) div M);

    if (A[x, y]=0) and (C[0] > Abs(C[1]-C[2]))
     and ((C[1]+Z[1])>E[1]) and ((C[2]+Z[2])>E[2]) Then Begin
     if (B[x, y, 2]=0) and ((C[1]-C[2]) < Z[2]) Then begin
      A[x, y]:=1;
      Inc(C[1]);
      dec(C[0]);
      Add(x, y, 1, +1);
      Find(x1, y1);
      Add(x, y, 1, -1);
      Dec(C[1]);
      Inc(C[0]);
      A[x, y]:=0;
     End;

     if (B[x, y, 1]=0) and ((C[2]-C[1]) < Z[1]) Then Begin
      A[x, y]:=2;
      Inc(C[2]);
      Dec(C[0]);
      Add(x, y, 2, +1);
      Find(x1, y1);
      Add(x, y, 2, -1);
      Dec(C[2]);
      Inc(C[0]);
      A[x, y]:=0;
     End;
    End;
    Find(x1, y1);
   End else begin
    if (C[1]=C[2]) And (C[1]>E[1]) Then Begin
     D:=A;
     E:=C;
    End;
    if Time >= Break Then
     Done;
   End;
  End;

  Procedure Find2(x, y: Word);
  var i: Integer;
      x1, y1: Integer;
  Begin
   if (y<N){ and (Time<Break)} Then begin
   FillChar(Z, SizeOf(Z), 0);
    for x1:=0 to M-1 do
     for y1:=0 to N-1 do begin
      if B[x1, y1, 1]=0 Then
       Inc(Z[2]);
      if B[x1, y1, 2]=0 Then
       Inc(Z[1]);
     end;
    x1:=(x+1) mod M;
    y1:=y+((x+1) div M);
    if (Z[1]>=(ee-C[1])) and (Z[2]>=(ee-C[2])) Then Begin
{     if C[1]<ee Then Begin}
      if (B[x, y, 2]=0) Then begin
       A[x, y]:=1;
       Inc(C[1]);
       dec(C[0]);
       Add(x, y, 1, +1);
       Find(x1, y1);
       Add(x, y, 1, -1);
       Dec(C[1]);
       Inc(C[0]);
       A[x, y]:=0;
      End;
{     End else Begin}
      if (B[x, y, 1]=0) Then Begin
       A[x, y]:=2;
       Inc(C[2]);
       Dec(C[0]);
       Add(x, y, 2, +1);
       Find(x1, y1);
       Add(x, y, 2, -1);
       Dec(C[2]);
       Inc(C[0]);
       A[x, y]:=0;
      End;
{     End;}
    End;
    Find(x1, y1);
   End else begin
    if (C[1]=C[2]) And (C[1]>E[1]) Then Begin
     D:=A;
     E:=C;
     Done;
    End;
    if Time >= Break Then
     Done;
   End;
  End;

 Procedure SolveFor2;
  var i, j: Integer;
  Begin
   if N=2 Then begin
    if Odd(M) Then  E[1]:=M div 2
              Else  E[1]:=(M div 2) - 1;
    E[2]:=E[1];
    for i:=1 to E[1] do  D[i, 1]:=1;
    for i:=1 to E[1] do  D[M-i+1, 2]:=2;
   End;

   if M=2 Then begin
    if Odd(N) Then E[1]:=N div 2
              Else E[1]:=(N div 2) - 1;
    E[2]:=E[1];
    for i:=1 to E[1] do D[1, i]:=1;
    for i:=1 to E[1] do D[2, N-i+1]:=2;
   End;
  End;

 Begin
  FillChar(A, SizeOf(A), 0);
  FillChar(B, SizeOf(B), 0);
  FillChar(C, SizeOf(C), 0);
  FillChar(D, SizeOf(D), 0);
  FillChar(E, SizeOf(E), 0);
  FillChar(Z, SizeOf(Z), 0);

  if (N>1) and (M>1) Then
   if (N=2) or (M=2) Then
    SolveFor2
   Else
   Begin
    C[0]:=N*M;
    Z[1]:=N*M;
    Z[2]:=N*M;
    Find(0, 0);
   End;
 End;


begin
 Init;
 Solve;
 Done;
End.

