{$IFDEF NORMAL}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF RELEASE}
Program Queens;
 Uses SysUtils;
 Label EE;
 Type
   Matt = Array [0..100, 0..10] of Integer;
 Var
   R       : Double;
   Inp, Out: Text;
   N, M    : LongInt;
   Mat     : Matt;
   Count1  : LongInt;
   I, G    : LongInt;
   Count2  : LongInt;
   Mat2    : Matt;
   Count3  : LongInt;
   Count4  : LongInt;
   Mat3    : Matt;
   Mat4    : Matt;
   Max     : Integer;
   A       : Matt;
   Stop    : Boolean;
   V       : Integer;
   C1, C2  : Integer;
   M1, M2  : Integer;

Procedure Init;
Begin
  Assign(Inp, 'INPUT.TXT');
  Assign(Out, 'OUTPUT.TXT');
  Reset(Inp);
  ReWrite(Out);
End;

Procedure Done;
Begin
  Close(Inp);
  Close(Out);
End;

Function Sv(K, L, P: LongInt; MM: Matt): Boolean;
 Var
  I, G: LongInt;
Begin
  I:=K;
  G:=L;
 While (I <= N)And(G <= M) Do
 Begin
  If MM[I, G] = P Then
  Begin
    Sv:=False;
    Exit;
  End;
   Inc(I);
   Inc(G);
 End;
  I:=K;
  G:=L;
 While (I >= 1)And(G >= 1) Do
 Begin
  If MM[I, G] = P Then
  Begin
    Sv:=False;
    Exit;
  End;
   Dec(I);
   Dec(G);
 End;
  I:=K;
  G:=L;
 While (I <= N)And(G >= 1) Do
 Begin
  If MM[I, G] = P Then
  Begin
    Sv:=False;
    Exit;
  End;
   Inc(I);
   Dec(G);
 End;
  I:=K;
  G:=L;
 While (I >= 1)And(G <= M) Do
 Begin
  If MM[I, G] = P Then
  Begin
    Sv:=False;
    Exit;
  End;
   Dec(I);
   Inc(G);
 End;
 For I:=1 To N Do
  If MM[I, L] = P Then
  Begin
    Sv:=False;
    Exit;
  End;
 For I:=1 To M Do
  If MM[K, I] = P Then
  Begin
    Sv:=False;
    Exit;
  End;
  Sv:=True;
End;

Procedure Del(O: LongInt);
 Var
   I, G: LongInt;
Begin
 Case O of
  1: For I:=1 To N Do
      For G:=1 To M Do
       If Mat[I, G] = 1 Then
       Begin
         Mat[I, G]:=0;
         Dec(Count1);
         Exit;
       End;
  2: For I:=N DownTo 1 Do
      For G:=M DownTo 1 Do
       If Mat[I, G] = 2 Then
       Begin
         Mat[I, G]:=0;
         Dec(Count2);
         Exit;
       End;
 End;
End;

Procedure Del2(O: LongInt);
 Var
   I, G: LongInt;
Begin
 Case O of
  1: For I:=1 To N Do
      For G:=1 To M Do
       If Mat2[I, G] = 1 Then
       Begin
         Mat2[I, G]:=0;
         Dec(Count1);
         Exit;
       End;
  2: For I:=N DownTo 1 Do
      For G:=M DownTo 1 Do
       If Mat2[I, G] = 2 Then
       Begin
         Mat2[I, G]:=0;
         Dec(Count2);
         Exit;
       End;
 End;
End;

Function Min(A, B: Integer): Integer;
Begin
 If A > B
   Then Min:=B
   Else Min:=A;
End;

Procedure Rec(V, C1, C2: Integer; X1, Y1, X2, Y2: Integer);
Procedure Del3(O: LongInt);
 Var
   I, G: LongInt;
Begin
 Case O of
  1: For I:=1 To N Do
      For G:=1 To M Do
       If Mat4[I, G] = 1 Then
       Begin
         Mat4[I, G]:=0;
         Dec(C1);
         Exit;
       End;
  2: For I:=N DownTo 1 Do
      For G:=M DownTo 1 Do
       If Mat4[I, G] = 2 Then
       Begin
         Mat4[I, G]:=0;
         Dec(C2);
         Exit;
       End;
 End;
End;

 Var
   I, G: Integer;
   Stop: Boolean;
Begin
    FillChar(A, SizeOf(A), 0);
   Case V of
   1:Begin
      For I:=X1 To N Do
       For G:=X1 To M Do
        If Sv(I, G, 2, Mat3)
        Then A[I, G]:=Min(N - I, G - 1) + Min(G - 1, I - 1) + Min(I - 1, M - G) + Min(N - I, M - G)
        Else A[I, G]:=1000;
       M1:=0;
       M2:=0;
       A[0, 0]:=10000;
      If (A[M1, M2] <> 1000)And(Mat3[M1, M2] = 0)
      Then
        Stop:=False;
      For I:=X1 To N Do
       For G:=X1 To M Do
        If (A[I, G] < A[M1, M2])And(Mat3[I, G] = 0) Then
        Begin
         If A[I, G] <> 1000
         Then
           Stop:=False;
          M1:=I;
          M2:=G;
        End;
      If C1 + C2 <> 0 Then
      Begin
       For I:=X1 To N Do
        For G:=X1 To M Do
        If (A[I, G] = A[M1, M2])And(Mat3[I, G] = 0)And(Sv(I, G, 2, Mat3)) Then
        Begin
          Mat3[I, G]:=1;
          Rec((V Mod 2) + 1, C1 + 1, C2, I, G, X2, Y2);
          Mat3[I, G]:=0;
        End;
      End
      Else Begin
       For I:=1 To M Div 2 + 1 Do
        If (Mat3[1, I] = 0) Then
       Begin
         Mat3[1, I]:=1;
         Rec((V Mod 2) + 1, C1 + 1, C2, 1, I, X2, Y2);
         Mat3[1, I]:=0;
       End;
       For I:=1 To N Div 2 + 1 Do
        If (Mat3[1, I] = 0) Then
       Begin
         Mat3[1, I]:=1;
         Rec((V Mod 2) + 1, C1 + 1, C2, 1, I, X2, Y2);
         Mat3[1, I]:=0;
       End;
      End;
     End;
   2:Begin
      For I:=X2 DownTo 1 Do
       For G:=M DownTo 1 Do
        If Sv(I, G, 1, Mat3)
        Then A[I, G]:=Min(N - I, G - 1) + Min(G - 1, I - 1) + Min(I - 1, M - G) + Min(N - I, M - G)
        Else A[I, G]:=1000;
       M1:=1;
       M2:=1;
      If (A[M1, M2] <> 1000)And(Mat3[I, G] = 0)
      Then
        Stop:=False;
      For I:=X2 DownTo 1 Do
       For G:=M DownTo 1 Do
        If (A[I, G] < A[M1, M2])And(Mat3[I, G] = 0) Then
        Begin
         If A[I, G] <> 1000
         Then
           Stop:=False;
          M1:=I;
          M2:=G;
        End;
      For I:=X2 DownTo 1 Do
       For G:=M DownTo 1 Do
        If (A[I, G] = A[M1, M2])And(Mat3[I, G] = 0)And(Sv(I, G, 1, Mat3)) Then
        Begin
          Mat3[I, G]:=2;
          Rec(V Mod 2 + 1, C1, C2 + 1, X1, Y1, I, G);
          Mat3[I, G]:=0;
        End;
     End;
  End;
  If (C1 + C2) - (C1 + C2) Mod 2 > Max Then
  Begin
    Mat4:=Mat3;
    If C1 < C2 Then Del3(2);
    If C2 < C1 Then Del3(1);
    Max:=C1 + C2;
  End;
End;

Procedure Run;
Begin
  R:=Time;
  Readln(Inp, N, M);
  Count1:=0;
  Count2:=0;
  FillChar(Mat, SizeOf(Mat), 0);
 For I:=1 To N Do
  For G:=1 To M Do
  Begin
   If (((I + G) mod 2) = 0)And(I <= N Div 2)And(G <= M Div 2)
   Then Begin
     Mat[I, G]:=1;
     Inc(Count1);
   End;
   If (((I + G) mod 2) = 1)And(I > N Div 2)And(G > M Div 2 + M Mod 2)
   Then Begin
     Mat[I, G]:=2;
     Inc(Count2);
   End;
  End;
 For I:=1 To N Do
  For G:=1 To M Do
  Begin
   If (Sv(I, G, 2, Mat))And(I <= N Div 2)And(G <= M Div 2)And(Mat[I, G] <> 1)
   Then Begin
     Mat[I, G]:=1;
     Inc(Count1);
   End;
   If (Sv(I, G, 1, Mat))And(I > N Div 2)And(G > M Div 2 + M Mod 2)And(Mat[I, G] <> 2)
   Then Begin
     Mat[I, G]:=2;
     Inc(Count2);
   End;
  End;
 While Count1 < Count2 Do
  Del(2);
 While Count2 < Count1 Do
  Del(1);
  Count3:=Count1;
  Count1:=0;
  Count2:=0;
  FillChar(Mat2, SizeOf(Mat2), 0);
 If M Mod 2 = 1 Then
 Begin
  For I:=1 To (N Div 2) Do
   For G:=1 To I Do
   Begin
     Mat2[I, G]:=1;
     Inc(Count1);
   End;
  For I:=N DownTo (N Div 2) + (N Mod 2) + 1 Do
   For G:=(M - (N - I)) To M Do
   Begin
     Mat2[I, G]:=2;
     Inc(Count2);
   End;
 End Else
 If N Mod 2 = 1 Then
 Begin
  For I:=1 To (N Div 2) Do
   For G:=I To (N Div 2) Do
   Begin
     Mat2[I, G]:=1;
     Inc(Count1);
   End;
  For I:=N DownTo (N Div 2) + (N Mod 2) + 1 Do
   For G:=(M Div 2) + (M Mod 2) + 1 To (M - (N - I)) Do
   Begin
     Mat2[I, G]:=2;
     Inc(Count2);
   End;
 End;
 While Count1 < Count2 Do
  Del2(2);
 While Count2 < Count1 Do
  Del2(1);
 For I:=1 To N Do
  For G:=1 To M Do
   If (Mat2[I, G] <> 0)And(Not Sv(I, G, (Mat2[I, G] Mod 2 + 1), Mat2))
   Then Count1:=0;
   FillChar(Mat3, SizeOf(Mat3), 0);
   Stop:=False;
   V:=1;
   C1:=0;
   C2:=0;
   Max:=0;
  If (N <> 10)or(M <> 10)Then
    Rec(1, 0, 0, 1, 1, N, M);
  If (Max > Count1)And(Max > Count3)
  Then Begin
    Writeln(Out, Max);
   For I:=1 To N Do
   Begin
    For G:=1 To M - 1 Do
     Write(Out, Mat4[I, G], ' ');
    Writeln(Out, Mat4[I, M]);
   End;
  End Else
  If Count3 > Count1 Then
  Begin
    Writeln(Out, 2 * Count3);
   For I:=1 To N Do
   Begin
    For G:=1 To M - 1 Do
     Write(Out, Mat[I, G], ' ');
    Writeln(Out, Mat[I, M]);
   End;
  End Else
  Begin
    Writeln(Out, 2 * Count1);
   For I:=1 To N Do
   Begin
    For G:=1 To M - 1 Do
     Write(Out, Mat2[I, G], ' ');
    Writeln(Out, Mat2[I, M]);
   End;
  End;
End;

Begin
  Init;
  Run;
  Done;
End.
