function myway(var t: town; var w: way): double;
var
  fin: double;
  p: array[0..99, 0..99] of double;
  o: array[0..99, 0..99] of word;
  way: array[0..1000] of byte;
  i, u: array[0..99] of byte;
  breaktime: double;
  e: byte;
  wn: integer;

  procedure findmatrix;
  var
    c1, c2: word;
  begin
    fillchar(i, sizeof(i), 0);
    for c1 := 0 to t.n-1 do begin
      for c2 := 0 to t.n-1 do begin
        if t.a[c1, c2] = 1 then begin
          o[c1, i[c1]] := c2; inc(i[c1]);
          p[c1, c2] := sqrt(sqr(t.x[c1, 0]-t.x[c2, 0])+
                            sqr(t.x[c1, 1]-t.x[c2, 1]));
        end;
      end;
    end;
  end;

  procedure go(c: byte; s: double; l: byte);
  var
    c1: integer;
    z: boolean;
  begin
    if ((s > fin) and (fin <> 0)) or (now >= breaktime) then begin
      exit;
    end;
    z := true;
    for c1 := 0 to t.n-1 do begin
      if u[c1] = 0 then begin
        z := false; break;
      end;
    end;
    if (z) and (t.a[c, 0] = 1) then begin
      s := s+p[c, 0];
      if (fin = 0) or (s < fin) then
        fin := s;
        w.m := wn+2;
        for c1 := 0 to wn do begin
          w.w[c1] := way[c1];
        end;
        w.w[wn+1] := 0;
      exit;
    end;
    for c1 := 0 to i[c]-1 do if (o[c, c1] <> l) and (t.a[c, o[c, c1]] = 1) then begin
      u[o[c, c1]] := 1; inc(wn); way[wn] := o[c, c1];
      go(o[c, c1], s+p[c, o[c, c1]], c);
      u[o[c, c1]] := 0; dec(wn);
    end;
  end;

begin
  breaktime := now+9.8/(24*60*60); e := 0; wn := 0; way[0] := 0;
  findmatrix;
  fin := 0; fillchar(u, sizeof(u), 0); u[0] := 1;
  go(0, 0, 0);
  myway := fin;
end;
