{$I-,Q-,R-,S-,V-,X-}
uses sysutils;
const  tm:double = (7/(24*60*60));
type   ta = array [1..12, 1..12] of byte;
var
  p, a, r: ta;
  n, m, rc, cc: integer;
  st: double;
  f: boolean;
  bt: byte;

procedure upd;
begin
  r := p; rc := cc;
end;

procedure put(si, sii: integer);
var
  i, j, ii, jj, hi, hj: integer;
  o, ob: ta;
begin
  if f then exit;
  inc(bt);
  if (bt=0) then begin if (Now>st) then begin f := true; exit; end; end;

  o := a;
  for i := si to n do for j := 1 to m do if ((a[i, j] and 1)>0) then begin
    a[i, j] := 0; p[i, j] := 1;
    for hi := 1 to n do a[hi, j] := a[hi, j] and 1;
    for hj := 1 to m do a[i, hj] := a[i, hj] and 1;
    hi := i+1; hj := j+1;
    while (hi<=n) and (hj<=m) do begin
      a[hi, hj] := a[hi, hj] and 1;
      inc(hi); inc(hj);
    end;
    hi := i-1; hj := j-1;
    while (hi>0) and (hj>0) do begin
      a[hi, hj] := a[hi, hj] and 1;
      dec(hi); dec(hj);
    end;
    hi := i+1; hj := j-1;
    while (hi<=n) and (hj>0) do begin
      a[hi, hj] := a[hi, hj] and 1;
      inc(hi); dec(hj);
    end;
    hi := i-1; hj := j+1;
    while (hi>0) and (hj<=m) do begin
      a[hi, hj] := a[hi, hj] and 1;
      dec(hi); inc(hj);
    end;

    ob := a;
    for ii:=sii downto 1 do for jj:=m downto 1 do if ((a[ii,jj] and 2)>0) then begin
      a[ii, jj] := 0; p[ii, jj] := 2;
      for hi := 1 to n do a[hi, jj] := a[hi, jj] and 2;
      for hj := 1 to m do a[ii, hj] := a[ii, hj] and 2;
      hi := ii+1; hj := jj+1;
      while (hi<=n) and (hj<=m) do begin
        a[hi, hj] := a[hi, hj] and 2;
        inc(hi); inc(hj);
      end;
      hi := ii-1; hj := jj-1;
      while (hi>0) and (hj>0) do begin
        a[hi, hj] := a[hi, hj] and 2;
        dec(hi); dec(hj);
      end;
      hi := ii+1; hj := jj-1;
      while (hi<=n) and (hj>0) do begin
        a[hi, hj] := a[hi, hj] and 2;
        inc(hi); dec(hj);
      end;
      hi := ii-1; hj := jj+1;
      while (hi>0) and (hj<=m) do begin
        a[hi, hj] := a[hi, hj] and 2;
        dec(hi); inc(hj);
      end;

      cc := cc + 2;
      if (cc>rc) then upd;
      put(i, ii);
      a := ob; p[ii, jj] := 0; cc := cc - 2;
    end;
    a := o; p[i, j] := 0;
  end;
end;

procedure Solve;
var  i, j: integer;
begin
  fillchar(r, sizeof(r), 0); rc := 0;
  fillchar(p, sizeof(p), 0);
  for i := 1 to n do for j := 1 to m do a[i, j] := 3;
  cc := 0;

  f := false; bt := 1;
  put(1, n);
end;

procedure ReadAll;
begin
  Assign(Input, 'INPUT.TXT'); Reset(Input);

  Read(n, m);

  Close(Input);
end;

procedure Out;
var  i, j: integer;
begin
  Assign(Output, 'OUTPUT.TXT'); ReWrite(Output);

  WriteLn(rc:1);
  for i := 1 to n do begin
    for j := 1 to m do begin
      if (j>1) then Write(' ');
      Write(r[i, j]:1);
    end;
    WriteLn;
  end;

  Close(Output);
end;

begin
  st := now + tm;
  ReadAll;
  Solve;
  Out;
end.
