{$UNDEF DEBUG}
{$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}



Const
  InpF='input.txt';
  OutpF='output.txt';
  DebugPath='c:\work\day28\3\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=10;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}

const
 Eps=1e-10;
 MaxN=20;

Type
 Real=Extended;
 TPoint = Record
           X, Y: Real;
          End;
 TLine = Record
          A, B, C : Real;
         End;

Var
 A: Array [1..maxn] of TLine;
 N, M: Word;
 B: Array [1..MaxN*MaxN] of TPoint;
 C: Array [1..MaxN, 1..MaxN] of Word;

Function Sign(A: Real): Integer;
 Begin
  if A>Eps Then
   Sign:=1
  else
   if A<-Eps Then
    Sign:=-1
   else
    Sign:=0;
 End;

Function Min(A, B: Real): Real;
 Begin
  if (A-B)>Eps Then
   Min:=B
  Else
   Min:=A;
 End;

Function Max(A, B: Real): Real;
 Begin
  if (A-B)>Eps Then
   Max:=A
  Else
   Max:=B;
 End;

Function Between(A, B, C: Real): Boolean;
 Begin
  Between:=((B-Min(A, C))>-eps) and ((B-Max(A, C))<eps);
 End;

Function CrossLine(Const L1, L2: TLine; var P: TPoint): Boolean;
 var D: Real;
 Begin
  D:=L2.A*L1.B-L2.B*L1.A;
  if Abs(d)<=Eps Then
   CrossLine:=False
  Else Begin
   P.X:=(L1.C*L2.B-L1.B*L2.C)/d;
   P.Y:=(L1.A*L2.C-L1.C*L2.A)/d;
   CrossLine:=True;
  End;
 End;

Procedure init;
 Var i: Integer;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  Read(N);
  For i:=1 to N do
   Read(A[i].A, A[i].B, A[i].C);
  close(Input);
 End;

Procedure solve;
 Begin
 End;

procedure done;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  if N=1 Then begin
   WriteLn(1);
   WriteLn(1e10, ' ', 1e10);
  End;
  if N=2 Then begin
   WriteLn(2);
   WriteLn(1e10, ' ', (((-A[1].C-1e10*A[1].A)/A[1].B)+((-A[2].C-1e10*A[2].A)/A[2].B))/2);
   WriteLn(-1e10, ' ', (((-A[1].C+1e10*A[1].A)/A[1].B)+((-A[2].C+1e10*A[2].A)/A[2].B))/2);
  End;

  close(Output);
 End;

begin
 Init;
 Solve;
 Done;
End.

