{$UNDEF DEBUG}
{$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}



Const
  InpF='INPUT.TXT';
  OutpF='OUTPUT.TXT';
  DebugPath='c:\work\day28\3\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=10;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}

const
 Eps=1e-10;
 MaxN=20;

Type
 Real=Extended;
 TPoint = Record
           X, Y, Z: Real;
          End;

Var
 A: Array [1..maxn] of TPoint;
 T1, T2, T3: Real;
 P: TPoint;

Procedure init;
 Var i: Integer;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  For i:=1 to 4 do
   Read(A[i].X, A[i].Y, A[i].Z);
  close(Input);
 End;

Procedure solve;
 Begin
  P:=A[Random(4)+1];
  if (T1=T2) and (T2=T3) Then begin
   P.X:=(A[2].X+A[3].X+A[4].X)/3;
   P.Y:=(A[2].Y+A[3].Y+A[4].Y)/3;
   P.Z:=(A[2].Z+A[3].Z+A[4].Z)/3;
  end;
 End;

procedure done;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  WriteLn(P.X, ' ', P.Y, ' ', P.Z);
  close(Output);
 End;

begin
 Init;
 Solve;
 Done;
End.

