Const InFile = 'INPUT.TXT'; Outfile = 'OUTPUT.TXT'; MaxN = 100;
      Eps = 0.00000001;
Var A: Array [1..MaxN,1..3,1..2] Of real;
    V: array [1..MaxN] of byte;
    N,S: Integer;
    X,Y: Real;

Function Rast(k,i,j: integer): real;
begin
     Rast:=Sqrt(sqr(a[k,i,1]-a[k,j,1])+sqr(a[k,i,2]-a[k,j,2]));
end;

Procedure Init;
Var I,k: Integer;
Begin
     Assign(Input,InFile);
     Reset(Input);
     Read(N);
     For I:=1 To N Do
         Read(A[I,1,1],a[I,1,2],a[I,2,1],a[I,2,2],a[I,3,1],a[I,3,2]);
     X:=0; Y:=0;
     FillChar(v,SizeOf(V),0);
     For k:=1 to N DO
     If ((rast(k,1,2)+rast(k,2,3)-rast(k,1,3)) < -eps)or
        ((rast(k,1,2)+rast(k,1,3)-rast(k,2,3)) < -eps)or
        ((rast(k,2,3)+rast(k,1,3)-rast(k,1,2)) < -eps)or
        (abs(rast(k,1,2)+rast(k,2,3)-rast(k,1,3)) < eps)or
        (abs(rast(k,1,2)+rast(k,1,3)-rast(k,2,3)) < eps)or
        (abs(rast(k,2,3)+rast(k,1,3)-rast(k,1,2)) < eps)Then v[k]:=1;
     Close(Input);
End;

procedure line(X1,y1,x2,y2: real; var a,b,c: real);
Begin
     b:=x1-x2; a:=y2-y1;
     c:=-(a*x1+y1*b);
End;

function per(a1,b1,c1,a2,b2,c2: real; var xx,yy: real): boolean;
var st: real;
Begin
     st:=b1*a2-a1*b2;
     If round(st) = 0 Then per:=false
        Else
            Begin
                 per:=true;
                 xx:=(b2*c1-c2*b1)/st;
                 yy:=(c2*a1-a2*c1)/st;
            End;
End;

Function pr(x1,y1,x2,y2: real; xx,yy: real): Boolean;
var a1,b1,c1,a2,b2,c2: real;
begin
     line(x1,y1,xx,yy,a1,b1,c1);
     line(x1,y1,x2,y2,a2,b2,c2);
     pr:=(xx <= x2)and(x1  <= xx)or(xx <= x2)and(x1 <= xx)and
         (y1 <= yy)and(yy <= y2)or(y1 <= yy)and(yy <= y2)and
             (a1*b2-a2*b1 = 0);
End;

function peres(x1,y1,x2,y2,x3,y3,x4,y4: real; var xx,yy: real): boolean;
var a1,b1,c1,a2,b2,c2: real;
Begin
     line(x1,y1,x2,y2,a1,b1,c1);
     line(x3,y3,x4,y4,a2,b2,c2);
     If per(a1,b1,c1,a2,b2,c2,xx,yy) and
        pr(x1,y1,x2,y2,xx,yy) Then peres:=true
        Else peres:=False;
End;

Function Prov(X1,Y1: Real; K: Integer): Boolean;
var xx,yy: real;
    y: integer;
Begin
     prov:=false; y:=0;
     If ((abs(a[k,1,1]-x1) < eps)and(abs(a[k,1,2]-y1) < eps))or
        ((abs(a[k,2,1]-x1) < eps)and(abs(a[k,2,2]-y1) < eps))or
        ((abs(a[k,3,1]-x1) < eps)and(abs(a[k,3,2]-y1) < eps)) Then Begin prov:=true; exit; End;
     If (((x1-a[k,1,1]) > eps)And((x1-a[k,2,1]) > eps)and((x1-a[k,3,1]) > eps))or
        (((y1-a[k,1,2]) > eps)And((y1-a[k,2,2]) > eps)and((y1-a[k,3,2]) > eps))or
        (((x1-a[k,1,1]) < -eps)And((x1-a[k,2,1]) < -eps)and((x1-a[k,3,1]) < -eps))or
        (((y1-a[k,1,2]) < -eps)And((y1-a[k,2,2]) < -eps)and((y1-a[k,3,2]) < -eps))
                        Then Exit;
     IF Pr(a[k,1,1],a[k,1,2],a[k,2,1],a[k,2,2],x1,y1) Or
        Pr(a[k,1,1],a[k,1,2],a[k,3,1],a[k,3,2],x1,y1) Or
        Pr(a[k,2,1],a[k,2,2],a[k,3,1],a[k,3,2],x1,y1) then begin prov:=true; exit; end;
     If v[k] = 1 Then Exit;
     If peres(a[k,1,1],a[k,1,2],a[k,2,1],a[k,2,2],x1,y1,0,y1,xx,yy) Then inc(y);
     If peres(a[k,1,1],a[k,1,2],a[k,3,1],a[k,3,2],x1,y1,0,y1,xx,yy) Then inc(y);
     If peres(a[k,2,1],a[k,2,2],a[k,3,1],a[k,3,2],x1,y1,0,y1,xx,yy) Then inc(y);
     If y = 2 Then prov:=true;
End;

Procedure Solve;
Var I,J,ss,II: Longint;
    MinX,MaxX,MinY,MaxY,h: LongInt;
    x1,y1: real;
Begin
     maxx:=-1000000; minx:=1000000;
     miny:=10000000; maxy:=-10000000;
     For II:=1 To N Do Begin
     For I:=1 To 3 Do Begin
         Ss:=0; x1:=A[II,I,1]; y1:=a[II,I,2];
         If x1-maxx > eps Then maxx:=round(x1);
         If x1-minx < -eps Then minx:=round(x1);
         If y1-maxy > eps then maxy:=round(y1);
         If y1-miny < -eps Then miny:=round(y1);
         For J:=1 To N Do
             If Prov(x1,y1,j) Then Inc(ss);
         If ss > s Then begin s:=ss; x:=x1; y:=y1; End;
     End; End;
     randomize;
     for I:=1 To 1000 Do
         Begin
              x1:=random(maxx)+random(100)*0.001+minx;
              y1:=random(maxy)+random(100)*0.001+miny;
              ss:=0;
              for J:=1 To N Do
                  If Prov(X1,y1,j) then inc(ss);
              If ss > s Then Begin s:=ss; x:=x1; y:=y1; End;
         End;
End;

Procedure Done;
Begin
     Assign(Output,OutFile);
     ReWrite(Output);
     WriteLn(X:0:4,' ',Y:0:4);
     Close(Output);
end;

Begin
     Init;
     Solve;
     Done;
End.