type Real = Extended;
Coord = record
 X,Y: Real;
end;
var F: text;
N: integer;
T: array [1..100,1..3] of Coord;
K,L,J,P,I: integer;
A: array [1..5000] of Coord;
MaxP: Coord;
MaxN: byte;
const Eps = 1E-5;

procedure Test(P1,P2,P3,P4: Coord);
var A1,A2,B1,B2,C1,C2,D1,D2,D,X,Y: Real;
I: integer;
begin
 A1:=P2.Y-P1.Y;
 B1:=P1.X-P2.X;
 C1:=A1*P1.X+B1*P1.Y;
 A2:=P4.Y-P3.Y;
 B2:=P3.X-P4.X;
 C2:=A2*P3.X+B2*P3.Y;
 D:=A1*B2-B1*A2;
 if Abs(D)<Eps then Exit;
 D1:=C1*B2-B1*C2;
 D2:=A1*C2-C1*A2;
 X:=D1/D;
 Y:=D2/D;
 for I:=1 to P do
 if (Abs(A[I].X-X)<Eps) and (Abs(A[I].Y-Y)<Eps) then Exit;
 Inc(P);
 A[P].X:=X;
 A[P].Y:=Y;
{ Writeln(A1,' ',B1,' ',C1);
 Writeln(P1.X,' ',P1.Y,' ',P2.X,' ',P2.Y,' ',P3.X,' ',P3.Y,' ',P4.X,' ',P4.Y,' ',X,' ',Y);}
end;

function Bound(N,A,B: Real): boolean;
var L,R: Real;
begin
 if A+Eps>B then
 begin
  L:=B;
  R:=A;
 end else
 begin
  L:=A;
  R:=B;
 end;
 if (N+Eps>L) and (N-Eps<R) then Bound:=True else Bound:=False;
end;

procedure TestPoint(P: Coord);
var I,J: integer;
A,B,C: Real;
CurN: byte;
begin
 CurN:=0;
 for I:=1 to N do
 for J:=1 to 3 do
 begin
  if not Bound(P.X,T[I,J].X,T[I,J mod 3+1].X) then Continue;
  if not Bound(P.Y,T[I,J].Y,T[I,J mod 3+1].Y) then Continue;
  A:=T[I,J].Y-T[I,J mod 3+1].Y;
  B:=-T[I,J].X+T[I,J mod 3+1].X;
  C:=A*T[I,J].X+B*T[I,J].Y;
  if Abs(A*P.X+B*P.Y-C)<Eps then
  begin
   Inc(CurN);
   Continue;
  end;
 end;
 if CurN>MaxN then
 begin
  MaxP:=P;
  MaxN:=CurN;
 end;
end;

begin
 Assign(F,'input.txt');
 Reset(F);
 Readln(F,N);
 for I:=1 to N do Readln(F,T[I,1].X,T[I,1].Y,T[I,2].X,T[I,2].Y,T[I,3].X,T[I,3].Y);
 Close(F);
 P:=N*3;
 Move(T,A,SizeOf(T));
 for I:=1 to N-1 do
 for J:=1 to 3 do
 for K:=I+1 to N do
 for L:=1 to 3 do
 Test(T[I,J],T[I,J mod 3+1],T[K,L],T[K,L mod 3+1]);
 MaxN:=0;
 for I:=1 to P do TestPoint(A[I]);
 Assign(F,'output.txt');
 Rewrite(F);
 Writeln(F,MaxP.X:1:5,' ',MaxP.Y:1:5);
 Close(F);
 Halt(0);
end.