{ Alpha }
type Real = Extended;
Point = record
 X,Y: Real;
end;
Line = record
 A,B,C: Real;
end;
var F: text;
Bool: boolean;
Per: byte;
I,J,Z,N: integer;
A: array [1..24] of Line;
PP: integer;
P: array [1..500] of Point;
BP: integer;
B: array [1..500] of Point;
PerRes: Point;
T: Point;
V: array [1..500,1..500] of byte;
VVV,VV: array [1..500] of byte;
const Eps = 1E-5;
Best: integer = 32767;

function GetPeresek(A,B: Line): boolean;
var D,D1,D2: Real;
begin
 GetPeresek:=False;
 D:=A.A*B.B-A.B*B.A;
 if Abs(D)<Eps then Exit;
 D1:=A.C*B.B-A.B*B.C;
 D2:=A.A*B.C-A.C*B.A;
 PerRes.X:=D1/D;
 PerRes.Y:=D2/D;
 GetPeresek:=True;
end;

function OtrPer(A,B: Point; C: Line): boolean;
var D1,D2: Real;
begin
 OtrPer:=False;
 D1:=C.A*A.X+C.B*A.Y-C.C;
 D2:=C.A*B.X+C.B*B.Y-C.C;
 if D1*D2<-Eps then OtrPer:=True;
end;

procedure Mid(A,B: Point; var C: Point);
begin
 C.X:=(A.X*B.X)/2;
 C.Y:=(A.Y+B.Y)/2;
end;

function Test: boolean;
var I,J: integer;
B: boolean;
begin
 Test:=False;
 for I:=1 to PP do
 begin
  B:=False;
  for J:=1 to N-4 do if OtrPer(P[I],T,A[J]) then B:=True;
  if not B then Exit;
 end;
 Test:=True;
end;

begin
 Assign(F,'input.txt');
 Reset(F);
 Readln(F,N);
 for I:=1 to N do
 begin
  Readln(F,A[I].A,A[i].B,A[i].C);
  A[I].C:=-A[I].C;
 end;
 Close(F);
 A[N+1].A:=0;
 A[N+1].B:=1;
 A[N+1].C:=1E+10;
 A[N+2].A:=0;
 A[N+2].B:=-1;
 A[N+2].C:=1E+10;
 A[N+3].A:=1;
 A[N+3].B:=0;
 A[N+3].C:=1E+10;
 A[N+4].A:=-1;
 A[N+4].B:=0;
 A[N+4].C:=1E+10;
 Inc(N,4);
 PP:=0;
 BP:=0;
 for I:=1 to N-1 do
 for J:=I+1 to N do
 begin
  if GetPeresek(A[I],A[J]) then
  begin
   Inc(BP);
   B[BP]:=PerRes;
  end;
 end;
 for I:=1 to BP do
 for J:=1 to BP do
 for Z:=1 to BP do
 if (I<>J) and (J<>Z) then
 begin
  Mid(B[J],B[Z],T);
  Mid(B[I],T,T);
  if Test then
  begin
   Inc(PP);
   P[PP]:=T;
  end;
 end;
 FillChar(V,SizeOf(V),0);
 for I:=1 to PP-1 do
 for J:=I+1 to PP do
 begin
  Per:=0;
  for Z:=1 to N do if OtrPer(P[I],P[J],A[Z]) then Inc(Per);
  if Per=1 then
  begin
   V[I,J]:=1;
   V[J,I]:=1;
  end;
 end;
{ for I:=1 to PP do
 begin
  FillChar(VV,SizeOf(VV),0);
  VV[I]:=1;
  repeat
   Bool:=True;
   for J:=1 to PP do if VV[J] in [1,2] then
   for Z:=1 to PP do if V[J,Z]=1 then
   if VV[Z]=0 then
   begin
    VV[Z]:=3-VV[J];
    Bool:=False;
   end;
  until Bool;
  Per:=0;
  for J:=1 to PP do if VV[J]=1 then Inc(Per);
  if Per<Abs(Best) then
  begin
   Best:=Per;
   VVV:=VV;
  end;
  Per:=0;
  for J:=1 to PP do if VV[J]=2 then Inc(Per);
  if Per<Abs(Best) then
  begin
   Best:=-Per;
   VVV:=VV;
  end;
 end;}

{ Hungry algorhytm }

 FillChar(VV,SizeOf(VV),0);
 FillChar(VVV,SizeOf(VVV),0);
 for I:=1 to PP do for J:=1 to PP do Inc(VV[I],V[I,J]);
 repeat
  Z:=1;
  for I:=2 to PP do if VV[I]>VV[Z] then Z:=I;
  if VV[Z]=0 then Break;
  VVV[Z]:=1;
  VV[Z]:=0;
  for I:=1 to PP do if V[Z,I]=1 then
  begin
   V[Z,I]:=0;
   V[I,Z]:=0;
   if VV[i]>0 then Dec(VV[I]);
   for J:=1 to PP do
   if V[I,J]=1 then if VV[J]>0 then Dec(VV[J]);
  end;
 until False;
 Best:=0;
 for I:=1 to PP do if VVV[I]=1 then Inc(Best);
 Assign(F,'output.txt');
 Rewrite(F);
 Writeln(F,Abs(Best));
 for I:=1 to PP do
 begin
  case VVV[I] of
   1: if Best>0 then Writeln(F,P[I].X:1:6,' ',P[I].Y:1:6);
   2: if Best<0 then Writeln(F,P[I].X:1:6,' ',P[I].Y:1:6);
  end;
 end;
 Close(F);
end.