{$I-,Q-,R-,S-,V-,X-}
const eps = 1e-5;
type float = double;
  tp = record
    x,y: float;
  end;
  tt = record
    a: array[0..4] of tp;
    s: float;
  end;
var
  n,b: integer;
  t: array[0..101] of tt;
  bp: tp;
procedure init;
var i,j: integer;
begin
  assign(input,'INPUT.TXT'); reset(input);
  read(n);
  for i:= 1 to n do
    for j:= 1 to 3 do
      read(t[i].a[j].x,t[i].a[j].y);
  for i:= 1 to n do t[i].a[4]:= t[i].a[1];
  close(input);
end;
function cross(p1,p2,p3,p4: tp; var o: tp): boolean;
var a,b,c,d,e,f,q,u,t: float;
begin cross:= false;
  a:= p2.x-p1.x; b:= p3.x-p4.x; c:= p3.x-p1.x;
  d:= p2.y-p1.y; e:= p3.y-p4.y; f:= p3.y-p1.y;
  q:= a*e-b*d;
  if abs(q)<eps then exit;
  u:= (c*e-b*f)/q;
  t:= (a*f-c*d)/q;
  if(u>-eps)and(u<1.0+eps)and(t>-eps)and(t<1.0+eps)then
  begin
    cross:=true;
    o.x:= (1.0-u)*p1.x+p2.x*u;
    o.y:= (1.0-u)*p1.y+p2.y*u;
  end;
end;
function vec(a,b,c: tp): float;
begin
  vec:= (b.x-a.x)*(c.y-a.y)-(b.y-a.y)*(c.x-a.x);
end;
function inside(p: tp; i: integer): boolean;
var w: float;
  j: integer;
begin w:= 0;
  for j:= 1 to 3 do w:= w+abs(vec(t[i].a[j],t[i].a[j+1],p));
  inside:= abs(w-t[i].s)<eps;
end;
procedure newpoint(p: tp);
var i,t: integer;
begin t:= 0;
  for i:= 1 to n do
    if inside(p,i) then inc(t);
  if t>b then
  begin
    b:= t;
    bp:= p;
  end;
end;
procedure solve;
var i,j,g,h: integer;
  p: tp;
begin b:= 0;
  for i:= 1 to n do t[i].s:= abs(vec(t[i].a[1],t[i].a[2],t[i].a[3]));
  for i:= 1 to n do
    for j:= 1 to 3 do
      newpoint(t[i].a[j]);
  for i:= 1 to n-1 do
    for j:= i+1 to n do
      for g:= 1 to 3 do
        for h:= 1 to 3 do
          if cross(t[i].a[g],t[i].a[g+1],t[j].a[h],t[j].a[h+1],p)then
            newpoint(p);
end;
procedure done;
begin
  assign(output,'OUTPUT.TXT'); rewrite(output);
  writeln(bp.x:0:5,#32,bp.y:0:5);
  close(output);
end;
begin
  init;
  solve;
  done;
end.
