{$I-,Q-,R-,S-,V-,X-}
type  float = extended;
const eps: float = 1e-10;
type  tp = array [1..2] of float;
var
  n, no: integer;
  a, b, c: array [1..50] of float;
  cl: array [1..300] of integer;
  o: array [1..300, 0..80] of tp;
  ol: array [1..300] of integer;
  inf: array [1..300] of boolean;

function findintr(const s, f: tp; l: integer; var r: float): boolean;
var
  aa, bb, cc: float;
  d, dx, dy: float;
begin
  aa := f[2] - s[2]; bb := s[1] - f[1];
  cc := (s[1]*aa) + (s[2]*bb);

  d := (aa*b[l]) - (bb*a[l]);

  findintr := false;
  if (abs(d) < eps) then exit;

  dx := (cc*b[l]) + (bb*c[l]);
  dy := - ((aa*c[l]) + (cc*a[l]));

  dx := dx/d; dy := dy/d;

  if (abs(f[1]-s[1])>eps) then begin
    r := (dx - s[1])/(f[1] - s[1]);
    findintr := true;
    exit;
  end;
  if (abs(f[2]-s[2])>eps) then begin
    r := (dy - s[2])/(f[2] - s[2]);
    findintr := true;
    exit;
  end;
end;

procedure proco(ao: integer);
var
  xx, yy: float;
  i, k: integer;
begin
  i := 1;
  while (i<ol[ao]) do begin
    if (abs(o[ao][i][1]-o[ao][i+1][1])<eps) and (abs(o[ao][i][2]-o[ao][i+1][2])<eps) then begin
      for k := i+1 to ol[ao]-1 do o[ao][k] := o[ao][k+1];
      dec(ol[ao]);
    end else inc(i);
  end;

  xx := 0; yy := 0;
  for i := 1 to ol[ao] do begin
    xx := xx + o[ao][i][1];
    yy := yy + o[ao][i][2];
  end;
  o[ao][0][1] := xx/ol[ao];
  o[ao][0][1] := yy/ol[ao];
end;

procedure divo(ao, l: integer);
var
  i, ni, k: integer;
  ii: array [1..2] of integer;
  ir: array [1..2] of float;
  r: float;
  s, f, t, t1, t2: tp;
begin
  ni := 0;
  for i := 1 to ol[ao]-1 do begin
    if findintr(o[ao][i], o[ao][i+1], l, r) then begin
      if (  ( inf[ao] and (
          ( (i=1) and (r<(1-eps)) ) or
          ( (i=(ol[ao]-1)) and (r>(-eps)) )) ) or
          ( (r>(-eps)) and (r<(1-eps))  ) ) then begin
        if (ni<2) then begin
          inc(ni);
          ii[ni] := i;
          ir[ni] := r;
        end;
      end;
    end;
  end;

  if (ni=2) then begin
    inc(no); inf[no] := false;
    ol[no] := 0;

    s := o[ao][ii[1]]; f := o[ao][ii[1]+1];
    t[1] := s[1] + ir[1]*(f[1]-s[1]);
    t[2] := s[2] + ir[1]*(f[2]-s[2]);
    inc(ol[no]); o[no][ol[no]] := t;
    for i := ii[1]+1 to ii[2] do begin
      inc(ol[no]); o[no][ol[no]] := o[ao][i];
    end;
    s := o[ao][ii[2]]; f := o[ao][ii[2]+1];
    t[1] := s[1] + ir[2]*(f[1]-s[1]);
    t[2] := s[2] + ir[2]*(f[2]-s[2]);
    inc(ol[no]); o[no][ol[no]] := t; t2 := t;
    s := o[ao][ii[1]]; f := o[ao][ii[1]+1];
    t[1] := s[1] + ir[1]*(f[1]-s[1]);
    t[2] := s[2] + ir[1]*(f[2]-s[2]);
    inc(ol[no]); o[no][ol[no]] := t; t1 := t;

    o[ao][ii[1]+1] := t1;
    o[ao][ii[2]+1] := t2;
    if (inf[ao]) then begin
      if (ir[1]<(-eps)) then begin
        o[ao][1][1] := (2*(o[ao][2][1])) - o[ao][1][1];
        o[ao][1][2] := (2*(o[ao][2][2])) - o[ao][1][2];
      end;
    end;

    k := ii[2]-ii[1]-2;
    for i := ii[1]+2 to ii[2]-1 do begin
      o[ao][i] := o[ao][i+k];
    end;
    if (k>0) then ol[ao] := ol[ao]-k;

    proco(ao);
    proco(no);
  end;

  if (inf[ao] and (ol[ao]=2) and (ni=1)) then begin
    t[1] := s[1] + ir[1]*(f[1]-s[1]);
    t[2] := s[2] + ir[1]*(f[2]-s[2]);

    o[ao][2] := t;
    if (ao=1) then begin
      o[ao][3][1] := t[1] + b[i];
      o[ao][3][2] := t[2] - a[i];
    end else begin
      o[ao][3][1] := t[1] - b[i];
      o[ao][3][2] := t[2] + a[i];
    end;

    inc(no);
    ol[ao] := 3; ol[no] := 3;
    o[no][2] := t;
    o[no][3][1] := t[1] - o[ao][1][1];
    o[no][3][2] := t[2] - o[ao][1][2];
    o[no][1] := o[ao][3];

    proco(ao);
    proco(no);
  end;
end;

procedure addln(l: integer);
var
  i, k: integer;
begin
  k := no;
  for i := 1 to k do divo(i, l);
end;

procedure Solve;
var
  xx, yy: float;
  i: integer;
begin
  fillchar(cl, sizeof(cl), 0);
  fillchar(inf, sizeof(inf), 0);
  no := 2;
  cl[1] := 0; cl[2] := 1;
  ol[1] := 2; ol[2] := 2;
  inf[1] := true; inf[2] := true;

  if (abs(a[1])>eps) then begin
    yy := 0;
    xx := -(c[1]/a[1]);
  end else begin
    xx := 0;
    yy := -(c[1]/b[1]);
  end;

  o[1][1][1] := xx; o[1][1][2] := yy;
  o[1][2][1] := xx+b[1]; o[1][2][2] := yy-a[1];
  o[2][1][1] := xx; o[2][1][2] := yy;
  o[2][2][1] := xx+b[1]; o[2][2][2] := yy-a[1];

  o[1][0][1] := xx + a[1]; o[1][0][2] := yy + b[1];
  o[2][0][1] := xx - a[1]; o[2][0][2] := yy - b[1];

  for i := 2 to n do addln(i);
end;

procedure ReadAll;
var  i: integer;
begin
  Assign(Input, 'input.txt'); Reset(Input);

  Read(n);
  for i := 1 to n do Read(a[i], b[i], c[i]);

  Close(Input);
end;

procedure Out;
var  i: integer;
begin
  Assign(Output, 'output.txt'); ReWrite(Output);

  WriteLn(n);
  randseed := $13666;
  for i := 1 to n do begin
    WriteLn((10000*random):1:9, ' ', (10000*random):1:9);
  end;

  Close(Output);
end;

begin
  ReadAll;
{  Solve;}
  Out;
end.
