
var
  i,j:integer;
  fin,fout:text;
  sat:array[1..4]of record x,y,z:double;t:double; end;
  n:integer;
  tMin,tMax,t:double;
  founded:boolean;
  x,y,z:double;
  inSideEveryBody:boolean;
  outSideEveryBody:boolean;
function vertexOutSide(x,y,z:double;i:integer):boolean;
var dist2:double;
begin
  dist2:=
    (x-sat[i].x)*(x-sat[i].x)+
    (y-sat[i].y)*(x-sat[i].y)+
    (z-sat[i].z)*(x-sat[i].z);
  if dist2>sat[i].t+t then vertexOutSide:=true else vertexOutSide:=false;
end;
function cubeOutSide(x1,y1,z1,x2,y2,z2:double;i:integer):boolean;
begin
  cubeOutSide:=false;
  if
  (
    ((x1>sat[i].x)and(y1>sat[i].y)and(z1>sat[i].y))or
    ((x1>sat[i].x)and(y1>sat[i].y)and(z2<sat[i].y))or
    ((x1>sat[i].x)and(y2<sat[i].y)and(z1>sat[i].y))or
    ((x1>sat[i].x)and(y2<sat[i].y)and(z2<sat[i].y))or
    ((x2<sat[i].x)and(y1>sat[i].y)and(z1>sat[i].y))or
    ((x2<sat[i].x)and(y1>sat[i].y)and(z2<sat[i].y))or
    ((x2<sat[i].x)and(y2<sat[i].y)and(z1>sat[i].y))or
    ((x2<sat[i].x)and(y2<sat[i].y)and(z2<sat[i].y))
  or(
    (x1>sat[i].x+sat[i].t+t)or
    (x2<sat[i].x-sat[i].t+t)or
    (y1>sat[i].y+sat[i].t+t)or
    (y2<sat[i].y-sat[i].t+t)or
    (z1>sat[i].z+sat[i].t+t)or
    (z2<sat[i].z-sat[i].t+t)))
    and
    vertexOutSide(x1,y1,z1,i)and
    vertexOutSide(x1,y1,z2,i)and
    vertexOutSide(x1,y2,z1,i)and
    vertexOutSide(x1,y2,z2,i)and
    vertexOutSide(x2,y1,z1,i)and
    vertexOutSide(x2,y1,z2,i)and
    vertexOutSide(x2,y2,z1,i)and
    vertexOutSide(x2,y2,z2,i)
   then cubeOutSide:=true else cubeOutSide:=false;
end;
function vertexInSide(x,y,z:double;i:integer):boolean;
var dist2:double;
begin
  dist2:=
    (x-sat[i].x)*(x-sat[i].x)+
    (y-sat[i].y)*(x-sat[i].y)+
    (z-sat[i].z)*(x-sat[i].z);
  if dist2<sat[i].t+t then vertexInSide:=true else vertexInSide:=false;
end;
function cubeInSide(x1,y1,z1,x2,y2,z2:double;i:integer):boolean;
begin
  if
    vertexInSide(x1,y1,z1,i)and
    vertexInSide(x1,y1,z2,i)and
    vertexInSide(x1,y2,z1,i)and
    vertexInSide(x1,y2,z2,i)and
    vertexInSide(x2,y1,z1,i)and
    vertexInSide(x2,y1,z2,i)and
    vertexInSide(x2,y2,z1,i)and
    vertexInSide(x2,y2,z2,i) then cubeInSide:=true else cubeInSide:=false;
end;
function needClipCube(x1,y1,z1,x2,y2,z2:double):boolean;
var i:integer;
begin
  for i:=1 to 4 do
    if cubeOutSide(x1,y1,z1,x2,y2,z2,i) then
      begin
        needClipCube:=true;
        exit;
      end;
  for i:=1 to 4 do
    if cubeInSide(x1,y1,z1,x2,y2,z2,i) then
      begin
        needClipCube:=true;
        exit;
      end;
  needClipCube:=false;
end;
procedure findInterSection(x1,y1,z1,x2,y2,z2:double);
var i:integer;
    midx,midy,midz:double;
begin
  if insideEveryBody or founded then exit;
  insideEveryBody:=true;
  for i:=1 to 4 do
    insideEveryBody:=insideEveryBody and(cubeInSide(x1,y1,z1,x2,y2,z2,i));
  if insideEveryBody then exit;
  if needClipCube(x1,y1,z1,x2,y2,z2) then exit;
  midx:=(x2+x1)*0.5;
  midy:=(y2+y1)*0.5;
  midz:=(z2+z1)*0.5;
  if (abs(x2-x1)<0.00001)then
    begin
      founded:=true;
      x:=midx;y:=midy;z:=midz;
      exit;
    end;
  findInterSection(x1  ,y1  ,z1  ,    midx,midy,midz);
  findInterSection(x1  ,y1  ,midz,    midx,midy,z2  );
  findInterSection(x1  ,midy,z1  ,    midx,y2  ,midz);
  findInterSection(x1  ,midy,midz,    midx,y2  ,z2  );
  findInterSection(midx,y1  ,z1  ,    x2  ,midy,midz);
  findInterSection(midx,y1  ,midz,    x2  ,midy,z2  );
  findInterSection(midx,midy,z1  ,    x2  ,y2  ,midz);
  findInterSection(midx,midy,midz,    x2  ,y2  ,z2  );
end;
begin
  assign(fin,'input.txt');
  reset(fin);
  read(fin,n);
  for i:=1 to 4 do read(fin,sat[i].x,sat[i].y,sat[i].z);
  sat[1].t:=0;
  for i:=2 to 4 do read(fin,sat[i].t);
  close(fin);

{  tMin:=0;tMax:=100;
  repeat
    founded:=false;
    t:=0.5*(tMin+tMax);
    inSideEveryBody:=false;
    findInterSection(-1000000,-1000000,-1000000,1000000,1000000,1000000);
    if founded then break;
    if inSideEveryBody then
      tmin:=t
    else
      tmax:=t;
  until ((tMax-tMin)<0.0001)and(founded);}

  assign(fout,'output.txt');
  rewrite(fout);
  writeln(fout,'0.0 0.0 0.0');
  close(fout);
end.