#include <stdio.h>
#include <stdlib.h>

int A, B, N, M;
int P[200][200];
int P0[200][200];
int Num[200][200];

int V[200];
int R[200];

int S, Y, X[40000];

void input()
{
  int i, j;
  FILE *f = fopen("output.txt", "rt");
  fscanf(f, "%d%d%d%d", &N, &A, &B, &M);
  A--; B--;
  for (i = 0; i < N; i++) for (j = 0; j < N; j++) P[i][j] = 0;
  for (i = 0; i < M; i++)
  {
    int v, w, pp;
    fscanf(f, "%d%d%d", &v, &w, &pp);
    P[v-1][w-1] = pp;
    P[w-1][v-1] = pp;
    Num[v-1][w-1] = i;
    Num[w-1][v-1] = i;
  }
  fclose(f);
}

void output()
{
  int i;
  FILE *f = fopen("input.txt", "wt");
  fprintf(f, "%d %d\n", Y, S);
  for (i = 0; i < Y; i++) fprintf(f, "%d ", X[i]+1);
  fclose(f);
}

int cmp(const void *xx, const void *yy)
{
  if (*(int*)xx > *(int*)yy) return 1;
  else if (*(int*)xx < *(int*)yy) return -1;
  else return 0;
}

int main()
{
  int i, j, k;
  input();
  for (i = 0; i < N; i++) for (j = 0; j < N; j++) P0[i][j] = P[i][j];
  for(;;)
  {
    for (i = 0; i < N; i++) V[i] = 0;
    V[A] = 32000;
    R[A] = -1;
    do
    {
      k = 0;
      for (i = 0; i < N; i++) if (V[i]) for (j = 0; j < N; j++)
      {
        if (P[i][j] > V[j] && V[i] > V[j])
        {
          V[j] = V[i];
          if (V[j] > P[i][j]) V[j] = P[i][j];
          R[j] = i;
          k = 1;
        }
      }
    }
    while(k);
    if (!V[B]) break;
    i = B;
    while(i != A)
    {
      P[R[i]][i] -= V[B];
      P[i][R[i]] += V[B];
      i = R[i];
    }
  }
  while(k);
  Y = 0;
  S = 0;
  for (i = 0; i < N; i++) for (j = 0; j < N; j++) if (V[i] && !V[j] && P0[i][j])
  {
    X[Y++] = Num[i][j];
    S += P0[i][j];
  }
  qsort(X, Y, sizeof(X[0]), cmp);
  output();
  return 0;
}
