{$UNDEF DEBUG}
{.$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}



Const
  InpF='output.txt';
  OutpF='input.txt';
  DebugPath='c:\work\Day29\2\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=15;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}
Const
 MaxN=200;

Var
 R: array [1..MaxN*MaxN, 0..2] of Byte;
 B: Array [1..MaxN, 1..MaxN] of Integer;
 C: Array [1..MaxN] of Record
                        Size: Longint;
                        From: Integer;
                       End;

 A: Array [1..MaxN] of Record
                        Count: Integer;
                        Num: Array [1..MaxN] of Byte;
                        Size: Array [1..MaxN] of Integer;
                        Id: Array [1..MaxN] of Word;
                       End;

 D, E: Array[1..MaxN*MaxN] of Boolean;

 N, M: Word;
 Source, Dest: Word;
 Ans: Longint;
 AnsCount: Integer;

Procedure init;
 Var i, q, w, e: Integer;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  Read(N, Source, Dest);
  Read(M);
  FillChar(A, Sizeof(A), 0);
  For i:=1 to M do begin
   Read(q, w, e);
   R[i, 0]:=q;
   R[i, 1]:=w;
   R[i, 2]:=e;
   With A[q] do begin
    Inc(Count);
    Num[Count]:=w;
    Id[Count]:=i;
    Size[Count]:=e;
   End;

   With A[w] do begin
    Inc(Count);
    Num[Count]:=q;
    Id[Count]:=i;
    Size[Count]:=e;
   End;
  End;
  close(Input);
 End;

Procedure solve;
 Var
  isDone: Boolean;
  i, j: Integer;

 Procedure Push(Const q: Integer);
  var i: Integer;
      p: Longint;
  Begin
   With A[q] do
    For i:=1 to Count do if D[Id[i]] then begin
     p:=Size[i]-B[q, Num[i]];
     if C[q].Size < p Then
      p:=C[q].Size;
     if p>C[Num[i]].Size Then begin
      C[Num[i]].Size:=p;
      C[Num[i]].From:=q;
      Push(Num[i]);
     End;
    End;
  End;

 Begin
  FillChar(B, SizeOf(B), 0);
  FillChar(D, SizeOf(D), True);
  Repeat
   FillChar(C, SizeOf(C), 0);
   C[Source].Size:=MaxLongInt shr 1;
   isDone:=True;
   Push(Source);
   if C[dest].Size>0 Then begin
    isDone:=False;
    i:=dest;
    while i<>Source do with C[i] do begin
     inc(B[From, i], C[dest].Size);
     dec(B[i, From], C[dest].Size);
     i:=From;
    end;
   End;
  Until isDone;

  for i:=1 to M do
   E[i]:=B[R[i, 0], R[i, 1]]=R[i, 2];
  FillChar(B, SizeOf(B), 0);

  i:=1;
  isDone:=False;
  Ans:=0;
  AnsCount:=0;
  repeat
   if E[i] Then begin
    D[i]:=False;
    FillChar(C, SizeOf(C), 0);
    C[Source].Size:=MaxLongInt shr 1;
    Inc(ansCount);
    Inc(Ans, R[i, 2]);
    Push(Source);
    isDone:=C[dest].Size=0
   end;
   Inc(i);
  Until isDone or (i>N);
 End;

procedure done;
 var i: Integer;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  WriteLn(AnsCount, ' ', ans);
  For i:=1 to M do
   if not D[i] Then
    Write(i, ' ');
  close(Output);
 End;

begin
 Init;
 Solve;
 Done;
End.

