{$UNDEF DEBUG}
{.$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}

Const
  InpF='INPUT.TXT';
  OutpF='OUTPUT.TXT';
  DebugPath='C:\WORK\DAY29\4\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=10;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}

Const
 MaxL=330;
 P=10000;
 MaxN=100;

Type
 TLong=Array [0..MaxL] of Word;
 PLong=^TLong;

Var
 K: TLong;
 N: Word;
 A: Array [1..MaxN] of Char;
 B: Array [1..MaxN+1, -1..MaxN+1] of TLong;

Function Max(Const A, B:Word): Word;
 begin
  if A>B Then
   Max:=A
  Else
   max:=B;
 End;

Procedure LongAdd(A, B, C: PLong);
 Var i: Integer;
     X: Longint;
 Begin
  FillChar(C^, SizeOf(C^), 0);
  X:=0;
  C^[0]:=Max(B^[0], A^[0]);
  For i:=1 to C^[0] do begin
   X:=X+A^[i]+B^[i];
   C^[i]:=X mod P;
   X:=X div P;
  End;
  While X>0 do begin
   Inc(C^[0]);
   C^[C^[0]]:=X mod P;
   X:=X div P;
  End;
 End;

Procedure LongSub(A, B, C: PLong);
 Var i: Integer;
     X: Longint;
 Begin
  FillChar(C^, SizeOf(C^), 0);
  X:=0;
  C^[0]:=Max(B^[0], A^[0]);
  For i:=1 to C^[0] do begin
   X:=X+A^[i]-B^[i];
   if X>0 Then begin
    C^[i]:=X mod P;
    X:=X div P;
   End else begin
    C^[i]:=(X+P) mod P;
    X:=(X-P) div P;
   end;
  End;
  While X>0 do begin
   Inc(C^[0]);
   C^[C^[0]]:=X mod P;
   X:=X div P;
  End;
 End;

Function LongMore(Const A, B: PLong): Boolean;
 Var i: Integer;
     X: Longint;
 Begin
  X:=0;
  if A^[0]>B^[0] Then
   LongMore:=True;
  if A^[0]<B^[0] Then
   LongMore:=false;

  if A^[0]=B^[0] Then begin
   For i:=1 to a^[0] do begin
    X:=(X+A^[i]-B^[i]) mod P;
   End;
   LongMore:=(X>=0);
  end;
 end;

Procedure LongSet(A: Longint; B: PLong);
 Begin
  FillChar(B^, SizeOf(B^), 0);
  While A>0 do begin
   Inc(B^[0]);
   B^[B^[0]]:=A mod P;
   A:=A div P;
  End;
 End;


Procedure init;
 var i, j, q: Longint;
     S: Array [1..1100] of Byte;
     CH: Char;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  ReadLn(N);
  q:=0;
  While Not Eof(Input) do begin
   Read(Ch);
   if ch in ['0'..'9'] Then begin
    Inc(q);
    S[q]:=(Ord(Ch)-Ord('0'))
   End Else
    Break;
  End;
  FillChar(K, SizeOf(K), 0);
  j:=1;
  i:=0;
  for q:=q downto 1 do Begin
    i:=i+S[q]*j;
    j:=j*10;
    if j>=P Then begin
     Inc(K[0]);
     K[K[0]]:=i;
     i:=0;
     j:=1;
    end;
  End;

  if i>0 Then begin
   Inc(K[0]);
   K[K[0]]:=i;
  end;
  close(Input);
 End;

Procedure solve;
 var i, j: Integer;
     Q: TLong;
 Begin
  FillChar(B, SizeOf(B), 0);
  LongSet(1, @B[1, 1]);
  for i:=2 to N*2 do
   For j:=0 to i do
    LongAdd(@B[i-1, j-1], @B[i-1, j+1], @B[i, j]);

  j:=0;
  For i:=1 to N*2 do begin
   if LongMore(@B[N*2-i, j+1], @K) Then begin
    A[i]:='(';
    Inc(j);
   end else begin
    A[i]:=')';
    LongSub(@K, @B[N*2-i, j+1], @Q);
    K:=Q;
    dec(j);
   End;
  End;
 End;

procedure done;
 var j, i: Integer;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  for i:=1 to N*2 do
   Write(A[i]);
  close(Output);
 End;

begin
 Init;
 Solve;
 Done;
End.

