Const
  FInput='INPUT.TXT';
  FOutput='OUTPUT.TXT';
Var
  Input,Output:Text;
{----------------------------------------------------------------------------}
Procedure Init;
begin
  Assign(Input,FInput);
  Assign(Output,FOutput);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
end;
{----------------------------------------------------------------------------}
Const
  MaxN=500+10;
  MaxM=10000+10;
Type
  TGr=array[1..MaxN]of Record
    Col:LongInt;
    Mas:Array[1..MaxN-1]of Record
      Num:Word;
      Color:Byte;
      V:Word;
    end;
  end;
Var
  N,M:LongInt;
  Gr:TGr;
  Ans:Boolean;
  {}
  R,R1,R2:LongInt;
  Start:Word;
  C:Byte;
  Col:Word;
  V:array[1..MaxN]of Boolean;
  D1:array[1..MaxM]of Boolean;
  D2:array[1..MaxM]of Boolean;

  Procedure Fill(From,Num:LongInt);
  begin
    Inc(Col);
    V[Num]:=True;
    With Gr[Num] do
      For R:=1 to Col do
      begin
        If (Mas[R].Color=C)or(Mas[R].Color=3) then
        begin
          If V[Mas[R].V] then
          begin
            If From<>Mas[R].V then
            begin
              If C=1 then D1[Mas[R].Num]:=True else D2[Mas[R].Num]:=True;
            end;
          end else Fill(Num,Mas[R].V);
        end else
        If C=1 then D1[Mas[R].Num]:=True else D2[Mas[R].Num]:=True;
      end;
  end;

Procedure Solve;
begin
  {Zero}
  FillChar(Gr,SizeOf(Gr),0);
  Ans:=True;
  {Input}
  Readln(Input,N,M);
  For R:=1 to M do
  begin
    Read(Input,R1,R2);
    if R=1 then Start:=R1;
    With Gr[R1] do
    begin
      Inc(Col);
      Mas[Col].Num:=R;
      Mas[Col].V:=R2;
      Read(Input,Mas[Col].Color);
    end;
    With Gr[R2] do
    begin
      Inc(Col);
      Mas[Col].Num:=R;
      Mas[Col].V:=R1;
      Mas[Col].Color:=Gr[R1].Mas[Gr[R1].Col].Color;
    end;
  end;
  {Solve}
  FillChar(D1,SizeOf(D1),0);
  FillChar(D2,SizeOf(D2),0);
  {}
  C:=1;
  Col:=0;
  FillChar(V,SizeOf(V),0);
  Fill(0,Start);
  {}
  If Col<>N then Ans:=False else
  begin
    C:=2;
    Col:=0;
    FillChar(V,SizeOf(V),0);
    Fill(0,Start);
    If Col<>N then Ans:=False;
  end;
  {Output}
  If Ans then
  begin
    Col:=0;
    For R:=1 to M do
    begin
      D1[R]:=(D1[R])and(D2[R]);
      If D1[R] then Inc(Col);
    end;
    Writeln(Output,Col);
    If Col<>0 then
      For R:=1 to M do
        If D1[R] then Write(Output,R,' ');
  end else Writeln(Output,-1);
end;
{----------------------------------------------------------------------------}
begin
  Init;
  Solve;
  Done;
end.
