{$I-,Q-,R-,S-,V-,X-}
var
  n, m, a, b, nd, s: longint;
  ff, f, c, no: array [1..210, 1..210] of longint;
  p, fr, dl: array [1..500] of longint;
  u: array [1..500] of boolean;

procedure fndch;
var
  i, l: integer;
  r: longint;
begin
  fillchar(p, sizeof(p), 0);
  fillchar(fr, sizeof(fr), 0);
  fillchar(u, sizeof(u), 0);

  p[a] := 1000000;
  repeat
    l := 1;
    while ((l<=n) and ((u[l]) or (p[l]<1))) do inc(l);
    if (l>n) then exit;

    u[l] := true;
    for i := 1 to n do if (not u[i]) then begin
      if ((c[l,i]-f[l,i])>p[l]) then r := p[l] else r := (c[l,i]-f[l,i]);
      if (p[i] < r) then begin
        p[i] := r; fr[i] := l;
      end;
      if ((f[i,l])>p[l]) then r := p[l] else r := f[i, l];
      if (p[i] < r) then begin
        p[i] := r; fr[i] := -l;
      end;
    end;
  until (l>n);
end;

procedure upd(v: integer; w: longint);
begin
  if ((v=0) or (fr[v]=0)) then exit;
  if (fr[v]>0) then begin
    f[fr[v], v] := f[fr[v], v] + w;
    upd(fr[v], w);
  end else begin
    f[v, abs(fr[v])] := f[v, abs(fr[v])] - w;
    upd(abs(fr[v]), w);
  end;
end;

procedure bldF;
begin
  fillchar(f, sizeof(f), 0);
  repeat
    fndch;
    if (p[b]>0) then upd(b, p[b]) else exit;
  until false;
end;

procedure redout(v: integer; w: longint); forward;
procedure redin(v: integer; w: longint);
var
  i: integer;
  r: longint;
begin
  i := 1;
  while (w>0) do begin
    while ((i<=n) and (f[i, v]<1)) do inc(i);
    if (i>n) then exit;
    if (w>f[i, v]) then r := f[i, v] else r := w;
    f[i, v] := f[i, v] - r;
    w := w - r;
    redin(i, r); redout(v, r);
  end;
end;

procedure redout(v: integer; w: longint);
var
  i: integer;
  r: longint;
begin
  i := 1;
  while (w>0) do begin
    while ((i<=n) and (f[v, i]<1)) do inc(i);
    if (i>n) then exit;
    if (w>f[v, i]) then r := f[v, i] else r := w;
    f[v, i] := f[v, i] - r;
    w := w - r;
    redin(v, r); redout(i, r);
  end;
end;

procedure Solve;
var
  i, j, m: integer;
  r, h: longint;
begin
  bldF;
  nd := 0; s := 0;

  for i := 1 to n do for j := 1 to n do begin
    if ((c[i, j]>0) and (f[i,j]>=c[i,j])) then begin
      ff := f;

      r := f[i, j];
      f[i, j] := 0;
      redin(i, r); redout(j, r);
      c[i, j] := 0; c[j, i]  := 0;

      fndch;

      if (p[b]>0) then begin f:=ff; c[i,j]:=r; c[j,i]:=r; end else begin
        inc(nd);
        dl[nd] := no[i, j];
        s := s + r;
      end;
    end;
  end;

  for i := 1 to nd-1 do begin
    m := i;
    for j := i+1 to nd do if (dl[m] > dl[j]) then m := j;
    h := dl[i]; dl[i] := dl[m]; dl[m] := h;
  end;
end;

procedure ReadAll;
var  i, x, y, w: longint;
begin
  Assign(Input, 'output.txt'); Reset(Input);

  Read(n, a, b);
  Read(m);
  fillchar(w, sizeof(w), 0);
  fillchar(no, sizeof(no), 0);
  for i := 1 to m do begin
    Read(x, y, w);
    c[x, y] := w; c[y, x] := w;
    no[x, y] := i; no[y, x] := i;
  end;

  Close(Input);
end;

procedure Out;
var i: integer;
begin
  Assign(Output, 'input.txt'); ReWrite(Output);

  WriteLn(nd:1, ' ', s:1);
  for i := 1 to nd do begin
    if (i>1) then Write(' ');
    Write(dl[i]);
  end;
  WriteLn;

  Close(Output);
end;

begin
  ReadAll;
  Solve;
  Out;
end.
