{$I-,Q-,R-,S-,V-,X-}
type
  tlong = array [0..70] of byte;
  tvlong = array [0..2000] of byte;
  plong = ^byte;
var
  n: integer;
  k: tvlong;
  s: string;
  ok: boolean;
  m: array [0..210, 0..110] of tlong;

procedure lsubi(a: plong; t: integer);
var
  z, cp, x: integer;
begin
  cp := 1; z := t;
  while (z<>0) do begin
    x := a[cp]; x := x - z;
    if (x>=0) then begin a[cp] := x; z := 0; end else begin
      z := abs(x) div 10;
      x := x + (z*10);
      while (x<0) do begin x := x + 10; inc(z); end;
      a[cp] := x;
    end;
    inc(cp);
  end;
  while ((a[0]>0) and (a[a[0]]<1)) do dec(a[0]);
end;

procedure ladd(a, b: plong);
var
  cp, x, y, z: integer;
begin
  z := 0; cp := 1;
  while ((z>0) or (a[0]>=cp) or (b[0]>=cp)) do begin
    x := a[cp]; y := b[cp];
    x := x + y + z;
    a[cp] := (x mod 10);
    z := x div 10;
    inc(cp);
  end;
  while ((cp>0) and (a[cp] = 0)) do dec(cp);
  a[0] := cp;
end;

procedure lsub(a, b: plong);
var
  cp, x, y, z: integer;
begin
  cp := 1; z := 0;
  while ((z>0) or (b[0]>=cp)) do begin
    if (cp>a[0]) then begin WriteLn('FUCK'); exit; end;
    x := a[cp]; y := b[cp];
    x := x - y - z;
    z := 0;
    if (x<0) then begin x := x + 10; z := 1; end;
    a[cp] := x;
    inc(cp);
  end;

  while ((a[0]>0) and (a[a[0]]<1)) do dec(a[0]);
end;

procedure makem;
var i, j: integer;
begin
  fillchar(m, sizeof(m), 0);
  m[0, 0][0] := 1; m[0, 0][1] := 1;
  for i := 1 to (2*n) do for j := 0 to n do begin
    if (j>0) then ladd(@m[i, j], @m[i-1, j-1]);
    if (j<n) then ladd(@m[i, j], @m[i-1, j+1]);
  end;
end;

function gr(a, b: plong): boolean;
var  i: integer;
begin
  if (a[0] > b[0]) then i := a[0] else i := b[0];
  gr := false;
  while (i>0) do begin
    if ((i>a[0]) and (b[i]>0)) then exit;
    if ((i>b[0]) and (a[i]>0)) then begin gr := true; exit; end;
    if (a[i] < b[i]) then exit;
    if (a[i] > b[i]) then begin gr := true; exit; end;
    dec(i);
  end;
end;

procedure Solve;
var
  cl, co: integer;
begin
  ok := false;
  makem;
  s := '('; cl := 1; co := 1;
  lsubi(k, 1);
  while (cl<(2*n)) do begin
    if ((co<n) and (gr(m[((2*n)-cl)-1][co+1], k))) then begin
      s := s + '('; inc(cl); inc(co);
    end else begin
      if (co<1) then exit;
      s := s + ')';
      lsub(k, m[((2*n)-cl)-1][co+1]);
      inc(cl); dec(co);
    end;
  end;

  while ((k[0]>0) and (k[k[0]]<1)) do dec(k[0]);
  if ((k[0]) > 0) then exit;

  ok := true;
end;

procedure ReadL(x: plong);
var
  s: array [1..2000] of char;
  c: char;
  l, i: integer;
begin
  repeat Read(c); until (c in ['0'..'9']) or (SeekEof);
  l := 0;
  while (c in ['0'..'9']) do begin
    inc(l); s[l] := c;
    if (Eof) then c := #0 else Read(c);
  end;

  x[0] := l;
  for i := 1 to l do x[l-i+1] := ord(s[i]) - ord('0');
  while ((x[0]>0) and (x[x[0]] < 1)) do dec(x[0]);
end;

procedure ReadAll;
begin
  Assign(Input, 'INPUT.TXT'); Reset(Input);

  Read(n);
  fillchar(k, sizeof(k), 0);
  ReadL(@k);

  Close(Input);
end;

procedure Out;
begin
  Assign(Output, 'OUTPUT.TXT'); ReWrite(Output);

  if (ok) then WriteLn(s) else WriteLn('No solution for this testcase.');

  Close(Output);
end;

begin
  ReadAll;
  Solve;
  Out;
end.

