#define MAX							12

#include <stdio.h>
#include <string.h>

void input ();
int go_X (char depth, char start_X, char start_0);
int go_0 (char depth, char start_X, char start_0);
void output ();

int answer, n, size, rest, win = 0, matrix [MAX] [MAX];
int horis_X [MAX], vertic_X [MAX], horis_0 [MAX], vertic_0 [MAX];


main ()
 {
   input ();
   answer = go_X (0, 0, 0);
   output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("input.txt", "r");
   fscanf (file, "%d\n", & n);

   for (int i = 0; i < n; i ++)
    {
	  for (int j = 0; j < n; j ++)
      {
	    fscanf (file, "%c", & matrix [i] [j]);
       
       if (matrix [i] [j] == 'X') matrix [i] [j] = 0;
       if (matrix [i] [j] == 'O') matrix [i] [j] = 1;
		 if (matrix [i] [j] == '.') matrix [i] [j] = -1;
      }

     fscanf (file, "\n");
    }

   fclose (file);
   rest = size = n * n;
   memset (horis_X, 0, n << 2);
   memset (vertic_X, 0, n << 2);
   memset (horis_0, 0, n << 2);
   memset (vertic_0, 0, n << 2);

   for (int i = 0; i < n; i ++)
	 for (int j = 0; j < n; j ++)
     if (matrix [i] [j] == 0)
      horis_X [i] ++, vertic_X [j] ++, rest --;
     else if (matrix [i] [j] == 1)
      horis_0 [i] ++, vertic_0 [j] ++, rest --;
 }

 
int go_X (char depth, char start_X, char start_0)
 {
   int answer = 0, i, j;
   
   if (depth == rest)
    return (win > 0);

   for (int k = start_X; k < size; k ++)
    {
     i = k / n; j = k % n;

     if (matrix [i] [j] == -1)
//      if (((! win) && ((horis_0 [i] == 0) || (vertic_0 [j] == 0))) || win)
       {
        matrix [i] [j] = 0;
        
        if (++ horis_X [i] == n)
         {
//           if (win == 0)
//            k = -1;
            
           win ++;
         }
        if (++ vertic_X [j] == n)
         {
//           if (win == 0)
//            k = -1;
            
           win ++;
         }
        
        answer += go_0 (depth + 1, k + 1, start_0);
        
        matrix [i] [j] = -1;
        
        if (horis_X [i] -- == n)  win --;
        if (vertic_X [j] -- == n)  win --;
       }
    }
    
   return (answer);
 }


int go_0 (char depth, char start_X, char start_0)
 {
   int answer = 0, i, j;
   
   if (depth == rest)
    return (win > 0);

   for (int k = start_0; k < size; k ++)
    {
     i = k / n; j = k % n;
     
     if (matrix [i] [j] == -1)
      {
        if (++ horis_0 [i] == n)
         {
           horis_0 [i] --;
           continue;
         }
         
        if (++ vertic_0 [j] == n)
         {
           vertic_0 [j] --;
           horis_0 [i] --;
           continue;
         }

        matrix [i] [j] = 1;         
        answer += go_X (depth + 1, start_X, k + 1);
        
        matrix [i] [j] = -1;
        
        horis_0 [i] --;
        vertic_0 [j] --;
      }
    }
    
   return (answer);
 }

 
void output ()
 {
 	FILE * file = fopen ("output.txt", "w");

   fprintf (file, "%d", answer);
   
   fclose (file);
 }
 
