#define MAX				400000

#include <stdio.h>


void input ();
void output ();
int slow ();
int solve ();

int n, k, m, answer;
int next [MAX];


main ()
 {
 	input ();

   if (m == n)
    answer = solve ();
   else answer = slow ();
   
   output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("input.txt", "r");
   
   fscanf (file, "%d %d %d", & n, & k, & m);
   
   fclose (file);
 }

 
int slow ()
 {
   int cur = n - 1;
   
   for (int i = 0; i < n; i ++)
    next [i] = (i + 1) % n;

   for (int i = 0; i < m; i ++)
    {
    	for (int j = 0; j < k - 1; j ++)
       cur = next [cur];

      if (i == m - 1) return (next [cur] + 1);

      next [cur] = next [next [cur]];
    }
 }

 
void output ()
 {
 	FILE * file = fopen ("output.txt", "w");

   if (n == 1)
    fprintf (file, "1");
   else fprintf (file, "%d", n + 2 - answer);
   
   fclose (file);
 }


int solve ()
 {
   int d = 1;

   while (d <= (k - 1) * n)
    if (k * d % (k - 1) == 0)
     d = k * d / (k - 1);
    else d = k * d / (k - 1) + 1;

   return (k * n + 1 - d);
 }
 
