{$I-,Q-,R-,S-,V-,-}
uses sysutils;
const tm:double = (8/(24*60*60));
const MM = 100000;
var
  st: double;
  n: integer;
  xx, yy, dd, d, ax, ay, tx, ty, nm: longint;
  x, y, x2, y2: array [1..100] of longint;
  mv: array [1..MM+3] of byte;
  md: boolean;
  bt: byte;

procedure try(a, b, c: byte);
begin
   xx := ax; yy := ay;
   if (a>0) then begin xx := x2[a] - xx; yy := y2[a] - yy; end;
   if (b>0) then begin xx := x2[b] - xx; yy := y2[b] - yy; end;
   if (c>0) then begin xx := x2[c] - xx; yy := y2[c] - yy; end;

   dd := abs(xx-tx) + abs(yy-ty);

   if (dd<d) then begin
      if (a>0) then begin inc(nm); mv[nm] := a; end;
      if (b>0) then begin inc(nm); mv[nm] := b; end;
      if (c>0) then begin inc(nm); mv[nm] := c; end;
      ax := xx; ay := yy; d := dd;
      md := false;
   end;
end;

procedure Solve;
var  i, j, k: byte;
begin
  nm := 0; bt := 0;

  d := abs(ax-tx) + abs(ay-ty);

  randseed := 666;
  while ((nm<MM) and ((ax<>tx) or (ay<>ty))) do begin
    inc(bt);
    if (bt=0) then begin if (now>st) then exit; end;

    md := true;
    for i := 1 to n do try(i, 0, 0);
    for i := 1 to n do for j := 1 to n do if (i<>j) then try(i, j, 0);
    for i := 1 to n do for j := 1 to n do if (i<>j) then
    for k := 1 to n do if (k<>j) then try(i, j, k);

    if ((md) and (d>0) and (nm<MM)) then begin
      inc(nm); k := random(n)+1; mv[nm] := k;
      ax := x2[k] - ax; ay := y2[k] - ay;
      d := abs(ax-tx) + abs(ay-ty);
    end;
  end;
end;

procedure ReadAll;
var  i: integer;
begin
  Assign(Input, 'OUTPUT.TXT'); Reset(Input);

  Read(ax, ay, tx, ty);
  Read(n);
  for i := 1 to n do begin
    Read(x[i], y[i]);
    x2[i] := x[i]*2; y2[i] := y[i]*2;
  end;

  Close(Input);
end;

procedure Out;
var  i: longint;
begin
  Assign(Output, 'INPUT.TXT'); ReWrite(Output);

  if ((ax=tx) and (ay=ty) and (nm<=MM)) then begin
    WriteLn(nm);
    for i := 1 to nm do WriteLn(mv[i]);
  end else WriteLn('-1');

  Close(Output);
end;

begin
  st := now + tm;
  ReadAll;
  Solve;
  Out;
end.
