{$UNDEF DEBUG}
{.$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}



Const
  InpF='input.txt';
  OutpF='output.txt';
  DebugPath='c:\work\30\3\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=5;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}
 Const
  maxn=300000;

var
 N, M, K: Longint;
 next, prev: Array [0..maxN] of Longint;
 Ans: Longint;

Procedure init;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  read(n, k, m);
  close(Input);
 End;

Procedure solve;
 var x, i, j: Longint;
 Begin
  for i:=0 to N-1 do begin
   j:=(i+1) mod N;
   next[i]:=j;
   prev[j]:=i;
  end;
  x:=0;
  for i:=1 to m do begin
   for j:=1 to k do x := prev[x];
   next[prev[x]]:=next[x];
   prev[next[x]]:=prev[x];
   Ans:=x+1;
   x:=prev[x];
  end;
 End;

procedure done;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  WriteLn(Ans);
  close(Output);
 End;

begin
 Init;
 Solve;
 Done;
End.

