#include <stdio.h>
#include <iostream>

using namespace std;

const int maxI = 60001;
const int maxL = 1000001;
const int INF = 1000000000;

int interv[ maxI ][ 2 ];
int ind[ maxI ];
int timel[ maxL ];
bool mark[ maxI ];

int costm[ maxI ];

int  rmqmin[ 20 ][ maxL ];
int n;
int l;

int logm ( int x )
{
	int r;
	int i;
	
	for ( i = 1, r = 0; i < x; r++, i<<=1 );
	return r;
}

bool cmpf( const int &a, const int &b )
{
	if ( interv[a][0] > interv[b][0] ) return false;
	if ( interv[a][0] < interv[b][0] ) return true;
	if ( interv[a][1] > interv[b][1] ) return false;
	if ( interv[a][1] < interv[b][1] ) return true;
	return true;
}

void make_rmq()
{
	int i,j,k = logm( n );

	for ( i = 1; i <= l; i++ )
		rmqmin[0][i] = timel[i];
	for ( j = 1; j <= k; j++ )
		for ( i = 1; i <= l; i++)
			rmqmin[j][i] = min ( rmqmin[ j-1 ][ i ] ,rmqmin[ j-1 ][ i+(1<<(j-1)) ] );
}

int rmq_find( int s, int e )
{
	int i,j;
	int minc = INF;
	int k = logm( e-s+1 );
	for ( i = k; i >= 0; i-- )
		if ( (e-s+1 ) & ( 1 << i ) )
	{
		minc = min( minc, rmqmin[i][s] );
		s += ( 1 << i );
	}
	return minc;
}

int main()
{	
	int i,j;
	int si,ei;
		
	freopen("cover.in","r",stdin);
	freopen("cover.out","w",stdout);
	
	scanf("%d %d\n", &n, &l);	

	for ( i = 1; i <= l; i++ )
		scanf("%d ", &timel[i] );
	for ( i = 1; i <= n; i++, ind[i-1] = i-1 )
		scanf("%d %d\n", &interv[ i ][0], &interv[ i ][1] );
	
	make_rmq();
	sort( ind + 1, ind + n + 1, cmpf );

	for ( i = 1; i <= n; i++ )
	{
		j = i-1;
		while( interv[ ind[i] ][ 0 ] >= interv[ ind[j] ][ 0 ] &&
		       interv[ ind[i] ][ 1 ] <= interv[ ind[j] ][ 1 ] &&
		       !mark[ ind[j] ] )
		{
			mark[ ind[j] ] = 1;
			j--;
		}
	}	
	
	for ( i = 1; i <= n; i++ )
	if ( ! mark [i] ) 
	{
		si = interv[ ind[i] ][ 0 ];
		ei = interv[ ind[i] ][ 1 ];
		j = i;
		costm[ i ] = INF;
		while ( 1 )
		{
			costm[ i ] = min( costm[i], costm[j-1] + rmq_find( si, ei ) );
			
			j--;
			while ( mark[j] && j>=0 ) j--;
			if ( j == 0 ) break;
			
			if ( si > interv[ ind[j] ][ 1 ] ) break;
			ei = interv[ ind[j] ][ 1 ];	
		}
	}
	else costm[ i ] = costm[ i - 1];
	while ( mark[n] ) n--;

	printf("%d\n", costm[ n ] );

	fclose(stdin);
	fclose(stdout);
}
