#include <stdio.h>
#include <iostream>

using namespace std;

const int maxCr = 501;
const int maxCv = 101;
const int INF = 666013;

int dist[ maxCr ][ maxCv ];
int depl[ maxCr ][ maxCv ];

char cuv1[ maxCv ][ 21 ];
char cuv2[ maxCv ][ 21 ];

int distmin = INF, depmin = INF;

int nrcuv1;
int nrcuv2;

int fpi[ maxCr ];

char aux[ maxCr ];
char prop2[ maxCr ];

int absv( int x )
{
	if ( x < 0 ) return (-1)*x;
	return x;
}

int calcdist( char cuv1[ 21 ], int n1, char cuv2[ 21 ], int n2 )
{
	int i,j;
	int x=0;
	j = n1;
	for ( i = 0; i < max( n1+1, n2 ); i++ )
	{
		if ( j >= 0 )
		{
			if ( i >= n2 )			
				x += absv( '@' - cuv1[ j ] );
			else
				x += absv( cuv2[i] - cuv1[j] );
			j--;
		}
		else
			x += absv( cuv2[ i ] - '@' );
	}

	return x;
}

int calcdepls( int i, int j, int cuv )
{
	int x = 0;
	int l;
	for ( l = i; l <= j; l++ )
		x += absv( cuv - fpi[l] );
	return x;
}

int main()
{
	int i,j,l,n;
	int k,x;
	freopen("dist.in","r",stdin);
	freopen("dist.out","w",stdout);

	gets(aux);
	n = strlen( aux );
	i = 0;
	while( i < n )
	{
		while ( aux[i] == ' ' ) i++;
		nrcuv1++;
		j = 0;
		while ( aux[i] != ' ' && i < n )
		{
			cuv1[ nrcuv1 ][ j ] = aux[i];
			i++;
			j++;
		}
	}
	
	gets(aux);
	n = strlen( aux );
	l = 0;
	i = 0;
	while( i < n )
	{
		while ( aux[i] == ' ' ) i++;
		nrcuv2++;
		j = 0;
		while ( aux[i] != ' ' && i < n )
		{
			l++;
			cuv2[ nrcuv2 ][ j ] = aux[i];
			prop2[ l ] = aux[ i ];
			fpi[l] = nrcuv2;
			i++;
			j++;
		}
	}
	
	for ( i = 1; i <= l; i++ )
		for ( j = 1; j <= min( i, nrcuv1 ); j++ )
		{
			// Formez al j-lea cuvant
			dist[ i ][ j ] = INF;
			n = -1;
			k = i;
			while ( k > 0 && n <= 19 && dist[k-1][j-1]  )
			{
				n++;
				aux[ n ] = prop2[k];
				x = calcdist( aux, n , cuv1[ j ], strlen( cuv1[ j ] ) ) + dist[k-1][ j-1 ];
				if ( x < dist[ i ][ j ] )
				{
					dist[ i ][ j ] = x;
					depl[ i ][ j ] = calcdepls( k, i, j ) + depl[ k-1 ][ j-1 ];
				}
				else
					if ( x == dist[ i ][ j ] )
					{
						x = calcdepls( k, i, j ) + depl[ k-1 ][ j-1 ];
						if ( depl[ i ][ j ] > x )
							depl[ i ][ j ] = x;
					}
				k--;
			}			
			if ( j == 1 )
			{
				n = 0;
				for ( k = i; k >= 1;k-- )
				{
					aux[n] = prop2[k];
					n++;
				}
				x = calcdist( aux, n-1, cuv1[j], strlen( cuv1[j] ) );
				if ( x < dist[ i ][ j ] )
				{
					dist[ i ][ j ] = x;
					depl[ i ][ j ] = calcdepls( 1, i, 1 );
				}
			}
			
		}

	for ( i = 1; i <= nrcuv1; i++ )
	{
		for ( j = i+1; j <= nrcuv1; j++ )
			dist[ l ][ i ] += calcdist( aux, -1, cuv1[j], strlen( cuv1[j] ) );
		if ( dist[l][i] < distmin )
		{
			distmin = dist[l][i];
			depmin = depl[l][i];
		}
		else
			if ( dist[l][i] == distmin )
				if ( depmin > depl[l][i] ) depmin = depl[l][i];
	}
	
	printf("%d %d\n", distmin, depmin );		
 
	fclose(stdin);
	fclose(stdout);

	return 0;
}
