#include <stdio.h>
#include <iostream>

using namespace std;

const int maxN = 100005;
const int maxM = 200005;

long long INF = 2000000000000000000LL;
long long distc;

const int X = 0;
const int Y = 1;

int pOX[ maxM ];
int pct[ maxN ][2];
int cp[ maxM ];

long long dmin[ maxN ]; 

int n,m;
int i,j;
int upc;

int main()
{
	freopen("puncte.in","r",stdin);
	freopen("puncte.out","w",stdout);

	scanf("%d %d\n", &n, &m);

	for ( i = 1; i <= n; i++)
		scanf("%d %d\n", &pct[i][X], &pct[i][Y] );

	
	for ( i = 1; i <= m; i++ )
		scanf("%d\n", &pOX[i] );
	
	j = 1;
	for ( i = 1; i <= m; i++ )
	{
		if ( upc )
			dmin[i] = ( long long ) pct[ upc ][Y]*pct[ upc ][Y] + ( pOX[i] - pct[upc][X] )*( pOX[i] - pct[upc][X] );
			
		else
			dmin[i] = INF;
		for ( j = upc+1; j <= n && pct[j][X] <= pOX[i]; j++ )
		{
			distc = ( long long ) pct[j][Y]*pct[j][Y] + (pOX[i] - pct[j][X])*(pOX[i] - pct[j][X] );
			if ( distc < dmin[i] )
			{
				dmin[i] = distc;
				upc = j;
			}
		}
	}
	
	j=n;
	upc = 0;
	for ( i = m; i >= 1; i-- )
	{
		if ( upc )
		{
			distc = ( long long ) pct[ upc ][Y]*pct[ upc ][Y] + ( pct[upc][X] - pOX[i] )*( pct[upc][X] - pOX[i] );
			if ( dmin[i] > distc )
				dmin[i] = distc;
		}
		for ( ; j >= 1 && pct[j][X] >= pOX[i]; j-- )
		{
			distc = ( long long ) pct[j][Y]*pct[j][Y] + ( pct[j][X] - pOX[i] ) * ( pct[j][X] - pOX[i] );
			if ( distc < dmin[i] )
			{
				dmin[i] = distc;
				upc = j;
			}
		}
	}
	
	for( i = 1; i <= m; i++ )
		printf("%Ld\n", dmin[i] );
	
	fclose(stdin);
	fclose(stdout);

	return 0;
}


	
