// puncte
#include <cstdio>

#include <algorithm>
using namespace std;

const int MAX_N = 100005;
const int MAX_M = 200005;
const int INF = 2000000000;
int M, N, Ax[MAX_N], Ay[MAX_N], B[MAX_M];
char line[20];

int dist(int ax, int ay, int bx, int by) {
	return (ax - bx) * (ax - bx) + (ay - by) * (ay - by);
}

int main(void) {
	FILE *in = fopen("puncte.in", "r"),
		*out = fopen("puncte.out", "w");
	fscanf(in, "%d %d\n", &N, &M);
	int i;
	for (i = 0; i < N; ++ i)
		fscanf(in, "%d %d", &Ax[i], &Ay[i]);
	for (i = 0; i < M; ++ i)
		fscanf(in, "%d", &B[i]);
	fclose(in);
	
	sort(B, B + M);
	int j = 0, min = INF, mini = -1, d;
	for (i = 0; i < M; ++ i) {
		min = INF;
		for (j = mini + 1; j < N; ++ j) {
			d = dist(B[i], 0, Ax[j], Ay[j]);
			if (min > d) {
				min = d;
				mini = j;
			}
		}
		fprintf(out, "%d\n", min);
	}
	fclose(out);
	
	return 0;
}
