#include <stdio.h>
#include <algorithm>
#include <vector>
using namespace std;

#define NMAX 60010
#define MMAX 1000010
#define INF 2000000000

int N, M;

int a[MMAX];

pair <int, int> inter[NMAX];

inline int MAX(int a, int b) { return (a > b) ? a : b; }
inline int MIN(int a, int b) { return (a < b) ? a : b; }

/*
int aint[MMAX * 5];

void update(int x, int y, int q, int poz, int val)
{
	if (x == y) {
		aint[q] = val;
		return;
	}

	int mij = (x + y) >> 1;

	if (poz <= mij) update(x, mij, q << 1, poz, val);
	else update(mij + 1, y, (q << 1) + 1, poz, val);

	aint[q] = MIN(aint[q << 1], aint[(q << 1) + 1]);
}

int query(int x, int y, int q, int a, int b)
{
	if (a <= x && y <= b) return aint[q];

	int mij = (x + y) >> 1, mn = INF;

	if (a <= mij) mn = MIN(mn, query(x, mij, q << 1, a, b));
	if (b > mij) mn = MIN(mn, query(mij + 1, y, (q << 1) + 1, a, b));

	return mn;
}

int sol1()
{
	int mx = 0, i, j;

	for (i = 0; i < (MMAX << 1); i++) aint[i] = INF;

	update(0, M, 1, 0, 0);

	j = 1;
	int cmin, rez = 0;
	for (i = 0; i <= M; i++) {
		while (inter[j].second <= i && j <= N) {
			mx = MAX(mx, inter[j].first);
			j++;
		}

		cmin = query(0, M, 1, mx, i);
//		printf("%d %d - %d\n", mx, i, cmin);
		if (i == M) rez = cmin;
		update(0, M, 1, i + 1, cmin + a[i + 1]);
	}

	return rez;

}
*/


int cmp(pair <int, int> a, pair <int, int> b) 
{
	if (a.second == b.second) return a.first < b.first;
	return a.second < b.second;
}


int deck[MMAX];
int poz[MMAX];
int jeg[MMAX];

int sol2()
{
	int i, j = 1;

	int p = 0, q = -1, mx = 0, w, cmin;

	for (i = 0; i <= M; i++) {
		while (inter[j].second <= i && j <= N) {
			mx = MAX(mx, inter[j].first);
			j++;
		}

		w = jeg[i];

		while (p <= q && w < deck[q]) q--;
		q++; deck[q] = w; poz[q] = i;

		while (p <= q && poz[p] < mx) p++;

		cmin = deck[p];

		if (i == M) return cmin;

		jeg[i + 1] = cmin + a[i + 1];
	}

return 0;
}
/*
int gen(int N, int M)
{
	freopen("cover.in", "w", stdout);

	printf("%d %d\n", N, M);

	int i, q, w;
	for (i = 1; i <= M; i++) printf("%d ", rand() % 1024);
	printf("\n");

	for (i = 1; i <= N; i++) {
		q = rand() % M + 1;
		w = q + rand() % (M - q);

		printf("%d %d\n", q, w);
	}

fclose(stdout);
return 0;
}
*/

int main()
{	
//	srand(131432423);
//	gen(60000, 1000000);
	
	int i;
	
	freopen("cover.in", "r", stdin);
	freopen("cover.out", "w", stdout);

	scanf("%d %d", &N, &M);
	
	for (i = 1; i <= M; i++) scanf("%d", &a[i]);

	for (i = 1; i <= N; i++) scanf("%d %d", &inter[i].first, &inter[i].second);

	sort(inter + 1, inter + N + 1, cmp);

	printf("%d\n", sol2());

//	printf("%d\n", sol1());

fclose(stdin);
fclose(stdout);
return 0;
}

