#include <stdio.h>
#include <bitset>
#include <vector>
using namespace std;

#define NMAX 2015
#define KMAX 100010

int N, K;

vector <int> leg[NMAX];

bitset <NMAX> mm[NMAX];

int xx[KMAX];
int yy[KMAX];

int grad[NMAX];

int jeg[NMAX];

char viz[NMAX];

int nr[2];
int a[2][NMAX];


int c1[NMAX];
int c2[NMAX];

char vz[NMAX];

int coada[2][NMAX];

bitset <NMAX> cur;

int NC;

int kkt[NMAX];

int cc1[NMAX];
int cc2[NMAX];

int make_colo(int nc)
{
	int i, j, x, y;

	int p[2], q[2];

	p[0] = 0; q[0] = -1;

	memset(vz, 0, sizeof(vz));

	for (i = 1; i <= nr[0]; i++) {
		x = a[0][i];
		vz[x] = 1;

		coada[0][++q[0]] = x;
	}

	for (i = 1; i <= nr[1]; i++) {
		x = a[1][i];
		vz[x] = 1;

		coada[0][++q[0]] = x;
 	}

	int e = 0;

	vector <int> :: iterator it;

	kkt[0] = 0;

	while (1) {
		p[e ^ 1] = 0;
		q[e ^ 1] = -1;
		cur = 0;
		
		while (p[e] <= q[e]) {
			x = coada[e][p[e]];
//			printf("%d (%d) | ", x, c1[x]);
			kkt[++kkt[0]] = x;

			p[e]++;

			for (it = leg[x].begin(); it != leg[x].end(); ++it)
				if (!vz[*it]) {
					coada[e ^ 1][++q[e ^ 1]] = *it;
					vz[*it] = 1;

					cur[*it] = 1;
					c1[*it] = c2[x];
				} else if (cur[*it] && c1[*it] != c2[x]) c2[*it] = c2[x];
		}
//		printf("\n");

		if (q[e ^ 1] == -1) break;

		for (i = 0; i <= q[e ^ 1]; i++) {
			x = coada[e ^ 1][i];
			for (j = i + 1; j <= q[e ^ 1]; j++) {
				y = coada[e ^ 1][j];
				if (!mm[x][y]) continue;

				if (c1[x] == c1[y]) continue;

				if (c2[x] && c2[y] && c2[x] != c2[y] && c2[x] && c2[y]) return 0;

				if (c2[x]) { if (c2[x] != c1[y]) c2[y] = c2[x]; }
				else 
				if (c2[y]) { if (c2[y] != c1[x]) c2[x] = c2[y]; }
				else {
					nc++;
					c2[x] = c2[y] = nc;
				}
			}
		}

		for (i = 0; i <= q[e ^ 1]; i++) {
			x = coada[e ^ 1][i];
			if (!c2[x]) c2[x] = ++nc;
		}

		e ^= 1;
	}

	for (i = 1; i <= kkt[0]; i++) {
//		printf("%d ", kkt[i]);

		if (!c2[kkt[i]]) c2[kkt[i]] = ++nc;
		c1[kkt[i]] += NC;
		c2[kkt[i]] += NC;

		cc1[kkt[i]] = c1[kkt[i]];
		cc2[kkt[i]] = c2[kkt[i]];
		viz[kkt[i]] = 1;
	}

//	printf("jeg %d", nc);
//	printf("\n");

	NC += nc;

return 1;
}

void color(int x)
{
	memset(c1, 0, sizeof(c1));
	memset(c2, 0, sizeof(c2));
	
	int e, i, k = 0, j, w, q;

	int nc;
	
	// ma uit la vecinii lui x

	jeg[0] = 0;

	for (vector <int> :: iterator it = leg[x].begin(); it != leg[x].end(); ++it)
		jeg[++jeg[0]] = *it;

	e = 0;
	for (i = 1; i <= 3; i++) {
		for (j = 1; j <= jeg[0]; j++) {
			if (j == i) continue;
			for (k = 1; k <= jeg[0]; k++) {
				if (k == j || k == i) continue;

				if (mm[jeg[i]][jeg[j]] && mm[jeg[i]][jeg[k]] && mm[jeg[j]][jeg[k]]) { e = 1; break; }
			}
			if (e) break;
		}
		if (e) break;
	}

	if (e) {
		e = 0;
		nr[0] = 0; nr[1] = 0;
		a[0][++nr[0]] = jeg[i];
		a[0][++nr[0]] = jeg[j];
		a[0][++nr[0]] = jeg[k];

		c1[ jeg[i] ] = 1;
		c1[ jeg[j] ] = 1;
		c1[ jeg[k] ] = 1;

		c2[ jeg[i] ] = 0;
		c2[ jeg[j] ] = 0;
		c2[ jeg[k] ] = 0;

		for (q = 1; q <= jeg[0]; q++) {
			if (q == i || q == j || q == k) continue;

			e = 1;
			for (w = 1; w <= nr[0] && e; w++)
				if (!mm[jeg[q]][ a[0][w] ]) e = 0;

			if (e) a[0][++nr[0]] = jeg[q], c1[ jeg[q] ] = 1, c2[ jeg[q] ] = 0;
			else a[1][++nr[1]] = jeg[q], c1[ jeg[q] ] = 2, c2[ jeg[q] ] = 0;
		}

		nc = 2;

		for (i = 1; i <= nr[0]; i++)
			for (j = 1; j <= nr[1]; j++)
				if (mm[ a[0][i] ][ a[1][j] ]) {
					if (c2[ a[0][i] ]) c2[ a[1][j] ] = c2[ a[0][i] ];
					else
					if (c2[ a[1][j] ]) c2[ a[0][i] ] = c2[ a[1][j] ];
					else c2[ a[0][i] ] = c2[ a[1][j] ] = ++nc;
				}

		for (i = 1; i <= jeg[0]; i++)
			if (!c2[ jeg[i] ]) c2[ jeg[i] ] = ++nc;

		a[0][++nr[0]] = x;
		c1[x] = 1; c2[x] = 2;

		make_colo(nc);

		return;
	}

	if (jeg[0] == 1) {
		nr[0] = 0;
		nr[1] = 0;
		a[0][++nr[0]] = x;
		c1[x] = 1;
		c2[x] = 2;
	
		w = jeg[1];
		a[0][++nr[0]] = w;
		c1[w] = 1;
		c2[w] = 3;

		make_colo(3);
		return;
	}

	if (jeg[0] == 2) {
		q = jeg[1];
		w = jeg[2];

		if (mm[q][w]) {
			nr[0] = nr[1] = 0;
			a[0][++nr[0]] = q;
			a[0][++nr[0]] = w;
			c1[q] = c1[w] = 1;
			c2[q] = 3; c2[w] = 4;
			a[0][++nr[0]] = x;
			c1[x] = 1; c2[x] = 2;

			if (make_colo(4)) return;

			memset(c1, 0, sizeof(c1));
			memset(c2, 0, sizeof(c2));

			nr[0] = nr[1] = 0;
			a[0][++nr[0]] = q;
			a[1][++nr[1]] = w;
			c1[q] = 1; c2[q] = 3;
			c1[w] = 2; c2[w] = 3;
			a[0][++nr[0]] = x;
			c1[x] = 1; c2[x] = 2;

			if (make_colo(3)) return;
		} else {
			nr[0] = nr[1] = 0;
			a[0][++nr[0]] = q;
			a[1][++nr[1]] = w;
			c1[q] = 1; c2[q] = 3;
			c1[w] = 2; c2[w] = 4;
			a[0][++nr[0]] = x;
			c1[x] = 1; c2[x] = 2;

			make_colo(4);
		}

		return;
	}

	if (jeg[0] == 3) {
		e = 0;	
		for (i = 1; i <= jeg[0]; i++) {
			for (j = i + 1; j <= jeg[0]; j++)
				if (mm[ jeg[i] ][ jeg[j] ]) {e = 1; break;}
			if (e) break;
		}

		q = jeg[i];
		w = jeg[j];

		for (k = 1; k <= jeg[0]; k++) if (k != i && k != j) break;

		k = jeg[k];

		nr[0] = nr[1] = 0;

		a[0][++nr[0]] = q;
		a[0][++nr[0]] = w;
		a[0][++nr[0]] = x;
		c1[q] = 1; c2[q] = 3;
		c1[w] = 1; c2[w] = 4;
		c1[x] = 1; c2[x] = 2;

		e = 0;
		c1[k] = 2;
		if (mm[k][q]) c2[k] = c2[q];
		else
		if (mm[k][w]) c2[k] = c2[w];
		else c2[k] = 5, e = 1;

		a[1][++nr[1]] = k;

		make_colo(4 + e);

		return;
	}

	if (jeg[0] == 4) {
		int aa, bb, jj;
		
		nr[0] = nr[1] = 0;
		
		e = 1;
		for (i = 1; i <= jeg[0] && e; i++)
			for (j = i + 1; j <= jeg[0] && e; j++)
				if (mm[ jeg[i] ][ jeg[j] ]) {
					aa = 0; bb = 0;
					for (jj = 1; jj <= jeg[0]; jj++) {
						if (jj == i || jj == j) continue;
						if (!aa) aa = jj;
						else bb = jj;
					}

					if (mm[ jeg[aa] ][ jeg[bb] ]) {
						e = 0;

						a[0][++nr[0]] = jeg[i];
						a[0][++nr[0]] = jeg[j];

						c1[jeg[i]] = c1[jeg[j]] = 1;
						c2[jeg[i]] = c2[jeg[j]] = 0;


						a[1][++nr[1]] = jeg[aa];
						a[1][++nr[1]] = jeg[bb];

						c1[jeg[aa]] = c1[jeg[bb]] = 2;
						c2[jeg[aa]] = c2[jeg[bb]] = 0;

						break;
					}
				}

		nc = 2;

		for (i = 1; i <= nr[0]; i++)
			for (j = 1; j <= nr[1]; j++)
				if (mm[ a[0][i] ][ a[1][j] ]) {
					if (c2[ a[0][i] ]) c2[ a[1][j] ] = c2[ a[0][i] ];
					else
					if (c2[ a[1][j] ]) c2[ a[0][i] ] = c2[ a[1][j] ];
					else c2[ a[0][i] ] = c2[ a[1][j] ] = ++nc;
				}

		a[0][++nr[0]] = x;
		c1[x] = 1; c2[x] = 2;
		
		
		make_colo(nc);
	}
}

int main()
{
	int i;
	
	freopen("promo.in", "r", stdin);
	freopen("promo.out", "w", stdout);

	scanf("%d %d", &N, &K);

	for (i = 1; i <= K; i++) {
		scanf("%d %d", &xx[i], &yy[i]);

		grad[xx[i]]++;
		grad[yy[i]]++;

		leg[xx[i]].push_back(yy[i]);
		leg[yy[i]].push_back(xx[i]);

		mm[xx[i]][yy[i]] = mm[yy[i]][xx[i]] = 1;
	}

	NC = 0;
	for (i = 1; i <= N; i++) {
		if (!viz[i]) {
			color(i);
//			for (int j = 1; j <= N; j++) printf("%d %d |", c1[j], c2[j]);
//			printf("\n");
		}
	}

	for (i = 1; i <= N; i++) {
		if (!cc1[i]) {
			cc1[i] = NC + 1;
			cc2[i] = NC + 2;
			NC += 2;
		}
	}

	printf("%d\n", NC);

	for (i = 1; i <= N; i++) printf("%d %d\n", cc1[i], cc2[i]);
	
fclose(stdin);
fclose(stdout);
return 0;
}

