#include <stdio.h>
#include <string.h>

#define Nmax 202
#define base 100000

struct big
 {
  unsigned a[21];
 } a[Nmax][Nmax];


void init(big &a)
 {
  a.a[0] = 1;
  a.a[1] = 0;
 }

void print(big a, FILE *f)
 {
  fprintf(f,"%u",a.a[a.a[0]]);
  int i;
  for(i=a.a[0]-1;i>0;--i)
   fprintf(f,"%.5u",a.a[i]);
//  fprintf(f,"\n");
 }

void add(big &A,big B)
 {
  unsigned i, t=0;

  for(i=1;i<=A.a[0] || i<=B.a[0] || t;++i)
   {
    A.a[i] += B.a[i] + t;
    t/=base;
    if(A.a[i] >= base)
     {
      t += A.a[i] / base;
      A.a[i] -= base;
      if(i == A.a[0])
       ++A.a[0];
     }
   }

  A.a[0] = i-1;
 }

void sub(big &A,big B)
 {
  unsigned i, t=0;

  for(i=1;i<=A.a[0] || i<=B.a[0];++i)
   {
    if(A.a[i] >= B.a[i])
     A.a[i] -= B.a[i];
      else
     {
      while(!(A.a[i] >= B.a[i]))
       {
        --A.a[i+1];
        A.a[i] += base;
       }
      A.a[i] -= B.a[i];
     }
   }

  while(A.a[0] == 0)
   --A.a[0];
 }

int main()
 {
  freopen("munte.in","r",stdin);
  freopen("munte.out","w",stdout);


  int i,j, n, N;

  scanf("%d", &n);


  N = n;
  n = 2*n - 2;

  int i1=0, i2=1;

  a[i1][1].a[0] = 1;
  a[i1][1].a[1] = 1;
  

  for(i=1;i<=n;++i)
   {
    for(j=1;j<=n;++j)
      {
       init(a[i][j]);
       add(a[i][j] , a[i-1][j]);
       add(a[i][j] , a[i-1][j+1]);
       add(a[i][j] , a[i-1][j-1]);
      }

    if(i)
     sub(a[i][1] , a[i-1][1]);
   }

  print(a[n][1],stdout);
  printf("\n");
  
  return 0;
 }
