#include <stdio.h>
#include <algorithm>
using std::sort;

#define FIN "cover.in"
#define FOUT "cover.out"
#define MAXN 60001
#define MAXL 1000001
#define INF 0x3f3f3f3f
const int maxa = 1<<17;

struct iv { int a, b; } ;

int A[maxa];
short c[MAXL];
int n, l;
iv B[MAXN];
int St[MAXN], k=0;

bool comp(const iv &a, const iv &b) {
	return a.a < b.a || a.a == b.a && a.b < b.b;
}

int min(int a, int b) {
	return (a<b) ? a : b;
}

int max(int a, int b) {
	return (a>b) ? a : b;
}

int build(int p, int lo, int hi)
{
	if (lo == hi) return A[p] = c[lo];
	int m = (lo+hi) >> 1;
	return A[p] = min( build((p<<1)+1, lo, m), build((p<<1)+2, m+1, hi) );
}

int iavezi(int p, int lo, int hi, int a, int b)
{
	if (a <= lo && hi <= b) 
		return A[p];
	int m = (lo+hi) >> 1, x = INF;
	if (a <= m) x = iavezi((p<<1)+1, lo, m, a, b);
	if (b >  m) x = min(x, iavezi((p<<1)+2, m+1, hi, a, b));
	return x;
}

void rez()
{
	// un kktzel...
	int i, ca, cb, mcrt, mincomun;
	int sum = 0, last = 0;
	for (i=0; i<n; ++i) {
		mcrt = iavezi(0, 1, l, B[i].a, B[i].b);
		if (i)
			ca = max(B[i].a, B[last].a), cb = min(B[i].b, B[last].b);
		if (i && ca <= cb && (mincomun = iavezi(0, 1, l, ca, cb)) <= St[k] + mcrt )
			St[k] = mincomun;
		else
			St[++k] = mcrt, last = i;	
	}
	for (i=1; i<=k; ++i)
		sum += St[i];
	printf("%ld\n", sum);
}

void citire()
{
	int i;
	freopen(FIN, "r", stdin);
	freopen(FOUT,"w",stdout);
	scanf("%d %d", &n, &l);
	for (i=1; i<=l; ++i)
		scanf("%hd", &c[i]);
	for (i=0; i<n; ++i)
		scanf("%d %d", &B[i].a, &B[i].b);
	sort(B, B+n, comp);
}

int main()
{
	citire();
	build(0, 1, l);
	rez();
	return 0;
}
