#include <stdio.h>
#include <string.h>
#define FIN "munte.in"
#define FOUT "munte.out"

int n;
int A[220][220][100];

void ReadData ()
{
 	freopen ( FIN , "r" ,  stdin );
    scanf ( "%d" , &n );
    fclose ( stdin );
}

void WriteData ( int *A )
{
 	int i,j;
 	freopen ( FOUT , "w" , stdout );
    for ( i=A[0] ; i ; i-- )
        printf ( "%d" , A[i]);
    printf ( "\n" );
	fclose ( stdout );
}

void SetV ( int *A , int v )
{
 	int i;
 	for ( i=2 ; i<100 ; i++ ) A[i]=0;
    A[0]=1; A[1]=v;
}

void Initialize ()
{
 	int i,j;
 	for ( j=0 ; j<n ; j++ ) SetV ( A[j][j] , 1 );
 	for ( i=2 ; i+2<n ; i++ )
       for ( j=0 ; j<n ; j++ ) SetV ( A[i+j][j] , 0 );
}

int max ( int x , int y ) { return ( x>y ) ? ( x ) : ( y ); }

void Tear ( int *A , int *B )
{
 	int t=0,i;
    A[0]=max ( A[0] , B[0] );
    for ( i=1,t=0 ; i<=A[0] ; i++ ) {
       t+=A[i]+B[i];
       A[i]=t%10;
       t/=10;
    }
	for ( ; t ; t/=10 ) A[++A[0]]=t%10;
}

void Solve ()
{
 	int i,j;
 	Initialize ();
 	for ( i=2 ; i<n*2 ; i+=2 )
       for ( j=0 ; j<n-(i/2) ; j++ )
          if ( j==0 ) Tear ( A[i][j] , A[i-1][j+1] ); else {
            Tear ( A[i+j][j] , A[i+j-1][j+1] );
            Tear ( A[i+j][j] , A[i+j-2][j] );
            Tear ( A[i+j][j] , A[i+j-1][j-1] );
          }
}

int main ()
{
 	ReadData ();
    Solve ();
    WriteData ( A[n*2-2][0]);
    return 0;
}
