#include <cstdio>
#include <cstdlib>

using namespace std;

#define NX 100001

int N;
int rola[ NX ], banda[ NX ];

void cit() {
	int i, x;
	
	scanf( "%d", &N );

	for( i = 1; i <= N; i++ ) {
		scanf( "%d%d", &rola[ i ], &x );
		banda[ rola[i] ] = i * ( x ? (-1) : 1 );
	}
	for( i = 1; i <= N; i++ )
		if( banda[ i ] == 0 ) {
			rola[ 0 ] = i;
			break;
		}
}

int ABS( int x ) {
	return x < 0 ? -x : x;
}

void exch( int x, int y ) {
	int b;
	// x = rola vida, y = rola de pe care fac mutarea
	printf( "%d\n", y );
	b = banda[ y ];
	banda[ x ] = b * (-1);
	banda[ y ] = 0;
	rola[ 0 ] = y;
	rola[ ABS( b ) ] = x;
}

int cauta() {
	int i;
	
	// return prima rola care contine o banda aiurea
	for( i = 1; i <= N; i++ )
		if( banda[ i ] != i )
			return i;
	return -1;
}

void rez() {
	bool	ok = 0;
	int x;

	srand( 243 );
	
	while( !ok ) {
		x = rola[0];
		if( x == 0 ) {
			exch( x, cauta() );
			exch( x, rand() % N + 1 );
		}
		else
			exch( x, rola[ x ] );
		if( cauta() == -1 )
			ok = 1;
	}
}
	
int main() {
	freopen( "role.in", "r", stdin );
	freopen( "role.out", "w", stdout );

	cit();
	rez();

	return 0;
}

