#include <stdio.h>
#include <string.h>
#define NMax 105

typedef int hugeNR[102];

int N;
hugeNR D[3][NMax][3];

hugeNR Res;

void aduna(hugeNR a, hugeNR b)
{
    int i, t = 0;

    for (i = 1; i <= a[0] || i <= b[0] || t; i++, t /= 10)
    {
        if (i > a[0]) a[i] = 0; if (i > b[0]) b[i] = 0;
        a[i] = (t += a[i] + b[i]) % 10;
    }
    
    a[0] = i-1;
}

int main(void)
{
    int i, j, c1 = 0, c2 = 1, c3 = 2;
    
    freopen("munte.in", "r", stdin);
    freopen("munte.out", "w", stdout);

    scanf("%d", &N);
    if (N == 1 || N == 2)
    { printf("1\n"); return 0; }    
    
    D[c1][1][0][0] = D[c1][1][0][1] = 1;
    D[c2][2][0][0] = D[c2][2][0][1] = 1;
    D[c2][0][2][0] = D[c2][0][2][1] = 1;

    for (i = 3; i <= 2*N-2; i++)
    {
        memset(D[c3], 0, sizeof(D[c3]));
        
        for (j = 0; j <= N-1; j++)
        {
            D[c3][j][0][0] = 1; D[c3][j][0][1] = 0;
            if (j)
            {
                aduna(D[c3][j][0], D[c2][j-1][0]);
                aduna(D[c3][j][0], D[c2][j-1][1]);
                aduna(D[c3][j][0], D[c2][j-1][2]);                
            }

            D[c3][j][1][0] = 1; D[c3][j][1][1] = 0;

            aduna(D[c3][j][1], D[c2][j+1][1]);
            aduna(D[c3][j][1], D[c2][j+1][2]);            
            if (j)
                aduna(D[c3][j][1], D[c2][j+1][0]);

            D[c3][j][2][0] = 1; D[c3][j][2][1] = 0;
            if (i >= 2)
            {
                aduna(D[c3][j][2], D[c1][j][0]);
                aduna(D[c3][j][2], D[c1][j][1]);
                aduna(D[c3][j][2], D[c1][j][2]);                
            }
                
        }

        if (i == 2 * N - 2) break;

        c1++; if (c1 == 3) c1 = 0;
        c2++; if (c2 == 3) c2 = 0;
        c3++; if (c3 == 3) c3 = 0;        
    }

    Res[0] = 1; Res[1] = 0;
    aduna(Res, D[c3][0][0]);
    aduna(Res, D[c3][0][1]);
    aduna(Res, D[c3][0][2]);

    for (i = Res[0]; i >= 1; i--)
        printf("%d", Res[i]);
    printf("\n");
        
    return 0;
}

