#include <stdio.h>
#include <algorithm>
#define x first
#define y second
#define inf 1000000000
#define lmax 1000009
#define nmax 60009

using namespace std;

int cost[lmax], n, l, no[nmax], start[lmax], end[lmax], c[nmax];// cum le rezolv pe primele i
pair<int, int> temp[nmax], v[nmax];

bool cmp(pair<int, int> one, pair<int, int> two)
{
	return one.x < two.x || (one.x == two.x && one.y > two.y);
}

int main()
{
	freopen("cover.in","r",stdin);
	freopen("cover.out","w",stdout);

	int i, j, cnt = 0, first, last;

	scanf("%d%d", &n, &l);

	for(i = 1; i <= l; ++i)
	{
		scanf("%d", &cost[i]);
	}
	for(i = 1; i <= n; ++i)
	{
		scanf("%d%d", &temp[i].x, &temp[i].y);
	}
	sort(temp + 1, temp + n + 1, cmp);
	for(i = 1; i <= n; ++i)
	{
		for(j = i + 1; j <= n && temp[i].y >= temp[j].x; ++j)
		{
			if(temp[i].x <= temp[j].x && temp[i].y >= temp[j].y)
			{
				no[i] = 1;
				break;
			}
		}
	}

	for(i = 1; i <= n; ++i)
	{
		if(!no[i])
		{
			v[++cnt] = temp[i];
		}
	}
	n = cnt;
	v[n + 1].x = lmax;
	v[n + 1].y = lmax;

	first = last = 0;
	for(i = 1; i <= l; ++i)
	{
		while(v[last + 1].x <= i)
		{
			++last;
		}
		while(v[first].y < i)
			++first;
		start[i] = first;
		end[i] = last;
	}
	for(j = 1; j <= n; ++j)
		c[j] = inf;

	for(j = 1; j <= l; ++j)
	{
		if(end[j] >= start[j] && c[end[j]] > c[start[j] - 1] + cost[j])
		{
			c[end[j]] = c[start[j] - 1] + cost[j];
			i = end[j] - 1;
			while(c[i] > c[end[j]])
			{
				c[i] = c[end[j]];
				--i;
			}
		}
	}

	printf("%d\n", c[n]);
	
	
	return 0;
}
