#include <cstdio>
#include <string>
#define maxn 60003
#include <cstdlib>
#include <algorithm>
using namespace std;
int dp[maxn];
int N, L;
struct nod { int a, b;};
nod a[maxn];
int H[1<<21];
char ax[8000000];

bool operator<(const nod &a, const nod &b)
{
  if(a.a<b.a) return 1;
  if(a.a==b.a && a.b<b.b) return 1;
  return 0;
}


void update(int n, int l, int r, int poz, int val)
{
  H[n]=min(H[n], val);
  if(l>=r) return ;
  int m=(l+r)>>1;
  if(poz<=m) update(n<<1, l, m, poz, val);
  else update((n<<1)|1, m+1, r, poz, val);
}

int query(int n, int l, int r, int a, int b)
{
  if(a<=l && r<=b) return H[n];
  int m=(l+r)>>1;
  int t=0x3f3f3f3f;
  if(a<=m) t=query(n<<1, l, m, a, b);
  if(b>m) t=min(t, query((n<<1)|1,m+1, r, a, b));
  return t;
}


void citire()
{
  freopen("cover.in", "r", stdin);
  scanf("%d %d\n", &N, &L);
  fread(ax, sizeof(char), N*10+L*7, stdin);

  memset(H, 0x3f3f3f3f, sizeof(H));  

  char *t;
 t=strtok(ax, " ");
 int p;
 p=atoi(t);
 update(1, 1, L, 1, p);
 for(int i=2;i<=L;i++) { t=strtok(0, " \n"); p=atoi(t);/*scanf("%d ", &p);*/ update(1, 1, L, i, p);}
  for(int i=1;i<=N;i++) { t=strtok(0, " "); a[i].a=atoi(t); t=strtok(0, " \n"); a[i].b=atoi(t); /*scanf("%d %d\n",&a[i].a, &a[i].b);
												 */} 
}

void solve()
{
  sort(a+1, a+N+1);
  dp[1]=query(1, 1, L, a[1].a,a[1].a);
  
  int i, j;
  int maxa, minb;
  int P;
  if(N<=1000 && L<=10000) P=1;else P=i-1;
  for(i=2;i<=N;i++)
   {
     dp[i]=0x3f3f3f3f;
     maxa=0;minb=0x3f3f3f3f;
     for(j=i;j>=1;j--)
      {
	if(a[j].a>maxa) maxa=a[j].a;
	if(a[j].b<minb) minb=a[j].b;
	//printf("__%d %d\n", maxa, minb);
	if(maxa>minb) break;
	dp[i]=min(dp[i], dp[j-1]+query(1, 1, L,maxa, minb));
      }
   }

  //for(int i=0;i<=N;i++) printf("%d ", dp[i]);
  //printf("%d\n", query(1, 1, L, 3, 3));
  //printf("\n");  
printf("%d\n", dp[N]);
  
  

  
}

int main()
{
  freopen("cover.out", "w", stdout);
  citire();
  solve();
  return 0;
}
