#include <cstdio>
#include <algorithm>

using namespace std;

#define x first
#define y second
#define MP make_pair

const int NMAX = 1 << 16;
const int LMAX = 1 << 20;

int N, L;
int A[LMAX];
int st[LMAX], s, t, poz[LMAX];
pair <int, int> T[NMAX];

/*
void read(void) {
	FILE *fin = fopen("cover.in", "rt");
	int i;

	fscanf(fin, " %d %d", &N, &L);

	for (i = 1; i <= L; ++i)
		fscanf(fin, " %d", A + i);

	for (i = 0; i < N; ++i)
		fscanf(fin, " %d %d", &T[i].y, &T[i].x);

	fclose(fin);
}
*/

int get(void) {
	char buf[16];
	int i, rez;

	scanf(" %s", buf);
	for (rez = 0, i = 0; buf[i] >= '0' && buf[i] <= '9'; ++i)
		rez = rez * 10 + (buf[i] - '0');

	return rez;
}

void read(void) {
	freopen("cover.in", "rt", stdin);

	int i;
	N = get(); L = get();
	
//	printf("%d %d\n", N, L);

	for (i = 1; i <= L; ++i)
		A[i] = get();
	
	for (i = 0; i < N; ++i)
		T[i].y = get(),
		T[i].x = get();
}

void solve(void) {
	int i, j, l, v;

	sort(T, T + N);

	j = 0; l = 0; t = -1; s = 0;
	for (i = 1; i <= L; ++i) {
		v = l + A[i];
		while (t >= s && st[t] >= v) --t;
		++t; st[t] = v; poz[t] = i;
		
		while (T[j].x == i) {
			while (s < t && poz[s] < T[j].y) ++s;
			l = st[s];

			++j;
		}
	}

	FILE *fout = fopen("cover.out", "wt");

	fprintf(fout, "%d\n", l);

	fclose(fout);

}

int main(void) {

	read();

	solve();

	return 0;
}

