#include <stdio.h>
#define INPUT "munte.in"
#define OUTPUT "munte.out"
#define MAXx 200
#define MAXy 100
#define MAXC 100
unsigned char npas[MAXx][MAXy][3][MAXC];

//npas[i][j][0] - numarul de pasi pt a ajunge in punctul i, j --
//npas[i][j][1] - numarul de pasi pt a ajunge in punctul i, j \
//npas[i][j][2] - /
void add(unsigned char *A, unsigned char *B)
{
    int i, t = 0;
    for(i = 1; i <= A[0] || i <= B[0] || t; ++i, t /= 10)
        A[i] = (t+= A[i] + B[i]) % 10;
    A[0] = i-1;
}
void afis(unsigned char *A)
{
    int i;
    for(i = A[0]; i; --i)
        printf("%d",A[i]);
    printf("\n");
}
int main()
{
    freopen(INPUT, "r", stdin);
    freopen(OUTPUT, "w", stdout);

    int N;
    scanf("%d", &N);
    int i, j;
    npas[0][0][0][0] = npas[0][0][0][1] = 1;
    npas[1][1][2][0] = npas[1][1][2][1] = 1;
    for(i = 2; i <= 2*N-2;++i)
        for(j = 0; j < N; ++j)
        {
            add(npas[i][j][0], npas[i-2][j][0]);
            add(npas[i][j][0], npas[i-2][j][1]);
            add(npas[i][j][0], npas[i-2][j][2]);
            if(j)
            {
                add(npas[i][j][1], npas[i-1][j+1][0]);
                add(npas[i][j][1], npas[i-1][j+1][1]);
                add(npas[i][j][1], npas[i-1][j+1][2]);
                add(npas[i][j][2], npas[i-1][j-1][0]);
                add(npas[i][j][2], npas[i-1][j-1][1]);
                add(npas[i][j][2], npas[i-1][j-1][2]);
            }
            else
            {
                add(npas[i][j][1], npas[i-1][j+1][0]);
                add(npas[i][j][1], npas[i-1][j+1][1]);
             }

        }
    add(npas[2*N-2][0][0], npas[2*N-2][0][1]);
    add(npas[2*N-2][0][0], npas[2*N-2][0][2]);


    afis(npas[2*N-2][0][0]);
    fclose(stdin);
    fclose(stdout);
    return 0;
}
