//role
#include <stdio.h>
#define INPUT "role.in"
#define OUTPUT "role.out"
#define MAXN 100001
int banda[MAXN];   //nr banda de pe rola i
int rola[MAXN];    //nr rola pe care se afla banda i
int sens[MAXN];   //sens banda i
int N;
int nr, j = 1;
int cauty()
{
    for(;j <= N; ++j)
        if(banda[j] != rola[j])
        {
            int k;
            for(k = rola[j]; k && k != j;) k = rola[k];
            if(k != j) continue;
            for(k = rola[j]; sens[k] == 0 && k != j;) k = rola[k];
            if(sens[rola[k]] == 1) return k;  //am gasit o banda optima
        }

    int p;
    for(p = 1; p <= N; ++p)
        if(banda[p] == rola[p] && sens[p] == 1) return p; //returnez o banda intoarsa
    for(p = 1; p <= N; ++p)
        if(banda[p] != rola[p]) return p;
    return 1;
}
int main()
{
    freopen(INPUT, "r", stdin);
    freopen(OUTPUT, "w", stdout);
    scanf("%d", &N);
    int i, lib;  //lib - nr rola  libera
    for(i = 1; i <= N; ++i)
    {
        scanf("%d %d",&rola[i], &sens[i]);
        banda[rola[i]] = i;
        if(rola[i] == i && sens[i] == 0) ++nr;
    }

    for(lib = banda[0]; banda[lib];) lib = banda[lib];

    while(nr < N)
    {
        if(lib)
        {
            if(sens[lib] == 1)
            {
                printf("%d\n", rola[lib]);
                ++nr;
                banda[lib] = lib;
                sens[lib] = 0;
                banda[rola[lib]] = 0;
                int aux = lib;
                lib = rola[lib];
                rola[aux]  = aux;
            }
            else
            {
                int y;
                if(sens[rola[lib]] == 0) y = rola[lib];
                else y = cauty();

                    printf("%d\n", rola[y]);
                    printf("%d\n", rola[lib]);
                    printf("%d\n", lib);
                    printf("%d\n", rola[y]);
                    nr ++;

                    if(y == rola[lib]) ++nr;
                    
                    int aux = rola[y];

                    rola[y] = rola[lib];
                    banda[rola[lib]] = y;
                    banda[lib] = rola[lib] = lib;
                    lib = aux;
                    banda[lib] = 0;
            }
        }
        else
        {
            int y = cauty();
            printf("%d\n", rola[y]);
            int aux = lib;
            banda[rola[y]] = 0;
            rola[y] = aux;
	banda[aux] = y;
            lib = rola[y];
        }
    }

    fclose(stdin);
    fclose(stdout);
    return 0;
}
