#include <stdio.h>
#include <string>

#define NMAX 201

typedef int NR_MARE[100];

int N, N2;
NR_MARE Asus[3][NMAX], A[3][NMAX];

void adun(int A[], int B[])
{
    int t = 0;
    int i;
    for (i = 1; i<=A[0] || i<=B[0] || t>0; ++i)
    {
        t += A[i] + B[i];
        A[i] = t%10;
        t /= 10;
    }
    A[0] = i-1;
}

void afis(int A[])
{
    for (int i = A[0]; i; --i)
    {
        printf("%d", A[i]);
    }
    printf("\n");
}

int main()
{
    freopen("munte.in", "r", stdin);
    freopen("munte.out", "w", stdout);

    scanf("%d", &N2);
    A[0][0][0] = 1;
    A[0][0][1] = 1;
    Asus[1][1][0] = 1;
    Asus[1][1][1] = 1;
    
    int crt=0, prev, prev2;

    N = 2*N2 - 2;

    for (int i = 2; i<=N; ++i)
    {
        crt = i % 3;
        prev2 = (crt + 1) % 3;
        prev = (prev2 + 1) % 3;
        for (int j = 0; j<=N; ++j)
        {
            memset(A[crt][j], 0, sizeof(NR_MARE));
            memset(Asus[crt][j], 0, sizeof(NR_MARE));
            
            // 1
            adun(A[crt][j], A[prev2][j]);
            adun(A[crt][j], Asus[prev2][j]);

            // 2
            if (j > 0)
            {
                adun(Asus[crt][j], A[prev][j-1]);
                adun(Asus[crt][j], Asus[prev][j-1]);
            }

            // 3
            adun(A[crt][j], A[prev][j+1]);
            if (j>0)
                adun(A[crt][j], Asus[prev][j+1]);
        }
    }

    adun(A[crt][0], Asus[crt][0]);
    afis(A[crt][0]);
//    printf("%lld\n", A[crt][0] + Asus[crt][0]);
}

