#include <cstdio>
#include <cassert>
#include <string>

#define FIN "role.in"
#define FOUT "role.out"
#define NMAX 100001
#define INF 0x3f3f3f3f

int I[NMAX], R[NMAX], N, emp, check[NMAX], iter = 1, B[NMAX];

void read ()
{
    scanf ("%d", &N);

    for (int i = 1; i <= N; ++ i)
    {
        scanf ("%d%d", &R[i], &I[i]);
        B[i] = i;
    }
}

void solve ()
{
    if (N == 1)
    {
        printf ("%d\n", R[1]);
        return;
    }

    for (int i = 1; i <= N; ++ i)
    {
        ++ iter;
        for (int j = 1; j <= N; ++ j)
            check[R[i]] = iter;

        for (int j = 0; j <= N; ++ j)
            if (check[j] != iter)
            {
                emp = j;
                break;
            }

        for (int j = 1; j <= N; ++ j)
            if (R[j] == emp)
            {
                R[j] = B[emp];
                I[j] = 1 - I[emp];
            }
        printf ("%d\n", emp);
    }
}

int
 main ()
{
    freopen (FIN, "rt", stdin);
    freopen (FOUT, "wt", stdout);

    read ();
    solve ();

    return 0;
}

