#include <cstdio>
#include <algorithm>

using namespace std;

#define Nmax 60005
#define Lmax 1000005
#define INF 0x3f3f3f3f
#define mp make_pair
#define y first
#define x second

int n, l;
int c[Lmax], d[Nmax];
pair<int, int> inv[Nmax];

void citire()
{
    int i, a, b;

    scanf("%d %d", &n, &l);
    for (i = 1; i <= l; ++i)
        scanf("%d", &c[i]);
    for (i = 1; i <= n; ++i)
        scanf("%d %d", &inv[i].x, &inv[i].y);
}

int cmp(const pair<int, int> a, const pair<int, int> b)
{
    if (a.y < b.y)
       return 1;
    if (a.y == b.y && a.x > b.x)
       return 1;
    return 0;
}

void solve()
{
    int i, ind = 1, best = 0, st = 0, k, j;

    sort(inv+1, inv+n+1, cmp);
    for (i = 1; i <= n; ++i)
    {
        if (inv[i].x <= best)
            inv[i].y = INF;
        else
            best = inv[i].x;
    }

    sort(inv+1, inv+n+1, cmp);
    while (inv[n].y == INF)
        --n;
    /*
    for (i = 1; i <= n; ++i)
        printf("%d %d\n", inv[i].x, inv[i].y);
    */

    d[0] = 0;
    for (i = 1; i <= n; ++i)
    {
        best = INF;
        for (j = inv[i].x; j <= inv[i].y; ++j)
            best = min(best, c[j]);
        d[i] = d[i - 1] + best;
        for (j = i - 1; j >= 1; --j)
            if (inv[j].y + 1 > inv[i].x)
            {
                best = INF;
                for (k = inv[j].y; k <= inv[j + 1].y; ++k)
                    best = min(best, c[k]);
                d[i] = min(d[i], best + d[j]);
            }
        ++j;
        if (inv[i].x <= inv[j].y)
        {
            best = INF;
            for (k = inv[i].x; k <= inv[j].y; ++k)
                best = min(best, c[k]);
            d[i] = min(d[i], best + d[j - 1]);
        }
        //printf("%d -> %d\n", i, d[i]);
    }
    printf("%d\n", d[n]);
}

int main()
{
    freopen("cover.in", "r", stdin);
    freopen("cover.out", "w", stdout);
    citire();
    solve();
    return 0;
}
