#include <cstdio>
#include <string.h>

#define Nmax 128
#define Lmax 80
#define base 10

int n;
int d1[Nmax][4][Lmax], d2[Nmax][4][Lmax], d3[Nmax][4][Lmax];
int sol[Lmax];

void citire()
{
    scanf("%d\n", &n);
}

void add(int A[], int B[])
{
    int i, t = 0;

    for (i = 1; i <= A[0] || i <= B[0] || t; ++i, t /= base)
        A[i] = (t += A[i] + B[i]) % base;
    if (i - 1 > A[0])
        A[0] = i - 1;
}

void solve()
{
    int i, j;
    
    d1[0][1][0] = d1[0][1][1] = 1;
    for (i = 1; i <= 2 * n - 2; ++i)
    {
        memcpy(d3, d2, sizeof(d2));
        memcpy(d2, d1, sizeof(d1));
        memset(d1, 0, sizeof(d1));
        for (j = 0; j <= n; ++j)
        {
            if (i != 1)
            {
                add(d1[j][1], d3[j][1]);
                add(d1[j][1], d3[j][2]);
                add(d1[j][1], d3[j][3]);
            }
            if (j > 0)
            {
                add(d1[j][2], d2[j - 1][1]);
                add(d1[j][2], d2[j - 1][2]);
                add(d1[j][2], d2[j - 1][3]);
            }
            add(d1[j][3], d2[j + 1][1]);
            add(d1[j][3], d2[j + 1][3]);
            if (j != 0)
                add(d1[j][3], d2[j + 1][2]);
        }
    }
    add(sol, d1[0][1]);
    add(sol, d1[0][2]);
    add(sol, d1[0][3]);
    for (i = sol[0]; i >= 1; --i)
        printf("%d", sol[i]);
}

int main()
{
    freopen("munte.in", "r", stdin);
    freopen("munte.out", "w", stdout);
    citire();
    solve();
    return 0;
}
