#include <stdio.h>
#include <algorithm>
using namespace std;

#define maxN 200100
#define maxM 200100
#define INF 0x7FFFFFFFFFFFFFFF

typedef long long lint;

struct po{int x,y;po(){}po(int const&xp,int const&yp){x=xp,y=yp;}};
struct que{int i,x;que(){}que(int const&ip,int const&xp){i=ip,x=xp;}};

int n,m;
po vec[maxN];
que inte[maxM];
lint res[maxM];

bool pred(que a,que b){return a.x<b.x;}
lint msqr(lint x){return x*x;}

void inputFunc(){
    FILE*fi=fopen("puncte.in","r");
    fscanf(fi,"%d %d",&n,&m);
    int la=-1;
    for(int i=0;i<n;){
        int a,b;fscanf(fi,"%d %d",&a,&b);
        if(la!=a){
            vec[i].x=a,vec[i].y=b;
            la=a;
            i++;
        }else n--;
    }
    for(int i=0;i<m;i++){
        int a;fscanf(fi,"%d",&a);
        inte[i].i=i; inte[i].x=a;
    }
    sort(inte,inte+m,pred);
    
    fclose(fi);
}

void outputFunc(){
    FILE*fi=fopen("puncte.out","w");
    for(int i=0;i<m;i++){
        fprintf(fi,"%lld\n",res[i]);
    }
    fclose(fi);
}

int main(){
    inputFunc();
    int lst=0;
    for(int i=0;i<m;i++){
        int c=inte[i].x,pm;lint min=INF;
        
        for(int j=lst;j<n;j++){
            if(vec[j].x-c > min)break;
            lint cd=msqr(vec[j].x-c)+msqr(vec[j].y);
            if(cd<min)min=cd,pm=i;
        }

        res[inte[i].i]=min;
        lst=pm;
    }
    outputFunc();
    return 0;
}

