#include <stdio.h>
#include <algorithm>
#include <math.h>

using namespace std;

#define nm 100100

struct point
{
	int x, y;
};

int n, m, h[nm], t[nm], ind[nm], v[nm], place[nm];
point a[nm], aux, O = {0, 0};

long long dist(point a, point b)
{
	return ((long long)a.x - b.x) * (a.x - b.x) + ((long long)a.y - b.y) * (a.y - b.y);
}

int cmp(int one, int two)
{
	return dist(a[one], O) < dist(a[two], O) || (dist(a[one], O) == dist(a[two], O) && a[one].x > a[two].x);
}

void ins(int pos)
{
	int crt, tmp;

	h[++h[0]] = pos;
    ind[pos] = h[0];

    crt = h[0];

    while(crt > 1 && (t[h[crt]] < t[h[crt / 2]] || (t[h[crt]] == t[h[crt / 2]] && a[h[crt]].x > a[h[crt / 2]].x)))
    {
    	tmp = h[crt];
        h[crt] = h[crt / 2];
        h[crt / 2] = tmp;

        ind[h[crt]] = crt;
        ind[h[crt / 2]] = crt / 2;

        crt /= 2;
    }
}

void del(int pos)
{
	int crt, tmp, min;

    tmp = h[ind[pos]];
    h[ind[pos]] = h[h[0]--];
    ind[h[ind[pos]]] = ind[pos];
    ind[tmp] = 0;

    crt = ind[pos];

    if (crt * 2 + 1 > h[0] || t[h[crt * 2]] < t[h[crt * 2 + 1]] || (t[h[crt * 2]] == t[h[crt * 2 + 1]] && a[h[crt * 2]].x > a[h[crt * 2 + 1]].x))
    	min = crt * 2;
    else
    	min = crt * 2 + 1;

    while(crt * 2 <= h[0] && (t[h[crt]] > t[h[min]] || (t[h[crt]] == t[h[min]] && a[h[crt]].x < a[h[min]].x)))
    {
    	tmp = h[crt];
        h[crt] = h[min];
        h[min] = tmp;

        ind[h[crt]] = crt;
        ind[h[min]] = min;

        crt = min;

	    if (crt * 2 + 1 > h[0] || t[h[crt * 2]] < t[h[crt * 2 + 1]])
    		min = crt * 2;
    	else
    		min = crt * 2 + 1;
    }
}

int main()
{
    int i, j, pos, tmp, x;

    freopen("puncte.in", "r", stdin);
    freopen("puncte.out", "w", stdout);

    scanf("%d%d", &n, &m);

    for (i = 1; i <= n; ++i)
    {
    	scanf("%d%d", &a[i].x, &a[i].y);
    	v[i] = i;
    }

    sort(v + 1, v + n + 1, cmp);

    for (i = 1; i <= n; ++i)
    	place[v[i]] = i;

    for (i = 1; i < n; ++i)
    {
        if (a[v[i]].x == a[v[i + 1]].x)
        	t[i] = -1;
        else
    		t[i] = (int)ceil(((double)a[v[i]].x * a[v[i]].x + a[v[i]].y * a[v[i]].y - a[v[i + 1]].x * a[v[i + 1]].x - a[v[i + 1]].y * a[v[i + 1]].y) / (2 * (a[v[i]].x - a[v[i + 1]].x)));

    	if (t[i] > 0)
        	ins(i);
    }
    
    for (i = 1; i <= m; ++i)
    {
    	scanf("%d", &x);

        while(h[0] && t[h[1]] <= x)
        {
        	pos = h[1];

            tmp = v[pos];
            v[pos] = v[pos + 1];
            v[pos + 1] = tmp;

            place[v[pos]] = pos;
            place[v[pos + 1]] = pos + 1;

            del(pos);

            if (ind[pos - 1])
	            del(pos - 1);

            if (ind[pos + 1])
	            del(pos + 1);

            for (j = pos - 1; j <= pos + 1; ++j)
            	if (a[v[j]].x == a[v[j + 1]].x)
                	t[j] = -1;
                else
		    		t[j] = (int)ceil(((double)a[v[j]].x * a[v[j]].x + a[v[j]].y * a[v[j]].y - a[v[j + 1]].x * a[v[j + 1]].x - a[v[j + 1]].y * a[v[j + 1]].y) / (2 * (a[v[j]].x - a[v[j + 1]].x)));

            if (t[pos - 1] > x)
            	ins(pos - 1);
                
        	if (t[pos + 1] > x)
            	ins(pos + 1);
        }

        aux.x = x;

        printf("%d\n", dist(a[v[1]], aux));
    }

	return 0;
}
