#include <stdio.h>
#include <memory.h>

const char iname[] = "munte.in";
const char oname[] = "munte.out";

int n;

int cnt[200][107][77];

int ans;

void f(int i, int j, int up) {
    if (i < 2 * n - 2) {
        f(i + 2, j, 0);
        f(i + 1, j + 1, j == 0);
        if (j > 0)
            if ((j == 1 && up == 1) == 0)
               f(i + 1, j - 1, 0);
    } else if (i == 2 * n - 2)
        if (j == 0)
            ans ++;
}

void add(int A[], const int B[]) {
    int i, tr = 0;
    for (i = 1; i <= A[0] || i <= B[0] || tr > 0; ++ i, tr /= 10)
        A[i] = (tr += A[i] + B[i]) % 10;
    A[0] = i - 1;
}

inline int update(const int i, const int j) {
    if (j == 0)
        add(cnt[i][j], cnt[i - 1][j + 1]);
    else if (j > 0) {
        add(cnt[i][j], cnt[i - 1][j + 1]);
        add(cnt[i][j], cnt[i - 1][j - 1]);
        if (i > 1)
            add(cnt[i][j], cnt[i - 2][j]);
    }
}

void solve(const int n) {
    cnt[0][0][0] = cnt[0][0][1] = 1;
    int lim = 2 * n - 2;
    for (int i = 1; i <= lim; ++ i) {
        update(i, 0);
        for (int j = 1; j <= n; ++ j)
            update(i, j);
    }
    for (int i = cnt[lim][0][0]; i > 0; -- i)
        printf("%d", cnt[lim][0][i]);
}

int main(void) {
    freopen(iname, "r", stdin);
    scanf("%d", & n);
    freopen(oname, "w", stdout);
    solve(n);
//  f(0, 0, 0), printf("\n%d", ans);
    return 0;
}
