#include <stdio.h>

const char iname[] = "promo.in";
const char oname[] = "promo.out";

#define MAX_N 1907

int G[MAX_N][MAX_N];

int M, K;

int cnt, P[MAX_N][2];


void read_in(void) {
    scanf("%d %d", & M, & K);
    int x, y;
    for (; K > 0; -- K) {
        scanf("%d %d", & x, & y);
        G[x][++ G[x][0]] = y;
        G[y][++ G[y][0]] = x;
    }
}

int Q[MAX_N], S[MAX_N], V[MAX_N], X[MAX_N];

void BF(const int nod) {
    int head, tail;
    P[nod][0] = (++ cnt), P[nod][1] = (++ cnt);
    head = tail = 0;
    S[nod] = 1;
    V[0]   = 0;
    for (int i = G[nod][0]; i > 0; -- i) {
        int x = G[nod][i];
        V[++ V[0]] = x, S[Q[tail ++] = x] = 1;
    }
    X[ V[1] ] = 1;
    for (int i = 1; i <= V[0]; ++ i) {
        int x = V[i];
        for (int j = G[x][0]; j > 0; -- j)
            X[ G[x][j] ] = X[x];
    }
    for (int i = 1; i <= V[0]; ++ i)
        P[ V[i] ][0] = P[nod][X[ V[i] ]];
    for (; head < tail; ++ head) {
        int x = Q[head];
        P[x][1] = (++ cnt);
        for (int i = G[x][0]; i > 0; -- i) {
            int y  = G[x][i];
            if (S[y])   continue ;
            P[y][0] = P[x][1];
            S[Q[tail ++] = y] = 1;
        }
    }
    for (int i = 1; i <= V[0]; ++ i)
        X[V[i]] = 0;
}

int main(void) {
    freopen(iname, "r", stdin);
    read_in();
    for (int i = 1; i <= M; ++ i)
        if (S[i] == 0)  BF(i);
    freopen(oname, "w", stdout);
    printf("%d\n", cnt);
    for (int i = 1; i <= M; ++ i)
        printf("%d %d\n", P[i][0], P[i][1]);
    return 0;
}
