#include <stdio.h>

const char iname[] = "role.in";
const char oname[] = "role.out";

#define MAX_N 100007

int R[MAX_N], I[MAX_N];

int n;

int E[MAX_N];  int P, stp;

inline int moves(int i, int R, int I) {
    if (i == R && I == 0)  return 0;
    if (i == R && I == 1)  return 3;
    if (i != R && I == 1)  return 1;
    if (i != R && I == 0)  return 2;
}

void read_in(void) {
    int cnt;
    scanf("%d", & n);
    for (int i = 1; i <= n; ++ i) {
        scanf("%d %d", R + i, I + i);
        E[R[i]] = i;
        stp += moves(i, R[i], I[i]);
    }
    for (int i = 0; i <= n; ++ i)
        if (E[i] == 0)   P = i;
}

#define shift(z, w) ((z) ^= (w) ^= (z) ^= (w))

int solve(void) {
    int ans = 0;
    for (; stp > 0; -- stp) {
        for (int i = 1; i <= n; ++ i)
            if (moves(i, R[i], I[i]) == moves(i, P, I[i] ^ 1) + 1) {
                printf("%d\n", R[i]);
                shift(R[i], P), I[i] ^= 1;
                break ;
            }
    }
}

int main(void) {
    freopen(iname, "r", stdin);
    read_in();
    freopen(oname, "w", stdout);
    solve();
    return 0;
}
