#include <stdio.h>
#include <algorithm>

#define inf 1000000000
#define nmax 60005
#define lmax 1000002

using namespace std;

int c[lmax],a[nmax];
int place[nmax],x[nmax],y[nmax],n,l,i,st[nmax];

int cmp(int i,int j) {
	if(x[i] > x[j]) return 0;
	else if(x[i] == x[j]) {
		if(y[i] < y[j]) return 0;
		else return 1;
	}
	else return 1;
}

int main() {
	freopen("cover.in","r",stdin);
	freopen("cover.out","w",stdout);

	scanf("%d%d",&n,&l);
	for(i = 1; i <= l; i++) scanf("%d",&c[i]);

	for(i = 1; i <= n; i++) {
		scanf("%d%d",&x[i],&y[i]);
		place[i] = i;
	}

	sort(place + 1,place + n + 1,cmp);
	st[0] = 0;
	for(i = 1; i <= n; i++) {
		while(st[0] > 0 && x[st[st[0]]] <= x[place[i]] && y[st[st[0]]] >= y[place[i]]) st[0]--;
		st[++st[0]] = place[i];
	}

	int ls = 0,ld = 0; 
	for(i = 1; i <= st[0]; i++) a[i] = inf;
	for(i = 1; i <= l; i++) {
		while(ls + 1 <= st[0] && x[st[ls + 1]] <= i) ls++;
		while(ld + 1 <= st[0] && y[st[ld + 1]] < i) ld++;
		if(ls != 0) a[ls] = min(a[ls],a[ld] + c[i]);
	}

	printf("%d\n",a[st[0]]);

	return 0;
}
