#include <stdio.h>
#include <algorithm>
#include <vector>

#define nmax 2010
#define gmax 4020
#define pb push_back

using namespace std;

vector <int> grupe[gmax],e[nmax];
int x1,y1,m,k,grp,v1[nmax],v2[nmax];

int vecin(int x,int y) {
	int fi = 0,la = e[x].size() - 1;
	while(fi <= la) {
		int mi = (fi + la) / 2;
		if(e[x][mi] == y) return 1;
		else if(e[x][mi] > y) la = mi - 1;
		else fi = mi + 1;
	}
	return 0;
}

int main() {
	freopen("promo.in","r",stdin);
	freopen("promo.out","w",stdout);

	scanf("%d%d",&m,&k);
	for(int i = 1; i <= k; i++) {
		scanf("%d%d",&x1,&y1);
		e[x1].pb(y1);
		e[y1].pb(x1);
	}
	
	for(int i = 1; i <= m; i++) sort(e[i].begin(),e[i].end());
	
	grp = 0;
	for(int i = 1; i <= m; i++) {
		int ngrup = 1;
		for(int j = 1; j <= grp; j++) {
			int sepotriv = 1;
			for(int k = 0; k < (int)grupe[j].size(); k++)
				if(!vecin(i,grupe[j][k])) {
					sepotriv = 0;
					break;
				}
			if(sepotriv == 1) {
				grupe[j].pb(i);
				ngrup = 0;
			}
		}
		if(ngrup) grupe[++grp].pb(i);
	}

	for(int i = 1; i <= m; i++) 
		for(int j = 1; j <= grp; j++) {
			int sepotriv = 1;
			for(int k = 0; k < (int)grupe[j].size(); k++)
				if(vecin(i,grupe[j][k]) == 0) {
					sepotriv = 0;
					break;
				}
			if(sepotriv == 1) grupe[j].pb(i);
		}

	int crt = 0;
	for(int i = 1; i <= grp; i++) {
		crt++;
		for(int j = 0; j < (int)grupe[i].size(); j++) 
			if(v1[grupe[i][j]] == 0) v1[grupe[i][j]] = crt;
			else v2[grupe[i][j]] = crt;
	}

	for(int i = 1; i <= m; i++) {
		if(v1[i] == 0) v1[i] = ++crt;
		if(v2[i] == 0) v2[i] = ++crt;
	}

	for(int i = 1; i <= m; i++) printf("%d %d\n",v1[i],v2[i]);

	return 0;
}
