#include <stdio.h>
#define FOR(i, a, b) for (i = (a); i <= (b); i++)
#define MaxN 60033
#define MaxL 1000033
struct seg {
    int left, right;
} S[MaxN];

int N, L, C[MaxN], CMin[MaxN];
int sel[MaxL], p[MaxN];
void quick(int lf, int rt)
{
    int i = lf - 1, j = rt + 1;
    if (lf >= rt) return;
    do
    {
        do { i++; } while (S[lf].right > S[i].right);
        do { j--; } while (S[lf].right < S[j].right);
        if (i < j)
        {
            seg aux = S[i]; S[i] = S[j]; S[j] = aux;
        }
    } while (i < j);
    quick(lf, j);
    quick(j + 1, rt);
}
int fmin(int lf, int rt)
{
    if (lf > rt) return -1;
    int min_val = C[lf], pos = lf, i;
    FOR (i, lf, rt)
        if (min_val > C[i]) min_val = C[i], pos = i;
    return pos;
}

int main()
{
    int i, j;
    
    FILE *fin = fopen("cover.in", "rt");
    FILE *fout= fopen("cover.out", "wt");

    fscanf(fin, "%d %d", &N, &L);
    FOR (i, 1, L)
        fscanf(fin, "%d", &C[i]);
    FOR (i, 1, N)
        fscanf(fin, "%d %d", &S[i].left, &S[i].right);

    quick(1, N);

    int pos1, pos2;
    
    CMin[1] = C[pos1 = fmin(S[1].left, S[1].right)];
    CMin[2] = CMin[1] + C[pos2 = fmin(S[2].left, S[2].right)];

    p[1] = pos1, p[2] = pos2;
    //sel[pos1] = sel[pos2] = 1;
    if (S[1].right >= S[2].left)
    {
        int p1 = fmin(S[2].left, S[1].right);
        if (CMin[2] > C[p1])
        {
            CMin[2] = C[p1];
            p[1] = p[2] = p1;
        }
    }
    
    FOR (i, 3, N)
        CMin[i] = CMin[i-1] + C[fmin(S[i].left, S[i].right)];

    fprintf(fout, "%d\n", CMin[N]);
    /*FOR (i, 1, N)
        fprintf(fout, "%d %d\n", S[i].left, S[i].right);*/

    fclose(fin);
    fclose(fout);

    return 0;
}
    
    
