#include <stdio.h>

int n, m;
short int min[2100000];
int i, j, k, l, h;
int x[60001], y[60001];
int c1[60001], c2[60001];
int d[60001];
int nmin, nmax, xc, yc;

void Sort(int st, int dr);
void Update(int nod, int st, int dr);
void Query(int nod, int st, int dr);

int main()
{
	freopen("cover.in", "r", stdin);
	freopen("cover.out", "w", stdout);
	scanf("%d %d", &n, &m);
	for ( i = 1; i <= m; i++ )
		scanf("%d", &j), nmax += j,
		Update(1, 1, m);
	for ( i = 1; i <= n; i++ )
		scanf("%d %d", &x[i], &y[i]);
	Sort(1, n);

	for ( i = 1; i <= n; i++ ) d[i] = nmax;
	for ( i = 1; i <= n; i++ )
	{
		xc = x[i], yc = y[i];
		for ( j = i; j >= 1; j-- )
		{
			yc = yc < y[j] ? yc : y[j];
			xc = xc > x[j] ? xc : x[j];
			if ( xc > yc ) break;
			nmin = nmax;
			Query(1, 1, m);
			if ( d[i] > d[j-1] + nmin )
				d[i] = d[j-1] + nmin;
		}
	}
	printf("%d\n", d[n]);


	return 0;

}

void Sort(int st, int dr)
{
	if ( st == dr ) return;
	int mij = (st+dr)/2;
	Sort(st, mij), Sort(mij+1, dr);
	k = 0, i = st, j = mij+1;
	while ( i <= mij || j <= dr )
	{
		if ( j > dr || (i <= mij && (x[i] < x[j] || (x[i] == x[j] &&
			y[i] < y[j]) ) ) )
				k++, c1[k] = x[i], c2[k] = y[i], i++;
		else
			k++, c1[k] = x[j], c2[k] = y[j], j++;
	}

	for ( h = 1; h <= k; h++ )
		x[st+h-1] = c1[h],
		y[st+h-1] = c2[h];
}

void Update(int nod, int st, int dr)
{
	if ( st == dr )
	{
		min[nod] = j;
		return;
	}
	int mij = (st+dr)/2;
	if ( i <= mij ) Update(2*nod, st, mij);
	if ( mij+1 <= i ) Update(2*nod+1, mij+1, dr);
	min[nod] = min[2*nod] > min[2*nod+1] ? min[2*nod+1] : min[2*nod];
}

void Query(int nod, int st, int dr)
{
	if ( xc <= st && dr <= yc )
	{
		if ( min[nod] < nmin ) nmin = min[nod];
		return;
	}
	int mij = (st+dr)/2;
	if ( xc <= mij ) Query(2*nod, st, mij);
	if ( mij+1 <= yc) Query(2*nod+1, mij+1, dr);
}

