#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define MAX    2005
#define NCUVS  505
#define CUVLEN 25
#define INF    0x3f3f


int d[NCUVS][CUVLEN], e[NCUVS][CUVLEN];
int nx[NCUVS], c[NCUVS][CUVLEN];
char a[MAX], b[MAX], *x[NCUVS], y[NCUVS];


int abs(char aa) {
if (aa>0) return int(aa);
return int(-aa); }


void update(int j, int k, int z) {
if (e[j][k]>z) e[j][k]=z; }


int main() {
int la, lb, lx, ly, i, j, k, s;

freopen("dist.in", "r", stdin);
freopen("dist.out", "w", stdout);

fgets(a, MAX, stdin);
fgets(b, MAX, stdin);
la=strlen(a);
lb=strlen(b);
a[la-1]=' ';
b[lb-1]=' ';

lx=0;
i=0;
while (i<la) {
  while (a[i]!=' ') { nx[lx]++; i++; }
  lx++;
  while (a[i]==' ') i++; }

for (i=0;i<lx;i++) { nx[i]++; x[i]=(char*)malloc(sizeof(char)*nx[i]); x[i][nx[i]-1]=0; }

lx=0;
i=0;
while (i<la) {
  nx[lx]=0;
  while (a[i]!=' ') { x[lx][nx[lx]++]=a[i]; i++; }
  lx++;
  while (a[i]==' ') i++; }

ly=0;
for (i=0;i<lb;i++)
  if (b[i]!=' ')
    y[ly++]=b[i];

for (i=0;i<lx;i++) {
  for (j=nx[i]-1;j>0;j--)
    c[i][j-1]=c[i][j]+x[i][j]-'@'; }

for (j=0;j<lx;j++)
  for (k=0;k<20;k++)
    d[j][k]=e[j][k]=INF;
d[0][0]=abs(x[0][0]-y[0]);

for (i=0;i<ly;i++) {
  for (j=0;j<lx;j++)
    for (k=0;k<20;k++)
      if (k<nx[j]) {
	update(j, k+1, d[j][k]+abs(y[i+1]-x[j][k+1]));
	update(j+1, 0, d[j][k]+abs(y[i+1]-x[j+1][0])+c[j][k]); }
      else {
	update(j, k+1, d[j][k]+y[i]-'@');
	update(j+1, 0, d[j][k]+abs(y[i+1]-x[j+1][0])); }
  for (j=0;j<lx;j++)
    for (k=0;k<20;k++) {
      d[j][k]=e[j][k];
      e[j][k]=INF; } }


s=INF;
for (i=0;i<lx;i++)
  for (j=0;j<20;j++)
    if (s>d[i][j])
      s=d[i][j];

printf("%d 0\n", s);

return 0;
}

