#include <cstdio>
#include <vector>
#define NMAX 4040

using namespace std;

vector<int> A[NMAX];
int N, M, K, G[NMAX], Muc[2][NMAX], F[NMAX];

void dfs(int nod)
{
        int i, x;

        F[nod] = 1;
        Muc[0][nod] = N;

        for (i = 0; i < G[nod]; i++)
            if (F[ A[nod][i] ] == 0)
            {
                x = A[nod][i];
                dfs( x );
            }

}

int main()
{
        int i, j, k;

        freopen("promo.in", "r", stdin);
        scanf("%d %d", &M, &K);

        for (k = 0; k < K; k++)
        {
                scanf("%d %d", &i, &j);
                A[i].push_back(j); A[j].push_back(i);
                G[i]++; G[j]++;
        }

        for (i = 1; i <= M; i++)
                if (F[i] == 0)
                {
                        N++;
                        dfs(i);
                }

        for (i = 1; i <= M; i++) Muc[1][i] = ++N;

        freopen("promo.out", "w", stdout);
        printf("%d\n", N);
        for (i = 1; i <= M; i++) printf("%d %d\n", Muc[0][i], Muc[1][i]);

        return 0;
        
}

