#include <stdio.h>

#define Nmax 100001
#define Mmax 200001
#define inf 666666666
int n,m,x[Nmax],y[Nmax],h[Mmax],p[Mmax],dist[Mmax],dist2[Mmax],d;

void qSort(int st, int dr)
{
   int i=st, j=dr, m=p[(st+dr)/2];
   do{
      while (p[i]<m) i++;
      while (p[j]>m) j--;
      if (i<=j)
        {
           int aux=p[i]; p[i]=p[j]; p[j]=aux;
               aux=h[i]; h[i]=h[j]; h[j]=aux;
               i++; j--;
        }
     }while(i<=j);
   if (st<j) qSort(st,j);
   if (i<dr) qSort(i,dr);
}

void qSort2(int st, int dr)
{
   int i=st, j=dr, m=h[(st+dr)/2];
   do{
      while (h[i]<m) i++;
      while (h[j]>m) j--;
      if (i<=j)
        {
           int aux=dist[i]; dist[i]=dist[j]; dist[j]=aux;
               aux=h[i]; h[i]=h[j]; h[j]=aux;
               i++; j--;
        }
     }while(i<=j);
   if (st<j) qSort2(st,j);
   if (i<dr) qSort2(i,dr);
}

int main()
{
   freopen("puncte.in","r",stdin);
   freopen("puncte.out","w",stdout);
   scanf("%d %d",&n,&m);
   int k=-1;
   for (int i=0;i<n;i++)
      {
         scanf("%d %d",&x[k+1],&y[k+1]);
         if (k>=0 && x[k+1]==x[k] && y[k+1]>=y[k]) continue;
         k++;
      }
   for (int i=0;i<m;i++) { scanf("%d",&p[i]); h[i]=i; }
   qSort(0,m-1);

   d=inf;
   for (int i=0;x[i]<=p[0];i++)
      {
         int aux=(p[0]-x[i])*(p[0]-x[i])+y[i]*y[i];
         if (aux<d) d=aux, dist[0]=i;
      }
   for (int k=1;k<m;k++)
      if (p[k]==p[k-1]) dist[k]=dist[k-1];
      else {
              d=inf;
              for (int i=dist[k-1];x[i]<=p[k];i++)
                 {
                    int aux=(p[k]-x[i])*(p[k]-x[i])+y[i]*y[i];
                    if (aux<d) d=aux, dist[k]=i;
                  }
           }

   d=inf;
   for (int i=n-1;x[i]>p[m-1];i--)
      {
         int aux=(p[m-1]-x[i])*(p[m-1]-x[i])+y[i]*y[i];
         if (aux<d) d=aux, dist2[m-1]=i;
      }
   for (int k=m-2;k>=0;k--)
      if (p[k]==p[k+1]) dist2[k]=dist2[k+1];
      else {
              d=inf;
              for (int i=dist[k+1];x[i]>p[k];i--)
                 {
                    int aux=(p[k]-x[i])*(p[k]-x[i])+y[i]*y[i];
                    if (aux<d) d=aux, dist2[k]=i;
                  }
           }

   for (k=0;k<m;k++)
      {
         int i=dist[i];
         d=(p[k]-x[i])*(p[k]-x[i])+y[i]*y[i];
         i=dist2[i];
         int aux=(p[k]-x[i])*(p[k]-x[i])+y[i]*y[i];
         if (aux<d) dist[k]=aux;
         else dist[k]=d;
      }
   qSort(0,m-1);
   for (int i=0;i<m;i++)
      printf("%d\n",dist[i]);

   fclose(stdout);
   return 0;
}
