#include <cstdio>
#include <algorithm>

using namespace std;

#define x first
#define y second

#define inf 2000000000 //doua miliarde
#define Nmax 60005
#define Mmax 1000005

int n, m;
int cost[Mmax], rez[Mmax];
pair<int, int> v[Nmax];
int Q[Mmax], qe, qb;

void readdata()
{
	freopen("cover.in", "r", stdin);
    freopen("cover.out", "w", stdout);

    int i;

    scanf("%d %d", &n, &m);
    for (i = 1; i <= m; ++i)
    	scanf("%d", &cost[i]);
    for (i = 1; i <= n; ++i)
    	scanf("%d %d", &v[i].x, &v[i].y);
}

int cmp(pair<int, int> a, pair<int, int> b)
{
	if (a.y < b.y) return 1;
    if (a.y == b.y && a.x < b.x) return 1;
    return 0;
}

inline int min(int a, int b)
{ return (a < b ? a : b); }

inline int max(int a, int b)
{ return (a > b ? a : b); }

void solve()
{
	int i, j, dr, best, ind;

	sort(v+1, v+n+1, cmp);

    Q[qb = qe = 1] = 0;
    j = 0;
    dr = 0;
    ind = 0;
    for (i = 1; i <= n; ++i)
    {
    	if (j < v[i].x) j = v[i].x;

        for (; j <= v[i].y; ++j)
        {
            while (v[ind+1].y < j)
            {
            	++ind;
                dr = max(dr, v[ind].x);
            }

            while (Q[qb] < dr) ++qb;
        
	        rez[j] = rez[ Q[qb] ] + cost[j];
            while (qe >= qb && rez[j] <= rez[ Q[qe] ]) --qe;
            Q[++qe] = j;
        }
    }

    dr = 0;
    for (i = 1; i <= n; ++i)
    	dr = max(dr, v[i].x);

    best = inf;
    for (i = dr; i <= v[n].y; ++i)
    	best = min(best, rez[i]);

    printf("%d\n", best);
}

int main()
{
	readdata();
    solve();
	return 0;
}
