#include <stdio.h>
#include <stdlib.h>

#define infile "promo.in"
#define outfile "promo.out"
#define MCHMAX 2010
#define KMAX 100005
#define LEFT true
#define RIGHT false
struct NOD {short int x; NOD *adr;};
struct mchstruct {NOD *left,*right;};
struct muchie {short int u,v; bool diru,dirv;};

FILE *fin,*fout;
int M,K;
bool C[MCHMAX][MCHMAX];
mchstruct *S[MCHMAX];
muchie mch[KMAX];
short int label[2][MCHMAX];
int nextlabel=0;

inline void adaug_st(NOD *(&prim), short int x)
  {
   NOD *a=new NOD;
   a->x=x;
   a->adr=prim;
   prim=a;
  }

void read_data()
  {
   int i,j,u,v;
   fin=fopen(infile,"r");
   fscanf(fin,"%d %d",&M,&K);
   for(i=0;i<M;i++)
      for(j=0;j<M;j++)
         C[i][j]=false;
   for(i=0;i<K;i++)
      {
       fscanf(fin,"%d %d",&u,&v);
       C[u-1][v-1]=C[v-1][u-1]=true;
       mch[i].u=u-1;
       mch[i].v=v-1;
      }
   fclose(fin);
  }

void init()
  {
   for(int i=0;i<M;i++)
      {
       S[i]=new mchstruct;
       S[i]->left=S[i]->right=NULL;
      }
  }

bool leg(NOD *prim, int varf)
  {
   NOD *b=prim;
   while(b)
        {
         if(!C[b->x][varf])
           return false;
         b=b->adr;
        }
   return true;
  }

bool introdu(mchstruct *S, short int varf)
  {
   if(S->left==NULL)
     if(S->right==NULL)
       {adaug_st(S->left,varf);
        return LEFT;}
     else
       if(leg(S->right,varf))
         {adaug_st(S->right,varf);
          return RIGHT;}
       else
         {adaug_st(S->left,varf);
          return LEFT;}
   else
     if(leg(S->left,varf))
       {adaug_st(S->left,varf);
        return LEFT;}
     else
       {adaug_st(S->right,varf);
        return RIGHT;}
  }

void solve()
  {
   int i,u,v; bool diru,dirv;
   for(i=0;i<K;i++)
      {
       mch[i].dirv=introdu(S[mch[i].u],mch[i].v);
       mch[i].diru=introdu(S[mch[i].v],mch[i].u);
      }
   for(i=0;i<M;i++)
      label[0][i]=label[1][i]=-1;
   for(i=0;i<K;i++)
      {
       u=mch[i].u;
       v=mch[i].v;
       diru=mch[i].diru;
       dirv=mch[i].dirv;
       if(label[diru][v]==-1)
         if(label[dirv][u]==-1)
           {
            ++nextlabel;
            label[diru][v]=label[dirv][u]=nextlabel;
           }
         else
           label[diru][v]=label[dirv][u];
       else
         if(label[dirv][u]==-1)
           label[dirv][u]=label[diru][v];
//         else
//           if(label[diru][v]!=label[dirv][u])
//             exit(1);
      }
   for(i=0;i<M;i++)
      {
       if(label[0][i]==-1)
         label[0][i]=++nextlabel;
       if(label[1][i]==-1)
         label[1][i]=++nextlabel;
      }
  }


int main()
{
read_data();
init();
solve();
fout=fopen(outfile,"w");
fprintf(fout,"%d\n",nextlabel);
for(int i=0;i<M;i++)
   fprintf(fout,"%d %d\n",label[0][i],label[1][i]);
fclose(fout);
return 0;
}
