#include <stdio.h>
#define input "cover.in"
#define output "cover.out"
#define nmax 60001
#define lmax 1000001
long n,l,i,l1,l2,pz;
long c[lmax];
long st[nmax],dr[nmax],s1[nmax],s2[nmax],d1[nmax],d2[nmax],cnt[nmax];
void citire()
{
 FILE *fin;
 fin=fopen(input,"r");
 fscanf(fin,"%ld %ld",&n,&l);
 for (i=1;i<=l;i++)
     fscanf(fin,"%ld",&c[i]);
 for (i=1;i<=n;i++)
     fscanf(fin,"%ld %ld",&st[i],&dr[i]);
 fclose(fin);
}
void merge(long ls, long ld)
{
 if (ls<ld)
    {
     long k=(ls+ld)/2,i,j;
     merge(ls,k);
     merge(k+1,ld);
     l1=0;
     for (i=ls;i<=k;i++)
	 {
	 s1[++l1]=st[i];
	 d1[l1]=dr[i];
	 }
     l2=0;
     for (i=k+1;i<=ld;i++)
	 {
	 s2[++l2]=dr[i];
	 d2[l2]=dr[i];
	 }
     i=1;
     j=1;
     k=ls;
     while (i<=l1 && j<=l2)
	   {
	    if ((s1[i]<s2[j])||(s1[i]==s2[j] && d1[i]>d2[j]))
	       {
		st[k]=s1[i];
		dr[k]=d1[i];
		i++;
	       }
	       else
	       {
		st[k]=s2[j];
		dr[k]=d2[j];
		j++;
	       }
	    k++;
	   }
    }
}
long min(long ls, long ld)
{
 long i;
 long minim=1025;
 for (i=ls;i<=ld;i++)
     if (minim>cnt[i]) minim=cnt[i];
 return minim;
}
long cover(long x)
{
 long j;
 for (j=1;j<=n;j++)
     if (st[j]<=x && dr[j]>=x) return j;
 return 0;
}
long search(long pz, long x)
{
 long j;
 for (j=pz;j<=n;j++)
     if (x<st[j] || x>dr[j])
	{
	 return min(st[j],dr[j]);
	}
 return 0;
}
void solve()
{
 merge(1,n);
 for (i=l;i>0;i--)
     {
      pz=cover(i);
      cnt[i]=search(pz,i)+c[i];
     }
}
void afisare()
{
 FILE *fout;
 fout=fopen(output,"w");
 fprintf(fout,"%ld",min(st[1],dr[1]));
 fclose(fout);
}
int main()
{
 citire();
 solve();
 afisare();
 return 0;
}