#include <cstdio>
#include <cstring>
using namespace std;

const int LMAX = 100;
const int BASE = 1000;

class nmare {
	public:
	int v[LMAX];
	nmare() {
		memset(v, 0, sizeof(v));
	}
	void add(nmare b) {
		int i, t = 0;
		for (i = 1; i <= v[0] || i <= b.v[0] || t; ++i, t/= BASE) {
			v[i] = (t += v[i] + b.v[i]) % BASE;
		}
		v[0] = i - 1;
	}

	void print(FILE *fout) {
		fprintf (fout, "%d", v[v[0]]);
		int i;
		for (i = v[0] - 1; i > 0; --i) {
			if (v[i] < 100) fprintf (fout, "0");
			if (v[i] < 10) fprintf (fout, "0");
			fprintf (fout, "%d", v[i]);
		}
		fprintf (fout, "\n");
	}
}mat[205][101]; 

int main() {
	FILE *fin = fopen ("munte.in", "r");
	FILE *fout = fopen ("munte.out", "w");
	int n, l, i, j;
	fscanf (fin, "%d", &n);
	l = 2 * n - 2;
	mat[0][0].v[0] = 1;
	mat[0][0].v[1] = 1;
	for (i = 0; i < l; ++i) {
		mat[i + 2][0].add(mat[i][0]); //Orizontal
		mat[i + 2][2].add(mat[i][0]); //Sus - sus
		mat[i + 3][1].add(mat[i][0]); //Sus - orizontal
		for (j = 1; j <= i; ++j) {
			mat[i + 2][j].add(mat[i][j]); //Orizontal
			mat[i + 1][j + 1].add(mat[i][j]); //In sus
			mat[i + 1][j - 1].add(mat[i][j]); //In jos
		}
	}
	
// 	printf ("%d\n", mat[l][0].v[0]);
	mat[l][0].print(fout);
	fclose(fout);
	return 0;
}
