#include<stdio.h>

#include<vector>
#include<bitset>
using namespace std;

#define pb push_back
#define vi vector<int>
#define pii pair<int, int>
#define f first
#define s second

const int MAXM = 2012;
const int MAXK = 100008;

vi ladm[MAXM]; // MAXK*2 size
bitset<MAXM> madn[MAXM*2]; // 2*MAXM*MAXM size
bitset<MAXM> madm[MAXM]; // MAXM*MAXM size
int m, k;

pii a[MAXM]; // MAXM*2 size
int nextn = 1;

void link(int e1, int x, int e2, int y)
{
    int q = (y==1) ? a[e2].f : a[e2].s;
    if (q)
    {
        if (x==1)
            a[e1].f = q;
        else
            a[e1].s = q;
        madn[q].set(e1);
    }
    else
    {
        if (x==1)
            a[e1].f = nextn;
        else
            a[e1].s = nextn;
        if (y==1)
            a[e2].f = nextn;
        else
            a[e2].s = nextn;
        madn[nextn].set(e1);
        madn[nextn].set(e2);
        ++nextn;
    }
}

void uneste(int e1, int x, int e2)
{
    if (!a[e2].f)
        link(e1, x, e2, 1);
    else
    {
        int q = a[e2].f;
        if ((madn[q] & (~madm[e1])).none()) // cool
            link(e1, x, e2, 1);
        else
            link(e1, x, e2, 2);
    }
}

int main(void)
{
    freopen("promo.in", "rt", stdin);
    freopen("promo.out", "wt", stdout);

    scanf("%d%d", &m, &k);
    for (int i=0; i<k; ++i)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        ladm[a].pb(b);
        ladm[b].pb(a);
        madm[a].set(b);
        madm[b].set(a);        
    }

    for (int i=2; i<m+1; ++i)
    {
        for (int j=ladm[i].size()-1; j+1; --j)
        {
            int v = ladm[i][j], q;
            if (v<i)
            {
                if (a[i].f)
                {
                    q = a[i].f;
                    if (a[v].f != q && a[v].s != q)
                        uneste(i, 2, v);
                }
                else
                    uneste(i, 1, v);
            }
        }
    }

    for (int i=1; i<m+1; ++i)
    {
        if (!a[i].f) a[i].f = nextn++;
        if (!a[i].s) a[i].s = nextn++;
    }

    printf("%d\n", nextn-1);
    for (int i=1; i<m+1; ++i)
        printf("%d %d\n", a[i].f, a[i].s);
    
    return 0;
}

