#include<stdio.h>
#include<math.h>
#include<stdlib.h>

#include<algorithm>
using namespace std;

#define pii pair<int, int>
#define x first
#define y second

const int MAXN = 100004;
const int MAXM = 200004;
const double INF = tan(M_PI_2);

int n, m;
pii p[MAXN];

long long sqr(const long long a)
{
    return (long long) a*a;
}

long long distx(const pii a, const int b)
{
    return (long long) sqr(abs(b-a.x)) + sqr(a.y);
}

int main(void)
{
    freopen("puncte.in", "rt", stdin);
    freopen("puncte.out", "wt", stdout);

    scanf("%d%d", &n, &m);
    
    for (int i=0; i<n; ++i)
        scanf("%d%d", &p[i].x, &p[i].y);

    for (int i=0, q=0; i<m; ++i)
    {
        scanf("%d", &q);

        long long min = distx(p[0], q);
        for (int j=1; j<n; ++j)
            if (min > distx(p[j], q))
                min = distx(p[j], q);
        printf("%Ld\n", min);
    }
    
    return 0;
}
