#include <stdio.h>
#include <stdlib.h>

// i = points, j = ref
#define DIST(i,j) ((points[(i)].x-ref[(j)].x)*(points[(i)].x-ref[(j)].x)+points[(i)].y*points[(i)].y)

struct {
	int x;
	int y;
} points[100000];


struct __ref {
	int x;
	long long mindist;
} ref[200000];

int refcmp (const struct __ref *a, const struct __ref *b) {
	return a->x-b->x;
}

// 3 in 1!!!
long long reord[67000];
#define SET(i,val) (reord[(i)/3] |= (((long long)(val)&0xfffff)<<(((i)%3)*20)))
#define GET(i) (int)((reord[(i)/3]>>(((i)%3)*20))&0xfffff)

int main () {
	int m;
	int i;
	// current point
	int c;
	int bc;
	long long odist;
	long long bdist;
	int n;

	FILE *in, *out;
	
	in = fopen ("puncte.in", "r");
	out = fopen ("puncte.out", "w");

	fscanf (in, "%d %d", &n, &m);
	for (i=0;i<n;i++) {
		fscanf (in, "%d %d", &points[i].x, &points[i].y);
		if (i > 0 && points[i].x == points[i-1].x) {
			i--;
			n--;
		}
	}

	for (i=0;i<m;i++) {
		fscanf (in, "%d", &ref[i].x);
		ref[i].mindist = i;
	}

	qsort (ref, m, sizeof (struct __ref), (int (*)(const void*,const void*))refcmp);
	//reord[(int)ref[0].mindist] = 0;
	SET((int)ref[0].mindist,0);
	ref[0].mindist = DIST(0, 0);
	c = 0;
	for (i=1;i<n;i++) {
		odist = DIST(i, 0);
		if (odist <= ref[0].mindist) {
			ref[0].mindist = odist;
			c = i;
		}
	}
	for (i=1;i<m;i++) {
		//reord[(int)ref[i].mindist] = i;
		SET((int)ref[i].mindist, i);
		bc = c;
		ref[i].mindist = DIST(c, i);
		while (points[++c].x < ref[i].x && c < n) {
			odist = DIST(c, i);
			if (odist <= ref[i].mindist) {
				bc = c;
				ref[i].mindist = odist;
			}
		}
		c = bc;
	}

	bdist = DIST (0, m-1);
	c = 0;
	for (i=1;i<n;i++) {
		odist = DIST(i, m-1);
		if (odist <= bdist) {
			bdist = odist;
			c = i;
		}
	}
	if (bdist < ref[m-1].mindist) {
		ref[m-1].mindist = bdist;
	}
	for (i=m-2;i>=0;i--) {
		bc = c;
		bdist = DIST(c, i);
		while (points[--c].x >= ref[i].x && c >= 0) {
			odist = DIST(c, i);
			if (odist <= bdist) {
				bc = c;
				bdist = odist;
			}
		}
		c = bc;
		if (bdist < ref[i].mindist) {
			ref[i].mindist = bdist;
		}
	}

	for (i=0;i<m;i++) {
		fprintf (out, "%lld\n", ref[GET(i)].mindist);
	}

	fclose (in);
	fclose (out);

	return 0;
}
