#include <stdio.h>

struct {
	int rola;
	char form;
} benzi[100001];
struct {
	int banda;
} role[100001];
int n;

FILE *in, *out;

int main () {
	int i;
	int r;

	in = fopen ("role.in", "r");
	out = fopen ("role.out", "w");

	fscanf (in, "%d", &n);
	memset (role, -1, (n+1)*sizeof (role[0]));
	for (i=1;i<=n;i++) {
		fscanf (in, "%d %d", &benzi[i].rola, &r);
		benzi[i].form = r;
		role[benzi[i].rola].banda = i;
	}
	for (i=0;i<=n;i++) {
		if (role[i].banda == -1) {
			benzi[0].rola = i;
		}
	}

/*	for (i=0;i<=n;i++) {
		printf ("%d %d %d\n", i, benzi[i].rola, (int)benzi[i].form);
	}*/

	// pentru fiecare banda
	for (i=1;i<=n;i++) {
		// rola ei e goala
		if (role[i].banda == 0) {
			// si poate fi pusa direct
			if (benzi[i].form == 1) {
				fprintf (out, "%d\n", benzi[i].rola);
				benzi[0].rola = benzi[i].rola;
				role[benzi[0].rola].banda = 0;
				benzi[i].rola = i;
				role[i].banda = i;
				benzi[i].form = 0;
			}
			else {
				// mutam banda i+1 cu banda 0
				if (i == n) {
					fprintf (out, "Sorry.\n");
					return 0;
				}
				fprintf (out, "%d\n", benzi[i+1].rola);
				benzi[0].rola = benzi[i+1].rola;
				role[benzi[0].rola].banda = 0;
				benzi[i+1].rola = i;
				role[benzi[i+1].rola].banda = i+1;
				benzi[i+1].form ^= 1;
				// mutam banda i cu banda 0
				fprintf (out, "%d\n", benzi[i].rola);
				r = benzi[0].rola;
				benzi[0].rola = benzi[i].rola;
				benzi[i].rola = r;
				role[benzi[0].rola].banda = 0;
				role[benzi[i].rola].banda = i;
				benzi[i].form = 1;
				// facem rola i goala (rola i e pe i+1)
				fprintf (out, "%d\n", benzi[i+1].rola);
				benzi[i+1].rola = benzi[0].rola;
				benzi[0].rola = i;
				role[benzi[0].rola].banda = 0;
				role[benzi[i+1].rola].banda = i+1;
				benzi[i+1].form ^= 1;
				// acum putem sa terminam cu banda i 
				fprintf (out, "%d\n", benzi[i].rola);
				benzi[0].rola = benzi[i].rola;
				role[benzi[0].rola].banda = 0;
				benzi[i].rola = i;
				role[i].banda = i;
				benzi[i].form = 0;
			}
		}
		// daca nu, o facem
		else {
			if (role[i].banda == i) {
				if (benzi[i].form == 0) continue;
				// inlocuim cu banda 0
				fprintf (out, "%d\n", benzi[i].rola);
				benzi[i].rola = benzi[0].rola;
				benzi[0].rola = i;
				role[benzi[i].rola].banda = i;
				role[benzi[0].rola].banda = 0;
				benzi[i].form = 1;
				// si din nou ne jucam
				// mutam banda i+1 cu banda 0
				if (i == n) {
					fprintf (out, "Sorry.\n");
					return 0;
				}
				fprintf (out, "%d\n", benzi[i+1].rola);
				benzi[0].rola = benzi[i+1].rola;
				role[benzi[0].rola].banda = 0;
				benzi[i+1].rola = i;
				role[benzi[i+1].rola].banda = i+1;
				benzi[i+1].form ^= 1;
				// mutam banda i cu banda 0
				fprintf (out, "%d\n", benzi[i].rola);
				r = benzi[0].rola;
				benzi[0].rola = benzi[i].rola;
				benzi[i].rola = r;
				role[benzi[0].rola].banda = 0;
				role[benzi[i].rola].banda = i;
				benzi[i].form = 1;
				// facem rola i goala (rola i e pe i+1)
				fprintf (out, "%d\n", benzi[i+1].rola);
				benzi[i+1].rola = benzi[0].rola;
				benzi[0].rola = i;
				role[benzi[0].rola].banda = 0;
				role[benzi[i+1].rola].banda = i+1;
				benzi[i+1].form ^= 1;
				// acum putem sa terminam cu banda i 
				fprintf (out, "%d\n", benzi[i].rola);
				benzi[0].rola = benzi[i].rola;
				role[benzi[0].rola].banda = 0;
				benzi[i].rola = i;
				role[i].banda = i;
				benzi[i].form = 0;
			}
			// mutam banda 0 cu banda role[i].banda
			fprintf (out, "%d\n", i);
			benzi[role[i].banda].rola = benzi[0].rola;
			benzi[role[i].banda].form ^= 1;
			benzi[0].rola = i;
			role[benzi[role[i].banda].rola].banda = role[i].banda;
			role[i].banda = 0;
			// si poate fi pusa direct
			if (benzi[i].form == 1) {
				fprintf (out, "%d\n", benzi[i].rola);
				benzi[0].rola = benzi[i].rola;
				role[benzi[0].rola].banda = 0;
				benzi[i].rola = i;
				role[i].banda = i;
				benzi[i].form = 0;
			}
			else {
				// mutam banda i+1 cu banda 0
				if (i == n) {
					fprintf (out, "Sorry.\n");
					return 0;
				}
				fprintf (out, "%d\n", benzi[i+1].rola);
				benzi[0].rola = benzi[i+1].rola;
				role[benzi[0].rola].banda = 0;
				benzi[i+1].rola = i;
				role[benzi[i+1].rola].banda = i+1;
				benzi[i+1].form ^= 1;
				// mutam banda i cu banda 0
				fprintf (out, "%d\n", benzi[i].rola);
				r = benzi[0].rola;
				benzi[0].rola = benzi[i].rola;
				benzi[i].rola = r;
				role[benzi[0].rola].banda = 0;
				role[benzi[i].rola].banda = i;
				benzi[i].form = 1;
				// facem rola i goala (rola i e pe i+1)
				fprintf (out, "%d\n", benzi[i+1].rola);
				benzi[i+1].rola = benzi[0].rola;
				benzi[0].rola = i;
				role[benzi[0].rola].banda = 0;
				role[benzi[i+1].rola].banda = i+1;
				benzi[i+1].form ^= 1;
				// acum putem sa terminam cu banda i 
				fprintf (out, "%d\n", benzi[i].rola);
				benzi[0].rola = benzi[i].rola;
				role[benzi[0].rola].banda = 0;
				benzi[i].rola = i;
				role[i].banda = i;
				benzi[i].form = 0;
			}
		}
	}
	
	/*for (i=0;i<=n;i++) {
		printf ("%d %d %d\n", i, benzi[i].rola, (int)benzi[i].form);
	}*/

	fclose (in);
	fclose (out);

	return 0;
}
