#include <stdio.h>
#include <algorithm>

using namespace std;

const int N_MAX = 50010;
const int INF = 2000000000;
const int M_MAX = 100010;

struct pct {
	int x, y;
} v[N_MAX];

struct bla {
    int poz, x;
} x[M_MAX];

struct kkt {
	int cine, mn;
} MIN[M_MAX];

int nrp, aux[M_MAX];

int cmp(bla a, bla b)
{
	return (a.x < b.x);
}

int bs(int val)
{
	int i, step;

	for (step = 1; step < nrp; step <<= 1);
	for (i = 0; step; step >>= 1) {
		if (i + step <= nrp && x[i + step].x <= val) {
			i += step;
		}
	}

	return i;
}

int minim(int a, int b)
{
	return (a < b ? a : b);
}

int main()

{
	freopen("puncte.in", "r", stdin);
#ifndef _SCREEN_
	freopen("puncte.out", "w", stdout);
#endif

	int N, M, i;
	scanf("%d %d\n", &N, &M);
	for (i = 1; i <= N; i ++) {
		scanf("%d %d\n", &v[i].x, &v[i].y);
	}

	for (i = 1; i <= M; i ++) {
		scanf("%d\n", &x[i].x);
		aux[i] = x[i].x;
		x[i].poz = i;
		MIN[i].mn = INF;
	}
	nrp = M;

	int poz, mn, care, inc;

	while (nrp) {

		sort(x + 1, x + nrp + 1, cmp);
		x[nrp + 1].x = INF;

		for (i = 1; i <= N; i ++) {
			poz = bs(v[i].x);
			
			if (poz == 0) {
				mn = x[poz + 1].x - v[i].x;
				care = poz + 1;
			} else {
				mn = minim((v[i].x - x[poz].x), (x[poz + 1].x - v[i].x));

				if (mn == v[i].x - x[poz].x) {
					care = poz;
				} else {
					care = poz + 1;
				}
			}
			
			if (mn * mn + (v[i].y * v[i].y) < MIN[x[care].poz].mn) {
				MIN[x[care].poz].mn = mn * mn + v[i].y * v[i].y;
				MIN[x[care].poz].cine = i;
			}
		}

/*		for (i = 1; i <= nrp; i ++) {
			printf("%d %d\n", MIN[i].cine, MIN[i].mn);
		}
*/
		inc = 1;
		for (i = 1; i <= nrp; i ++) {
			if (MIN[i].mn == INF) {
				x[inc].x = aux[i];
				x[inc ++].poz = i;
			}
		}
		nrp = inc - 1;

	}
			
	
	for (i = 1; i <= M; i ++) {
		printf("%d\n", MIN[i].mn);
		
	}
	
	return 0;
}
