#include <cstdio>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

#define MAXC 128
#define MAXN 512
#define MAXL 25

vector< string > p1;
string p2; int nr2, p2c[MAXC];

istringstream S;
char tmp[MAXN];
string stmp;

int bst[2][MAXN], nr[2][MAXN];

inline int getdist( int cuv, int l, int r )
{
	int len = r - l + 1, k, rez = 0;
	for (k = 0; k < (int)p1[cuv].length() && k < len; k++)
		rez += abs( p1[cuv][k] - p2[k + l] );
	
	for (; k < (int)p1[cuv].length(); k++)
		rez += abs( p1[cuv][k] - '@' );
	for (; k < len; k++)
		rez += abs( p2[k + l] - '@' );
	return rez;
}

int main()
{
	freopen("dist.in", "rt", stdin);
	freopen("dist.out", "wt", stdout);

	fgets( tmp, MAXN, stdin );

	S.clear(); S.str(tmp);
	for (p1.clear(); S >> stmp; )
		p1.push_back( stmp );

	fgets( tmp, MAXN, stdin );
	
	S.clear(); S.str(tmp);
	for (p2 = "$", nr2 = 0; S >> stmp; )
		p2 += stmp, p2c[ nr2++ ] = p2.size() - 1;

	for (; (int)p1.size() < nr2; p1.push_back(""));
	for (; nr2 < (int)p1.size(); p2c[ nr2++ ] = p2.size() - 1);

	for (int i = 0; i < (int)p2.length(); i++)
		bst[0][i] = getdist( 0, 1, i ),
		nr[0][i] = abs( i - p2c[0] );

	int step = 1;
	for (int i = 1; i < (int)p1.size(); i++, step ^= 1)
		for (int j = 0; j < (int)p2.length(); j++)
		{
			bst[step][j] = 0x3f3f3f3f;
			nr[step][j] = 0x3f3f3f3f;

			for (int k = j + 1; k > 0 && k > j - 20; k--)
			{
				int _bst = bst[1 ^ step][k - 1] + getdist( i, k, j );
				int _nr = nr[1 ^ step][k - 1] + abs( j - p2c[i] );
				if (_bst < bst[step][j])
					bst[step][j] = _bst,
					nr[step][j] = _nr;
				else
					if (_bst == bst[step][j] && _nr < nr[step][j])
						nr[step][j] = _nr;
			}
		}

	printf("%d %d\n", bst[1 ^ step][ p2.length() - 1 ], nr[1 ^ step][ p2.length() - 1 ]);

	return 0;
}
