#include <stdio.h>
#include <string.h>

#define MAXN 205

#define MAXL 32
#define BAZA 1000000000
#define OUTPUT_FORMAT "%09d"
class huge
{
private:
	int a[MAXL];
public:
	huge() { memset(a, 0, sizeof(a)); }
	huge( int N )
	{
		memset(a, 0, sizeof(a));
		do
		{
			a[ ++a[0] ] = N % BAZA;
			N /= BAZA;
		}
		while (N);
	}

	huge operator = (huge B)
	{
		memcpy(a, B.a, sizeof(a));
		return (*this);
	}

	huge operator += (huge B)
	{
		int i, t = 0;
		for (i = 1; i <= a[0] || i <= B.a[0] || t; i++, t /= BAZA)
			a[i] = (t += a[i] + B.a[i]) % BAZA;
		a[0] = i - 1;
		return (*this);
	}

	void print()
	{
		int i;
		printf("%d", a[ a[0] ]);
		for (i = a[0] - 1; i > 0; i--)
			printf(OUTPUT_FORMAT, a[i]);
		printf("\n");
	}
};

int N;
huge Nr[MAXN][MAXN];

int main()
{
	freopen("munte.in", "rt", stdin);
	freopen("munte.out", "wt", stdout);

	scanf("%d", &N);
	N = 2 * N - 2;

	Nr[0][0] = 1;
	for (int i = 1; i <= N; i++)
		for (int j = 0; j <= N; j++)
		{
			Nr[i][j] = 0;
			if (i >= 2)
				Nr[i][j] += Nr[i - 2][j];
			if (j > 0)
				Nr[i][j] += Nr[i - 1][j - 1];
			if (j == 0)
			{
				if (i >= 3)
					Nr[i][j] += Nr[i - 3][j + 1];
				if (i >= 2)
					Nr[i][j] += Nr[i - 2][j + 2];
			}
			else
				Nr[i][j] += Nr[i - 1][j + 1];
		}

	Nr[N][0].print();
	
	return 0;
}
