#include <cstdio>
#include <vector>
#include <set>

using namespace std;

#define MAXN 2048

int N, M, K;
set<int> con[MAXN];
int deg[MAXN];
int sol[MAXN][3];

set< pair<int, int> > S;
vector<int> tmp;

int main()
{
	freopen("promo.in", "rt", stdin);
	freopen("promo.out", "wt", stdout);

	for (scanf("%d %d", &M, &K); K; K--)
	{
		int i, j;
		scanf("%d %d", &i, &j);
		con[i].insert( j );
		con[j].insert( i );
		deg[i]++;
		deg[j]++;
	}
	
	for (int i = 1; i <= M; i++)
		S.insert( make_pair( deg[i], i ) );

	for (N = 0; !S.empty(); )
	{
		int i = (*S.begin()).second;
		S.erase( S.begin() );
		if (deg[i] == 0)
			for (; sol[i][0] != 2; )
			{
				N++;
				sol[i][ ++sol[i][0] ] = N;
			}
		if (deg[i] == 1)
		{
			N++;
			sol[i][ ++sol[i][0] ] = N;
			int nxt = *(con[i].begin());
			sol[nxt][ ++sol[nxt][0] ] = N;
			
			S.erase( make_pair( deg[nxt], nxt ) );
			deg[nxt]--; deg[i]--;
			S.insert( make_pair( deg[nxt], nxt ) );
			con[nxt].erase(i);
			
			for (; sol[i][0] != 2; )
			{
				N++;
				sol[i][ ++sol[i][0] ] = N;
			}
		}
		if (deg[i] == 2)
		{
			int a, b;
			a = *con[i].begin();
			con[i].erase( con[i].begin() );
			b = *con[i].begin();
		
			N++;
			sol[i][ ++sol[i][0] ] = N;
			sol[a][ ++sol[a][0] ] = N;
			sol[b][ ++sol[b][0] ] = N;
			
			con[a].erase(i);
			S.erase( make_pair( deg[a], a ) );
			deg[a]--; deg[i]--;
			
			con[b].erase(i);
			S.erase( make_pair( deg[b], b ) );
			deg[b]--; deg[i]--;

			con[a].erase(b); deg[a]--;
			con[b].erase(a); deg[b]--;
			S.insert( make_pair( deg[a], a ) );
			S.insert( make_pair( deg[b], b ) );
		}
		if (deg[i] > 2)		//clica
		{
			N++;
			sol[i][ ++sol[i][0] ] = N;
			tmp.clear();
			set<int> :: iterator it;
			for (it = con[i].begin(); it != con[i].end(); it++)
			{
				sol[ *it ][ ++sol[*it][0] ] = N;
				tmp.push_back( *it );
				con[*it].erase(i);
				S.erase( make_pair( deg[*it], *it ) );
				deg[*it]--;
			}

			for (int i = 0; i < (int)tmp.size(); i++)
				for (int j = i + 1; j < (int)tmp.size(); j++)
				{
					con[ tmp[i] ].erase( tmp[j] ); deg[ tmp[i] ]--;
					con[ tmp[j] ].erase( tmp[i] ); deg[ tmp[j] ]--;
				}

			for (int i = 0; i < (int)tmp.size(); i++)
				S.insert( make_pair( deg[tmp[i]], tmp[i] ) );
		}
	}

	for (int i = 1; i <= M; i++)
		for (; sol[i][0] != 2; )
		{
			N++;
			sol[i][ ++sol[i][0] ] = N;
		}

	printf("%d\n", N);
	for (int i = 1; i <= M; i++)
		printf("%d %d\n", sol[i][1], sol[i][2]);

	return 0;
}

