#include <cstdio>
#include <algorithm>

using namespace std;

#define MAXN 100005
#define MAXM 200005
#define INF (1LL << 62)

int N, M;
int x[MAXN], y[MAXN];
int q[MAXM], o[MAXM];

int st[MAXN];
long long sol[MAXM];

inline long long dist( int x1, int y1, int x2, int y2 )
{
	long long dx = x1 - x2, dy = y1 - y2;
	return dx * dx + dy * dy;
}

int cmp( int a, int b )
{
	return q[a] < q[b];
}

char stmp[64];

int main()
{
	freopen("puncte.in", "rt", stdin);
	freopen("puncte.out", "wt", stdout);

	scanf(" %d %d ", &N, &M);
	for (int i = 0; i < N; i++)
		scanf(" %d %d ", x + i, y + i);
	
	for (int i = 0; i < M; i++)
	{
		fgets(stmp, 64, stdin);
		char *p = stmp;
		for (; '0' > *p || *p > '9'; p++);
		for (q[i] = 0; '0' <= *p && *p <= '9'; p++)
			q[i] = q[i] * 10 + *p - '0';
	       	o[i] = i;
	}
	sort( o, o + M, cmp );

	long long BST, tmp; int BSTp;

	st[ st[0] = 1 ] = N - 1;
	BST = dist( 0, 0, x[N - 1], y[N - 1] );
	for (int i = N - 2; i >= 0; i--)
	{
		tmp = dist( 0, 0, x[i], y[i] );
		if (tmp < BST)
			BST = tmp,
			st[ ++st[0] ] = i;
	}

	BST = INF; BSTp = -1;
	for (int k = 0; k < M; k++)
	{
		int i = o[k];
		
		if (BSTp != -1)
			BST = dist( q[i], 0, x[ BSTp ], y[ BSTp ] );
		for (; st[0] && x[ st[st[0]] ] <= q[i]; st[0]--)
		{
			tmp = dist( q[i], 0, x[ st[st[0]] ], y[ st[st[0]] ] );
			if (tmp < BST)
				BST = tmp,
				BSTp = st[ st[0] ];
		}
		long long rez = BST;
		
		if (st[0])
		{
			tmp = dist( q[i], 0, x[ st[st[0]] ], y[ st[st[0]] ] );
			if (tmp < rez)
				rez = tmp;
		}
		sol[i] = rez;
	}

	for (int k = 0; k < M; k++)
		printf("%lld\n", sol[k]);
	
	return 0;
}

