#include <fstream.h>
#include <iostream.h>
#define Nmax 101
#define Fin  "oua.in"
#define Fout "oua.out"

typedef long Vector[Nmax];
typedef int Matrice[Nmax][Nmax];
int L;                              //dimensiunea pajistei
int P;                              //numarul oualelor
int N;                              //numarul iepurasilor
Matrice A;                          //pajistea
Vector Rx,Ry;                       //memorez pozitiile iepurasilor la fiecare moment de timp
Vector Dx,Dy;                       //memoreaza directia in care se misca iepurasii
Vector Cos;                         //memoreaza valoarea oualelor adunate de fiecare iepuras
Vector Este;                        //memoreaza starea fiecarui iepuras (pe pajiste sau in afara)
long NrOua, Timp, ValCos;           //datele de iesire

int main()
{
 int i,j,x,y,v, NrIepuri, ok;
 //citesc datele de intrare
 ifstream f(Fin);
 f>>L>>P;
 for(i=1;i<=L;i++)
   for(j=1;j<=L;j++) A[i][j]=0;
 for(i=1;i<=P;i++)
   {
    f>>x>>y>>v;
    A[x][y]=v;                         
   }  
 f>>N;
 NrOua=Timp=ValCos=0;
 NrIepuri=N;
 for(i=1;i<=N;i++)
  {
   Este[i]=1;  Cos[i]=0;
   f>>Rx[i]>>Ry[i];
   if(Rx[i]==1 && Ry[i]!=1) Dx[i]=1, Dy[i]=0;
   if(Rx[i]==L && Ry[i]!=L) Dx[i]=-1, Dy[i]=0;
   if(Ry[i]==1 && Rx[i]!=L) Dx[i]=0, Dy[i]=1;
   if(Ry[i]==L && Rx[i]!=1) Dx[i]=0, Dy[i]=-1;
   //daca exista ou in poz. initiala a unui iepuras
   if(A[Rx[i]][Ry[i]])
    {
     Cos[i]=A[Rx[i]][Ry[i]],A[Rx[i]][Ry[i]]=0, NrOua++;
     //schimb directia iepurasului i
     if(Dx[i]==1 && Dy[i]==0)  Dx[i]=0,Dy[i]=-1; else
     if(Dx[i]==-1 && Dy[i]==0) Dx[i]=0,Dy[i]=1;  else
     if(Dx[i]==0 && Dy[i]==1)  Dx[i]=1,Dy[i]=0;  else
     if(Dx[i]==0 && Dy[i]==-1) Dx[i]=-1,Dy[i]=0;
    }

  }
 f.close();
 //iepurasii tzopaie !!!
 do{
    Timp++;
    for(i=1;i<=N;i++)
     if(Este[i])
     {
      //mut fiecare iepuras
      Rx[i]+=Dx[i]; Ry[i]+=Dy[i];
      if(1<=Rx[i] && Rx[i]<=L && 1<=Ry[i] && Ry[i]<=L)  //daca poz. actuala este inca pe pajiste
        {
          //adun oul, daca exista          
	  if(A[Rx[i]][Ry[i]])
	   {
	    Cos[i]+=A[Rx[i]][Ry[i]],A[Rx[i]][Ry[i]]=0, NrOua++;
	    //schimb directia iepurasului i
	    if(Dx[i]==1 && Dy[i]==0)  Dx[i]=0,Dy[i]=-1; else
	    if(Dx[i]==-1 && Dy[i]==0) Dx[i]=0,Dy[i]=1;  else
	    if(Dx[i]==0 && Dy[i]==1)  Dx[i]=1,Dy[i]=0;  else
	    if(Dx[i]==0 && Dy[i]==-1) Dx[i]=-1,Dy[i]=0;
	   }
        } 
       else 
        {
         //iepurele i a parasit pajistea
         Este[i]=0, NrIepuri--;           
        } 
     }                    
 }while(NrIepuri);
 //determin cel mai valoros cos
 for(i=1;i<=N;i++)
   if(ValCos<Cos[i]) ValCos=Cos[i];
 //afisez rezultatele
 ofstream g(Fout);
 g<<NrOua<<' '<<ValCos<<' '<<Timp<<'\n';
 g.close();
 return 0;   
}

