{ XI ᨩ᪠  誮쭨  ଠ⨪ }
{ (c) 1999,   . }
{  2.  娬 }
{ :   .஢ }
{ 襭: .஢ }
{ 室 䠩: INPUT.TXT, 室: OUTPUT.TXT }

{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}

program Problem2;

const
  nMax = 6;
  kMax = 100;
  maxPos = 10000;
  inf = MAXLONGINT;

type TPosition=array[1..nMax] of longint;
     PTPosition = ^TPosition;
     tRule = array[1..kMax, 1..nMax] of integer;
     tNames =  array[1..kMax] of string[10];

var
  n, k : integer;
  ruleIn, ruleOut : tRule;
  seq : array[1..maxPos] of PTPosition;
  pred : array[1..maxPos] of boolean;
  more : array[1..nMax] of integer;
  names : ^TNames;
  max : longint;
  nm, _beg, _fin : integer;
  _is : set of 1..2;

procedure Save(s : string; k : integer; var a : tRule);
var
  i : integer;
  vesh : string;
begin
  while (s[length(s)] = ' ') do dec(s[0]);
  s := s + ' ';
  while length(s)<>0 do begin
    vesh := copy(s, 1, pos(' ', s) - 1);
    delete(s, 1, pos(' ', s));

    i := 1;
    while names^[i] <> vesh do
      inc(i);

    a[k, i] := 1;
  end;
end;

procedure readData;
var
  i, j : integer;
  s : string;
begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  reWrite(output);
  new(names);

  readLn(n);
  readLn(s);
  s := s + ' ';
  for i := 1 to n do begin
    names^[i] := copy(s, 1, pos(' ', s)-1);
    if names^[i] = '' then _fin := i;
    if names^[i] = 'ᢨ' then _beg := i;

    delete(s, 1, pos(' ', s));
  end;

  readLn(k);
  _is := [];
  for i := 1 to k do begin
    readLn(s);
    save(s, i, ruleIn);
    if ruleIn[i, _beg] = 1 then
      include(_is, 1);

    readLn(s);
    save(s, i, ruleOut);
    if ruleOut[i, _fin] = 1 then
      include(_is, 2);
  end;

  if _is <> [1,2] then begin
    writeLn(0);
    Halt;
  end;

  close(input);
end;

function analyze(k : integer) : boolean;
var
  i, j, cntless, cntmore : integer;
begin
  for i := 1 to k-1 do begin
    cntless := 0; cntmore := 0;
    for j := 1 to n do begin
      if seq[k]^[j] > seq[i]^[j] then begin
        inc(cntmore);
        more[cntmore] := j;
      end;

      if seq[k]^[j] < seq[i]^[j] then
        inc(cntless);
    end;

    if cntmore = 0 then begin
      analyze := false;
      exit;
    end;
    if cntless = 0 then
      if pred[i] then
        for j := 1 to cntmore do
          seq[k]^[more[j]] := inf;
  end;

  analyze := true;
end;

procedure search;
var
  l, i, j : integer;
  fl : boolean;
begin
  if max = inf then begin
    writeLn('QUANTUM SATIS');
    halt;
  end;

  l := nm;
  pred[l] := true;

  for i := 1 to k do begin
    fl := true;
    for j := 1 to n do
      if seq[l]^[j] < inf then
        if seq[l]^[j] >= ruleIn[i, j] then
          seq[nm+1]^[j] := seq[l]^[j]-ruleIn[i, j]+ruleOut[i, j]
        else
          fl := false;

    if fl and analyze(nm+1) then begin
      if seq[nm+1]^[_fin] > max then
        max := seq[nm+1]^[_fin];

      inc(nm);
      search;
    end;
  end;

  pred[l] := false;
end;

procedure solve;
var
  i : integer;
begin
  fillChar(seq, sizeOf(seq), 0);
  for i := 1 to maxpos do begin
    new (seq[i]);
    fillchar (seq[i]^,sizeof(seq[i]^),0);
  end;
  fillChar(pred, sizeOf(pred), $FF);
   seq[1]^[_beg] := 1;
  nm := 1;
  max := 0;
  search;

  writeLn(max);
end;

Begin
  readData;
  solve;
End.
