{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
 var
   n, np, nr, nv: integer;
   a: array [1..25,1..25] of boolean;
   p,r: array [1..25,0..25] of integer;
   tm: longint absolute 0:$46c;
   stm: longint;
   v: array [1..26] of boolean;

 procedure ReadAll;
 var
   i,j: integer;
 begin
   Assign(Input, 'input.txt');
   Reset(Input);

   Read(n);
   fillchar(a, sizeof(a),0);
   while not SeekEof do begin
     Read(i, j);
     if i<>j then a[i,j] := true;
   end;

   Close(Input);
 end;

 procedure donext; forward;

 procedure walk(k: integer);
 var
   x, y: integer;
   ww: boolean;
 begin
   if tm>stm then exit;

   v[k] := true;
   inc(nv);
   inc(p[np,0]);
   p[np,p[np,0]] := k;

   ww := true;

   for x := 1 to n do if a[k,x] and (not v[x]) then begin
     walk(x);
     ww := false;
   end;

   if ww then donext;

   v[k] := false;
   dec(p[np,0]);
   dec(nv);
 end;

 procedure donext;
 var
   i,j: integer;
   ni: boolean;
 begin
   if np>=nr then exit;
   if nv<n then begin
     for i := 1 to n do if not v[i] then begin
       ni := true;
       for j := 1 to n do if (not v[j]) and (a[j,i]) then begin
         ni:=false; break;
       end;
       if ni then begin
         inc(np);
         if np>=nr then begin dec(np);exit; end;
         p[np,0] := 0;
         walk(i);
         dec(np);
         exit;
       end;
     end;
   end;

   if np<nr then begin
     nr := np;
     r := p;
   end;
 end;

 procedure Perebor;
 begin
   fillchar(v, sizeof(v), 0);
   fillchar(p, sizeof(p), 0);
   np := 0; nv := 0;
   donext;
 end;

 procedure Solve1;
 var
   d: array [1..25] of integer;
   i, j, k, s, l: integer;
   ni: boolean;
 begin
   fillchar(v, sizeof(v), 0);
   nv := 0; np := 0;
   while nv<n do begin
     i := 0;
     repeat
       inc(i);
       while v[i] do inc(i);
       ni := true;
       for j := 1 to n do if (not v[j]) and (a[j,i]) then begin
         ni:=false; break;
       end;
     until ni;
     s := i;
     for i := 1 to n do d[i] :=-1;
     d[s] := 0;

     for k := 1 to n do
       for i := 1 to n do if (d[i]<>-1)and(not v[i]) then
         for j := 1 to n do if (not v[j]) then
           if (a[i,j]) and ((d[j]=-1)or(d[j]<d[i]+1)) then d[j] := d[i]+1;

     k := 1;
     for i := 2 to n do if d[i]>d[k] then k := i;
     inc(np);
     p[np,0] := d[k]+1;
     for l := d[k]+1 downto 1 do begin
       if v[k] then exit;
       p[np,l] := k;
       v[k] := true; inc(nv);
       for j := 1 to n do if d[j]+1=d[k] then begin
         k := j; break;
       end;
     end;
   end;

   if (np<nr) then begin
     nr := np; r := p;
   end;
 end;

 function mpth1(s, t: integer): boolean;
 var
   i,j,k,l: integer;
   d: array [1..25] of integer;
 begin
   mpth1 := true;
   for i := 1 to n do d[i] :=-1;
   d[s] := 0;
   for k := 1 to n do
     for i := 1 to n do if (d[i]<>-1)and(not v[i]) then
       for j := 1 to n do if (not v[j]) then
         if (a[i,j]) and ((d[j]=-1)or(d[j]>d[i]+1)) then d[j] := d[i]+1;

   if d[t] = -1 then begin
     mpth1 := false;exit;
   end;

   k := t;
   inc(np);
   p[np,0] := d[k]+1;
   for l := d[k]+1 downto 1 do begin
     if v[k] then exit;
     p[np,l] := k;
     v[k] := true; inc(nv);
     for j := 1 to n do if d[j]+1=d[k] then begin
       k := j; break;
     end;
   end;

   mpth1 := true;
 end;

 function mpth2(s, t: integer): boolean;
 var
   i,j,k,l: integer;
   d: array [1..25] of integer;
 begin
   mpth2 := true;
   for i := 1 to n do d[i] :=-1;
   d[s] := 0;
   for k := 1 to n do
     for i := 1 to n do if (d[i]<>-1)and(not v[i]) then
       for j := 1 to n do if (not v[j]) then
         if (a[i,j]) and ((d[j]=-1)or(d[j]<d[i]+1)) then d[j] := d[i]+1;

   if d[t] = -1 then begin
     mpth2 := false;exit;
   end;

   k := t;
   inc(np);
   p[np,0] := d[k]+1;
   for l := d[k]+1 downto 1 do begin
     if v[k] then exit;
     p[np,l] := k;
     v[k] := true; inc(nv);
     for j := 1 to n do if d[j]+1=d[k] then begin
       k := j; break;
     end;
   end;

   mpth2 := true;
 end;

 function max(a,b: integer): integer;
 begin
   if a>b then max := a else max :=b;
 end;

 procedure Solve2;
 var
   i,j,vi,vo: integer;
   dd,ni,no: boolean;
 begin
   nv := 0; np := 0;
   fillchar(v, sizeof(v), 0);
   while nv<n do begin
     i := 0;
     repeat
       inc(i);
       if i>n then exit;
       while v[i] do inc(i);
       if i>n then exit;
       ni := true;
       for j := 1 to n do if (not v[j]) and (a[j,i]) then begin
         ni:=false; break;
       end;
     until ni;
     vi := i;

     i := 0;
     repeat
       repeat
         inc(i);
         if i>n then exit;
         while v[i] do inc(i);
         if i>n then exit;
         no := true;
         for j := 1 to n do if (not v[j]) and (a[i,j]) then begin
           no:=false; break;
         end;
       until no;
       vo := i;
     until mpth1(vi, vo);
   end;

   if nr>np then begin
     nr := np; r := p;
   end;
 end;

 procedure Solve3;
 var
   i,j,vi,vo: integer;
   dd,ni,no: boolean;
 begin
   nv := 0; np := 0;
   fillchar(v, sizeof(v), 0);
   while nv<n do begin
     i := 0;
     repeat
       inc(i);
       if i>n then exit;
       while v[i] do inc(i);
       if i>n then exit;
       ni := true;
       for j := 1 to n do if (not v[j]) and (a[j,i]) then begin
         ni:=false; break;
       end;
     until ni;
     vi := i;

     i := 0;
     repeat
       repeat
         inc(i);
         if i>n then exit;
         while v[i] do inc(i);
         if i>n then exit;
         no := true;
         for j := 1 to n do if (not v[j]) and (a[i,j]) then begin
           no:=false; break;
         end;
       until no;
       vo := i;
     until mpth2(vi, vo);
   end;

   if nr>np then begin
     nr := np; r := p;
   end;
 end;

 procedure Solve;
 var
   i: Integer;
 begin
   nr := n;
   for i := 1 to nr do begin
     r[i,0] := 1;
     r[i,1] := i;
   end;

   Solve1;
   Solve2;
   Solve3;
   Perebor;
 end;

 procedure Out;
 var
   i, j: Integer;
 begin
   Assign(Output, 'output.txt');
   ReWrite(Output);

   WriteLn(nr);
   for i := 1 to nr do begin
     for j := 1 to r[i,0] do Write(r[i,j], ' ');
     WriteLn;
   end;

   Close(Output);
 end;

 begin
   stm := tm+165;
   ReadAll;
   Solve;
   Out;
 end.