{  }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

var N, A, B: integer;
    c, v: array [1..30, 1..30] of integer;
    Optimized: boolean;
    w: array [1..30] of boolean;
    num, p, q: array [1..30] of integer;
    qh, qt, qn: integer;

procedure ReadAll;
var i, j: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Read(N, a, b);
  while not SeekEof do begin
    Read(i, j);
    if (i = A) and (j = B) then
      Inc(c[i, j])
    else
    if i <> B then
      c[i, j] := 1;
  end;
end;

procedure Optimize;
var i, j: integer;
begin
  Optimized := False;
  qh := 1;
  qt := 1;
  qn := 1;
  q[1] := A;
  Fillchar(w, Sizeof(w), 0);
  while qn > 0 do begin
    i := q[qh];
    if i = B then break;
    Inc(qh);
    Dec(qn);
    for j := 1 to N do
      if not w[j] then begin
        if ((c[i, j] > 0) and (v[i, j] < 1) and (num[i] = 0) and (num[j] = 0)) or
           ((c[j, i] > 0) and (v[j, i] > 0))
        then
        begin
          Inc(qt);
          Inc(qn);
          q[qt] := j;
          w[j] := True;
          p[j] := i;
        end;
      end;
  end;
  if qn > 0 then begin
    Optimized := True;
    while i <> A do begin
      j := i;
      i := p[j];
      if (c[i, j] > 0) and (v[i, j] < 1) then begin
        Inc(v[i, j]);
        Inc(num[i]);
        Inc(num[j]);
      end else begin
        Dec(v[j, i]);
        Dec(num[i]);
        Dec(num[j]);
      end;
    end;
  end;
  num[A] := 0;
  num[B] := 0;
end;

procedure Way(i: integer);
var j: integer;
begin
  if i = B then Writeln(B) else begin
    Write(i, ' ');
    for j := 1 to N do
      if v[i, j] > 0 then begin
        Way(j);
        Break;
      end;
  end;
end;

procedure Solve;
var i, count: Integer;
begin
  Fillchar(v, Sizeof(v), 0);
  repeat
    Optimize;
  until not Optimized;
  count := 0;
  for i := 1 to N do
    if v[a,i] > 0 then
      Inc(count);
  if c[a, b] > 1 then begin
    Inc(count, c[a, b] - v[a, b]);
    Writeln(count);
    for i := 1 to c[a, b] - v[a, b] do begin
      Writeln(a, ' ', b);
    end;
  end else
    Writeln(count);
  for i := 1 to N do
    if v[a,i] > 0 then begin
      Write(A, ' ');
      Way(i);
    end;
end;

begin
  ReadAll;
  Solve;
end.