{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  MaxN=100;
Type
  T2Graph=Array[1..MaxN,1..MaxN]Of Boolean;
Var
  M,N:Byte;
  DXN,DYN,DXM,DYM:Array[1..MaxN]Of LongInt;
  G:T2Graph;
  UN,UM:Array[1..MaxN]Of Byte;
  UNow:Array[1..MaxN]Of Boolean;
  Result:Byte;
Procedure Load;
Var
  I:Byte;
  T:LongInt;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  Read(M,N);
  For I:=1 To M Do If Not SeekEOF Then Begin
    Read(DYM[I],DXM[I]);
    If DYM[I]>DXM[I] Then Begin
      T:=DXM[I];
      DXM[I]:=DYM[I];
      DYM[I]:=T;
    End;
  End;
  For I:=1 To N Do If Not SeekEOF Then Begin
    Read(DYN[I],DXN[I]);
    If DYN[I]>DXN[I] Then Begin
      T:=DXN[I];
      DXN[I]:=DYN[I];
      DYN[I]:=T;
    End;
  End;
  Close(Input);
End;
Procedure Run;
Var
  I,J:Byte;
Function CanPack(I,J:Byte):Boolean;
Var
  Res:Boolean;
  DLen,Ang,Ang2:Real;
Begin
  If DXN[I]<=DXM[J] Then
    If DYN[I]<=DYN[J] Then
      CanPack:=True
    Else
      CanPack:=False
  Else
    If DYN[I]<=DYN[J] Then Begin
      DLen:=Sqrt(Sqr(DXN[I]*1.0)+Sqr(DYN[I]*1.0));
      Ang:=ArcTan(Sqrt(Sqr(DLen)-Sqr(DYM[J]*1.0))/DYM[J]);
      Ang2:=Ang+ArcTan(DYN[I]/DXN[I]);
      CanPack:=(2*Cos(Ang2)*DYN[I]+Sin(Ang)*DLen)-1E-6<DXM[J];
    End Else
      CanPack:=False;
End;
Function FromBox(Num:Byte):Boolean; Forward;
Function FromCard(Num:Byte):Boolean;
Var
  J:Byte;
Begin
  For J:=1 To M Do If G[Num,J] And Not UNow[J] And FromBox(J) Then Begin
    UN[Num]:=J;
    UM[J]:=Num;
    FromCard:=True;
    Exit;
  End;
  FromCard:=False;
End;
Function FromBox(Num:Byte):Boolean;
Begin
  If UM[Num]=0 Then Begin
    FromBox:=True;
    Exit;
  End;
  UNow[Num]:=True;
  FromBox:=FromCard(UM[Num]);
  UNow[Num]:=False;
End;
Begin
  For I:=1 To N Do
    For J:=1 To M Do
      G[I,J]:=CanPack(I,J);
  Result:=0;
  FillChar(UN,SizeOf(UN),0);
  FillChar(UM,SizeOf(UM),0);
  For I:=1 To N Do Begin
    FillChar(UNow,SizeOf(UNow),False);
    If FromCard(I) Then Inc(Result);
  End;
End;
Procedure Save;
Var
  I:Byte;
  First:Boolean;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  WriteLn(Result);
  First:=True;
  For I:=1 To N Do If UN[I]>0 Then Begin
    If First Then First:=False Else Write('  ');
    Write(I,' ',UN[I]);
  End;
  Close(Output);
End;
Begin
  Load;
  Run;
  Save;
End.