{$A+,B-,D-,E+,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
Program MPS;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxN=25;
      Ogr=18.2*9.5;
      inf=10000;
Type Sset=Set Of 1..MaxN;
     TSol=Array[0..MaxN] Of Byte;
     BMasSol=Array[0..MaxN] Of TSol;
 Var IfP, Sv: Array[1..MaxN, 1..MaxN] Of Boolean;
     ToWh: Array[1..MaxN] Of SSet;
{     sc: Array[1..MaxN] Of Integer;}
     Rs, NwSl: BMasSol;
     scRs: Integer;
     N, Na, Nb: Integer;
     Timer: LongInt absolute $0000:$046c;
     OTm: LongInt;
{     spd: Sset;}
     Potok: Array[1..MaxN, 1..MaxN] Of Integer;

 Procedure Init;
  Var k, p: Integer;
   Begin
    scRs:=0;
    FillChar(Rs, SizeOf(Rs), 0);
    FillChar(ToWh, SizeOf(ToWh), 0);
{    FillChar(sc, SizeOf(sc), 0);}
    FillChar(IfP, sizeOf(IfP), False);
    Assign(Input, InputFile);
     Reset(Input);
      Read(N, Na, Nb);
      While Not SeekEof Do Begin
       Read(k, p);
{       Inc(sc[k]);}
       IfP[k, p]:=True;
       Include(ToWh[k], p);
      End;
     Close(Input);
    OTm:=Timer;
{    spd:=[Na, Nb];}
   End;

Var Use: SSet;
    scNw: Integer;

 Procedure Done;
  Var i, j: Integer;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      WriteLn(scRs);
      For i:=1 To scRs Do Begin
       For j:=1 To Rs[i, 0] Do Write(Rs[i, j], ' ');
       WriteLn;
      End;
     Close(Output);
    Halt;
   End;

 Procedure Rec(Const k, mp: Integer;Const Ub: Sset);
  Var i: Integer;
   Begin
    If (Timer-OTm)>Ogr Then Begin
     Done;
     Halt;
    End;
    If (k>2) Or (mp=1) Then Begin
        For i:=1 To N Do
        If (i In Ub) And (Not(i In Use)) Then Begin
          NwSl[mp, k]:=i;
           Include(Use, i);
             If i=Nb Then Begin
                         NwSl[mp, 0]:=k;
                         NwSl[mp, 1]:=Na;
                    If mp>scRs Then Begin
                              scRs:=mp;
                              Rs:=NwSl;
                          End;
                     Use:=Use-[Nb];
                     Rec(2, mp+1, ToWh[Na]-Use);
                End
         Else Rec(k+1, mp, ToWh[i]-Use);
         Exclude(Use, i);
        End;
     End
     Else Begin
      For i:=NwSl[mp-1, 2]+1 To N Do Begin
        If (i In Ub) And (Not(i In Use)) Then Begin
          NwSl[mp, k]:=i;
           Include(Use, i);
             If i=Nb Then Begin
                         NwSl[mp, 0]:=k;
                         NwSl[mp, 1]:=Na;
                    If mp>scRs Then Begin
                              scRs:=mp;
                              Rs:=NwSl;
                          End;
                     Use:=Use-[Nb];
                     Rec(2, mp+1, ToWh[Na]-Use);
                End
         Else Rec(k+1, mp, ToWh[i]-Use);
         Exclude(Use, i);
        End;
       End;
     End;
   End;

Var W, P: Array[1..MaxN] Of LongInt;

 Procedure AddChange;
  Var i, v, d: Integer;
   Begin
    v:=nb; d:=P[v];
    Repeat
     If W[v]>0 Then Inc(Potok[W[v], v], d) Else
      Dec(Potok[v, -W[v]], d);
      v:=Abs(W[v]);
      d:=P[v];
    Until v=na;
   End;

 Function Min(Const a, b: LongInt): LongInt;
  Begin
   If a>b Then Min:=b Else Min:=a;
  End;

 Procedure PsHp;
  Var i, j: Integer;
      Och: Array[1..MaxN*MaxN] Of Integer;
      r, yk1, yk2: Integer;
   Begin
    FillChar(W, SizeOf(W), 0);
{    FillChar(P, SizeOf(P), 0);
     P[na]:=MaxInt;}
    FillChar(Och, SizeOf(Och), 0);
    Och[1]:=na;
    yk1:=0; yk2:=1; r:=0;
     While (yk2>yk1) And (W[nb]=0) Do Begin
      Inc(yk1); r:=Och[yk1];
      For i:=1 To N Do
      If (IfP[r, i]) And (W[i]=0) Then
       If Potok[r, i]<1 Then Begin
         Inc(yk2);
         Och[yk2]:=i;
         W[i]:=r;
         P[i]:=Min(1-Potok[r, i], P[r]);
       End
      Else If Potok[i, r]>0 Then Begin
            Inc(yk2);
            Och[yk2]:=i;
            W[i]:=-r;
            P[i]:=Min(P[r], Potok[i, r]);
       End;
     End;
   End;

 Procedure FsSolve;
  Begin
   FillChar(Potok, SizeOf(Potok), 0);
   FillChar(P, SizeOf(P), 0);
   FillChar(W, SizeOf(W), 0);
    P[na]:=inf;
    Repeat
     PsHp;
     If W[nb]<>0 Then AddChange;
    Until W[nb]=0;
  End;

 Procedure DelWay(Var a, b, d: Integer);
  Var i, j: Integer;
   Begin
    If d=na Then Begin
     b:=1;
     Rs[a, b]:=d;
    End
    Else Begin
     j:=0;
     For i:=N DownTo 1 Do
      If Potok[i, d]>0 Then j:=i;
      IfP[j, d]:=False;
     DelWay(a, b, j);
     Inc(b);
     Rs[a, b]:=d;
    End;
   End;

 Procedure Rassm;
  Var i, j: Integer;
   Begin
      scrs:=0;
    j:=0; Sv:=IfP; scRs:=0;
    Repeat
     If Timer-OTm>Ogr Then Done;
     j:=0;
    For i:=N DownTo 1 Do
     If Potok[i, nb]=1 Then j:=i;
       If j<>0 Then Begin
          Inc(scRs);
              i:=0;
               DelWay(scRs, i, j);
               Rs[scRs, 0]:=i+1;
               Rs[scRs, i+1]:=nb;
              IfP[j, nb]:=False;
         FsSolve;
        End;
    Until j=0;
    IfP:=Sv;
   End;

 Procedure Solve;
  Begin
   Use:=[Na];
    scNw:=0;
   Rec(2, 1, ToWh[Na]-Use);
  End;

BEGIN
 Init;
  FsSolve;
   Rassm;
  Solve;
 Done;
END.