{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
const     Max=100;
var       Pack: array [1..Max,0..Max] of Byte;
          Card: array [1..Max,0..Max] of Byte;
          PF, CF: array [1..Max] of Byte;
          M, N: Integer; {M-pack, N-card}
          Ans: Integer;

procedure ReadIn;
var       PX, PY: array [1..Max] of Integer;
          CX, CY: array [1..Max] of Integer;
          I, J: Integer;

function _In(X, Y, CX, CY: LongInt): Boolean;
var      A,C,S: Real;
         I: Integer;
const    MOP=100;
begin
 for I := 0 to MOP-1 do
 begin
  C := (I/MOP);
  S := Sqrt (1-C*C);
  if (X*C+Y*S<=CX) and
     (Y*C+X*S<=CY) then begin _In:=True; exit;end;
  if (X*C+Y*S<=CY) and
     (Y*C+X*S<=CX) then begin _In:=True; exit;end;
 end;
 _In:=False;
end;

begin
 Assign (Input,'input.txt'); reset (Input);
 ReadLn (M, N);
 for I := 1 to M do Read (PX[I],PY[I]);
 for I := 1 to N do Read (CX[I],CY[I]);
 FillChar (Pack, SizeOf (Pack),0);
 FillChar (Card, SizeOf (Card),0);

 for I := 1 to M do
  for J := 1 to N do
   if _In (CX[J],CY[J],PX[I],PY[I]) then
   begin
    Inc (Pack[I,0]); Pack[I,Pack[I,0]]:=J;
    Inc (Card[J,0]); Card[J,Card[J,0]]:=I;
   end;
 Close (input);
end;

procedure WriteOut;
var       I: Integer;
begin
 assign (output,'output.txt'); rewrite (output);
 WriteLn (Ans);
 for I := 1 to M do
  if PF[I]>0 then WriteLN (I, ' ',PF[I]);
 Close(output);
end;

procedure Solve;
var       I: Integer;
          WasP, WasC: set of 1..Max;

function Crd (C: integeR): Boolean; forward;

function Pck (P: Integer): Boolean;
var      CN, C: Integer;
begin
 for CN := 1 to Pack[P,0] do if not (Pack[P,CN] in WasC) then
 begin
  C := Pack[P,CN];
  WasC:=WasC+[C];
  if (CF[C]=0) or (Crd(C)) then
  begin
   CF[C] := P;
   PF[P] := C;
   Pck := True;
   WasC := WasC-[P];
   Exit;
  end;
  WasC := WasC-[P];
 end;
 Pck := False;
end;

function Crd (C: integeR): Boolean;
var      PN, P: Integer;
begin
 if CF[C] in WasP then begin Crd := False; Exit; end;
 WasP := WasP+[CF[C]];
 if Pck(CF[C]) then
 begin
  Crd := True;
  Exit;
 end;
 Crd:=False;
end;

begin
 FillChar (PF,SizeOf (PF), 0);
 FillChar (CF,SizeOf (CF), 0);
 Ans := 0;
 for I := 1 to M do
 begin
  WasP := [I]; WasC := [];
  if Pck (I) then Inc (Ans);
 end;
end;

begin
 ReadIn;
 solve;
 WriteOut;
end.