{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 64384,0,655360}
Var I:Integer;
    Konv,Card:Array[1..110] Of Record SX,SY:LongInt;End;
    Mas:Array[1..110,1..110] Of Byte;
    M,N:Integer;

Function Max(A,B:Integer):Integer;
Begin
If A>B Then Max:=A Else Max:=B;
End;

Function Min(A,B:Integer):Integer;
Begin
If A<B Then Min:=A Else Min:=B;
End;

Function InSide(A1,B1,C1,D1:Integer):Boolean;
Var A,B,C,D,LX,LY,TX,TY:Real;S1:Real;
Begin
InSide:=False;
LX:=Max(A1,B1);LY:=Min(A1,B1);
TX:=Max(C1,D1);TY:=Min(C1,D1);
If (LX>=TX) And (LY>=TY) Then Begin InSide:=True;Exit;End;
A:=TX*TX+TY*TY;B:=-2*TX*TY;C:=-TX*TX+LX*LX;
{A:=-TX*TX-TY*TY;B:=2*TX*TY;C:=TX*TX-LX*LX;}
D:=B*B-4*A*C;
If D<0 Then Exit;
S1:=(-B+Sqrt(D))/(2*A);
If (S1<=1) And (S1>0) Then
If Abs(TX*S1+TY*Sqrt(1-Sqr(S1)))<=LY Then Begin InSide:=True;Exit;End;
S1:=(-B-Sqrt(D))/(2*A);
If (S1<=1) And (S1>0) Then
If Abs(TX*S1+TY*Sqrt(1-Sqr(S1)))<=LY Then Begin InSide:=True;Exit;End;
End;

Procedure Input;
Var F:Text;A,B,C,D:Integer;
Begin
Assign(F,'Input.Txt');
ReSet(F);
ReadLn(F,M,N);
For I:=1 To M Do Read(F,Konv[I].SX,Konv[I].SY);
For I:=1 To N Do Read(F,Card[I].SX,Card[I].SY);
Close(F);
End;

Function SvobConv(A:Byte):Byte;
Var I:Integer;
Begin
SvobConv:=0;
For I:=1 To N Do
If Mas[A,I]=2 Then Begin SvobConv:=I;Exit;End;
End;

Function SvobCard(A:Byte):Byte;
Var I:Integer;
Begin
SvobCard:=0;
For I:=1 To M Do
If Mas[I,A]=2 Then Begin SvobCard:=I;Exit;End;
End;

Procedure BuildNach;
Var I,Q:Integer;
Begin
For I:=1 To M Do
For Q:=1 To N Do
If (Mas[I,Q]=1) And (SvobCard(Q)=0) Then Begin Mas[I,Q]:=2;Break;End;
End;

Function FindChain:Boolean;
Label 1;
Var I,Yk,Num,R,P:Integer;
    Chain:Array[1..300] Of Integer;
    A:Array[-300..300] Of Boolean;
    TTTT:Boolean;
Begin
FillChar(A,SizeOf(A),False);
FindChain:=False;
YK:=1;
Num:=0;
For I:=1 To M Do If SvobConv(I)=0 Then Begin Num:=I;Break;End;
If Num=0 Then Begin FindChain:=False;Exit;End;
P:=Num;FillChar(Chain,SizeOf(Chain),0);
Chain[Yk]:=P;

Num:=0;
For I:=1 To N Do If SvobCard(I)=0 Then Begin Num:=I;Break;End;
If Num=0 Then Begin FindChain:=False;Exit;End;

Repeat
R:=Chain[Yk];
A[R]:=True;
If R=0 Then Break;
If (R<0) And (SvobCard(-R)=0) Then Begin FindChain:=True;Break;End;
If R>0 Then
For I:=1 To N Do
If (Mas[R,I]=1) And Not (A[-I]) And (SvobCard(I)=0) Then
Begin Inc(YK);Chain[Yk]:=-I;Goto 1;End;

If R>0 Then Begin
TTTT:=False;
For I:=1 To N Do
If (Mas[R,I]=1) And Not (A[-I]) Then Begin TTTT:=True;Inc(YK);Chain[YK]:=-I;Break;End;
If Not TTTT Then Begin FindChain:=False;Exit;End;
End;

If R<0 Then
For I:=1 To M Do
If (Mas[I,-R]=2) And Not (A[I]) Then Begin Inc(YK);Chain[Yk]:=I;Break;End;
Until False;
1:FindChain:=True;
For I:=1 To YK-1 Do Begin
If I Mod 2<>0 Then Mas[Abs(Chain[I]),Abs(Chain[I+1])]:=2;
If I Mod 2=0 Then Mas[Abs(Chain[I+1]),Abs(Chain[I])]:=1;
End;
End;

Procedure Work;
Var I,Q:Integer;
Begin
FillChar(Mas,SizeOf(Mas),0);
For I:=1 To M Do
For Q:=1 To N Do If InSide(konv[I].Sx,Konv[I].Sy,Card[Q].SX,Card[Q].Sy) Then Mas[I,Q]:=1;
BuildNach;
While FindChain Do Write;
End;

Procedure Out;
Var F:Text;
    I,Q,T:Integer;
Begin
Assign(F,'OutPut.Txt');
ReWrite(F);
T:=0;
For I:=1 To M Do
For Q:=1 To N Do
If Mas[I,Q]=2 Then Inc(T);
WriteLn(F,T);
For I:=1 To M Do
For Q:=1 To N Do
If Mas[I,Q]=2 Then Write(F,I,' ',Q,' ');
Close(F);
End;

Begin
Input;
Work;
Out;
End.