program A;

const
{$ifdef ILIA}
  InFile='a.in';
  OutFile='a.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

var J,D:byte;

var boyf:array[1..100] of byte;
    girlf:array[1..100] of byte;
    sizeo:array[1..100] of record max,min:integer; end;
    sizek:array[1..100] of record max,min:integer; end;

const eps=1e-3;

function data(i,j:byte):boolean;
  var A,B,C,D:integer;
      bb:boolean;
  begin
  A:=sizek[j].max;
  B:=sizek[j].min;
  C:=sizeo[i].max;
  D:=sizeo[i].min;
  bb:=((C<=A) and (D<=B)) or
        (sqrt(longint(C)*C+longint(D)*D-B*longint(B))*(C+D)<A*longint(C-D)+eps);
  data:=bb;
  end;

procedure Marry;
  var markd:array[1..100] of boolean;
  var cur:byte;

  function girls(n:byte):boolean; forward;

  function boys(n:byte):boolean;
    var g:byte;
    begin
    boys:=true;
    if girlf[n]=0 then begin
      boys:=false;
      for g:=1 to D do
        if data(n,g) and not markd[g] and (girls(g)) then begin
            girlf[n]:=g;
            boyf[g]:=n;
            boys:=true;
            exit;
        end;
    end;
    end;

  function girls(n:byte):boolean;
    var bf:byte;
    begin
    girls:=true;
    if boyf[n]<>0 then begin
      girls:=false;
      bf:=boyf[n];
      girlf[boyf[n]]:=0;
      boyf[n]:=0;
      markd[n]:=true;
      if boys(bf) then
        girls:=true
      else begin
        boyf[n]:=bf;
        girlf[bf]:=n;
      end;
      markd[n]:=false;
    end;
    end;

  var i:byte;
  begin
  fillchar(boyf,sizeof(boyf),0);
  fillchar(girlf,sizeof(girlf),0);
  fillchar(markd,sizeof(markd),0);
  for cur:=1 to J do
    for i:=1 to D do
      if data(cur,i) then
        if girls(i) then begin
          boyf[i]:=cur;
          girlf[cur]:=i;
          break;
        end;
  end;

procedure ReadData;
  var i:byte;
      a,b:integer;
  begin
  Assign(input,InFile);
  Reset(Input);
  readln(D,J);
  for i:=1 to D do begin
    read(a,b);
    if a>b then begin
      sizek[i].max:=a;
      sizek[i].min:=b;
    end else begin
      sizek[i].min:=a;
      sizek[i].max:=b;
    end;
  end;
  for i:=1 to J do begin
    read(a,b);
    if a>b then begin
      sizeo[i].max:=a;
      sizeo[i].min:=b;
    end else begin
      sizeo[i].min:=a;
      sizeo[i].max:=b;
    end;
  end;
  Close(Input);
  end;

procedure WriteSol;
  var cnt:byte;
      i:byte;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  cnt:=0;
  for i:=1 to J do
    if boyf[i]<>0 then inc(cnt);
  writeln(cnt);
  for i:=1 to J do
    if boyf[i]<>0 then
      write(i,' ',boyf[i],' ');
  writeln;
  Close(Output);
  end;

begin
ReadData;
Marry;
WriteSol;
end.