{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R+,S+,T-,V+,X+}
{$M 65520,0,655360}

Program tt12;


Const Max=101;
      Eps=0.00001;

Type
  Priam = Record
            X,Y : Integer;
          End;
  MasPr  = Array [1..Max] Of Priam;
  MasBol = Array [1..Max] Of Boolean;
  MasInt = Array [1..Max] Of Integer;
  Matr   = Array [1..Max,1..Max] Of Boolean;



Var        N,M : Byte;
      Konv,Otk : MasPr;
 InWhatK,WhatO : MasInt;
             A : Matr;
          MaxI : Integer;
        ChKonv : MasBol;
        ChOtkr : MasBol;
           Col : Integer;


Procedure Swap(Var A,B : Integer);
  Var C : INteger;
Begin
  C:=A;
  A:=B;
  B:=C;
End;


Procedure Init;
  Var Inp : Text;
        i : Integer;
Begin
  Assign(Inp,'input.txt');
  Reset(Inp);
  Readln(Inp,M,N);
  For i:=1 To M do
    Begin
      Read(Inp,Konv[i].X);
      Read(Inp,Konv[i].Y);
      With Konv[i] Do
        If Y>X Then Swap(X,Y);
    End;
  For i:=1 To N do
    Begin
      Read(Inp,Otk[i].X);
      Read(Inp,Otk[i].Y);
      With Otk[i] Do
        If Y>X Then Swap(X,Y);
    End;
  Close(Inp);
End;



Function Rotate(Lit,Big : Priam) : Boolean;
  Var T : Real;
Begin
  T:=Sqr(Big.X)+Sqr(Lit.X);

  If (T-Sqr(Big.Y))<Eps
     Then Begin Rotate:=False; Exit; End
     Else Rotate:=True;

End;


Function IsIn(Lit,Big : Priam) : Boolean;
  Var FuncRav : Boolean;
Begin
  FuncRav:=False;
  If (Lit.X<=Big.X)
     Then
       If (Lit.Y<=Big.Y) Then Begin IsIn:=True; Exit; End
     Else
       Begin
         Swap(Lit.X,Lit.Y);
         Swap(Big.X,Big.Y);
         IsIn:=Rotate(Lit,Big);
         Exit;
       End;
  If (Lit.X>=Big.X)
     Then
       If (Lit.Y>=Big.Y) Then Begin IsIn:=False; Exit; End
     Else
       Begin
         IsIn:=Rotate(Lit,Big);
         Exit;
       End;

  IsIn:=FuncRav;
End;


Function ChangeOtFor(NumK : Integer) : Boolean; ForWard;


Function ChangeKonFor(NumO : Integer) : Boolean;
  Var i : Integer;
Begin
  ChOtkr[NumO]:=True;
  For i:=1 To M do
    If not (ChKonv[i])
      Then
        If (InWhatK[NumO]=0) or (ChangeOtFor(i)) Then
          Begin
            ChangeKonFor:=True;
            InWhatK[NumO]:=i;
            WhatO[i]:=NumO;
            Exit;
         End;

  ChangeKonFor:=False;
End;

Function ChangeOtFor(NumK : Integer) : Boolean;
  Var i : Integer;
Begin
  ChKonv[NumK]:=True;
  For i:=1 To MaxI do
    If (not (ChOtkr[i])) And (i<>WhatO[NumK])
      Then
        If (WhatO[NumK]=0) Or (ChangeKonFor(i)) Then
          Begin
            ChangeOtFor:=True;
            InWhatK[i]:=NumK;
            WhatO[NumK]:=i;
            Exit;
          End;

  ChangeOtFor:=False;
End;


Procedure Solve;
  Var   i,j : Integer;
   EasyFind : Boolean;
        K,O : MasInt;
Begin
  FillChar(A,SizeOf(A),0);
  For i:=1 To N Do
    For j:=1 To M do
      If (IsIn(Otk[i],Konv[j])) Then A[i,j]:=True;
  FillChar(InWhatK,SizeOf(MasInt),0);
  FillChar(WhatO,SizeOf(MasInt),0);
  Col:=0;
  For i:=1 To N do
    Begin
      MaxI:=i;
      EasyFind:=False;
      For j:=1 To M do
        If (A[i,j]) And (WhatO[j]=0)
          Then
            Begin
              EasyFind:=True;
              WhatO[j]:=i;
              InWhatK[i]:=j;
              Inc(Col);
              Break;
            End;
      If Not EasyFind Then
        Begin
          For j:=1 To M do
            If (A[i,j]) Then
              Begin
                K:=InWhatK;
                O:=WhatO;
                FillChar(ChKonv,SizeOf(MasBol),0);
                FillChar(ChOtkr,SizeOf(MasBol),0);
                If ChangeOtFor(j)
                  Then
                    Begin
                      WhatO[j]:=i;
                      InWhatK[i]:=j;
                      Inc(Col);
                    End
                  Else
                    Begin
                      InWhatK:=K;
                      O:=WhatO;
                    End;
               End;
        End;
    End;
End;

Procedure Print;
  Var Out : Text;
        i : Integer;
Begin
  Assign(Out,'output.txt');
  Rewrite(Out);
  Writeln(Out,Col);
  For i:=1 To N Do
    If InWhatK[i]<>0 Then
      Write(Out,i,' ',InWhatK[i],' ');
  Close(Out);
End;



Begin
  INit;
  Solve;
  Print;
End.