{   ⪨ }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}

{$M 16384,0,655360}

var m, n: integer;
    x1, y1, x2, y2: array [1..100] of integer;
    c: array [1..100, 1..100] of boolean;
    m1, m2: array [1..100] of integer;
    k: integer;
    p: array [1..101] of integer;
    q: array [1..202] of integer;
    v: array [1..101] of boolean;
    qh, qt, qn: integer;

function GetY(x,y,L: double): double;
var c, s, d: double;
begin
  d := Sqr(x)+Sqr(y)-Sqr(L);
  GetY := 1000000;
  if d >= 0 then begin
    c := (x*L-y*Sqrt(d))/(Sqr(x)+Sqr(y));
    s := Sqrt(1-Sqr(c));
    if (c >= 0) and (c <= 1) then
      GetY := x*s+y*c;
  end;
end;

function Inside(x2,y2,x1,y1: integer): boolean;
begin
  Inside := (x2 <= x1) and (y2 <= y1) or
            (x2 <= y1) and (y2 <= x1) or
            (GetY(x2,y2,x1) <= y1+1.0e-6) or
            (GetY(x2,y2,y1) <= x1+1.0e-6);
end;

procedure ReadAll;
var i, j: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Read(m, n);
  for i := 1 to m do
    Read(x1[i], y1[i]);
  for i := 1 to n do
    Read(x2[i], y2[i]);

  for i := 1 to n do
    for j := 1 to m do
      c[i, j] := Inside(x2[i], y2[i], x1[j], y1[j]);
end;

procedure Solve;
var count, ii, i, j, jj: integer;
    f: Boolean;
label brk;
begin
  for k := 1 to N do begin
    qh := 1;
    qt := 1;
    qn := 0;
    Fillchar(v, Sizeof(v), 0);
    Inc(qn);
    qt := 1;
    qh := 1;
    q[qt] := k; Inc(qt);
    v[k] := True;
    while qn > 0 do begin
      i := q[qh]; Inc(qh); Dec(qn);
      for j := 1 to M do
        if c[i, j] then begin
          if m1[j] = 0 then begin
            repeat
              jj := m2[i];
              m2[i] := j;
              m1[j] := i;
              j := jj;
              if i = k then goto Brk;
              i := p[i];
            until false;
          end;
          jj := m1[j];
          if not v[jj] then begin
            q[qt] := jj;
            v[jj] := True;
            p[jj] := i;
            Inc(qt);
            Inc(qn);
          end;
        end;
    end;
Brk:
  end;
  count := 0;
  for i := 1 to n do
    if m2[i] > 0 then Inc(count);
  Writeln(count);
  for i := 1 to n do
    if m2[i] > 0 then
      Write(i, ' ',m2[i],'  ');
  Writeln;
end;

begin
  ReadAll;
  Solve;
end.

