{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
{$N+}
Program Konverts_Otkr;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxN=100;
      MaxM=100;
      Eps=1e-6;
Type TOtk=Array[1..2] Of LongInt;
 Var RsN, RsM: Array[1..MaxN] Of TOtk;
     N, M: Integer;
     IfP: Array[1..MaxN, 1..MaxM] Of Boolean;
     NTo: Array[1..MaxN] Of Integer;
     Was: Array[1..MaxN] Of Boolean;
     sc: Integer;

 Procedure Init;
  Var i, j: Integer;
   Begin
    FillChar(IfP, sizeOf(IfP), False);
    FillChar(RsN, SizeOf(RsN), 0);
    FillChar(RsM, SizeOf(RsM), 0);
    Assign(Input, InputFile);
     Reset(Input);
      Read(N, M);
      For i:=1 To M Do
      For j:=1 To 2 Do Read(RsM[i, j]);
      For i:=1 To N Do
      For j:=1 To 2 Do Read(RsN[i, j]);
     Close(Input);
   End;

 Function Eq(Const a, b: Real): Boolean;
  Begin
   Eq:=Abs(a-b)<Eps;
  End;

 Function ArcSin(Const a: Real): Real;
  Var bb: Real;
   Begin
    bb:=Sqrt(Abs(1-sqr(a)));{!?}
    If Eq(bb, 0) Then ArcSin:=Pi/2
     Else ArcSin:=ArcTan(a/bb);
   End;

 Function More(Const a, b: Real): Boolean;
  Begin
   More:=(a-b)>Eps;
  End;

 Function ArcCos(Const a: Real; Var arc: Real): Boolean;
  Var bb: Real;
   Begin
    ArcCos:=Not More(Abs(a), 1);
    bb:=Sqrt(Abs(1-Sqr(a)));
    If Eq(a, 0) Then Arc:=Pi/2
     Else Arc:=ArcTan(bb/a);
   End;

 Function Getnn(Const a, b, c, d: LongInt): Boolean;
  Var fd, alp1, ff, alp2, ssq: Real;
   Begin
    Getnn:=False;
    ssq:=Sqrt(Sqr(d) + Sqr(c));
    If Not ArcCos(a/ssq, alp1) Then Exit;
    If Not ArcCos(c/ssq, alp2) Then Exit;;
    ff:=c*Cos(alp1+alp2);
    fd:=Sqrt(Sqr(ssq)-Sqr(a));
    If More(fd, ff*2) Then Exit;
    Getnn:=Not More(ff*2-fd, b);
   End;

 Function Poss(Const k, p: Integer): Boolean;
  Var b: Boolean;
   Begin
    b:=((RsN[k, 1]<=RsM[p, 1]) And (RsN[k, 2]<=RsM[p, 2]))
     Or ((RsN[k, 2]<=RsM[p, 1]) And (RsN[k, 1]<=RsM[p, 2]));
    If b Then Poss:=b
    Else
     If ((RsN[k, 1]*RsN[k, 2]>RsM[p, 1]*RsM[p, 2])) Then Poss:=False
    Else
     If ((RsN[k, 1]>RsM[p, 1]) And (RsN[k, 2]>RsM[p, 1])) Then Poss:=False
    Else
     If ((RsN[k, 1]>RsM[p, 2]) And (RsN[k, 2]>RsM[p, 2])) Then Poss:=False
    Else Begin
     Poss:=Getnn(RsM[p, 1], RsM[p, 2], RsN[k, 1], RsN[k, 2])
      Or Getnn(RsM[p, 1], RsM[p, 2], RsN[k, 2], RsN[k, 1])
       Or Getnn(RsM[p, 2], RsM[p, 1], RsN[k, 1], RsN[k, 2])
      Or Getnn(RsM[p, 2], RsM[p, 1], RsN[k, 2], RsN[k, 1]);
    End;
   End;

 Function RecOtk(Const k: Integer): Boolean; ForWard;


{ Function RecConv(Const k: Integer): Boolean;
  Var i: Integer;
   Begin
    RecConv:=False;
    For i:=1 To N Do
    If IfP[i, k] And (((RecOtk(i)))) Then Begin
     MTo[k]:=i;
     RecConv:=True;
     Exit;
    End;
   End;
 }
 Function RecOtk(Const k: Integer): Boolean;
  Var i: Integer;
   Begin
    RecOtk:=False;
    If Not Was[k] Then Begin
     Was[k]:=True;
     For i:=1 To M Do
     If IfP[k, i] And ((NTo[i]=0) Or RecOtk(NTo[i])) Then Begin
{       NTo[k]:=i;}
       NTo[i]:=k;
       RecOtk:=True;
       Exit;
     End;
    End;
   End;

 Procedure Solve;
  Var i, j: Integer;
   Begin
    FillChar(IfP, SizeOf(IfP), False);
    FillChar(NTo, SizeOf(NTo), 0);
{     N:=5; M:=6;
     IfP[1, 2]:=True;
     IfP[1, 3]:=True;
     IfP[1, 4]:=True;
     IfP[2, 1]:=True;
     IfP[2, 2]:=True;
     IfP[2, 3]:=True;
     IfP[3, 1]:=True;
     IfP[4, 6]:=True;
     IfP[5, 3]:=True;}
    For i:=1 To N Do
    For j:=1 To M Do
     IfP[i, j]:=Poss(i, j);
     sc:=0;
    FillChar(NTo, SizeOf(NTo), 0);
    For i:=1 To N Do Begin
     FillChar(Was, SizeOf(Was), False);
     If RecOtk(i) Then Inc(sc);
    End;
{    N:=i;}
   End;

 Procedure Done;
  Var i, j: Integer;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      WriteLn(sc);
      For i:=1 To M do
      If NTO[i]<>0 Then Write(NTo[i], ' ', i, '         ');
     Close(Output);
   End;

BEGIN
 Init;
  Solve;
 Done;
END.