{ ⭨ }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

type float = double;
const eps = 1.0e-8;
var x, y: array [0..500] of float;
    n: integer;
    r: float;
    last, count: integer;
    nx, ny, way, cx, cy, ca, cl: float;

procedure ReadAll;
var i, j: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Read(i, r);
  for i := 1 to i do begin
    Inc(n);
    Read(x[n], y[n]);
    if y[n] >= 0 then Dec(n);
  end;
end;

function GetAngle(x, y: float): float;
var a: float;
begin
  if Abs(x) < eps then begin
    if y > 0 then a := pi/2 else a := -pi/2;
  end else begin
    a := arctan(y/x);
    if x < 0 then a := a - pi;
  end;
  if a < ca then begin
    a := a + Int((ca-a)/(2*pi))*2*pi;
    while a < ca do a := a + 2*pi;
  end;
  GetAngle := a;
end;

procedure Solve;
var next, i: integer;
    dnext, da: float;
    ff: boolean;
begin
  x[0] := 0;
  y[0] := 0;
  last := 0;
  count := 0;
  cx := -r;
  cy := 0;
  ca := -pi;
  cl := r;
  way := 0;
  repeat
    ff := false;
    dnext := 1.0e+30;
    next := 0;
    for i := 1 to N do
      if (Sqrt(Sqr(x[last]-x[i])+Sqr(y[last]-y[i])) <= cl+eps) and (i <> last) then
      begin
        da := GetAngle(x[i]-x[last], y[i]-y[last]);
        if (da > ca) and (da < dnext) then begin
          dnext := da;
          next := i;
          ff := false;
        end;
      end;
    if (next = 0) or
       (y[last] + cl * sin(dnext) > 0) then
    begin
      if cl <= -y[last]-eps then { FIXME }
        Writeln(2*pi*cl)
      else
        Writeln(2*(way+cl*(GetAngle(Sqrt(Sqr(cl)-Sqr(y[last])), -y[last]) - ca)));
      Halt;
    end;
    way := way + cl * (dnext - ca);
    da := dnext;
    cx := x[last] + cl * cos(dnext);
    cy := y[last] + cl * sin(dnext);
    ca := dnext;
    cl := cl - Sqrt(Sqr(x[last]-x[next]) + Sqr(y[last]-y[next]));
    last := next;
  until false;
end;

begin
  ReadAll;
  Solve;
end.