{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  MaxN=14;
Var
  N:Byte;
  X,Y,V,L:Array[0..MaxN+1]Of LongInt;
  BestCost:LongInt;
  BestLive:Byte;
  BestOver:Extended;
  BestMap:Word;
Procedure Load;
Var
  I:Byte;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  Read(N);
  For I:=0 To N-1 Do If Not SeekEOF Then Read(X[I],Y[I],V[I],L[I]);
  Close(Input);
End;
Procedure Run;
Var
  BitMap:Word;
  I:Byte;
  Will:Array[0..MaxN-1]Of Boolean;
  NeedWood:Extended;
  SumCost,SumWood:LongInt;
  Live:Byte;
  MinI,StartI,CurI,PrevI:Byte;
  NrmKoef:LongInt;
  A,B,C,CC,D:LongInt;
  CurR,MinR:Extended;
  MinRD,CurRD:Extended;
Begin
  BestCost:=MaxLongInt;
  X[N]:=MaxLongInt;
  Y[N]:=MaxLongInt;
  For BitMap:=1 To (1 Shl N)-1 Do Begin
    SumCost:=0;
    SumWood:=0;
    Live:=0;
    For I:=0 To N-1 Do Begin
      Will[I]:=BitMap And (1 Shl I)>0;
      If Will[I] Then Inc(Live) Else Begin
        SumCost:=SumCost+V[I];
        SumWood:=SumWood+L[I];
      End;
    End;
    If SumCost>BestCost Then Continue;
    Case Live Of
      1:NeedWood:=0;
      Else Begin
        MinI:=N;
        For I:=0 To N-1 Do If Will[I] And ((X[I]<X[MinI]) Or (X[I]=X[MinI]) And (Y[I]<Y[MinI])) Then MinI:=I;
        CurI:=MinI;
        StartI:=MinI;
        NeedWood:=0;
        X[N+1]:=X[MinI]+1;
        Y[N+1]:=Y[MinI]-20001;
        PrevI:=N+1;
        Repeat
          A:=Y[CurI]-Y[PrevI];
          B:=X[PrevI]-X[CurI];
          C:=-(A*X[CurI]+B*Y[CurI]);
          NrmKoef:=A*A+B*B;
          MinR:=-1E+30;
          MinI:=N+1;
          For I:=0 To N-1 Do If Will[I] And ((X[I]<>X[CurI]) Or (Y[I]<>Y[CurI])) Then Begin
            D:=A*X[I]+B*Y[I]+C;
            If D>0 Then Begin
              CurRD:=Sqr(X[I]-X[CurI])+Sqr(Y[I]-Y[CurI]);
              CurR:=(CurRD-1.0*D*D/NrmKoef)/(1.0*D*D);
              If (X[CurI]-X[PrevI])*(X[I]-X[CurI])+(Y[CurI]-Y[PrevI])*(Y[I]-Y[CurI])<0 Then CurR:=-CurR;
              If ((Abs(CurR-MinR)<1E-6) And (CurRD>MinRD)) Or (CurR>MinR+1E-6) Then
                Begin MinR:=CurR; MinRD:=CurRD; MinI:=I; End;
            End;
          End;
          If MinI=N+1 Then Begin
            NeedWood:=NeedWood*2;
            Break;
          End;
          NeedWood:=NeedWood+Sqrt(Sqr(X[MinI]-X[CurI])+Sqr(Y[MinI]-Y[CurI]));
          PrevI:=CurI;
          CurI:=MinI;
        Until CurI=StartI;
      End;
    End;
    If (SumWood>NeedWood-1E-6) And ((SumCost<BestCost) Or ((SumCost=BestCost) And (Live>BestLive))) Then Begin
      BestCost:=SumCost;
      BestLive:=Live;
      BestMap:=BitMap;
      BestOver:=SumWood-NeedWood;
    End;
  End;
End;
Procedure Save;
Var
  I:Byte;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  Write('Cut these trees:');
  For I:=1 To N Do If (BestMap And (1 Shl (I-1)))=0 Then Write(' ',I);
  WriteLn;
  WriteLn('Extra wood: ',BestOver:0:10);
  Close(Output);
End;
Begin
  Load;
  Run;
  Save;
End.