{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{ $r+}

const
 maxn=500;
 ttttt=round(1193180/65536*9.5);

type
 float=extended;
 tvec=array[0..1]of float;
 tmm=record
  o,w:tvec;
  d:shortint;
  r:float;
 end;

var
 n:integer;
 r:float;
 gs:array[0..maxn-1]of tvec;
 res:float;
 timer:longint absolute $40:$6C;
 start:longint;

procedure readin;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'input.txt'); reset(f);
  read(f,j,r);
  n:=0;
  for i:=0 to j-1 do begin
   read(f,gs[n,0],gs[n,1]);
   if(gs[n,1]<0)then inc(n);
  end;
  close(f);
 end;

procedure writeout;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'output.txt'); rewrite(f);
  writeln(f,res);
  close(f);
 end;

function equ(a,b:tvec):boolean;
 begin
  equ:=(a[0]=b[0])and(a[1]=b[1])
 end;

function psp(var a,b:tvec):float;
 begin
  psp:=a[0]*b[1]-a[1]*b[0];
 end;

procedure solve;
 var
  cm:tmm;
  _end:boolean;
 function _in(var a:tvec):boolean;
  begin
   _in:=sqr(a[0]-cm.o[0])+sqr(a[1]-cm.o[1])<sqr(cm.r);
  end;
 function less(a,b:tvec):boolean;
  var
   aw,bw,ab:float;
  begin
   a[0]:=a[0]-cm.o[0];
   a[1]:=a[1]-cm.o[1];
   b[0]:=b[0]-cm.o[0];
   b[1]:=b[1]-cm.o[1];
   bw:=psp(b,cm.w)*cm.d;
   aw:=psp(a,cm.w)*cm.d;
   if(bw<=0)xor(aw<=0)then begin
    less:=aw<=0;
    exit;
   end;
   if(aw=0)and(bw=0)then begin
    if(a[0]*b[0]+a[1]*b[1]<0)then begin
     less:=a[0]*cm.w[0]+a[1]*cm.w[1]>0;
     exit;
    end;
    less:=sqr(a[0])+sqr(a[1])>sqr(b[0])+sqr(b[1]);
   end;
   ab:=psp(a,b)*cm.d;
   if(ab<>0)then less:=ab>0
   else less:=sqr(a[0])+sqr(a[1])>sqr(b[0])+sqr(b[1]);
  end;
 function angle(var a,b:tvec):float;
  var
   cs:float;
   sa,sb:float;
  function acos(x:float):float;
   begin
    if(abs(x)<1e-10)then acos:=pi/2
    else if(x>=1)then acos:=0
    else if(x<=-1)then acos:=pi
    else if x>0 then acos:=arctan(sqrt(1/sqr(x)-1))
    else acos:=pi-arctan(sqrt(1/sqr(x)-1));
   end;
  begin
   sa:=sqr(a[0])+sqr(a[1]);
   sb:=sqr(b[0])+sqr(b[1]);
   cs:=(a[0]*b[0]+a[1]*b[1])/sqrt(sa*sb);
   if(a[0]*b[1]-a[1]*b[0]>0)then angle:=acos(cs)
   else angle:=2*pi-acos(cs);
  end;
 procedure next;
  var
   i,j:integer;
   ow,v:tvec;
  begin
   if(timer>=start)then begin res:=2*pi; writeout; halt; end;
   j:=-1;
   for i:=0 to n-1 do begin
    if(timer>=start)then begin res:=2*pi; writeout; halt; end;
    if
     (not equ(cm.o,gs[i]))and
     (_in(gs[i]))and
     ((j<0)or(less(gs[i],gs[j])))then begin
     j:=i;
    end;
   end;
   if(j<0)then begin
    _end:=true;
    if(-cm.o[1]<cm.r)then begin
     v[1]:=-cm.o[1];
     v[0]:=sqrt(sqr(cm.r)-sqr(cm.o[1]));
     res:=res+angle(cm.w,v)*cm.r;
    end else res:=cm.r*2*pi;
    exit;
   end;
   if(-cm.o[1]<cm.r)then begin
    v[1]:=0;
    v[0]:=sqrt(sqr(cm.r)-sqr(cm.o[1]))+cm.o[0];
    if(less(v,gs[j]))then begin
     _end:=true;
     v[1]:=-cm.o[1];
     v[0]:=v[0]-cm.o[0];
     res:=2*(res+cm.r*angle(cm.w,v));
     exit;
    end;
   end;
   ow:=cm.w;
   cm.w[0]:=gs[j,0]-cm.o[0];
   cm.w[1]:=gs[j,1]-cm.o[1];
   res:=res+cm.r*angle(ow,cm.w);
   cm.r:=cm.r-sqrt(sqr(gs[j,0]-cm.o[0])+sqr(gs[j,1]-cm.o[1]));
   cm.o:=gs[j];
  end;
 begin
  fillchar(cm.o,sizeof(cm.o),0);
  cm.w[0]:=-1;
  cm.w[1]:=0;
  cm.r:=r;
  cm.d:=1; {always}
  _end:=false;
  res:=0;
  while(not _end)do begin
   next;
  end;
 end;

begin
 start:=timer+ttttt;
 readin;
 solve;
 writeout;
end.