{$A+,B-,D-,E+,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
{$N+}
Program Mayitnik;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxN=500;
      Pi=system.Pi;
      Eps=1e-6;
Type TPoint=Record
      x, y: Real;
     End;
 Var A: Array[1..MaxN] Of TPoint;
     B: Array[1..MaxN] Of Real;
     Cd: Array[1..MaxN] Of Integer;
     N: Integer;
     rmt: Real;
     rs: Real;



 Procedure Init;
  Var i: Integer;
   Begin
    Assign(Input, InputFile);
     Reset(Input);
      Read(N, rmt);
      For i:=1 To N Do Read(A[i].x, A[i].y);
     Close(Input);
   End;

 Function GetOrb(Const r, b: Real): Real;
  Begin
   GetOrb:=2*Pi*r;
  End;

 Function Rast(Const x1, y1: Real): Real;
  Begin
   Rast:=Sqrt(Sqr(x1) + Sqr(y1));
  End;

 function Eq(const a, b: Real): Boolean;
  Begin
   Eq:=Abs(a-b)<Eps;
  End;

 function More(const a, b: Real): Boolean;
  Begin
   More:=(a-b)>Eps;
  End;

 Function GetAlp(Const x1, y1, x2, y2: real): Real;
  Var aa, bb, cc: Real;
   Begin
    aa:=(x1-x2)*(100);
    bb:=(y1-y2)*0;
    cc:=Rast(x1-x2, y1-y2)*Rast(100, 0);
    If Eq(cc, 0) Then GetAlp:=-1
     Else GetAlp:=(aa+bb)/cc;
   End;

 Procedure SwapR(Var a, b: Real);
  Var c: Real;
   Begin
    c:=a; a:=b; b:=c;
   End;

 Procedure SwapI(Var a, b: Integer);
  Var d: Integer;
   Begin
    d:=a; a:=b; b:=d;
   End;

 Procedure Sort(Const k: Integer);
  Var i, j: Integer;
   Begin
    For i:=1 To k-1 Do
    For j:=i+1 To k Do
     If More(B[i], B[j]) Then Begin
      SwapR(B[i], B[j]);
      SwapI(Cd[i], Cd[j]);
    End;
   End;

 Procedure SortAll(Const ci, cj: Real; Var sc: Integer);
  Var i: Integer;
   Begin
    sc:=0;
    For i:=1 To N Do
    If A[i].y<=cj Then Begin
     Inc(sc);
      Cd[i]:=i;
     B[sc]:=GetAlp(A[i].x, A[i].y, ci, cj);
    End;
    Sort(sc);
   End;

 Function FindNext(Var ci, cj, cr: Real): Boolean;
  Var i, k: Integer;
   Begin
    SortAll(ci, cj, k);
    i:=1;
    While (i<=k) And
    More(Sqr(ci-A[Cd[i]].x) + Sqr(cj-A[Cd[i]].y), Sqr(cr))
     Do Inc(i);
    FindNext:=i<=N;
    If i<=N Then Begin
     cr:=cr-Sqrt(Sqr(ci-A[Cd[i]].x) + Sqr(cj-A[Cd[i]].y));
      If Eq(ci, A[Cd[i]].x) And Eq(cj, A[Cd[i]].y) Then Begin
       FindNext:=False;
       Exit;
      End;
     ci:=A[Cd[i]].x;
     cj:=A[Cd[i]].y;
    End;
   End;

 Procedure Solve;
  Var i, j: Integer;
      ci, cj, cr: Real;
   Begin
    ci:=0; cj:=0; cr:=rmt;
    While FindNext(ci, cj, cr) Do;
    rs:=Pi*2*cr;
   End;

 Procedure Done;
  Begin
   Assign(Output, OutputFile);
    Rewrite(Output);
     WriteLn(rs:0:2);
    Close(Output);
  End;

BEGIN
 Init;
  Solve;
 Done;
END.