{$A+,B-,D-,E+,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
{$N+}
Program Ograda;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxN=14;
      CutT='Cut these trees: ';
      ExtraWood='Extra wood: ';
      Eps=1e-6;
      Ogr=9.5*18.2;
Type TTRee=Record x, y, v, l: LongInt; End;
     BMas=Array[-1..MaxN] Of Integer;
     Sset=Set Of Byte;
 Var A: Array[0..MaxN] Of TTree;
     N: Integer;
     whb: Array[1..MaxN] Of Integer;
     Nw, Rs: BMas;
     scRs, scNw: Integer;
     rRs, RNw: Real;
     Timer: LongInt Absolute $0000:$046c;
     Tm: LongInt;


 Procedure Init;
  Var i: Integer;
   Begin
    scRs:=MaxInt; scNw:=0;
     FillChar(Rs, SizeOf(Rs), 0);
     FillChar(Nw, SizeOf(Nw), 0);
    FillChar(A, SizeOf(A), 0);
    Assign(Input, InputFile);
     Reset(Input);
      Read(N);
      For i:=1 To N Do Read(A[i].x, A[i].y, A[i].v, A[i].l);
     Close(Input);
    For i:=1 To N Do whb[i]:=i;
     Tm:=Timer;
   End;

 Procedure Swap(Var a, b: Integer);
  Var c: Integer;
   Begin
    c:=a; a:=b; b:=c;
   End;

 Procedure SwapMs(Var a, b: TTree);
  Var c: TTree;
   Begin
    c:=a; a:=b; b:=c;
   End;

 Procedure Sort;
  Var i, j: Integer;
   Begin
    For i:=1 To N-1 Do
    For j:=i+1 To N Do
     If A[i].v>A[j].v Then Begin
      SwapMs(A[i], A[j]);
      Swap(whb[i], whb[j]);
     End;
   End;

Var ls: Integer;
    Can: Array[1..MaxN] Of Boolean;

 Function Eq(Const a, b: Real): Boolean;
  Begin
   Eq:=Abs(a-b)<Eps;
  End;

 Function Less(Const a, b: Real): Boolean;
  Begin
   Less:=(b-a)>Eps;
  End;

 Function Rast(Const k, p: Integer): Real;
  Begin
   Rast:=Sqrt(Sqr(A[k].x-A[p].x) + Sqr(A[k].y-A[p].y));
  End;

 Function GetAlp(Const i, j, k: Integer): Real;
  Var aa, bb, cc: Real;
   Begin
    aa:=(A[j].x - A[i].x)*(A[k].x-A[j].x);
    bb:=(A[j].y - A[i].y)*(A[k].y-A[j].y);
    cc:=Rast(i, j)*Rast(j ,k);
    If Eq(cc, 0) Then GetAlp:=-4
    Else GetAlp:=(aa+bb)/cc;
   End;

 Function IfProv: Boolean;
  Var i, j, nn, ls, fk, mn: Integer;
      Cn: Sset;
      rps, fnn, sdf: Real;
   Begin
    mn:=MaxInt;
     rps:=Nw[-1];
    For i:=1 To N Do
    If Can[i] And ((A[i].x<mn) Or ((A[i].x=mn) And (A[i].y>A[j].y))) Then Begin
     mn:=A[i].x;
     j:=i;
    End;
     fk:=j; ls:=0;
     A[0]:=A[j];
     Dec(A[0].y);

      Cn:=[];
    Repeat
     nn:=0; fnn:=-6;
     For i:=1 To N Do
     If Can[i] Then Begin
      sdf:=GetAlp(ls, j, i);
       If Less(fnn, sdf) Then Begin
         nn:=i;
         fnn:=sdf;
        End;
     End;
      rps:=rps-Rast(j, nn);
      ls:=j;
      j:=nn;
    Until j=fk;
     rNw:=rps;
    IfProv:=Not Less(rps, 0);
   End;

 Procedure Done;
  Var i: Integer;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      Write(CutT);
      For i:=1 To Rs[0] Do Write(whb[Rs[i]], ' ');
       WriteLn;
      Write(ExtraWood, rRs:0:2);
{      For i:=1 To Rs[0] Do Write(Rs[i], ' ');}
     Close(Output);
    Halt;
   End;

 Procedure Rec(Const k, sc: Integer);
  Var i: Integer;
   Begin
    If Timer-Tm>Ogr Then Done
    Else
    If IfProv Then Begin
     If sc<scRs Then Begin
      scRs:=sc;
      Rs:=Nw;
      Rs[0]:=k-1;
      rRs:=rNw;
     End;
     If (sc=scRs) And (k-1<Rs[0]) Then Begin
      scRs:=sc;
      Rs:=Nw;
      Rs[0]:=k-1;
      rRs:=rNw;
     End;
    End
     Else
    If k=N Then Exit
     Else
    For i:=ls+1 To N Do Begin
     Can[i]:=False;
     ls:=i;
      Nw[k]:=i;
      Inc(Nw[-1], A[i].l);
       Rec(k+1, sc + A[i].v);
       Can[i]:=True;
      Nw[k]:=0;
     Dec(Nw[-1], A[i].l);
    End;
   End;

 Procedure Solve;
  Begin
   ls:=0;
   Sort;
    FillChar(Can, SizeOf(Can), True);
   Rec(1, 0);
  End;

BEGIN
 Init;
  Solve;
 Done;
END.