#define MAX		15

#include <conio.h>
#include <stdio.h>
#include <mem.h>
#include <time.h>
#include <process.h>
#include <math.h>


void input ();
void output ();
void solve (int num);
float round ();

int n, mater = 0, sum = 0, trees = 0, best_sum = 30000, best_trees = 30000;
int min;
int current [MAX], best [MAX];
float len [MAX] [MAX];
float best_extra;


typedef struct
			{
				int x, y, v, l;
			} tree;

tree array [MAX];


main ()
 {
	 input ();
	 solve (0);
	 output ();

	 return (0);
 }




void input ()
 {
	int x, y;

	FILE * file = fopen ("input.txt", "r");
	fscanf (file, "%d", & n);

	for (int index = 0; index < n; index ++)
	 fscanf (file, "%d %d %d %d", & array [index]. x, & array [index]. y,
											& array [index]. v, & array [index]. l);
	fclose (file);

	memset (current, 1, n << 1);

	for (x = 0; x < n; x ++)
	  for (y = 0; y < n; y ++)
		len [x] [y] = sqrt ((array [x]. x - array [y]. x) * (array [x]. x - array [y]. x) +
							(array [x]. y - array [y]. y) * (array [x]. y - array [y]. y));

	printf ("aft %d %d\n", array [0]. x, array [0]. y);
	printf ("aft %d %d\n", array [2]. x, array [2]. y);
	printf ("aft %d\n", len [0] [2]);

	x = y = 30000;

	for (index = 0; index < n; index ++)
	 if (array [index]. x < x)
	  x = array [index]. x;

	for (index = 0; index < n; index ++)
	 if (array [index]. y < y)
	  y = array [index]. y;

	for (index = 0; index < n; index ++)
	 {
		array [index]. x += -x + 1;
		array [index]. y += -y + 1;
	 }
 }


void output ()
 {
	FILE * file = fopen ("output.txt", "w");
	fprintf (file, "Cut these trees: ");

	for (int index = 0; index < n; index ++)
	 if (! best [index])
	  fprintf (file, "%d ", index + 1);

	fprintf (file, "\nExtra wood: %f", best_extra);

	fclose (file);
 }


void solve (int num)
 {
	float borders;

	if (num == n)
	 {
//		printf ("H ");
		if (((borders = round ()) <= mater) &&
			((best_sum > sum) || ((best_sum == sum) && (best_trees >= trees))))
		  {
			 memcpy (best, current, n << 1);
			 best_extra = mater - borders;
			 best_sum = sum;
			 best_trees = trees;
		  }

		return;
	 }

	if ((int) (clock () / CLK_TCK) > 9) //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	 {
		output ();
		exit (0);
	 }

	solve (num + 1);

	current [num] = 0;
	sum += array [num]. v;
	trees ++;
	mater += array [num]. l;

	solve (num + 1);

	current [num] = 1;
	sum -= array [num]. v;
	trees --;
	mater -= array [num]. l;
 }


float round ()
 {
	int cur, next, note, max_note = 2, flag = 0, min_num = 30000, m_note;
	float materi = 0, temp, max;

	for (note = 0; note < n; note ++)
	 if (current [note])
	  {
		flag ++;

		if (array [note]. x < min_num)
		 {
			min_num = array [note]. x;
			min = note;
		 }
	  }

	cur = min;

	if ((! flag) || (flag == 1))
	 return (0);

	do
	 {
		max = -1.e10;
//		max_note = -1;

		for (int index = 0; index < n; index ++)
		 if ((index != cur) && (current [index]))
		  {
			 temp = (((float) (array [index]. y - array [cur]. y)) /
						 ((float) (array [index]. x - array [cur]. x) + 1e-5));
			 if (array [index]. x >= array [cur]. x)
			  {
				if (array [index]. y > array [cur]. y)
				 note = 2;
				else
				 note = 1;
			  }
			 else
			  {
				if (array [index]. y > array [cur]. y)
				 note = 3;
				else
				 note = 0;
			  }

			if ((note == m_note) && (temp > max))
			 {
				max = temp;
				max_note = note;
				next = index;
			 }
		  }

		if (max == -1.e10)

		for (int index = 0; index < n; index ++)
		 if ((index != cur) && (current [index]))
		  {
			 temp = (((float) (array [index]. y - array [cur]. y)) /
						 ((float) (array [index]. x - array [cur]. x) + 1e-5));
			 if (array [index]. x >= array [cur]. x)
			  {
				if (array [index]. y > array [cur]. y)
				 note = 2;
				else
				 note = 1;
			  }
			 else
			  {
				if (array [index]. y > array [cur]. y)
				 note = 3;
				else
				 note = 0;
			  }

			if ((note == (m_note + 3) % 4) && (temp > max))
			 {
				max = temp;
				max_note = note;
				next = index;
			 }
		  }

		if (max == -1.e10)

		for (int index = 0; index < n; index ++)
		 if ((index != cur) && (current [index]))
		  {
			 temp = (((float) (array [index]. y - array [cur]. y)) /
						 ((float) (array [index]. x - array [cur]. x) + 1e-5));
			 if (array [index]. x >= array [cur]. x)
			  {
				if (array [index]. y > array [cur]. y)
				 note = 2;
				else
				 note = 1;
			  }
			 else
			  {
				if (array [index]. y > array [cur]. y)
				 note = 3;
				else
				 note = 0;
			  }

			if ((note == (m_note + 2) % 4) && (temp > max))
			 {
				max = temp;
				max_note = note;
				next = index;
			 }
		  }

		if (max == -1e10)

		for (int index = 0; index < n; index ++)
		 if ((index != cur) && (current [index]))
		  {
			 temp = (((float) (array [index]. y - array [cur]. y)) /
						 ((float) (array [index]. x - array [cur]. x) + 1e-5));
			 if (array [index]. x >= array [cur]. x)
			  {
				if (array [index]. y > array [cur]. y)
				 note = 2;
				else
				 note = 1;
			  }
			 else
			  {
				if (array [index]. y > array [cur]. y)
				 note = 3;
				else
				 note = 0;
			  }

			if ((note == (m_note + 1) % 4) && (temp > max))
			 {
				max = temp;
				max_note = note;
				next = index;
			 }
		  }
		materi += len [cur] [next];

		cur = next;
		m_note = max_note;
	 }
	while (cur != min);

	return (materi);
 }
