program Majatnik;
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

const
{$ifdef ILIA}
  InFile='a.in';
  OutFile='a.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type Real=Extended;
var
  N:word;
  gv:array[0..500] of record x,y:real; end;
  R:real;


procedure ReadData;
  var i:word;
  begin
  Assign(input,InFile);
  Reset(Input);
  read(N,r);
  for i:=1 to N do
    with gv[i] do
      read(x,y);
  Close(Input);
  end;

const eps=1e-5;

var S:real;

procedure WriteSol;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  writeln(S:2:2);
  Close(Output);
  end;

function arccos(x:real):real;
  var y:real;
  begin
  if abs(x)<eps then
    arccos:=pi/2
  else begin
    y:=arctan(sqrt(sqr(1/x)-1));
    if x<0 then
      arccos:=pi-y
    else
      arccos:=y;
  end;
  end;

function angle(a,b:word): real;
  var cs:real;
  begin
  cs:=(gv[a].x-gv[b].x)/sqrt(sqr(gv[a].x-gv[b].x)+sqr(gv[a].y-gv[b].y));
  if gv[a].y<=gv[b].y then
    angle:=2*pi-arccos(cs)
  else
    angle:=arccos(cs);
  end;


function d(a,b:word):real;
  begin
  d:=sqrt(sqr(gv[a].x-gv[b].x)+sqr(gv[a].y-gv[b].y));
  end;

procedure Run;
  var no:word;
      phi:real;
      l:real;
      bestn:word;
      bestphi:real;
      phi1:real;
      i:word;
  begin
  S:=0;
  gv[0].x:=0;
  gv[0].y:=0;
  no:=0;
  phi:=0;
  l:=r;
  repeat
{    writeln(no,' ',phi:2:2,' ',l:2:2);}
    bestphi:=2*pi+phi;
    bestn:=0;
    for i:=1 to N+1 do
      if (i>N) or ((i<>no) and (d(no,i)<l)) then begin
        if i<>N+1 then
          phi1:=angle(no,i)
        else if -gv[no].y<=l then
          phi1:=1.5*pi-arccos(-gv[no].y/l)
        else continue;
        if phi1<phi then
          phi1:=phi1+2*pi;
        if (phi1<bestphi) then begin
          bestphi:=phi1;
          bestn:=i;
        end;
      end;
    if bestn=0 then begin
      S:=2*pi*l;
      exit;
    end;
    S:=S+2*(bestphi-phi)*l;
    if bestn=N+1 then exit;
    l:=l-d(no,bestn);
    phi:=bestphi;
    if phi>2*pi then phi:=phi-2*pi;
    no:=bestn;
  until false;
  end;

begin
ReadData;
Run;
WriteSol;
end.