{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
 var
   x0,y0,x,y: array [1..8] of extended;
   xx,yy,zz: array [1..8] of extended;
   ccc: array [1..8,1..8] of extended;
   p: array [1..8] of integer;
   v: array [1..8] of boolean;
   s: boolean;
   tm: longint absolute 0:$46c;
   stm,kk: longint;

 procedure ReadAll;
 var  i: Integer;
 begin
   Assign(Input, 'input.txt');
   Reset(Input);

   for i := 1 to 8 do Read(x0[i],y0[i]);

   Close(Input);
 end;

 function ll(a,b: integer): extended;
 begin
   ll := sqrt (sqr(xx[a]-xx[b]) + sqr(yy[a]-yy[b]) + sqr(zz[a]-zz[b]) );
 end;

 function cc(a,b: integer): extended;
 begin
   cc := sqr(xx[a]-xx[b])+sqr(yy[a]-yy[b]);
 end;

 procedure cck(l: extended);
 var  i: Integer;al:extended;
 begin
   if (l<1e-3) or (abs(l - round(l)) > 1e-3) then exit;

   zz[1] := 0;
   zz[2] := (l*l) - cc(1,2);
   zz[3] := 2*(l*l) - cc(1,3);
   zz[4] := (l*l) - cc(1,4);
   zz[5] := (l*l) - cc(1,5);
   zz[6] := 2*(l*l) - cc(1,6);
   zz[7] := 3*(l*l) - cc(1,7);
   zz[8] := 2*(l*l) - cc(1,8);
   for i := 1 to 8 do if abs(zz[i])<1e-7 then zz[i] := 0;
   for i := 2 to 8 do begin
     if zz[i]<0 then exit;
     zz[i] := sqrt(zz[i]);
   end;

   if abs(ll(1,2)-l)>1e-5 then exit;
   if abs(ll(2,3)-l)>1e-5 then exit;
   if abs(ll(3,4)-l)>1e-5 then exit;
   if abs(ll(4,1)-l)>1e-5 then exit;
   if abs(ll(5,6)-l)>1e-5 then exit;
   if abs(ll(6,7)-l)>1e-5 then exit;
   if abs(ll(7,8)-l)>1e-5 then exit;
   if abs(ll(8,5)-l)>1e-5 then exit;
   if abs(ll(1,5)-l)>1e-5 then exit;
   if abs(ll(2,6)-l)>1e-5 then exit;
   if abs(ll(3,7)-l)>1e-5 then exit;
   if abs(ll(4,8)-l)>1e-5 then exit;

   s := true;
 end;

 procedure CkUp;
 var
   i, j: Integer;
   l,bbb,ccc,dd,u: extended;
 begin
   for i := 1 to 8 do begin
     xx[i] := x[i];
     yy[i] := y[i];
   end;
   bbb := cc(1,2)+cc(1,5);
   u := (cc(2,5)-cc(1,2)-cc(1,5))/2;
   ccc := cc(1,2)*cc(1,5) - (u*u);
   dd := sqr(bbb) - (4*ccc);
   if abs(dd)<1e-5 then dd := 0;
   if dd<0 then exit;
   l := (bbb + sqrt(dd))/2;
   if l>0 then cck(sqrt(l));
   if s then exit;
   l := (bbb - sqrt(dd))/2;
   if l>0 then cck(sqrt(l));
   if s then exit;
 end;

 procedure ck;
 var
   i: Integer;
 begin
   for i := 1 to 8 do x[i] := x0[p[i]];
   for i := 1 to 8 do y[i] := y0[p[i]];
   CkUp;
 end;

 procedure bld(k: integer);
 var
   x: integer;
 begin
   if tm>stm then exit;
   if k>8 then begin
     ck;
     exit;
   end;
   for x := 1 to 8 do if not v[x] then begin
     v[x] := true;
     p[k] := x;
     bld(k+1);
     if s then exit;
     v[x] := false;
   end;
 end;

 procedure Solve;
 begin
   s := false;
   fillchar(v, sizeof(v),0);
   bld(1);
 end;

 procedure Out;
 var  i: Integer;
 begin
   Assign(Output, 'output.txt');
   ReWrite(Output);

   if s then begin
     for i := 1 to 4 do
        Writeln(xx[i*2-1]:0:15, ' ', yy[i*2-1]:0:15, ' ', zz[i*2-1]:0:15, ' ',
                xx[i*2]:0:15, ' ', yy[i*2]:0:15, ' ', zz[i*2]:0:15);
   end else WriteLn('NO SOLUTIONS');

   Close(Output);
 end;

 begin
   stm := tm+165;
   ReadAll;
   Solve;
   Out;
 end.