{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{ $r+}

{$undef debug}

const
 maxn=26;
 maxk=10*10;
 maxl=6*maxk+10;
{$ifndef debug}
 ttttt=round(1193180/65536*9.5);
{$else}
 ttttt=round(1193180/65536*9500);
{$endif}

const
 dqe=0;
 dqr=1;
 dge=2;
 dgr=3;
 dse=4;
 dsr=5;
 dinit=6;
 ddone=7;

 lentry=0;
 lexit=1;
 lwe=2;
 lwr=3;
 ltr=4;
 lte=5;
 ltrr=8;
 lsr=6;
 lse=7;

 nat=maxlongint;

const
 prio:array[0..7]of integer=(0,0,1,1,0,0,0,0);

type
 (*te=record {event}
  id:integer;
  what:integer;
  t:longint;
 end;*)
 tss=array[0..maxl-1]of record
  id:byte;
  start:longint;
  d:array[0..1]of integer;
 end;

var
 an:integer;
 as:array[0..maxn-1]of record
  id:char;
  come:longint;
  kn,tar:integer;
  ks:array[0..maxk]of integer;
  ts:array[0..maxk-1]of longint;
  cf:integer;
 end;
 {en:integer;
 es:array[0..maxe-1]of te;}
 ls:array[0..maxn-1]of record
  sn:integer;
  ss:^tss;
 end;
 left:array[0..maxn-1]of boolean;
 leftn:integer;
 hd:array[0..maxn-1]of record
  d:integer;
  e:boolean;
  t:longint;
  wh,fr:integer;
 end;
 lts:array[0..9]of longint;
 kts:array[0..maxk-1]of longint;
 ltn:array[0..9]of longint;
 ktn:array[0..maxk-1]of longint;
 start:longint;
 timer:longint absolute $40:$6C;

function tni(var s:string):longint;
 var
  l:integer;
  a,b,c:integer;
 begin
  l:=length(s);
  a:=(byte(s[l  ])-48)+10*(byte(s[l-1])-48);
  b:=(byte(s[l-3])-48)+10*(byte(s[l-4])-48);
  c:=(byte(s[l-6])-48)+10*(byte(s[l-7])-48);
  tni:=a+60*(b+60*longint(c));
 end;

function tin(t:longint):string;
 var
  h,m,s:integer;
 begin
  s:=t mod 60; t:=t div 60;
  m:=t mod 60; h:=t div 60;
  tin:=
   char(h div 10+48)+char(h mod 10+48)+':'+
   char(m div 10+48)+char(m mod 10+48)+':'+
   char(s div 10+48)+char(s mod 10+48);
 end;

function kni(k:integer):integer;
 begin
  kni:=(k mod 100-1)+10*(k div 100-1);
 end;

function kin(k:integer):string;
 var
  a,b:integer;
 begin
  a:=k mod 10+1;
  b:=k div 10+1;
  kin:=
   char(b div 10+48)+char(b mod 10+48)+
   char(a div 10+48)+char(a mod 10+48);
 end;

procedure readin;
 var
  f:text;
  i,j:integer;
  s:string;
 begin
  assign(f,'input.txt'); reset(f);
  an:=0;
  while(not seekeof(f))do begin
   readln(f,s);
   if(s='.')then break;
   as[an].id:=s[1];
   delete(s,1,1); while(length(s)>0)and(s[1]=' ')do delete(s,1,1);
   as[an].come:=tni(s);
   as[an].kn:=0;
   repeat
    read(f,as[an].ks[as[an].kn]);
    if(as[an].ks[as[an].kn])=0 then break;
    as[an].ks[as[an].kn]:=kni(as[an].ks[as[an].kn]);
    read(f,as[an].ts[as[an].kn]);
    inc(as[an].kn);
   until false;
   inc(an);
  end;
  close(f);
 end;

var
 ct:longint;

procedure solve;
 var
  i,j,k:integer;
  min:integer;
  _type:integer;

 procedure init;
  var
   i:integer;
  begin
   fillchar(left,sizeof(left),0);
   fillchar(lts,sizeof(lts),255);
   fillchar(ltn,sizeof(ltn),0);
   fillchar(ktn,sizeof(ktn),0);
   for i:=0 to 9 do
    lts[i]:=nat;
   for i:=0 to maxk-1 do
    kts[i]:=nat;
   for i:=0 to an-1 do begin
    ls[i].sn:=0;
    new(ls[i].ss);
    left[i]:=true;
    as[i].cf:=0;
   end;
   leftn:=an;
   ct:=0;
   for i:=0 to an-1 do begin
    if as[i].kn=0 then begin
     left[i]:=false;
     dec(leftn);
     continue;
    end;
    as[i].tar:=0;
    hd[i].d:=dinit;
    hd[i].e:=true;
    hd[i].t:=as[i].come+30;
    with ls[i].ss^[ls[i].sn] do begin
     start:=as[i].come;
     id:=lentry;
    end;
    inc(ls[i].sn);
   end;
  end;

 function gett(t,i:integer):longint;
  begin
   case t of
    0:begin
     if hd[i].e then gett:=hd[i].t
     else gett:=nat;
    end;
    1:begin
     if(ltn[i]=0)then gett:=nat
     else if(ct=lts[i])then gett:=(ct div 5+1)*5
     else gett:=(ct+4)div 5*5;
    end;
    2:gett:=kts[i];
   end;
  end;
 procedure gofloor(who,f:integer);
  begin
   if as[who].tar>0 then begin
    with ls[who].ss^[ls[who].sn] do begin
     id:=lte;
     start:=ct;
     d[0]:=as[who].ks[as[who].tar-1];
    end;
    inc(ls[who].sn);
    hd[who].d:=dge;
    hd[who].t:=ct+10;
    hd[who].e:=true;
    hd[who].wh:=f;
    hd[who].fr:=as[who].cf;
   end;
  end;
 procedure goroom(who:integer);
  begin
   if(as[who].tar>=as[who].kn)then begin
    if(as[who].cf<>0)then gofloor(who,0)
    else begin
     with ls[who].ss^[ls[who].sn] do begin
      id:=lexit;
      start:=ct;
     end;
     inc(ls[who].sn);
     left[who]:=false;
    end;
   end;
   if(as[who].cf<>as[who].ks[as[who].tar])then
    gofloor(who,as[who].ks[as[who].tar] div 10)
   else begin
    with ls[who].ss^[ls[who].sn] do begin
     if(as[who].tar>0)and(as[who].cf=as[who].ks[as[who].tar-1] div 10)then begin
      id:=ltrr;
      d[0]:=as[who].ks[as[who].tar-1];
      d[1]:=as[who].ks[as[who].tar];
     end else if(as[who].tar=0)then begin
     end else begin
      id:=ltr;
      d[0]:=as[who].ks[as[who].tar];
     end;
     start:=ct;
    end;
    hd[who].d:=dgr;
    hd[who].t:=ct+10;
    hd[who].e:=true;
    inc(ls[who].sn);
   end;
  end;
 begin
  init;
  while(leftn>0)do begin
   if timer>=start then exit;

   min:=-1;
   for i:=0 to an-1 do if(left[i])and(hd[i].e)then begin
    if(min<0)or(hd[min].t>hd[i].t)then begin
     min:=i;
     _type:=0;
    end;
   end;
   for i:=0 to 9 do
    if(lts[i]<gett(_type,min))then begin
     _type:=1;
     min:=i;
    end;
   for i:=0 to maxk-1 do
    if(kts[i]<gett(_type,min))then begin
     _type:=2;
     min:=i;
    end;
   if gett(_type,min)=nat then min:=-1;
   if min<0 then exit;
   ct:=gett(_type,min);

   if(_type=0)then begin
    case(hd[min].d)of
     dinit:begin
      hd[min].e:=false;
      goroom(min);
     end;
     dge:begin
      with ls[min].ss^[ls[min].sn] do begin
       id:=lwe;
       start:=ct;
      end;
      inc(ls[min].sn);
      if(ltn[as[min].cf]=0)then lts[as[min].cf]:=ct;
      inc(ltn[as[min].cf]);
      hd[min].d:=dqe;
      hd[min].e:=false;
     end;
     dgr:begin
      with ls[min].ss^[ls[min].sn] do begin
       id:=lwr;
       start:=ct;
      end;
      inc(ls[min].sn);
      if(ktn[as[min].ks[as[min].tar]]=0)then
       kts[as[min].ks[as[min].tar]]:=ct;
      inc(ktn[as[min].ks[as[min].tar]]);
      hd[min].d:=dqr;
      hd[min].e:=false;
     end;
     dse:begin
      as[min].cf:=hd[min].wh;
      goroom(min)
     end;
     dsr:begin
      inc(as[min].tar);
      goroom(min);
     end;
    end;
   end else if(_type=1)then begin
    j:=-1;
    for i:=0 to an-1 do if(hd[i].d=dqe)and(as[i].cf=min)then begin
     if(j<0)or(as[i].id<as[j].id)then
      j:=i;
    end;
    dec(ltn[min]);
    lts[min]:=ct;
    with(ls[j].ss^[ls[j].sn])do begin
     id:=lse;
     start:=ct;
    end;
    inc(ls[j].sn);
    hd[j].d:=dse;
    hd[j].t:=ct+30*abs(hd[j].fr-hd[j].wh);
    hd[j].e:=true;
   end else begin {_type=2}
    j:=-1;
    for i:=0 to an-1 do if(hd[i].d=dqr)and(as[i].ks[as[i].tar]=min)then begin
     if(j<0)or(as[i].id<as[j].id)then
      j:=i;
    end;
    if j<0 then begin
     kts[min]:=nat;
    end else begin
     dec(ktn[min]);
     kts[min]:=ct+as[i].ts[as[i].tar];
     with(ls[j].ss^[ls[j].sn])do begin
      id:=lsr;
      start:=ct;
     end;
     inc(ls[j].sn);
     hd[j].d:=dsr;
     hd[j].t:=ct+as[i].ts[as[i].tar];
     hd[j].e:=true;
    end;
   end;
  end;
 end;

procedure writeout;
 var
  f:text;
  i,j:integer;
  c:char;
  found:boolean;
 begin
  assign(f,'output.txt'); rewrite(f);
  for c:='A' to 'Z' do begin
   found:=false;
   for i:=0 to an-1 do if as[i].id=c then begin found:=true; break; end;
   if not found then continue;
   writeln(f,c);
   for j:=0 to ls[i].sn-2 do if(ls[i].ss^[j].start<>ls[i].ss^[j+1].start)then begin
    write(f,
     tin(ls[i].ss^[j].start),' ',
     tin(ls[i].ss^[j+1].start),' '
    );
    case ls[i].ss^[j+1].id of
     lentry:writeln(f,'Entry');
     lexit:writeln(f,'Exit');
     lwe:writeln(f,'Waiting in elevator queue');
     lwr:writeln(f,'Waiting in front of room ',kin(ls[i].ss^[j+1].d[0]));
     ltr:writeln(f,'Transfer from elevator to room ',kin(ls[i].ss^[j+1].d[0]));
     lte:writeln(f,'Transfer from room ',kin(ls[i].ss^[j+1].d[0]),' to elevator');
     ltrr:writeln(f,'Transfer from room ',kin(ls[i].ss^[j+1].d[0]),' to room ',kin(ls[i].ss^[j+1].d[1]));
     lsr:writeln(f,'Stay in room ',kin(ls[i].ss^[j+1].d[0]));
     lse:writeln(f,'Stay in elevator');
    end;
   end;
   writeln(f,
    tin(ls[j].ss^[j].start),' ',
    tin(ls[j].ss^[j].start+30),' Exit'
   );
   writeln(f);
  end;
  close(f);
 end;

begin
 start:=timer+ttttt;
 readin;
 solve;
 writeout;
end.