{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{ $r+}

type
 tbuf=array[0..$7FFF]of char;

var
 sf,df:file;
 inb:tbuf;
 inl,inp:longint;
 oub:^tbuf;
 oup:longint;

procedure load;
 var
  t:word;
 begin
  blockread(sf,inb,$8000,t); inl:=t;
  if(inl<$8000)then begin
   inb[inl]:=#26;
   inc(inl);
  end;
  inp:=0;
 end;

procedure flush;
 begin
  blockwrite(df,oub^,oup);
  oup:=0;
 end;

procedure init;
 begin
  assign(sf,'input.txt'); reset(sf,1);
  assign(df,'output.txt'); rewrite(df,1);
  new(oub);
  load;
 end;

procedure done;
 var
  f:text;
  i,j:integer;
 begin
  flush;
  close(sf);
  close(df);
 end;

procedure puts(var s:array of char; l:longint);
 var
  sp:longint;
 begin
  if l<=0 then exit;
  sp:=0;
  while($8000-oup<=l)do begin
   move(s[sp],oub^[oup],$8000-oup);
   dec(l,$8000-oup);
   inc(sp,$8000-oup);
   oup:=$8000;
   flush;
  end;
  if l>0 then move((pchar(addr(s))+sp)^,oub^[oup],l);
  inc(oup,l);
 end;

procedure putch(c:char);
 begin
  if(oup>$7FFF)then flush;
  oub^[oup]:=c; inc(oup);
 end;

procedure solve;
 var
  op:longint;
  use:boolean;
  state:integer;
 procedure readinum;
  begin
   while(inp<inl)and(inb[inp] in ['0'..'9'])do inc(inp);
   if(inp>=inl)then begin state:=3; exit; end;
  end;
 procedure readnum;
  begin
   if(inp>=inl)then begin state:=2; exit; end;
   if(inb[inp]='.')then begin
    inc(inp);
    if(inp>=inl)then begin state:=4; exit; end;
    if not(inb[inp] in ['0'..'9'])then begin
     putch('.');
     exit;
    end;
    while(inp<inl)and(inb[inp] in ['0'..'9'])do inc(inp);
    if(inp>=inl)then begin state:=3; exit; end;
   end;
   while(inp<inl)and(inb[inp] in ['0'..'9'])do inc(inp);
   if(inp>=inl)then begin state:=2; exit; end;
   if(inb[inp]='.')then begin
    inc(inp);
    while(inp<inl)and(inb[inp] in ['0'..'9'])do inc(inp);
    if(inp>=inl)then begin state:=3; exit; end;
   end;
  end;
 begin
  use:=true;
  state:=0;
  while(true)do begin
   if(inp=0)and(state>0)then begin
    if state=1 then begin
     if use then begin
      if not(inb[0] in ['b','i','s','*'])then begin
       putch(inb[0]);
       inc(inp);
      end else if inb[0]='*' then begin use:=false; inc(inp); end
      else if inb[0]='s' then begin
       readnum;
       if inp>=inl then begin load; continue; end;
      end;
     end else begin
      if inb[0]='*' then begin use:=true; inc(inp); end
      else begin putch('\'); putch(inb[0]); inc(inp); end;
     end;
    end else if(state=2)then begin
     readnum;
     if inp>=inl then begin load; continue; end;
    end else if(state=3)then begin
     readinum;
     if inp>=inl then begin load; continue; end;
    end else if(state=4)then begin
     if not(inb[0] in ['0'..'9'])then begin
      putch('.');
     end else begin
      readinum;
      if inp>=inl then begin load; continue; end;
     end;
    end;
   end;
   op:=inp;
   while(inp<inl)and not(inb[inp] in ['\',#26])do inc(inp);
   puts(inb[op],inp-op);
   if(inp>=inl)then begin load; state:=0; continue; end;
   if(inb[inp]=#26)then exit;
   if(inb[inp]='\')then begin
    inc(inp);
    if(inp>=inl)then begin
     state:=1;
     load;
     continue;
    end;
    if use then begin
     if not(inb[inp] in ['b','i','s','*'])then begin
      putch(inb[inp]);
      inc(inp);
     end else if inb[inp]='*' then begin use:=false; inc(inp); end
     else if inb[inp]='s' then begin
      inc(inp);
      readnum;
      if inp>=inl then begin load; continue; end;
     end else inc(inp);
    end else begin
     if inb[inp]='*' then begin use:=true; inc(inp); end
     else begin putch('\'); putch(inb[inp]); inc(inp); end;
    end;
   end;
  end;
 end;

begin
 init;
 solve;
 done;
end.