{$A+,B-,D-,E+,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
Program Department;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxAg=27;
      MaxRm=100;
Type TAgen=Record
            Iden: Char;
            TmEntry: LongInt;
            ToGone: Integer;
            TWh: Array[0..MaxRm] Of Byte;{0 - after entry, 1 .. TWh[0] - room, TWh[0]+1 exit}
            HwB: Array[0..MaxRm] Of LongInt;
            WhFr: LongInt;
           End;
      TSee=Record
            wh: Integer;
            tm: LongInt;
           End;
      TWhSee=Array[1..MaxRm*MaxAg*4] Of TSee;
      Tres=Array[1..3] Of Byte;
      {0 - Entry, 1 - exit, 2 - stay at room,
       3 - transfer from ## to ##,
       4 - stay in elevator,
       5 - wait in front,
       6 - wait in elevator queue}
Const  Mprq=MaxRm*6;
Type MsF=Array[1..MpRq] Of LongInt;
      TRs=Array[1..MaxAg] Of Record
           sc: Integer;
           TMf, Tme: ^MSf;
           Ms: Array[1..MpRq] Of TRes;
          End;
 Var A: Array[1..MaxAg] Of TAgen;
     N: Integer;
     nch: Char;
     OCh: Array[-1..109, 0..MaxAg] Of Integer;{num ag}
     WhoAt: Array[10..109] Of Integer; {0..9 - lifts, 10..109 rooms, -1 entry}
     WhatSee: ^TWhSee;
     scWS: Integer;
     nowTime: LongInt;
     Rs: ^TRs;
     NwWas, Rslf: Array[0..9] Of LongInt;

 Function GetNext: String;
  Var sp: String;
   Begin
    sp:='';
     Read(nch);
    While (nch In [#0..#25, #27..#32]) Do Read(nch);
    While not (nch In [#0..#32]) Do Begin
      sp:=sp+nch;
      Read(nch);
     End;
    GetNext:=sp;
   End;

 Function GetNum(Const s: String): LongInt;
  Var a: LongInt;
      i: Integer;
   Begin
    Val(s, a, i);
    GetNum:=a;
   End;

 Function GetExu(Var sp: String): LongInt;
  Var i: Integer;
   Begin
    i:=1;
     While (i<=Length(sp)) And (sp[i] In ['0'..'9']) Do Inc(i);
     GetExu:=GetNum(Copy(sp, 1, i-1));
    If i<=Length(sp) Then Delete(sp, 1, i)
     Else Delete(sp, 1, i-1);
   End;

 Function GetTime(sp: String): LongInt;
  Var sc, rs, i: LongInt;
Const A: array[1..3] Of LongInt=(3600, 60, 1);
   Begin
    sc:=0; i:=0;
    While sp<>'' Do Begin
     rs:=GetExu(sp);
      Inc(i);
     sc:=sc+rs*A[i];
    End;
    GetTime:=sc;
   End;

 Procedure AddWhSee(Const k, Tm: LongInt);
  Var i: Integer;
   Begin
     i:=1;
     While (i<=scWS) And (WhatSee^[i].tm>=Tm) Do Inc(i);
    If i<=scWs Then Begin
      Move(WhatSee^[i], WhatSee^[i+1], (scWs-i+1)*SizeOf(WhatSee^[i]));
    End;
    Inc(scWS);
    WhatSee^[i].wh:=k;
    WhatSee^[i].tm:=tm;
   End;

 Procedure GetWhSee(Var a: Integer; Var bb: LongInt);
  Begin
   a:=WhatSee^[scWs].wh;
   bb:=WhatSee^[scWs].tm;
   Dec(scWs);
  End;

 Procedure AddSeq(Const k, p: Integer; Tm: LongInt);
  Begin
   Inc(Och[k, 0]);
    Och[k, Och[k, 0]]:=p;
    A[p].WhFr:=Tm;
   If (k=-1) Or (k>9) Then AddWhSee(k, tm)
    Else Begin
     If Tm Mod 5<>0 Then tm:=tm+(5-tm Mod 5);
      A[p].WhFr:=Tm;
     If RsLf[k]+5<Tm Then Begin
      AddWhSee(k, tm);
      RsLf[k]:=Tm;
     End
      Else Begin
       AddWhSee(k, RsLf[k]+5);
       Inc(rsLf[k], 5);
      End;
    End;
  End;

 Procedure AddRs(Const nm, a, b, c: Byte;Const a1, a2: LongInt);
  Begin
   Inc(Rs^[nm].sc);
   Rs^[nm].Tmf^[Rs^[nm].sc]:=a1;{from}
   Rs^[nm].Tme^[Rs^[nm].sc]:=a2;{as}
   Rs^[nm].Ms[Rs^[nm].sc][1]:=a;
   Rs^[nm].Ms[Rs^[nm].sc][2]:=b;{0 = elevator}
   Rs^[nm].Ms[Rs^[nm].sc][3]:=c;
  End;
      {0 - Entry, 1 - exit, 2 - stay at room,
       3 - transfer from ## to ##,
       4 - stay in elevator,
       5 - wait in front,
       6 - wait in elevator queue}

 Procedure EndLast(Const nm: Byte;Const a1: LongInt);
  Begin
   Rs^[nm].Tme^[Rs^[nm].sc]:=a1;{as}
  End;

 Procedure Init;
  Var id: String;
      i, sp: Integer;
   Begin
    scWS:=0;
     New(WhatSee);
      New(RS);
     FillChar(Rs^, SizeOf(Rs^), 0);
     For i:=1 To MaxAg Do Begin
      New(Rs^[i].tmf);
       FillChar(Rs^[i].tmf^, SizeOf(Rs^[i].tmf^), 0);
      New(Rs^[i].tme);
       FillChar(Rs^[i].tme^, SizeOf(Rs^[i].tme^), 0);
     End;
     FillChar(WhoAt, sizeOf(WhoAt), 0);
     FillChar(Och, SizeOf(Och), 0);
     FillChar(A, SizeOf(A), 0);
     FillChar(WhatSee^, SizeOf(WhatSee^), 0);
    Assign(Input, InputFile);
     Reset(Input);
      N:=0;
      id:=GetNext;
     While id<>'.' Do Begin
      Inc(N);
       A[N].iden:=Id[1];
       A[N].TmEntry:=GetTime(GetNext);
       A[N].ToGone:=0;
        id:=GetNext;

{!}        {add entry} AddRs(N, 0, 0, 0, A[N].TmEntry, A[N].TmEntry+30);
       AddSeq(-1, N, A[N].TmEntry+30);
       While id<>'0' Do Begin
         While Length(id)<4 do id:='0'+id;
         sp:=(GetNum(id[1])*10+GetNum(id[2]))*10 + GetNum(id[3])*10+GetNum(id[4])-1;
          Inc(A[N].TWh[0]);
          A[N].TWh[A[N].TWh[0]]:=sp;
          A[N].HwB[A[N].TWh[0]]:=GetNum(GetNext);
         id:=GetNext;
       End;
      id:=GetNext;
     End;
     Close(Input);
   End;

 Procedure DelAtSeq(Const k, p: Integer);
  Begin
   Move(Och[k, p+1], Och[k, p], (Och[k, 0]-p)*SizeOf(Och[k, p]));
   Dec(Och[k, 0]);
  End;

 Function GetMinTm: Integer;
  Var i, j: Integer;
      mn: LongInt;
   Begin
    mn:=MaxLongInt; j:=0;
    For i:=1 To Och[-1, 0] Do Begin
     If (A[Och[-1, i]].TmEntry<mn) And (A[Och[-1, i]].WhFr<=nowTime) Then Begin
      mn:=A[Och[-1, i]].TmEntry;
      j:=i;
     End;
    End;
    GetMinTm:=j;
   End;

 Function GetMinId(Const pp: Integer): Integer;
  Var i, j: Integer;
      mn: Char;
   Begin
    mn:=#255; j:=0;
    For i:=1 To Och[pp, 0] Do Begin
     If (A[Och[pp, i]].Iden<mn) And (A[Och[pp, i]].WhFr<=NowTime) Then Begin
      mn:=A[Och[pp, i]].Iden;
      j:=i;
     End;
    End;
    GetMinId:=j;
   End;

 Procedure RasborRoom(Const bb: Integer);
  Var k, cd: Integer;
   Begin
    If WhoAt[bb]=0 Then Begin
     k:=GetMinId(bb);
       If k=0 Then Exit;
        WhoAt[bb]:=Och[bb, k];
       cd:=WhoAt[bb];
       EndLast(cd, nowTime);{end stay in front}
       A[cd].WhFr:=nowTime+A[cd].HwB[A[cd].ToGone];
       AddRs(cd, 2, bb, 0, nowTime, A[cd].WhFr);{stay at room}
      AddWhSee(bb, A[cd].WhFr);
     DelAtSeq(bb, k);
    End Else
     If nowTime=A[WhoAt[bb]].WhFr Then Begin
       cd:=WhoAt[bb];
        Inc(A[cd].ToGone);
        If A[cd].ToGone>A[cd].TWh[0] Then Begin
{~}      If bb Div 10=1 Then AddRs(cd, 1, 0, 0, nowTime, nowTime+30){exit}
           Else Begin
             AddRs(cd, 3, bb, 0, NowTime, NowTime+10);{transfer room to lift}
{not full}   AddRs(cd, 6, 0, 0, NowTime+10, 0);{stay at elevator sequence}
             AddSeq(bb Div 10-1, cd, nowTime+10);
             A[cd].WhFr:=nowTime+10;
           End;
        End
       Else Begin
        If A[cd].TWh[A[cd].ToGone] Div 10=bb Div 10 Then Begin
            AddRs(cd, 3, bb, A[cd].TWh[A[cd].ToGone], nowTime, nowTime+10);
{!}         {Transfer room to rrom}
            AddRs(cd, 5, A[cd].TWh[A[cd].ToGone], 0, nowTime+10, 0);
            {STAY INF FRONT}
           AddSeq(A[cd].TWh[A[cd].ToGone], cd, nowTime+10);
         End
         Else Begin
{~}       {Transfer  room to lift}
           AddRs(cd, 3, bb, 0, NowTime, NowTime+10);
           AddRs(cd, 6, 0, 0, NowTime+10, 0);
           AddSeq(bb Div 10-1, cd, nowTime+10);
         End;
       End;
       WhoAt[bb]:=0;
      k:=GetMinId(bb);
      If k=0 Then Exit;
        WhoAt[bb]:=Och[bb, k];
       cd:=WhoAt[bb];
       EndLast(cd, nowTime);{end stay in front}
        A[cd].WhFr:=nowTime+A[cd].HwB[A[cd].ToGone];
        AddRs(cd, 2, bb, bb, nowTime, A[cd].WhFr);{stay at room}
       AddWhSee(bb, A[cd].WhFr);
      DelAtSeq(bb, k);
     End;
   End;

 Procedure RasborEntry;
  Var Gm, cd: Integer;
   Begin
    Gm:=GetMinTm;
      If Gm=0 Then Exit;
       cd:=Och[-1, Gm];
{!}  If A[cd].TWh[0]=0 Then AddRs(cd, 1, 0, 0, nowTime, nowTime+30)
      Else Begin
       Inc(A[cd].ToGone);
       If A[cd].TWh[1]<20 Then Begin
{~}     {transfer room}
        AddRs(cd, 5, A[cd].TWh[A[cd].ToGone], 0, A[cd].TmEntry+30, 0); {wait at front}
         A[cd].WhFr:=A[cd].TmEntry+30;
        AddSeq(A[cd].TWh[1], Och[-1, Gm], A[cd].TmEntry+30);
       End
       Else Begin
{~}     {transfer to elevator}
        AddRs(cd, 6, 0, 0, A[cd].TmEntry+30, 0); {wait at front}
{        A[Och[-1, Gm]].WhFr:=A[Och[-1, Gm]].TmEntry+30;}
        AddSeq(0, Och[-1, Gm], A[cd].TmEntry+30);
       End;
      End;
    DelAtSeq(-1, Gm)
   End;

 Procedure RasborLift(Const bb: Integer);
  Var k, cd: Integer;
   Begin
    If nowTime=NwWas[bb] Then Exit;
    k:=GetMinId(bb);
    If k=0 Then Exit;
      cd:=Och[bb, k];
      EndLast(cd, nowTime);
     If A[cd].ToGone>A[cd].TWh[0] Then Begin
      AddRs(cd, 4, 0, 0, nowTime,
       nowTime+(A[cd].TWh[A[cd].ToGone-1] Div 10-1)*30);
      AddRs(cd, 1, 0, 0, nowTime+(A[cd].TWh[A[cd].ToGone-1] Div 10-1)*30,
           nowTime+(A[cd].TWh[A[cd].ToGone-1] Div 10-1)*30+30);
       {0 - Entry, 1 - exit, 2 - stay at room,
       3 - transfer from ## to ##,
       4 - stay in elevator,
       5 - wait in front,
       6 - wait in elevator queue}

{~}   {stay elev, }
{~}   {exit + 30}
     End
     Else Begin
      AddRs(cd, 4, 0, 0, nowTime, nowTime+Abs(bb+1-A[cd].TWh[A[cd].ToGone] Div 10)*30);
      AddRs(cd, 3, 0, A[cd].TWh[A[cd].ToGone],
      nowTime+Abs(bb+1-A[cd].TWh[A[cd].ToGone] Div 10)*30, nowTime+Abs(bb+1-A[cd].TWh[A[cd].ToGone] Div 10)*30+10);
      AddRs(cd, 5, A[cd].TWh[A[cd].ToGone], 0, nowTime+Abs(bb+1-A[cd].TWh[A[cd].ToGone] Div 10)*30+10, 0);
{~}   {stay elev, Abs(bb-A[cd].TWh[ToGone] Div 10))*30}
{~}   {move from elev to room 10}
      AddSeq(A[cd].TWh[A[cd].ToGone], cd,
         nowTime+Abs(bb+1-A[cd].TWh[A[cd].ToGone] Div 10)*30 + 10);
     End;
    DelAtSeq(bb, k);
    NwWas[bb]:=nowTime;
   End;

 Procedure Solve;
  Var bb: Integer;
      ls, nw: LongInt;
   Begin
    ls:=0;
     FillChar(NwWas, SizeOf(NwWas), 0);
     FillChar(rslf, SizeOf(rslf), 0);
    While scWS<>0 Do Begin
     GetWhSee(bb, nowtime);
     If bb>9 Then RasborRoom(bb) Else
      If bb=-1 Then RasborEntry Else
       RasborLift(bb);
    End;
   End;

 Function GetDw(const l: Integer): string;
  Var s: STring;
   Begin
    Str(l, s);
     While Length(s)<2 Do s:='0'+s;
    GetDw:=s;
   End;

 Function GetTimeB(p: LongInt): String;
  Begin
   GetTimeB:=GetDw(p Div 3600) + ':' +
    GetDw((p Mod 3600) Div 60) + ':' + GetDw(p Mod 60);
  End;

 Function GetRNum(Const l: Byte): String;
  Begin
   If l=0 Then GetRNum:='elevator'
    Else GetRNum:='room '+GetDw(l Div 10) + GetDw(l Mod 10 + 1);
  End;

 Procedure Done;
  Var i, j: Integer;
   Begin
    Assign(Output, OutputFile);
     Rewrite(Output);
      For i:=1 To N Do Begin
       WriteLn(A[i].Iden);
        For j:=1 To Rs^[i].sc Do
        If Rs^[i].tme^[j]<>Rs^[i].tmf^[j] Then Begin
         Write(GetTimeB(Rs^[i].tmf^[j]), ' ', GetTimeB(Rs^[i].tme^[j]), ' ');
         Case Rs^[i].Ms[j, 1] Of
          0: WriteLn('Entry');
          1: WriteLn('Exit');
          2: WriteLn('Stay in ', GetRNum(Rs^[i].Ms[j, 2]));
          3: WriteLn('Transfer from ', GetRNum(Rs^[i].Ms[j, 2]),
           ' to ', GetRNum(Rs^[i].Ms[j, 3]));
          4: WriteLn('Stay in elevator');
          5: WriteLn('Waiting in front of ', GetRNum(Rs^[i].Ms[j, 2]));
          6: WriteLn('Waiting in elevator queue');
       {0 - Entry, 1 - exit, 2 - stay at room,
       3 - transfer from ## to ##,
       4 - stay in elevator,
       5 - wait in front,
       6 - wait in elevator queue}
         End;
        End;
       WriteLn;
      End;
     Close(Output);
   End;

BEGIN
 Init;
  Solve;
 Done;
END.