{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
type  TS=array [1..3,1..3] of Char;
var   C: array [1..9] of TS;
      Ans: array [1..9] of Byte;
const Cifr: array [0..9] of TS =
      (
      (' _ ',
       '| |',
       '|_|'),

      ('   ',
       '  |',
       '  |'),

      (' _ ',
       ' _|',
       '|_ '),

      (' _ ',
       ' _|',
       ' _|'),

      ('   ',
       '|_|',
       '  |'),

      (' _ ',
       '|_ ',
       ' _|'),

      (' _ ',
       '|_ ',
       '|_|'),

      (' _ ',
       '  |',
       '  |'),

      (' _ ',
       '|_|',
       '|_|'),

      (' _ ',
       '|_|',
       ' _|')
      );

procedure ReadIn;
var       I, Y, X: integer;
begin
 Assign (Input,'input.txt'); reset (Input);
 FillChar (C, SizeOf (C), #32);
 for Y := 1 to 3 do
 begin
  I := 1; X := 1;
  while not EOLN do
  begin
   Read (C[I, Y, X]);
   if X=3 then
   begin
    X := 1;
    Inc (I);
   end else Inc (X);
  end;
  ReadLn;
 end;
 close (input);
end;

procedure WriteOut;
var       I: Integer;
begin
 assign (output,'output.txt'); rewrite (output);
 for I := 1 to 9 do Write (Ans[I]); WriteLn;
 Close(output);
 Halt;
end;

procedure Failure;
begin
 Assign (output,'output.txt'); Rewrite (output);
 WriteLn ('failure');
 Close(output); halt;
end;

procedure Ambiguous;
begin
 Assign (output,'output.txt'); Rewrite (output);
 WriteLn ('ambiguous');
 Close(output); halt;
end;

procedure Solve;
var       K,J,I: Integer;
          D, UnRec, X: Integer;
          DS:array [0..10] of Byte;

function Eq (var A, B: TS): Boolean;
var      I: integer;
         P: array [0..8] of Byte absolute A;
         Q: array [0..8] of Byte absolute B;
begin
 for I := 0 to 8 do if P[I]<>Q[I] then begin Eq := False; Exit; end;
 Eq := True;
end;

function SpcEq (var A, B: TS): Boolean;
var      I: integer;
         P: array [0..8] of Byte absolute A;
         Q: array [0..8] of Byte absolute B; {Etalon}
begin
 for I := 0 to 8 do
  if (Q[I]=32) and (P[I]<>32) then
   begin SpcEq := False; Exit; end else
  if (Q[I]<>32) and (P[I]<>32) and (P[I]<>Q[I]) then
   begin SpcEq := False; Exit; end;
 SpcEq := True;
end;

begin
 FillChar (Ans, SizeOf (Ans), 255); X := 0; UnRec := 0;
 for I := 1 to 9 do
 begin
  for J := 0 to 9 do
   if Eq (C[I],Cifr[J]) then begin Ans[I]:=J; Break; end;
  if Ans [I]=255 then
   if unRec=0 then UnRec := I else
   Failure else
   Inc (X, J*(10-I));
 end;
 if (X mod 11=0) and (UnRec=0) then WriteOut;
 if UnRec<>0 then
 begin
  DS [0] := 0;
  for D := 0 to 9 do
   if (X+D*(10-UnRec)) mod 11=0 then
    if SpcEq (C[UnRec], Cifr[d]) then
    begin
     Inc (DS[0]); DS[DS[0]]:=D;
     Ans[UnRec] := D;
    end;
  if DS[0]=0 then Failure else
  if DS[0]=1 then WriteOut else
                  Ambiguous;
 end else
 begin
  DS [0] := 0;
  for UnRec := 1 to 9 do
  begin
   X := 0;
   for I := 1 to 9 do
    if I<>UnRec then Inc (X,Ans[I]*(10-I));
   begin
    for D := 0 to 9 do
     if (X+D*(10-UnRec)) mod 11=0 then
      if SpcEq (C[UnRec], Cifr[d]) then
      begin
       Inc (DS[0]); DS[DS[0]]:=D;
       Ans[UnRec] := D; K :=  UnRec;
      end;
   end;
  end;
  if DS[0]=0 then Failure else
  if DS[0]=1 then WriteOut else
                  Ambiguous;
 end;
end;

begin
 ReadIn;
 solve;
 WriteOut;
end.