{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65384,0,655360}
Program Miro;
Const InputFile='D.In';
      OutputFile='D.Out';
Const MaxN=10000;
Type BMas=Array[1..MaxN] Of Integer;
 Var Ax, Ay: BMas;
     N: Integer;
     xx, yy: LongInt;
     Res: LongInt;

 Procedure Init;
  Var i: Integer;
   Begin
    Assign(Input, InputFile);
     Reset(Input);
      Read(N);
      For i:=1 To N Do Read(Ax[i], Ay[i]);
     Close(Input);
   End;

 Function Min(Const a, b: LongInt): LongInt;
  Begin
   If a>b Then Min:=b Else Min:=a;
  End;


 Procedure Swap(Var a, b: Integer);
  Var c: Integer;
   Begin
    c:=a; a:=b; b:=c;
   End;

 Procedure Sort(Var Ax: BMas;Const lf, rg: Integer);
  Var i, j, x: Integer;
   Begin
    i:=lf; j:=rg; x:=Ax[(lf + rg) Div 2];
    Repeat
     While Ax[i]<x Do Inc(i);
     While Ax[j]>x Do Dec(j);
     If i<=j Then Begin
      Swap(Ax[i], Ax[j]);
      Inc(i); Dec(j);
     End;
    Until i>j;
    If i<rg Then Sort(Ax, i, rg);
    If j>lf Then Sort(Ax, lf, j);
   End;


 Function SolveA(Const Ax, Ay: BMas): LongInt;
  Var sc, sc1: LongInt;
      i: Integer;
   Begin
    sc:=0;
     xx:=Ax[(N+1) Div 2];
     yy:=Ay[(N+1) Div 2];
     For i:=1 To N Do
       sc:=sc + Abs(Ay[i]-yy) + Abs(Ax[i]-(xx-((N+1) Div 2)+i));
        sc1:=sc;
     If Not(Odd(N)) Then Begin
      sc1:=0;
      xx:=Ax[N Div 2+1];
      For i:=1 To N Do
       sc1:=sc1 + Abs(Ay[i]-yy) + Abs(Ax[i]-(xx-(N Div 2+1)+i));
     End;
    SolveA:=Min(sc, sc1);
   End;

 Procedure Solve;
  Begin
   Sort(Ax, 1, N);
   Sort(Ay, 1, N);
   Res:=Min(SolveA(Ax, Ay), SolveA(Ay, Ax));
  End;

 Procedure Done;
  Begin
   Assign(Output, OutputFile);
    Rewrite(Output);
     WriteLn(Res);
    Close(Output);
  End;

BEGIN
 Init;
  Solve;
 Done;
END.