{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
 var
   x,y,r: array[1..1000] of extended;
   n: longint;
   d,h: array [1..1000] of longint;

 procedure ReadAll;
 var
   i: longint;
 begin
   Assign(input, 'c.in');
   Reset(Input);
   Read(n);
   for i := 1 to n do Read(x[i], y[i], r[i]);
   Close(Input);
 end;

 function inside(a, b:longint): boolean; { a inside b }
 var
   xx,yy:extended;
 begin
   xx := sqrt(sqr(x[a]-x[b])+sqr(y[a]-y[b]))+r[a];
   yy := r[b];
   inside := (xx<=yy)or(abs(xx-yy)<1e-7);
 end;

 procedure Solve;
 var
   k, x: boolean;
   i,j,s: longint;
 begin
   for i := 1 to n do begin
     k := true;
     for j := 1 to n do if i<>j then begin
       if inside(j,i) then begin
         k := false; break;
       end;
     end;
     if (not k) then d[i] := -1 else begin
       d[i] := 0;
       h[i] := 0;
     end;
   end;

   repeat
     k := true;
     for i := 1 to n do if d[i]<>0 then for j := 1 to n do if i<>j then
       if (d[j]>=0) and inside(j,i) and (d[i]<d[j]+1) then begin
         k := false;
         d[i] := d[j]+1;
         h[i] := j;
       end;
   until k;
 end;

 procedure Out;
 var
   np, m, v, i: longint;
   pp: array [1..1000] of longint;
 begin
   m := -1000;
   for i := 1 to n do if d[i]>m then begin
     m := d[i]; v := i;
   end;

   Assign(Output, 'c.out');
   ReWrite(Output);

   WriteLn(m+1);
   np := 0;
   repeat
     inc(np);
     pp[np] := v;
     v := h[v];
   until v=0;

   for i := np downto 1 do Write(pp[i], ' ');

   WriteLn;

   Close(Output);
 end;

 begin
   ReadAll;
   Solve;
   Out;
 end.
