program p26_06_C;

type _1array = array [1..500] of boolean;

var
	inner : array [1..500] of ^_1array;
	num_k : integer;

    krat : array [1..500] of record
    							p1, p2, r : longint;
    						end;

    k, i, j : integer;

    f, out : text;

    lev : integer;
    finished, is_in : boolean;

    maxlev, maxind : word;
    best_way : array [1..500] of word;

    checked, checked_new : array [1..500] of boolean;
    level : array [1..500] of integer;

begin
	assign (f, 'C.IN');
    reset (f);
	readln (f, num_k);
    for i := 1 to num_k do
    	Readln (f, krat [i].p1, krat [i].p2, krat [i].r);
    close (f);

    for i := 1 to num_k do
    	new (inner [i]);

    for i := 1 to num_k do
    	for j := 1 to num_k do
        	inner [i]^[j] := false;

    for i := 1 to num_k do
    	for j := 1 to num_k do if (i <> j) then
        	if (krat [i].r <= krat [j].r)
					and ((sqr (krat [i].p1 - krat [j].p1) + sqr (krat [i].p2 - krat [j].p2))
					<= sqr (krat [j].r - krat [i].r))
            	then
                	begin
                    	inner [i]^[j] := true;
                    end;

    for i := 1 to num_k do
    	for j := 1 to num_k do
        	if (i <> j) and (inner [i]^[j]) and (inner [j]^[i])
            	then inner [j]^[i] := false;

    fillchar (checked, sizeof (checked), 0);
    fillchar (level, sizeof (level), 1);

    lev := 1;
    finished := false;
    while not finished do
    	begin
        	checked_new := checked;
            for k := 1 to num_k do
            	if not checked [k] then
                begin
		        	is_in := false;
					for i := 1 to num_k do
	                	if not checked [i] then
		            	if (inner [k]^[i])
	                    	then
								begin
									is_in := true;
                                    break;
                                end;
                    if not (is_in)
                    	then
                        	begin
                            	checked_new [k] := true;
                                level [k] := lev;
                            end;
                end;
            checked := checked_new;
            inc (lev);
            finished := true;
            for i := 1 to num_k do
            	if not checked [i]
					then
						begin
							finished := false;
                            break;
                        end;
		end;

    maxlev := 0;
    maxind := 1;
    for i := 1 to num_k do
    	if level [i] > maxlev
        	then
            	begin
                	maxlev := level [i];
                    maxind := i;
                end;

    best_way [1] := maxind;
    for lev := maxlev - 1 downto 1 do
    	begin
        	i := 1;
            while (level [i] <> lev) or (not (inner [best_way [maxlev - lev]]^[i])) do
				inc (i);
            best_way [maxlev - lev + 1] := i;
        end;

    assign (out, 'C.OUT');
    rewrite (out);
    Writeln (out, maxlev);
    for i := 1 to maxlev do
    	Writeln (out, best_way [i]);
    close (out);
end.
