{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  MaxR=52;
Type
  TWArr=Array[0..255]Of Word;
  TSArr=Array[1..MaxR]Of String;
  TCArr=Array[1..MaxR]Of Char;
Var
  R:Byte;
  ZS:TSArr;
  ZC:TCArr;
  RDist:Array[1..MaxR,#0..#255]Of Byte;
  IsThis:Array[1..255,1..MaxR]Of Boolean;
  N:Word;
  Best,Last:TWArr;
Procedure PrepareRules;
Var
  J,K:Word;
  C:Char;
Begin
  For J:=1 To R Do Begin
    For C:=#0 To #255 Do Begin
      RDist[J,C]:=Length(ZS[J]);
      For K:=Length(ZS[J])-1 DownTo 1 Do If ZS[J,K]=C Then Begin RDist[J,C]:=Length(ZS[J])-K; Break; End;
    End;
  End;
End;
Procedure PackString(Var S,D:String);
Var
  I,J,K:Word;
  C:Char;
Begin
  Best[0]:=0;
  Last[0]:=0;
  FillChar(IsThis,SizeOf(IsThis),False);
  For J:=1 To R Do Begin
    I:=Length(ZS[J]);
    While I<=Length(S) Do Begin
      If S[I]=ZS[J,Length(ZS[J])] Then Begin
        IsThis[I,J]:=True;
        For K:=1 To Length(ZS[J])-1 Do
          If S[I-K]<>ZS[J,Length(ZS[J])-K] Then Begin
            IsThis[I,J]:=False;
            Break;
          End;
      End;
      I:=I+RDist[J,S[I]];
    End;
  End;
  For I:=1 To Length(S) Do Begin
    Best[I]:=Best[I-1]+1;
    Last[I]:=0;
    For J:=1 To R Do If IsThis[I,J] Then Begin
      If Best[I-Length(ZS[J])]+1<Best[I] Then Begin
        Best[I]:=Best[I-Length(ZS[J])]+1;
        Last[I]:=J;
      End;
    End;
  End;
  I:=Length(S);
  D:='';
  While I>0 Do Begin
    If Last[I]=0 Then Begin
      D:=S[I]+D;
      Dec(I);
    End Else Begin
      D:=ZC[Last[I]]+D;
      Dec(I,Length(ZS[Last[I]]));
    End;
  End;
End;
Procedure Work;
Var
  S,D:String;
  I,J:Word;
  BufI,BufO:Pointer;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  GetMem(BufI,65535);
  SetTextBuf(Input,BufI^,65534);
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  GetMem(BufO,65535);
  SetTextBuf(Output,BufO^,65534);
  ReadLn(R,N);
  For I:=1 To R Do Begin
    ReadLn(ZS[I]);
    ReadLn(ZC[I]);
  End;
  I:=1;
  While I<=R Do Begin
    If Length(ZS[I])>1 Then Inc(I) Else Begin
      For J:=I+1 To R Do Begin
        ZS[J-1]:=ZS[J];
        ZC[J-1]:=ZC[J];
      End;
      Dec(R);
    End;
  End;
  PrepareRules;
  For I:=1 To N Do Begin
    ReadLn(S);
    PackString(S,D);
    WriteLn(D);
  End;
  Close(Input);
  Close(Output);
  FreeMem(BufI,65535);
  FreeMem(BufO,65535);
End;
Begin
  Work;
End.