{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const
  MaxN=51;
Type
  TWall=(wLeft,wRight,wUp,wDown);
  TCArr=Array[0..15]Of Char;
Const
  WChars:TCArr=(' ','','','','','','','','','','','','','','','');
  VChars:TCArr=(' ','','','','','','','','','','','','','','','');
  HChars:TCArr=(' ','','','','','','','','','','','','','','','');
  DChars:TCArr=(' ','','','','','','',' ','','','',' ','',' ',' ',' ');
Var
  F:Array[0..MaxN,0..MaxN]Of Set Of TWall;
  N,M:Byte;
Procedure Load;
Var
  S:String;
  I,J,K:Byte;
  Buf:Pointer;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  GetMem(Buf,65535);
  SetTextBuf(Input,Buf^,65534);
  ReadLn(M,N);
  FillChar(F,SizeOf(F),0);
  For I:=1 To N Do
    For J:=1 To M Do Begin
      ReadLn(S);
      F[J,I]:=[];
      For K:=1 To Length(S) Do Case UpCase(S[K]) Of
        'L':Include(F[J,I],wLeft);
        'R':Include(F[J,I],wRight);
        'U':Include(F[J,I],wUp);
        'D':Include(F[J,I],wDown);
      End;
    End;
  Close(Input);
  FreeMem(Buf,65535);
End;
Procedure Save;
Var
  I,J,K:Byte;
  CA:^TCArr;
Begin
  For I:=1 To M Do If wDown In F[I,N] Then F[I,N+1]:=[wUp];
  For I:=1 To N Do If wRight In F[M,I] Then F[M+1,I]:=[wLeft];
  For I:=1 To M Do If wUp In F[I,1] Then F[I,0]:=[wDown];
  For I:=1 To N Do If wLeft In F[1,I] Then F[0,I]:=[wRight];
  F[0,0]:=[];
  F[M+1,N+1]:=[];
  F[0,N+1]:=[];
  F[M+1,0]:=[];
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  For I:=0 To 2*N Do Begin
    For J:=0 To 2*M Do Begin
      If (I=0) Or (I=2*N) Then
        If (J=0) Or (J=2*M) Then
          CA:=@DChars
        Else
          CA:=@HChars
      Else
        If (J=0) Or (J=2*M) Then
          CA:=@VChars
        Else
          CA:=@WChars;
      Case Ord(Odd(I))*2+Ord(Odd(J)) Of
        0:Begin
          K:=0;
          If wUp In F[J Shr 1,I Shr 1+1] Then K:=K+1;
          If wUp In F[J Shr 1+1,I Shr 1+1] Then K:=K+2;
          If wLeft In F[J Shr 1+1,I Shr 1] Then K:=K+4;
          If wLeft In F[J Shr 1+1,I Shr 1+1] Then K:=K+8;
          Write(CA^[K]);
        End;
        1:If wUp In F[J Shr 1+1,I Shr 1+1] Then Write(CA^[3]) Else Write(' ');
        2:If wLeft In F[J Shr 1+1,I Shr 1+1] Then Write(CA^[12]) Else Write(' ');
        3:Write(' ');
      End;
    End;
    WriteLn;
  End;
  Close(Output);
End;
Begin
  Load;
  Save;
End.