
{.$define Debug}

program Solution;
{$M 16384,0,0}

{$ifndef Debug}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'output.txt';
{$else}
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile			= 'input.txt';
  outFile			= 'con';
  dbgFile			= 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 50;

var
  n                             : integer;
  m                             : integer;
  left                          : array[1..maxN,1..maxN] of boolean;
  right                         : array[1..maxN,1..maxN] of boolean;
  up                            : array[1..maxN,1..maxN] of boolean;
  down                          : array[1..maxN,1..maxN] of boolean;

procedure Solve;
var
  i,j				: integer;

  procedure PutLine( i : integer );
  var
    j				: integer;

  begin
    if left[i,1] then write( '' ) else write( ' '  );
    write( ' ' );
    for j := 1 to n - 1 do begin
      if right[i,j] then write( '' ) else write( ' ' );
      write( ' ' );
    end;
    if right[i,n] then writeln( '' ) else writeln( ' '  );
  end;

begin
{
for i:=128 to 255 do
write( i:4, chr(i), ' ' );
halt;
}
  if up[1,1] and left[1,1] then write( '' ) else
  if up[1,1] and not left[1,1] then write( '' ) else
  if not up[1,1] and left[1,1] then write( '' ) else
  write( ' ' );

  for i := 1 to n - 1 do begin
    if up[1,i] then write( '' ) else write( ' ' );
    if right[1,i] and up[1,i] and up[1,i+1] then write( '' ) else
    if right[1,i] and up[1,i] and not up[1,i+1] then write( '' ) else
    if right[1,i] and not up[1,i] and up[1,i+1] then write( '' ) else
    if right[1,i] and not up[1,i] and not up[1,i+1] then write( '' ) else
    if up[1,i] or up[1,i+1] then write( '' ) else
    write( ' ' );
  end;

  if up[1,n] then write( '' ) else write( ' ' );
  if up[1,n] and right[1,n] then writeln( '' ) else
  if up[1,n] and not right[1,n] then writeln( '' ) else
  if not up[1,n] and right[1,n] then writeln( '' ) else
  writeln( ' ' );

  for i := 1 to m - 1 do begin
    PutLine( i );

    if down[i,1] and left[i,1] and left[i+1,1] then write( '' ) else
    if down[i,1] and not left[i,1] and left[i+1,1] then write( '' ) else
    if down[i,1] and left[i,1] and not left[i+1,1] then write( '' ) else
    if not down[i,1] and (left[i,1] or left[i+1,1]) then write( '' ) else
    if down[i,1] and not left[i,1] and not left[i+1,1] then write( '' ) else
    write( ' ' );

    for j := 1 to n - 1 do begin

      if down[i,j] then write( '' ) else write( ' ' );

      if down[i,j] and right[i,j] and
         not right[i+1,j] and not down[i,j+1] then write( '' ) else
      if not down[i,j] and right[i,j] and
         not right[i+1,j] and down[i,j+1] then write( '' ) else
      if down[i,j] and not right[i,j] and
         right[i+1,j] and not down[i,j+1] then write( '' ) else
      if not down[i,j] and not right[i,j] and
         right[i+1,j] and down[i,j+1] then write( '' ) else

      if down[i,j] and right[i,j] and
         right[i+1,j] and down[i,j+1] then write( '' ) else
      if down[i,j] and right[i,j] and
         not right[i+1,j] and down[i,j+1] then write( '' ) else
      if not down[i,j] and right[i,j] and
         right[i+1,j] and down[i,j+1] then write( '' ) else
      if down[i,j] and not right[i,j] and
         right[i+1,j] and down[i,j+1] then write( '' ) else
      if down[i,j] and right[i,j] and
         right[i+1,j] and not down[i,j+1] then write( '' ) else
      if down[i,j] and down[i,j+1] then write( '' ) else
      if right[i,j] or right[i+1,j] then write( '' ) else write(' ');

    end;

    if down[i,n] then write( '' ) else write( ' ' );

    if down[i,n] and right[i,n] and right[i+1,n] then write( '' ) else
    if down[i,n] and not right[i,n] and right[i+1,n] then write( '' ) else
    if down[i,n] and right[i,n] and not right[i+1,n] then write( '' ) else
    if not down[i,n] and (right[i,n] or right[i+1,n]) then write( '' ) else
    if down[i,n] and not right[i,n] and not right[i+1,n] then write( '' ) else
    write( ' ' );
    writeln;
  end;
  PutLine( m );

  if down[m,1] and left[m,1] then write( '' ) else
  if down[m,1] and not left[m,1] then write( '' ) else
  if not down[m,1] and left[m,1] then write( '' ) else
  write( ' ' );

  for i := 1 to n - 1 do begin
    if down[m,i] then write( '' ) else write( ' ' );
    if right[m,i] and down[m,i] and down[m,i+1] then write( '' ) else
    if right[m,i] and not down[m,i] and down[m,i+1] then write( '' ) else
    if right[m,i] and down[m,i] and not down[m,i+1] then write( '' ) else
    if down[m,i] or down[m,i+1] then write( '' ) else
    write( ' ' );
  end;

  if down[m,n] then write( '' ) else write( ' ' );
  if down[m,n] and right[m,n] then write( '' ) else
  if down[m,n] and not right[m,n] then write( '' ) else
  if not down[m,n] and right[m,n] then write( '' ) else
  write( ' ' );
  writeln;

end;

procedure ReadData;
var
  i,j,k				: integer;
  s				: string;

begin
  readln( m, n );
  fillchar( left, sizeof(left), false );
  fillchar( right, sizeof(right), false );
  fillchar( up, sizeof(up), false );
  fillchar( down, sizeof(down), false );
  for i := 1 to m do
    for j := 1 to n do begin
      readln( s );
      for k := 1 to length( s ) do
        case s[k] of
          'L' : left[i,j] := true;
          'R' : right[i,j] := true;
          'U' : up[i,j] := true;
          'D' : down[i,j] := true;
        end;
    end;
end;

procedure WriteData;
var
  i				: integer;

begin

end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef Debug}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef Debug}
  close( dbg );
  writeln( '----Finalized----' );
  {$endif}

  close( input );
  close( output );
  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.