program p27_06_1;

var
	_from : array [1..52] of string;
	_to : array [1..52] of char;

    f, out : text;
    s : string;
    n, i : integer;
    r : integer;

    comp_arr : array [0..255] of ^string;

function Compress (s : string) : string;
	var
    	i, j, k : integer;
        s2, sbest : string;

	begin
    	comp_arr [0]^ := '';
    	for i := 1 to length (s) do
        	begin
            	sbest := comp_arr [i - 1]^ + s [i];
                for j := 1 to r do
                	if (length (s) >= length (_from [j])) and
                    	(copy (s, i - length (_from [j]) + 1, length (_from [j])) = _from [j])
                        then
                        	begin
                            	s2 := comp_arr [i - length (_from [j])]^ + _to [j];
                                if length (s2) < length (sbest)
                                	then sbest := s2;
                            end;
                comp_arr [i]^ := sbest;
            end;
        Compress := comp_arr [length (s)]^;
    end;

begin
	assign (f, 'INPUT.TXT');
    reset (f);
    readln (f, r, n);
    for i := 1 to r do
    	begin
        	readln (f, _from [i]);
            readln (f, _to [i]);
        end;

    assign (out, 'OUTPUT.TXT');
    rewrite (out);

	for i := 0 to 255 do
    	new (comp_arr [i]);

    for i := 1 to n do
    	begin
        	readln (f, s);
            Writeln (out, Compress (s));
        end;

    close (out);
    close (f);

    for i := 0 to 255 do
    	dispose (comp_arr [i]);
end.