program Name;

{$A+,B-,D-,E+,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}

const
{$ifdef ILIA}
  InFile='2.in';
  OutFile='con';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

function rupcase(x:char):char;
  begin
  if x in[''..''] then
    rupcase:=chr(ord(x)+ord('')-ord(''))
  else if x in [''..''] then
    rupcase:=chr(ord(x)+ord('')-ord(''))
  else rupcase:=x;
  end;

const Russian=[''..''];
type TCharSet=set of #128..#255;
type TItem = record
             one:char;
             more: TCharSet;
             min,max:word;
             end;
     TTemplate=array[0..80] of TItem;

var papa,mama:string;
    pap,mam: TTemplate;
    papc,mamc:byte;

procedure ReadData;
  begin
  Assign(input,InFile);
  Reset(Input);
  readln(papa);
  readln(mama);
  Close(Input);
  end;

procedure ReadDiap(const x:string; var idx:byte; var d:TCharSet);
  var inv:boolean;
      ch:char;
  begin
  inc(idx);
  d:=[];
  inv:=(x[idx]='!');
  if inv then inc(idx);
  while x[idx-1]<>']' do begin
    if x[idx+1]='-' then begin
      for ch:=rupcase(x[idx]) to rupcase(x[idx+2]) do
        include(d,ch);
      inc(idx,4);
    end else begin
      include(d,rupcase(x[idx]));
      inc(idx,2);
    end;
  end;
  if inv then d:=Russian-d;
  dec(idx);
  end;


procedure Convert(const x:string; var y:TTemplate; var n:byte);
  var idx:byte;
    function readnum:word;
      var n:word;
      begin
      n:=0;
      while x[idx] in ['0'..'9'] do begin
        n:=10*n+ord(x[idx])-ord('0');
        inc(idx);
      end;
      readnum:=n;
      end;
  begin
  n:=0;
  y[0].one:='#';
  y[0].more:=['#'];
  y[0].min:=1;
  y[0].max:=1;
  idx:=1;
  while idx<=length(x) do begin
    case x[idx] of
      '?': begin
         inc(n);
         with y[n] do begin
           one:=#0;
           more:=Russian;
           min:=1;
           max:=1;
         end;
         end;
      '*': begin
         inc(n);
         with y[n] do begin
           one:=#0;
           more:=Russian;
           min:=0;
           max:=200;
         end;
         end;
      '[': begin inc(n); with y[n] do begin
             one:=#0;
             readdiap(x,idx,more);
             min:=1;
             max:=1;
           end; end;
      '@': begin
             y[n].max:=200;
           end;
      '{':
           if y[n].max=200 then begin
             while x[idx]<>'}' do inc(idx);
           end else begin
           inc(idx);
           y[n].min:=readnum;
           y[n].max:=y[n].min;
           if x[idx]=';' then begin
             if x[idx+1]='}' then begin
               y[n].max:=200;
               inc(idx);
             end else begin
               inc(idx);
               y[n].max:=readnum;
             end;
           end;
           end
      else begin
           inc(n);
           with y[n] do begin
             one:=rupcase(x[idx]);
             more:=[];
             include(more,one);
             min:=1;
             max:=1;
           end;
           end;
    end;
    inc(idx);
  end;
  inc(n);
  y[n].one:=#255;
  y[n].more:=[#255];
  end;

var Answer:string;

procedure WriteSol;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  writeln(Answer);
  Close(Output);
  end;

type TSostRec = record midx,pidx:byte; midx1,pidx1:byte; got:string; end;
     TSost=record s:array[1..5000] of ^TSostRec; n:word; end;
var st:string;
    curs,news:TSost;
    step:byte;
const done:boolean=false;

procedure Register(const x:TSostrec);
  begin
  if news.n=high(news.s) then begin
    done:=true;
    exit;
  end;
  inc(news.n);
  new(news.s[news.n]);
  news.s[news.n]^:=x;
  end;

procedure Addc(var st:string; const s:TCharSet);
  var ch:char;
  begin
  inc(st[0]);
  for ch:=#128 to #255 do
    if ch in s then begin
      st[length(st)]:=ch;
      break;
    end;
  end;
procedure Analyze(const x:TSostRec);
  var r:TSostRec;
     procedure think(dp,dm:byte);
       begin
       with x do
         if (mam[midx+dm].more * pap[pidx+dp].more)<>[] then
           if (mam[midx+dm].one=#255) = (pap[pidx+dp].one=#255) then begin
             if (mam[midx+dm].one=#255) and (pap[pidx+dp].one=#255) then
               if (Answer[1]='N') or (Answer>got) then begin
                 Answer:=got;
                 done:=true;
                 exit;
               end;
             r.midx:=midx+dm;
             r.pidx:=pidx+dp;
             if dp=0 then    r.pidx1:=pidx1+1
             else            r.pidx1:=1;
             if dm=0 then    r.midx1:=midx1+1
             else            r.midx1:=1;
             r.got:=got;
             addc(r.got,mam[midx+dm].more * pap[pidx+dp].more);
             Register(r);
           end;
       end;
     var mc,pc:byte;
         i,j:byte;
  begin
  with x do begin
    if mam[midx].max>midx1 then
      if pap[pidx].max>pidx1 then
        think(0,0);
(*    if mam[midx].max>midx1 then
      if pap[pidx].min<=pidx1 then
        think(1,0);
    if mam[midx].min<=midx1 then
      if pap[pidx].max>pidx1 then
        think(0,1);
    if mam[midx].min<=midx1 then
      if pap[pidx].min<=pidx1 then
        think(1,1);*)
    mc:=0;
    for i:=midx+1 to mamc do
      if mam[i].min<>0 then
        break
      else
        inc(mc);
    pc:=0;
    for i:=pidx+1 to papc do
      if pap[i].min<>0 then
        break
      else
        inc(pc);
    if mam[midx].min<=midx1 then
      if pap[pidx].max>pidx1 then
        for i:=1 to mc+1 do
          think(0,i);
    if pap[pidx].min<=pidx1 then
      if mam[midx].max>midx1 then
        for i:=1 to pc+1 do
          think(i,0);
    if pap[pidx].min<=pidx1 then
      if mam[midx].min<=midx1 then
        for i:=1 to pc+1 do
          for j:=1 to mc+1 do
            think(i,j);
  end;
  end;

procedure Run;
  var j:byte;
  begin
  Convert(papa,pap,papc);
  Convert(mama,mam,mamc);
  Answer:='NO SOLUTION';

  new(curs.s[1]);
  with curs.s[1]^ do begin
    midx:=1;
    midx1:=0;
    pidx:=1;
    pidx1:=0;
    got:='';
  end;
  curs.n:=1;

  step:=0;
  repeat
    inc(step);
    news.n:=0;
    for j:=1 to curs.n do begin
      Analyze(curs.s[j]^);
    end;
    for j:=1 to curs.n do
      dispose(curs.s[j]);
    curs:=news;
  until done or (curs.n=0);

  end;

begin
ReadData;
Run;
WriteSol;
end.