Uses Crt;
Const
  Walls   : Array [0..15] of Char = (#179,#196,#179,#217,#196,#196,#192,#193,
                                     #179,#191,#179,#180,#218,#194,#195,#197);
  HWalls  : Array [0..15] of Char = (#186,#205,#186,#188,#205,#205,#200,#207,
                                     #186,#187,#186,#182,#201,#209,#199,#206);
Var
  a,b,c         : Integer;
  Map           : Array [0..102,0..102] of Char;
  f             : Text;
  xr,yr         : Integer;
  St            : String;

Begin
  Assign(f,'input.txt');
  Reset(f);
  ReadLn(f,yr,xr);
  FillChar(Map,SizeOf(Map),0);
  For b:=1 to yr do
    for a:=1 to xr do Begin
      ReadLn(f,St);
      If Pos('L',St)<>0 then
        Map[a*2-1,b*2]:=#219;
      If Pos('R',St)<>0 then
        Map[a*2+1,b*2]:=#219;
      If Pos('U',St)<>0 then
        Map[a*2,b*2-1]:=#219;
      If Pos('D',St)<>0 then
        Map[a*2,b*2+1]:=#219;
      Map[a*2+1,b*2+1]:=#219;
      Map[a*2-1,b*2+1]:=#219;
      Map[a*2-1,b*2-1]:=#219;
      Map[a*2+1,b*2-1]:=#219;
    End;
  Close(f);

  For a:=1 to xr*2+1 do
    for b:=1 to yr*2+1 do
      if Map[a,b]='' then Begin
        c:=0;
        if Map[a-1,b]<>#0 then Inc(c,1);
        if Map[a,b-1]<>#0 then Inc(c,2);
        if Map[a+1,b]<>#0 then Inc(c,4);
        if Map[a,b+1]<>#0 then Inc(c,8);
        Map[a,b]:=Walls[c];
      End;
  For a:=1 to xr*2+1 do Begin
    For b:=0 to 15 do Begin
      if Map[a,1]=Walls[b] then Map[a,1]:=HWalls[b];
      if (a<>1) and (a<>xr*2+1) and (Map[a,1]=#201) then Map[a,1]:=#213;
      if (a<>1) and (a<>xr*2+1) and (Map[a,1]=#187) then Map[a,1]:=#184;
      if Map[a,yr*2+1]=Walls[b] then Map[a,yr*2+1]:=HWalls[b];
      if (a<>1) and (a<>xr*2+1) and (Map[a,yr*2+1]=#200) then Map[a,yr*2+1]:=#212;
      if (a<>1) and (a<>xr*2+1) and (Map[a,yr*2+1]=#188) then Map[a,yr*2+1]:=#190;
    End;
  End;

  For a:=1 to yr*2+1 do Begin
    For b:=0 to 15 do Begin
      if Map[1,a]=Walls[b] then Map[1,a]:=HWalls[b];
      if (a<>1) and (a<>yr*2+1) and (Map[1,a]=#201) then Map[1,a]:=#214;
      if (a<>1) and (a<>yr*2+1) and (Map[1,a]=#200) then Map[1,a]:=#211;
      if Map[xr*2+1,a]=Walls[b] then Map[xr*2+1,a]:=HWalls[b];
      if (a<>1) and (a<>yr*2+1) and (Map[xr*2+1,a]=#188) then Map[xr*2+1,a]:=#189;
      if (a<>1) and (a<>yr*2+1) and (Map[xr*2+1,a]=#187) then Map[xr*2+1,a]:=#183;
    End;
  End;

  for a:=1 to xr-1 do
    for b:=1 to yr-1 do Begin
      c:=0;
      if (Map[a*2+1,b*2+2]=#0) then Inc(c);
      if (Map[a*2+2,b*2+1]=#0) then Inc(c);
      if (Map[a*2+1,b*2]=#0) then Inc(c);
      if (Map[a*2,b*2+1]=#0) then Inc(c);
      If (c>=3) then
        Map[a*2+1,b*2+1]:=#0;
    End;
  Assign(f,'output.txt');
  Rewrite(f);
  For b:=1 to yr*2+1 do Begin
    For a:=1 to xr*2+1 do
      Write(f,Map[a,b]);
    WriteLn(f);
  End;
  Close(f);
End.