{  宯 }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}

program XPEH;
const Dig: array [0..9] of string[10] =
      ('',
       '~',
       '!',
       '!',
       '~',
       '!',
       '!',
       '!',
       '~ᥬ',
       '~');
      Twenty: array [11..19] of string[15] =
      ('~',
       '~',
       'ਭ~',
       '~ୠ',
       '~',
       '~',
       'ᥬ~',
       'ᥬ~',
       '~');
      Tens: array [1..9] of string[15] =
      ('~',
       '~',
       '~',
       '~ப',
       '줥~',
       '줥~',
       '~줥',
       '~ᥬ줥',
       '~');
      Hundreds: array [1..9] of string[15] =
      ('!',
       '~',
       '~',
       '~',
       '~',
       '~',
       'ᥬ~',
       'ᥬ~',
       '~');
      Thou1: array [0..9] of string[10] =
      ('', '', '!', '!', '~', '!', '!', '!',
       '~ᥬ', '~');
      Thou2: array [0..9] of string[10] =
      ('~', '~', '~','~','~',
       '~', '~', '~', '~', '~');

const TimeLimit = 9.0;

var sch: array [1..20] of string;
    prev, id: array [1..20] of integer;
    Nums: array [1..20, 0..200] of integer;
    sts: array [1..20, 1..1500] of char;
    stl: array [1..20] of integer;
    used: array [1..20, 0..999] of boolean;
    n: integer;
    Timer: longint absolute $40:$6C;
    st: longint;

procedure ReadAll;
var i, j: integer;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Readln(N);
  for i := 1 to N do begin
    Read(id[i]);
    Readln(sch[i]);
    j := 1;
    while sch[i,j] = ' ' do Inc(j);
    Delete(sch[i], 1, j-1);
    for j := 1 to length(sch[i]) do
      if sch[i,j] = '''' then sch[i,j] := '"';
  end;
  for i := 1 to N do begin
    for j := 1 to i-1 do
      if id[i] = id[j] then prev[i] := j;
  end;
end;

function Spell(i: longint; thou: boolean): string;
var s: string;
    dd, form: integer;
begin
  if i < 1000 then begin
    s := '';
    if i = 0 then begin
      Spell := '!';
      Exit;
    end;
    if i >= 100 then begin
      s := s + Hundreds[i div 100];
    end;
    dd := (i div 10) mod 10;
    case i mod 100 of
      0..9, 20..99:
      begin
        if dd > 0 then begin
          s := s + Tens[dd];
        end;
        form := i mod 10;
        if thou then
          s := s + Thou1[i mod 10]
        else begin
          s := s + Dig[i mod 10]
        end;
      end;
      10..19:
      begin
        s := s + Twenty[i mod 100];
        form := 9;
      end;
    end;
    if thou then
      s := s + Thou2[form];
    Spell := s;
  end else
    Spell := Spell(i div 1000, true) + Spell(i mod 1000, false);
end;

function Getsch(const s: string): string;
var i: integer;
    d: string;
begin
  i := 1;
  d := '';
  while i <= length(s) do begin
    if (s[i] = '~') or (s[i] = '!') then begin
      if s[i] = '~' then d := d + '"' else d := d + '!';
      inc(i,2);
    end else
    if (s[i] in ['','','','','','','','','']) then begin
      d := d + '~';
      inc(i);
    end else
      inc(i);
  end;
  Getsch := d;
end;

function Rhyme(p, q: integer): boolean;
var i, j: integer;
begin
  i := stl[p];
  j := stl[q];
  Rhyme := false;
  if (sts[p,i] = '~') and (sts[q,j] = '~') then begin
    Rhyme := (i > 1) and (j > 1) and (sts[p,i-1] = sts[q,j-1]);
  end;
  repeat
    if (sts[p,i] <> sts[q,j]) then Exit;
    if (sts[p,i] = '~') then begin
      Rhyme := true;
      Exit;
    end;
    Dec(i);
    Dec(j);
    if (i = 0) or (j = 0) then Exit;
  until false;
end;

function Match(const sch, s: string; p: integer): boolean;
var i, j: integer;
begin
  i := p;
  j := 1;
  Match := false;
  while j <= length(s) do begin
    if i > length(sch) then exit;
    if sch[i] = '"' then begin
      if (s[j] <> '!') and (s[j] <> '"') then Exit;
    end else
    if sch[i] = '~' then begin
      if (s[j] <> '!') and (s[j] <> '~') then Exit;
    end else
    if (sch[i] <> s[j]) then Exit;
    inc(i);
    inc(j);
  end;
  Match := true;
end;

function SameEnd(a, b: integer): boolean;
begin
  a := Nums[a,Nums[a,0]];
  b := Nums[b,Nums[b,0]];
  case a mod 100 of
    0: SameEnd := (a div 100 = b div 100);
    10..19,10,20,30,40,50,60,70,80,90: SameEnd := (a mod 100 = b mod 100);
    else SameEnd := a mod 10 = b mod 10;
  end;
end;

procedure NoSol;
begin
  Writeln('NO SOLUTION');
  Halt;
end;

procedure Rec(x, y: integer);
const Ud: array [1..12] of byte =
      (0,2,3,5,6,7,102,103,105,106,107,100);

var Tries, d, c, i, j, a: integer;
    ss, sc: string[30];
    len_st: integer;
    flag: boolean;
label Skip, 1, 2;
begin
  if Timer - st > Trunc(TimeLimit*18.2) then begin
    NoSol;
  end;
  if y > N then begin
    for i := 1 to N do begin
      for j := 1 to Nums[i,0] do begin
        if j <> 1 then Write(' ');
        Write(Nums[i, j]);
      end;
      Writeln;
    end;
    Halt;
  end else
  if x > length(sch[y]) then begin
    for i := 1 to y-1 do
      if (id[i] = id[y]) and (not Rhyme(i, y)) then goto Skip;
    if (prev[y] > 0) and (SameEnd(y, prev[y])) then goto Skip;
    Rec(1, y+1);
Skip:
  end else begin
    d := (length(sch[y]) - x);
    if d = 0 then Exit;
    len_st := stl[y];
    flag := (d >= 2) and (sch[y,x]='"') and (sch[y,x+1]='"') and
            (sch[y,x+2]='"');
    for c := 1 to 3 do begin
      Tries := 0;
      repeat
        Inc(Tries);
        if Tries > 100 then exit;
        repeat
          { Optimization }
          if flag then begin
            a := Ud[random(high(ud))+1];
          end else
          if random(3) = 1 then
            a := random(10)*100 + random(99) + 1
          else
          case random(3+Byte(d=1)) of
            0: a := random(100) + 1;
            1: a := random(9) + 11;
            2: a := 50 + random(2) + random(3)*100;
            3: if (d = 1) then a := 100*(5+random(5));
          end;
          ss := Spell(a, false);
          sc := Getsch(ss);
        until Match(sch[y], sc, x) and (not used[y,a]);
        if (x + length(sc) > length(sch[y])) then begin
          if (not ((a mod 100) in [0, 10..20, 50, 60])) then goto 1;
        end;
        break;
1:
      until false;

      Inc(Nums[y,0]); Nums[y,Nums[y,0]] := a;
      Used[y,a] := True;
      Move(ss[1], sts[y,stl[y]+1], length(ss));
      inc(stl[y], length(ss));
      Rec(x + length(sc), y);
      stl[y] := len_st;
      Used[y, a] := False;
      Dec(Nums[y,0]);
    end;
  end;
end;

procedure Solve;
begin
  Rec(1, 1);
  NoSol;
end;

begin
  st := Timer;
  Randseed := 123817232;
  ReadAll;
  Solve;
end.