{$A+,B-,E-,F-,G-,N-,P-,Q-,T-,V+,X+,Y+}
{$D-,L-,R-,S-,I-}
{$M 65520,0,655360}

program Stihi;

const
	num_count = 37;

	numbers : array [1..num_count] of record
								num : string [20];
								code : longint;
							end =
    ((num: 'ਭ'''; code: 13), (num: ''''; code: 15),
    (num: ''''; code: 12), (num: ''''; code: 1),
	(num: ''''; code: 4), (num: '''ᥬ'; code: 8),
	(num: ''''; code: 9), (num: ''''; code: 10),
	(num: ''''; code: 11), (num: '''ୠ'; code: 14),
	(num: ''''; code: 16), (num: 'ᥬ'''; code: 17),
	(num: 'ᥬ'''; code: 18), (num: ''''; code: 19),
	(num: ''''; code: 20), (num: ''''; code: 30),
	(num: '''ப'; code: 40),	(num: '줥'''; code: 50),
	(num: '줥'''; code: 60), (num: '''줥'; code: 70),
	(num: '''ᥬ줥'; code: 80), (num: ''''; code: 90),
	(num: ''''; code: 200), (num: ''''; code: 300),
    (num: ''''; code: 400), (num: ''''; code: 500),
	(num: ''''; code: 600), (num: 'ᥬ'''; code: 700),
	(num: 'ᥬ'''; code: 800), (num: ''''; code: 900),
    (num: ''''; code: 1000),
    (num: ''; code: 100), (num: ''; code: 2),
	(num: ''; code: 3), (num: ''; code: 5),
	(num: ''; code: 6), (num: 'ᥬ'; code: 7)
	);

	glas : set of char = ['', '', '', '', '', '', '', '', ''];

type
	linesSet = set of 1..20;
    wordsSet = set of 1..num_count;

var
	words : array [1..num_count] of record
    				w : string [20];
                    scheme : string [4];
                    len : byte;
                    ud_pos : byte;
                    ud_glas : byte;
                    end;

    num_str : integer;
    scheme : array [1..20] of string;

    s, s2 : string;
    i, j, num : integer;

    num_rhytm : integer;
    rhytmes : array [1..20] of record
            		code : integer;
                    lines : linesSet;
                    end;

    Lines_toMake, lines_made : linesSet;

    cur_line : integer;

    work : array [1..20] of record
    			words : array [1..num_count] of integer;
                num_words : integer;
                scheme_pos : integer;
                used : wordsSet;
                end;

procedure AnalyzeWord (i : integer);
	var
    	count : integer;
        position : integer;

	begin
    	position := pos ('''', numbers [i].num);
        if position = 0
        	then
            	begin
                	words [i].w := numbers [i].num;
                    words [i].scheme := '?';
                    words [i].len := 1;
                    words [i].ud_pos := 0;
                    count := 1;
                    while not (words [i].w [count] in glas) do
                    	inc (count);
                    words [i].ud_glas := count;
                end
            else
            	begin
                	words [i].w := copy (numbers [i].num, 1, position - 1) +
                    			copy (numbers [i].num, position + 1, 20);
                	words [i].ud_pos := position;
                    words [i].ud_glas := position;
                    words [i].scheme := '';
                    for count := 1 to length (words [i].w) do
                    	if (words [i].w [count] in glas)
                        	then if count = position
                            	then words [i].scheme := words [i].scheme + ''''
                                else words [i].scheme := words [i].scheme + '~';

                    words [i].len := length (words [i].scheme);
                end;
    end;

function GetEnding (line : integer) : string;
	var
    	m, n, k : integer;
        s : string;

    begin
    	m := 1;
        n := length (words [work [line].words [m]].w);
        s := '';
        repeat
        	if (n < 1)
            	then
                	begin
                    	inc (m);
				        n := length (words [work [line].words [m]].w);
                    end
                else dec (n);
        	s := s + words [work [line].words [m]].w [n];
        until n = words [work [line].words [m]].ud_pos;
		GetEnding := s;
    end;

function CheckRhytming : boolean;
	var
    	i1, i2 : integer;

	begin
    	i1 := 20;
        while not (i1 in lines_made) do
        	dec (i1);
        if (lines_made - [i1]) = []
        	then
            	begin
                	CheckRhytming := true;
                    Exit;
                end;
        i2 := i1 - 1;
        while not (i2 in lines_made) do
        	dec (i2);
		if work [i1].words [work [i1].num_words] = work [i2].words [work [i1].num_words]
			then
				begin
					CheckRhytming := false;
                    Exit;
                end;
        if GetEnding (i1) = GetEnding(i2)
        	then CheckRhytming := true
            else CheckRhytming := false;
    end;

function ComposeLines : boolean;
	var
    	i : integer;

	begin
        if {work [cur_line].scheme_pos > length (scheme [cur_line])}
        	(work [cur_line].scheme_pos < 1)
        	then
            	begin
	               	i := cur_line;
                   	exclude (lines_toMake, cur_line);
                    include (lines_made, cur_line);
                    if lines_toMake = []
                        	then
                            	begin
                                	ComposeLines := true;
                                    Exit;
                                end
                            else
                            	begin
				                   	while not (cur_line in lines_toMake) do
                                    	inc (cur_line);
                                	if ComposeLines
                                    	then
                                        	begin
                                            	ComposeLines := true;
                                                Exit;
                                            end;
				                	cur_line := i;
				                   	include (lines_toMake, cur_line);
				                    exclude (lines_made, cur_line);
                                end;
                end
            else
            	begin
                	for i := 1 to num_count do
                    	if not (i in work [cur_line].used)
                        	then
                            	if words [i].len = 1
                                	then
                                    	begin
                                        	case scheme [cur_line] [work [cur_line].scheme_pos] of
                                            	'''': words [i].ud_pos := words [i].ud_glas;
												'~': words [i].ud_pos := 0;
                                                end;
                                            dec (work [cur_line].scheme_pos);
                                            inc (work [cur_line].num_words);
                                            work [cur_line].words [work [cur_line].num_words] := i;
                                            include (work [cur_line].used, i);
                                            if ComposeLines
												then
													begin
														ComposeLines := true;
                                                        Exit;
                                                    end;
                                            inc (work [cur_line].scheme_pos);
                                            dec (work [cur_line].num_words);
                                            exclude (work [cur_line].used, i);
											words [i].ud_pos := 0;
                                        end
                                    else
                                    	if (words [i].len <= work [cur_line].scheme_pos) and
											(copy (scheme [cur_line], work [cur_line].scheme_pos - words [i].len + 1,
											words [1].len) = words [i].scheme)
                                        	then begin
                                            inc (work [cur_line].num_words);
                                            work [cur_line].words [work [cur_line].num_words] := i;
                                            dec (work [cur_line].scheme_pos, words [i].len);
                                            include (work [cur_line].used, i);
                                            if ComposeLines
												then
													begin
														ComposeLines := true;
                                                        Exit;
                                                    end;
                                            exclude (work [cur_line].used, i);
                                            dec (work [cur_line].num_words);
                                            inc (work [cur_line].scheme_pos, words [i].len);
                                        	end;
                end;
        ComposeLines := false;
    end;

function ComposeRhytmes : boolean;
	var
    	i, prev : integer;

	begin
    	prev := 0;
    	for i := 1 to num_count do
        	if not (i in work [cur_line].used) then
            	if words [i].len = 1
                	then
                    	begin
                            case scheme [cur_line] [work [cur_line].scheme_pos] of
                                '''': words [i].ud_pos := words [i].ud_glas;
								'~': words [i].ud_pos := 0;
                                end;
                            dec (work [cur_line].scheme_pos);
                            inc (work [cur_line].num_words);
                            work [cur_line].words [work [cur_line].num_words] := i;
                            include (work [cur_line].used, i);
                            if (scheme [cur_line] [work [cur_line].scheme_pos + 1] = '~')
                            	then begin
                                	if ComposeRhytmes
                                    	then
                                        	begin
                                            	ComposeRhytmes := true;
                                                Exit;
                                            end;
                                    end
                                else
                                	begin
					                   	exclude (lines_toMake, cur_line);
					                    include (lines_made, cur_line);
					                	prev := cur_line;
                                        if CheckRhytming
                                        	then
                                            	if lines_toMake = []
                                                	then
                                                    	begin
	                                        lines_toMake := lines_made;
	                                        cur_line := 1;
							                while not (cur_line in lines_toMake) do
							                	inc (cur_line);
							                lines_made := [];
				                            if ComposeLines
												then
													begin
														ComposeRhytmes := true;
				                                        Exit;
				                                    end;
	                                        lines_made := lines_toMake;
											lines_toMake := [];
														end
													else
														begin
	                                        cur_line := 1;
							                while not (cur_line in lines_toMake) do
							                	inc (cur_line);
				                            if ComposeRhytmes
												then
													begin
														ComposeRhytmes := true;
				                                        Exit;
				                                    end;
                                                    	end;
					                	cur_line := prev;
					                   	include (lines_toMake, cur_line);
					                    exclude (lines_made, cur_line);
                                    end;

                            inc (work [cur_line].scheme_pos);
                            dec (work [cur_line].num_words);
                            exclude (work [cur_line].used, i);
							words [i].ud_pos := 0;
                        end
        	else if (words [i].len <= work [cur_line].scheme_pos) and
				(copy (scheme [cur_line], work [cur_line].scheme_pos - words [i].len + 1, words [i].len) =
            	words [i].scheme)
		            then
                    	begin
                            dec (work [cur_line].scheme_pos, words [i].len);
                            inc (work [cur_line].num_words);
                            work [cur_line].words [work [cur_line].num_words] := i;
                            include (work [cur_line].used, i);
                                	begin
					                   	exclude (lines_toMake, cur_line);
					                    include (lines_made, cur_line);
					                	prev := cur_line;
                                        if CheckRhytming
                                        	then
                                            	if lines_toMake = []
                                                	then
                                                    	begin
	                                        lines_toMake := lines_made;
	                                        cur_line := 1;
							                while not (cur_line in lines_toMake) do
							                	inc (cur_line);
							                lines_made := [];
				                            if ComposeLines
												then
													begin
														ComposeRhytmes := true;
				                                        Exit;
				                                    end;
	                                        lines_made := lines_toMake;
											lines_toMake := [];
														end
													else
														begin
	                                        cur_line := 1;
							                while not (cur_line in lines_toMake) do
							                	inc (cur_line);
				                            if ComposeRhytmes
												then
													begin
														ComposeRhytmes := true;
				                                        Exit;
				                                    end;
                                                    	end;
					                	cur_line := prev;
					                   	include (lines_toMake, cur_line);
					                    exclude (lines_made, cur_line);
                                    end;

                            inc (work [cur_line].scheme_pos, words [i].len);
                            dec (work [cur_line].num_words);
                            exclude (work [cur_line].used, i);
                        end;
        ComposeRhytmes := false;
    end;



procedure ComposeAPoem;
	var
    	i : integer;

	begin
       	for cur_line := 1 to num_str do
			begin
            	work [cur_line].num_words := 0;
                work [cur_line].scheme_pos := length (scheme [cur_line]);
                work [cur_line].used := [];
			end;

    	for i := 1 to num_rhytm do
        	begin
            	lines_toMake := rhytmes [i].lines;
                cur_line := 1;
                while not (cur_line in lines_toMake) do
                	inc (cur_line);
                lines_made := [];

                ComposeRhytmes;
            end;
    end;

begin
	num_rhytm := 0;
	assign (input, 'input.txt');
    reset (input);
    readln (num_str);
    for i := 1 to num_str do
    	begin
        	read (num);
            readln (scheme [i]);
            delete (scheme [i], 1, 1);
            j := 1;
            while (j <= num_rhytm) and (num <> rhytmes [j].code) do
            	inc (j);
            if (j > num_rhytm)
            	then
                	begin
                    	inc (num_rhytm);
                        rhytmes [num_rhytm].code := num;
                        rhytmes [num_rhytm].lines := [i];
                    end
                else include (rhytmes [j].lines, i);
        end;

    for i := 1 to 38 do
    	AnalyzeWord (i);

    ComposeAPoem;

    assign (output, 'output.txt');
    rewrite (output);
    for i := 1 to num_str do
    	begin
        	for j := work [i].num_words downto 2 do
            	Write (numbers [work [i].words [j]].code, ' ');
            Writeln (numbers [work [i].words [1]].code);
        end;
    close (output);
end.
