{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{ $r+}

const
 maxn=1500;
 maxk=3100;
 maxm=maxk*2;

type
 tm=record
  come:boolean;
  id:integer;
  side:byte; {1=right}
  sing:boolean;
  when:integer;
  get:byte;
 end;
 tlsr=record
  w:integer;
  a:integer;
 end;
 tlsra=array[0..maxk-1]of tlsr;
 tlsrs=record
  n:integer;
  m:^tlsra;
 end;

var
 cs:array[0..maxm-1]of tm;
 n,k:integer;

 req:array[0..1]of integer;
 lr:integer;
 lra:array[0..maxk-1]of integer;
 lsr:array[0..1]of tlsrs;
 l_r:array[0..1]of integer;

procedure readin;
 var
  f:text;
  i,j,_:integer;
  buf:string;
  wh:array[0..maxn-1]of integer;
 begin
  assign(f,'input.txt'); reset(f);
  readln(f,n);
  readln(f,k);
  for i:=0 to 2*k-1 do begin
   readln(f,buf);
   cs[i].come:=buf[1]='+';
   delete(buf,1,2);
   j:=pos(' ',buf);
   val(copy(buf,1,j-1),cs[i].id,_); dec(cs[i].id);
   delete(buf,1,j);
   cs[i].side:=byte(buf[1] in ['','','r','R']);
   cs[i].sing:=buf[3] in ['','','y','Y'];
   if(cs[i].come)then wh[cs[i].id]:=i
   else begin
    cs[i].when:=wh[cs[i].id];
    cs[wh[cs[i].id]].when:=i;
   end;
   if(cs[i].come)and(cs[i].sing)then cs[i].get:=1
   else cs[i].get:=0;
  end;
  close(f);
 end;

procedure make(action:integer);
 begin
  cs[action shr 1].get:=action and 1;
 end;

procedure writeout;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'output.txt'); rewrite(f);
  writeln(f,req[0],' ',req[1]);
  for i:=0 to 2*k-1 do if(cs[i].come)then
   writeln(f,cs[i].get);
  close(f);
 end;

procedure put(s,w,a:integer);
 var
  min,max,mid:integer;
 begin
  min:=0; max:=lsr[s].n;
  while(min<max)do begin
   mid:=(min+max-1)shr 1;
   if(lsr[s].m^[mid].w<=w)then min:=mid+1
   else max:=mid;
  end;
  move(lsr[s].m^[min],lsr[s].m^[min+1],sizeof(lsr[s].m^[min])*(lsr[s].n-min));
  inc(lsr[s].n);
  lsr[s].m^[min].w:=w;
  lsr[s].m^[min].a:=a;
 end;

procedure solve;
 var
  i,j:integer;
 begin
  fillchar(req,sizeof(req),0);
  fillchar(l_r,sizeof(l_r),0);
  lr:=0;
  lsr[0].n:=0; new(lsr[0].m);
  lsr[1].n:=0; new(lsr[1].m);
  for i:=0 to 2*k-1 do with cs[i] do begin
   if(come)then begin
    if(sing)then begin
     if(l_r[side]>0)then dec(l_r[side])
     else if(lsr[side].n>0)then begin
      dec(lsr[side].n);
      make(lsr[side].m^[lsr[side].n].a xor 1);
     end else if(lr>0)then begin
      dec(lr);
      make(lra[lr] xor side xor 1);
     end else begin
      inc(req[side]);
     end;
    end else if(cs[when].side<>side)then begin
     if(l_r[side]>0)then begin
      dec(l_r[side]);
      put(side,when,i shl 1+1);
     end else if(lsr[side].n>0)and(lsr[side].m^[lsr[side].n-1].w>when)then begin
      dec(lsr[side].n);
      put(side,when,i shl 1+1);
     end;
    end;
   end else begin
    if(lsr[1-side].n>0)and(lsr[1-side].m^[0].w<=i)then begin
     lra[lr]:=lsr[1-side].m^[0].a xor (1-side);
     inc(lr);
     dec(lsr[1-side].n);
     move(lsr[1-side].m^[1],lsr[1-side].m^[0],sizeof(lsr[1-side].m^[0])*lsr[1-side].n);
    end;
    if(sing)then inc(l_r[side]);
   end;
  end;
  dispose(lsr[0].m);
  dispose(lsr[1].m);
 end;

procedure checksol;
 var
  i:integer;
  has:array[0..maxn-1]of boolean;
 begin
  fillchar(has,sizeof(has),0);
  for i:=0 to 2*k-1 do with cs[i] do begin
  end;
 end;

begin
 readin;
 solve;
 writeout;
end.