{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}

{ $r+}

const
 maxn=20;
 maxw=200;
 maxwl=255;

type
 tw=record
  w:string[32];
  f:string[16];
  gr:integer;
 end;
 tstring=string;
 pstring=^tstring;

var
 ws:array[0..maxw-1]of tw;
 wn:integer;
 n:integer;
 sc:array[0..maxn-1]of string;
 rh:array[0..maxn-1]of integer;
 p:array[0..maxn-1,0..maxwl-1]of integer;
 pn:array[0..maxn-1]of integer;

 ls:array[0..maxn-1]of integer;
 ln:integer;

procedure readin;
 var
  f:text;
  i,j,k:integer;
 begin
  assign(f,'input.txt'); reset(f);
  readln(f,n);
  for i:=0 to n-1 do begin
   readln(f,sc[i]);
   j:=pos(' ',sc[i]);
   val(copy(sc[i],1,j-1),rh[i],k);
   delete(sc[i],1,j);
   while(pos('''',sc[i])>0)do sc[i][pos('''',sc[i])]:='`';
  end;
  close(f);
 end;

procedure writeout;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'output.txt'); rewrite(f);
  for i:=0 to n-1 do begin
   for j:=pn[i]-1 downto 0 do
    write(f,ws[p[i,j]].w,' ');
   writeln(f);
  end;
  close(f);
 end;

procedure putw(w,f:string; gr:integer);
 begin
  if(wn>=maxw)then halt(216);
  ws[wn].f:=f;
  ws[wn].w:=w;
  ws[wn].gr:=gr;
  inc(wn);
 end;

const
 maxr=4;

function getf(s:string):string;
 var
  i:integer;
 begin
  for i:=0 to wn-1 do
   if ws[i].w=s then begin
    getf:=ws[i].f;
    exit;
   end;
  getf:='';
 end;

procedure putws;
 var
  i,j:integer;
  s,f:string;
 begin
  wn:=0;
  putw('1','~`',-1);
  putw('4','~`~',-1);
  putw('8','`~',-1);
  putw('9','`~',-1);
  putw('10','`~',-1);
  putw('11','~`~~',-1);
  putw('12','~`~',2); {adcat}
  putw('13','~`~',2);
  putw('14','~`~~',-1); {irnadcat}
  putw('15','~`~',2);
  putw('16','~`~',2);
  putw('17','~`~',2);
  putw('18','~~`~',2);
  putw('19','~~`~',2);
  putw('20','`~',2);
  putw('30','`~',-1); {idcat}
  putw('40','`~',-1);
  putw('50','~~`',1); {at}
  putw('60','~~`',1);
  putw('70','`~~',-1); {emdesat}
  putw('80','`~~',-1);
  putw('90','`~',-1);
  putw('200','`~',-1);
  putw('300','`~',-1);
  putw('400','~`~~',-1);
  putw('500','~`',0); {sot}
  putw('600','~`',0);
  putw('700','~`',0);
  putw('800','~~`',0);
  putw('900','~~`',0);
  putw('1000','`~~',-1);
  putw('1000000','~~`',3); {on}
  putw('1000000000','~~`',-1);
  putw('1000000000000','~~`',3); {tri} {on}
  putw('1000000000000000','~~~`',3); {15}
  putw('1000000000000000000','~~~`',3); {18}
  putw('1000000000000000000000','~~~`',3); {21}
  putw('1000000000000000000000000','~~~`',3); {24}
  putw('1000000000000000000000000000','~~~`',3); {27}
  putw('0','0',-1);
  putw('2','0',-1);
  putw('3','0',-1);
  putw('5','0',-1);
  putw('6','0',-1);
  putw('7','0',-1);
  putw('100','0',-1);
  for i:=101 to 199 do begin
   str(i-100,s);
   f:=getf(s);
   if f<>'' then begin
    str(i,s);
    putw(s,'0'+f,-1);
   end;
  end;
 end;

var
 scs,scr:string;
 scn:integer;
 curn:integer;
 used:array[0..maxw-1]of boolean;

function postfix(var a,b:string):boolean;
 var
  i:integer;
 begin
  for i:=0 to length(a)-1 do
   if not(a[length(a)-i]in [b[length(b)-i],'0'])then begin
    postfix:=false;
    exit;
   end;
  postfix:=true;
 end;

function rs1:boolean;
 var
  i:integer;
 begin
  if(length(scr)=0)then begin
   rs1:=true;
   exit;
  end;
  for i:=0 to wn-1 do if
   (not used[i])and
   (length(scr)>=length(ws[i].f))and
   (postfix(pstring(addr(ws[i].f))^,scr))then begin
   dec(scr[0],length(ws[i].f));
   p[scn,curn]:=i;
   inc(curn);
   used[i]:=true;
   if rs1 then begin
    rs1:=true;
    exit;
   end;
   used[i]:=false;
   dec(curn);
   inc(scr[0],length(ws[i].f));
  end;
  rs1:=false;
 end;

procedure solve1(s:integer);
 begin
  scs:='';
  scn:=s;
  scr:=sc[s];
  curn:=0;
  fillchar(used,sizeof(used),0);
  if rs1 then
   pn[scn]:=curn;
 end;

var
 lw:array[0..maxn-1]of integer;
 clw:integer;
 crh:integer;

function solvem1e:boolean;
 var
  i:integer;
  ok:boolean;
 begin
  ok:=true;
  for i:=0 to ln-1 do begin
   scs:='';
   scn:=ls[i];
   scr:=sc[ls[i]];
   curn:=1;
   fillchar(used,sizeof(used),0);
   used[lw[i]]:=true;

   dec(scr[0],length(ws[lw[i]].f));
   p[scn,0]:=lw[i];

   if rs1 then begin
    pn[scn]:=curn;
    continue;
   end else begin
    solvem1e:=false;
    exit;
   end;
  end;
  solvem1e:=true;
 end;

function solvem1lw:boolean;
 var
  i:integer;
 begin
  if clw>=ln then begin
   solvem1lw:=solvem1e;
   exit;
  end;
  for i:=0 to wn-1 do if
   (ws[i].gr=crh)and
   ((clw=0)or(lw[clw-1]<>i))and
   (length(sc[ls[clw]])>=length(ws[i].f))and
   (postfix(pstring(addr(ws[i].f))^,sc[ls[clw]]))then begin
   lw[clw]:=i;
   inc(clw);
   if solvem1lw then begin
    solvem1lw:=true;
    exit;
   end;
   dec(clw);
  end;
  solvem1lw:=false;
 end;

function solvem1(r:integer):boolean;
 begin
  clw:=0;
  crh:=r;
  solvem1:=solvem1lw;
 end;

procedure solvem;
 var
  i:integer;
 begin
  for i:=0 to maxr-1 do begin
   if solvem1(i) then break;
  end;
 end;

procedure solve;
 var
  i,j:integer;
 begin
  fillchar(pn,sizeof(pn),0);
  for i:=1 to n do begin
   ln:=0;
   for j:=0 to n-1 do
    if rh[j]=i then begin
     ls[ln]:=j;
     inc(ln);
    end;
   if ln=1 then solve1(ls[0])
   else if ln>1 then solvem;
  end;
 end;

begin
 readin;
 putws;
 solve;
 writeout;
end.