{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const   Max=11500;
type TTT=Comp;
     TSet = set of 1..100;
     TNab = array [0..110] of Byte;
     TS = array [1..100] of TTT;
     PVert = ^TVert;
     TVert = record
              C: TS;
              Prev, Left, Next: PVert;
              INQ: Integer;
              {next-sled sam prav}
             end;
var  N, K,L: Integer;
     W: array [1..110] of string[12];
     R1: array [1..110] of Byte;
     R2: array [1..110] of TNab;
     R2S: array [1..110] of TSet;
     Gold, Svin: Integer;
     Ans:TTT;
     Tick: Longint absolute 0:$46c;
     OTick: LongInt;

procedure DecC (var T: TTT);
begin
 T:=T-1;
end;

procedure IncC (var T: TTT);
begin
 T:=T+1;
end;

procedure ReadIn;
var       J, I: Integer;
          C: Char;
          S: string;

procedure ReadNabSet (var Nab: TNab; var St: TSet);
var       J: Integer;
begin
 Nab[0]:=0; St:=[];
 while not EOLN do
 begin
  repeat Read (C); until C<>' '; S:=C;
  repeat
   Read(C); if C=' ' then Break;
   S:=S+C;
  until EOLN;
  for J := 1 to K do
   if S=W[J] then Break;
  Inc (Nab[0]); Nab[Nab[0]]:=J; St:=St+[J];
 end;
 ReadLn;
end;

begin
 Assign (Input,'input.txt'); reset (Input);
 ReadLn (K);
 for I := 1 to K do
 begin
  repeat Read (C); until C<>' '; W[I]:=C;
  repeat
   Read(C); if C=' ' then Break;
   W[I]:=W[I]+C;
  until EOLN;
  if W[I]='ᢨ' then Svin :=I;
  if W[I]='' then Gold :=I;
 end;
 ReadLn;
 ReadLn (L);
 for I := 1 to L do
 begin
  ReadLn (S);
  for J := 1 to K do if W[J]=s then Break;
  R1[I] := J;
  ReadNabSet (R2[I], R2S[I]);
 end;
 Close (input);
end;

procedure WriteOut (Ans:TTT);
begin
 assign (output,'output.txt'); rewrite (output);
 WriteLn (Ans:0:0);
 Close(output);
 Halt;
end;

procedure QSatis;
begin
 assign (output,'output.txt'); rewrite (output);
 WriteLn ('QUANTUM SATIS');
 Close(output);
 Halt;
end;

var       Q: array [0..Max] of PVert;

procedure Solve;
var       O1, O2: Integer;
          F: TVert;
          P: PVert;
          TT, T: PVert;
          Res,I,J,V: Integer;
          Predok: Boolean;
          State: (_DOWN, _UP,_O);
label     2,1,Fail;

procedure Rubanut (T: PVert);
var       State: (_DOWN, _UP);
          Sor,TT: PVert;
label     1;
begin
 SOR := T; State := _DOWN;
 repeat
  1:if T=Sor then Break; if tick>otick then WriteOut(Ans); {OTSEK}
  case State of
   _DOWN: if T^.Next=nil then
           if T^.Left=nil then
           begin
            TT := T^. Prev; Q[T^.INQ]:=nil;
            Dispose (T);
            T := TT;
            T^. Next := nil;
            State:=_UP; goto 1;
           end else
           begin
            TT := T^. Left; Q[T^.INQ]:=nil;
            Dispose (T);
            T := TT;
           end else
           T := T^.Next;
   _UP: begin
         if T^.Left=nil then
         begin
          TT := T^. Prev; Q[T^.INQ]:=nil; Dispose (T); T := TT; TT^. Next := nil;
         end else
         begin State := _DOWN; T := T^. Left; end;
         goto 1;
        end;
  end;
 until T=Sor;
end;

function Cmp (var a, b: TVert): Integer; {1-A>=B, -1 - a<B, 0 - hz}
var      I:Integer;
begin
 i := 1;
 while (a.c[i]=b.c[i]) and (i<K)do inc (I);
 if a.c[i]>b.c[i] then
 begin
  for I := i+1 to k do
   if a.c[i]<b.c[i] then begin cmp := 0; exit; end;
  cmp:=1;
 end else
 if a.c[i]<b.c[i] then
 begin
  for I := i+1 to k do
   if a.c[i]>b.c[i] then begin cmp := 0; exit; end;
  cmp:=-1;
 end else
 begin
  if a.c[i]<b.c[i] then begin cmp := 0; exit; end;
  cmp := 1;
 end;
end;

begin
 FillChar (F.C,SizeOf (F.C), 0); Ans := 0;
 F.C[Svin]:=1; F.Prev := nil; F.Left := nil; {F.Right := nil;}F.Next:=nil;
 O1 := 0; O2 := 1; Q[0]:=@F;
 while O1<>O2 do if Q[O1]<> nil then with Q[O1]^ do
 begin
  for I := 1 to L do
  begin
   if C[R1[I]]=0 then goto Fail;
   p:=nil;
   New (P);
   P^.C:=C;
   DecC (P^.C[R1[I]]);
   for J := 1 to R2[I,0] do
    IncC (P^.C[R2[I,J]]);
   if P^.C[Svin]>0 then QSatis;
   if P^.C[Gold]>Ans then Ans := P^.C[Gold];

   {Check our vetv}
   T := Q[O1];
    while T<>nil do
    begin
     Res := 0;
     case CMP (T^, P^) of
      1: begin
          Dispose(P); goto fail;
         end;
      -1: if P^.C[Gold]>T^.C[Gold] then
          QSatis
          else
          begin
           TT := T^. Prev; Rubanut (T); TT^.Next:=P;
           P^. Prev := TT; P^. Left := nil; {P^. Right := nil;}
           Break;
          end;
     end;
     T := T^. Prev;
    end;
   {Check our vetv end}

   {Check}
   T := F.Next; State := _DOWN;
   while T<>nil do
   begin
    1:if tick>otick then WriteOut(ANS); {OTSEK}
    case State of
     _DOWN: if T^.Next=nil then State := _O else begin T := T^.Next; goto 1; end;
{     _UP: begin
           if T^.Left=nil then T := T^. Prev else
           begin State := _DOWN; T := T^. Left; end;
           goto 1;
          end;}
    end;
    if T=nil then Break;
    if P<>T then
    begin
     Res := 0;
     case Cmp (T^, P^) of
      1: begin
          Dispose(P); goto Fail;
         end;
      -1: begin TT := T^. Prev; Rubanut (T); State := _UP; T := TT; end;
     end;
    end;
    if T^.Left=nil then
    begin
     T:=T^.Prev;
    end else
    begin
     T:=T^.Left; State:=_DOWN;
    end;
   end;
   {Check end}
   if Next=nil {Q[O1]^.} then
   begin
    P^.Left := nil;
   end else
   begin
    P^.Left := Next;{Q[O1]^.}
{    P^.Left^.Right := P;}
   end;
   Next := P; {P^.Right:=nil; }P^.Next:=nil; P^.Prev := Q[O1];

   Q[O2]:=P; P^.INQ := O2; Inc (O2); if O2>Max then O2 := 0;
   Fail:
  end;
  Inc (O1); if O1>Max then O1:=0;
 end else
 begin
  Inc (O1); if O1>Max then O1:=0;
 end;
end;

begin
OTick:=Tick+179;
 ReadIn;
 solve;
 WriteOut(Ans);
end.