program PushkinForProgrammers;

{$ifdef ILIA}
const
  InFile='b.in';
  OutFile='con';
{$else}
  {$A+,B-,D-,E+,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
  {$M 16384,0,655360}
const
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type TByteSet=set of byte;
function fromSet(var x:TByteset):byte;
  var i:byte;
  begin
  for i:=1 to 255 do
    if i in x then begin
      fromSet:=i;
      exclude(x,i);
      exit;
    end;
  fromSet:=0;
  end;

var N:byte;
    data: array[1..20] of string;
    class: array[1..20] of byte;
    answer: array[1..20] of string;

function lastsp(x:byte):byte;
  var idx:byte;
      lst:byte;
  begin
  idx:=length(data[x]);
  while data[x,idx]<>'"' do dec(idx);
  lst:=idx;
  repeat
    dec(idx);
  until (idx=0) or (data[x,idx]='"');
  lastsp:=lst-idx-1;
  end;

procedure ReadData;
  var i,j:byte;
  begin
  Assign(input,InFile);
  Reset(Input);
  readln(N);
  for i:=1 to N do begin
    readln(class[i],data[i]);
    while data[i,1] in [#9,#32] do delete(data[i],1,1);
    while data[i,length(data[i])] in [#9,#32] do dec(data[i,0]);
    for j:=1 to length(data[i]) do
      if data[i,j]='''' then data[i,j]:='"';
  end;
  Close(Input);
  end;

procedure WriteSol;
  var i:byte;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  for i:=1 to N do
    writeln(answer[i]);
  Close(Output);
  end;

var bundle:array[1..20] of byte;
    bn:byte;
const numbers:array[0..38,1..2] of string= (
            ('',''),
            ('~"','1'),
            ('?','2'),
            ('?','3'),
            ('~"~','4'),
            ('?','5'),
            ('?','6'),
            ('?','7'),
            ('"~','8'),
            ('"~','9'),
            ('"~','10'),
            ('~"~~','11'),
            ('~"~','12'),
            ('~"~','13'),
            ('~"~~','14'),
            ('~"~','15'),
            ('~"~','16'),
            ('~"~','17'),
            ('~~"~','18'),
            ('~~"~','19'),
            ('"~','20'),
            ('"~','30'),
            ('"~','40'),
            ('~~"','50'),
            ('~~"','60'),
            ('"~~','70'),
            ('"~~~','80'),
            ('~~"~','90'),
            ('?','100'),
            ('"~~','1000'),
            ('~~"','1000000'),
            ('~~"','1000000000'),
            ('"~','300'),
            ('~"~~','400'),
            ('~"','500'),
            ('~"','600'),
            ('~"','700'),
            ('~~"','800'),
            ('~~"','900'));

const dzatset0:TByteSet=[20];
      dzatset1:TByteSet=[12,13,15,16,17];
      dzatset2:TByteSet=[18,19];
      sotset1:TByteSet=[34..36];
      sotset2:TByteSet=[37,38];
const numbers50=23;
var last:array[1..20] of byte;
var mark:array[0..high(numbers)] of boolean;

procedure imposs;
  begin
  HALT;
  end;

procedure Work;
  var st:string;
      i,j:byte;
      _dzatset0,_dzatset1,_dzatset2,_sotset1,_sotset2:TByteSet;
      idx:byte;
      found:boolean;
      done:array[1..20] of boolean;
  begin
  _dzatset0:=dzatset0;
  _dzatset1:=dzatset1;
  _dzatset2:=dzatset2;
  _sotset1:=sotset1;
  _sotset2:=sotset2;
  st:=data[bundle[1]];
  fillchar(last,sizeof(last),0);
  fillchar(done,sizeof(done),false);
  if bn=1 then begin
    last[1]:=0;
  end else begin
    if st[length(st)]='"' then begin
      for i:=1 to bn do
        if lastsp(bundle[i])<=1 then begin
          done[i]:=true;
          last[i]:=fromSet(_sotset1);
          dec(data[bundle[i],0],2);
        end;
      for i:=1 to bn do
        if not done[i] then
          if lastsp(bundle[i])>=2 then begin
            last[i]:=fromSet(_sotset1);
            if last[i]<>0 then
              dec(data[bundle[i],0],2)
            else begin
              last[i]:=fromSet(_sotset2);
              dec(data[bundle[i],0],3);
            end;
          end;
    end else begin
      for i:=1 to bn do
        if lastsp(bundle[i])=0 then begin
          done[i]:=true;
          last[i]:=fromSet(_dzatset0);
          dec(data[bundle[i],0],2);
        end;
      for i:=1 to bn do
        if not done[i] then
          if lastsp(i)=1 then begin
            last[i]:=fromSet(_dzatset0);
            if last[i]=0 then begin
              last[i]:=fromSet(_dzatset1);
              dec(data[bundle[i],0],3);
            end else
              dec(data[bundle[i],0],2);
          end;
      for i:=1 to bn do
        if not done[i] then
          if lastsp(i)>=2 then begin
            last[i]:=fromSet(_dzatset0);
            if last[i]=0 then begin
              last[i]:=fromSet(_dzatset1);
              if last[i]=0 then begin
                last[i]:=fromSet(_dzatset2);
                dec(data[bundle[i],0],4);
              end else
                dec(data[bundle[i],0],3);
            end else
              dec(data[bundle[i],0],2);
          end;
    end;
  end;
  for i:=1 to bn do begin
    fillchar(mark,sizeof(mark),false);
    mark[last[i]]:=true;
    idx:=1;
    answer[bundle[i]]:='';
    while idx<=length(data[bundle[i]]) do begin
      found:=false;
      for j:=1 to high(numbers) do
        if not mark[j] and (copy(data[bundle[i]],idx,length(numbers[j,1]))=numbers[j,1]) then begin
          answer[bundle[i]]:=answer[bundle[i]]+numbers[j,2]+' ';
          mark[j]:=true;
          inc(idx,length(numbers[j,1]));
          found:=true;
          break;
        end;
      if not found then
        for j:=1 to high(numbers) do
          if not mark[j] and (numbers[j,1]='?') then begin
          answer[bundle[i]]:=answer[bundle[i]]+numbers[j,2]+' ';
          mark[j]:=true;
          found:=true;
          inc(idx);
          break;
          end;
      if not found then Halt;
    end;
    answer[bundle[i]]:=answer[bundle[i]]+numbers[last[i],2];
  end;
  end;

procedure Run;
  var c,i:byte;
  begin
  for c:=1 to 20 do begin
    bn:=0;
    for i:=1 to N do
      if class[i]=c then begin
        inc(bn);
        bundle[bn]:=i;
      end;
    if bn>0 then
      Work;
  end;
  end;

begin
ReadData;
Run;
WriteSol;
end.