{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Program Lisie;
Const
  MaxN=1000;
  MaxK=3000;
Var
  A:Array[1..MaxK*2]Of Char;
  B:Array[1..MaxK*2]Of Word;
  C:Array[1..MaxK*2]Of Char;
  D:Array[1..MaxK*2]Of Char;
  Pair:Array[1..2*MaxK]Of Word;
  Takes:Array[1..2*MaxK]Of Boolean;
  TL,TR:Word;
  N,K:Word;
Procedure Load;
Var
  I:Word;
  Buf:Pointer;
  Last:Array[1..MaxN]Of Word;
Begin
  Assign(Input,'INPUT.TXT');
  ReSet(Input);
  GetMem(Buf,65535);
  SetTextBuf(Input,Buf^,65534);
  ReadLn(N);
  ReadLn(K);
  For I:=1 To K*2 Do Begin
    If Not SeekEOLN Then Read(A[I]);
    If Not SeekEOLN Then Read(B[I]);
    If Not SeekEOLN Then Read(C[I]);
    If Not SeekEOLN Then Read(D[I]);
    If A[I]='+' Then Last[B[I]]:=I Else Begin
      Pair[I]:=Last[B[I]];
      Pair[Last[B[I]]]:=I;
    End;
    ReadLn;
  End;
  Close(Input);
  FreeMem(Buf,65535);
End;
Procedure Run;
Type
  TArvArr=Array[1..MaxK]Of Word;
Var
  S:Array[False..True,False..True,False..True]Of Word;
  Carriers:TArvArr;
  CarN:Word;
  LArv,RArv:TArvArr;
  LArvN,RArvN:Word;
  I:Word;
Procedure DeleteLastArv(Var Arv:TArvArr; Var ArvN:Word);
Begin
  Takes[Pair[Arv[ArvN]]]:=False;
  Dec(ArvN);
End;
Procedure AddArv(Var Arv:TArvArr; Var ArvN:Word; Pr:Word);
Var
  I,J:Word;
Begin
  Inc(ArvN);
  Arv[ArvN]:=65535;
  For I:=1 To ArvN Do If Pr<Arv[I] Then Break;
  For J:=ArvN DownTo I+1 Do Arv[I]:=Arv[I-1];
  Arv[I]:=Pr;
End;
Procedure DeleteArv(Var Arv:TArvArr; Var ArvN:Word; Pr:Word);
Var
  I,J:Word;
Begin
  For I:=1 To ArvN Do If Arv[I]=Pr Then Break;
  For J:=I+1 To ArvN Do Arv[I-1]:=Arv[I];
  Dec(ArvN);
End;
Procedure AddCarrier(Ps:Word);
Begin
  Inc(CarN);
  Carriers[CarN]:=Ps;
End;
Function TakeFrom(L,C,R:Boolean):Boolean;
Begin
  If S[L,C,R]>0 Then Begin
    Dec(S[L,C,R]);
    Inc(S[False,True,False]);
    If (L=True) And (C=True) And (R=False) Then Begin
      DeleteLastArv(RArv,RArvN);
    End;
    If (L=False) And (C=True) And (R=True) Then Begin
      DeleteLastArv(LArv,LArvN);
    End;
    If (L=True) And (C=False) And (R=True) Then Begin
      If Lisie.C[Carriers[CarN]]=Lisie.C[I] Then Takes[Carriers[CarN]]:=False;
      Dec(CarN);
    End;
    TakeFrom:=False;
    Takes[I]:=True;
  End Else TakeFrom:=True;
End;
Function TakeLFrom(L,C,R:Boolean):Boolean;
Begin
  If S[L,C,R]>0 Then Begin
    Dec(S[L,C,R]);
    Inc(S[L,True,R]);
    If (L=True) And (C=True) And (R=False) Then Begin
      DeleteLastArv(RArv,RArvN);
    End;
    If (L=False) And (C=True) And (R=True) Then Begin
      DeleteLastArv(LArv,LArvN);
    End;
    TakeLFrom:=False;
    Takes[I]:=True;
    If R=True Then AddArv(LArv,LArvN,Pair[I]) Else AddArv(RArv,RArvN,Pair[I]);
  End Else TakeLFrom:=True;
End;
Procedure Make(LR:Byte);
Begin
  If LR=1 Then Begin
    Inc(TL);
  End Else Begin
    Inc(TR);
  End;
  Takes[I]:=True;
  Inc(S[False,True,False]);
End;
Procedure EstimateLisiy(A:Byte);
Begin
  If A=1 Then Begin
    If TakeLFrom(True,False,False) And (RArvN>0) Then Begin
      If Pair[I]<RArv[RArvN] Then Begin
        DeleteLastArv(RArv,RArvN);
        AddArv(RArv,RArvN,Pair[I]);
        Takes[I]:=True;
      End Else Takes[I]:=False;
    End Else Takes[I]:=False;
  End Else Begin
    If TakeLFrom(False,False,True) And (LArvN>0) Then Begin
      If Pair[I]<LArv[LArvN] Then Begin
        DeleteLastArv(LArv,LArvN);
        AddArv(LArv,LArvN,Pair[I]);
        Takes[I]:=True;
      End Else Takes[I]:=False;
    End Else Takes[I]:=False;
  End;
End;
Begin
  FillChar(S,SizeOf(S),0);
  LArvN:=0;
  RArvN:=0;
  CarN:=0;
  For I:=1 To 2*K Do Case A[I] Of
    '+':Case D[I] Of
      '':Case C[I] Of
        '':If TakeFrom(True,False,False) And TakeFrom(True,True,False) And TakeFrom(True,False,True) Then Make(1);
        '':If TakeFrom(False,False,True) And TakeFrom(False,True,True) And TakeFrom(True,False,True) Then Make(2);
      End;
      '':Case C[I] Of
        '':If C[Pair[I]]='' Then EstimateLisiy(1) Else Takes[I]:=False;
        '':If C[Pair[I]]='' Then EstimateLisiy(2) Else Takes[I]:=False;
      End;
    End;
    '-':Case D[I] Of
      '':Case C[I] Of
        '':Begin Dec(S[False,True,False]); Inc(S[True,False,False]); End;
        '':Begin Dec(S[False,True,False]); Inc(S[False,False,True]); End;
      End;
      '':Case C[I] Of
        '':If Takes[Pair[I]] Then Begin
          Dec(S[False,True,True]);
          Inc(S[True,False,True]);
          DeleteArv(LArv,LArvN,I);
          AddCarrier(Pair[I]);
        End;
        '':If Takes[Pair[I]] Then Begin
          Dec(S[True,True,False]);
          Inc(S[True,False,True]);
          DeleteArv(RArv,RArvN,I);
          AddCarrier(Pair[I]);
        End;
      End;
    End;
  End;
End;
Procedure Save;
Var
  I:Word;
Begin
  Assign(Output,'OUTPUT.TXT');
  ReWrite(Output);
  WriteLn(TL,' ',TR);
  For I:=1 To 2*K Do If A[I]='+' Then WriteLn(Ord(Takes[I]));
  Close(Output);
End;
Begin
  Load;
  Run;
  Save;
End.