{M}
{$A+,B-,D-,E+,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}(**)
program Microphone; { or BASSEIN }

const
{$ifdef ILIA}
  InFile='3_a.in';
  OutFile='3_a.out';
{$else}
  InFile='input.txt';
  OutFile='output.txt';
{$endif}

type TMPhoneType=(_unused,_nonvirt,_virtused,_vscl,_vscr,_vlfr,_vrtl);
var N,K:word;
    data: array[1..3000] of record st,fn:word; stl,fnl:boolean; nd:boolean;
                                   mph:TMphoneType end;
    actdata: array[1..1000] of 1..3000; {. ->  .}
    conseq: array[1..6000] of 1..3000; {६ ->  }

procedure ReadData;
  var cha:char;
      bi:word;
      st:string;
      ai,ci,di:boolean;
      procedure makeread;
        begin
        readln(cha,bi,st);
        while st[1] in [#9,#32] do delete(st,1,1);
        while st[length(st)] in [#9,#32] do dec(st[0]);
        ai:=(cha='+');
        ci:=(st[1]='');
        di:=(st[length(st)]='');
        end;
  var i:word;
      actlast:word;

  begin
  Assign(Input,InFile);
  Reset(Input);
  readln(N,K);
  actlast:=0;
  for i:=1 to 2*K do begin
     makeread;
     if ai then begin
       inc(actlast);
       actdata[bi]:=actlast;
       with data[actlast] do begin
         st:=i;
         stl:=ci;
         nd:=di;
         mph:=_unused;
       end;
       conseq[i]:=actlast;
     end else with data[actdata[bi]] do begin
       fn:=i;
       fnl:=ci;
       conseq[i]:=actdata[bi];
     end;
  end;
  Close(Input);
  end;

var ndl,ndr:word;   {need}

procedure WriteSol;
  var i:word;
  begin
  Assign(Output,OutFile);
  Rewrite(Output);
  writeln(ndl,' ',ndr);
  for i:=1 to K do
    with data[i] do
      writeln(ord(nd or (mph=_virtused)));
  Close(Output);
  end;

procedure Run;
  var nowl,nowr:word; {now}
      vscl,vscr:word; {virtual at scene}
      vlfr,vrtl:word; {virtual at left/right}
      kk: word;
      i,j:word;
      procedure findLast(tp:TMPhoneType; var res:word);
        var i:word;
            bestfn:integer;
        begin
        bestfn:=-1;
        res:=0;
        for i:=kk downto 1 do begin
          if (data[conseq[i]].mph=tp) and (data[conseq[i]].fn>bestfn) then begin
          bestfn:=data[conseq[i]].fn;
          res:=i;
          end;
        end;
        end;
  begin
  ndl:=0;
  ndr:=0;
  nowl:=0;
  nowr:=0;
  vscl:=0;
  vscr:=0;
  vlfr:=0;
  vrtl:=0;
  for kk:=1 to 2*K do begin
    with data[conseq[kk]] do begin
      if kk=st then begin
        if nd then begin
          if stl then begin
            if nowl<>0 then dec(nowl) else begin
              if vscl<>0 then begin
                findLast(_vscl,j);
                data[conseq[j]].mph:=_unused;
                dec(vscl);
              end else if vlfr<>0 then begin
                findLast(_vlfr,j);
                data[conseq[j]].mph:=_unused;
                dec(vlfr);
              end else if vrtl<>0 then begin
                findLast(_vrtl,j);
                data[conseq[j]].mph:=_virtused;
                dec(vrtl);
              end else inc(ndl);
            end;
          end else begin
            if nowr<>0 then dec(nowr) else begin
              if vscr<>0 then begin
                findLast(_vscr,j);
                data[conseq[j]].mph:=_unused;
                dec(vscr);
              end else if vrtl<>0 then begin
                findLast(_vrtl,j);
                data[conseq[j]].mph:=_unused;
                dec(vrtl);
              end else if vlfr<>0 then begin
                findLast(_vlfr,j);
                data[conseq[j]].mph:=_virtused;
                dec(vlfr);
              end else inc(ndr);
            end;
          end;
          mph:=_nonvirt;
        end else begin
          if stl then begin
            if (not fnl) then begin
              if (nowl<>0) then begin
                dec(nowl);
                inc(vscl);
                mph:=_vscl;
              end else begin
                findLast(_vscl,j);
                if (j<>0) and (data[conseq[j]].fn>fn) then begin
                  data[conseq[j]].mph:=_unused;
                  mph:=_vscl;
                end;
              end;
            end;
          end else begin
            if (fnl) then begin
              if (nowr<>0) then begin
                dec(nowr);
                inc(vscr);
                mph:=_vscr;
              end else begin
                findLast(_vscr,j);
                if (j<>0) and (data[conseq[j]].fn>fn) then begin
                  data[conseq[j]].mph:=_unused;
                  mph:=_vscr;
                end;
              end;
            end;
          end;
        end;
      end else begin
        if nd then begin
          if fnl then
            inc(nowl)
          else
            inc(nowr);
        end else begin
          if fnl then begin
            if mph=_vscr then begin
              dec(vscr);
              inc(vrtl);
              mph:=_vrtl;
            end;
          end else begin
            if mph=_vscl then begin
              dec(vscl);
              inc(vlfr);
              mph:=_vlfr;
            end;
          end;
        end;
      end;
    end;
  end;
  end;

begin
ReadData;
Run;
WriteSol;
end.