{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

{ $r+}
{$s-}

const
 maxn=100000;
 maxs=13;
 ttttt=round(1193180/65536*29.1);

type
 ts=array[0..8191]of longint;
 tbuf=array[0..$7FFF]of byte;

var
 ds:array[0..maxs-1]of ^ts;
 n:longint;
 cd:integer;
 p1:boolean;
 buf:^tbuf;
 timer:longint absolute $40:$6C;
 start:longint;

const
 d10:array[0..9]of longint=(
 1,
 10,
 100,
 1000,
 10000,
 100000,
 1000000,
 10000000,
 100000000,
 1000000000
 );
 d2:array[0..9]of integer=(
 1,4,7,10,14,17,20,24,27,30
 );

procedure readin;
 var
  f:text;
  i,j:integer;
 begin
  assign(f,'input.txt'); reset(f);
  readln(f,n);
  if seekeof(f) then begin
   p1:=false;
   exit;
  end else p1:=true;
  cd:=1;
  for i:=0 to (n-1)shr 13 do begin
   if i<(n-1)shr 13 then new(ds[i])
   else getmem(ds[i],4*(n-(n-1)and(not 8191)));
   for j:=0 to 8191 do begin
    if seekeof(f) then break;
    read(f,ds[i]^[j]);
    while(ds[i]^[j]>=d10[cd])do
     inc(cd);
   end;
  end;
  close(f);
 end;

var
 prefix:string;
 f:text;
 wn:longint;

procedure put(i,s:integer);
 var
  j:integer;
 begin
  while(s>=10)do dec(s,10);
  if i=1 then begin
   prefix[1]:=char(48+s);
   writeln(f,prefix);
   inc(wn);
   exit;
  end;
  for j:=0 to 9 do begin
   prefix[i]:=char(48+j);
   put(i-1,s+j);
   if(wn>=n)then exit;
  end;
 end;

procedure solve2;
 var
  i,j:integer;
 begin
  cd:=1;
  while(n>d10[cd])do inc(cd);
  inc(cd);
  new(buf);
  assign(f,'output.txt'); settextbuf(f,buf^,32768); rewrite(f);
  prefix:=''; prefix[0]:=char(cd);
  wn:=0;
  if n>0 then put(cd,0);
  close(f);
 end;

procedure rdsort(l,r,m:longint);
 var
  i,j:integer;
  t:longint;
 begin
  if(l>=r)or(m=0)then exit;
  i:=l; j:=r;
  repeat
   while(i<=j)and(ds[i shr 13]^[i and 8191] and m= 0)do inc(i);
   while(i<=j)and(ds[j shr 13]^[j and 8191] and m<>0)do dec(j);
   if i<j then begin
    t:=ds[i shr 13]^[i and 8191];
    ds[i shr 13]^[i and 8191]:=ds[j shr 13]^[j and 8191];
    ds[j shr 13]^[j and 8191]:=t;
    inc(i); dec(j);
   end;
  until i>j;
  m:=m shr 1;
  rdsort(l,j,m);
  rdsort(i,r,m);
 end;

function killd(n:longint; i:integer):longint;
 begin
  if i<0 then killd:=n
  else killd:=n-(n div d10[i] mod 10)*d10[i];
 end;

procedure rdsort2(l,r,m:longint; k:integer);
 var
  i,j:longint;
  t:longint;
 begin
  if(timer>=start)then exit;
  if(l>=r)or(m=0)then exit;
  i:=l; j:=r;
  repeat
   while(i<=j)and(killd(ds[i shr 13]^[i and 8191],k)and m= 0)do inc(i);
   while(i<=j)and(killd(ds[j shr 13]^[j and 8191],k)and m<>0)do dec(j);
   if(timer>=start)then exit;
   if i<j then begin
    t:=ds[i shr 13]^[i and 8191];
    ds[i shr 13]^[i and 8191]:=ds[j shr 13]^[j and 8191];
    ds[j shr 13]^[j and 8191]:=t;
    inc(i); dec(j);
   end;
  until i>j;
  m:=m shr 1;
  rdsort2(l,j,m,k);
  rdsort2(i,r,m,k);
 end;

var
 equ:comp;

procedure solve1;
 var
  i:integer;
  j:longint;
  cn:comp;
 function csqr(a:comp):comp;
  var
   r:comp;
   w:byte absolute r;
   wa:word absolute a;
  begin
   r:=(sqr(a)-a)/2;
   {w:=(sqr(wa)-wa)/2;}
   csqr:=r;
  end;
 function _equ(a,b:longint; i:integer):boolean;
  begin
   if(i>0)and(a mod d10[i]<>b mod d10[i])then begin
    _equ:=false;
    exit;
   end;
   if(i>=9)then begin
    _equ:=true;
    exit;
   end;
   a:=a div d10[i+1];
   b:=b div d10[i+1];
   _equ:=a=b;
  end;
 begin
  equ:=0;
  for i:=0 to cd-1 do begin
   rdsort2(0,n-1,1 shl longint(d2[cd]-1),i);
   if timer>=start then exit;
   cn:=0;
   for j:=1 to n-1 do begin
    if
     (not _equ(ds[ j   shr 13]^[ j   and 8191],
               ds[(j-1)shr 13]^[(j-1)and 8191],i))then begin
     if cn>0 then equ:=equ+csqr(cn+1);
     cn:=0;
    end else cn:=cn+1;
   end;
   equ:=equ+csqr(cn+1);
  end;
 end;

procedure writeout1;
 var
  f:text;
 begin
  assign(f,'output.txt'); rewrite(f);
  writeln(f,equ:0:0);
  close(f);
 end;

begin
 start:=timer+ttttt;
 readin;
 if p1 then begin
  {rdsort(0,n-1,1 shl 29);}
  solve1;
  writeout1;
 end else begin
  solve2;
 end;
 {writeln(timer-start+ttttt);}
end.