{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65384,0,655360}
{$N+}
Program Walk_Mnogoug;
Const InputFile='Input.TxT';
      OutputFile='Output.TxT';
      MaxN=20;
      Eps=1e-6;
Type  TPoint=Record
           X, Y: LongInt;
          End;
      TMnog=Array[0..MaxN+1] Of TPoint;
 Var A: TMnog;
     N: Integer;
     ToWh: TPoint;
     SqPl: Real;
     SqP: Array[1..MaxN] Of Real;
     Sx, Sy: Array[1..MaxN, 1..2] Of LongInt;


 Procedure ReadPn(Var a: TPoint);
  Begin
   Read(a.x, a.y);
  End;

 Procedure Init;
  Var i: Integer;
   Begin
    FillChar(A, SizeOf(A), 0);
    Assign(Input, InputFile);
     Reset(Input);
      Read(N);
       ReadPn(ToWh);
      For i:=1 To N Do ReadPn(A[i]);
     Close(Input);
    A[N+1]:=A[1]; A[0]:=A[N];
   Assign(Output, OutputFile);
    Rewrite(Output);
   End;

 Procedure GetNw(Var a, b: TPoint);
  Begin
   a.x:=b.x-a.x;
   a.y:=b.y-a.y;
  End;

 Procedure Move(Const k, p: Integer);
  Var i: Integer;
      cn: TPoint;
   Begin
    cn.x:=(A[k].x + A[p].x);
    cn.y:=(A[k].y + A[p].y);
    For i:=1 To N Do GetNw(A[i], cn);
    A[N+1]:=A[1]; A[0]:=A[N];
   End;

 Procedure CalcSq;
  Var i: Integer;
   Begin
    SqPl:=0;
    For i:=1 To N Do SqPl:=SqPl + a[i].x*(a[i+1].y-a[i-1].y)/2;
    SqPl:=Abs(SqPl);
   End;

 Function Eq(Const a, b: Real): Boolean;
  Begin
   Eq:=Abs(a-b)<Eps;
  End;

 Function InPoly: Boolean;
  Var i: Integer;
      sq: Real;
   Begin
    sq:=0;
    For i:=1 To N Do
     sq:=sq + abs(ToWh.x*(a[i].y-a[i+1].y) + a[i+1].x*(ToWh.y-a[i].y) + a[i].x*(a[i+1].y-ToWh.y))/2;
     InPoly:=Eq(sq, sqPl);
   End;

 Function Less(Const a, b: Real): Boolean;
  Begin
   Less:=b-a>Eps;
  End;

 Function GetNewRs(Const aa: Integer): Real;
  Begin
   GetNewRs:=Sqr(A[aa].x-ToWh.x) + Sqr(A[aa].y-ToWh.y);
  End;

 Procedure FindNear(Var aa: Integer);{Rs(aa)<Rs(bb)<Rs(cc)}
  Var i, j: Integer;
   Begin
    For i:=1 To N Do SqP[i]:=GetNewRs(i);
     aa:=0;{ bb:=0; cc:=0;}
    For i:=1 To N Do
    If (aa=0) Or (Less(SqP[i], SqP[aa])) Then aa:=i;
{     db:=SqP[aa];}
{     SqP[aa]:=MaxLongInt;
      bb:=aa+1; cc:=aa+2;
    For i:=1 To N Do
    If (bb=0) Or (Less(SqP[i], SqP[bb])) Then bb:=i;
     SqP[bb]:=MaxLongInt;
     If aa>bb Then Begin
      j:=bb; bb:=aa; aa:=j;
     End;
{
    For i:=1 To N Do
    If (cc=0) Or (Less(SqP[i], SqP[cc])) Then cc:=i;}
   End;
{
 Procedure Get(Const aa, bb, cc: Integer; Var cx, cy: LongInt);
  Var Sv: TMnog;
   Begin
    Sv:=A;
     Move(aa, bb);
      Move(aa, cc);
     cx:=-Sv[1].x+A[1].x;
     cy:=-Sv[1].y+A[1].y;
    A:=Sv;
   End;
}
 Procedure Get1(Const aa, bb, cc, dd: Integer; Var cx, cy: LongInt);
  Var Sv: TMnog;
   Begin
    Sv:=A;
     Move(aa, bb);
      Move(cc, dd);
     cx:=-Sv[1].x+A[1].x;
     cy:=-Sv[1].y+A[1].y;
    A:=Sv;
   End;

 Procedure Impossible;
  Begin
   Close(Output);
   Rewrite(Output);
    WriteLn('IMPOSSIBLE');
   Close(Output);
   Halt;
  End;

Const Md=6;


Var Dn: Array[1..Md] Of Integer;

 Procedure RecDone(Const k: Integer);
  Var i: Integer;
   Begin
    For i:=1 To k-1 Do Begin
     WriteLn(Dn[i], ' ', Dn[i] Mod N + 1);
    End;
    Close(Output);
    Halt;
   End;

 Procedure Rec(Const k: Integer);
  Var i: Integer;
      Sv: TMnog;
   Begin
    If InPoly Then RecDone(k)
    Else If k>Md Then Exit;
     Sv:=A;
    For i:=1 To N Do
    If (k=1) Or (Dn[k-1]<>i) Then Begin
     Move(i, i Mod 10+1);
      Dn[k]:=i;
      Rec(k+1);
     A:=Sv;
    End;
   End;

 Function Gn(Const L: LongInt): LongInt;
  Begin
   If L=0 Then Gn:=0
    Else Gn:=L Div Abs(L);
  End;

 Procedure SaMove(Const k, p: Integer);
  Begin
   WriteLn(k, ' ', p);
   Move(k, p);
  End;

 Procedure DvigFirst;
  Var i, j: Integer;
{      aa, bb, cc: Integer;}
      ndb, db: Real;
      aa: Integer;
      sc: Integer;
      ndx, ndy, dx, dy: LongInt;
{      cx, cy, fx, fy: LongInt;}
       msx, msy: Integer;
       lf, rg: Integer;
       fdx, fdy, onx, ony, k, p: Integer;
       onyp, onxp: Integer;



   Begin
     FindNear(aa);{aa<bb}
{     Get(aa, bb, (aa+N-2) Mod N + 1, cx, cy);
     Get(bb, aa, (bb) Mod N + 1, fx, fy);}
      msy:=MaxInt;
      msx:=MaxInt;
       dx:=ToWh.x-A[aa].x;
       dy:=ToWh.y-A[aa].y;
     FillChar(Sx, SizeOf(Sx), 0);
     lf:=0;
     For i:=1 To N Do Begin
      j:=(i+N-2) Mod N+1;
      Get1(i, i Mod N + 1, j, j Mod N + 1, Sx[i, 1], Sy[i, 1]);
      j:=(i Mod N + 1);
      Get1(i, i Mod N + 1, j, j Mod N + 1, Sx[i, 2], Sy[i, 2]);
      For j:=1 To 2 Do Begin
       If (Abs(Sy[i, j])<Abs(msy)) And (Gn(sx[i, j])=Gn(dx)) Then Begin
        msy:=Sy[i, j];
        msx:=Sx[i, j];
        lf:=i;
        If j=1 Then rg:=(i+N-2) Mod N+1
        Else rg:=(i Mod N + 1);
       End
       Else If Abs(Sy[i, j])=Abs(msy) Then
         If (Abs(msx)<Abs(Sx[i, j])) And (Gn(sx[i, j]) = Gn (dx))Then Begin
          msx:=Sx[i, j];
          msy:=Sy[i, j];
          lf:=i;
        If j=1 Then rg:=(i+N-2 Mod N)+1
        Else rg:=(i Mod N + 1);

        End;
      End;

     End;
      fdx:=dx; fdy:=dy;
{    If lf<>0 Then Begin
     Move(lf, lf Mod N + 1);
     WriteLn(lf, ' ', lf Mod N + 1);
     Move(rg, rg Mod N + 1);
     WriteLn(rg, ' ', rg Mod N + 1);
      While (db<2) Do Begin
      End;
    End;}

    onx:=0; ony:=0;

    For i:=1 To N Do
     For k:=1 To 2 do
    For j:=1 To N Do
     For p:=1 To 2 Do Begin
       If (Sx[i, k]+Sx[j, p]=0) And (Gn(dy)=Gn(Sy[i, k] + Sy[j, p])) Then Begin
        ony:=i*2+k-1;
        onyp:=j*2+p-1;
       End;
       If (Sy[i, k]+Sy[j, p]=0) And (Gn(dx)=Gn(Sx[i, k] + Sx[j, p])) Then Begin
        onx:=i*2+k-1;
        onxp:=j*2+p-1;
       End;
     End;

    If (dy>0) And (ony>0) Then Begin
       ndy:=dy;
     Repeat
      dy:=ndy;
        SaMove(ony Div 2, (ony Div 2) Mod N + 1);
        SaMove((ony Div 2 + (ony Mod 2)*2-2) Mod N + 1,
        (ony Div 2 + (ony Mod 2)*2-1) Mod N + 1);
        SaMove(onyp Div 2, (onyp Div 2) Mod N + 1);
        SaMove((onyp Div 2 + (onyp Mod 2)*2-2) Mod N + 1,
        (onyp Div 2 + (onyp Mod 2)*2-1) Mod N + 1);

       ndy:=ToWh.y-A[aa].y;
     Until (Abs(dy)<Abs(ndy));
    End;

    If (dx>0) And (onx>0) Then Begin
       ndx:=dx;
     Repeat
      dx:=ndx;
        SaMove(onx Div 2, (onx Div 2) Mod N + 1);
        SaMove((onx Div 2 + (onx Mod 2)*2-2) Mod N + 1,
        (onx Div 2 + (onx Mod 2)*2-1) Mod N + 1);
        SaMove(onxp Div 2, (onxp Div 2) Mod N + 1);
        SaMove((onxp Div 2 + (onxp Mod 2)*2-2) Mod N + 1,
        (onxp Div 2 + (onxp Mod 2)*2-1) Mod N + 1);

       ndx:=ToWh.x-A[aa].x;
     Until (Abs(dx)<Abs(ndx));{ Or Not(Gn(dx)=Gn(fdx));}

    End;
{    While}
   End;

 Procedure Solve;
  Begin
   CalcSq;
   If InPoly Then Exit;
    DvigFirst;
   If InPoly Then Exit;
{    WriteLn(InPoly);
   Move(2, 3);
    WriteLn(InPoly);
   Move(1, 3);
    WriteLn(InPoly);
   Move(2, 3);
    WriteLn(InPoly);}
    Rec(1);
   If Not InPoly Then Impossible;
  End;

 Procedure Done;
  Begin
    Close(Output);
  End;

BEGIN
 Init;
  Solve;
 Done;
END.