{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
program            TaskA;
const              MaxB=14300;
type               TBlock=array [0..MaxB] of LongInt;
                   PBlock=^TBLock;

var   N: LongInt;
      B: array [1..7] of PBlock;
      P: PBlock;
      MaxCif, Blocks, BN: Integer;
      Task: Byte;
      K, Ans:LongInt;
      F: file;

procedure QSort(L, R: Integer);
var       I, J: Integer;
          M: LongInt;
begin
 I := L; J := R; M := P^[(I+J) div 2];
 repeat
  while P^[I]<M do Inc (I);
  while P^[J]>M do Dec (J);
  if I<=J then
  begin
   K:=P^[I];P^[I]:=P^[J];P^[J]:=K;
   Inc (I); Dec (J);
  end;
 until I>J;
 if L<J then QSort (L, J);
 if I<R then QSort (I, R);
end;

procedure SortAll;
var       I: Integer;
begin
 for I := 1 to Blocks do
 begin
  P := B[I];
  QSort (1,P^[0]);
 end;
end;

procedure ReadWO1;
var       I,J,T,MaxT: LongInt;
          Buf: array [0..60000] of Byte;
begin
 Assign (Input,'input.txt'); Reset (Input);
 SetTextBuf (Input, Buf, 60000);
 ReadLn (T);
 B[1]^[0] := 0; BN := 1; MaxT:=0; P := B[1];
 for I := 1 to N do
 begin
  J := P^[0];
  if J=MaxB then begin Inc (BN); P := B[BN]; J := 1; end else
                 Inc (J);
  P^[0]:=J;
  ReadLn (T);
  if T>MaxT then MaxT:=T;
  P^[J]:=T;
 end;
 Close (Input);

 Assign (F, '$$$.$$$'); Rewrite (F, 1);
 for I := 1 to Blocks do BlockWrite (F, B[I]^, (B[I]^[0]+1) shl 2);
 Close (F);

 for I := 1 to Blocks do
 begin
  P := B[I];
  for J := 1 to P^[0] do
   P^[J] := P^[J] div 10;
 end;

 MaxCif := 0;
 while MaxT>0 do begin Inc (MaxCif); MaxT:=MaxT div 10; end;
end;

procedure MWO (K: LongInt);
var       K9, I, J, T: LongInt;
begin
 K9:=1; for I := 1 to K-1 do K9:=K9*10;
 Assign (F, '$$$.$$$'); Reset (F, 1);
 for I := 1 to Blocks do BlockRead (F, B[I]^, (B[I]^[0]+1) shl 2);
 Close (F);
 for I := 1 to Blocks do
 begin
  P := B[I];
  for J := 1 to P^[0] do
  begin
   T := P^[J];
   P^[J] := T-((T div K9) mod 10)*K9;
  end;
 end;
end;

procedure ReadIn;
var       I: Integer;
begin
 Assign (Input,'input.txt'); reset (Input);
 ReadLn(N);
 if SeekEOF then begin Task := 2; exit; end;
 Task := 1;
 Blocks := N div MaxB+1;
 for I := 1 to Blocks do New (B[I]);
 ReadWO1;
end;

procedure Solve1;
var       I, J, K: Integer;
          Prev, Min: LongInt;
          Count: LongInt;
          P: array [1..10] of Integer;
begin
 Ans := 0;
 for K := 1 to MaxCif do
 begin
  TaskA.K:=K; SortAll;
  for I := 1 to Blocks do P[I]:=1; Prev := -1; Count:=1;

  repeat
   Min:=MaxLongInt;
   for I := 1 to Blocks do
    if P[I]<=B[I]^[0] then
    if (B[I]^[P[I]]<Min) then
    begin
     Min := B[I]^[P[I]]; J := I;
    end;
   if Min=Prev then Inc (Count) else
   begin
    Inc (Ans, (Count*(Count-1)) div 2);
    Prev := Min; Count := 1;
   end;
   Inc (P[J]);
  until Min=MaxLongInt;

  if K<>MaxCif then MWO (K+1);
 end;
 WriteLn (Ans);
end;

procedure Solve2;
var       I,J,K: LongInt;
          P: array [0..60000] of Byte;
begin
 SetTextBuf (Output,P,60000);
 for I := 0 to N-1 do
 begin
  J:=I; K := 0; while J>0 do begin Inc (K, J mod 10); J:=J div 10; end;
  J:=I*10+(K mod 10);
  WriteLn (J);
 end;
end;

begin
 ReadIn;
 assign (output,'output.txt'); rewrite (output);
 case Task of
  1: Solve1;
  2: Solve2;
 end;
 close (Output);
end.