Uses CRt;
Const
  Digits : Array [0..9,1..3,1..3] of Char =(
                                            ((' ','_',' '),
                                             ('|',' ','|'),
                                             ('|','_','|')),
                                            ((' ',' ',' '),
                                             (' ',' ','|'),
                                             (' ',' ','|')),
                                            ((' ','_',' '),
                                             (' ','_','|'),
                                             ('|','_',' ')),
                                            ((' ','_',' '),
                                             (' ','_','|'),
                                             (' ','_','|')),
                                            ((' ',' ',' '),
                                             ('|','_','|'),
                                             (' ',' ','|')),
                                            ((' ','_',' '),
                                             ('|','_',' '),
                                             (' ','_','|')),
                                            ((' ','_',' '),
                                             ('|','_',' '),
                                             ('|','_','|')),
                                            ((' ','_',' '),
                                             (' ',' ','|'),
                                             (' ',' ','|')),
                                            ((' ','_',' '),
                                             ('|','_','|'),
                                             ('|','_','|')),
                                            ((' ','_',' '),
                                             ('|','_','|'),
                                             (' ','_','|'))
  );
Var
  a,b,c,d               : Integer;
  Sc                    : Array [1..27,1..3] of Char;
  Canbe                 : Array [1..9,0..9] of Boolean;
  Nums,BV               : Array [1..9] of Byte;
  sum                   : Integer;
  Bad                   : Boolean;
  Fully                 : Array [1..9] of Byte;
  Vers                  : Integer;

Procedure Compare(what,wth : Byte);
Var
  k,l : integer;
Begin
  Bad:=False;
  for k:=1 to 3 do
    for l:=1 to 3 do
      if (Sc[(what-1)*3+k,l] in [#124,#95]) and (Digits[wth,l,k]=' ') then Begin
        CanBe[what,wth]:=False;
        Exit;
      End else
        if Sc[(what-1)*3+k,l]<>Digits[wth,l,k] then
          Bad:=true;
  if not Bad then
    fully[what]:=wth;
end;

Procedure Find(n : Byte);
Var
  k,l,i : Integer;
Begin
  l:=0;
  for k:=1 to 9 do
    if n<>k then
      Inc(l,(10-k)*Nums[k]);
  for k:=0 to 9 do
    if CanBe[n,k] then Begin
      i:=l+(10-n)*k;
      if i mod 11=0 then Begin
        Inc(vers);
        BV:=Nums;
        BV[n]:=k;
        if Vers=2 then Begin
          Assign(output,'output.txt');
          REwrite(output);
          WriteLn('ambiguous');
          close(output);
          Halt;
        End;
      End;
    End;
End;

Begin
  Assign(input,'input.txt');
  reset(input);
  for b:=1 to 3 do Begin
    for a:=1 to 27 do Begin
      Read(Sc[a,b]);
      if EOLn(input) then
      Break;
    End;
    if a<>27 then
      for c:=a+1 to 27 do
        Sc[c,b]:=#32;
    ReadLn;
  End;
  close(input);
  FillChar(CanBe,90,1);
  c:=0;
  for a:=1 to 9 do Begin
    Fully[a]:=10;
    for b:=0 to 9 do
      Compare(a,b);
    if Fully[a]=10 then Begin Inc(c);d:=a;End;
    nums[a]:=Fully[a];
  End;
  Vers:=0;
  if c=1 then
    Find(d)
  else
    for d:=1 to 9 do
      Find(d);
  if Vers=0 then Begin
    Assign(output,'output.txt');
    REwrite(output);
    WriteLn('failure');
    close(output);
    Halt;
  End;
  Assign(output,'output.txt');
  REwrite(output);
  for a:=1 to 9 do
    Write(BV[a]);
  close(output);
end.