#include <conio.h>
#include <stdio.h>


void input ();
void output ();
void solve ();
void recurs (int sum, int num);
void scan ();
int goes (int pic, int num);
int right (int pic, int num);

int fail = 0, amb = 0, answers =  0;
long ans = 0, cur = 0;

struct stru
			{
				int pic [7];
				int num [10];
				int nums, right;
			} array [9];

int counts [10] [7] = {{1, 0, 1, 1, 1, 1, 1}, {0, 0, 0, 0, 1, 0, 1},
							  {1, 1, 1, 0, 1, 1, 0}, {1, 1, 1, 0, 1, 0, 1},
							  {0, 1, 0, 1, 1, 0, 1}, {1, 1, 1, 1, 0, 0, 1},
							  {1, 1, 1, 1, 0, 1, 1}, {1, 0, 0, 0, 1, 0, 1},
							  {1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 0, 1}};


main ()
 {
	 input ();
	 scan ();
	 solve ();
	 output ();

	 return (0);
 }




void input ()
 {
	FILE * file = fopen ("input.txt", "r");
	char chr1, chr2, chr3, filler = 0;

	for (int index = 0; index < 9; index ++)
	 {
		if (filler) chr2 = ' '; else chr2 = fgetc (file); if (chr2 == '\n') filler = 1;
		if (filler) chr1 = ' '; else chr1 = fgetc (file); if (chr1 == '\n') filler = 1;
		if (filler) chr3 = ' '; else chr3 = fgetc (file); if (chr3 == '\n') filler = 1;

		array [index]. pic [0] = (chr1 == '_');
	 }

	if (! filler) fgetc (file);

	filler = 0;

	for (index = 0; index < 9; index ++)
	 {
		if (filler) chr1 = ' '; else chr1 = fgetc (file); if (chr1 == '\n') filler = 1;
		if (filler) chr2 = ' '; else chr2 = fgetc (file); if (chr2 == '\n') filler = 1;
		if (filler) chr3 = ' '; else chr3 = fgetc (file); if (chr3 == '\n') filler = 1;

		array [index]. pic [3] = (chr1 == '|');
		array [index]. pic [1] = (chr2 == '_');
		array [index]. pic [4] = (chr3 == '|');
	 }

	if (! filler) fgetc (file);

	filler = 0;

	for (index = 0; index < 9; index ++)
	 {
		if (filler) chr1 = ' '; else chr1 = fgetc (file); if (chr1 == '\n') filler = 1;
		if (filler) chr2 = ' '; else chr2 = fgetc (file); if (chr2 == '\n') filler = 1;
		if (filler) chr3 = ' '; else chr3 = fgetc (file); if (chr3 == '\n') filler = 1;

		array [index]. pic [5] = (chr1 == '|');
		array [index]. pic [2] = (chr2 == '_');
		array [index]. pic [6] = (chr3 == '|');
	 }

	fclose (file);

	for (index = 0; index < 9; index ++)
	 array [index]. right = -1;
 }


void output ()
 {
	FILE * file = fopen ("output.txt", "w");

	if (! answers)
	 fprintf (file, "failure");
	else if (amb)
	 fprintf (file, "ambiguous");
	else
	 fprintf (file, "%ld", ans);

	fclose (file);
 }



/*void recurs (int sum, int num)
 {
	if (amb) return;

	if (cur == 123456789)
	 {
		getch ();
	 }

	if (num == 10)
	 {
		if (! (sum % 11))
		 {
			ans = cur;

			if ((++ answers) > 1)
			 amb = 1;
		 }
		return;
	 }

	for (int index = 0; index < array [num]. nums; index ++)
	 {
		cur = (cur + array [num]. num [index]) * 10;
		recurs (sum + (num + 1) * array [num]. num [index], num + 1);

		cur /= 10;
	 }
 }


void solve ()
 {
	int flag = 0, cur, note = 0, answers = 0;

	for (int index = 0; index < 9; index ++)
	  if (array [index]. nums > 1)
		{
			flag ++;
			cur = index;
		}

	if (flag > 1)
	 {
		fail = 1;
		return;
	 }

	for (index = 0; index < 9; index ++)
	 if (index != cur)
	  note += (index + 1) * array [index]. num [0];

	for (index = 0; index < array [cur]. nums; index ++)
	 {
		note += (cur + 1) * array [cur]. num [index];

		if (! (note % 11))
		 {
			answers ++;
			array [cur]. num [0] = array [cur]. num [index];
		 }

		note -= (cur + 1) * array [cur]. num [index];
	 }

	if (answers > 1)
	 {
		amb = 1;
		return;
	 }

	for (index = 0; index < 9; index ++)
	 ans = (ans + array [index]. num [0]) * 10;
 }

*/


/*void solve ()
 {
	int index2, index3;

	for (int index = 0; index < 11; index ++)
	 solves [0] [index] = 0;

	for (index = 0; index < 10; index ++)
	 for (index2 = 0; index2 < 11; index2 ++)
	  for (index3 = 0; index3 < array [index]. nums; index3 ++)
		{
			solves [index + 1] [(index2 + (index + 1) * (array [index]. num [index3])) % 11] =
			solves [index] [index2] * 10 + array [index]. num [index3];

			if ((index == 8) && (((index2 + (index + 1) * (array [index]. num [index3])) % 11) == 0))
			 if ((++ answers) > 1)
			  {
				amb = 1;
				return;
			  }
		}
 }*/


void solve ()
 {
	int index2, flag, sum;
	long exp;

	for (int index = 0; index < 9; index ++)
	 {
		exp = 100000000; cur = 0; sum = 0; flag = 1;

		for (index2 = 0; index2 < 9; index2 ++)
		 if (index != index2)
		  {
			if (flag) exp /= 10;

			if (array [index2]. right == -1)
			 goto l;

			cur = cur * 10 + array [index2]. right;
			sum += (9 - index2) * array [index2]. right;
		  }
		 else
		  {
			 flag = 0;
			 cur *= 10;
		  }

		for (index2 = 0; index2 < array [index]. nums; index2 ++)
		 if (((sum + (9 - index) * array [index]. num [index2]) % 11) == 0)
		  {
			ans = cur + exp * array [index]. num [index2];

			if ((++ answers) > 1)
			 {
				amb = 1;
				return;
			 }
		  }
		l:
	 }
 }


void scan ()
 {
	int index2;

	for (int index = 0; index < 9; index ++)
	 {
		array [index]. nums = 0;

		for (index2 = 0; index2 < 10; index2 ++)
		 {
			if (goes (index, index2))
			 array [index]. num [array [index]. nums ++] = index2;
			if (right (index, index2))
			 array [index]. right = index2;
		 }
	 }
 }



int goes (int pic, int num)
 {
	int flag = 1;

	for (int index = 0; index < 7; index ++)
	 if (array [pic]. pic [index])
	  flag &= counts [num] [index];

	return (flag);
 }



int right (int pic, int num)
 {
	int flag = 1;

	for (int index = 0; index < 7; index ++)
	 flag &= (!((array [pic]. pic [index]) ^ (counts [num] [index])));

	return (flag);
 }


