{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 56384,0,655360}

program Ugh_Yuck;
var n, k: integer;
    rt, h, m: integer;
    b, e: array [0..101] of integer;
    ws, st: array [1..100] of integer;
    fl: array [0..100] of integer;
    ll: array [0..100] of integer;
    dist: integer;
    np: array [1..100, -100..100] of byte;
    bs: array [1..100, -100..100] of byte;

procedure ReadAll;
begin
  assign (input, 'input.txt'); reset (input);
  read (n, k);
  m := 0;
  fillchar (st, sizeof (st), 0);
  while not seekeof (input) do
  begin
    inc (m);
    read (b[m], e[m]);
    inc (st[b[m]]);
    inc (st[e[m]]);
  end;
  close (input);
end;

procedure Smooth (a, b: integer);
var i, j: integer;
begin exit;
  for i := -dist to dist do
  for j := i+1 to dist do
  if np[a, i] < np[a, j] then
   i := i;
{  for i := b to n do
  if np[a, i] > np[a, b] then np[a, i] := np[a, b];}
end;

procedure Smoot (a: integer);
var i, j: integer;
begin exit;
  for i := -dist to dist do
  for j := i+1 to dist do
  if np[a, i] < np[a, j] then
   i := i;
{  for i := b to n do
  if np[a, i] > np[a, b] then np[a, i] := np[a, b];}
end;

procedure Shug (a: byte);
var i: byte;
begin
  ws [a] := 1;
  for i := 1 to m do
  begin
    if (b[i] = a) and (ws[e[i]] = 0) then Shug (e[i]);
    if (e[i] = a) and (ws[b[i]] = 0) then
          begin
            h := b[i]; b[i] := e[i]; e[i] := h;
            Shug (b[i]);
          end;
  end;
end;

procedure FindRoot;
var i, j: integer;
begin
  for i := 1 to n do
  if st[i] = 1 then
     begin
       rt := i;
       FillChar (ws, sizeof(ws), 0);
       ws[rt] := 1;
       Shug (rt);
       exit;
     end;
end;

procedure SortLinks;
var i, j, k: integer;
begin
  for i := 1 to m-1 do
  for j := i+1 to m do
  if b[i] > b[j] then
    begin
      k := b[i]; b[i] := b[j]; b[j] := k;
      k := e[i]; e[i] := e[j]; e[j] := k;
    end;
  b[0] := 0;
  b[n+1] := 0;
  fillchar (fl, sizeof (fl), 0);
  fillchar (ll, sizeof (ll), 0);
  for i := 1 to n+1 do
  begin
    if b[i] <> b[i-1] then
      begin
        fl[b[i]] := i;
        ll[b[i-1]] := i-1;
      end;
  end;
end;

procedure Ugh (a: byte);
var j, i, u, q: integer;
    d, k: byte;
begin
  if fl [a] = 0 then
      begin
        for i := -n to -dist-1 do
          np[a, i] := 255;
        for i := -dist to 0 do
          np[a, i] := 1;
        for i := 1 to n do
          np[a, i] := 0;
        exit;
      end;
  for k := fl[a] to ll[a] do
  Ugh (e[k]);

  for i := -n to -dist-1 do  np[a, i] := 255;
  for i := -dist to 0 do  np[a, i] := {1}255;
  for i := 1 to n do  np[a, i] := {0} 255;

  { A Man }
  q := 1;
  for k := fl[a] to ll[a] do
    q := q + np[e[k], dist];
  for i := -dist to n do
    if np [a, i] > q then
       begin
       np [a, i] := q;
         smooth (a, i);
       end;
  smoot (a);
  { No Man, No "D" }
  for i := 1 to n do
  begin
    q := 0;
    for k := fl[a] to ll[a] do
      q := q + np[e[k], i-1];
    if np [a, i] > q then
     begin
       np [a, i] := q;
       smooth(a, i);
     end;
  end;
  smoot (a);
  { No Man, one "D" }
  for i := -dist to 0 do
  begin
    for d := fl[a] to ll[a] do
    begin
      q := np [e[d], i-1];
      for k := fl[a] to ll[a] do
      if k <> d then
        q := q + np[e[k], -i];
      for j := i to n do
      if np [a, j] > q then
        begin
          np [a, j] := q;
          smooth (a, i);
        end;
    end;
  end;
{  for i := -n to -dist+1 do np[a, i] := np[a, -dist];}
  smoot (a);
end;

procedure PRT (a: byte; l: integer);
var j, i, u, q: integer;
    d, k: byte;
begin
  if fl [a] = 0 then
      begin
        if np [a, l] > 0 then write (a,' ');
        exit;
      end;

  { A Man }
  if (l >=-dist) and (l<=n) then
  begin
    q := 1;
    for k := fl[a] to ll[a] do
      q := q + np[e[k], dist];
      if np [a, l] = q then
        begin
          write (a, ' ');
          for k := fl[a] to ll[a] do
          PRT (e[k], dist);
          exit;
        end;
  end;

  { No Man, No "D" }
  if (l >=1) and (l<=n) then
  begin
    q := 0;
    for k := fl[a] to ll[a] do
      q := q + np[e[k], l-1];
    if np [a, l] = q then
        begin
          for k := fl[a] to ll[a] do
            PRT(e[k], l-1);
          exit;
        end;
  end;
  for i := -dist to 0 do
  begin
    for d := fl[a] to ll[a] do
    begin
      q := np [e[d], i-1];
      for k := fl[a] to ll[a] do
      if k <> d then
        q := q + np[e[k], -i];
      for j := i to n do
      if j = l then
      if np [a, j] = q then
        begin
          np [a, j] := q;
          PRT (e[d], i-1);
          for k := fl[a] to ll[a] do
          if k <> d then PRT (e[k], -i);
          smooth (a, i);
          exit;
        end;
    end;
  end;
(*  { No Man, one "D" }
  if (l>=-dist) and (l<=0) then
  begin
    for d := fl[a] to ll[a] do
    begin
      q := np [e[d], l-1];
      for k := fl[a] to ll[a] do
      if k <> d then
        q := q + np[e[k], -l];
{      dg}
      for j := l to n do
      if np [a, j] = q then
          begin
            PRT (e[d], j-1);
            for k := fl[a] to ll[a] do
            if k <> d then PRT (e[k], -j);
            exit;
          end;
    end;
  end;*)
end;

procedure FillTable;
var i: integer;
begin
  for dist := 0 to n do
  begin
    Ugh (rt);
    for i := -dist to 0 do
    if np[rt, i] <= k then
       begin
         writeln (dist);
         PRT (rt, i);
         writeln;
         close (output);
         halt;
       end;
  end;
end;

procedure Solve;
var i: integer;
begin
  FindRoot;
  SortLinks;
  assign (output, 'output.txt'); rewrite (output);
  FillTable;
  close (output);
end;

begin
  ReadAll;
  Solve;
end.