{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 46384,0,655360}

program Kruzhochek;


type float = double;
     arrf = array [0..99] of float;
     parrf = ^arrf;

var xx, yy, rr: float;
    nn, n: integer;
    tm: longint absolute $0000:$046C;
    ts: longint;
    an, x, y: array [0..100] of float;
    xq, yq, tmpa, mina: float;
    tmp, ans: array [1..130] of integer;
    tmpc, ansc: integer;
    nm: array [0..100] of integer;
    sq: array [0..99] of Parrf;
    bst: array [1..100, 1..100] of byte;

const eps = 1e-6;
      eps1 = 1e-8;
      infinity = 1e+30;

procedure ReadAll;
var i: integer;
begin
  assign (input, 'input.txt'); reset (input);
  read (n);
  read (xx, yy, rr);
  nn := 0;
  for i := 1 to n do
  begin
    inc (nn);
    read (x[nn], y[nn]);
    nm[nn] := i;
    if sqrt(sqr(x[nn]-xx)+sqr(y[nn]-yy)) < rr-eps1 then dec (nn);
  end;
  close (input);
  n := nn;
end;

procedure PrintRes;
var bi, i: integer;
    min: float;
begin
  bi := 0; min := infinity;
  assign (output, 'output.txt'); rewrite (output);
  writeln ('mar');
  if mina > infinity * 0.1 then
    begin
      writeln ('No'); close (output); halt;
    end;
  writeln (mina);
  for i := ansc downto 1 do
  write (ans[i], ' ');
  writeln;
  close (output);halt;
end;


procedure SortThemAll;
var i, j, ih: integer;
    hf, x0, y0: float;
begin
  for i := 1 to n do
  begin
    x0 := x[i] - xq;
    y0 := y[i] - yq;
    if abs (x0) < abs (y0) then
      begin
        an [i] := arctan (x0/y0);
        if y0 < 0 then an [i] := an[i] + pi;
        an [i] := (pi/2) - an[i];
        if an [i] < 0 then an [i] := an [i] + 2 * pi;
        if an [i] > 2 * pi then an [i] := an [i] - 2 * pi;
      end else
      begin
        an [i] := arctan (y0/x0);
        if x0 < 0 then an [i] := an[i] + pi;
        if an [i] < 0 then an [i] := an [i] + 2 * pi;
        if an [i] > 2 * pi then an [i] := an [i] - 2 * pi;
      end;
  end;
  for i := 1 to n-1 do
  for j := i+1 to n do
  if an[i] > an[j] then
    begin
      hf := x[i]; x[i] := x[j]; x[j] := hf;
      hf := y[i]; y[i] := y[j]; y[j] := hf;
      hf := an[i]; an[i] := an[j]; an[j] := hf;
      ih := nm[i]; nm[i] := nm[j]; nm[j] := ih;
    end;
end;

function Square (i, j: integer): float;
begin
  Square := 0.5*abs((x[i]-xx)*(y[j]-yy)-(x[j]-xx)*(y[i]-yy));
end;

function Possible (i, j: integer): boolean;
var k: float;
    x0, y0: float;
begin
  if (i = j) then begin possible := false; exit; end;
  k := ((x[j]-x[i]) * (xx-x[i]) + (y[j]-y[i]) * (yy-y[i])) /
       (sqr(x[j]-x[i])+sqr(y[j]-y[i]));
  x0 := x[i] + (x[j]-x[i]) * k;
  y0 := y[i] + (y[j]-y[i]) * k;
  if sqr(xx-x0)+sqr(yy-y0) > sqr(rr) - eps then
   begin
     possible := true;
     exit;
   end;
  if (k <0) or (k > 1) then
    begin
      Possible := true;
      exit;
    end;
  Possible := false;
end;

function Squ (i, j: integer): float;
var an1, an2: float;
begin
  Squ := Infinity;
  if (i = 1) and (j=4) then
   i := i;
  an1 := an[i];
  an2 := an[j];
  if an2 < an1 then an2 := an2 + 2 * pi;
  if an2-an1 > pi - eps then exit;
  if not (possible (i, j)) then exit;
  Squ := Square (i, j);
end;

procedure FillPairs;
var i, j, k: integer;
begin
  for i := 1 to n do
  if possible (i, (i mod n) + 1) then
    begin
      sq[(i-1) mod n]^[(i) mod n] := Square (i, (i mod n)+1);
      sq[(i) mod n]^[(i-1) mod n] := sq[(i-1) mod n]^[(i) mod n];
    end;
end;

procedure FillTab;
var i, j, k: integer;
    min, cur: float;
begin
  for i := 0 to 99 do
  begin
    for j := 0 to 99 do
    sq[i]^[j] := infinity;
  end;
  for i := 0 to n-1 do
  sq[i]^[i] := Infinity;
  FillPairs;
  for k := 2 to n do
  begin
    if tm > ts then begin PrintRes; halt; end;
    for i := 0 to n-1 do
    begin
      min := squ (i+1, (i+k) mod n+1);
      bst [i+1, (i+k) mod n+1] := 0;
      for j := i+1 to i+k-1 do
      begin
        cur := squ((i mod n)+1, (j mod n)+1) + sq[j mod n]^[(i+k) mod n];
        if cur < min then begin min := cur; bst [i+1, (i+k) mod n+1] := j+1; end;
      end;
      sq[i]^[(i+k) mod n] := min;
    end;
  end;
end;

procedure Print (x, y: integer);
begin
  if ((y-x) < 2) or (bst[(x mod n) +1, (y mod n)+1]=0) then
     begin
       inc (ansc);
       ans[ansc] := nm[(x mod n)+1];
       exit;
     end;
  Print (x, bst[(x mod n) +1, (y mod n)+1]-1);
  Print (bst[(x mod n)+1, (y mod n)+1]-1, y);
end;

procedure FindSol;
var min: float;
    bi, i: integer;
begin
  min := Infinity;
  for i := 0 to n-1 do
  if sq[i]^[i] < min then
    begin
      min := sq[i]^[i];
      bi := i;
    end;
  if min > Infinity * 0.1 then
      begin
        tmpa := infinity;
        exit;
      end;
  tmpa := min;
  if tmpa > mina then exit;
  mina := min;
  ansc := 0;
  Print (bi, bi+n);
end;

procedure Solve;
var de, an: float;
    i: integer;
begin
  for i := 0 to 99 do
  new (sq[i]);
  xq := xx; yq := yy;
  SortThemAll;
  FillTab;
  FindSol;
{  xq := xx; yq := yy-rr;
  SortThemAll;
  FillTab;
  FindSol;
  xq := xx; yq := yy+rr;
  SortThemAll;
  FillTab;
  FindSol;
  xq := xx-rr; yq := yy;
  SortThemAll;
  FillTab;
  FindSol;
  xq := xx+rr; yq := yy;
  SortThemAll;
  FillTab;
  FindSol;
  repeat
    an := random * 2 * pi;
    de := (1-sqr(random)) * rr;
    xq := xx + sin (an) * de;
    yq := yy + cos (an) * de;
    SortThemAll;
    FillTab;
    FindSol;
  until false;}
end;

begin
  ts := tm + 165;
  ReadAll;
  mina := Infinity;
  Solve;
  PrintRes;
end.