{ XII ᨩ᪠  誮쭨  ଠ⨪ }
{ (c) 2000,   . }
{  "" }
{ :   . ॣ }
{ 襭: ᨬ  }
{ 室 䠩: INPUT.TXT, 室: OUTPUT.TXT }

{.$define DEBUG}
{$M 16384,0,0}

{.$define BUILD_ANSWER}

{.$define FROM_BEGINING}

program Solution;

{$ifndef DEBUG}
{$A-,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile                        = 'input.txt';
  {$ifndef BUILD_ANSWER}
  outFile                       = 'output.txt';
  {$else}
  outFile                       = 'answer.txt';
  {$endif}
{$else}
{$A-,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile                        = 'input.txt';
  outFile                       = 'con';
  dbgFile                       = 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 100;

type
  TNumber                       = array[0..maxN] of integer;

var
  r                             : integer;
  m,n                           : integer;
  a,b,c,p                       : TNumber;
  nSols                         : integer;

procedure PrintNumber( var n : TNumber );
var
  i,j                           : integer;

begin
  for i := maxN downto 0 do
    if n[i] <> 0 then break;
  for j := i downto 0 do write( n[j] );
end;

procedure WriteData;
begin
  PrintNumber( a );
  write( '*' );
  PrintNumber( b );
  write( '=' );
  PrintNumber( p );
  writeln;
end;

procedure EvalProduct;
var
  i,j                           : integer;
  x,y                           : integer;

begin
  fillchar( p, sizeof(p), 0 );
  for i := 0 to r do begin
    y := c[i];
    for j := i to maxint do begin
      if y = 0 then break;
      x := y + p[j];
      p[j] := x mod 10;
      y := x div 10;
    end;
  end;
end;

{$ifndef FROM_BEGINING}
procedure Rec( depth : integer );
var
  i,j,k                         : integer;
  x,y                           : integer;
  p,q                           : integer;
  s,ss                          : integer;
  hiP,hiQ                       : integer;

begin
  k := m + n - depth - 1;

  if k < 0 then begin
    if m = n then
      for i := m - 1 downto 0 do begin
        if a[i] < b[i] then break;
        if a[i] > b[i] then exit;
      end;
    inc( nSols );
    {$ifndef BUILD_ANSWER}
    WriteData;
    {$endif}
    exit;
  end;

  s := 0;
  x := -1;
  y := -1;
  for i := 0 to k do begin
    j := k - i;
    if (i >= n) or (j < 0) then break;
    if j < m then begin
      { a[i] * b[j] }
      if i = n - depth then x := b[j] else
      if j = m - depth then y := a[i] else
      inc( s, a[i] * b[j] );
    end;
  end;

  s := c[k] - s;
  i := n - depth;
  j := m - depth;
  if (x = -1) and (y = -1) then begin
    if s <> 0 then begin
      { dead branch }
      exit;
    end;
    Rec( depth + 1 );
    exit;
  end;

  hiP := 9;
  if x = -1 then hiP := 0;
  hiQ := 9;
  if y = -1 then hiQ := 0;

  for p := 0 to hiP do
    for q := 0 to hiQ do begin
      ss := 0;
      if x <> -1 then inc( ss, p * x );
      if y <> -1 then inc( ss, q * y );
      if ss = s then begin
        if x <> -1 then a[i] := p;
        if y <> -1 then b[j] := q;
        Rec( depth + 1 );
      end;
    end;
end;

procedure SolveHelper;
var
  i,j                           : integer;

begin
  fillchar( a, sizeof(a), 0 );
  fillchar( b, sizeof(b), 0 );
  for i := 1 to 9 do
    if c[m+n-2] mod i = 0 then begin
      a[n-1] := i;
      j := c[m+n-2] div a[n-1];
      if j <= 9 then begin
        b[m-1] := j;
        Rec( 2 );
      end;
    end;

end;

{$else}

procedure Rec( depth : integer; al, bl : integer );
var
  i,j                           : integer;
  p,q                           : integer;
  s,ss                          : integer;
  hiP,hiQ                       : integer;
  x,y                           : integer;
  _al,_bl                       : integer;

begin

  if al + bl - 1 > r then exit;

  if depth = r then begin
    if al > bl then exit;
    if al = bl then
      for i := al - 1 downto 0 do begin
        if a[i] < b[i] then break;
        if a[i] > b[i] then exit;
      end;
    inc( nSols );
    {$ifndef BUILD_ANSWER}
    WriteData;
    {$endif}
    exit;
  end;

  s := 0;
  x := -1;
  y := -1;
  for i := 0 to depth do begin
    j := depth - i;
    { a[i] * b[j] }
    if i = depth then x := b[j] else
    if j = depth then y := a[i] else
    inc( s, a[i] * b[j] );
  end;

  s := c[depth] - s;
  if (x = -1) and (y = -1) then begin
    if s <> 0 then begin
      { dead branch }
      exit;
    end;
    Rec( depth + 1, al, bl );
    exit;
  end;

  hiP := 9;
  if x = -1 then hiP := 0;
  hiQ := 9;
  if y = -1 then hiQ := 0;

  for p := 0 to hiP do
    for q := 0 to hiQ do begin
      ss := 0;
      if x <> -1 then inc( ss, p * x );
      if y <> -1 then inc( ss, q * y );
      if ss = s then begin
        _al := al;
        _bl := bl;
        if x <> -1 then begin
          a[depth] := p;
          if p <> 0 then _al := depth + 1;
        end;
        if y <> -1 then begin
          b[depth] := q;
          if q <> 0 then _bl := depth + 1;
        end;
        Rec( depth + 1, _al, _bl );
      end;
    end;
end;

{$endif}

procedure Solve;
var
  i,j                           : integer;
  al, bl : integer;

begin
  EvalProduct;
  nSols := 0;

  {$ifndef FROM_BEGINING}
  for m := 1 to (r + 1) div 2 do begin
    n := r - m + 1;
    SolveHelper;
  end;
  {$else}
   for i := 0 to 9 do
     for j := 0 to 9 do
       if i * j = c[0] then begin
         a[0] := i;
         b[0] := j;
         if i = 0 then al := 0 else al := 1;
         if j = 0 then bl := 0 else bl := 1;
         Rec( 1, al, bl );
       end;
  {$endif}

  {$ifdef BUILD_ANSWER}
  writeln( nSols );
  PrintNumber( p );
  writeln;
  {$endif}
end;

procedure ReadData;
var
  i                             : integer;

begin
  r := 0;
  while not SeekEOF do begin
    read( c[r] );
    inc( r );
  end;
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef DEBUG}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef DEBUG}
  writeln( '----Finalized----' );
  close( dbg );
  {$endif}

  close( input );
  close( output );

  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  Finalize;
end.