{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P+,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}

program map;

const
  maxnum = 3000;

var
  q: array [1..maxnum] of
       record
         x1, y1, x2, y2: shortint;
         a, f: shortint;
       end;
  num: longint;
  h, v: array [0..51, 0..51] of shortint;
  i, j, k, n, m, answer: longint;
  c: char;

function calc(x1, y1, x2, y2: longint): longint;
var
  i, j, k, r: longint;
  left, cent, right: longint;
  f: boolean;
  my: longint;
begin
  if (x2 = x1) and (y2 = y1) then
  begin
    calc := 0;
    exit;
  end;

  for i := 1 to num do
    if (q[i].x1 = x1) and (q[i].y1 = y1) and
       (q[i].x2 = x2) and (q[i].y2 = y2) then
    begin
      calc := q[i].a;
      exit;
    end;
{  writeln(x1, ' ', y1, ' ', x2, ' ', y2);}

  inc(num);
  if num > maxnum then
  begin
    writeln('Queue overflow !');
    halt(1);
  end;

  q[num].x1 := x1;
  q[num].y1 := y1;
  q[num].x2 := x2;
  q[num].y2 := y2;
  q[num].a := -1;
  q[num].f := 0;
  my := num;

  { Check for plane }
  f := true;
  for i := x1 to x2 - 1 do
  begin
    if not f then break;
    for j := y1 to y2 do
      if v[i][j] <> 0 then
      begin
        f := false;
        break;
      end;
  end;
  for i := x1 to x2 do
  begin
    if not f then break;
    for j := y1 to y2 - 1 do
      if h[i][j] <> 0 then
      begin
        f := false;
        break;
      end;
  end;
  if f then
  begin
    q[num].a := 0;
    calc := 0;
    exit;
  end;

  { Searching for vertical }
  for i := x1 to x2 - 1 do
  begin
    if v[i][y1] = 0 then continue;
    f := true;
    for j := y1 + 1 to y2 do
      if v[i][j] <> v[i][y1] then
      begin
        f := false;
        break;
      end;
    if f then
    begin
      left := x1;
      cent := i;
      right := x2;
      if cent - left > right - cent - 1 then
        left := 2 * cent - right + 1;
      if cent - left < right - cent - 1 then
        right := 2 * cent - left + 1;

      f := true;
      { Check horisontal inversion }
      for j := 0 to cent - left do
      begin
        if not f then break;
        for k := y1 to y2 - 1 do
          if h[left + j][k] <> - h[right - j][k] then
          begin
            f := false;
            break;
          end;
      end;
      { Check vertical inversion }
      for j := 0 to cent - left - 1 do
      begin
        if not f then break;
        for k := y1 to y2 do
          if v[left + j][k] <> - v[right - j - 1][k] then
          begin
            f := false;
            break;
          end;
      end;

      if f then
      begin
        if i - x1 > x2 - i - 1 then
          r := calc(x1, y1, i, y2)
        else
          r := calc(i + 1, y1, x2, y2);
        if (r <> -1) and ((q[my].a = -1) or (r + 1 < q[my].a)) then
        begin
          q[my].a := r + 1;
          q[my].f := i - x1 + 1;
        end;
      end;
    end;
  end;

  { Searching for horisontal }
  for i := y1 to y2 - 1 do
  begin
    if h[x1][i] = 0 then continue;
    f := true;
    for j := x1 + 1 to x2 do
      if h[j][i] <> h[x1][i] then
      begin
        f := false;
        break;
      end;
    if f then
    begin
      left := y1;
      cent := i;
      right := y2;
      if cent - left > right - cent - 1 then
        left := 2 * cent - right + 1;
      if cent - left < right - cent - 1 then
        right := 2 * cent - left + 1;

      f := true;
      { Check horisontal inversion }
      for j := 0 to cent - left - 1 do
      begin
        if not f then break;
        for k := x1 to x2 do
          if h[k][left + j] <> - h[k][right - j - 1] then
          begin
            f := false;
            break;
          end;
      end;
      { Check vertical inversion }
      for j := 0 to cent - left do
      begin
        if not f then break;
        for k := x1 to x2 - 1 do
          if v[k][left + j] <> - v[k][right - j] then
          begin
            f := false;
            break;
          end;
      end;

      if f then
      begin
        if i - y1 > y2 - i - 1 then
          r := calc(x1, y1, x2, i)
        else
          r := calc(x1, i + 1, x2, y2);
        if (r <> -1) and ((q[my].a = -1) or (r + 1 < q[my].a)) then
        begin
          q[my].a := r + 1;
          q[my].f := -(i - y1 + 1);
        end;
      end;
    end;
  end;

  calc := q[my].a;
end;

procedure outit(x1, y1, x2, y2, signh, signv: longint);
var
  i, my: longint;
begin
  my := 0;
  for i := 1 to num do
    if (q[i].x1 = x1) and (q[i].y1 = y1) and
       (q[i].x2 = x2) and (q[i].y2 = y2) then
    begin
      my := i;
      break;
    end;

  if (my = 0) or (q[my].f = 0) then exit;

  if q[my].f > 0 then
    if signv = 1 then
      writeln(q[my].f)
    else
      writeln(x2 - x1 + 1 - q[my].f)
  else
    if signh = 1 then
      writeln(q[my].f)
    else
      writeln(-(y2 - y1 + 1 - abs(q[my].f)));

  if q[my].f > 0 then
  begin
    i := x1 + q[my].f - 1;
    if i - x1 > x2 - i - 1 then
      outit(x1, y1, i, y2, signh, signv)
    else
      outit(i + 1, y1, x2, y2, signh, -signv);
  end
  else
  begin
    i := y1 - q[my].f - 1;
    if i - y1 > y2 - i - 1 then
      outit(x1, y1, x2, i, signh, signv)
    else
      outit(x1, i + 1, x2, y2, -signh, signv);
  end;
end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  readln(m, n);
  readln; { 2m-1 * }
  for i := 1 to n do
  begin
    read(c); { * }
    for j := 1 to m-1 do
    begin
      read(c); { . }
      read(c);
      if c = '+' then v[j][i] := 1;
      if c = '0' then v[j][i] := 0;
      if c = '-' then v[j][i] := -1;
    end;
    read(c, c); { .* };
    readln;

    if i < n then
    begin
      read(c); { * };
      for j := 1 to m do
      begin
        read(c);
        if c = '+' then h[j][i] := 1;
        if c = '0' then h[j][i] := 0;
        if c = '-' then h[j][i] := -1;
        read(c); { * }
      end;
      readln;
    end;
  end;

  answer := calc(1, 1, m, n);
  if answer = -1 then
  begin
    writeln('NO')
  end
  else
  begin
    writeln('YES');
    writeln(answer);
    outit(1, 1, m, n, 1, 1);
  end;

{  writeln(num);}
end.