{$A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program macro;

var
  PrimesN       : integer;
  Primes        : array [1..4096] of integer;
  inv, maxv     : array [1..4096] of longint;

function invnum (x : longint) : longint;
var y, z : longint;
begin
  x := 1 - x;
  y := 1;
  z := 0;
  repeat
    z := z + y;
    y := y * x
  until y = 0;
  invnum := z
end;

type
  arr   = array [0..32767] of boolean;
  parr  = ^arr;

procedure makeprimes;
var
  A    : parr;
  p, i : integer;
begin
  new (A);
  fillchar (A^, sizeof (A^), 0);
  p := 1;
  repeat
    repeat inc (p) until (p = MaxInt) or (not A^[p]);
    if p = MaxInt then break;
    inc (PrimesN);
    Primes [PrimesN] := p;
    i := p;
    repeat
      i := i + p;
      if i < 0 then break;
      A^[i] := true
    until false
  until false;
  dispose (A);
  for i := 2 to PrimesN do
    begin
      inv [i] := invnum (Primes [i]);
      maxv [i] := MaxLongInt div longint (Primes [i]);
    end
end;

var i, N, Sum   : longint;

function calc (z : longint) : longint;
var i, p, s    : integer;
    t          : longint;
begin
  while (z and 1) = 0 do z := z shr 1;
  if (z and 3) = 3 then begin calc := 0; exit end;
  i := 2;
  p := 3;
  t := 4;
  repeat
    if abs (z * inv[i]) < maxv[i] then
      begin
        s := 0;
        repeat
          z := z div p;
          inc (s)
        until abs (z * inv[i]) >= maxv[i];
        if (p and 3) = 1 then t := t * (s + 1)
        else if odd (s) then begin calc := 0; exit end;
      end;
    inc (i);
    p := primes [i];
  until sqr (longint (p)) > z;
  if z > 1 then t := t shl 1;
  calc := t
end;

begin
  makeprimes;
  assign (input, 'input.txt'); reset (input);
  assign (output, 'output.txt'); rewrite (output);
  repeat
    read (N);
    if N = 0 then break;
    Sum := 0;
    i := 0;
    repeat
      Sum := Sum + calc (N - sqr (i)) shl ord (i > 0);
      inc (i)
    until sqr (i) >= N;
    if sqr (i) = N then inc (Sum, 2);
    writeln (Sum)
  until seekeof
end.
