{ ᨩ   誮쭨  ணࠬ஢ }
{ :  "⪨"                                               }
{ :   ३ ⠭                                       }
{ 襭: ३ ⠭                                       }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P+,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}

program Tiles;

const
  maxn = 60;

  magic: array [1..3, 1..3] of longint =
    ((  1,  2,  4 ),
     (  2,  8, 16 ),
     (  4, 16, 32 ));

type
  ttable = array [1..3, 1..3] of boolean;
  tlong = array [1..maxn] of byte;

var
  n: longint;
  can: ttable;
  code: longint;
  total: array [0..1, 1..3, 0..63] of tlong;
  answer: tlong;

procedure readdata;
var
  s: string;
  i1, i2: longint;
begin
  readln(n);
  for i1 := 1 to 3 do
  begin
    readln(s);
    for i2 := 1 to 3 do
      if upcase(s[i2]) = 'Y' then
      begin
        can[i1][i2] := true;
        can[i2][i1] := true;
      end;
  end;
end;

procedure findcode;
var
  i, j: longint;
begin
  code := 0;
  for i := 1 to 3 do
    for j := i to 3 do
      if can[i][j] then
        code := code + magic[i][j];
end;

procedure init(var x: tlong; n: longint);
var
  i: longint;
begin
  fillchar(x, sizeof(x), 0);
  i := 1;
  while n > 0 do
  begin
    x[i] := n mod 10;
    inc(i);
    n := n div 10;
  end;
end;

procedure add(var a, b: tlong);
var
  i, c: longint;
begin
  c := 0;
  for i := 1 to maxn do
  begin
    c := c + a[i] + b[i];
    a[i] := c mod 10;
    c := c div 10;
  end;
end;

procedure print(var a: tlong);
var
  i: longint;
begin
  i := maxn;
  while (i > 1) and (a[i] = 0) do
    dec(i);
  while (i > 0) do
  begin
    write(a[i]);
    dec(i);
  end;
  writeln;
end;

function ok(i, j, num: longint): boolean;
begin
  ok := (magic[i][j] and num) <> 0;
end;

function but(i, j, num: longint): longint;
begin
  but := num xor magic[i][j];
end;

var
  i, j, k, l, m: longint;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  readdata;
  findcode;

  fillchar(total, sizeof(total), 0);
  init(total[1, 1, 0], 1);
  init(total[1, 2, 0], 1);
  init(total[1, 3, 0], 1);

  for i := 2 to n do
    for j := 0 to 63 do
      for k := 1 to 3 do
      begin
        init(total[i and 1][k][j], 0);
        for l := 1 to 3 do
          if ok(k, l, j) then
          begin
            add(total[i and 1][k][j], total[(i and 1) xor 1][l][j]);
            add(total[i and 1][k][j], total[(i and 1) xor 1][l][but(k, l, j)]);
          end;
      end;

  init(answer, 0);
  add(answer, total[n and 1][1][code]);
  add(answer, total[n and 1][2][code]);
  add(answer, total[n and 1][3][code]);
  print(answer);
end.