{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

const maxn=5000;
      maxk=20000;
      eps=1e-7;
type tline=record a,b,c:real;end;
     tpoint=record x,y:real;end;
     mm=array [1..maxk] of word;
     ma=array [1..maxn] of tpoint;
var a:array [1..maxn] of tpoint;
    c:array [1..1000] of record s,f:integer;end;
    b,pr:^mm;
    pr2:^ma;
    i,e,j,n,v,u:integer;
    xa,ya,xb,yb:real;
    l,color,yk,kk,yk2:longint;
    tl,tl1,tl2:tline;
    p,p1,p2,res:tpoint;
    ch:boolean;

procedure init;
begin
 assign(input,'fire.in');
 reset(input);
 read(l);
 read(n);
end;

procedure load;
begin
 read(p1.x,p1.y,p2.x,p2.y);
end;

procedure point2toline(a,b:tpoint;var l:tline);
begin
 l.a:=b.y-a.y;l.b:=a.x-b.x;l.c:=-(l.a*a.x+l.b*a.y);
end;

function realeq(a,b:real):boolean;
begin
 realeq:=abs(a-b)<=eps;
end;

procedure sim(l:tline;var fl,sl:tline);
 var x0,y0,x2,y2,q:real;
begin
 q:=50*sqrt(sqr(l.a)+sqr(l.b));
 if not realeq(l.a,0) then begin
   y0:=100;y2:=100;
   x0:=(q-l.b*y0-l.c)/l.a;
   x2:=(-q-l.b*y2-l.c)/l.a;
  end
    else begin
        x0:=100;x2:=100;
        y0:=(q-l.a*x0-l.c)/l.b;
        y2:=(-q-l.a*x2-l.c)/l.b;
     end;
 fl:=tl;
 fl.c:=-tl.a*x0-tl.b*y0;
 sl:=tl;
 sl.c:=-tl.a*x2-tl.b*y2;
end;

function line2topoint(fl,sl:tline;var p:tpoint):boolean;
 var st:real;
begin
 st:=fl.a*sl.b-fl.b*sl.a;
 if not realeq(st,0) then begin
   line2topoint:=true;
   p.x:=-(fl.c*sl.b-fl.b*sl.c)/st;
   p.y:=(fl.c*sl.a-fl.a*sl.c)/st;
  end else line2topoint:=false;
end;

function eqpoint(a,b:tpoint):boolean;
begin
 eqpoint:=realeq(a.x,b.x) and realeq(a.y,b.y);
end;

function realmoreeq(a,b:real):boolean;
begin
 realmoreeq:=a-b>-eps;
end;

function atotres(a,b,p:tpoint):boolean;
begin
 if eqpoint(a,b) then atotres:=eqpoint(a,p) else
  atotres:=realeq((b.x-a.x)*(p.y-a.y),(b.y-a.y)*(p.x-a.x)) and

    ((realmoreeq(p.x,a.x) and realmoreeq(b.x,p.x)) or
      realmoreeq(p.x,b.x) and realmoreeq(a.x,p.x)) and

      ((realmoreeq(p.y,a.y) and realmoreeq(b.y,p.y)) or
       realmoreeq(p.y,b.y) and realmoreeq(a.y,p.y));
end;

function find(f:integer):word;
 var w:integer;
begin
 for w:=i+1 to j do
  if b^[w]=f then begin find:=w;exit;end;
 find:=0;
end;

function findnew(f:integer):word;
 var w:integer;
begin
 for w:=1 to j do
  if b^[w]=f then begin findnew:=w;exit;end;
 findnew:=0;
end;

function rasttoline(l:tline;p:tpoint):real;
begin
 rasttoline:=(l.a*p.x+l.b*p.y+l.c)/(sqrt(sqr(l.a)+sqr(l.b)));
end;

procedure main;
 var rs:real;
     pp:boolean;
begin

 fillchar(c,sizeof(c),0);kk:=0;
 for i:=1 to yk do if b^[i]<>0 then begin
   rs:=rasttoline(tl,a[i]);
   if realmoreeq(abs(rs),50) then begin
     if realmoreeq(rs,0) then begin
       pp:=false;
       for j:=1 to kk do
        if b^[i]=c[j].s then begin
          b^[i]:=c[j].f;
          pp:=true;
          break;
         end;
       if not pp then begin
         inc(color);
         inc(kk);
         c[kk].s:=b^[i];c[kk].f:=color;
         b^[i]:=color;
        end;
      end;
    end else b^[i]:=0;
  end;
end;

procedure sort;
begin
end;

procedure make;
 var r:tline;
     t:integer;
begin
 point2toline(p1,p2,tl);
 sim(tl,tl1,tl2);j:=yk;
 for i:=1 to j do begin
   if b^[i]=0 then continue;
   t:=find(b^[i]);
  if t<>0 then  begin
   point2toline(a[i],a[t],r);
   if line2topoint(r,tl1,p) and atotres(a[i],a[t],p) then begin
     inc(yk);
     a[yk]:=p;b^[yk]:=b^[i];
    end;
   if line2topoint(r,tl2,p) and atotres(a[i],a[t],p) then begin
     inc(yk);
     a[yk]:=p;b^[yk]:=b^[i];
    end;

  end else begin
    t:=findnew(b^[i]);
    point2toline(a[i],a[t],r);
   if line2topoint(r,tl1,p) and atotres(a[i],a[t],p) then begin
     inc(yk);
     a[yk]:=p;b^[yk]:=b^[i];
    end;
   if line2topoint(r,tl2,p) and atotres(a[i],a[t],p) then begin
     inc(yk);
     a[yk]:=p;b^[yk]:=b^[i];
    end;
  end;
 end;

 main;
end;

procedure result;
 var t,h,k,l:integer;
begin
 ch:=false;
 for i:=1 to yk do
  if b^[i]<>0 then begin
     t:=1;h:=i;k:=0;l:=0;
    for j:=i+1 to yk do
      if b^[j]=b^[i] then begin
       inc(t);
       case t of
        2:k:=j;
        3:k:=j;
       end;
      if t=3 then begin color:=b^[i];exit;end;
     end;
   end;

 ch:=true;
end;

procedure upgrade;
begin
 for i:=1 to yk-1 do
  for j:=i+1 to yk do
   if eqpoint(a[i],a[j]) and (b^[j]<>0) and (b^[i]<>0) then b^[j]:=0;
end;

procedure del;
 var i:integer;
begin
 yk2:=0;
 for i:=1 to yk do
  if b^[i]<>0 then begin
    inc(yk2);
    pr^[yk2]:=b^[i];
    pr2^[yk2]:=a[i];
   end;
 yk:=yk2;
 b^:=pr^;
 for i:=1 to yk do
  a[i]:=pr2^[i];
end;

procedure solve;
begin
 fillchar(a,sizeof(a),0);
 fillchar(b^,sizeof(b^),0);
 yk:=4;
 a[2].x:=0;a[2].y:=l;
 a[3].x:=l;a[3].y:=l;
 a[4].x:=l;a[4].y:=0;
 b^[1]:=1;b^[2]:=1;b^[3]:=1;b^[4]:=1;
 color:=1;kk:=0;

 for e:=1 to n do begin
   load;
   make;
   upgrade;
   if e mod 10=0 then del;
   v:=0;
   for u:=1 to yk do
      if b^[u]<>0 then inc(v);
  end;

  upgrade;
  result;
end;

procedure done;
begin
 close(input);

 assign(output,'fire.out');
 rewrite(output);
  res.x:=0;res.y:=0;e:=0;
  if ch then write('OK') else begin
    for i:=1 to yk do
     if b^[i]=color then begin
       inc(e);
       res.x:=res.x+a[i].x;
       res.y:=res.y+a[i].y;
      end;
    res.x:=res.x/e;
    res.y:=res.y/e;
    writeln(res.x:0:3,' ',res.y:0:3);
   end;
 close(output);
end;

begin
 new(b);new(pr);new(pr2);
 init;
 solve;
 done;
 dispose(b);dispose(pr);dispose(pr2);
end.
