{$M 65520,0,655360}
{$N+ $G+}
program p0305_1;
type
  tsum=array [0..4] of word;
  telement=packed record s:tsum; l:byte; end;
  tmain=array [0..3239] of telement;
  pmain=^tmain;
  tpair=packed record n1,n2:byte; end;
  tpoint=packed record x,y:byte; end;
  tpath=packed record p:array [1..240] of tpoint; l:byte; end;
var
  a,b,c,d,e,g,h,i,j,l,n,r,sl,e1,g1:word;
  k:byte;
  s1,s2:tsum;
  m:array [1..3,1..3] of pmain;
  f:text;
  table:array [1..80,1..3] of word;
  pair:array [0..3239] of tpair;
  pn:array [1..80,1..80] of word;
  kpairs:word;
  p:tpath;
  x1,y1,x2,y2,dx,dy:integer;

procedure zs(var s:tsum);
begin
  s[0]:=0; s[1]:=0; s[2]:=0; s[3]:=0; s[4]:=0;
end;

procedure shlsm(var s:tsum; c:word);
var
  a,b:word; c1:word;
begin
  c1:=16-c; b:=$FFFF; b:=b shl c1;
  s[4]:=s[4] shl c;
  a:=(s[3] and b) shr c1;
  s[4]:=s[4] or a;
  s[3]:=s[3] shl c;
  a:=(s[2] and b) shr c1;
  s[3]:=s[3] or a;
  s[2]:=s[2] shl c;
  a:=(s[1] and b) shr c1;
  s[2]:=s[2] or a;
  s[1]:=s[1] shl c;
  a:=(s[0] and b) shr c1;
  s[1]:=s[1] or a;
  s[0]:=s[0] shl c;
end;

procedure shls(var s:tsum; s1:tsum; c:integer);
var
  a:word;
begin
  s:=s1;
  repeat
    a:=c; if a>15 then a:=15;
    shlsm(s,a);
    c:=c-a;
  until c=0;
end;

function grs(s1,s2:tsum):boolean;
var
  a:word;
begin
  for a:=4 downto 0 do
    if s1[a]<>s2[a] then begin grs:=(s1[a]>s2[a]); exit; end;
  grs:=false;
end;

procedure ors(var s:tsum; s1,s2:tsum);
var
  a:word;
begin
  for a:=0 to 4 do s[a]:=s1[a] or s2[a];
end;

procedure sbit(var s:tsum; n:word; v:word);
var
  a,b,c:word;
begin
  b:=1 shl (n and 15); c:=n shr 4;
  if v=1 then s[c]:=s[c] or b else s[c]:=s[c] and ($FFFF-b);
end;

procedure testsl1(a,b:word; var s:tsum);
var
  c,d,e:word;
begin
  c:=(b-a+1)*3; zs(s);
  for d:=a to b do begin dec(c); sbit(s,c,table[d,1]); end;
  for d:=b downto a do begin dec(c); sbit(s,c,table[d,2]); end;
  for d:=a to b do begin dec(c); sbit(s,c,table[d,3]); end;
end;

procedure testsl2(a,b:word; var s:tsum);
var
  c,d,e:word;
begin
  c:=(b-a+1)*3; zs(s);
  for d:=a to b do begin dec(c); sbit(s,c,table[d,3]); end;
  for d:=b downto a do begin dec(c); sbit(s,c,table[d,2]); end;
  for d:=a to b do begin dec(c); sbit(s,c,table[d,1]); end;
end;

{function getrsum(a,c,st,fin:word; var s:tsum);
var
  s1:tsum; b,d,e:word;
begin
end;}

procedure testrazb(a,b,c,st,fin:word; var h:word; var s:tsum; var l:byte);
var
  d,e,g,h1:word;
  s1,s2:tsum;
begin
  h:=1; zs(s); d:=pn[a,c]; g:=pn[c+1,b]; l:=m[st,1]^[d].l+m[1,fin]^[g].l;
  for h1:=1 to 3 do
    begin
    s1:=m[st,h1]^[d].s; e:=m[h1,fin]^[g].l; shls(s1,s1,e);
    s2:=m[h1,fin]^[g].s; ors(s1,s1,s2);
    if grs(s1,s) then
      begin s:=s1; h:=h1; l:=m[st,h]^[d].l+m[h,fin]^[g].l; end;
    end;
end;

procedure test(b,c,e,g:word; var r,sl,l,h1:word; var s2:tsum);
var
  d,h,i,j:word;
  k:byte;
begin
  d:=pn[b,c];
  if b=c then
    begin
    s2:=m[e,g]^[d].s; l:=m[e,g]^[d].l; sl:=3;
    exit;
    end;
  for i:=b to c-1 do
    begin
    testrazb(b,c,i,e,g,h,s1,k);
    if (i=b) or (grs(s1,s2)) then
      begin s2:=s1; l:=k; h1:=h; sl:=0; r:=i; end;
    end;
  if (e=1) and (g=3) then
    begin
    testsl1(b,c,s1);
    if grs(s1,s2) then begin s2:=s1; l:=(c-b+1)*3; sl:=1; end;
    end;
  if (e=3) and (g=1) then
    begin
    testsl2(b,c,s1);
    if grs(s1,s2) then begin s2:=s1; l:=(c-b+1)*3; sl:=2; end;
    end;
{  m[e,g]^[d].s:=s2; m[e,g]^[d].l:=l;}
end;

procedure getpath(var p:tpath; b,c,e,g:integer);
var
  a,h,i,j,k,l,r,sl,z:word;
  s2:tsum;
  p1:tpath;
begin
  test(b,c,e,g,r,sl,l,h,s2);
  case sl of
    0:
      begin
      getpath(p1,b,r,e,h);
      for a:=1 to p1.l do p.p[a]:=p1.p[a]; z:=p1.l;
      getpath(p1,r+1,c,h,g);
      for a:=1 to p1.l do p.p[a+z]:=p1.p[a];
      p.l:=z+p1.l;
      end;
    1:
      begin
      z:=0;
      for a:=b to c do begin inc(z); p.p[z].x:=a; p.p[z].y:=1; end;
      for a:=c downto b do begin inc(z); p.p[z].x:=a; p.p[z].y:=2; end;
      for a:=b to c do begin inc(z); p.p[z].x:=a; p.p[z].y:=3; end;
      p.l:=(c-b+1)*3;
      end;
    2:
      begin
      z:=0;
      for a:=b to c do begin inc(z); p.p[z].x:=a; p.p[z].y:=3; end;
      for a:=c downto b do begin inc(z); p.p[z].x:=a; p.p[z].y:=2; end;
      for a:=b to c do begin inc(z); p.p[z].x:=a; p.p[z].y:=1; end;
      p.l:=(c-b+1)*3;
      end;
    3:
      begin
      p.l:=abs(e-g)+1; z:=0;
      if e<g then
        for a:=e to g do begin inc(z); p.p[z].x:=b; p.p[z].y:=a; end
      else
        for a:=e downto g do begin inc(z); p.p[z].x:=b; p.p[z].y:=a; end;
      end;
    end;
end;

begin
  for a:=1 to 3 do for b:=1 to 3 do new(m[a,b]);
  assign(f,'CLASS.IN'); reset(f); read(f,n);
  for a:=1 to 3 do for b:=1 to n do read(f,table[b,a]); close(f);
  c:=0;
  for a:=1 to n do for b:=a to n do
    begin
    pair[c].n1:=a; pair[c].n2:=b; pn[a,b]:=c;
    inc(c);
    end;
  kpairs:=c;
  for a:=1 to n do
    begin
    d:=pn[a,a];
    for b:=1 to 3 do for c:=1 to 3 do
      begin
      e:=abs(integer(b)-integer(c))+1; zs(s1); g:=e;
      if b<c then for h:=b to c do begin dec(e); sbit(s1,e,table[a,h]); end
        else for h:=b downto c do begin dec(e); sbit(s1,e,table[a,h]); end;
      m[b,c]^[d].s:=s1; m[b,c]^[d].l:=g;
      end;
    end;
  for a:=1 to n-1 do
    for b:=1 to n-a do
      begin
      c:=b+a;
      d:=pn[b,c];
      for e:=1 to 3 do
        for g:=1 to 3 do
          begin
 {         for i:=b to c-1 do
            begin
            testrazb(b,c,i,e,g,h,s1,k);
            if (i=b) or (grs(s1,s2)) then
              begin s2:=s1; l:=k; end;
            end;
          if (e=1) and (g=3) then
            begin
            testsl1(b,c,s1);
            if grs(s1,s2) then begin s2:=s1; l:=(c-b+1)*3; end;
            end;
          if (e=3) and (g=1) then
            begin
            testsl2(b,c,s1);
            if grs(s1,s2) then begin s2:=s1; l:=(c-b+1)*3; end;
            end;}
          test(b,c,e,g,r,sl,l,h,s2);
          m[e,g]^[d].s:=s2; m[e,g]^[d].l:=l;
          end;
      end;
  zs(s1);
  d:=pn[1,n];
  for e:=1 to 3 do
    for g:=1 to 3 do
      begin
      test(b,c,e,g,r,sl,l,h,s2);
      if ((e=1) and (g=1)) or grs(s2,s1) then
        begin s1:=s2; e1:=e; g1:=g; end;
      end;
  getpath(p,1,n,e1,g1);
  for a:=1 to 3 do for b:=1 to 3 do dispose(m[a,b]);
  assign(f,'CLASS.OUT');
  rewrite(f);
  writeln(f,p.p[1].y);
  for a:=1 to p.l-1 do
    begin
    x1:=p.p[a].x; y1:=p.p[a].y; x2:=p.p[a+1].x; y2:=p.p[a+1].y;
    dx:=x2-x1; dy:=y2-y1;
    if dy=-1 then write(f,'U');
    if dy=1 then write(f,'D');
    if dx=-1 then write(f,'L');
    if dx=1 then write(f,'R');
    end;
  close(f);
end.