program p0305_5;
var
  a,b,c,d,m,n,k,e,g,h:integer;
  gr:array [1..5000] of integer;
  exist:array [1..5000] of boolean;
  equ:array [1..5000] of integer;
  main:integer;
  kgr,sgr:array [1..1000] of integer;
  color:array [1..1000] of integer;
  u:array [1..1000] of boolean;
  p:array [1..1000] of integer;
  circle:array [1..1000] of integer;
  gr1,gr2:array [1..1000] of integer;
  kgr1,kgr2:integer;
  csize:integer;
  f:text;
  mainpath:array [1..5000] of integer;
  kmp:integer;

procedure fill(n:integer; c:integer);
var
  a,b:integer;
begin
  if color[n]>0 then exit;
  color[n]:=c;
  b:=sgr[n];
  for a:=1 to kgr[n] do
    begin
    if (color[gr[b]]=0) and (exist[b]) and (gr[b]<>main) then fill(gr[b],c);
    inc(b);
    end;
end;

function mm(a,i:integer):integer;
begin
  a:=sgr[a]+i-1;
  if exist[a] then mm:=gr[a] else mm:=0;
end;

procedure fillpath(fin:integer; no:integer);
var
  a,b,c,d:integer;
begin
  fillchar(u,sizeof(u),0);
  u[fin]:=true; kgr1:=1; gr1[1]:=fin;
  repeat
    kgr2:=0;
    for a:=1 to kgr1 do
      begin
      b:=gr1[a];
      for c:=1 to kgr[b] do
        begin
        d:=mm(b,c); if d=0 then continue;
        if (d<>no) and not u[d] then
          begin inc(kgr2); gr2[kgr2]:=d; u[d]:=true;
                p[d]:=equ[sgr[b]+c-1]-sgr[d]+1; end;
        end;
      end;
    for a:=1 to kgr2 do gr1[a]:=gr2[a]; kgr1:=kgr2;
  until kgr1=0;
end;

procedure addpath(st,fin:integer);
var
  a:integer;
begin
  a:=st;
  while a<>fin do
    begin
    a:=mm(a,p[a]);
    inc(kmp); mainpath[kmp]:=a;
    end;
end;

procedure deletepath(st,fin:integer);
var
  a,b:integer;
begin
  a:=st;
  while a<>fin do
    begin
    b:=mm(a,p[a]); exist[sgr[a]+p[a]-1]:=false;
    exist[equ[sgr[a]+p[a]-1]]:=false;
    a:=b;
    end;
end;

procedure delr(a,i:integer);
begin
  a:=sgr[a]+i-1;
  exist[a]:=false; exist[equ[a]]:=false;
end;

function testcircle:boolean;
var
  a,b,c,d,st,fin,stnum,finnum:integer;
begin
  for a:=1 to n do color[a]:=0;
  color[main]:=10000; st:=0; fin:=0;
  for a:=1 to kgr[main] do
    begin
    b:=mm(main,a); if b=0 then continue; if color[b]>0 then
      begin
      st:=mm(main,color[b]); fin:=mm(main,a);
      stnum:=color[b]; finnum:=a; break;
      end;
    fill(b,a);
    end;
  if st=0 then begin testcircle:=false; exit; end;
  csize:=1;
  testcircle:=true;
  fillpath(fin,main);
  inc(kmp); mainpath[kmp]:=st; addpath(st,fin);
  inc(kmp); mainpath[kmp]:=main;
  deletepath(st,fin); delr(main,stnum); delr(main,finnum);
end;

begin
  assign(f,'CASTLE.IN'); reset(f); read(f,n,k); m:=0;
  for a:=1 to n do
    begin
    c:=0; sgr[a]:=m+1;
    repeat
      read(f,b);
      if b>0 then begin inc(c); inc(m); gr[m]:=b; end;
    until b=0;
    kgr[a]:=c;
    end;
  close(f);
  for a:=1 to n do
    begin
    b:=sgr[a];
    for c:=1 to kgr[a] do
      begin
      d:=gr[b+c-1];
      for e:=1 to kgr[d] do
        if gr[sgr[d]+e-1]=a then equ[b+c-1]:=sgr[d]+e-1;
      end;
    end;
  fillchar(exist,sizeof(exist),true);
  {஢ઠ  NO}
  fillchar(color,sizeof(color),0);
  main:=0; fill(k,1); b:=0;
  for a:=1 to n do if (color[a]=1) and (kgr[a] and 1=1) and (a<>k) then
    begin b:=1; main:=a; end;
  if b=0 then
    begin
    assign(f,'CASTLE.OUT'); rewrite(f); writeln(f,'No'); close(f); halt;
    end;
  {----}
  kmp:=1; mainpath[1]:=k;
  fillpath(main,0);
  addpath(k,main);
  deletepath(k,main);
  while testcircle do begin end;
  for a:=1 to n do color[a]:=0;
  fill(k,1);
  for a:=1 to kgr[main] do
    begin
    b:=mm(main,a);
    if (b>0) then if color[b]=0 then
      begin
      inc(kmp);
      mainpath[kmp]:=b;
      break;
      end;
    end;
  assign(f,'CASTLE.OUT'); rewrite(f);
  writeln(f,'Yes'); writeln(f,kmp-1);
  for a:=1 to kmp do
    begin write(f,mainpath[a]); if a<kmp then write(f,' '); end;
  close(f);
end.