type Combine = array [1..10000] of word;
var F: text;
A: Combine;			{  稪 }
C: Combine;			{ 室  }
D: Combine;			{ ᫥⥫쭮 }
DD,I,J,N: integer;
L: longint;
Source: word;
Sel: integer;

function GetCombineNumber(const C: Combine): word;
var I: integer;
L,R: longint;
begin
 L:=1;
 R:=0;
 for I:=1 to N do
 begin
  Inc(R,(C[I]-1)*L);
  L:=L*A[I];
 end;
 GetCombineNumber:=R+1;
end;

function TotalCombines: word;
var I: integer;
L: longint;
begin
 L:=1;
 for I:=1 to N do
 begin
  L:=L*A[I];
  if L>10000 then
  begin
   Assign(F,'tele.out');
   Rewrite(F);
   Writeln(F,'No');
   Close(F);
  end;
 end;
 TotalCombines:=L;
end;

function Rebro(R,B: word): boolean;
var A1,A2,I,Q: integer;
begin
 Dec(R);
 Dec(B);
 Rebro:=False;
 Q:=0;
 for I:=1 to N do
 begin
  A1:=R mod A[I];
  A2:=B mod A[I];
  Inc(Q,Abs(A1-A2));
  R:=R div A[I];
  B:=B div A[I];
  if Q>1 then Exit;
 end;
 if Q=1 then Rebro:=True;
end;

procedure Mover(R,B: integer);
var A1,A2,I,Q: integer;
begin
 Dec(R);
 Dec(B);
 for I:=1 to N do
 begin
  A1:=R mod A[I];
  A2:=B mod A[I];
  if Abs(A1-A2)=1 then
  begin
   Write(F,I,' ');
   if A1>A2 then Writeln(F,'+') else Writeln(F,'-');
   Exit;
  end;
  R:=R div A[I];
  B:=B div A[I];
 end;
end;

procedure MakeSequence(P: integer);
var I,J,L,R: integer;
begin
 if P-1=N then
 begin
  Inc(DD);
  if DD>10000 then
  begin
   Assign(F,'output.txt');
   Rewrite(F);
   Writeln(F,'No');
   Close(F);
   Halt(0);
  end;
  D[DD]:=GetCombineNumber(C);
  Exit;
 end;
 if C[P]=1 then
 for I:=1 to A[P] do
 begin
  C[P]:=I;
  MakeSequence(P+1);
 end else
 for I:=A[P] downto 1 do
 begin
  C[P]:=I;
  MakeSequence(P+1);
 end;
end;

begin
 Assign(F,'tele.in');
 Reset(F);
 Readln(F,N);
 for I:=1 to N do Read(F,A[I]);
 for I:=1 to N do Read(F,C[I]);
 Close(F);
 L:=1;
 for I:=1 to N do L:=L*A[I];
 if Odd(L) then
 begin
  Assign(F,'tele.out');
  Rewrite(F);
  Writeln(F,'No');
  Close(F);
  Halt(0);
 end;
 Source:=GetCombineNumber(C);
 DD:=0;
 for I:=1 to N do C[I]:=1;
 MakeSequence(1);
 L:=TotalCombines;
 if not Rebro(D[1],D[L]) then
 begin
  Assign(F,'tele.out');
  Rewrite(F);
  Writeln(F,'No');
  Close(F);
  Halt(0);
 end;
 for I:=1 to L do if D[I]=Source then Break;
 Assign(F,'tele.out');
 Rewrite(F);
 Writeln(F,'Yes');
 repeat
  J:=I mod L+1;
  Mover(D[J],D[I]);
  I:=J;
 until D[I]=Source;
 Close(F);
end.
