var F: text;
I,J,K,KK,X,N: integer;
A,C,Path: array [1..1000] of integer;
Q: array [1..1001] of integer;
PL: integer;
B: array [1..10000,1..2] of integer;
BB: integer;
label 1,2;

procedure Add(A,C: integer);
var I: integer;
begin
 for I:=1 to BB do if (B[I,1]=A) and (B[I,2]=C) then Exit;
 Inc(BB);
 B[BB,1]:=A;
 B[BB,2]:=C;
end;

procedure Cannot;
begin
 Assign(F,'castle.out');
 Rewrite(F);
 Writeln(F,'No');
 Close(F);
 Halt(0);
end;

procedure SolveFor1;
var I: integer;
begin
 for I:=1 to BB do
 if B[I,1]=K then
 begin
  Assign(F,'castle.out');
  Rewrite(F);
  Writeln(F,'Yes');
  Writeln(F,1);
  Writeln(F,K,' ',B[I,2]);
  Close(F);
  Halt(0);
 end;
end;

procedure Swap(L,R: integer);
var X: integer;
begin
 X:=B[L,1];
 B[L,1]:=B[R,1];
 B[R,1]:=X;
 X:=B[L,2];
 B[L,2]:=B[R,2];
 B[R,2]:=X;
end;

procedure Sort(L,R: integer);
var I,J: integer;
begin
 X:=B[(L+R) div 2,1];
 I:=L;
 J:=R;
 repeat
  while B[I,1]<X do Inc(I);
  while B[J,1]>X do Dec(J);
  if I<=J then
  begin
   Swap(I,J);
   Inc(I);
   Dec(J);
  end;
 until I>J;
 if L<J then Sort(L,J);
 if I<R then Sort(I,R);
end;

procedure Optimize;
var I,J: integer;
begin
 J:=1;
 for I:=1 to N do
 begin
  Q[I]:=J;
  while (B[J,1]<=I) and (J<=BB) do Inc(J);
 end;
 Q[I+1]:=BB+1;
end;

function Rebro(F,T: integer): boolean;
var I,J: integer;
begin
 Rebro:=False;
 I:=Q[F];
 J:=Q[F+1]-Q[F];
 while J>0 do
 begin
  if B[I,2]=T then
  begin
   Rebro:=True;
   Exit;
  end;
  Inc(I);
  Dec(J);
 end;
end;

procedure DelRebro(F,T: integer);
var I,J: integer;
begin
 I:=Q[F];
 J:=Q[F+1]-Q[F];
 while J>0 do
 begin
  if B[I,2]=T then
  begin
   B[I,2]:=-B[I,2];
   Dec(A[B[I,1]]);
   Exit;
  end;
  Inc(I);
  Dec(J);
 end;
end;

procedure DelRebroCapital(F,T: integer);
var I,J: integer;
begin
 I:=Q[F];
 J:=Q[F+1]-Q[F];
 while J>0 do
 begin
  if B[I,2]=T then
  begin
   B[I,2]:=0;
   Dec(A[B[I,1]]);
   Exit;
  end;
  Inc(I);
  Dec(J);
 end;
end;

procedure RepairRebras;
var I: integer;
begin
 for I:=1 to BB do
 if B[I,2]<0 then
 begin
  B[I,2]:=-B[I,2];
  Inc(A[B[I,1]]);
 end;
end;

procedure AddToPath(N: integer);
begin
 Inc(PL);
 Path[PL]:=N;
 DelRebroCapital(Path[PL-1],N);
 DelRebroCapital(N,Path[PL-1]);
end;

function Moving(F,T: integer): boolean;
var I,J,Z: integer;
D: boolean;
begin
 FillChar(C,SizeOf(C),0);
 C[T]:=1;
 Z:=1;
 repeat
  D:=True;
  for I:=1 to N do
  if C[I]=Z then
  for J:=1 to N do
  if Rebro(I,J) then
  begin
   if C[J]=0 then
   begin
    C[J]:=Z+1;
    DelRebro(I,J);
    DelRebro(J,I);
    if J=F then Break;
    D:=False;
   end;
  end;
  Inc(Z);
 until D;
 RepairRebras;
 Moving:=False;
 if C[F]=0 then Exit;
 Moving:=True;
 Dec(Z);
 while Z>0 do
 begin
  for I:=1 to N do if (C[I]=Z) and Rebro(F,I) then
  begin
   F:=I;
   AddToPath(I);
   Break;
  end;
  Dec(Z);
 end;
end;

begin
 Assign(F,'castle.in');
 Reset(F);
 Readln(F,N);
 Readln(F,K);
 BB:=0;
 for I:=1 to N do
 begin
  repeat
   Read(F,J);
   if J=0 then Break;
   Add(I,J);
   Add(J,I);
  until False;
 end;
 Close(F);
 FillChar(A,SizeOf(A),0);
 for I:=1 to BB do Inc(A[B[I,1]]);
 for I:=1 to N do if Odd(A[I]) and (I<>K) then goto 1;
 Cannot;
1: if A[K]=0 then Cannot;
 if A[K]=1 then SolveFor1;
 PL:=1;
 Path[1]:=K;
 Sort(1,BB);
 Optimize;
 KK:=K;
 repeat
  for I:=1 to N do if (I<>KK) and (I<>K) and Odd(A[I]) then if Moving(K,I) then
  begin
   K:=I;
   goto 2;
  end;
  Cannot;
2: if (A[KK]=0) or (A[K]=0) then
  begin
   Assign(F,'castle.out');
   Rewrite(F);
   Writeln(F,'Yes');
   Writeln(F,PL-1);
   for I:=1 to PL do
   begin
    Write(F,Path[I]);
    if I=PL then Writeln(F) else Write(F,' ');
   end;
   Close(F);
   Break;
  end;
 until False;
end.