{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
var
  n, nm, st: longint;
  p, s: array [1..1100] of longint;
  mv: array [1..21000] of integer;
  ok: boolean;

procedure ReadAll;
var  i: integer;
begin
  Assign(Input, 'tele.in'); Reset(Input);

  Read(n);
  for i := 1 to n do Read(p[i]);
  for i := 1 to n do Read(s[i]);

  Close(Input);
end;

var
  c, d: array [1..1100] of integer;
  ev: integer;
  nb: integer;
  bn: array [1..1100] of integer;

procedure ck(x: boolean);
var  i: integer;
begin
  if (st>0) then exit;
  for i := 1 to nb do if (c[bn[i]] <> s[bn[i]]) then exit;
  st := nm+1;
end;

procedure Grey(skip: integer);
var
  i: integer;
  t: longint;
  dn: boolean;
begin
  ck(false);
  repeat
    i := 1;
    while (i=ev) or (p[i]=1) do begin
      inc(i);
      if (i>n) then exit;
    end;
    dn := false;
    repeat
      t := c[i] + d[i];
      if ((t>=1) and (t<=p[i])) then begin
        c[i] := t;
        dn := true; ck(true);
        if (skip<1) then begin
          inc(nm);
          mv[nm] := i*d[i];
          ck(false);
        end else dec(skip);
      end else begin
        d[i] := -d[i]; inc(i);
        if (i>n) then exit;
        while (i=ev) or (p[i]=1) do begin
         inc(i);
         if (i>n) then exit;
        end;
      end;
    until dn;
  until false;
end;

procedure Solve;
var
  i: integer;
  cn: longint;
begin
  cn := 1;
  for i := 1 to n do cn := cn*p[i];
  nb := 0;
  for i := 1 to n do if (p[i]>1) then begin
    inc(nb);
    bn[nb] := i;
  end;
  ok := false;
  if (cn<2) then begin
    nm := 0; ok := true; exit
  end;

  ev := 0;
  for i := 1 to n do if (not odd(p[i])) then ev := i;

  if (ev<1) then exit;
  cn := 1;
  for i := 1 to n do if (i<>ev) then cn := cn*p[i];

  if (cn<2) then exit;

  nm := 0;
  for i := 1 to n do begin
    c[i] := 1; d[i] := 1;
  end;

  st := 0;
  ck(false);
  Grey(0); {Max}
  for i := 1 to ((p[ev] div 2) - 1) do begin
    inc(c[ev]);
    inc(nm); mv[nm] := ev;
    ck(false);
    Grey(0); dec(nm); {=> 1+1}
    inc(c[ev]);
    inc(nm); mv[nm] := ev;
    ck(false);
    Grey(1); {=> Max}
  end;
  inc(c[ev]);
  inc(nm); mv[nm] := ev;
  Grey(0); {=> 1}
  while (c[ev] > 1) do begin
    dec(c[ev]);
    inc(nm); mv[nm] := -ev;
    ck(false);
  end;

  if (st > nm) then st := st - nm;

  if (st>0) then ok := true;
end;

procedure Out;
var
  i: integer;
  z: char;
begin
  Assign(Output, 'tele.out'); ReWrite(Output);

  if ok then begin
    WriteLn('Yes');
    if (nm > 0) then begin
      i := st;
      repeat
        if (mv[i]>0) then z := '+' else z := '-';
        WriteLn(abs(mv[i]):1, ' ', z);
        i := (i mod nm) + 1;
      until (i = st);
    end;
  end else WriteLn('No');

  Close(Output);
end;

begin
  ReadAll;
  Solve;
  Out;
end.
