{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 61440,0,655360}
var
  n, k, pl, nt, ps: integer;
  t, pt: array [1..11000] of integer;
  av: array [1..11000] of boolean;
  st: array [1..1100] of integer;

procedure ReadAll;
var
  i, x: integer;
  kk: boolean;
begin
  Assign(Input, 'castle.in'); Reset(Input);

  Read(n, k);
  nt := 0;
  for i := 1 to n do begin
    st[i] := nt+1; kk := false;
    repeat
      Read(x);
      if (x=k) then kk := true else begin
        inc(nt);
        t[nt] := x;
      end;
    until (x=0);
    if kk then begin
      t[nt] := t[st[i]];
      t[st[i]] := k;
      inc(nt); t[nt] := 0;
    end;
  end;

  Close(Input);
end;

procedure Out;
var i: integer;
begin
  Assign(Output, 'castle.out'); ReWrite(Output);

  if (ps>=1) and (pl>=1) and (pt[ps] <> k) and (pt[pl] = k) then begin
    WriteLn('Yes');
    for i := pl downto ps do begin
      if (i < pl) then Write(' ');
      Write(pt[i]:1);
    end;
    WriteLn;
  end else WriteLn('No');

  Close(Output);
end;

procedure deledg(a, b: integer);
var  x: integer;
begin
  x := st[a];
  while (t[x] > 0) do begin
    if (t[x] = b) then begin
      av[x] := false;
      exit;
    end;
    inc(x);
  end;
end;

procedure walk(v: integer);
var  x: integer;
begin
  x := st[v];
  while (t[x] > 0) do begin
    if (av[x]) then begin
      av[x] := false;
      deledg(t[x], v);
      walk(t[x]);
    end;
    inc(x);
  end;

  inc(pl);
  pt[pl] := v;
end;

function edg(a, b: integer): boolean;
var  x: integer;
begin
  edg := true;
  x := st[a];
  while (t[x] > 0) do begin
    if (av[x]) and (t[x] = b) then begin
      av[x] := false;
      deledg(b, a);
      exit;
    end;
    inc(x);
  end;
  edg := false;
end;

procedure Solve;
begin
  pl := 0;
  fillchar(av, sizeof(av), 1);
  walk(k);

  ps := pl;
  while (pl>1) do begin
    fillchar(av, sizeof(av), 1);
    while ((ps>1) and (edg(pt[ps-1], pt[ps]))) do dec(ps);
    if (pt[ps] <> k) then exit;
    if (pl = ps) then exit;
    pl := ps;
  end;
end;

begin
  ReadAll;
  Solve;
  Out;
end.
