{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
const
    InFile='class.in';
    OutFile='class.out';
    max=80;

type
    TStep=array[0..max*3+1]of integer;

var
    n,kr,FirstRub,Start,BestStart,b,nk:integer;
    maximum:longint;
    pole:array[1..max,1..3]of byte;
    was:array[1..max,1..3]of boolean;
    Step,Best:TStep;
    Timer:longint absolute $40:$6C;
    TimeBreak:longint;

procedure ReadData;
var
    f:text;
    i,j,rub:integer;
begin
    assign(f,InFile);
    reset(f);
    readln(f,n);
    kr:=0;
    FirstRub:=n;
    for j:=1 to 3 do
        for i:=1 to n do begin
            read(f,rub);
            if rub=0 then pole[i,j]:=0
             else begin
                pole[i,j]:=1;
                inc(kr);
                if FirstRub>i then FirstRub:=i;
            end;
        end;
    close(f);
end;

procedure Result;
var
    f:text;
    i:integer;
begin
    assign(f,OutFile);
    rewrite(f);
    writeln(f,BestStart);
    for i:=1 to Best[0] do begin
        if Best[i]=1 then write(f,'U');
        if Best[i]=2 then write(f,'D');
        if Best[i]=3 then write(f,'L');
        if Best[i]=4 then write(f,'R');
    end;
    close(f);
end;

function Money:longint;
var
    x,y,i:integer;
    m:longint;
begin
    y:=Start;
    x:=1;
    m:=pole[x,y];
    for i:=1 to Step[0] do begin
        if Step[i]=1 then dec(y);
        if Step[i]=2 then inc(y);
        if Step[i]=3 then dec(x);
        if Step[i]=4 then inc(x);
        m:=m*2+pole[x,y];
    end;
    Money:=m;
end;

procedure Proverka;
var
    m:longint;
begin
    m:=Money;
    if ((m=maximum)and(Best[0]>Step[0]))or(m>maximum) then begin
        maximum:=m;
        Best:=Step;
        BestStart:=Start;
        Result;
    end;
end;

procedure Gen(x,y:byte);
begin
    if TimeBreak<Timer then halt;
    if was[x,y] then exit;
    was[x,y]:=true;
    if x=n then Proverka;
    inc(Step[0]);
    inc(Step[nk]);
    Step[Step[0]]:=1;
    if y>1 then Gen(x,y-1);
    Step[Step[0]]:=2;
    if y<3 then Gen(x,y+1);
    Step[Step[0]]:=3;
    if (not((was[x,1])and(was[x,2])and(was[x,3])))and(x>1)and(y=2) then Gen(x-1,y);
    Step[Step[0]]:=4;
    if x<n then Gen(x+1,y);
    dec(Step[nk]);
    dec(Step[0]);
    was[x,y]:=false;
end;

procedure Solve;
var
    i,j:integer;
    ud:boolean;
    m:longint;
begin
    maximum:=0;
    if kr=0 then begin
        BestStart:=1;
        Best[0]:=n-1;
        for i:=1 to Best[0] do Best[i]:=4;
        exit;
    end;
    Step[0]:=n*3-1;
    {1}
    ud:=false;
    Start:=1;
    for i:=1 to Step[0] do begin
        if (i mod 3)=0 then begin
            Step[i]:=4;
            ud:=not(ud);
        end
         else begin
            if ud then Step[i]:=1
             else Step[i]:=2;
        end;
    end;
    Proverka;
    {2}
    ud:=true;
    Start:=3;
    for i:=1 to Step[0] do begin
        if (i mod 3)=0 then begin
            Step[i]:=4;
            ud:=not(ud);
        end
         else begin
            if ud then Step[i]:=1
             else Step[i]:=2;
        end;
    end;
    Proverka;
    {3}
    Start:=1;
    for i:=1 to (n-1) do Step[i]:=4;
    Step[n]:=2;
    for i:=1 to (n-1) do Step[i+n]:=3;
    Step[2*n]:=2;
    for i:=1 to (n-1) do Step[i+2*n]:=4;
    Proverka;
    {4}
    Start:=3;
    for i:=1 to (n-1) do Step[i]:=4;
    Step[n]:=1;
    for i:=1 to (n-1) do Step[i+n]:=3;
    Step[2*n]:=1;
    for i:=1 to (n-1) do Step[i+2*n]:=4;
    Proverka;
    {---}
    Step[0]:=FirstRub-1;
    for i:=1 to Step[0] do Step[i]:=4;
    for i:=1 to n do
        for j:=1 to 3 do was[i,j]:=false;
        nk:=3*n+1;
        Step[nk]:=0;
    {5}
    Start:=1;
    for i:=1 to Step[0] do was[i,Start]:=true;
    Gen(FirstRub,Start);
    for i:=1 to Step[0] do was[i,Start]:=false;
    {6}
    Start:=3;
    for i:=1 to Step[0] do was[i,Start]:=true;
    Gen(FirstRub,Start);
    for i:=1 to Step[0] do was[i,Start]:=false;
    {7}
    if FirstRub=1 then begin
        Start:=2;
        Gen(1,2);
    end;
end;

begin
    TimeBreak:=Timer+round(18.2*5-4);
    ReadData;
    Solve;
    Result;
end.