const inp='fire.in';out='fire.out';
      NMax=100;
{---Types(global)------------}
type TOtr=record
 b,e:real;
end;

type TLine=record
 xb,yb:real;
 xe,ye:real;
end;

{-----Variables(global)----------}
var fin,
    fout:Text;
    L,N,i,j:Integer;
    t:real;
    A:array[1..NMax]of TLine;
    otrxb,otrxe,otryb,otrye:array[1..2*NMax] of TOtr;
    nxb,nxe,nyb,nye:integer;
{--------Manipulating with otr-------}
{Adding an otrezok}
procedure AddXb(b,e:real);
begin
 nxb:=nxb+1;if b>e then
    begin otrxb[nxb].b:=e;otrxb[nxb].e:=b;end else
    begin otrxb[nxb].b:=b;otrxb[nxb].e:=e;end;
end;
procedure AddYb(b,e:real);
begin
 nyb:=nyb+1;if b>e then
    begin otryb[nyb].b:=e;otryb[nyb].e:=b;end else
    begin otryb[nyb].b:=b;otryb[nyb].e:=e;end;
end;
procedure AddXe(b,e:real);
begin
 nxe:=nxe+1;if b>e then
    begin otrxe[nxe].b:=e;otrxe[nxe].e:=b;end else
    begin otrxe[nxe].b:=b;otrxe[nxe].e:=e;end;
end;
procedure AddYe(b,e:real);
begin
 nye:=nye+1;if b>e then
    begin otrye[nye].b:=e;otrye[nye].e:=b;end else
    begin otrye[nye].b:=b;otrye[nye].e:=e;end;
end;
{Deleting an otrezok}
procedure DelXB(N:integer);
var i:integer;
begin if N<nxb then for i:=N to nxb do begin otrxb[i].b:=otrxb[i+1].b;otrxb[i].e:=otrxb[i+1].e;end;nxb:=nxb-1;end;
procedure DelXE(N:integer);
var i:integer;
begin if N<nxe then for i:=N to nxe do begin otrxe[i].b:=otrxe[i+1].b;otrxe[i].e:=otrxe[i+1].e;end;nxe:=nxe-1;end;
procedure DelYB(N:integer);
var i:integer;
begin if N<nyb then for i:=N to nyb do begin otryb[i].b:=otryb[i+1].b;otryb[i].e:=otryb[i+1].e;end;nyb:=nyb-1;end;
procedure DelYE(N:integer);
var i:integer;
begin if N<nye then for i:=N to nye do begin otrye[i].b:=otrye[i+1].b;otrye[i].e:=otrye[i+1].e;end;nye:=nye-1;end;
{---------------}
procedure Swap(var A,B:real);
var c:real;
begin
 C:=A;A:=B;B:=C;
end;
{===========================================================================}
procedure DoLineInterception(N:integer);
var tga:real;
    xlb,xrb,ylb,yrb,
    xle,xre,yle,yre,
    x1b,x2b,y1b,y2b,
    x1e,x2e,y1e,y2e,
    xb,xe,yb,ye,
    ac,bc,cc:real;
begin
 tga:=(A[N].ye-A[n].yb)/(A[n].xe-A[n].xb);

 x1b:=A[n].xb-50*sqrt((1+1/sqr(tga)));
 y1b:=A[n].yb+50*sqrt((1+sqr(tga)));
 x1e:=A[n].xe-50*sqrt((1+1/sqr(tga)));
 y1e:=A[n].ye-50*sqrt((1+sqr(tga)));

 x2b:=A[n].xb+50*sqrt((1+1/sqr(tga)));
 y2b:=A[n].yb-50*sqrt((1+sqr(tga)));
 x2e:=A[n].xe+50*sqrt((1+1/sqr(tga)));
 y2e:=A[n].ye+50*sqrt((1+sqr(tga)));

 Ac:=y1e-y1b;
 Bc:=x1b-x2e;
 Cc:=x1e*y1b-x1b*y1e;
 ylb:=-Cc/Bc;
 xlb:=-Cc/Ac;
 xle:=-(Ac*L+Cc)/Bc;
 yle:=-(Bc*L+Cc)/Ac;

 Ac:=y2e-y2b;
 Bc:=x2b-x2e;
 Cc:=x2e*y2b-x2b*y2e;
 yrb:=-Cc/Bc;
 xrb:=-Cc/Ac;
 xre:=-(Ac*L+Cc)/Bc;
 yre:=-(Bc*L+Cc)/Ac;

 if xlb>xrb then Swap(xlb,xrb);
 if ylb>yrb then Swap(ylb,yrb);
 if xle>xre then Swap(xle,xre);
 if yle>yre then Swap(yle,yre);


     if nxb>=1 then
     for i:=1 to nxb do
      if (xlb>otrxb[i].b)and(xrb<otrxb[i].e)then
         begin
          xb:=otrxb[i].b;xe:=otrxb[i].e;DelXb(i);
          AddXb(xb,xlb);Addxb(xrb,xe);
         end else
      if (xlb<=otrxb[i].b)and(xrb>=otrxb[i].e)then
         begin
          DelXb(i);
         end else
      if (xlb>otrxb[i].b)and(xrb>=otrxb[i].e)and(xlb<otrxb[i].e)then
         begin
          xb:=otrxb[i].b;DelXb(i);AddXb(xb,xlb);
         end else
      if (xlb<=otrxb[i].b)and(xrb<otrxb[i].e)and(xrb>otrxb[i].b)then
         begin
          xe:=otrxb[i].e;DelXb(i);AddXb(xrb,xe);
         end;

     if nxe>=1 then
     for i:=1 to nxe do
      if (xle>otrxe[i].b)and(xrb<otrxe[i].e)then
         begin
          xb:=otrxe[i].b;xe:=otrxe[i].e;DelXe(i);
          AddXe(xb,xle);Addxe(xre,xe);
         end else
      if (xle<=otrxe[i].b)and(xre>=otrxe[i].e)then
         begin
          DelXe(i);
         end else
      if (xle>otrxe[i].b)and(xre>=otrxe[i].e)and(xle<otrxe[i].e)then
         begin
          xb:=otrxe[i].b;DelXe(i);AddXe(xb,xle);
         end else
      if (xle<=otrxe[i].b)and(xre<otrxe[i].e)and(xre>otrxe[i].b)then
         begin
          xe:=otrxe[i].e;DelXe(i);AddXe(xrb,xe);
         end;

     if nyb>=1 then
     for i:=1 to nyb do
      if (ylb>otryb[i].b)and(yrb<otryb[i].e)then
         begin
          yb:=otryb[i].b;ye:=otryb[i].e;Delyb(i);
          Addyb(yb,ylb);Addyb(yrb,ye);
         end else
      if (ylb<=otryb[i].b)and(yrb>=otryb[i].e)then
         begin
          Delyb(i);
         end else
      if (ylb>otryb[i].b)and(yrb>=otryb[i].e)and(ylb<otryb[i].e)then
         begin
          yb:=otryb[i].b;Delyb(i);Addyb(yb,ylb);
         end else
      if (ylb<=otryb[i].b)and(yrb<otryb[i].e)and(yrb>otryb[i].b)then
         begin
          ye:=otryb[i].e;Delyb(i);Addyb(yrb,ye);
         end;

     if nye>=1 then
     for i:=1 to nye do
      if (yle>otrye[i].b)and(yrb<otrye[i].e)then
         begin
          yb:=otrye[i].b;ye:=otrye[i].e;Delye(i);
          Addye(yb,yle);Addye(yre,ye);
         end else
      if (yle<=otrye[i].b)and(yre>=otrye[i].e)then
         begin
          Delye(i);
         end else
      if (yle>otrye[i].b)and(yre>=otrye[i].e)and(yle<otrye[i].e)then
         begin
          yb:=otrye[i].b;Delye(i);Addye(yb,yle);
         end else
      if (yle<=otrye[i].b)and(yre<otrye[i].e)and(yre>otrye[i].b)then
         begin
          ye:=otrye[i].e;Delye(i);Addye(yrb,ye);
         end;


end;


{===========================================================================}
procedure DoIt(N:integer);
var i:integer;
    xb,xe,yb,ye:real;
begin
 if (A[N].xb=A[n].xe)then
    {Vertical Interception}
    begin
     if A[n].xb+50>L then nye:=0;
     if A[n].xb-50<0 then nyb:=0;
     if nxb>=1 then
     for i:=1 to nxb do
      if (A[n].xb-50>otrxb[i].b)and(A[n].xb+50<otrxb[i].e)then
         begin
          xb:=otrxb[i].b;xe:=otrxb[i].e;DelXb(i);
          AddXb(xb,A[n].xb-50);Addxb(A[n].xb+50,xe);
         end else
      if (A[n].xb-50<=otrxb[i].b)and(a[n].xb+50>=otrxb[i].e)then
         begin
          DelXb(i);
         end else
      if (A[n].xb-50>otrxb[i].b)and(A[n].xb+50>=otrxb[i].e)and(A[n].xb-50<otrxb[i].e)then
         begin
          xb:=otrxb[i].b;DelXb(i);AddXb(xb,A[n].xb-50);
         end else
      if (A[n].xb-50<=otrxb[i].b)and(A[n].xb+50<otrxb[i].e)and(A[n].xb+50>otrxb[i].b)then
         begin
          xe:=otrxb[i].e;DelXb(i);AddXb(A[n].xb+50,xe);
         end;
     if nxe>=1 then
     for i:=1 to nxe do
      if (A[n].xb-50>otrxe[i].b)and(A[n].xb+50<otrxe[i].e)then
         begin
          xb:=otrxe[i].b;xe:=otrxe[i].e;DelXe(i);
          AddXe(xb,A[n].xb-50);Addxe(A[n].xb+50,xe);
         end else
      if (A[n].xb-50<=otrxe[i].b)and(a[n].xb+50>=otrxe[i].e)then
         begin
          DelXe(i);
         end else
      if (A[n].xb-50>otrxe[i].b)and(A[n].xb+50>=otrxe[i].e)and(A[n].xb-50<otrxe[i].e)then
         begin
          xb:=otrxe[i].b;DelXe(i);AddXe(xb,A[n].xb-50);
         end else
      if (A[n].xb-50<=otrxe[i].b)and(A[n].xb+50<otrxe[i].e)and(A[n].xb+50>otrxe[i].b)then
         begin
          xe:=otrxe[i].e;DelXe(i);AddXe(A[n].xb+50,xe);
         end;
    end else
 if (A[N].yb=A[n].ye)then
    {Horizontal Interception}
    begin
     if A[n].yb+50>L then nxe:=0;
     if A[n].yb-50<0 then nxb:=0;
     if nyb>=1 then
     for i:=1 to nyb do
      if (A[n].yb-50>otryb[i].b)and(A[n].yb+50<otryb[i].e)then
         begin
          yb:=otryb[i].b;ye:=otryb[i].e;Delyb(i);
          Addyb(yb,A[n].yb-50);Addyb(A[n].yb+50,ye);
         end else
      if (A[n].yb-50<=otryb[i].b)and(a[n].yb+50>=otryb[i].e)then
         begin
          Delyb(i);
         end else
      if (A[n].yb-50>otryb[i].b)and(A[n].yb+50>=otryb[i].e)and(A[n].yb-50<otryb[i].e)then
         begin
          yb:=otryb[i].b;Delyb(i);Addyb(xb,A[n].yb-50);
         end else
      if (A[n].yb-50<=otryb[i].b)and(A[n].yb+50<otryb[i].e)and(A[n].yb+50>otryb[i].b)then
         begin
          ye:=otryb[i].e;Delyb(i);Addyb(A[n].yb+50,ye);
         end;
     if nye>=1 then
     for i:=1 to nye do
      if (A[n].yb-50>otrye[i].b)and(A[n].yb+50<otrye[i].e)then
         begin
          yb:=otrye[i].b;ye:=otrye[i].e;Delye(i);
          Addye(yb,A[n].yb-50);Addye(A[n].yb+50,ye);
         end else
      if (A[n].yb-50<=otrye[i].b)and(a[n].yb+50>=otrye[i].e)then
         begin
          Delye(i);
         end else
      if (A[n].yb-50>otrye[i].b)and(A[n].yb+50>=otrye[i].e)and(A[n].yb-50<otrye[i].e)then
         begin
          yb:=otrye[i].b;Delye(i);Addye(yb,A[n].yb-50);
         end else
      if (A[n].yb-50<=otrye[i].b)and(A[n].yb+50<otrye[i].e)and(A[n].yb+50>otrye[i].b)then
         begin
          ye:=otrye[i].e;Delye(i);Addye(A[n].yb+50,ye);
         end;
    end else
    {Line Interception}
    begin
     DoLineInterception(N);
    end;
end;

begin
{----Reading from file-----------}
assign(fin,inp);
reset(fin);
Read(fin,L);
Read(fin,N);
for i:=1 to N do
    begin
    Read(fin,A[i].xb,
             A[i].yb,
             A[i].xe,
             A[i].ye);
    if A[i].xb>A[i].xe then
       begin
        t:=A[i].xb;A[i].xb:=A[i].xe;A[i].xe:=t;
        t:=A[i].yb;A[i].yb:=A[i].ye;A[i].ye:=t;
       end;
    if A[i].yb>A[i].ye then
       begin
        t:=A[i].xb;A[i].xb:=A[i].xe;A[i].xe:=t;
        t:=A[i].yb;A[i].yb:=A[i].ye;A[i].ye:=t;
       end;
    end;
close(fin);
{------Inittialize---------}
nxb:=1;nxe:=1;nyb:=1;nye:=1;
otrxb[1].b:=0;otrxb[1].e:=L;
otrxe[1].b:=0;otrxe[1].e:=L;
otryb[1].b:=0;otryb[1].e:=L;
otrye[1].b:=0;otrye[1].e:=L;
{------Main work---------}
for i:=1 to N do
    DoIt(i);
{-----Output results----------}
assign(fout,out);
rewrite(fout);
if (nxb=0)and(nxe=0)and(nye=0)and(nyb=0)then
    Writeln(fout,'OK')
   else
   begin
    if nxb>0 then Writeln(fout,otrxb[1].b+(otrxb[1].e-otrxb[1].b)/2:0:3,' ',0) else
    if nxe>0 then Writeln(fout,otrxe[1].b+(otrxe[1].e-otrxe[1].b)/2:0:3,' ',L) else
    if nyb>0 then Writeln(fout,0,' ',otryb[1].b+(otryb[1].e-otryb[1].b)/2:0:3) else
    if nye>0 then Writeln(fout,L,' ',otrye[1].b+(otrye[1].e-otrye[1].b)/2:0:3) else

   end;
close(fout);
{---------------}
end.