Program P0412_5;
Type
Ways = Array [1 .. 1000] of Integer;
Var
FIn, FOut: Text;
N, K, a, b, DoorsCount, RoomDoorsCount, Length, BegD, EndRoom, MinRoomDoors: Integer;
Doors: Array [1 .. 10000, 1 .. 2] of Integer;
DoorsClosed: Array [1 .. 10000] of Boolean;
RoomDoors: Array [1 .. 1000] of Integer;
c: Char;
Answer, AnswerFound, BFound: Boolean;
Way: Ways;
WayFound: Boolean;
Procedure FindWay (Beg, En, WayPoint: Integer;var Way: Ways;var WayLength: Integer);
Var
a, b: Integer;
Begin
  For a := 1 to DoorsCount do
    If (Doors [a, 1] = Beg) and (Doors [a, 2] = En) and DoorsClosed [a] then Begin
      WayFound := True;
      For b := 1 to DoorsCount do
        If (Doors [a, 1] = Doors [b, 2]) and (Doors [a, 2] = Doors [b, 1]) then Begin
          DoorsClosed [b] := False;
          Break;
        End;
      DoorsClosed [a] := False;
      WayLength := WayPoint;
      Way [WayPoint] := Doors [a, 2];
      Break;
    End;
  If not WayFound then Begin
    For a := 1 to DoorsCount do
     If (Doors [a, 1] = Beg) and DoorsClosed [a] then Begin
        For b := 1 to DoorsCount do
          If (Doors [a, 1] = Doors [b, 2]) and (Doors [a, 2] = Doors [b, 1]) then Begin
            DoorsClosed [b] := False;
            Break;
          End;
        DoorsClosed [a] := False;
        Way [WayPoint] := Doors [a, 2];
        WayPoint := WayPoint + 1;
        FindWay (Doors [a, 2], En, WayPoint, Way, WayLength);
        For b := 1 to DoorsCount do
          If (Doors [a, 1] = Doors [b, 2]) and (Doors [a, 2] = Doors [b, 1]) then Begin
            DoorsClosed [b] := True;
            Break;
          End;
        If not WayFound then Begin
          DoorsClosed [a] := True;
          Way [WayPoint] := 0;
          WayPoint := WayPoint - 1;
        End;
      End;
  End;
End;

Begin
  WayFound := False;
  MinRoomDoors := 5001;
  FillChar (DoorsClosed, Sizeof (DoorsClosed), 1);
  Assign (FIn, 'Castle.in');
  Reset (FIn);
  Readln (FIn, N);
  Readln (FIn, K);
  DoorsCount := 1;
  a := 1;
  Answer := False;
  While not (Eof (FIn)) do Begin
    Read (FIn, b);
    Read (FIn, c);
    If b > 0 then Begin
      Doors [DoorsCount, 1] := a;
      Doors [DoorsCount, 2] := b;
      DoorsCount := DoorsCount + 1;
      RoomDoorsCount := RoomDoorsCount + 1;
    End
    Else Begin
      Read (FIn, c);
      RoomDoors [a] := RoomDoorsCount;
      If (RoomDoorsCount mod 2 = 1) and (K <> a) and (RoomDoorsCount < MinRoomDoors) then Begin
        Answer := True;
        EndRoom := a;
        MinRoomDoors := RoomDoorsCount;
      End;
      RoomDoorsCount := 0;
      a := a + 1;
    End;
  End;
  Close (FIn);
  DoorsCount := DoorsCount - 1;
  If Answer then Begin
    Way [1] := K;
    FindWay (K, EndRoom, 2, Way, Length);
    Repeat
      WayFound := False;
      BFound := False;
      For b := 1 to DoorsCount do
        If (Doors [b, 1] = Way [Length]) and DoorsClosed [b] then Begin
          BFound := True;
          BegD := Doors [b, 2];
          Break;
        End;
      If not BFound then AnswerFound := True
      Else Begin
        Way [Length + 1] := BegD;
        For b := 1 to DoorsCount do
          If ((Doors [b, 1] = Way [Length]) and (Doors [b,2] = BegD)) or ((Doors [b, 2] = Way [Length]) and
            (Doors [b,1] = BegD)) then
            DoorsClosed [b] := False;
        Length := Length + 2;
        FindWay (BegD, EndRoom, Length, Way, Length);
      End;
    Until AnswerFound;
  End;
  Assign (FOut, 'Castle.out');
  Rewrite (FOut);
  If not (Answer) then Writeln (FOut, 'No')
  Else Begin
    Writeln (FOut, 'Yes');
    Writeln (FOut, Length - 1);
    For a := 1 to Length do
      Write (FOut, Way [a], ' ');
  End;
  Close (FOut);
End.