{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
program P0606_2;
{Written by 0606}
const
IName = 'org.in';
OName = 'org.out';
Nmax = 10000;
type
PVertex = ^TVertex;
PListVertex = ^TListVertex;
TListVertex = record
  a:PVertex;
  Next:PListVertex;
end;

TVertex = record
  a,f:integer;
  num:integer;
  c:PlistVertex;
  end;
var
K,N:integer;
A:array[1..Nmax] of integer;
B:array[1..NMax] of PVertex;
Root:PVertex;
procedure Input;
var f:text;
i:integer;
begin
 assign(f,IName);
 reset(f);
 readln(f,K);
 readln(f,N);
 A[1]:=0;
 for i:=2 to N do begin
   read(f,A[i]);
 end;
 close(f);
end;
procedure PrintIt(A:PVertex;var f:text);
var c:PListVertex;
begin
  if A^.f=0 then begin
    write(f,A^.num,' ');
  end;
  c:=A^.c;
  while c<>nil do begin
    PrintIt(c^.a,f);
    c:=C^.Next;
  end;
end;
procedure Print;
var f:text;i:integer;
begin
  assign(f,OName);
  rewrite(f);
  writeln(f,Root^.a);
{  PrintIt(Root,f);}
  for i:=1 to N do begin
    if B[i]^.f=0 then write(f,i,' ');
  end;
  close(f);
end;
procedure Done(A:PVertex);
var c,d:PListVertex;
begin
  if a=nil then exit;
  c:=A^.C;
  while c<>nil do begin
    Done(C^.a);
    d:=c^.next;
    dispose(c);
    c:=d;
  end;
{  writeln(A^.Num);}
  Dispose(A);
end;
procedure addto(b1,b2:integer);
var d:PListVertex;
begin
  if B[b1]^.c=nil then begin
    New(B[b1]^.c);
    B[b1]^.c^.a:=B[b2];
    B[b1]^.c^.Next:=nil;
    exit;
  end;
  New(B[b1]^.c^.Next);
  d:=B[b1]^.c^.Next;
  d^.Next:=nil;
  d^.a:=B[b2];
end;
procedure CalcOf(d:integer);
var sa,sf:integer;bb:PListVertex;
begin
  if B[d]^.c=nil then begin
    B[d]^.f:=1;
    B[d]^.a:=0;
    if K=1 then begin
      B[d]^.f:=0;
      B[d]^.a:=1;
    end;
  end else begin
    sa:=0;
    sf:=0;
    bb:=B[d]^.c;
    while bb<>nil do begin
      sa:=sa+bb^.a^.a;
      sf:=sf+bb^.a^.f;
      bb:=bb^.Next;
    end;
    if sf>=K-1 then begin
      B[d]^.a:=sa+1;
      B[d]^.f:=0;
    end else begin
      B[d]^.a:=sa;
      B[d]^.f:=sf+1;
    end;
  end;
end;
procedure CreateTree;
var i:integer;
begin
 for i:=1 to N do begin New(B[i]);B[i]^.num:=i;B[i]^.c:=nil;end;
 for i:=N downto 2 do begin
   AddTo(A[i],i);
 end;
 for i:=N downto 1 do begin
   CalcOf(i);
 end;
 if N>0 then Root:=B[1];
end;
procedure Solve;
begin
  CreateTree;
end;
begin
  Input;
  Solve;
  Print;
  Done(Root);
end.