#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>

typedef unsigned bool;
#define true (1)
#define false (0)

FILE *fin, *fout;

#define NMAX 1000
#define POSMAX 10000
unsigned N;
unsigned P[NMAX];
int pos[NMAX * 10], initpos[NMAX];
char waspos[POSMAX];
unsigned cwas = 0, maxwas;
long posid;
int moves[POSMAX];
unsigned cmoves = 0;

void out(const char *fmt, ...)
{
	va_list va;
    va_start(va, fmt);

    vfprintf(fout, fmt, va);
    //vprintf(fmt, va);

    va_end(va);
}

char *in()
{
	static char buf[10000];
    fgets(buf, 10000, fin);
    return buf;
}


#define SMAX 10000
int far stack[SMAX];
unsigned cstack = 0;
void push(int i, int st)
{
	stack[cstack++] = (i + 1) * st;
}
void pop(int &i, int &st)
{
    int v = stack[--cstack];
    i = (v > 0 ? v - 1 : -v - 1) ;
    st = (v > 0 ? 1 : -1);
}
inline bool stmore()
{
	return cstack > 0;
}


void run();

void main()
{
	fin = fopen("tele.in", "rt");
	fout = fopen("tele.out", "wr");

    run();

    fclose(fin);
    fclose(fout);
}


long fh(/*unsigned pos[]*/)
{
	long s = 0, m = 1;
    for( unsigned i = 0; i < N; ++i )
    {
    	s += m * pos[i];
        m *= P[i] + 1;
    }
    return s;
}

inline bool check(unsigned idx, unsigned p)
{
	return idx > 0 && idx <= P[p] && !waspos[posid];
}

inline void mark(bool v = true)
{
	waspos[posid] = v;
    if( v )
    	++cwas;
    else
    	--cwas;
}
bool isinit()
{
	for( unsigned i = 0; i < N; ++i )
    	if( pos[i] != initpos[i] )
        	return false;
    return true;
}

inline void outpos(unsigned p, int st)
{
	moves[cmoves++] = (p + 1) * st;
}

bool doPos1()
{
	int st = -1;
    int i = 0;
    while(1)
    {
cont:
	    while( i < N )
	    {
	    	while( st <= 1 )
	        {
	 	       	pos[i] += st;
    	        posid = fh();
        	    if( check( pos[i], i ) )
            	{
		            mark( true );
    	            if( cwas > maxwas )
        	        	return false;

            	   	if( isinit() )
            		{
						if( cwas == maxwas )
    	                {
        	                outpos( i, st );
            	            while( stmore() )
                	        {
                    	    	pop( i, st );
	                    	    outpos( i, st );
	                        }
    	                    return true;
        	            }
            	    }
                	else
					{
    	            	push( i, st );
        	            i = 0;
            	        st = -1;
                	    goto cont;
	                }
    	            posid = fh();
	    	        mark( false );
            	}
	            pos[i] -= st;
    	        st += 2;
        	}

	        //if( !stmore() ) break;

       		++i;
        }

    	if( !stmore() ) break;
	    pop( i, st );
	    i = 0;
	    st = -1;
    }

    return false;
}

bool doPos()
{
	int st;
    unsigned i;
    for( i = 0; i < N; ++i )
    	for( st = -1; st <= 1; st += 2 )
        {
        	pos[i] += st;
            posid = fh();
            if( check( pos[i], i ) )
            {
	            mark( true );
                if( cwas > maxwas )
                	return false;
               	if( isinit() )
            	{
					if( cwas == maxwas )
                    {
                        outpos( i, st );
                        return true;
                    }
                }
                else
				{
			   		if( doPos() )
                    {
	                   	outpos( i, st );
                        return true;
                    }
                }
                posid = fh();
	            mark( false );
            }
            pos[i] -= st;
        }

    return false;
}

void run()
{
	char *s;
    unsigned j, n;
    s = in();
    sscanf(s, "%u", &N);
    s = in();
    maxwas = 1;
    for( j = 0; j < N; ++j )
    {
  		sscanf(s, "%u%n", &P[j], &n);
        s += n;
        maxwas *= P[j];
    }
    s = in();
    for( j = 0; j < N; ++j )
    {
  		sscanf(s, "%u%n", &pos[j], &n);
        initpos[j] = pos[j];
        s += n;
    }

    bool f = doPos();

    if( f )
    {
    	out("Yes\n");
        int i;
        for( i = cmoves - 1; i >= 0; --i )
			if( moves[i] > 0 )
            	out( "%u +\n", moves[i] );
            else
            	out( "%u -\n", -moves[i] );
    }
    else
    	out("No\n");
}
