#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>
#include <string.h>

typedef unsigned bool;
const bool false = 0;
const bool true = 1;

FILE *fin, *fout;

#define MAXN 1000
unsigned N;
unsigned ti[MAXN];
unsigned pp[MAXN];
bool id[MAXN], co = 0;
long ti_sum;
unsigned mv;
unsigned maxst;
const MAXM = MAXN * 10;
unsigned far move[MAXM][3];
unsigned far best[MAXM][3];
unsigned cmove, cbest;

unsigned long cur_ti, best_ti = 0x7FFFFFFFl;



void out(const char *fmt, ...)
{
	va_list va;
    va_start(va, fmt);

    vfprintf(fout, fmt, va);
    vprintf(fmt, va);

    va_end(va);
}

char *in()
{
	static char buf[10000];
    fgets(buf, 10000, fin);
    return buf;
}

void run();

void main()
{
	fin = fopen("olymp.in", "rt");
	fout = fopen("olymp.out", "wt");

    run();

    fclose(fin);
    fclose(fout);
}

inline void swap(unsigned &a, unsigned &b)
{
	unsigned t = a;
    a = b;
    b = t;
}


void test_out()
{
	unsigned i;
    long cpy;
    for( i = 0; i < N; ++i )
	{
        if( id[i] )
        {
            if( cur_ti + ti[i] >= best_ti ) continue;
        	++co;
            move[cmove++][3] = i;
            cpy = cur_ti;
            cur_ti += ti[i];

            test_in();

            cur_ti = cpy;
            --co;
            --cmove;
        }
    }
}

void test_in()
{
	unsigned i, st;
    long cpy, cpy2;
    for( i = 0; i < N; ++i )
	{
        if( !id[i] )
        {
            if( cur_ti + ti[i] >= best_ti ) continue;
        	id[i] = true;
            --co;
            move[cmove][0] = i;
            cpy = cur_ti;
            cur_ti += ti[i];
	    	for( st = 1; st < N - i - 1; ++st )
    	    	if( !id[i + st] )
                {
		            if( cur_ti + ti[i+st] >= best_ti ) continue;
					id[i] = true;
                 	--co;
                    move[cmove][1] = i + st;
                    cpy2 = cur_ti;
                    cur_ti += ti[i+st];
                    if( co == 0 )
                    {
						if( cur_ti < best_ti )
                        {
                        	best_ti = cur_ti;
                            memcpy(best, move, sizeof(move));
                            cbest = cmove;
                        }
                    }
                    else
                    {
                        test_out();
                    }
                    cur_ti = cpy2;
                    ++co;
                }
            cur_ti = cpy;
            ++co;
        }
	}
}



void run()
{
	char *s;
    unsigned i, j;
    s = in();
    sscanf(s, "%u", &N);
    for( i = 0; i < N; ++i )
    {
	    s = in();
    	sscanf(s, "%u", &ti[i]);
		pp[i] = i;
    }


    /*
    for( i = N - 1; i > 1; --i )
    	for( j = 0; j < i; ++j )
        	if( ti[j] > ti[j+1] )
            {
            	swap( ti[j], ti[j+1] );
                swap( pp[j], pp[j+1] );
            }
    */

    for( i = 0; i < N; ++i )
    	ti_sum += ti[i];


    //mv = N / 2;
    //maxst = (mv > 20 ? mv / 5 : 10);

    co = N;
    cur_ti = 0;
    best_ti = ti_sum * 100;


    test_in();


    out("%li\n", best_ti);
    if( cbest > 1 )
	    for(i = 0; i < cbest-1; ++i)
    	   	out("%u %u %u\n", best[i][0], best[i][1], best[i][2]);
    else
    	i = 0;

   	out("%u %u\n", best[i][0], best[i][1]);

    out("\n");
}