{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Const
  eps = 1E-9;

Var
  Timer:LongInt absolute 0:$046C;
  BreakTime:LongInt;
  L:Word;
  I,J,N:Byte;
  Xb,Yb,Xe,Ye:Array[1..100]of Extended;
  X,Y:Extended;
  Yes:Boolean;
  OK:Boolean;
  St:Byte;
  CurX,CurY:LongInt;
  W:Extended;

Function equ(A,B:Extended):Boolean;
Begin
  If Abs(A-B)<Eps then equ:=True
  Else equ:=False;
end;

Procedure Init;
Begin
  Assign(Input,'fire.in');
  Reset(Input);
  ReadLn(L);
  ReadLn(N);
  Yes:=True;
  For I:=1 to N do Begin
    ReadLn(Xb[I],Yb[I],Xe[I],Ye[I]);
    If Yes then
      If not(equ(Xb[I],Xe[I])or equ(Yb[I],Ye[I]))then Yes:=False;
  End;
  Close(Input);
  OK:=True;
End;

Procedure Done;
Begin
  Assign(Output,'fire.out');
  ReWrite(Output);
  If OK then Write('OK')
  Else Write(X:0:3,' ',Y:0:3);
  Close(Output);
End;

Function PointIn:Boolean;
Var
  I:Byte;
  d:Extended;

Begin
  If Timer>=BreakTime then Begin
    Done;
    Halt;
  End;
  For I:=1 to N do Begin
    d:=Abs((Xe[I]-Xb[I])*(Y-Yb[I])-(X-Xb[I])*(Ye[I]-Yb[I]))/Sqrt(Sqr(Xe[I]-Xb[I])+Sqr(Ye[I]-Yb[I]));
    If d<=50 then Begin
      Pointin:=True;
      Exit;
    End;
  End;
  PointIn:=False;
End;

Procedure Run;
Var
  V:Array[1..100]of Byte;
  NV:Byte;
  Buf:Byte;

Begin
  {check points}
  X:=0;Y:=0;
  If Not PointIn then Begin
    OK:=False;
    Done;
    Halt;
  End;
  X:=0;Y:=L;
  If Not PointIn then Begin
    OK:=False;
    Done;
    Halt;
  End;
  X:=L;Y:=L;
  If Not PointIn then Begin
    OK:=False;
    Done;
    Halt;
  End;
  X:=L;Y:=0;
  If Not PointIn then Begin
    OK:=False;
    Done;
    Halt;
  End;
  X:=0;Y:=L/2;
  If Not PointIn then Begin
    OK:=False;
    Done;
    Halt;
  End;
  X:=L/2;Y:=L;
  If Not PointIn then Begin
    OK:=False;
    Done;
    Halt;
  End;
  X:=L;Y:=L/2;
  If Not PointIn then Begin
    OK:=False;
    Done;
    Halt;
  End;
  X:=L/2;Y:=0;
  If Not PointIn then Begin
    OK:=False;
    Done;
    Halt;
  End;

  {all parall}
  If Yes then Begin
    NV:=0;
    For I:=1 to N do
      If equ(Xb[I],Xe[I])then Begin
        Inc(NV);
        V[NV]:=I;
    End;
    If (NV>1)and(N-NV>1)then Begin
      For I:=1 to NV-1 do For J:=I+1 to NV do
        If Xb[V[I]]>Xb[V[J]] then Begin Buf:=V[I];V[I]:=V[J];V[J]:=Buf;End;
      Yes:=False;
      For I:=1 to NV-1 do If Xb[V[I+1]]-Xb[V[I]]>100 then Begin
        Yes:=True;
        Break;
      End;
      If Yes then Begin
        X:=(Xb[V[I+1]]+Xb[V[I]])/2;
        NV:=0;
        For I:=1 to N do
          If equ(Yb[I],Ye[I])then Begin
            Inc(NV);
            V[NV]:=I;
        End;
        For I:=1 to NV-1 do For J:=I+1 to NV do
          If Yb[V[I]]>Yb[V[J]] then Begin Buf:=V[I];V[I]:=V[J];V[J]:=Buf;End;
        Yes:=False;
        For I:=1 to NV-1 do If Yb[V[I+1]]-Yb[V[I]]>100 then Begin
          Yes:=True;
          Break;
        End;
        If Yes then Begin
          Y:=(Yb[V[I+1]]+Yb[V[I]])/2;
          OK:=False;
        End;
      End;
      Done;
      Halt;
    End;
  End;

  {perebor}
  St:=0;
  Repeat
    Inc(St);
    W:=L/(1 shl St);
    CurX:=1;
    While CurX<(1 shl St) do Begin
      X:=CurX*W;
      For CurY:=1 to 1 shl St-1 do Begin
        Y:=CurY*W;
        If not PointIn then Begin
          OK:=False;
          Done;
          Halt;
        End;
      End;
      Inc(CurX,2);
    End;
    CurY:=1;
    While CurY<(1 shl St)do Begin
      Y:=CurY*W;
      CurX:=2;
      While CurX<(1 shl St)do Begin
        X:=CurX*W;
        If Not PointIn then Begin
          OK:=False;
          Done;
          Halt;
        End;
        Inc(CurX,2);
      End;
      Inc(CurY,2);
    End;
  Until False;
End;

Begin
  BreakTime:=Timer+Trunc(5/55*1000)-5;
  Init;Run;Done;
End.