{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
type PElem = ^TElem;
     TElem = record
              Inf: integer;
              Next: PElem;
             end;
     Ar = array [1..1000] of PElem;
var N,K: integer;
    A: Ar;
    i,c: integer;
procedure Add(N,K: integer);
var P: PElem;
begin
 New(P);
 P^.Inf:=K;
 P^.Next:=A[N];
 A[N]:=P;
end;
type PWay = ^TWay;
     TWay = record
             N1,N2: integer;
             Next: PWay;
            end;
procedure GetWay(V1,V2: integer; Way: PWay);
 procedure AddWay(i1,i2: integer);
 var P: PWay;
 begin
  New(P);
  P^.N1:=i1;
  P^.N2:=i2;
  P^.Next:=Way;
  Way:=P;
 end;
 procedure DelWay;
 begin
  Way:=Way^.Next;
 end;
 function CheckWay: boolean;
  procedure DelA;
  var P: PWay;
      PP: PElem;
      i: integer;
  begin
   P:=Way;
   while P<>nil do
    begin
     PP:=A[P^.N1];
     if PP^.Inf=P^.N2 then A[P^.N1]:=A[P^.N1]^.Next
     else
      begin
       while PP^.Next^.Inf<>P^.N2 do PP:=PP^.Next;
       PP^.Next:=PP^.Next^.Next;
      end;

     PP:=A[P^.N2];
     if PP^.Inf=P^.N1 then A[P^.N2]:=A[P^.N2]^.Next
     else
      begin
       while PP^.Next^.Inf<>P^.N1 do PP:=PP^.Next;
       PP^.Next:=PP^.Next^.Next;
      end;

     P:=P^.Next;
    end;
  end;
  procedure DoA;
  var P: PWay;
  begin
   P:=Way;
   while P<>Nil do
    begin
     Add(P^.N1,P^.N2);
     Add(P^.N2,P^.N1);
     P:=P^.Next;
    end;
  end;
 var Go: array [1..1000] of boolean;
 procedure GoGo(N: integer);
 var P: PElem;
 begin
  if Go[N] then exit;
  Go[N]:=True;
  P:=A[N];
  while P<>Nil do
   begin
    GoGo(P^.Inf);
    P:=P^.Next;
   end;
 end;
 begin
  DelA;
  if (A[K]=nil) or (A[V2]=nil) then
   begin
    CheckWay:=true;
    exit;
   end;
  FillChar(Go,SizeOf(Go),False);
  GoGo(K);
  if Go[V2]=False then
   begin
    CheckWay:=True;
    exit;
   end;
  CheckWay:=False;
  DoA;
 end;
 function OkWay(V1,V2: integer): boolean;
 var P: PWay;
 begin
  P:=Way;
  while P<>nil do
   begin
    if ((P^.N1=V1) and (P^.N2=V2)) or ((P^.N2=V1) and (P^.N1=V2)) then
     begin
      OkWay:=False;
      exit;
     end;
    P:=P^.Next;
   end;
  OkWay:=True;
 end;
 procedure WritelnWay;
 var i,j: integer;
     Mas: array [1..5000] of integer;
 begin
  i:=0;
  while Way<>nil do
   begin
    inc(i);
    Mas[i]:=Way^.N2;
    Way:=Way^.Next;
   end;
  inc(i);
  Mas[i]:=K;
  assign(OutPut,'Castle.out');
  rewrite(OutPut);
   writeln(i-1);
   for j:=i downto 1 do
    write(Mas[j],' ');
  close(OutPut);
 end;
var P: PElem;
begin
 if V1=V2 then
  if CheckWay then
   begin
    WritelnWay;
    halt;
   end;
 P:=A[V1];
 while P<>nil do
  begin
   if OkWay(V1,P^.Inf) then
    begin
     AddWay(V1,P^.Inf);
     GetWay(P^.Inf,V2,Way);
     DelWay;
    end;
   P:=P^.Next;
  end;
end;

var W: PWay;
begin
 for i:=1 to 1000 do
  begin
   New(A[i]);
   A[i]:=nil;
  end;
 assign(Input,'castle.in');
 reset(Input);
  readln(N);
  readln(K);
  for i:=1 to N do
   begin
    read(c);
    while c<>0 do
     begin
      Add(i,c);
      read(c);
     end;
    readln;
   end;
 close(Input);
 for i:=1 to N do if i<>K then GetWay(K,i,nil);
 assign(OutPut,'castle.out');
 rewrite(OutPut);
  writeln('No');
 close(OutPut);
end.