{$R+}
Const
  FIn='Olymp.In';
  FOut='Olymp.Out';
Var
  Input,Output:Text;
{----------------------------------------------------------------------------}
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
end;
{----------------------------------------------------------------------------}
Const
  MaxN=1000;
Type
  List=array[1..MaxN] of LongInt;
Var
  N:LongInt;
  T:List;
  Unsorted:List;
  {}
  Res:LongInt;
  Nums:array[1..MaxN]of Record
    N1,N2,Return:Byte;
  end;
  Col:Byte;
  {}
  Delegat:Array[1..MaxN]of Byte;
  R:Byte;
  Run,O:Byte;
  Num,Min:Byte;
  Variants:array[1..MaxN*26]of Record
    N1,N2:Byte;
  end;

   procedure QSort(var A: List; Lo, Hi: LongInt);
     procedure Sort(l, r: LongInt);
     var
       i, j, x, y: LongInt;
     begin
       i := l; j := r; x := a[(l+r) DIV 2];
       repeat
         while a[i] < x do i := i + 1;
         while x < a[j] do j := j - 1;
         if i <= j then
         begin
           {Change}
           y:=a[i];  a[i]:=a[j];  a[j]:=y;
           y:=Unsorted[i];  Unsorted[i]:=Unsorted[j];  Unsorted[j]:=y;
           {}
           i := i + 1; j := j - 1;
         end;
       until i > j;
       if l < j then Sort(l, j);
       if i < r then Sort(i, r);
     end;
   begin
     Sort(Lo,Hi);
   end;

Procedure Solve;
begin
  {Zero}
  Res:=0;
  Col:=0;
  FillChar(Delegat,SizeOf(Delegat),0);
  FillChar(Nums,SizeOf(Nums),0);
  {Load}
  Readln(Input,N);
  For R:=1 to N do
  begin
    ReadLn(Input,T[R]);
    Unsorted[R]:=R;
  end;
  QSort(T,1,N);
  {Solve}
  Run:=1;
  While Run<N do
  begin
    Inc(Run);
    If Run<=N then
    begin
      Inc(Col);
      Nums[Col].N1:=1;
      Nums[Col].N2:=Run;
      Nums[Col].Return:=1;
      {}
      Inc(Res,T[Run]);
      If Run+1<=N then Inc(Res,T[1]);
    end;
  end;
  {Save}
  Writeln(Output,Res);
  For R:=1 to Col do
  begin
    With Nums[R] do
      If R<>Col then Writeln(Output,Unsorted[N1],' ',Unsorted[N2],' ',Unsorted[Return])
                else Writeln(Output,Unsorted[N1],' ',Unsorted[N2]);
  end;
end;
{----------------------------------------------------------------------------}
begin
  Init; Solve; Done;
end.