#define MAX					1024

#include <stdio.h>


void input ();
void solve ();
void output ();


long n, p [MAX], t [MAX], ans;


main ()
 {
	input ();
	solve ();
	output ();

	return (0);
 }


void input ()
 {
	FILE * file = fopen ("olymp.in", "r");
	fscanf (file, "%ld", & n);

	for (int i = 0; i < n; i ++)
	 fscanf (file, "%ld", & t [i]);

	fclose (file);
 }


void solve ()
 {
	for (int i = 0; i < n; i ++)
	 p [i] = i;

	for (i = 0; i < n; i ++)
	 for (int j = i + 1; j < n; j ++)
	  if (t [p [j]] < t [p [i]])
		p [i] ^= p [j], p [j] ^= p [i], p [i] ^= p [j];

	for (i = 2; i <= n - 2; i += 2)
	 ans += 2 * t [p [1]] + t [p [0]] + t [p [i + 1]];

	if (n % 2)
	 ans += t [p [0]] + t [p [1]] + t [p [n - 1]];
	else ans += t [p [1]];
 }


void output ()
 {
	FILE * file = fopen ("olymp.out", "w");
	fprintf (file, "%ld\n", ans);

	for (long i = 2; i <= n - 2; i += 2)
	 fprintf (file, "%ld %ld %ld\n%ld %ld %ld\n", p [0] + 1, p [1] + 1, p [0] + 1, p [i] + 1, p [i + 1] + 1, p [1] + 1);

	if (n % 2)
	 fprintf (file, "%ld %ld %ld\n%ld %ld", p [0] + 1, p [1] + 1, p [0] + 1, p [n - 1] + 1, p [0] + 1);
	else fprintf (file, "%ld %ld", p [0] + 1, p [1] + 1);

	fclose (file);
 }