{ : 1115; : 1; }
{ 室 $ ਡ     -ᨪ. }
program P1115_1;

const
  INPUT_FILE_NAME = 'class.in';
  OUTPUT_FILE_NAME = 'class.out';

type
  TDirection = (tdL, tdU, tdR, tdD);
  TClassics = array [1..80, 1..3] of Byte;
  TWay = record
    Length: Integer;
    Way: array [1..80*3] of Byte;
  end;
  TRoad = record
    Length: Integer;
    Road: array [1..80*3] of TDirection;
  end;

var
  InOutFile: Text;
  { ⢮ ⮫殢  ᨪ: }
  N: Integer;
  {  ᨪ: }
  Classics, Used: TClassics;
  Count1, Count2: Integer;
  StartRow: Integer;
  BestRoad: TRoad;

function CompareWays(A, B: TWay): Shortint;
var
  CurPos: Integer;
  A1, B1: TWay;
begin
  A1.Length:= 0;
  B1.Length:= 0;
  CurPos:= 1;
  if A.Length > 0 then
    while A.Way[CurPos] = 0 do Inc(CurPos);
  while A.Length >= CurPos do
  begin
    Inc(A1.Length);
    A1.Way[A1.Length]:= a.Way[CurPos];
    Inc(CurPos);
  end;
  CurPos:= 1;
  while B.Way[CurPos] = 0 do Inc(CurPos);
  while B.Length >= CurPos do
  begin
    Inc(B1.Length);
    B1.Way[B1.Length]:= B.Way[CurPos];
    Inc(CurPos);
  end;

  if A1.Length > B1.Length then
  begin
    CompareWays:= -1;
    Exit;
  end;
  if B1.Length > A1.Length then
  begin
    CompareWays:= 1;
    Exit;
  end;
  for CurPos:= 1 to A1.Length do
  begin
    if A1.Way[CurPos] > B1.Way[CurPos] then
    begin
      CompareWays:= -1;
      Exit;
    end;
    if B1.Way[CurPos] > A1.Way[CurPos] then
    begin
      CompareWays:= 1;
      Exit;
    end;
  end;
  if A.Length > B.Length then
  begin
    CompareWays:= 1;
    Exit;
  end;
  if B.Length > A.Length then
  begin
    CompareWays:= -1;
    Exit;
  end;
end;

function GetBestWay(Col, Row: Integer; var Way: TWay; var Road: TRoad): Boolean;
var
  CurDir: TDirection;
  CurWay, BstWay: ^TWay;
  CurRoad, BstRoad: ^TRoad;
  NRow, NCol: Integer;
  Done, Trap: Boolean;
  Count: Integer;
begin
  Trap:= False;
  if (Row = 1) and (Col < N) then Trap:= Used[Col + 1, 1] = 1;
  if (Row = 2) and (Col < N) then
    Trap:= (Used[Col + 1, 2] = 1) and (Used[Col, 1] = 1)
      and (Used[Col, 3] = 1);
  if (Row = 3) and (Col < N) then Trap:= Used[Col + 1, 3] = 1;

  if Trap then
  begin
    GetBestWay:= False;
    Exit;
  end;
  New(CurWay);
  New(BstWay);
  New(CurRoad);
  New(BstRoad);
  Used[Col, Row]:= 1;
  Done:= True;
  BstWay^:= Way;
  Inc(BstWay^.Length);
  BstWay^.Way[BstWay^.Length]:= Classics[Col, Row];
  BstRoad^:= Road;
  for CurDir:= tdL to tdD do
  begin
    CurWay^:= Way;
    Inc(CurWay^.Length);
    CurWay^.Way[CurWay^.Length]:= Classics[Col, Row];
    CurRoad^:= Road;
    NRow:= Row;
    NCol:= Col;
    case CurDir of
      tdL:
      begin
        if Col > 1 then NCol:= Col - 1;
      end;
      tdU:
      begin
        if Row > 1 then NRow:= Row - 1;
      end;
      tdR:
      begin
        if Col < N then NCol:= Col + 1;
      end;
      tdD:
      begin
        if Row < 3 then NRow:= Row + 1;
      end;
    end;
    if Used[NCol, NRow] = 0 then
    begin
      Inc(CurRoad^.Length);
      CurRoad^.Road[CurRoad^.Length]:= CurDir;
      if not GetBestWay(NCol, NRow, CurWay^, CurRoad^) then
      begin
        if (CompareWays(BstWay^, CurWay^) = 1) or Done then
        begin
          BstWay^:= CurWay^;
          BstRoad^:= CurRoad^;
        end;
        Done:= False;
      end;
    end;
  end;

  if not (Done and (Col < N)) then
  begin
    Way:= BstWay^;
    Road:= BstRoad^;
  end;

  Used[Col, Row]:= 0;
  Dispose(CurWay);
  Dispose(BstWay);
  Dispose(CurRoad);
  Dispose(BstRoad);
  GetBestWay:= Done and (Col < N);
end;

procedure GetBestRoad;
var
  CurStartRow: Integer;
  CurWay: TWay;
  CurRoad: TRoad;
  BestWay: TWay;
begin
  BestRoad.Length:= 0;
  BestWay.Length:= 0;
  for CurStartRow:= 1 to 3 do
  begin
    CurRoad.Length:= 0;
    CurWay.Length:= 0;
    GetBestWay(1, CurStartRow, CurWay, CurRoad);
    if (CompareWays(BestWay, CurWay) = 1) or (CurStartRow = 1) then
    begin
      BestRoad:= CurRoad;
      BestWay:= CurWay;
      StartRow:= CurStartRow;
    end;
  end;
end;

begin
  {  室 䠩: }
  Assign(InOutFile, INPUT_FILE_NAME);
  Reset(InOutFile);

  Read(InOutFile, N);

  for Count1:= 1 to 3 do
  begin
    for Count2:= 1 to N do
    begin
      Read(InOutFile, Classics[Count2, Count1]);
      Used[Count2, Count1]:= 0;
    end;
  end;

  GetBestRoad;

  {  室 䠩: }
  Close(InOutFile);

  {  室 䠩: }
  Assign(InOutFile, OUTPUT_FILE_NAME);
  Rewrite(InOutFile);

  WriteLn(InOutFile, StartRow);
  for Count1:= 1 to BestRoad.Length do
  begin
    case BestRoad.Road[Count1] of
      tdL:
      begin
        Write(InOutFile, 'L');
      end;
      tdU:
      begin
        Write(InOutFile, 'U');
      end;
      tdR:
      begin
        Write(InOutFile, 'R');
      end;
      tdD:
      begin
        Write(InOutFile, 'D');
      end;
    end;
  end;

  { ࠭ 室 䠩: }
  Close(InOutFile);
end.