{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
Program Task;
var
   rects:array[1..4000,1..4] of single;
   cnt:integer;
   l:extended;
   n:byte;
   i,k:integer;
   x1,y1,x2,y2:extended;
   a1,a2:extended;

Procedure SwapS(var a,b:single);
var t:single;
begin
   t:=a; a:=b; b:=t;
end;

Procedure SwapE(var a,b:extended);
var t:extended;
begin
   t:=a; a:=b; b:=t;
end;

function InsideL(x1,x2,i1,i2:extended; var a1,a2:extended):boolean;
begin
   InsideL:=false;
   {full out, but includes}
   if (x1<=i1) and (x2>=i2) then
   begin
      a1:=i1; a2:=i2; InsideL:=true;
   end
   {left enters, right out}
   else if (x1>=i1) and (x1<=i2) and (x2>=i2) then
   begin
      a1:=x1; a2:=i2; InsideL:=true;
   end
   {left out, right enters }
   else if (x1<=i1) and (x2>=i1) and (x2<=i2) then
   begin
      a1:=i1; a2:=x2; InsideL:=true;
   end
   {fuls enters}
   else if (x1>=i1) and (x1<=i2) and (x2>=i1) and (x2<=i2) then
   begin
      a1:=x1; a2:=x2; InsideL:=true;
   end;
end;

Procedure AddRect(x1,y1,x2,y2:single);
begin
   inc(cnt);
   rects[cnt,1]:=x1;
   rects[cnt,2]:=y1;
   rects[cnt,3]:=x2;
   rects[cnt,4]:=y2;
end;

begin
   assign(input,'fire.in');
   reset(input);
   assign(output,'fire.out');
   rewrite(output);
   readln(l);
   readln(n);

   cnt:=1;
   rects[1,1]:=0; rects[1,2]:=0; rects[1,3]:=l; rects[1,4]:=l;
   for k:=1 to n do
   begin
      readln(x1,y1,x2,y2);
      {two cases: if horiz or if vert}
      if (x1=x2) then {if vert}
      begin
         if y1>y2 then swapE(y1,y2);
         {split}
         {determine rect in which left or right in}
         for i:=1 to cnt do
            if InsideL(x1-50,x1+50,rects[i,1],rects[i,3],a1,a2) then
            begin
              {split it into rect(s)}
              if (a1=rects[i,1]) then {one rect} rects[i,1]:=a2
              else if (a2=rects[i,3]) then rects[i,3]:=a1
              else
              begin
                 AddRect(a2,rects[i,2],rects[i,3],rects[i,4]);
                 rects[i,3]:=a1;
              end;
            end;
      end
      else if (y1=y2) then {if horiz}
      begin
         if x1>x2 then swapE(x1,x2);
         {split}
         {determine rect in which down or up in}
         for i:=1 to cnt do
            if InsideL(y1-50,y1+50,rects[i,2],rects[i,4],a1,a2) then
            begin
              {split it into rect(s)}
              if (a1=rects[i,2]) then {one rect} rects[i,2]:=a2
              else if (a2=rects[i,4]) then rects[i,4]:=a1
              else
              begin
                 AddRect(rects[i,1],a2,rects[i,3],rects[i,4]);
                 rects[i,4]:=a1;
              end;
            end;
      end
      else
      begin
         writeln('OK');
         close(input);
         close(output);
         halt;
      end;
   end;
{   writeln('------');
   for i:=1 to cnt do
      writeln('x1:',rects[i,1]:5:3,'  y1:',rects[i,2]:5:3,
              '  x2:',rects[i,3]:5:3,' y2:',rects[i,4]:5:3);
   writeln('------');}
   for i:=1 to cnt do
      if (abs(rects[i,1]-rects[i,3])>1e-5) and (abs(rects[i,2]-rects[i,4])>1e-5) then
      begin
         writeln((rects[i,1]+rects[i,3])/2:3:3,' ',(rects[i,2]+rects[i,4])/2:3:3);
         close(input);
         close(output);
         halt;
      end;
   writeln('OK');
   close(input);
   close(output);
end.