{       (C) 2001, 쥢 . . ( 146, . ).  2.  4.      }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program         P1405_4;

type
  Float         = Single;

  TPoint        = record
    X, Y        : Float;
  end;

  TLine         = record
    A, B, C     : Float;
  end;

var
  N             : Integer;
  L             : Float;
  Lines         : array[1..100] of TLine;

procedure       OpenFiles;
begin
  Assign(Input, 'FIRE.IN');
  Reset(Input);
  Assign(Output, 'FIRE.OUT');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : Integer;
  X1, Y1, X2, Y2: Float;
begin
  ReadLn(L);
  ReadLn(N);
  for I := 1 to N do begin
    ReadLn(X1, Y1, X2, Y2);
    Lines[I].A := Y2 - Y1;
    Lines[I].B := X1 - X2;
    Lines[I].C := X2 * Y1 - X1 * Y2;
  end;
end;

procedure       Solve;
var
  Q, Y, X       : Float;
  I             : Integer;
  Delta         : array[1..100] of Float;
  Fl            : Boolean;
  SX, EX        : array[0..101] of Float;

procedure       QSort(L, R: Integer);
var
  I, J          : Integer;
  X, Temp       : Float;
begin
  I := L; J := R; X := SX[(L + R) div 2];
  repeat
    while SX[I] < X do
      Inc(I);
    while SX[J] > X do
      Dec(J);
    if I > J then
      Break;
    if SX[J] <> SX[I] then begin
      Temp := SX[I];
      SX[I] := SX[J];
      SX[J] := Temp;
      Temp := EX[I];
      EX[I] := EX[J];
      EX[J] := Temp;
    end;
    Dec(J);
    Inc(I);
  until I > J;
  if L < J then
    QSort(L, J);
  if I < R then
    QSort(I, R);
end;

function        Max(A, B: Float): Float;
begin
  if A > B then
    Max := A
  else
    Max := B;
end;

function        Min(A, B: Float): Float;
begin
  if A < B then
    Min := A
  else
    Min := B;
end;

begin
  if N <= 5 then
    Q := 0.001
  else
    Q := 0.01;
  Y := 0;
  for I := 1 to N do
    if Lines[I].B <> 0 then
      Delta[I] := 50 / Sin(ArcTan(-Lines[I].A / Lines[I].B));
  while Y <= L do begin
    for I := 1 to N do begin
      X := -(Lines[I].B * Y + Lines[I].C) / Lines[I].A;
      if Lines[I].B <> 0 then begin
        SX[I] := X - Delta[I];
        EX[I] := X + Delta[I];
      end else begin
        SX[I] := X - 50;
        EX[I] := X + 50;
      end;
      if SX[I] > EX[I] then begin
        X := SX[I];
        SX[I] := EX[I];
        EX[I] := X;
      end;
    end;
    QSort(1, N);
    Fl := False;
    SX[0] := 0;
    EX[0] := 0;
    SX[N + 1] := L;
    EX[N + 1] := L;
    for I := 1 to N + 1 do begin
      if SX[I] > EX[I - 1] then begin
        Fl := True;
        Break;
      end;
    end;
    if Fl then begin
      WriteLn(Min(Max(SX[I] - 0.001, 0.001), L - 0.001):0:3, ' ', Y:0:3);
      Exit;
    end;
    Y := Y + Q;
  end;
  WriteLn('OK');
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.