{       (C) 2001, 쥢 . . ( 146, . ).  2.  6.      }
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
program         P1405_6;

var
  N             : Integer;
  T             : array[1..1000] of Integer;
  NN            : array[1..1000] of Integer;
  P             : array[1..2000] of record A, B, C: Integer; end;

procedure       OpenFiles;
begin
  Assign(Input, 'OLYMP.IN');
  Reset(Input);
  Assign(Output, 'OLYMP.OUT');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : Integer;
begin
  ReadLn(N);
  for I := 1 to N do begin
    ReadLn(T[I]);
    NN[I] := I;
  end;
end;

procedure       QSort(L, R: Integer);
var
  I, J, X, Temp : Integer;
begin
  I := L; J := R; X := T[(L + R) div 2];
  repeat
    while T[I] < X do
      Inc(I);
    while T[J] > X do
      Dec(J);
    if I > J then
      Break;
    if T[J] <> T[I] then begin
      Temp := T[I];
      T[I] := T[J];
      T[J] := Temp;
      Temp := NN[I];
      NN[I] := NN[J];
      NN[J] := Temp;
    end;
    Dec(J);
    Inc(I);
  until I > J;
  if L < J then
    QSort(L, J);
  if I < R then
    QSort(I, R);
end;

procedure       Solve;
var
  TT            : LongInt;
  NumIn, K      : Integer;
begin
  TT := 0; NumIn := 1; K := 0;
  repeat
    Inc(K);
    Inc(NumIn);
    QSort(1, N);
    P[K].A := NN[1];
    P[K].B := NN[2];
    P[K].C := NN[1];
    if NumIn <> N then
      TT := TT + T[2] + T[1]
    else
      TT := TT + T[2];
    T[2] := MaxInt;
  until NumIn = N;
  WriteLn(TT);
  for K := 1 to NumIn - 1 do begin
    if K <> NumIn - 1 then
      WriteLn(P[K].A, ' ', P[K].B, ' ', P[K].C)
    else
      WriteLn(P[K].A, ' ', P[K].B);
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.