{tele.in
tele.out}
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
var
  p,r,s,num,c:array[1..1000] of longint;
  bool:boolean;
  n:longint;
  m:array[0..1000] of char;
  i,j:longint;

procedure init;
begin
  assign(input,'tele.in');
  reset(input);
  assign(output,'tele.out');
  rewrite(output);
  readln(n);
  for i:=1 to n do read(p[i]);
  for i:=1 to n do read(s[i]);
  r:=s;
end;

procedure done;
begin
  close(input);
  close(output);
end;

procedure qsort(l,r:integer);
var
  i,j:integer;
  t,m:integer;
begin
  m:=p[(l+r) shr 1];
  i:=l;
  j:=r;
  repeat
    while p[i]<m do inc(i);
    while p[j]>m do dec(j);
    if i<=j then begin
      t:=p[i];
      p[i]:=p[j];
      p[j]:=t;
      t:=s[i];
      s[i]:=s[j];
      s[j]:=t;
      t:=num[i];
      num[i]:=num[j];
      num[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then qsort(i,r);
  if l<j then qsort(l,j);
end;

function pw2:longint;
var
  i,t:integer;
begin
  t:=1;
  for i:=1 to n-2 do t:=t shl 1;
  pw2:=t;
end;

procedure solve;
begin
  for i:=1 to n do num[i]:=i;
  qsort(1,n);
  for i:=1 to n do if p[i]=1 then begin
    for j:=i to n do begin
      p[j]:=p[j+1];
      s[j]:=s[j+1];
      num[j]:=num[j+1];
    end;
    dec(i);
    dec(n);
  end;
  if n=0 then begin
    writeln('Yes');
    halt;
  end;
  if (n=1) then begin
    if p[1]>2 then writeln('No')
    else begin
      writeln('Yes');
      if s[1]=1 then begin
        writeln(num[1],' +');
        writeln(num[1],' -');
      end else begin
        writeln(num[1],' -');
        writeln(num[1],' +');
      end;
    end;
    halt;
  end;
  if n=2 then begin
    if (p[1]>2) then writeln('No')
    else begin
      writeln('Yes');
      for i:=s[2] to p[2]-1 do writeln(num[2],' +');
      if s[1]=1 then writeln(num[1],' +')
      else writeln(num[1],' -');
      for i:=1 to p[2]-1 do writeln(num[2],' -');
      if s[1]=1 then writeln(num[1],' -')
      else writeln(num[1],' +');
      for i:=1 to s[2]-1 do writeln(num[2],' +');
    end;
    halt;
  end;
  bool:=true;
  for i:=1 to n-1 do if p[i]>2 then begin
    bool:=false;
    break;
  end;
  for i:=1 to n do c[i]:=1;
  if bool then begin
    writeln('Yes');
    for j:=1 to pw2 do begin
      for i:=s[n] to p[n]-1 do writeln(num[n],' +');
      if s[n-1]=1 then writeln(num[n-1],' +')
      else writeln(num[n-1],' -');
      for i:=1 to p[n]-1 do writeln(num[n],' -');
      if s[n-1]=1 then writeln(num[n-1],' -')
      else writeln(num[n-1],' +');
      for i:=1 to s[n]-1 do writeln(num[n],' +');
      fillchar(m,sizeof(m),0);
      inc(c[n-2]);
      m[i]:='+';
      for i:=n-2 downto 1 do if c[i]>2 then begin
        inc(c[i-1]);
        c[i]:=1;
        m[i]:='-';
        m[i-1]:='+';
      end;
      for i:=1 to n-2 do if m[i]<>#0 then writeln(num[i],#32,m[i]);
    end;
  end;
end;

begin
  init;
  solve;
  done;
end.