Program P2605_1;

Const
 Up      = 1;
 Down    = 2;
 Right   = 3;
 Left    = 4;
 Empty   = 0;
 Present = 1;

Var
 N                         : Word;
 Map                       : Array[1..80,1..3] Of Byte;
 Map2                      : Array[1..80,1..3] Of Byte;
 Road                      : Array[1..240] Of Byte;
 X,Y,I                     : Integer;
 StartX,StartY,MoveX,MoveY : Word;
 S                         : String;
 Money                     : Word;


Function CantGo(X,Y : Word):Boolean;
Begin
 IF (((Map2[X+1,Y]=Present) And (Map2[X-1,Y] = Present)
    And (Map2[X,Y+1] = Present) And (Map2[X,Y-1] = Present))
    Or
((X+1>N) And (Map2[X-1,Y] = Present)
    And (Map2[X,Y+1] = Present) And (Map2[X,Y-1] = Present))
Or
((Map2[X+1,Y]=Present) And (X-1<N)
    And (Map2[X,Y+1] = Present) And (Map2[X,Y-1] = Present))
Or
((Map2[X+1,Y]=Present) And (Map2[X-1,Y] = Present)
    And (Y+1>3) And (Map2[X,Y-1] = Present))
Or
((Map2[X+1,Y]=Present) And (Map2[X-1,Y] = Present)
    And (Map2[X,Y+1] = Present) And (Y-1<1)))
Then    CantGo:= True
Else CantGo := False;
End;

Function FindNeg(StX,StY:Word) : Byte;
Var
 CanMove : Array[1..4] Of Boolean;
Begin
 FillChar(CanMove,SizeOf(CanMove),1);
  If StX - 1 < 1 Then CanMove[Left] := False;
  If StX + 1 > N Then CanMove[Right] := False;
  If StY + 1 > 3 Then CanMove[Down] := False;
  If StY - 1 < 1 Then CanMove[Up] := False;

  If (Map[StX-1,StY] = Empty) And (Map2[StX-1,Sty] = Empty) And CanMove[Left]Then
   Begin
{    Map2[StX-1,Sty] := Present;}
    FindNeg := Left;
    Exit;
   End;

  If (Map[StX+1,StY] = Empty) And (Map2[StX+1,Sty] = Empty) And CanMove[Right]Then
   Begin
{    Map2[StX+1,StY] := Present;}
    FindNeg := Right;
    Exit;
   End;

  If (Map[StX,StY-1] = Empty) And (Map2[StX,Sty-1] = Empty) And CanMove[Up]Then
   Begin
{    Map2[StX,StY-1] := Present;}
    FindNeg := Up;
    Exit;
   End;

  If (Map[StX,StY+1] = Empty) And (Map2[StX,Sty+1] = Empty) And CanMove[Down]Then
   Begin
{    Map2[StX,StY+1] := Present;}
    FindNeg:= Down;
    Exit;
   End;


   FindNeg:= 200;
End;



Function FindNext(StX,StY:Word) : Byte;
Var
 CanMove : Array[1..4] Of Boolean;
Begin
 FillChar(CanMove,SizeOf(CanMove),1);
  If StX - 1 < 1 Then CanMove[Left] := False;
  If StX + 1 > N Then CanMove[Right] := False;
  If StY + 1 > 3 Then CanMove[Down] := False;
  If StY - 1 < 1 Then CanMove[Up] := False;

  If (Map[StX-1,StY] = Present) And (Map2[StX-1,Sty] = Empty) And CanMove[Left]Then
   Begin
{    Map2[StX-1,Sty] := Present;}
    FindNext := Left;
    Exit;
   End;

  If (Map[StX+1,StY] = Present) And (Map2[StX+1,Sty] = Empty) And CanMove[Right]Then
   Begin
{    Map2[StX+1,StY] := Present;}
    FindNext := Right;
    Exit;
   End;

  If (Map[StX,StY-1] = Present) And (Map2[StX,Sty-1] = Empty) And CanMove[Up]Then
   Begin
{    Map2[StX,StY-1] := Present;}
    FindNext := Up;
    Exit;
   End;

  If (Map[StX,StY+1] = Present) And (Map2[StX,Sty+1] = Empty) And CanMove[Down]Then
   Begin
{    Map2[StX,StY+1] := Present;}
    FindNext := Down;
    Exit;
   End;


   FindNext := Empty;
End;

Begin
 Assign(InPut,'Class.in');
 Assign(OutPut,'Class.out');

 FillChar(Map,SizeOf(Map),0);
 FillChar(Map2,SizeOf(Map2),0);
 FillChar(Road,SizeOf(Road),0);

 ReSet(Input);
 Readln(N);
  For Y := 1 To 3 Do
   Begin
    For X := 1 To N Do
     Read(Map[X,Y]);
   End;

  For Y := 1 To 3 Do
   If FindNext(1,Y) <> Empty Then
    Begin
     StartY := Y;
     Break;
    End;
X:=1;
Y:=1;
Map2[1,StartY] := Present;

 Repeat
  Inc(I);
  If FindNext(X,Y) <> Empty Then
   Begin
    Road[I] := FindNext(X,Y);
     Case FindNext(X,Y) Of
      Left  : Dec(X);
      Right : Inc(X);
      Down  : Inc(Y);
      Up    : Dec(Y);
     End;
    Map2[X,Y] := Present;
    Continue;
   End;

  If FindNeg(X,Y) <> 200 Then
   Begin
    Road[I] := FindNeg(X,Y);
     Case FindNeg(X,Y) Of
      Left  : Dec(X);
      Right : Inc(X);
      Down  : Inc(Y);
      Up    : Dec(Y);
     End;
    Map2[X,Y] := Present;
    Continue;
   End;

 Until CantGo(X,Y);

 ReWrite(OutPut);
 I := 0;
 WriteLn(StartY);
 S := 'UDRL';
  Repeat
   Inc(I);
   Write(S[Road[i]]);
  Until Road[I+1] = Empty;
{ ReWrite(OutPut);
  For Y := 1 To 3 Do
   For X := 1 To N Do
    WriteLn(Map[X,Y]);
 Close(OutPut);}
 Close(Input);
End.