#include <fstream.h>
#include <math.h>
const double TOCHNOST = 0.0001;
int L,N;
double D[101][4];

double GetLineS(double a, double b, double c)
{
	double p=(a+b+c)/2;

	double result;
	result=sqrt(p*(p-a)*(p-b)*(p-c));
	return result;
}


double GetH(int i, double x, double y)
{
	double result,AB, AC, BC;
	AB=hypot(D[i][0]-D[i][2], D[i][1]-D[i][3]);
	if (fabs(AB)<TOCHNOST)
	{
		result=hypot(D[i][0]-x,D[i][1]-y);
	}
	else
	{
		AC=hypot(D[i][0]-x,D[i][1]-y);
		BC=hypot(D[i][2]-x,D[i][3]-y);
		result=2.0*GetLineS(AB,AC,BC)/AB;
	}
	return result;
}

int main()
{
	ifstream in("fire.in");
	char buffer[512];
	in>>L; in.getline(buffer,511);
	in>>N; in.getline(buffer,511);

	ofstream out("fire.out");
	for (int i=1;i<=N;i++)
	{
		for (int j=0;j<4;j++)
			in>>D[i][j];
		in.getline(buffer,511);
	}

		char flag=0,n;
		double step=L;
		double x,y;

	for (n=1;n<=10;n++)
	{
		step/=2;
		for (x=0;x<double(L);x+=step)
		for (y=0;y<double(L);y+=step)
		{

			flag=0;
			for (i=1;i<=N;i++)
				if (GetH(i,x,y)-50.0<TOCHNOST)
					flag=1;

			if (flag==0)
			{
				out<<x<<' '<<y<<endl;
				return 0;
			}
		}
	}
	out<<"OK"<<endl;
	return 0;
}
