{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q+,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Var
   Res                  :       Extended;
   RMoves               :       Array[1..240] of Char;
   RCol                 :       Byte;
   RS                   :       Byte;
   Map                  :       Array[1..80, 1..3] of Byte;
   F                    :       Text;
   N                    :       Byte;
   X, Y                 :       Byte;
   WhereWeWere          :       Array[1..80, 1..3] of Byte;
   S                    :       Byte;
   Col                  :       Byte;
   Moves                :       Array[1..240] of Char;
   R                    :       Extended;
   Count                :       Byte;
   I                    :       Byte;
Procedure Check;
Var
   I            :       Byte;
Begin
     If R <= Res then Exit;
     If X <> N then Exit;
     For I := 1 to Count do RMoves[I] := Moves[I];
     Res := R;
     RS := S;
End;
Procedure Move(Way : Char);
Procedure LeaveProc;
Begin
     Case Way of
          'D'           :       Dec(Y);
          'U'           :       Inc(Y);
          'L'           :       Inc(X);
          'R'           :       Dec(X);
     End;
     Dec(Count);
End;
Begin
     Inc(Count);
     If Count > Col then
        Begin
             Dec(Count);
             Exit;
        End;
     Case Way of
          'D'           :       Inc(Y);
          'U'           :       Dec(Y);
          'L'           :       Dec(X);
          'R'           :       Inc(X);
     End;
     If Not((X in [1..N]) and (Y in [1..3])) then
        Begin
             LeaveProc;
             Exit;
        End;
     If WhereWeWere[X, Y] = 1 then
        Begin
             LeaveProc;
             Exit;
        End;
     Moves[Count] := Way;
     R := R * 2 + Map[X, Y];
     WhereWeWere[X, Y] := 1;
     If Count = Col then Check;
     Move('D');
     Move('U');
     Move('L');
     Move('R');
     WhereWeWere[X, Y] := 0;
     R := (R - Map[X, Y]) / 2;
     LeaveProc;
End;
Begin
     Assign(F, 'class.in');
     ReSet(F);
     Read(F, N);
     For Y := 1 to 3 do
         For X := 1 to N do
             Begin
                  Read(F, Map[X, Y]);
                  WhereWeWere[X, Y] := 0;
             End;
     Close(F);
     Col := (3 * N) - 1;
     For S := 1 to 3 do
         Begin
              Y := S;
              X := 1;
              WhereWeWere[X, Y] := 1;
              R := Map[1, S];
              Move('D');
              Move('R');
              Move('U');
              WhereWeWere[X, Y] := 0;
         End;
     Assign(F, 'class.out');
     ReWrite(F);
     WriteLn(F, RS);
     For I :=  1 to Col do Write(F, RMoves[I]);
     Close(F);
End.