{$ifdef check}
{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,150000}
{$else}
{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,150000}
{$endif}
{Kalinin Petr}
type real=single;
     tarr=array[1..7000] of single;
const eps=1e-6;
var n:longint;
    l:single;
    xb,yb,xe,ye:array[1..100] of single;
    cr:tarr;
    tt:tarr;
    nc:longint;
    x1,y1,x2,y2,x3,y3,x4,y4:array[1..100] of single;
    f:text;
    i,j:longint;
    yy:single;
    tmp:single;
    d:longint;
    t:longint absolute 0:$46c;
    t0:longint;
    goodfly:boolean;

procedure findb(i:integer);
var tt:extended;
    d:extended;
begin
d:=sqrt(sqr(xb[i]-xe[i])+sqr(yb[i]-ye[i]));
tt:=(ye[i]-yb[i])/d;
if abs(tt)<eps then begin
   x1[i]:=xb[i];y1[i]:=yb[i]-50;x2[i]:=xe[i];y2[i]:=yb[i]-50;
   x3[i]:=xb[i];y3[i]:=yb[i]+50;x4[i]:=xe[i];y4[i]:=yb[i]+50;
   exit;
end;
tt:=50/tt;
x1[i]:=xb[i]-tt;y1[i]:=yb[i];x2[i]:=xe[i]-tt;y2[i]:=ye[i];
x3[i]:=xb[i]+tt;y3[i]:=yb[i];x4[i]:=xe[i]+tt;y4[i]:=ye[i];
end;

function eq(a,b:single):boolean;
begin eq:=abs(a-b)<eps; end;

function isin(a,t,b:single):boolean;
begin isin:=((a<t)and(t<b))or((b<t)and(t<a)); end;

procedure findinout(x1,y1,x2,y2:single);
var k,b:extended;
    tt:single;
begin
if eq(x1,x2) then exit;
k:=(y2-y1)/(x2-x1);
b:=y1-k*x1;
if isin(0,b,l) then begin
   inc(nc);cr[nc]:=b;
end;
tt:=k*l+b;
if isin(0,tt,l) then begin
   inc(nc);cr[nc]:=tt;
end;
end;

procedure cross(x1,y1,x2,y2,x3,y3,x4,y4:single;var yy:single);
begin
if eq((y4-y3)*(x1-x2)-(x3-x4)*(y2-y1),0) then begin
   if eq(((x1*(y2-y1)+y1*(x1-x2))*(y4-y3)-(x3*(y4-y3)+y3*(x3-x4))*(y2-y1)),0)
   then yy:=-1e10 else yy:=1e10;
   exit;
end;
yy:=((x1*(y2-y1)+y1*(x1-x2))*(y4-y3)-(x3*(y4-y3)+y3*(x3-x4))*(y2-y1))/
       ((y4-y3)*(x1-x2)-(x3-x4)*(y2-y1))
end;

procedure sort(l,r:longint);
var i1,i2,i3:longint;
begin
if l=r then exit;
if l=r-1 then begin
   if cr[l]>cr[r] then begin
      tmp:=cr[l];cr[l]:=cr[r];cr[r]:=tmp;
   end;
   exit;
end;
sort(l,(l+r) div 2);sort((l+r) div 2+1,r);
i1:=l;i2:=(l+r) div 2+1;
tt:=cr;
for i3:=l to r do begin
    if (i1<=(l+r) div 2)and((i2>r)or(cr[i1]<cr[i2])) then begin
       tt[i3]:=cr[i1];inc(i1);
    end else begin
        tt[i3]:=cr[i2];inc(i2);
    end;
end;
cr:=tt;
end;

procedure out(x,y:real);
begin
if isin(0,x,l)and isin(0,y,l) then begin
   assign(f,'fire.out');rewrite(f);
   writeln(f,x:3:3,' ',y:3:3);close(f);halt;
end;
end;

procedure check(y:single);
var x:array[0..202] of single;
    was:array[1..202] of byte;
    tt:single;
    nx:byte;
    i,j:longint;
    xx,xx2:single;
    d:integer;
begin
if t>t0+85 then begin
   assign(f,'fire.out');rewrite(f);
   writeln(f,'OK');
   close(f);halt;
end;
nx:=1;x[0]:=0;x[1]:=l;
for i:=1 to n do begin
    cross(y1[i],x1[i],y2[i],x2[i],y,0,y,l,xx);
    if isin(0,xx,l) then begin inc(nx);x[nx]:=xx; end;
    cross(y3[i],x3[i],y4[i],x4[i],y,0,y,l,xx);
    if isin(0,xx,l) then begin inc(nx);x[nx]:=xx; end;
end;
for i:=0 to nx-1 do
    for j:=nx-1 downto i do
        if x[j]>x[j+1] then begin
           tt:=x[j];x[j]:=x[j+1];x[j+1]:=tt;
        end;
d:=0;
for i:=1 to nx do begin
    if eq(x[i-1],x[i]) then inc(d);
    x[i-d]:=x[i];
end;
nx:=nx-d;
fillchar(was,sizeof(was),0);
for i:=1 to n do begin
    cross(y1[i],x1[i],y2[i],x2[i],y,0,y,l,xx);
    cross(y3[i],x3[i],y4[i],x4[i],y,0,y,l,xx2);
    if abs(xx)>1e9 then
       if isin(y1[i],y,y3[i])or eq(y,y1[i])or eq(y,y3[i]) then exit;
    for j:=1 to nx do
        if (was[j]=0) and ((xx<x[j-1])or eq(x[j-1],xx))and((xx2>x[j])or eq(xx2,x[j])) then
           was[j]:=1;
end;
for i:=1 to nx do if was[j]=0 then out((x[j-1]+x[j])/2,y);
end;

procedure chkrnd;
begin
check(l);
while t<t0+85 do
      check(random*l);
assign(f,'fire.out');rewrite(f);writeln(f,'OK');close(f);halt;
end;

procedure checkgood;
var pole:array[1..202,1..202] of byte;
    x,y:array[1..200] of single;
    nx,ny:integer;
    i,j,k:integer;
    tt:single;
begin
nx:=2;x[1]:=0;x[2]:=l;ny:=2;y[1]:=0;y[2]:=l;
fillchar(pole,sizeof(pole),0);
for i:=1 to n do begin
    if eq(xb[i],xe[i]) then begin
       inc(nx,2);x[nx]:=xb[i]-50;x[nx-1]:=xb[i]+50;
    end else begin
       inc(ny,2);y[ny]:=yb[i]-50;y[ny-1]:=yb[i]+50;
    end;
end;
for i:=nx-1 downto 1 do
    for j:=1 to i do
        if x[j]>x[j+1] then begin
           tt:=x[j];x[j]:=x[j+1];x[j+1]:=tt;
        end;
for i:=ny-1 downto 1 do
    for j:=1 to i do
        if y[j]>y[j+1] then begin
           tt:=y[j];y[j]:=y[j+1];y[j+1]:=tt;
        end;
for i:=1 to n do
    if eq(xb[i],xe[i]) then
       for j:=1 to nx-1 do begin
           if ((x[j]>xb[i]-50)or eq(x[j],xb[i]-50))and((x[j+1]<xb[i]+50)or eq(x[j+1],xb[i]+50)) then
              for k:=1 to ny do pole[j,k]:=1;
       end
    else
       for j:=1 to ny-1 do begin
           if ((y[j]>yb[i]-50)or eq(y[j],yb[i]-50))and((y[j+1]<yb[i]+50)or eq(y[j+1],yb[i]+50)) then
              for k:=1 to nx do pole[k,j]:=1;
       end;
for i:=1 to nx-1 do if not eq(x[i],x[i+1]) then
    for j:=1 to ny-1 do if not eq(y[j],y[j+1]) then
        if pole[i,j]=0 then out((x[i]+x[i+1])/2,(y[j]+y[j+1])/2);
assign(f,'fire.out');rewrite(f);writeln(f,'OK');close(f);
halt;
end;

begin t0:=t;goodfly:=true;
assign(f,'fire.in');reset(f);
read(f,l,n);
for i:=1 to n do begin
    read(f,xb[i],yb[i],xe[i],ye[i]);
    if not(eq(xb[i],xe[i])or eq(yb[i],ye[i])) then goodfly:=false;
end;
if goodfly then checkgood;
close(f);
nc:=2;cr[1]:=0;cr[2]:=l;
for i:=1 to n do
    findb(i);
for i:=1 to n do begin
    findinout(x1[i],y1[i],x2[i],y2[i]);
    findinout(x3[i],y3[i],x4[i],y4[i]);
    for j:=1 to i-1 do begin
        cross(x1[i],y1[i],x2[i],y2[i],x1[j],y1[j],x2[j],y2[j],yy);
        if isin(0,yy,l) then begin
           inc(nc);cr[nc]:=yy;
        end;
        cross(x1[i],y1[i],x2[i],y2[i],x3[j],y3[j],x4[j],y4[j],yy);
        if isin(0,yy,l) then begin
           inc(nc);cr[nc]:=yy;
        end;
        cross(x3[i],y3[i],x4[i],y4[i],x1[j],y1[j],x2[j],y2[j],yy);
        if isin(0,yy,l) then begin
           inc(nc);cr[nc]:=yy;
        end;
        cross(x3[i],y3[i],x4[i],y4[i],x3[j],y3[j],x4[j],y4[j],yy);
        if isin(0,yy,l) then begin
           inc(nc);cr[nc]:=yy;
        end;
    end;
end;
{$ifdef check}writeln('Found ',nc,'crosses... Sorting...');{$endif}
if nc>7000 then chkrnd;
sort(1,nc);
d:=0;
for i:=2 to nc do begin
    if eq(cr[i-1],cr[i]) then inc(d);
    cr[i-d]:=cr[i];
end;
nc:=nc-d;
for i:=1 to nc do
    check(cr[i]);
assign(f,'fire.out');rewrite(f);
writeln(f,'OK');
close(f);
end.

{Kalinin Petr}
