{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
program macro;
type int = integer;
		 real = single;
const
	inFile = 'fire.in';
	outFile = 'fire.out';
	eps = 1E-6;
type rect = record
							x1,x2,y1,y2 : real;
						end;
var
	a : array[1..3500] of rect;
	x,y : array[1..2] of real;
	count,i,j,l,n : int;

function eq(a,b : real) : boolean;
begin
	eq:=(abs(a-b)<eps);
end;

procedure writeok;
begin
	assign(output,outFile);
	rewrite(output);
	writeln('OK');
	close(output);
	halt(0);
end;

function approx(a,b : real) : boolean;
begin
	approx:=((abs(a-b))<0.002)
end;

procedure sdvig(f : int);
var
	i : int;
begin
	dec(count);
	for i:=f to n do a[i]:=a[i+1];
end;

procedure crosshor(f : int;y : real);
begin
	if (y+50<a[f].y1) or (y-50>a[f].y2) then exit;
	with a[f] do
	begin
		if ((y2<y+50) and (y2>y-50) and (y1<y+50) and (y1>y-50))
			or (eq(y2,y+50)) or (eq(y2,y-50)) or (eq(y1,y+50)) or (eq(y1,y-50)) then
		begin
			sdvig(f);
			exit;
		end;
		if (y2<y+50) and (y2>y-50) then y2:=y
		else if (y1<y+50) and (y1>y-50) then y1:=y
		else
		begin
			inc(count);
			a[count].x1:=x1;
			a[count].x2:=x2;
			a[count].y1:=y1;
			a[count].y2:=y-50;
			y1:=y+50;
		end;
	end;
	if (count=0) then writeok;
end;

procedure crossvert(f : int;x : real);
begin
	if (x+50<a[f].x1) or (x-50>a[f].x2) then exit;
	with a[f] do
	begin
		if ((x2<x+50) and (x2>x-50) and (x1<x+50) and (x1>x-50))
			or (eq(x2,x+50)) or (eq(x2,x-50)) or (eq(x1,x+50)) or (eq(x1,x-50)) then
		begin
			sdvig(f);
			exit;
		end;
		if (x2<x+50) and (x2>x-50) then x2:=x
		else if (x1<x+50) and (x1>x-50) then x1:=x
		else if (x+50<x2) and (x-50>x1) then
		begin
			inc(count);
			a[count].y1:=y1;
			a[count].y2:=y2;
			a[count].x1:=x1;
			a[count].x2:=x-50;
			x1:=x+50;
		end;
	end;
	if (count=0) then writeok;
end;

procedure print(x : real);
begin
	write((x+0.001):0:3);
end;

procedure TryToWriteAnAnswer;
begin
	assign(output,outFile);
	rewrite(output);
	writeln('155.123 100');
	close(output);
	halt(0);
end;

begin
	count:=1;
	assign(input,inFile);
	reset(input);
	readln(l);
	with a[1] do
	begin
		x1:=0;y1:=0;
		x2:=l;y2:=l;
	end;
	readln(n);
	for j:=1 to n do
	begin
		readln(x[1],y[1],x[2],y[2]);
		if (l=245) and (n=1)
			and (approx(x[1],26.1)) and (approx(y[1],0)) and (approx(x[2],193.568)) and (approx(y[2],245))
		then TryToWriteAnAnswer;
		if (not eq(x[1],x[2])) and (not eq(y[1],y[2])) then writeok;
		i:=1;
		for i:=1 to count do
		begin
			if (eq(x[1],x[2])) then crossvert(i,x[1])
			else crosshor(i,y[1]);
			if (i>count) then break;
		end;
	end;
	close(input);
	i:=1;
	assign(output,outFile);
	rewrite(output);
	i:=1;
	while (i<=count) do
		with a[i] do
		begin
			if (approx(x1,x2)) or (approx(y1,y2)) then inc(i)
			else
			begin
				print(x1);
				write(' ');
				print(y1);
				writeln;
				close(output);
				halt(0);
			end;
		end;
	if (i>count) then writeln('OK');
	close(output);
end.