{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
type real=extended;
const delta:extended=0.001;
Unlim:extended=1E10;


Var
	xb,xe,yb,ye:array [1..100] of Real;
    L,N,i,j:integer;
	x,y:array [1..200] of Real;
    cx,cy:byte;
    _F:boolean;
    eps:real;
    timer:longint absolute $0:$46c;
    t1:longint;

Function test(i1,j1:byte):boolean;
var px,py:real;
	i,j:byte;
begin
	test:=false;
   	px:=(x[i1]+x[i1+1])/2;
	py:=(y[j1]+y[j1+1])/2;
    if (px<delta) or (py<delta) then exit;
    for i:=1 to N do begin
		if abs(xb[i]-xe[i])<delta then begin
			if (px-(xb[i]+50)<delta) and
               (px-(xb[i]-50)>delta) then
			   		exit;
        end else begin
			if (py-(yb[i]+50)<delta) and
               (py-(yb[i]-50)>delta) then
			   		exit;
        end;
    end;
    test:=true;
end;

Procedure Out(i,j:byte);
begin
	assign(output,'fire.out');rewrite(output);
    	Writeln((x[i]+x[i+1])/2:0:3,' ',(y[j]+y[j+1])/2:0:3);
    close(output);
	halt;
end;

Procedure OutNo;
begin
	assign(output,'fire.out');rewrite(output);
    	writeln('OK');
    close(output);
	halt;
end;

function fmin(a,b:real):real;
begin
	if a-b<delta then fmin:=a else fmin:=b;
end;

function fmax(a,b:real):real;
begin
	if a-b<delta then fmax:=b else fmax:=a;
end;

function d(a,b,c,d1:real):real;
begin
d:=sqrt((a-c)*(a-c)+(b-d1)*(b-d1));
end;

Function Sgn(a:real):Shortint;
begin
	if a>delta then sgn:=1 else sgn:=-1
end;

Function Prin(a1,b1:real):boolean;
Var m1,a,b,c,p:real;
{xbi,xei,ybi,yei:real;}
begin
	prin:=True;
	for i:=1 to N do begin
{    	m1:=(a-xb[i])*(ye[i]-yb[i])-(b-yb[i])*(xe[i]-xb[i]);
        if abs(m1)-50<delta then exit;}
        a:=d(xb[i],yb[i],a1,b1);
        b:=d(xe[i],ye[i],a1,b1);
        c:=d(xb[i],yb[i],xe[i],ye[i]);
        p:=0.5*(a+b+c);
        m1:=( sqrt(p*(p-a)*(p-b)*(p-c)) )/(c*0.5);
        if m1-50<delta then exit;
    end;
    Prin:=False;
end;

function Len (a,b:real): real;
var i:byte;
	res:real;
begin
    if Prin(a,b) then begin
    	Len:=Unlim;
        exit;
    end;
	res:=0.0;
	for i:=1 to n do begin
		res:=res+1/(sqrt((a-xb[i])*(a-xb[i])+(b-yb[i])*(b-yb[i]))+0.01);
		res:=res+1/(sqrt((a-xe[i])*(a-xe[i])+(b-ye[i])*(b-ye[i]))+0.01);
    end;
    Len:=res;
end;

Procedure Solve;
var m,mm,mpx,mpy,px,py:real;
begin
	mpx:=0.001;mpy:=0.001;
	mm:=Len(mpx,mpy);

	px:=L-0.001;py:=L-0.001;
	m:=Len(px,py);
    if m-mm<delta then begin
    	mm:=m;
        mpx:=px;
        mpy:=py;
    end;

	px:=L-0.001;py:=0.001;
	m:=Len(px,py);
    if m-mm<delta then begin
    	mm:=m;
        mpx:=px;
        mpy:=py;
    end;

	px:=0.001;py:=L-0.001;
	m:=Len(px,py);
    if m-mm<delta then begin
    	mm:=m;
        mpx:=px;
        mpy:=py;
    end;

	px:=0.001;py:=L/2;
	m:=Len(px,py);
    if m-mm<delta then begin
    	mm:=m;
        mpx:=px;
        mpy:=py;
    end;

	px:=L/2;py:=0.001;
	m:=Len(px,py);
    if m-mm<delta then begin
    	mm:=m;
        mpx:=px;
        mpy:=py;
    end;

	px:=L-0.001;py:=L/2;
	m:=Len(px,py);
    if m-mm<delta then begin
    	mm:=m;
        mpx:=px;
        mpy:=py;
    end;

	px:=L/2;py:=L-0.001;
	m:=Len(px,py);
    if m-mm<delta then begin
    	mm:=m;
        mpx:=px;
        mpy:=py;
    end;

    assign(output,'fire.out');rewrite(output);
    	writeln(mpx:0:3,' ',mpy:0:3);
    close(output);
    halt;
end;

Procedure Out1(px,py:real);
begin
    assign(output,'fire.out');rewrite(output);
    	writeln(px:0:3,' ',py:0:3);
    close(output);
    halt;
end;

Procedure Solve1;
var m,mm,mpx,mpy,px,py:real;
begin
	RandSeed:=1;
	while timer-t1<4*18.2 do begin
	    px:=Random(L)+Random(1000)/1000;
	    py:=Random(L)+Random(1000)/1000;
		if not prin(px,py) then out1(px,py);
    end;
	px:=0.001;py:=0.001;
	if not prin(px,py) then out1(px,py);
	px:=L-0.001;py:=L-0.001;
	if not prin(px,py) then out1(px,py);
	px:=L-0.001;py:=0.001;
	if not prin(px,py) then out1(px,py);
	px:=0.001;py:=L-0.001;
	if not prin(px,py) then out1(px,py);
	px:=0.001;py:=L/2;
	if not prin(px,py) then out1(px,py);
	px:=L/2;py:=0.001;
	if not prin(px,py) then out1(px,py);
	px:=L-0.001;py:=L/2;
	if not prin(px,py) then out1(px,py);
	px:=L/2;py:=L-0.001;
	if not prin(px,py) then out1(px,py);
end;

begin
    t1:=timer;
	cx:=1;cy:=1;
    x[1]:=0;
    y[1]:=0;
    eps:=0;
    _f:=false;
	assign(input,'fire.in'); reset(input);
    	read(L,N);
        for i:=1 to N do begin
			read(xb[i],yb[i],xe[i],ye[i]);
			if {abs(xb[i]-xe[i])<delta}
			(fmin(yb[i],ye[i])<delta) and
			(abs(fmax(yb[i],ye[i])-L)<delta) then begin
	        	inc(cx);
	            x[cx]:=xb[i]-50;
	        	inc(cx);
	            x[cx]:=xb[i]+50;
                if not(
				(abs(xb[i]-xe[i])<delta)
				) then begin
					_f:=true;
                    eps:=eps+abs(xb[i]-xe[i]);
                end;
	        end else begin
	        	inc(cy);
	            y[cy]:=yb[i]-50;
	        	inc(cy);
	            y[cy]:=yb[i]+50;
                if {abs(xb[i]-xe[i])<delta}
                not(
				(abs(yb[i]-ye[i])<delta)
				) then begin
					_f:=true;
                    eps:=eps+abs(yb[i]-ye[i]);
                end;
	        end;
        end;
    close(input);
    inc(cx);
    x[cx]:=L;
    inc(cy);
    y[cy]:=L;
    if _f then begin
{    	if eps-L/N>delta then}
		{if L mod 3<>0 then }Solve1;
		{else }
		OutNo;
    end;
    for i:=1 to cx-1 do
    	for j:=1 to cy-1 do if test(i,j) then Out(i,j);
    OutNo;
end.