{$A+,B-,D-,E+,F+,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
const eps=1e-5;
type tpoint=record
              x,y:single;
            end;
     tline=record a,b,c:single; end;
var n,l,i,j:integer;
    {p:array [1..1000,1..2] of tpoint;}
    xb,yb,xe,ye:single;
    b,e:tpoint;
    p:array [1..1000,1..2] of tline;
    line:tline;
    add:single;
    cnt:integer;

procedure point2line(var p1,p2:tpoint;var l:tline);
begin
  l.a:= (p2.y-p1.y);
  l.b:=-(p2.x-p1.x);
  l.c:=p1.y*(p2.x-p1.x)-p1.x*(p2.y-p1.y);
end;

function pokrline(x,y:single;l1,l2:tline):boolean;
begin
  pokrline:= (l1.a*x+l1.b*y+l1.c)*(l2.a*x+l2.b*y+l2.c) < eps ;
end;

function pokr(xmin,ymin,xmax,ymax:single):boolean;
var i,j,k:byte;
begin
  if (xmax-xmin)<3e-4 then begin
    i:=1; while (i<=n) and not pokrline(xmin,ymin,p[i,1],p[i,2]) do inc(i);
    if i>n then begin
      writeln(xmin:14:4,ymin:14:4);
      halt;
    end
    else begin
      pokr:=true;
      exit;
    end;
  end;
  inc(cnt);
  i:=1; while (i<=n) and not pokrline(xmin,ymin,p[i,1],p[i,2]) do inc(i);
  if i>n then begin
    writeln(xmin:14:4,ymin:14:4);
    halt;
  end
  else if pokrline(xmin,ymax,p[i,1],p[i,2]) and
          pokrline(xmax,ymax,p[i,1],p[i,2]) and
          pokrline(xmax,ymin,p[i,1],p[i,2]) then pokr:=true
  else begin{   }
    i:=1; while (i<=n) and not pokrline(xmin,ymax,p[i,1],p[i,2]) do inc(i);
    j:=1; while (j<=n) and not pokrline(xmax,ymin,p[j,1],p[j,2]) do inc(j);
    k:=1; while (k<=n) and not pokrline(xmax,ymax,p[k,1],p[k,2]) do inc(k);
    if (i<=n) and (j<=n) and (k<=n) then
       pokr:=pokr(xmin,ymin,(xmin+xmax)/2,(ymin+ymax)/2) and
             pokr((xmin+xmax)/2,ymin,xmax,(ymin+ymax)/2) and
             pokr(xmin,(ymin+ymax)/2,(xmin+xmax)/2,ymax) and
             pokr((xmin+xmax)/2,(ymin+ymax)/2,xmax,ymax)
    else if i>n then begin writeln(xmin:14:4,ymax:14:4); halt; end
    else if j>n then begin writeln(xmax:14:4,ymin:14:4); halt; end
    else if k>n then begin writeln(xmax:14:4,ymax:14:4); halt; end;
  end;
  dec(cnt);
end;

begin
  assign(input,'fire.in'); reset(input);
  assign(output,'fire.out'); rewrite(output);
  read(l,n);
  for i:=1 to n do begin
    read(b.x,b.y,e.x,e.y);
    point2line(b,e,line);
    add:=50*sqrt(sqr(line.a)+sqr(line.b));
    p[i,1]:=line; p[i,2]:=line;
    p[i,1].c:=line.c+add; p[i,2].c:=line.c-add;
  end;

  cnt:=0;
  if pokr(0,0,l,l) then writeln('OK');

end.
