{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
type tcoord=record
      x,y:extended;
     end;

const eps=0.000000001;

var f:text;
    l:integer;
    n:integer;
    line:array[1..100] of record
      t1,t2:tcoord;
    end;
    a:array[0..3] of record
      l:integer;
      p:array[1..100] of record
        t1,t2:tcoord;
      end;
    end;
    found1,found2,found3,found4:boolean;
    t1,t2,t3,t4:tcoord;
    timer:longint absolute $0:$046c;

procedure load;
var i:integer;
begin
  assign(f,'fire.in');reset(f);
  read(f,l,n);
  for i:=1 to n do read(f,line[i].t1.x,line[i].t1.y,line[i].t2.x,line[i].t2.y);
  close(f);
end;

procedure checkpoint(t1:tcoord);
var c:byte;
begin
  if t1.x=0 then c:=0
  else if t1.x=l then c:=1
  else if t1.y=0 then c:=2
  else if t1.y=l then c:=3;
  if c>=2 then begin
    if t1.x-50.0>=0 then begin
      inc(a[c].l);
      a[c].p[a[c].l].t1:=t1;
      a[c].p[a[c].l].t2:=t1;
      a[c].p[a[c].l].t1.x:=0.0;
      a[c].p[a[c].l].t2.x:=t1.x-50.0;
    end;
    if t1.x+50 <=l then begin
      inc(a[c].l);
      a[c].p[a[c].l].t1:=t1;
      a[c].p[a[c].l].t2:=t1;
      a[c].p[a[c].l].t1.x:=t1.x+50.0;
      a[c].p[a[c].l].t2.x:=l;
    end;
  end
  else begin
    if t1.y-50>=0 then begin
      inc(a[c].l);
      a[c].p[a[c].l].t1:=t1;
      a[c].p[a[c].l].t2:=t1;
      a[c].p[a[c].l].t1.y:=0.0;
      a[c].p[a[c].l].t2.y:=t1.y-50.0;
    end;
    if t1.y+50<=l then begin
      inc(a[c].l);
      a[c].p[a[c].l].t1:=t1;
      a[c].p[a[c].l].t2:=t1;
      a[c].p[a[c].l].t1.y:=t1.y+50.0;
      a[c].p[a[c].l].t2.y:=l;
    end;
  end;
end;

function maxr(a,b:extended):extended;
begin
  if a<b then maxr:=b else maxr:=a;
end;

function minr(a,b:extended):extended;
begin
  if a>b then minr:=b else minr:=a;
end;

procedure findpoint;
var i:integer;
    lp,rp:extended;
begin
  found1:=false;found2:=false;found3:=false;found4:=false;
  lp:=0;rp:=l;
  for i:=1 to a[0].l do begin
    lp:=maxr(lp,a[0].p[i].t1.y);
    rp:=minr(rp,a[0].p[i].t2.y);
  end;
  if abs(lp-rp)>eps then begin
    found1:=true;t1.x:=0;t1.y:=(lp+rp)/2;
  end;
  lp:=0;rp:=l;
  for i:=1 to a[1].l do begin
    lp:=maxr(lp,a[1].p[i].t1.y);
    rp:=minr(rp,a[1].p[i].t2.y);
  end;
  if abs(lp-rp)>eps then begin
    found2:=true;t2.x:=l;t2.y:=(lp+rp)/2;
  end;
  lp:=0;rp:=l;
  for i:=1 to a[2].l do begin
    lp:=maxr(lp,a[2].p[i].t1.x);
    rp:=minr(rp,a[2].p[i].t2.x);
  end;
  if abs(lp-rp)>eps then begin
    found3:=true;t3.y:=0;t3.x:=(lp+rp)/2;
  end;
  lp:=0;rp:=l;
  for i:=1 to a[3].l do begin
    lp:=maxr(lp,a[3].p[i].t1.x);
    rp:=minr(rp,a[3].p[i].t2.x);
  end;
  if abs(lp-rp)>eps then begin
    found4:=true;t4.y:=l;t4.x:=(lp+rp)/2;
  end;
end;

procedure solve;
var i:integer;
begin
  fillchar(a,sizeof(a),0);
  for i:=1 to n do begin
    checkpoint(line[i].t1);
    checkpoint(line[i].t2);
  end;
  findpoint;
end;

procedure save;
var i:integer;
    a:array[1..4] of byte;
    c:byte;
    tt:tcoord;
begin
  assign(f,'fire.out');rewrite(f);
  if not(found1 or found2 or found3 or found4) then begin
    writeln(f,'OK');
  end
  else begin
    c:=0;
    if found1 then begin inc(c);a[c]:=1;end;
    if found2 then begin inc(c);a[c]:=2;end;
    if found3 then begin inc(c);a[c]:=3;end;
    if found4 then begin inc(c);a[c]:=4;end;
    c:=a[timer mod c+1];
    if c=1 then tt:=t1 else if c=2 then tt:=t2 else if c=3 then tt:=t3 else if c=4 then tt:=t4;
    writeln(f,tt.x:0:3,' ',tt.y:0:3);
  end;
  close(f);
end;

begin
  load;
  solve;
  save;
end.
