{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T+,V+,X+,Y+}
{$M 65520,0,655360}
const eps = 1e-7;
  maxy = 6000;
type
  float = extended;
  tp = record x,y: float; end;
  tair = record h: byte; a,b: tp; end;
  tsarr = array[0..200] of float;
  tfarr = array[0..maxy] of float;
  pfarr = ^tfarr;
var
  n,m: integer;
  l: float;
  a,b,c: array[0..99] of tair;
  y: array[0..4] of pfarr;
  x1,x2,x3,x4,t1,t2,t3,t4: tsarr;
  f: array[0..200] of byte;
  an: tp;
  ans: byte;
procedure qsort(l,r: integer);
var i,j: integer;
  s,m: float;
begin i:= l; j:= r; m:= y[((i+j)shr 1)div maxy]^[((i+j)shr 1)mod maxy];
  repeat
    while y[i div maxy]^[i mod maxy]<m do inc(i);
    while y[j div maxy]^[j mod maxy]>m do dec(j);
    if i<=j then
    begin
      s:= y[i div maxy]^[i mod maxy];
      y[i div maxy]^[i mod maxy]:= y[j div maxy]^[j mod maxy];
      y[j div maxy]^[j mod maxy]:= s;
      inc(i); dec(j);
    end;
  until i>j;
  if i<r then qsort(i,r);
  if l<j then qsort(l,j);
end;
procedure init;
var i,j: integer;
begin
  assign(input,'fire.in'); reset(input);
  read(l,n);
  for i:= 0 to n-1 do with a[i] do
  begin
    read(a.x,a.y,b.x,b.y);
    if abs(a.y-b.y)<eps then h:= 1;
  end;
  m:= 2;
  for i:= 0 to 4 do new(y[i]);
  y[0]^[0]:= 0; y[0]^[1]:= l;
  close(input);
  i:= 0;
end;
function crs(q,w,r,t: tp; var u,g: float): boolean;
var a,b,c,d,e,f,z: float;
begin
  a:= w.x-q.x; b:= r.x-t.x; c:= q.x-r.x;
  d:= w.y-q.y; e:= r.y-t.y; f:= q.y-r.y;
  z:= a*e-b*d; crs:= false;
  if abs(z)<eps then exit;
  crs:= true;
  u:= -(c*e-b*f)/z;
  g:= -(a*f-c*d)/z;
end;
procedure gethl(var a,b,c: tair);
var l: float;
begin
  b.a.x:= a.b.y-a.a.y;
  b.a.y:= a.b.x-a.a.x;
  l:= sqrt(sqr(b.a.x)+sqr(b.a.y));
  b.a.x:= 50.0/l*b.a.x+a.a.x;
  b.a.y:= -50.0/l*b.a.y+a.a.y;
  b.b.x:= b.a.x+a.b.x-a.a.x;
  b.b.y:= b.a.y+a.b.y-a.a.y;
  c.a.x:= a.b.y-a.a.y;
  c.a.y:= a.b.x-a.a.x;
  c.a.x:= -50.0/l*c.a.x+a.a.x;
  c.a.y:= 50.0/l*c.a.y+a.a.y;
  c.b.x:= c.a.x+a.b.x-a.a.x;
  c.b.y:= c.a.y+a.b.y-a.a.y;
end;
procedure qcrs(a,b,c,d: tp);
var u,t,nx,ny: float;
begin
  if crs(a,b,c,d,u,t) then
  begin
    nx:= a.x*(1.0-u)+b.x*u;
    ny:= a.y*(1.0-u)+b.y*u;
    if(nx>-eps)and(ny>-eps)and(nx<l+eps)and(ny<l+eps)then
    begin
      y[m div maxy]^[m mod maxy]:= ny; inc(m);
    end;
  end;
end;
procedure getair(i:integer;y:float;var x,g:tsarr);
var u,t,nx,mx: float;
  p1,p2: tp;
begin p1.x:= 0; p1.y:= y; p2.x:= l; p2.y:= y;
  if crs(b[i].a,b[i].b,p1,p2,u,t) then;
  begin
    nx:= b[i].a.x*(1-u)+b[i].b.x*u;
    crs(c[i].a,c[i].b,p1,p2,u,t);
    mx:= c[i].a.x*(1-u)+c[i].b.x*u;
    if nx<mx then begin x[i]:= nx; g[i]:= mx; end else
    begin x[i]:= mx; g[i]:= nx; end;
  end;
end;
function badline(y1,y2: float): boolean;
var i,j,q: integer;
  t: integer;
  q1,q2,q3,q4: float;
begin badline:= false;
  for i:= 0 to n-1 do if a[i].h=1 then
  begin
    if(b[i].a.y<y1+eps)and(c[i].a.y>y2-eps)then exit;
    if(c[i].a.y<y1+eps)and(b[i].a.y>y2-eps)then exit;
  end;
  for i:= 0 to n-1 do if a[i].h=0 then getair(i,y1,x1,x2);
  for i:= 0 to n-1 do if a[i].h=0 then getair(i,y2,x3,x4);
  fillchar(f,sizeof(f),1); f[0]:= 0;
  t:= 1; t1[0]:= 0; t2[0]:= l; t3[0]:= 0; t4[0]:= l;
  for i:= 0 to n-1 do if a[i].h=0 then
  begin q1:= x1[i]; q2:= x2[i]; q3:= x3[i]; q4:= x4[i];
    for j:= 0 to t-1 do if f[j]=0 then
    begin
      if(q1>t1[j]-eps)and(q1<t2[j]+eps)and(q2>t2[j]+eps)then
      begin
	t2[j]:= q1; t4[j]:= q3;
	break;
      end else if(q1<t1[j]-eps)and(q2>t1[j]-eps)and(q2<t2[j]+eps)then
      begin
	t1[j]:= q2; t3[j]:= q4;
	break;
      end else if(q1>t1[j]-eps)and(q2<t2[j]+eps)then
      begin
        if(q3>t3[j]+eps)then
        begin
          t2[j]:= q1; t4[j]:= q3;
        end else begin
          f[j]:= 1; if j=t-1 then dec(t);
        end;
        if(q4<t4[j]-eps)then
        begin
	  for q:= 0 to t do
	    if f[q]=1 then
	    begin
	      t1[q]:= q2; t2[q]:= t2[j];
	      t3[q]:= q4; t4[q]:= t4[j];
	      f[q]:= 0; if q>=t then inc(t);
	      break;
	  end;
        end;
        break;
      end else if(q1<t1[j])and(q2>t2[j])then
      begin
        f[j]:= 1; if j=t-1 then dec(t);
      end;
    end;
  end;
  q:= 0;
  for i:= 0 to t-1 do
    if f[i]=0 then
    begin
      an.x:= (t1[i]+t2[i]+t3[i]+t4[i])/4;
      an.y:= (y1+y2)/2;
      ans:= 1;
      q:= 1;
      break;
    end;
  badline:= q=1;
end;
procedure solve;
var i,j: integer;
  q,w,e,r: tp;
begin
  for i:= 0 to n-1 do gethl(a[i],b[i],c[i]);
  q.x:= 0.0; q.y:= 0.0;
  w.x:= l;   w.y:= 0.0;
  e.x:= l;   e.y:=   l;
  r.x:= 0.0; r.y:=   l;
  for i:= 0 to n-1 do
  begin
    qcrs(b[i].a,b[i].b,q,w); qcrs(b[i].a,b[i].b,w,e);
    qcrs(b[i].a,b[i].b,e,r); qcrs(b[i].a,b[i].b,r,q);
    qcrs(c[i].a,c[i].b,q,w); qcrs(c[i].a,c[i].b,w,e);
    qcrs(c[i].a,c[i].b,e,r); qcrs(c[i].a,c[i].b,r,q);
    for j:= i+1 to n-1 do
    begin
      qcrs(b[i].a,b[i].b,b[j].a,b[j].b);
      qcrs(b[i].a,b[i].b,c[j].a,c[j].b);
      qcrs(c[i].a,c[i].b,b[j].a,b[j].b);
      qcrs(c[i].a,c[i].b,c[j].a,c[j].b);
    end;
  end;
  qsort(0,m-1);
  for i:= 0 to m-2 do
    if abs(y[i div maxy]^[i mod maxy]-y[(i+1)div maxy]^[(i+1)mod maxy])>eps then
      if badline(y[i div maxy]^[i mod maxy],y[(i+1)div maxy]^[(i+1)mod maxy]) then break;
end;
procedure done;
begin
  assign(output,'fire.out'); rewrite(output);
  if ans=0 then writeln('OK') else writeln(an.x:0:5,#32,an.y:0:5);
  close(output);
end;
begin
  init; solve; done;
end.