program Class;
{異 ⮭ :  11}
{$B-}

const
	IFN = 'class.in';
    OFN = 'class.out';
    MaxN = 80;
    M = 3;

type
	TStep = (U, R, D, L, EC);
    TEl = record
    	Visited: Boolean;
        Dollar: Boolean;
    end;

    TPathArray = array [1..M*MaxN+10] of TStep;

    TMoney = record
        Steps: LongInt;
		M: array [1..M*MaxN+10] of Boolean;
    end;

var
	C: array [1..M, 1..MaxN] of TEl;
    P, BestPath: TPathArray;
    N, MinSteps, BestBegin: LongInt;

    function Grater(var Big, Small: TMoney): LongInt;
    var
        i, j, EB, ES, G: LongInt;
    begin
        EB := 1000;
        ES := 1000;
        for i := 1 to Big.Steps do
            if Big.M[i] then
            begin
                EB := i;
                Break;
            end;
        for i := 1 to Small.Steps do
            if Small.M[i] then
            begin
                ES := i;
                Break;
            end;
        if Big.Steps-EB = Small.Steps-ES then
        begin
            G := 0;
            for i := 1 to Big.Steps-EB do
            begin
                if Big.M[i+EB] <> Small.M[i+ES] then
                begin
                    if Big.M[i+EB] > Small.M[i+ES] then
                        G := 1
                    else
                        G := -1;
                    Break;
                end;
            end;
            Grater := G;
        end
        else
        begin
            if Big.Steps-EB > Small.Steps-ES then
                Grater := 1
            else
                Grater := -1;
        end;
    end;

    procedure InPut;
    var
    	F: Text;
        A: LongInt;
        i, j: LongInt;
    begin
    	Assign(F, IFN);
        ReSet(F);
        ReadLn(F, N);
		for i := 1 to M do
        begin
        	for j := 1 to N do
            begin
            	Read(F, A);
	            if A = 0 then
					C[i, j].Dollar := False
				else
					C[i, j].Dollar := True;
                C[i, j].Visited := False;
        	end;
            if not EoF(F) then ReadLn(F);
        end;
        Close(F);
    end;

    procedure Proceed;
    var
    	i, j, Steps, BB: LongInt;
        Money, MaxMoney: TMoney;

        procedure Step(i, j: LongInt);
        var
        	k: LongInt;

        begin
        	if (i >= 1) and (i <= M) and (j >= 1) and (j <= N) and (not C[i, j].Visited) then
            begin
            	C[i, j].Visited := True;
        	    Inc(Steps);
                Money.Steps := Steps;
                if C[i, j].Dollar then
                	Money.M[Steps] := True;
                if j = N then
                begin
                    case Grater(Money, MaxMoney) of
                    	1:
                        begin
                            BestBegin := BB;
                            for k := 1 to Steps do
                                BestPath[k] := P[k];
                            MaxMoney.Steps := Money.Steps;
                            for k := 1 to Money.Steps do
                            	MaxMoney.M[k] := Money.M[k];
                            MinSteps := Steps;
                        end;
                        0:
                        begin
                        	if Steps < MinSteps then
                            begin
                                BestBegin := BB;
                                for k := 1 to Steps do
                                    BestPath[k] := P[k];
                                MaxMoney.Steps := Money.Steps;
                                for k := 1 to Money.Steps do
                            	    MaxMoney.M[k] := Money.M[k];
                                MinSteps := Steps;
                            end;
                        end;
                    end;
                end;
			    P[Steps] := U;
                repeat
					case P[Steps] of
                    	U: Step(i-1, j);
                        R: Step(i, j+1);
                        D: Step(i+1, j);
                        L: Step(i, j-1);
                    end;
            	    Inc(P[Steps]);
                until P[Steps] = EC;
            	C[i, j].Visited := False;
                if C[i, j].Dollar then
					Money.M[Steps] := False;
                Dec(Steps);
                Money.Steps := Steps;
            end;
        end;

    begin
    	MinSteps := MaxLongInt;
		Steps := 0;
        for i := 1 to M*MaxN+10 do
        begin
        	Money.M[i] := False;
            MaxMoney.M[i] := False;
        end;
        Money.Steps := 0;
		MaxMoney.Steps := 0;
        for BB := 1 to M do
        	Step(BB, 1);
    end;

	procedure OutPut;
    var
    	F: Text;
        k: LongInt;
    begin
    	Assign(F, OFN);
        ReWrite(F);
		WriteLn(F, BestBegin);
        for k := 1 to MinSteps-1 do
        	case BestPath[k] of
            	U: Write(F, 'U');
            	R: Write(F, 'R');
            	D: Write(F, 'D');
            	L: Write(F, 'L');
            end;
        Close(F);
	end;

begin
	InPut;
    Proceed;
    OutPut;
end.