program Castle;
{$B-}
const
	MaxN = 1000;
    IFN = 'castle.in';
    OFN = 'castle.out';
type
	PSRoom = ^TSRoom;
	TSRoom = record
    	N: Word;
        Next: PSRoom;
    end;

	TRoom = record
    	Head: PSRoom;
        Been: Boolean;
        Neib: Word;
    end;
var
	N, K, NoPar: Word;
    A: array [1..MaxN] of TRoom;
    Path: array [1..MaxN+10] of Word;

    procedure Input;
    var
    	i: Word;
        T: Integer;
        F: Text;
        X: PSRoom;
    begin
		Assign(F, IFN);
        ReSet(F);
        ReadLn(F, N);
        ReadLn(F, K);
        for i := 1 to N do
        begin
        	A[i].Head := nil;
            A[i].Neib := 0;
            A[i].Been := False;
           	Read(F, T);
            while T <> 0 do
            begin
				New(X);
                X^.Next := A[i].Head;
                A[i].Head := X;
                X^.N := T;
                Inc(A[i].Neib);
            	Read(F, T);
            end;
            if not EoF(F) then ReadLn(F);
        end;
        A[K].Been := True;
        Close(F);
    end;

    procedure Proceed;
    var
	    i, Doors: Word;
    	F: Text;

        procedure Step(M: Word);
        var
        	i: Word;
            X: PSRoom;
        begin
            Inc(Doors);
            Path[Doors] := M;
            A[M].Been := True;
          	Dec(A[M].Neib);
        	if A[M].Neib = 0 then
            begin
                WriteLn(F, Doors-1);
                for i := 1 to Doors-1 do
                	Write(F, Path[i], ' ');
                WriteLn(F, Path[Doors]);
                Close(F);
                Halt(0);
            end
            else
            begin
			    X := A[M].Head;
                while X <> nil do
                begin
                	if (not A[X^.N].Been) or ((A[X^.N].Neib = 1) and (Path[Doors-1] <> X^.N) and (X^.N <> K)) then
                    begin
                    	Dec(A[M].Neib);
                    	Step(X^.N);
                        Inc(A[M].Neib);
                    end;
            	    X := X^.Next;
                end;
            end;
           	Inc(A[M].Neib);
            Dec(Doors);
            A[M].Been := False;
        end;
    begin
    	Assign(F, OFN);
        ReWrite(F);
    	NoPar := 0;
		for i := 1 to N do
        	if A[i].Neib mod 2 <> 0 then
            	Inc(NoPar);
		if NoPar <> 0 then
        begin
        	WriteLn(F, 'Yes');
            if A[K].Neib = 1 then
            begin
            	WriteLn(F, 1);
                WriteLn(F, K, ' ', A[K].Head^.N);
            end
            else
            begin
            	Doors := 0;
            	Step(K);
            end;
        end
        else
        begin
        	WriteLn(F, 'No');
        end;
        Close(F);
    end;


begin
	InPut;
    Proceed;
end.