type man = record
                 t: integer;
                 n: integer;
           end;

var     n: integer;
        m: array[1..1000] of man;
        time: longint;
        np: integer;
        first, second: integer;

function rbet(a, b: integer): integer;
begin
     rbet := random(b - a + 1) + a;
end;

function f(x: integer): integer;
begin
     f := m[x].t;
end;

procedure swap(a, b: integer);
var       temp: man;
begin
     temp := m[a];
     m[a] := m[b];
     m[b] := temp;
end;


procedure qsort(l, h: integer);
var       i, j, r: integer;
          temp: integer;
begin
     if l < h then
        if h - l = 1 then
        begin
             if f(l) > f(h) then
                swap(l, h);
        end
        else
        begin
             {r := rbet(l, h);}
             i := l;
             j := h;
             {temp := f(r);}
             {swap(a, r);}
             {while (i <= j) and (f(i) <= r) do
                   inc(i);
             while (j >= i) and (f(j) >= r) do
                   dec(j);}
             repeat
                   while (i < j) and (f(i) >= f(l)) do
                         inc(i);
                   while (j > i) and (f(j) <= f(h)) do
                         dec(j);
                   if i <> j then
                   begin
                        swap(l, i);
                        swap(h, j);
                   end
                   else
                   if f(l) > f(j) then
                   begin
                      if f(l) > f(h) then
                      begin
                           swap(l, h);
                           if f(l) > f(j) then
                              swap(l, j);
                      end
                      else
                          swap(l, j);
                   end
                   else if f(j) > f(h) then
                        swap(j, h);
             until i = j;
             qsort(l, i);
             qsort(j, h)

        end;
end;

procedure nqsort(l, h: integer);
var       i, j, r: integer;
          temp: integer;
begin
     if l < h then
        if h - l = 1 then
        begin
             if f(l) > f(h) then
                swap(l, h);
        end
        else
        begin
             r := rbet(l, h);
             i := l;
             j := h;
             temp := f(r);
             swap(l, r);
             repeat
                   while (i <= j) and (f(i) >= temp) do
                         inc(i);
                   while (j >= i) and (f(j) <= temp) do
                         dec(j);
{                   i :=}
             until i > j;
             {until i = j;}
             repeat
                   while (i < j) and (f(i) >= f(l)) do
                         inc(i);
                   while (j > i) and (f(j) <= f(h)) do
                         dec(j);
                   if i <> j then
                   begin
                        swap(l, i);
                        swap(h, j);
                   end
                   else
                   if f(l) > f(j) then
                   begin
                      if f(l) > f(h) then
                      begin
                           swap(l, h);
                           if f(l) > f(j) then
                              swap(l, j);
                      end
                      else
                          swap(l, j);
                   end
                   else if f(j) > f(h) then
                        swap(j, h);
             until i = j;
             qsort(l, i);
             qsort(j, h)

        end;
end;

procedure simple;
var       i, j: integer;
          p, min: integer;
begin
     for i := 1 to n - 1 do
     begin
          p := i;
          min := m[p].t;
          for j := i + 1 to n do
              if m[j].t < min then
              begin
                   p := j;
                   min := m[j].t;
              end;
          swap(i, p);
     end;
end;

procedure init;
var       i, j: integer;
begin
     randomize;
     readln(n);
     for i := 1 to n do
     begin
          readln(m[i].t);
          m[i].n := i;
     end;
     np := n;
end;

procedure solve;
var       i, j, k: integer;
begin
     for i := 1 to n do
         time := time + m[i].t;
     for i := 1 to 2 * (n - 2) do
         time := time + m[1].t;
     time := time + m[n].t;
     writeln(time);
     for i := 1 to n - 1 do
         if i <> n - 1 then
            writeln(m[1].n, ' ', m[i + 1].n, ' ', m[1].n)
         else
             writeln(m[1].n, ' ', m[i + 1].n);
     halt;
     repeat
           if f(1) <= f(2) then
           begin
                i := 1;
                j := 2;
           end
           else
           begin
                i := 2;
                j := 1;
           end;
           for k := 3 to n do
               if f(k) < f(i) then
               begin
                    j := i;
                    i := k;
               end
               else if f(k) < f(j) then
                    j := k;
           write(i, ' ', j);
           if np >= 3 then
              write(' ', i);
           writeln;
           dec(np);
     until np = 1;
end;

var     i, j: integer;
begin
     assign(input, 'olymp.in'); reset(input);
     assign(output, 'olymp.out'); rewrite(output);
     init;
     {solve;}
     {nqsort(1, n);}
     simple;
     solve;

     {for i := 1 to n do
         writeln(i, ' ', m[i].t);}
end.
