{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65520,0,655360}
{Solution by Denis Pak, reg. # 0607}
const
 MaxHist = 100;

type
 TPos = array[1..2] of integer;
 THist = array[1..MaxHist] of TPos;

var
 InFile,OutFile: Text;
 GroupsNo: integer;
 Groups: array[1..2] of integer;
 stPos: TPos;
 stHist: THist;
 PosNo: integer;
 I,K: integer;
 SolFound: boolean;
 SolSize: integer;
 Sol: THist;
 Timer: longint absolute $0:$046C;
 BreakTime: longint;

procedure ShoutNo;
begin
 Assign(OutFile,'tele.out');
 Rewrite(OutFile);
 Writeln(OutFile,'No');
 Close(OutFile);
 Halt;
end;

function Eq(A,B: TPos): boolean;
begin
 Eq:=True;
 if A[1]<>B[1] then Eq:=False;
 if GroupsNo=2 then if A[2]<>B[2] then Eq:=False;
end;

procedure Scan(P: TPos; Hist: THist; HistSize: integer);
var
 nP: TPos;
 nHist: THist;
function Present: boolean;
var
 I: integer;
begin
 Present:=False;
 for I:=1 to HistSize do
  if Eq(Hist[I],nP) then Present:=True;
end;
begin
 if (HistSize=PosNo) and Eq(P,stPos) then begin
  SolFound:=True;
  Sol:=Hist;
  SolSize:=HistSize;
 end;
 if (HistSize<PosNo) and not SolFound {and (Timer<BreakTime)} then begin
  if P[1]>1 then begin
   nP:=P;
   Dec(nP[1]);
   if not Present then begin
    nHist:=Hist;
    nHist[HistSize+1]:=nP;
    Scan(nP,nHist,HistSize+1);
   end;
  end;
  if P[1]<Groups[1] then begin
   nP:=P;
   Inc(nP[1]);
   if not Present then begin
    nHist:=Hist;
    nHist[HistSize+1]:=nP;
    Scan(nP,nHist,HistSize+1);
   end;
  end;
  if GroupsNo=2 then begin
   if P[2]>1 then begin
    nP:=P;
    Dec(nP[2]);
    if not Present then begin
     nHist:=Hist;
     nHist[HistSize+1]:=nP;
     Scan(nP,nHist,HistSize+1);
    end;
   end;
   if P[2]<Groups[2] then begin
    nP:=P;
    Inc(nP[2]);
    if not Present then begin
     nHist:=Hist;
     nHist[HistSize+1]:=nP;
     Scan(nP,nHist,HistSize+1);
    end;
   end;
  end;
 end;
end;

begin
 BreakTime:=Timer-10+Round((1000/55)*5);
 Assign(InFile,'tele.in');
 Reset(InFile);
 Readln(InFile,GroupsNo);
 if GroupsNo<3 then begin
  for I:=1 to GroupsNo do
   Read(InFile,Groups[I]);
  for I:=1 to GroupsNo do
   Read(InFile,stPos[I]);
 end;
 Close(InFile);
 if GroupsNo>2 then ShoutNo;
 PosNo:=Groups[1];
 if GroupsNo=2 then PosNo:=PosNo*Groups[2];
 FillChar(stHist,SizeOf(stHist),#0);
 SolFound:=False;
 Scan(stPos,stHist,0);
 if not SolFound then ShoutNo;
 if SolFound then begin
  for I:=SolSize downto 1 do
   Sol[I+1]:=Sol[I];
  Sol[1]:=stPos;
  Assign(OutFile,'tele.out');
  Rewrite(OutFile);
  Writeln(OutFile,'Yes');
  Inc(SolSize);
  for I:=1 to SolSize-1 do begin
   if Sol[I][1]-Sol[I+1][1]>0 then
    Writeln(OutFile,'1 -');
   if Sol[I][1]-Sol[I+1][1]<0 then
    Writeln(OutFile,'1 +');
   if Sol[I][2]-Sol[I+1][2]>0 then
    Writeln(OutFile,'2 -');
   if Sol[I][2]-Sol[I+1][2]<0 then
    Writeln(OutFile,'2 +');
  end;
  Close(OutFile);
 end;
end.