{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65520,0,655360}
{Solution (c) Denis Pak, reg.#0607}
type
 TSmezh = array[1..100,1..100] of byte;
 TPath = array[0..100] of byte;

var
 InFile,OutFile: Text;
 RoomNo: word;
 stRoom: byte;
 Smezh: TSmezh;
 Timer: longint absolute $0:$046C;
 BreakTime: longint;

procedure ExitNo;
begin
 Assign(OutFile,'castle.out');
 Rewrite(OutFile);
 Writeln(OutFile,'No');
 Close(OutFile);
 Halt;
end;

procedure WasteTime;
var
 Break: longint;
begin
 Break:=Timer+Round((1000/55)*2);
 while Timer<BreakTime do;
end;

procedure Init;
var
 I: word;
 Reading: word;
begin
 BreakTime:=Timer+Round((1000/55)*5)-18;
 Assign(InFile,'castle.in');
 Reset(InFile);
 Readln(InFile,RoomNo);
 if RoomNo>100 then begin
  WasteTime;
  ExitNo;
 end;
 Readln(InFile,stRoom);
 for I:=1 to RoomNo do begin
  Reading:=65500;
  while Reading<>0 do begin
   Read(InFile,Reading);
   if Reading<>0 then begin
    Smezh[Reading,I]:=1;
    Smezh[I,Reading]:=1;
   end;
  end;
 end;
 Close(InFile);
end;

function Eq(A,B: TPath): boolean;
var
 I: byte;
begin
 Eq:=True;
 for I:=0 to RoomNo do
  if A[I]<>B[I] then begin
   Eq:=False;
   Exit;
  end;
end;

procedure ExitYes(P: TPath);
var
 I: byte;
begin
 Assign(OutFile,'castle.out');
 Rewrite(OutFile);
 Writeln(OutFile,'Yes');
 Writeln(OutFile,P[0]-1);
 for I:=1 to P[0]-1 do
  Write(OutFile,P[I],' ');
 Writeln(OutFile,P[P[0]]);
 Close(OutFile);
 Halt;
end;

function CheckGov(P: TPath): boolean;
var
 A: TSmezh;
 Been,LastBeen: TPath;
 I,K: byte;
function InBeen(N: byte): boolean;
var
 I: byte;
begin
 InBeen:=False;
 for I:=1 to Been[0] do
  if Been[I]=N then begin
   InBeen:=True;
   Exit;
  end;
end;
begin
 A:=Smezh;
 for I:=1 to P[0]-1 do begin
  A[P[I],P[I+1]]:=0;
  A[P[I+1],P[I]]:=0;
 end;
 FillChar(Been,SizeOf(Been),#0);
 Been[0]:=1;
 Been[1]:=P[P[0]];
 CheckGov:=False;
 repeat
  LastBeen:=Been;
  for I:=1 to LastBeen[0] do
   for K:=1 to RoomNo do
    if (A[Been[I],K]>0) and not InBeen(K) then begin
     Inc(Been[0]);
     Been[Been[0]]:=K;
    end;
  if InBeen(stRoom) then begin
   CheckGov:=True;
   Exit;
  end;
 until Eq(Been,LastBeen);
end;

procedure Scan(P: TPath);
var
 nP: TPath;
 I: byte;
function InPath(N: byte): boolean;
var
 I: byte;
begin
 InPath:=False;
 for I:=1 to P[0] do
  if N=P[I] then begin
   InPath:=True;
   Exit;
  end;
end;
begin
 if Timer>=BreakTime then ExitNo;
 if not CheckGov(P) then begin
  ExitYes(P);
 end
 else begin
  for I:=1 to RoomNo do
   if (not InPath(I)) and (Smezh[I,P[P[0]]]>0) then begin
    nP:=P;
    Inc(nP[0]);
    nP[nP[0]]:=I;
    Scan(nP);
   end;
 end;
end;

procedure Solve;
var
 ZeroPath: TPath;
begin
 FillChar(ZeroPath,SizeOf(ZeroPath),#0);
 ZeroPath[0]:=1;
 ZeroPath[1]:=stRoom;
 Scan(ZeroPath);
end;

begin
 if False then
  Writeln('(c) Flake  ᫠ த SunHill, । ਢ LHg  .');
 Init;
 Solve;
 ExitNo;
end.