{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65520,0,655360}
{Solution (c) Denis Pak, reg.#0607}
type
 TGuy = array[1..2] of word;

var
 InFile,OutFile: Text;
 PeopleNo: word;
 People: array[1..1000] of TGuy;
 Ans: array[1..1000] of array[1..3] of word;
 Ans1: array[1..1000] of array[1..3] of word;
 Ans1No: word;
 AnsNo: word;
 Time,Time1: longint;

procedure Init;
var
 I: word;
begin
 Assign(InFile,'olymp.in');
 Reset(InFile);
 Readln(InFile,PeopleNo);
 for I:=1 to PeopleNo do begin
  People[I][1]:=I;
  Readln(InFile,People[I][2]);
 end;
 Close(InFile);
end;

procedure Sort(L,R: integer);
var
 I,J,X: integer;
 TempGuy: TGuy;
begin
 I:=L;
 J:=R;
 X:=People[(L+R) div 2][2];
 repeat
  while People[I][2]<X do I:=I+1;
   while X<People[J][2] do J:=J-1;
  if I<=J then begin
   TempGuy:=People[I];
   People[I]:=People[J];
   People[J]:=TempGuy;
   I:=I+1;
   J:=J-1;
  end;
 until I>J;
 if L<J then Sort(L,J);
 if I<R then Sort(I,R);
end;

function Max(A,B: word): word;
begin
 if A>B then Max:=A else Max:=B;
end;

function GuyTime(N: word): word;
var
 I: word;
begin
 for I:=1 to PeopleNo do
  if People[I][1]=N then begin
   GuyTime:=People[I][2];
   Exit;
  end;
end;

procedure Solve;
var
 I: word;
 Pereved: array[1..1000] of boolean;
 High,Low: word;
 Baah: longint;
function NeperExist: boolean;
var
 I: word;
begin
 NeperExist:=False;
 for I:=1 to PeopleNo do
  if Pereved[I]=False then begin
   NeperExist:=True;
   Exit;
  end;
end;
function FastPereved: word;
var
 I: word;
 Best: word;
begin
 Best:=0;
 for I:=1 to PeopleNo do begin
  if Pereved[I] and (Best=0) then Best:=I;
  if Best<>0 then begin
   if Pereved[I] and (People[I][2]<People[Best][2]) then Best:=I;
  end;
 end;
 FastPereved:=Best;
end;
function Diff(A,B: word): word;
begin
 Diff:=Abs(People[A][2]-People[B][2]);
end;
function BestPair: longint;
var
 I,K: word;
 Res1,Res2: longint;
 Best: word;
begin
 Res1:=0;
 Res2:=0;
 for I:=1 to PeopleNo do
  if not Pereved[I] then Res1:=I;
 for I:=1 to PeopleNo do
  if (not Pereved[I]) and (I<>Res1) then Res2:=I;
 if (Res1=0) or (Res2=0) then begin
  BestPair:=0;
  Exit;
 end;
 Best:=Diff(Res1,Res2);
 for I:=1 to PeopleNo do
  for K:=1 to PeopleNo do
   if (not Pereved[I]) and (not Pereved[K]) and (K<>I) then
    if Diff(I,K)<Best then begin
     Best:=Diff(I,K);
     Res1:=I;
     Res2:=K;
    end;
 BestPair:=Res1*10000+Res2;
end;
begin
 Sort(1,PeopleNo);
 FillChar(Ans,SizeOf(Ans),#0);
 FillChar(Pereved,SizeOf(Pereved),#0);
 { ॢ ᭠砫 室 ᠬ }
 AnsNo:=1;
  Baah:=BestPair;
  High:=Baah div 10000;
  Low:=Baah mod 10000;
  Pereved[High]:=True;
  Pereved[Low]:=True;
  Ans[AnsNo][1]:=High;
  Ans[AnsNo][2]:=Low;
 {⮬    ᥣ ᠬ   ॢ}
 { 室  ⮬  ᠬ   ॢ}
 while NeperExist do begin
  Ans[AnsNo][3]:=FastPereved;
  Pereved[FastPereved]:=False;
  Inc(AnsNo);
  Baah:=BestPair;
  High:=Baah div 10000;
  Low:=Baah mod 10000;
  Pereved[High]:=True;
  Pereved[Low]:=True;
  Ans[AnsNo][1]:=High;
  Ans[AnsNo][2]:=Low;
 end;
 Time:=0;
 for I:=1 to AnsNo do begin
  Inc(Time,Max(GuyTime(Ans[I][1]),GuyTime(Ans[I][2])));
  if Ans[I][3]<>0 then Inc(Time,GuyTime(Ans[I][3]));
 end;
 FillChar(Ans1,SizeOf(Ans1),#0);
 Ans1No:=1;
 Ans1[1][1]:=1;
 Ans1[1][2]:=2;
 Ans1[1][3]:=0;
 for I:=1 to PeopleNo-2 do begin
  Ans1[I][3]:=1;
  Ans1[I+1][1]:=1;
  Ans1[I+1][2]:=I+2;
  Inc(Ans1No);
 end;
 Time1:=0;
 for I:=1 to Ans1No do begin
  Inc(Time1,Max(GuyTime(Ans1[I][1]),GuyTime(Ans1[I][2])));
  if Ans1[I][3]<>0 then Inc(Time1,GuyTime(Ans1[I][3]));
 end;
end;

procedure Done;
var
 I: word;
begin
 Assign(OutFile,'olymp.out');
 Rewrite(OutFile);
 if Time<time1 then begin
  Writeln(OutFile,Time);
 for I:=1 to AnsNo-1 do
  Writeln(OutFile,People[Ans[I][1]][1],' ',People[Ans[I][2]][1],' ',People[Ans[I][3]][1]);
 Writeln(OutFile,People[Ans[AnsNo][1]][1],' ',People[Ans[AnsNo][2]][1]);
 end
 else begin
  Writeln(OutFile,Time1);
 for I:=1 to Ans1No-1 do
  Writeln(OutFile,People[Ans1[I][1]][1],' ',People[Ans1[I][2]][1],' ',People[Ans1[I][3]][1]);
 Writeln(OutFile,People[Ans1[Ans1No][1]][1],' ',People[Ans1[Ans1No][2]][1]);
 end;
 Close(OutFile);
end;

begin
 if False then
  Writeln('  ஬ ,   쭮 祣.');
 Init;
 Solve;
 Done;
end.