{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 16384,0,655360}
Program Castle;
Const
  InFile='CASTLE.IN';
  OutFile='CASTLE.OUT';
  MaxN=1000;
Type
  PList=^TList;
  TList=Record
    Item:Word;
    Next:PList;
  End;
  PBiList=^TBiList;
  TBiList=Record
    Item:Word;
    Next:PBiList;
    Prev:PBiList;
  End;
Var
  N,K:Word;
  Out:Array[1..MaxN]Of PList;
  Seq:PBiList;
Procedure Load;
Var
  P:PList;
  I,A:Word;
Begin
  FillChar(Out,SizeOf(Out),0);
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  If Not SeekEOF Then Read(K);
  For I:=1 To N Do Repeat
    If Not SeekEOF Then Read(A);
    If (A<>0) And (A<>I) Then Begin
      New(P);
      P^.Next:=Out[I];
      P^.Item:=A;
      Out[I]:=P;
    End;
  Until A=0;
  Close(Input);
End;
Procedure Save(BackTo,AndFrom:PBiList);
Var
  Cur,Cur2:PBiList;
  Count:LongInt;
  First:Boolean;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn('Yes');
  Cur:=BackTo;
  Count:=0;
  While Cur^.Next<>Nil Do Begin
    Cur^.Next^.Prev:=Cur;
    Cur:=Cur^.Next;
    Inc(Count);
  End;
  Cur2:=AndFrom;
  While Cur2^.Next<>Nil Do Begin
    Inc(Count);
    Cur2:=Cur2^.Next;
  End;
  WriteLn(Count);
  First:=True;
  While Cur<>BackTo Do Begin
    If First Then First:=False Else Write(' ');
    Write(Cur^.Item);
    Cur:=Cur^.Prev;
  End;
  Cur:=AndFrom;
  While Cur<>Nil Do Begin
    If First Then First:=False Else Write(' ');
    Write(Cur^.Item);
    Cur:=Cur^.Next;
  End;
  Close(Output);
End;
Procedure DelOut(Src,Dst:Word);
Var
  P,PP:PList;
Begin
  P:=Out[Src];
  PP:=Nil;
  While P<>Nil Do Begin
    If P^.Item=Dst Then Begin
      If PP=Nil Then Out[Src]:=P^.Next Else PP^.Next:=P^.Next;
      Dispose(P);
      Exit;
    End;
    PP:=P;
    P:=P^.Next;
  End;
End;
Function Go(From:PBiList):Boolean;
Var
  First,Cur,Next:PBiList;
  Temp:PList;
Begin
  Go:=True;
  New(Cur);
  Cur^.Item:=From^.Item;
  Cur^.Next:=Nil;
  First:=Cur;
  While Out[Cur^.Item]<>Nil Do Begin
    New(Next);
    Next^.Next:=Nil;
    Next^.Item:=Out[Cur^.Item]^.Item;
    Temp:=Out[Cur^.Item];
    Out[Cur^.Item]:=Out[Cur^.Item]^.Next;
    DelOut(Temp^.Item,Cur^.Item);
    Dispose(Temp);
    Cur^.Next:=Next;
    Cur:=Next;
  End;
  If Cur^.Item<>First^.Item Then Begin
    Save(From,First);
    Release(HeapOrg);
    Halt;
  End;
  Cur^.Next:=From^.Next;
  From^.Next:=First^.Next;
  Dispose(First);
  Go:=False;
End;
Procedure Solve;
Var
  Cur:PBiList;
Begin
  New(Seq);
  Seq^.Next:=Nil;
  Seq^.Item:=K;
  Cur:=Seq;
  While Cur<>Nil Do Begin
    While Out[Cur^.Item]<>Nil Do
      If Go(Cur) Then Exit;
    Cur:=Cur^.Next;
  End;
End;
Procedure SaveNo;
Begin
  Release(HeapOrg);
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn('No');
  Close(Output);
End;
Begin
  Load;
  Solve;
  SaveNo;
End.