{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}
Program Olympiad;
Const
  InFile='OLYMP.IN';
  OutFile='OLYMP.OUT';
  MaxN=1002;
Var
  N:LongInt;
  T:Array[1..MaxN]Of LongInt;
  Seq:Array[1..MaxN]Of LongInt;
  Result:LongInt;
  RAt:LongInt;
Procedure Load;
Var
  I:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do If Not SeekEOF Then Read(T[I]);
  Close(Input);
End;
procedure Sort(l, r: Integer);
var
  i, j, x, y: LongInt;
begin
  i := l; j := r; x := T[Seq[(l+r) DIV 2]];
  repeat
    while T[Seq[i]] < x do i := i + 1;
    while x < T[Seq[j]] do j := j - 1;
    if i <= j then
    begin
      y := Seq[i]; Seq[i] := Seq[j]; Seq[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;
Procedure Solve;
Var
  I,J:LongInt;
  CTime:LongInt;
Begin
  For I:=1 To N Do Seq[I]:=I Mod N+1;
  Sort(1,N);
  Result:=MaxLongInt;
  For I:=0 To N Div 2-1 Do Begin
    CTime:=0;
    For J:=1 To I Do
      CTime:=CTime+T[Seq[1]]+2*T[Seq[2]]+T[Seq[N-J*2+2]];
    For J:=N-I*2 DownTo 3 Do
      CTime:=CTime+T[Seq[J]]+T[Seq[1]];
    CTime:=CTime+T[Seq[2]];
    If CTime<Result Then Begin
      Result:=CTime;
      RAt:=I;
    End;
  End;
End;
Procedure Save;
Var
  I:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Result);
  For I:=1 To RAt Do Begin
    WriteLn(Seq[1],' ',Seq[2],' ',Seq[1]);
    WriteLn(Seq[N-I*2+2],' ',Seq[N-I*2+1],' ',Seq[2]);
  End;
  For I:=N-RAt*2 DownTo 3 Do
    WriteLn(Seq[1],' ',Seq[I],' ',Seq[1]);
  WriteLn(Seq[1],' ',Seq[2]);
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.