{$A+,B-,D-,E-,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 16384,0,655360}
{$R+,S+,Q+}
{$L+,D+}
PROGRAM Task1; (* Task 1 Day 1 by Shulyatnikov D. *)

  Const
    inp = 'class.in';
    out = 'class.out';
    M = 3;
    MaxN = 80;

  Type
    TDir    = (_L, _U, _R, _D);
    TStep   = Array [1..4] Of TDir;

  Const
    DX      : Array [TDir] Of Integer = (-1,0,1,0);
    DY      : Array [TDir] Of Integer = (0,-1,0,1);

  Var
    inf, ouf: Text;
    A       : Array [-1..MaxN+1, 0..M+1] Of Integer;
    Was     : Array [0..MaxN, 1..M] Of Boolean;
    N       : Integer;

    Res, Rs, as : Array [1..M*MaxN*2] Of TDir;
    Cnt, ct : Integer;
    first   : Integer;

    BB, b   : Integer;

  Procedure Init;
    Var i,j: Integer;
  Begin
    Assign(inf, inp); Reset(inf);
      Read(inf, N);
      FillChar(a, SizeOf(a), 0);
      For i := 1 To M Do
       For j := 1 To N Do Read(inf, a[j,i]);
    Close(inf);
  End;

  Function Good(x: Integer): Boolean;
  Begin
    Good := Not Was[x,1] Or Not Was[x,2] Or Not Was[x,3];
  End;

  Procedure Rec(x,y,cnt: Integer);
    Var nx,ny: Integer; q: TDir;
  Begin
    Was[x,y] := True;
    If Good(x) Then
     Begin
       If cnt > b Then
        Begin
          b := cnt; rs := as;
        End;

       For q := _L To _D Do
       Begin
         nx := x + dx[q];
         ny := y + dy[q];
         If (a[nx,ny] = 1) And Not Was[nx,ny] Then
          Begin
            as[cnt+1] := q;
            Rec(nx,ny,cnt+1);
          End;
       End;
     End;
     Was[x,y] := False;
  End;

  Procedure Solve;
    Var i: Integer;
  Begin
    Assign(ouf, out); Rewrite(ouf);
    WriteLn(ouf, 1);
    For i := 1 To N Do
    Begin
      If i mod 2 = 1 Then Write(ouf, 'DD')
      Else Write(ouf, 'UU');
      If i <> N Then Write(ouf, 'R');
    End;
  End;

  Procedure Done;
    Var i: Integer;
  Begin
    Close(ouf);
  End;

BEGIN
  Init; Solve; Done;
END.