{$A+,B-,D-,E-,F-,G-,I+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65500,0,655360}
{.$R+,S+,Q+}
{.$L+,D+}
PROGRAM Task5; (* Task 5 Day 2 By Shulyatnikov D. *)

  Const
    inp = 'castle.in';
    out = 'castle.out';
    MaxN = 1000;

  Type
    PList  = ^TList;
    TList  = Record
               num: Integer;
               Next: PList;
             End;

  Var
    inf, ouf   : Text;
    First, N   : Integer;
    Head, Tail : Array [1..MaxN] Of PList;
    WasH, WasT : Array [1..MaxN] Of PList;
    Deg        : Array [1..MaxN] Of Integer;
    FF         : Array [1..MaxN] Of Boolean;
    WasFirst   : Boolean;

    Res        : Array [0..MaxN+1] Of Integer;
    Ok, WW     : Boolean;

  Procedure Init;
    Var i,t: Integer;
  Begin
    Assign(inf, inp); Reset(inf);
      Read(inf, N, First);
      FillChar(Deg, SizeOf(Deg), 0);
      For i := 1 To N DO
       Begin
         New(Head[i]); Tail[i] := Head[i];
         Repeat
           Read(inf, t);
           Tail[i]^.num := t;
           If t <> 0 Then
            Begin
              Inc(Deg[i]);
              New(Tail[i]^.Next);
              Tail[i] := Tail[i]^.Next;
            End
           Else Tail[i]^.Next := nil;
         Until t = 0;
       End;
    Close(inf);
  End;

  Function Was(v,i: Integer): Boolean;
    Var l: PList;
  Begin
    Was := True;
    l := WasH[v];
    While l^.Next <> nil Do
     Begin
       If l^.num = i Then Exit;
       l := l^.next;
     End;
    Was := False;
  End;

  Procedure Mark(v,i: Integer);
  Begin
    WasT[v]^.num := i;
    New(WasT[v]^.Next);
    WasT[v] := WasT[v]^.Next;
    WasT[v]^.Next := nil;
  End;

  Procedure SearchCir(v,cnt: Integer);
    Var l: PList;
  Begin
    Res[cnt] := v; l := Head[v];
    If v = First Then WasFirst := True;
    If (v=res[Res[0]]) Then
     Begin
       WW := True; Res[0] := cnt;
     End;
    While (l^.Next <> nil) And (Not WW) Do
     Begin
       If Not Was(v,l^.num) Then With l^ Do
        Begin
          Mark(num, v);
          Mark(v, num);
          SearchCir(num,cnt+1);
        End;
       l := l^.Next;
     End;
    If Not WW And Not WasFirst Then
     Begin
       WW := True; Res[0] := cnt;
     End;
  End;

  Function SearchCircles: Boolean;
    Var i: Integer;
  Begin
    SearchCircles := False;
    For i := 1 To N Do
     Begin
       New(WasH[i]); WasT[i] := WasH[i];
       WasH[i]^.num := 0;
       WasH[i]^.Next := nil;
     End;
    Mark(Res[Res[0]], Res[Res[0]-1]);
    Mark(Res[Res[0]-1], Res[Res[0]]);
    While Head[Res[Res[0]]]^.Next <> nil Do
     Begin
       WW := True;
       If Not Was(Res[Res[0]], Head[Res[Res[0]]]^.num) Then
        Begin
          ww := False;
          WasFirst := False;
          Mark(Head[Res[Res[0]]]^.num, Res[Res[0]]);
          Mark(Res[Res[0]], Head[Res[Res[0]]]^.num);
          SearchCir(Head[Res[Res[0]]]^.num, Res[0]+1);
        End;
       Head[Res[Res[0]]] := Head[Res[Res[0]]]^.Next;
     End;
    SearchCircles := ww;
  End;

  Procedure SearchBad(v,cnt: Integer);
    Var l: PList;
  Begin
    l := Head[v]; FF[v] := False;
    Res[cnt] := v;
    If (v <> First) And Odd(Deg[v]) Then
     Begin
       Res[Res[0]] := cnt;
       Ok := SearchCircles;
 {      If Not Ok Then Res[Res[0]] := cnt;}
     End
    Else
     Begin
       While (l^.Next <> nil) And Not Ok Do
        Begin
          If FF[l^.num] Then SearchBad(l^.num, cnt+1);
          l := l^.Next;
        End;
     End;
  End;

  Procedure Solve;
    Var i: Integer;
  Begin
    FillChar(FF, SizeOf(FF), True);
    SearchBad(First,1);
  End;

  Procedure Done;
    Var i: Integer;
  Begin
    Assign(ouf, out); Rewrite(ouf);
     If Ok Then
      Begin
        WriteLn(ouf, 'Yes');
        For i := 1 To Res[0]-1 Do Write(ouf, Res[i],' ');
        Write(ouf, Res[Res[0]]);
      End
     Else Write(ouf, 'No');
    Close(ouf);
  End;

BEGIN
  Init; Solve; Done;
END.