{ த᪠  誮쭨 -࣠ 2001   }
{ ࠪ᪨                                            }
{ : "㣮쭨"                                    }
{ : ३ ⠭                                    }
{ 襭: ࣨ ୥                                   }
{ :                                         }
{$n+}
var
  x, y: array [1..110] of double;
  l: array [1..110] of double;
  a, b, c: array [1..110] of double;
  ap, bp, cp: array [1..210] of double;
  mx, my: double;
  i, j, k, m, n: longint;

const
  eps = 1e-4;

function intersect(a1, b1, c1, a2, b2, c2: double; var x, y: double): boolean;
var
  d: double;
begin
  d := a1 * b2 - a2 * b1;
  if abs(d) < eps then begin
    intersect := false;
    exit;
  end;

  x := (c1 * b2 - c2 * b1) / d;
  y := (a1 * c2 - a2 * c1) / d;
  intersect := true;
end;

function inside(lx, ly: double): boolean;
var
  i: longint;
begin
  inside := false;
  for i := 1 to n do begin
    if lx * a[i] + ly * b[i] - c[i] < -eps then exit;
  end;
  inside := true;
end;

procedure count(a1, b1, c1, a2, b2, c2: double);
var
  lx, ly, cx, cy, d: double;
  c: longint;
  i: integer;
begin 
  if not intersect(a1, b1, c1, a2, b2, c2, lx, ly) then exit;

  if not inside(lx, ly) then exit;

  c := 0;
  for i := 1 to n do begin
    d := (lx - x[i]) * b[i] - (ly - y[i]) * a[i];
    if (-eps < d) and (d < l[i] + eps) then inc(c);
  end; 
  if c > m then begin
    m := c;
    mx := lx;
    my := ly;
  end;
end;

procedure norm(var a, b, c: double);
var
  d: double;
begin
  d := sqrt(a * a + b * b);
  a := a / d;
  b := b / d;
  c := c / d;
end;

begin
  assign(input, 'input.txt'); reset(input);
  assign(output, 'output.txt'); rewrite(output);

  read(n);
  for i := 1 to n do begin
    read(x[i], y[i]);
  end;
  x[n + 1] := x[1];
  y[n + 1] := y[1];

  m := 0;

  for i := 1 to n do begin
    a[i] := y[i] - y[i + 1];
    b[i] := x[i + 1] - x[i];
    c[i] := a[i] * x[i] + b[i] * y[i];
    l[i] := sqrt(a[i] * a[i] + b[i] * b[i]);
    norm(a[i], b[i], c[i]);

    ap[i * 2 - 1] := b[i];
    bp[i * 2 - 1] := -a[i];
    cp[i * 2 - 1] := ap[2 * i - 1] * x[i] + bp[2 * i - 1] * y[i];
    norm(ap[i * 2 - 1], bp[i * 2 - 1], cp[i * 2 - 1]);

    ap[i * 2] := b[i];
    bp[i * 2] := -a[i];
    cp[i * 2] := ap[2 * i] * x[i + 1] + bp[2 * i] * y[i + 1];
    norm(ap[i * 2], bp[i * 2], cp[i * 2]);
  end;

  for i := 1 to n * 2 do begin
    for j := i + 1 to n * 2 do begin
      count(ap[i], bp[i], cp[i], ap[j], bp[j], cp[j]);
    end;
  end;
  writeln(m);
  writeln(mx:0:4, ' ', my:0:4);
end.