{ த᪠  誮쭨 -࣠ 2001   }
{ ࠪ᪨                                            }
{ : "᪮ "                                      }
{ : ⠭⨭ 襢                                 }
{ 襭: ३ ⠭                                  }
{ : ॡ  ⮬, ᪠,     }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P+,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}

type
  tfield = array [0..12, 0..12] of shortint;
  tships = array [0..10] of byte;

var
  a: tships;
  b, ans, prev: tfield;
  parity, i, j, k, s, p, l, r, q, m, n: longint;
  x, y: array [0..100] of integer;
  sum, cc, was, cut, cut2, cut3: longint;
  c: char;

function canh(const b: tfield; i, j, x: integer): boolean;
var
  k, d: integer;
begin
  canh := false;
  for k := 0 to x do
    for d := 0 to 1 do
      if (b[i + d][j + k] = 1) or
         ((d = 0) and (k < x) and (b[i + d][j + k] = 2)) then
        exit;
  canh := true;
end;

function canv(const b: tfield; i, j, x: integer): boolean;
var
  k, d: integer;
begin
  canv := false;
  for k := 0 to x do
    for d := 0 to 1 do
      if (b[i + k][j + d] = 1) or
         ((d = 0) and (k < x) and (b[i + k][j + d] = 2)) then
        exit;
  canv := true;
end;

procedure puth(var b: tfield; i, j, x: integer);
var
  k, d: integer;
begin
  for k := 0 to x do
    for d := 0 to 1 do
      b[i + d][j + k] := 1;
end;

procedure putv(var b: tfield; i, j, x: integer);
var
  k, d: integer;
begin
  for k := 0 to x do
    for d := 0 to 1 do
      b[i + k][j + d] := 1;
end;

function can(a: tships; b: tfield; x, pi, pj, p, need: integer): boolean;
var
  li, lj, i, j, k, y: integer;
  free: longint;
  c: tfield;
  z: array [0..1, 0..1] of integer;
begin
  inc(was);
  while (x > 0) and (a[x] = 0) do dec(x);
  if x = 0 then
  begin
    can := true;
    exit;
  end;

  fillchar(z, sizeof(z), 0);
  fillchar(y, sizeof(y), 0);
  free := 0;
  li := pi; lj := pj;
  for i := li to n + 1 do
  begin
    for j := lj to m + 1 do
    begin
      k := ord(b[i - 1][j] <> 1) * 8 +
           ord(b[i][j - 1] <> 1) * 4 +
           ord(b[i + 1][j] <> 1) * 2 +
           ord(b[i][j + 1] <> 1);
      if (b[i][j] <> 1) and not (k in [0, 1, 2, 4, 8, 5, 10]) then
      begin
        inc(z[i mod 2][j mod 2]);
        inc(free);
      end;
    end;
    lj := 1;
  end;

  if (z[0][0] < p) or (z[0][1] < p) or
     (z[1][0] < p) or (z[1][1] < p) then
  begin
    inc(cut);
    can := false;
    exit;
  end;
  if (need > free) then
  begin
    inc(cut2);
    can := false;
    exit;
  end;

  for y := 1 to x do
    if a[y] > 0 then
    begin
      dec(a[y]);
      li := pi;
      lj := pj;
      for i := li to n do
      begin
        for j := lj to m do
        begin
          if (j <= m - y + 1) and canh(b, i, j, y) then
          begin
            c := b;
            puth(c, i, j, y);
            if can(a, c, x, i, j, p - (y + 1) div 2, need - 2 * (y + 1)) then
            begin
              ans[i][j] := y;
              can := true;
              exit;
            end;
          end;

          if (i <= m - y + 1) and canv(b, i, j, y) then
          begin
            c := b;
            putv(c, i, j, y);
            if can(a, c, x, i, j, p - (y + 1) div 2, need - 2 * (y + 1)) then
            begin
              ans[i][j] := -y;
              can := true;
              exit;
            end;
          end;
        end;
        lj := 1;
      end;

      inc(a[y]);
    end;
  can := false;
end;

procedure out(const d: tfield);
var
  c: tfield;
  i, j, k: longint;
begin
  c := d;
  for i := 1 to n do
    for j := 1 to m do
    begin
      if d[i][j] > 0 then
      begin
        for k := 0 to d[i][j] - 1 do
          c[i][j + k] := d[i][j];
      end;
      if d[i][j] < 0 then
      begin
        for k := 0 to - d[i][j] - 1 do
          c[i + k][j] := -d[i][j];
      end;
    end;
  for i := 1 to n do
  begin
    for j := 1 to m do
    begin
{      if (c[i][j] = 0) and (b[i][j] <> 0) then
        write('. ') else
      if (c[i][j] <> 0) and (b[i][j] <> 0) then
        write('* ') else}
      write(c[i][j], ' ');
    end;
    writeln;
  end;
end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  read(m, n);
  read(p);

  fillchar(a, sizeof(a), 0);
  s := 0;
  sum := 0;
  for i := 1 to p do
  begin
    read(j);
    inc(a[j]);
    s := s + 2 * (j + 1);
    sum := sum + j;
    parity := parity + (j + 1) div 2;
  end;

  j := 0;
  for i := 1 to m * n do
  begin
    if seekeof then;
    read(c);
    read(k);
    x[i] := k;
    y[i] := ord(c) - ord('a') + 1;
  end;

  l := 0;
  r := m * n - sum + 1;
  while l <> r do
  begin
{    writeln(l, ' ', r);}
    q := (l + r) div 2;

    fillchar(b, sizeof(b), 1);
    fillchar(ans, sizeof(ans), 0);
    for i := 1 to n + 1 do
      for j := 1 to m + 1 do
        b[i][j] := 0;
    for i := 1 to q do
      b[x[i]][y[i]] := 2;
    if can(a, b, 10, 1, 1, parity, s) then
      l := q + 1
    else
      r := q;
  end;

  writeln(l);
  if l > 0 then out(ans);

  close(input);
  close(output);
end.