program The_Point_in_the_Polygon_with_the_best_view;

type pPnt = ^Pnt;
     Pnt = record
      x, y: real;
      next: pPnt;
     end;

function Seen (x1, y1, x2, y2, x3, y3: real): boolean;
var a, b: real;
begin
 if (x2 = x3) then
 begin
  seen := ((y1 >= y2) and (y1 <= y3)) or ((y1 <= y2) and (y1 >= y3));
 end
 else
 begin
  a := (x2 + (y2 - y1) * (y2 - y3) / (x2 - x3));
  b := (x3 + (y3 - y1) * (y2 - y3) / (x2 - x3));
  seen := ((x1 >= a) and (x1 <= b)) or ((x1 <= a) and (x1 >= b));
 end;
end;

procedure Add (var head: pPnt; a, b: real);
var cur: pPnt;
begin
 if (head = nil) then
 begin
  new (head);
  head^.x := a;
  head^.y := b;
  head^.next := nil;
 end
 else
 begin
  cur := head;
  while (cur^.next <> nil) do
   cur := cur^.next;
  new (cur^.next);
  cur^.next^.x := a;
  cur^.next^.y := b;
  cur^.next^.next := nil;
 end;
end;

var f: text;
    head: Pnt;
    num, tmp, maxN: byte;
    minX, minY, maxX, maxY, a, b, step: real;
    i, j, bestI, bestJ: longint;

function NumberOfSeen (k, l: longint): byte;

var NOS: byte;
    cur: pPnt;

begin
 NOS := 0;
 cur := head.next;
 repeat
  if seen (k/step, l/step, cur^.x, cur^.y, cur^.next^.x, cur^.next^.y) then
   NOS := NOS + 1;
  cur := cur^.next;
 until (cur^.next = nil);
 if seen (k/step, l/step, cur^.x, cur^.y, head.next^.x, head.next^.y) then
  NOS := NOS + 1;
 NumberOfSeen := NOS;
end;

begin
 assign (f, 'input.txt');
 reset (f);
 readln (f, num);
 head.next := nil;
 read (f, minX);
 maxX := minX;
 readln (f, minY);
 maxY := minY;
 add (head.next, minX, minY);
 for tmp := 1 to num-1 do
 begin
  read (f, a);
  readln (f, b);
  add (head.next, a, b);
  if (a < minX) then minX := a;
  if (a > maxX) then maxX := a;
  if (b < minY) then minY := b;
  if (b > maxY) then maxY := b;
 end;
 close (f);
 step := sqrt (450000 / ((maxX-minX)*(maxY-minY)*num));
 assign (f, 'output.txt');
 maxN := 0;
 bestI := 0;
 bestJ := 0;
 for i := round (minX * step) to round (maxX * step) do
 begin
 for j := round (minY * step) to round (maxY * step) do
 begin
  tmp := NumberOfSeen (i, j);
  if (tmp > maxN) then
  begin
   if (tmp = num) then
   begin
    rewrite (f);
    writeln (f, num);
    write (f, i/step:0:4, ' ', j/step:0:4);
    writeln (f, '');
    close (f);
    halt (0);
   end;
   maxN := tmp;
   bestI := i;
   bestJ := j;
  end;
 end;
 writeln (i/step:0:4);
 end;
 rewrite (f);
 writeln (f, maxN);
 write (f, bestI/step:0:4, ' ', bestJ/step:0:4);
 writeln (f, '');
 close (f);
end.