{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+}
{$M 65000,0,655360}
const
    InFile='input.txt';
    OutFile='output.txt';
    max=4000;

type
    stroka=array[1..max]of char;

var
    s1,s2,c1,c2:stroka;
    l1,l2,l,d,min,pos1,pos2:integer;

function Hemming(s1,s2:stroka;l:integer):integer;
var
    i,h:integer;
begin
    h:=0;
    for i:=1 to l do
        if s1[i]<>s2[i] then inc(h);
    Hemming:=h;
end;

procedure ReadData;
var
    f:text;
    i:integer;
begin
    assign(f,InFile);
    reset(f);
    readln(f,l1,l2);
    for i:=1 to l1 do read(f,s1[i]);
    readln(f);
    for i:=1 to l2 do read(f,s2[i]);
    close(f);
end;

procedure Result;
var
    f:text;
    i:integer;
begin
    assign(f,OutFile);
    rewrite(f);
    writeln(f,d);
    for i:=1 to l do write(f,c1[i]);
    writeln(f);
    for i:=1 to l do write(f,c2[i]);
    close(f);
end;

procedure gen(n1,n2:integer);
begin
    if (n1>l)and(n2>l)then begin
        d:=Hemming(c1,c2,2*l);
        if d<min then begin
            min:=d;
            Result;
        end;
        exit;
    end;
    if (pos1>l*2)or(pos2>l*2) then exit;
    c1[pos1]:=s1[n1];
end;

procedure Solve;
var
    i:integer;
begin
    c1:=s1;
    c2:=s2;
    if l1<l2 then begin
        l:=l2;
        for i:=(l1+1) to l2 do c1[i]:='*';
    end
     else begin
        l:=l1;
        for i:=(l2+1) to l1 do c2[i]:='*';
    end;
    for i:=l+1 to l*2 do begin
        c1[i]:='*';
        c2[i]:='*';
    end;
    d:=Hemming(c1,c2,l);
    Result;
    {min:=d;
    pos1:=1;
    pos2:=1;
    gen(1,1); }
end;

begin
    ReadData;
    Solve;
end.