/*****************************************************************\
* Computer Graphics Support Group of 30 Phys-Math Gymnasium       *
*          PROGRAMMER: Peter Azmanov                              *
*          DATE:       04.03.01                                   *
*          TASK NUMBER:Task A                                     *
*          NOTE:       Memory model for Borland C - LARGE         *
\*****************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef void  VOID;
typedef int   INT;
typedef char  CHAR;
typedef int   BOOL;
typedef float FLOAT;

typedef struct
{
  FLOAT x, y;
} VERT;

#define MIN_AMOUNT 3
#define MAX_AMOUNT 100

FILE *F;
INT N, i;
VERT V[MAX_AMOUNT];

VOID OpenInputFile( VOID )
{
  if ((F = fopen("input.txt", "rt")) == NULL)
  {
    printf("Error loading input file!");
    return;
  }
  fscanf(F, "%d %d", &N);
  if (N < MIN_AMOUNT || N < MIN_AMOUNT)
  {
    printf("Not valid number of vertices!");
    return;
  }

  for (i = 0; i < N; i++)
    fscanf(F, "%i %i", &V[i].x, &V[i].y);
fclose(F);
}

VOID OutputFile( VOID )
{
  if ((F = fopen("output.txt", "wt")) == NULL)
  {
    printf("Error loading input file!");
    return;
  }
  fprintf(F, "%d\n", N);
  fprintf(F, "%d %d", V[0].x, V[0].y);
fclose(F);
}
int main( VOID )
{
  OpenInputFile();
  OutputFile();

  return 0;
}