program problem_c;

var
  p,t:array[0..11,0..11] of integer;
  m,n,k,i,j:integer;
  s:array[1..10] of integer;


procedure clrh(x,y,l:integer);
var
  i:integer;
begin
  for i:=x to x+l-1 do p[i,y]:=0;
end;

procedure clrv(x,y,l:integer);
var
  i:integer;
begin
  for i:=y to y+l-1 do p[x,i]:=0;
end;

procedure puth(x,y,l:integer);
var
  i:integer;
begin
  for i:=x to x+l-1 do p[i,y]:=l;
end;

procedure putv(x,y,l:integer);
var
  i:integer;
begin
  for i:=y to y+l-1 do p[x,i]:=l;
end;

function tryh(x,y,l:integer):boolean;
var
  i,j:integer;
begin
  if x+l-1>n then begin
    tryh:=false;
    exit;
  end;
  for i:=y-1 to y+1 do
    for j:=x-1 to x+l do
      if p[j,i]>0 then begin
        tryh:=false;
        exit;
      end;
  for i:=x to x+l-1 do
    if p[i,y]<>0 then begin
      tryh:=false;
      exit;
    end;
  tryh:=true;
end;

function tryv(x,y,l:integer):boolean;
var
  i,j:integer;
begin
  if y+l-1>m then begin
    tryv:=false;
    exit;
  end;
  for i:=y-1 to y+l do
    for j:=x-1 to x+1 do
      if p[j,i]>0 then begin
        tryv:=false;
        exit;
      end;
  for i:=y to y+l-1 do
    if p[x,i]<>0 then begin
      tryv:=false;
      exit;
    end;
  tryv:=true;
end;


function try:boolean;
var
  fin:boolean;

  procedure rec(i:integer);
  var
    x,y:integer;
  begin
    if i>k then begin
      fin:=true;
      exit;
    end;
    if fin then exit;
    for x:=1 to m do
      for y:=1 to n do begin
        if tryv(x,y,s[i]) then begin
          putv(x,y,s[i]);
          rec(i+1);
          if fin then exit;
          clrv(x,y,s[i]);
        end;
        if tryh(x,y,s[i]) then begin
          puth(x,y,s[i]);
          rec(i+1);
          if fin then exit;
          clrh(x,y,s[i]);
        end;
      end;
  end;

begin
  fin:=false;
  fillchar(p,sizeof(p),0);
  move(t,p,sizeof(p));
  rec(1);
  try:=fin;
end;

procedure print;
var
  i,j:integer;
begin
  for i:=1 to n do  begin
    for j:=1 to m do if p[j,i]>0 then write(p[j,i]) else write('0');
    writeln;
  end;
end;

procedure tryall;
var
  i,j:integer;
begin
  for j:=1 to 3 do begin
    for i:=1 to 3 do begin
      if tryv(i,j,3) then write('v') else write('n');
      if tryh(i,j,3) then write('h') else write('n');
      write(' ');
    end;
    writeln;
  end;
end;

var
  st:string;
  f,g,r:integer;

begin
  assign(input,'input.txt'); reset(input);
  assign(output,'output.txt'); rewrite(output);
  readln(m,n);
  read(k);
  fillchar(t,sizeof(t),0);
  for i:=1 to k do read(s[i]); readln;
  if not try then begin
    writeln('0');
    halt(0);
  end;
  for i:=1 to m*n do begin
    readln(st);
    g:=ord(st[1])-ord('a')+1;
    delete(st,1,1);
    val(st,f,r);
    if p[f,g]=0 then begin
      t[f,g]:=-1;
      continue;
    end;
    t[f,g]:=-1;
    if not try then begin
      t[f,g]:=0;
      writeln(i);
      try;
      print;
      halt(0);
    end;
  end;
end.
