#include <stdio.h>
#include <alloc.h>

FILE * fi;
FILE * fo;

#define horiz 0
#define vert 1

#define free 0
#define occup 1
//

int M;//y-length
int N;//x-length
int * goodfield=NULL;

int put1(int * field,int x,int y,int shiplength,int orient);
void tryset (int * field,int x,int y,int val);

int may_put (int * field,int * ships,int P)
 {
 int maxlong=0,i,x,y;
 if(P==0)
   return 1;

 for(i=0;i<P;i++)
   {
   if(maxlong<ships[i])
     maxlong=ships[i];
   }
 for(y=0;y<=M-maxlong;y++)
   for(x=0;x<=N-maxlong;x++)
   {
   if(put1(field,x,y,maxlong,horiz))
     {
     int * newfield=(int *)malloc(sizeof(int)*M*N);
     int * newships=(int *)malloc(sizeof(int)*(P-1));

     int status=1,result;
     for(int co=0;co<M*N;co++)//copying old field
       {
       newfield[co]=field[co];
       }
     for(co=-1;co<=maxlong;co++) //occupying place
       {
       tryset(newfield,x+co,y,occup);
       tryset(newfield,x+co,y+1,occup);
       tryset(newfield,x+co,y-1,occup);
       }
     //copying new ships array with no biggest ship
     for(co=0;co<P;co++)
       {
       if(status)
         {
         if(ships[co!=maxlong])
           newships[co]=ships[co];
         else
         status=0;
         }
       else
         {
         newships[co-1]=ships[co];
         }
       }
     //initing new func
     result=may_put(newfield,newships,P-1);
     //delete newfield;
     //delete newships;
     if(result)
       return 1;
     }
   if(put1(field,x,y,maxlong,vert))
     {
     int * newfield=(int *)malloc(sizeof(int)*M*N);
     int * newships=(int *)malloc(sizeof(int)*(P-1));
     int status=1,result;
     for(int co=0;co<M*N;co++)//copying old field
       {
       newfield[co]=field[co];
       }
     for(co=-1;co<=maxlong;co++) //occupying place
       {
       tryset(newfield,x,y+co,occup);
       tryset(newfield,x+1,y+co,occup);
       tryset(newfield,x-1,y+co,occup);
       }
     //copying new ships array with no biggest ship
     for(co=0;co<P;co++)
       {
       if(status)
         {
         if(ships[co!=maxlong])
           newships[co]=ships[co];
         else
         status=0;
         }
       else
         {
         newships[co-1]=ships[co];
         }
       }
     //initing new func
     result=may_put(newfield,newships,P-1);
     //delete newfield;
     //delete newships;
     if(result)
       return 1;
     }
    }
  return 0;
  }

int put1(int * field,int x,int y,int shiplength,int orient)
  {
  int pos,status=1;
  if(orient==horiz)
    {
    for(pos=0;pos<shiplength;pos++)
      if(field[N*y+x+pos]!=free)
        {
        status=0;
        break;
        }
    }
  else
    {
    for(pos=0;pos<shiplength;pos++)
      if(field[N*(y+pos)+x]!=free)
        {
        status=0;
        break;
        }
    }
  return status;
  }

void tryset (int * field,int x,int y,int val)
  {
  if(x<0)
    return;
  if(y<0)
    return;
  if(x>=N)
    return;
  if(y>=M)
    return;
  field[N*y+x]=val;
  }

int main (void)
  {
  int P,result;
  char what;
  int ships [10];
  int shots [100][2];
  int field [100];
  fi=fopen("input.txt","r");
  fscanf(fi,"%i%i%i",&N,&M,&P);
  for(int i=0;i<P;i++)
    {
    fscanf(fi,"%i",ships+i);
    }
  for(i=0;i<M*N;i++)
    {
    while(1)
      {
      fscanf(fi,"%c",&what);
      if(what!='\n'&&what!='\r')
        break;
      }
    shots[i][vert]=what-'a';
    fscanf(fi,"%c",&what);
    shots[i][horiz]=what-'1';
    }

  fclose(fi);
  for(i=0;i<M*N;i++)
    field[i]=occup;

  fo=fopen("output.txt","w");

  int status=1;
  for(i=M*N-1;i>=0;i--)
    {

    if(may_put(field,ships,P))
      {
      fprintf(fi,"%i\n",i+1);
      //field output
      status=0;
      break;
      }
    field[shots[i][vert]*N+shots[i][horiz]]=free;
    }
  if(status)
    fprintf(fo,"0\n");

  fclose(fo);
  return 0;
  }