program problem_B;

const x=0;
      y=1;
      eps=1e-10;

type line=record
           A,B,C:real;
          end;

var N,i,j,k,ik,jk:integer;
    ver:array[1..200,0..1] of real;
    norms:array[1..200,1..2] of line;
    err:boolean;
    x0,y0:real;
    l1,l2,l3,l4:line;
    max_x,max_y:real;
    max,sum:integer;

procedure Norm(a,b:integer; var L:line);
var x1,y1,x2,y2:real;
begin
 if a=N+1 then a:=1;
 if b=N+1 then b:=1;
 x1:=ver[a,x]; y1:=ver[a,y];
 x2:=ver[b,x]; y2:=ver[b,y];
 with L do
  begin
   A:=x1-x2; {A:=y2-y1;}
   B:=y1-y2; {B:=x1-x2;}
   {C:=x1*(y1-y2)+y1(x2-x1);}
   C:=x1*(x2-x1)+y1*(y2-y1);
  end;
end;

procedure Per(l1,l2:line; var x0,y0:real);
var del,delX,delY:real;
begin
 err:=false;
 del:=l1.A*l2.B-l2.A*l1.B;
 delX:=l1.B*l2.C-l2.B*l1.C;
 delY:=l2.A*l1.C-l1.A*l2.C;

 if abs(del)<=eps then begin err:=true; exit; end;

 x0:=delX/del;
 y0:=delY/del;
end;

function is_90(a:integer; x0,y0:real):boolean;
var x1,y1,x2,y2,tmp:real;
begin
 x1:=ver[a,x]; y1:=ver[a,y];
 inc(a);
 if a=N+1 then a:=1;
 x2:=ver[a,x]; y2:=ver[a,y];

 tmp:= ( (x0-x1)*(x2-x1)+(y0-y1)*(y2-y1) ) *
       ( (x0-x2)*(x2-x1)+(y0-y2)*(y2-y1) );

 is_90:=(tmp<=0);
end;

begin
 assign(input,'input.txt');
 reset(input);
 assign(output,'output.txt');
 rewrite(output);

 read(N);
 for i:=1 to N do
  read(ver[i,x],ver[i,y]);

 for i:=1 to N do
  begin
   norm(i,i+1,l1);
   norms[i,1]:=l1;
   norm(i+1,i,l1);
   norms[i,2]:=l1;
  end;

 max:=0;
 for i:=1 to N do
  for j:=i+1 to N do
    begin
     l1:=norms[i,1];
     l2:=norms[j,1];
     l3:=norms[i,2];
     l4:=norms[j,2];

     per(l1,l2,x0,y0);
     if not err then
      begin
       sum:=0;
       for k:=1 to N do
        if is_90(k,x0,y0) then inc(sum);
       if sum>max then begin max:=sum; max_x:=x0; max_y:=y0; end;
      end;

     per(l1,l4,x0,y0);
     if not err then
      begin
       sum:=0;
       for k:=1 to N do
        if is_90(k,x0,y0) then inc(sum);
       if sum>max then begin max:=sum; max_x:=x0; max_y:=y0; end;
      end;

     per(l3,l2,x0,y0);
     if not err then
      begin
       sum:=0;
       for k:=1 to N do
        if is_90(k,x0,y0) then inc(sum);
       if sum>max then begin max:=sum; max_x:=x0; max_y:=y0; end;
      end;

     per(l3,l4,x0,y0);
     if not err then
      begin
       sum:=0;
       for k:=1 to N do
        if is_90(k,x0,y0) then inc(sum);
       if sum>max then begin max:=sum; max_x:=x0; max_y:=y0; end;
      end;
    end;

  writeln(max);
  writeln(max_x:10:5,' ',max_y:10:5);
end.