uses Crt;
type StackRec = record
 S: array ['A'..'Z'] of longint;
 Mode: byte;
 Last: integer;
 Func: integer;
end;
var Mode: byte;
F: text;
SE: string;
S,SS: array [-5..210] of string;
Offset,Entry,Stop,N: integer;
Func: array ['A'..'Z','A'..'Z'] of boolean;
FuncQ: array ['A'..'Z',1..26] of char;
FuncN: array ['A'..'Z'] of byte;
FuncEntry: array ['A'..'Z'] of integer;
Glob_Char: array [1..100] of char;
I,J,Z: integer;
BreakPos,BreakLev: integer;
Stack: array [0..200] of StackRec;
const StackPos: integer = 0;
TitleS: string[80]='--------------------------------------------------------------------------------';
RowS: string[80]='|                                                                              |';

function Name(S: string; N: integer): string;
var L,R,P: integer;
begin
 R:=1;
 P:=N;
 while N>0 do
 begin
  L:=R;
  while S[L]=' ' do Inc(L);
  R:=L;
  while S[R] in ['A'..'Z','-','0'..'9'] do Inc(R);
  if L=R then Inc(R);
  Dec(N);
 end;
 Name:=Copy(S,L,R-L);
 Glob_Char[P]:=S[L];
end;

procedure Parsing;
var I,J: integer;
begin
 for I:=1 to N do
 if Name(S[I],1)='FUNCTION' then
 begin
  Name(S[I],2);
  FuncEntry[Glob_Char[2]]:=I+1;
  J:=3;
  FuncN[Glob_Char[2]]:=0;
  while Name(S[I],J)<>')' do
  begin
   Inc(J); Name(S[I],J);
   if Glob_Char[J] in ['A'..'Z'] then
   begin
    Func[Glob_Char[2],Glob_Char[J]]:=True;
    Inc(FuncN[Glob_Char[2]]);
    FuncQ[Glob_Char[2],FuncN[Glob_Char[2]]]:=Glob_Char[J];
   end;
  end;
 end else
 if Name(S[I],1)='}' then Entry:=I+1;
end;

procedure EndDebug;
begin
 TextAttr:=7;
 if Mode=2 then ClrScr;
 Close(F);
 Halt(0);
end;

procedure ProgVis;
var I: integer;
T: string;
begin
 if Mode<>2 then Exit;
 T[0]:=#78;
 for I:=2 to 9 do
 begin
  Move(SS[Entry+I-5,Offset],T[1],78);
  if I=5 then TextAttr:=$3F else TextAttr:=$1F;
  GotoXY(2,I);
  Write(T);
 end;
end;

procedure NewVision;
var T: string;
I: integer;
begin
 if Mode<>2 then Exit;
 ProgVis;
 T[0]:=#78;
 FillChar(T[1],78,0);
 for I:=12 to 20 do
 begin
  GotoXY(2,I);
  Write(T);
 end;
 GotoXY(2,23);
 Write(T);
end;

procedure AddWatch(C: char);
var I: integer;
begin
 if Mode<>2 then Exit;
 I:=Byte(C)-65;
 GotoXY(I div 9*20+2,I mod 9+12);
 Write(C,'=',Stack[StackPos].S[C]);
end;

function KeyOper(Mode: byte): byte;
var C: char;
begin
 if Mode=0 then
 begin
  KeyOper:=2;
  Exit;
 end;
 repeat
  C:=ReadKey;
  if C=#0 then
  begin
   C:=ReadKey;
   if C=#75 then if Offset>1 then
   begin
    Dec(Offset);
    ProgVis;
   end;
   if C=#77 then if Offset<150 then
   begin
    Inc(Offset);
    ProgVis;
   end;
   if C in ['A','B','_'] then
   begin
    case C of
     'A': KeyOper:=1;
     'B': KeyOper:=2;
     '_': KeyOper:=3;
    end;
    Exit;
   end;
  end;
 until False;
end;

function Value(S: string): longint;
var V: longint;
Code: integer;
begin
 Val(S,V,Code);
 Value:=V;
end;

procedure FullAddWatch(S: string);
var I: integer;
begin
 if Mode<>2 then Exit;
 while Pos('THEN',S)<>0 do
 begin
  I:=Pos('THEN',S);
  S[I]:='<';
  S[I+3]:='>';
 end;
 while Pos('IF',S)<>0 do
 begin
  I:=Pos('IF',S);
  S[I]:='<';
  S[I+1]:='>';
 end;
 while Pos(' ',S)<>0 do Delete(S,Pos(' ',S),1);
 S:=' '+S+' ';
 for I:=2 to Length(S)-1 do
 if (S[I] in ['A'..'Z']) and not (S[I-1] in ['A'..'Z']) and
    not (S[I+1] in ['A'..'Z','(']) then AddWatch(S[I]);
end;

function Debugger(Mode: byte; St: integer; Print: boolean): longint;
var V,A1,A2: longint;
SE: string;
label 1,2;
begin
 Debugger:=0;
 StackPos:=St;
1: if Entry=Stop then EndDebug;
 SE:=S[Entry];
 if SE='' then
 begin
  Inc(Entry);
  goto 1;
 end;
 if Name(SE,1)='}' then
 begin
  TextAttr:=7;
  ClrScr;
  TextAttr:=12;
  Writeln('Syntax Error (Fatal): function without RETURN');
  Halt(0);
 end;
 if Mode=2 then NewVision;
2:
{ IF }
 if Name(SE,1)='IF' then
 begin
  Name(SE,2);
  FullAddWatch(SE);
  if Mode=2 then AddWatch(Glob_Char[2]);
  if Stack[St].S[Glob_Char[2]]=0 then
  begin
   if Mode=2 then GotoXY(3,23);
   if Mode=2 then Write('Condition = False');
   case KeyOper(Mode) of
    1,2: begin
      Inc(Entry);
      goto 1;
     end;
    3: EndDebug;
   end;
  end else
  begin
   V:=Pos('THEN',SE);
   Delete(SE,1,V+4);
   goto 2;
  end;
 end;
{ PRINT }
 if Name(SE,1)='PRINT' then
 begin
  Name(SE,2);
  if Glob_Char[2] in ['A'..'Z'] then
  begin
   if Print then Writeln(F,Stack[St].S[Glob_Char[2]]);
   if Mode=2 then AddWatch(Glob_Char[2])
  end else if Print then Writeln(F,Value(Name(SE,2)));
  case KeyOper(Mode) of
   1,2: begin
     Inc(Entry);
     goto 1;
    end;
   3: EndDebug;
  end;
 end;
{ RETURN }
 if Name(SE,1)='RETURN' then
 begin
  Name(SE,2);
  if Glob_Char[2] in ['A'..'Z'] then
  begin
   Debugger:=Stack[St].S[Glob_Char[2]];
   if Mode=2 then AddWatch(Glob_Char[2])
  end else Debugger:=Value(Name(SE,2));
  case KeyOper(Mode) of
   1,2: begin
     Entry:=Stack[St].Last;
     Dec(StackPos);
     Exit;
    end;
   3: EndDebug;
  end;
 end;
 { X=A.. }
 if Name(SE,2)='=' then
 begin
  Name(SE,1);
  Name(SE,3);
  Name(SE,4);
  Name(SE,5);
  if Glob_Char[3] in ['A'..'Z','0'..'9','-'] then
  begin
   case Glob_Char[4] of
    '(': begin
      FillChar(Stack[St+1],SizeOf(StackRec),0);
      Stack[St+1].Last:=Entry;
      J:=5;
      Writeln(FuncN[Glob_Char[3]]);
      for I:=1 to FuncN[Glob_Char[3]] do
      begin
       Name(SE,J);
       if Glob_Char[J] in ['A'..'Z'] then
       begin
        Stack[St+1].S[FuncQ[Glob_Char[3],I]]:=Stack[St].S[Glob_Char[J]];
        if Mode=2 then AddWatch(Glob_Char[J]);
       end else Stack[St+1].S[FuncQ[Glob_Char[3],I]]:=Value(Name(SE,J));
       Inc(J,2);
      end;
      Entry:=FuncEntry[Glob_Char[3]];
      V:=Debugger(0,St+1,True);
      if Mode=2 then GotoXY(2,23);
      Name(SE,1);
      Name(SE,3);
      if Mode=2 then Write('Old value = ',Stack[St].S[Glob_Char[1]],', new value = ',V);
      case KeyOper(Mode) of
       1: begin
         FillChar(Stack[St+1],SizeOf(StackRec),0);
         Stack[St+1].Last:=Entry;
         J:=5;
         for I:=1 to FuncN[Glob_Char[3]] do
         begin
          Name(SE,J);
          if Glob_Char[J] in ['A'..'Z'] then
          begin
           Stack[St+1].S[FuncQ[Glob_Char[3],I]]:=Stack[St].S[Glob_Char[J]];
           if Mode=2 then AddWatch(Glob_Char[J]);
          end else Stack[St+1].S[FuncQ[Glob_Char[3],I]]:=Value(Name(SE,J));
          Inc(J,2);
         end;
         Entry:=FuncEntry[Glob_Char[3]];
         V:=Debugger(2,St+1,False);
         Inc(Entry);
         Stack[St].S[Glob_Char[1]]:=V;
         goto 1;
        end;
       2: begin
         Stack[St].S[Glob_Char[1]]:=V;
         Inc(Entry);
         goto 1;
        end;
       3: EndDebug;
      end;
     end;
    else begin
     for I:=1 to Length(SE) do if (SE[I]='-') and (SE[I-1] in ['0'..'9','A'..'Z']) then SE[I]:='~';
     for I:=1 to 5 do Name(SE,I);
     if Glob_Char[3] in ['A'..'Z'] then
     begin
      A1:=Stack[St].S[Glob_Char[3]];
      if Mode=2 then AddWatch(Glob_Char[3])
     end else A1:=Value(Name(SE,3));
     if Glob_Char[5] in ['A'..'Z'] then
     begin
      A2:=Stack[St].S[Glob_Char[5]];
      if Mode=2 then AddWatch(Glob_Char[5])
     end else A2:=Value(Name(SE,5));
     case Glob_Char[4] of
      '+': V:=A1+A2;
      '~': V:=A1-A2;
      '*': V:=A1*A2;
      '<': if A1<A2 then V:=1 else V:=0;
      '=': if A1=A2 then V:=1 else V:=0;
      '>': if A1>A2 then V:=1 else V:=0;
     end;
     if Mode=2 then GotoXY(2,23);
     if Mode=2 then Write('Old value = ',Stack[St].S[Glob_Char[1]],', new value = ',V);
     case KeyOper(Mode) of
      1,2: begin
        Stack[St].S[Glob_Char[1]]:=V;
        Inc(Entry);
        goto 1;
       end;
      3: EndDebug;
     end;
    end;
   end;
  end else
  begin
   Name(SE,1);
   if Mode=2 then GotoXY(2,23);
   if Mode=2 then Write('Old value = ',Stack[St].S[Glob_Char[1]],', new value = ',Value(Name(SE,3)));
   case KeyOper(Mode) of
    1,2: begin
      Stack[St].S[Glob_Char[1]]:=Value(Name(SE,3));
      Inc(Entry);
      goto 1;
     end;
    3: EndDebug;
   end;
  end;
 end;
 TextAttr:=7;
 ClrScr;
 TextAttr:=12;
 Writeln('Syntax error (Fatal): Cannot parse string ',SS[Entry]);
 Close(F);
 Halt(0);
end;

procedure Window(X1,Y1,X2,Y2: integer; const S: string);
var I,J: integer;
begin
 TextAttr:=$1F;
 GotoXY(X1,Y1);
 Write(TitleS);
 GotoXY(X1,Y2);
 Write(TitleS);
 for I:=Y1+1 to Y2-1 do
 begin
  GotoXY(1,I);
  Write(RowS);
 end;
 GotoXY((X1+X2-Length(S)-2) div 2,Y1);
 Write(' ',S,' ');
end;

procedure PrepScreen;
begin
 Window(1,1,80,10,'Program');
 Window(1,11,80,21,'Used variables');
 Window(1,22,80,24,'Result of command');
end;

begin
 FillChar(S,SizeOf(S),0);
 Assign(F,'input.txt');
 Reset(F);
 N:=0;
 Readln(F,S[1]);
 SS[1]:=S[1];
 for I:=1 to Length(S[1]) do if S[1,I] in ['a'..'z'] then Dec(S[1,I],32);
 if Name(S[1],1)='RUN' then Mode:=0 else
 if Name(S[1],1)='COMPILE' then Mode:=1 else
 if Name(S[1],1)='DEBUG' then Mode:=2;
 while not EOF(F) do
 begin
  Inc(N);
  Readln(F,S[N]);
  SS[N]:=S[N];
  if Copy(S[N],1,1)='#' then S[N]:='';
  for I:=1 to Length(S[N]) do if S[N,I] in ['a'..'z'] then Dec(S[N,I],32);
 end;
 Close(F);
 Entry:=1;
 Parsing;
 while (S[Entry]='') or (S[Entry,1]='#') do Inc(Entry);
 FillChar(Stack,SizeOf(Stack),0);
 Stop:=N;
 while (S[Stop]='') or (S[Stop,1]='#') do Dec(Stop);
 Stack[0].Mode:=Mode;
 if Mode=2 then PrepScreen;
 Offset:=1;
 Assign(F,'output.txt');
 Rewrite(F);
 Stop:=Stop+1;
 if Mode in [0,2] then Debugger(Mode,0,True);
end.
