{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{.$DEFINE DEBUG}

Const
 MaxN=100;
 Inp='TMISSION.DAT';
 Outp='TMISSION.SOL';

Type
 TCol=Array [1..MaxN] of Boolean;
 PCol=^TCol;

var
 N, K: Word;
 Bk: Byte;
 A: Array [1..maxN, 0..MaxN] of Byte;
 B: Array [1..MaxN] of Byte;
 C, D: Array [1..MaxN*3] of Boolean;
 Col: Array [1..MaxN*3] of PCol;
 ColN: Word;

Procedure Init;
 Var i, q, w: Integer;
     Ch: Char;
 begin
  assign(Input, Inp);
  reset(Input);
  Read(N, K);
  FillChar(A, Sizeof(A), 0);
  FillChar(D, Sizeof(D), True);
  For i:=1 to k do begin
   read(q, w);
   Inc(A[q, 0]);
   A[q, A[q, 0]]:=w;
   Inc(A[w, 0]);
   A[w, A[w, 0]]:=q;
  end;
  ReadLn(K);
  Read(Ch);
  if Ch='C' Then Bk:=1
            Else Bk:=2;
  B[K]:=Bk;
  Close(Input);
 end;

Procedure Solve;

Var St: Array [0..MaxN] of Byte;
    Stl: Word;
    NewCol: PCol;
    i, j, l: Integer;
    v: Boolean;

 Procedure Find(Const Q: Integer; Const O: Byte);
  Var i: Integer;
  Begin
   If D[q] Then
   if C[q] then begin
    if B[q]<>o Then begin
     New(NewCol);
     FillChar(NewCol^, Sizeof(TCol), False);
     For i:=1 to Stl do
      NewCol^[St[i]]:=True;

     {$IFDEF DEBUG}
     For i:=1 to Stl do
      Write(St[i], ' ');
     WriteLn;
     {$ENDIF}

     Inc(ColN);
     Col[ColN]:=NewCol;
    end
   End
   else Begin
    C[q]:=True;
    B[q]:=o;
    Inc(Stl);
    St[Stl]:=q;
    for i:=1 to A[q, 0] do
     Find(A[q, i], (not o) and 3);
    C[q]:=False;
    Dec(Stl);
   End;
  End;

 Begin
  FillChar(C, SizeOf(C), False);
  Stl:=0;
  ColN:=0;
  FillChar(B, Sizeof(B), 0);
  B[k]:=Bk;
  Find(K, B[K]);
  i:=1;
  while i<=ColN do begin
   j:=1;
   while j<=ColN do begin
    if j=i Then Inc(j);
    v:=True;
    for l:=1 to N do
     if Col[i]^[l] and (not Col[j]^[l]) Then
      v:=False;
    if V then begin
     Dispose(Col[j]);
     dec(ColN);
     for l:=j to ColN do
      Col[l]:=Col[l+1];
    End else
     inc(j);
   end;
   Inc(i);
  End;
  if ColN<>0 Then Begin
   FillChar(c, sizeof(c), True);
   Stl:=ColN;
   While Stl>0 do Begin
    FillChar(st, Sizeof(St), 0);
    for i:=1 to ColN do if C[i] Then
     For j:=1 to N do if Col[i]^[j] Then
      Inc(St[j]);

    St[k]:=0; {!!!}

    l:=0;
    for i:=1 to N do
     if (St[i]>St[l]) Then
      L:=i;

    for i:=1 to ColN do if C[i] Then
     if Col[i]^[l] Then begin
      C[i]:=False;
      dec(Stl);
     end;
    D[l]:=false;
   End;
   FillChar(B, Sizeof(B), 0);
   FillChar(C, Sizeof(C), False);
   Stl:=0;
   B[K]:=Bk;
   Find(K, B[K]);
  End;
 End;

Procedure Done;
 Var i: Integer;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  if ColN=0 Then
   WriteLn('W')
  Else
   WriteLn('B');
  For i:=1 to N do
   if B[i]=1 Then Write(i, ' ');
  WriteLn;
  For i:=1 to N do
   if B[i]=2 Then Write(i, ' ');
  WriteLn;
  For i:=1 to N do
   if Not D[i] Then Write(i, ' ');
  Close(Output);
  for i:=1 to ColN do
   dispose(Col[i]);
 end;

Begin
 Init;
 Solve;
 Done;
end.