Program P24_15_2;
Const
  FInput='Org.In';
  FOutput='Org.Out';
Var
  Input,Output:Text;
{----------------------------------------------------------------------------}
Procedure Init;
begin
  Assign(Input,FInput);
  Assign(Output,FOutput);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
end;
{----------------------------------------------------------------------------}
Const
  MaxK=100+10;
  MaxN=1000+10;
Type
  TMas=array[1..MaxN]of Record
    S:LongInt;
    V:Integer;
    Col:Integer;
    P:array[1..MaxN]of Integer;
  end;
  TMasD=array[1..MaxN]of Boolean;
Var
  K,N:Integer;
  Mas:TMas;
  D:TMasD;
  Result:LongInt;
  {}
  R,R1,R2:Integer;

Procedure Del(Num:Integer);
Var
  Min:LongInt;
  Number:Integer;
  R:Integer;
begin
  With Mas[Num] do
  begin
    Number:=Num;
    Min:=S;
    For R:=1 to Col do
      If Min>Mas[P[R]].S then
      begin
        Min:=Mas[P[R]].S;
        Number:=P[R];
      end;
    V:=V-Mas[Number].V;
    D[Number]:=True;
    Result:=Result+Min;
  end;
end;

Procedure Solve;
begin
  {Zero}
  Result:=0;
  FillChar(Mas,SizeOf(Mas),0);
  FillChar(D,SizeOf(D),False);
  {Input}
  Readln(Input,K);
  Readln(Input,N);
  For R:=2 to N do
  begin
    Read(Input,R2);
    Inc(Mas[R2].Col);
    With Mas[R2] do P[Col]:=R;
  end;
  For R:=1 to N do Read(Input,Mas[R].S);
  {Solve}
  For R:=N downto 1 do
    With Mas[R] do
    begin
      R2:=0;
      For R1:=1 to Col do
        R2:=R2+Mas[P[R1]].V;
      V:=R2+1;
      If V>=K then Del(R);
    end;
  {Output}
  Writeln(Output,Result);
  For R:=1 to N do
    If D[R] then Write(Output,R,' ');
end;
{----------------------------------------------------------------------------}
begin
  Init;
  Solve;
  Done;
end.
