{$I-,Q-,R-,S-,V-,X-}
Program OppositionAgainWithUs;
Const
  InFile='ORG.IN';
  OutFile='ORG.OUT';
  MaxN=1002;
  MaxK=102;
Var
  N,K:Word;
  Parent:Array[1..MaxN]Of Word;
  Cost:Array[1..MaxN]Of LongInt;
  Best:Array[1..MaxN,0..MaxK+1]Of LongInt;
  Prev:Array[2..MaxN,0..MaxK]Of LongInt;
  ResHead:LongInt;
Procedure Load;
Var
  I:Word;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(K);
  If Not SeekEOF Then Read(N);
  Parent[1]:=0;
  For I:=2 To N Do If Not SeekEOF Then Read(Parent[I]);
  For I:=1 To N Do If Not SeekEOF Then Read(Cost[I]);
  Close(Input);
End;
Procedure Solve;
Var
  I,J,II,JJ,LL:LongInt;
  NBest:Array[0..MaxK]Of LongInt;
Begin
  For I:=N DownTo 1 Do Begin
    For J:=2 To K Do Best[I,J]:=-1;
    Best[I,1]:=0;
    For II:=I+1 To N Do If Parent[II]=I Then Begin
      FillChar(NBest,SizeOf(NBest),255);
      For JJ:=1 To K Do If Best[I,JJ]>=0 Then
        For LL:=0 To (K-JJ) Do If Best[II,LL]>=0 Then
          If (NBest[JJ+LL]<0) Or (Best[II,LL]+Best[I,JJ]<NBest[JJ+LL]) Then Begin
            NBest[JJ+LL]:=Best[II,LL]+Best[I,JJ];
            Prev[II,JJ+LL]:=LL;
          End;
      For JJ:=1 To K Do Best[I,JJ]:=NBest[JJ];
    End;
    Best[I,0]:=Cost[I];
    For II:=I+1 To N Do If Parent[II]=I Then Begin
      Prev[II,0]:=0;
      For J:=0 To K-1 Do If (Best[II,J]>=0) And (Best[II,J]<Best[II,Prev[II,0]]) Then
        Prev[II,0]:=J;
      Inc(Best[I,0],Best[II,Prev[II,0]]);
    End;
  End;
  ResHead:=0;
  For J:=0 To K-1 Do If (Best[1,J]>=0) And (Best[1,J]<Best[1,ResHead]) Then ResHead:=J;
End;
Procedure Save;
Var
  First:Boolean;
Procedure WriteCut(From,Head:LongInt);
Var
  J:LongInt;
Begin
  If Head=0 Then Begin
    If First Then First:=False Else Write(' ');
    Write(From);
  End;
  For J:=N DownTo From+1 Do If Parent[J]=From Then Begin
    WriteCut(J,Prev[J,Head]);
    If Head>0 Then Dec(Head,Prev[J,Head]);
  End;
End;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Best[1,ResHead]);
  First:=True;
  WriteCut(1,ResHead);
  WriteLn;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
