{$I-,Q-,R-,S-,V-,X-}
Program FileOfStringConverter;
Const
  InFile='CONVERT.BIN';
  OutFile='CONVERT.TXT';
  BlockSize=1024*256;
  IBlockSize=BlockSize Div 256;
  EOLN:Array[0..1]Of Byte=(13,10);
Var
  F1,F2:File;
  Block1:Array[0..IBlockSize-1,0..255]Of Byte;
  Block2:Array[0..BlockSize-1]Of Byte;
  B1S,B1P,B2S,B2P:LongInt;
Function AtEOF:Boolean;
Begin
  AtEOF:=(B1S=0);
End;
Procedure Skip;
Begin
  If B1S=0 Then Exit;
  Inc(B1P);
  If B1P>=B1S Then Begin
    BlockRead(F1,Block1,IBlockSize,B1S);
    B1P:=0;
  End;
End;
Procedure FlushIt;
Begin
  If B2P=0 Then Exit;
  BlockWrite(F2,Block2,B2P);
  B2P:=0;
End;
Procedure Put(Var Data; Size:LongInt);
Begin
  If Size=0 Then Exit;
  If B2P+Size>B2S Then
    FlushIt;
  Move(Data,Block2[B2P],Size);
  Inc(B2P,Size);
End;
Procedure Solve;
Begin
  Assign(F1,InFile);
  ReSet(F1,256);
  Assign(F2,OutFile);
  ReWrite(F2,1);
  B1P:=0;
  B1S:=1;
  Skip;
  B2P:=0;
  B2S:=BlockSize;
  While Not AtEOF Do Begin
    Put(Block1[B1P,1],Block1[B1P,0]);
    Put(EOLN,High(EOLN)-Low(EOLN)+1);
    Skip;
  End;
  FlushIt;
  Close(F1);
  Close(F2);
End;
Begin
  Solve;
End.
