#define MAX						1024

#include <stdio.h>

int p [MAX], power [MAX], dynamics [MAX] [MAX], bet [MAX] [MAX], last [MAX] [MAX], addr [MAX], n, k;

void input ();
void solve ();
void output ();
inline int dist (int a, int b) { return ((p [a] < p [b]) ? (p [b] - p [a]) : (p [a] - p [b])); }


main ()
 {
 	input ();
   solve ();
   output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("phone.in", "r");
   fscanf (file, "%d %d", & n, & k);

   for (int i = 0; i < n; i ++)
    fscanf (file, "%d", & p [i]);

   for (int i = 0; i < n; i ++)
    fscanf (file, "%d", & power [i]);
    
   fclose (file);
 }

 
void solve ()
 {
   for (int i = 0; i < n; i ++)
    for (int j = i; j < n; j ++)
     {
      bet [i] [j] = 0;
      
      for (int k = i; k <= j; k ++)
       bet [i] [j] += power [k] * dist (k, (i + j) / 2);
     }

   for (int i = 0; i < n; i ++)
    dynamics [i] [1] = bet [0] [i], last [i] [1] = 0;

   for (int i = 2; i <= k; i ++)
    for (int j = 0; j < n; j ++)
     {
      dynamics [j] [i] = 2000000000;
      
      for (int l = 0; l < j; l ++)
       if (dynamics [j] [i] > dynamics [l] [i - 1] + bet [l + 1] [j])
        {
          dynamics [j] [i] = dynamics [l] [i - 1] + bet [l + 1] [j];
          last [j] [i] = l;
        }
     }

   int curi = n - 1, curk = k, lst;

   while (curk > 0)
    {
      lst = last [curi] [curk];
      addr [curk - 1] = p [(curi + lst + 1) / 2];
      curi = lst; curk --;
    }
 }

 
void output ()
 {
 	FILE * file = fopen ("phone.out", "w");

   for (int i = 0; i < k; i ++)
    fprintf (file, "%d ", addr [i]);
    
   fclose (file);
 }
 
