#include <stdio.h>

int g0[4][100], g1[4][100], n[4][100];
int dir[3][3] = {{1, 2, 4}, {128, 0, 8}, {64, 32, 16}};
int rev[8] = {4, 5, 6, 7, 0, 1, 2, 3};
int dd[8][2] = {{-1, 1}, {0, 1}, {1, 1}, {1, 0},
                {1, -1}, {0, -1}, {-1, -1}, {-1, 0}};

int N;
void reset( int r, int c, int b )
{
  if (r < 0 || r > 3 || c < 0 || c > N - 1)
    return;
  g0[r][c] &= ~b;
}

int main( void )
{
  int M, i, j, k = 0;
  int lo = 1, hi;
  
  freopen("nalog.in", "r", stdin);
  freopen("nalog.out", "w", stdout);
  scanf("%i %i", &N, &M);
  for (i = 0; i < 4; i++)
  {
    for (j = 0; j < N; j++)
      printf("%i ", k++);
    printf("\n");
    return 0;
  }
  hi = 4 * N;
  for (i = 0; i < M; i++)
  {
    int r1, c1, r2, c2;

    scanf("%i %i %i %i", &r1, &c1, &r2, &c2);
    r1--, r2--, c1--, c2--;
    g0[r1][c1] |= dir[c2 - c1 + 1][r2 - r1 + 1];
    g1[r2][c2] |= dir[c1 - c2 + 1][r1 - r2 + 1];
  }
  while (1)
  {
    for (i = 0; i < 4; i++)
      for (j = 0; j < N; j++)
        if ((g0[i][j] == 0) && !n[i][j])
        {
          int k;
          
          n[i][j] = lo++;
          for (k = 0; k < 8; k++)
            if (g1[i][j] & (1 << k))
              reset(i + dir[rev[k]][1], j + dir[rev[k]][0], 1 << rev[k]);
        }
  }
  return 0;
}

