{$I-,Q-,R-,S-,V-,X-}
Program SpacesGetOut;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  BlockSize=1024*256;
Var
  F1,F2:File;
  Block1,Block2:Array[0..BlockSize-1]Of Byte;
  B1P,B2P,B1S,B2S:LongInt;
Function Get(Var B:Byte):Boolean;
Begin
  Get:=False;
  If B1S=0 Then Exit;
  If B1P>=B1S Then Begin
    BlockRead(F1,Block1,BlockSize,B1S);
    B1P:=0;
    If B1S=0 Then Exit;
  End;
  Get:=True;
  B:=Block1[B1P];
  Inc(B1P);
End;
Procedure Put(B:Byte);
Begin
  If B2P>=B2S Then Begin
    BlockWrite(F2,Block2,B2P);
    B2P:=0;
  End;
  Block2[B2P]:=B;
  Inc(B2P);
End;
Procedure FlushIt;
Begin
  If B2P>0 Then Begin
    BlockWrite(F2,Block2,B2P);
    B2P:=0;
  End;
End;
Procedure Solve;
Var
  WasSpace:Boolean;
  B:Byte;
Begin
  Assign(F1,InFile);
  ReSet(F1,1);
  Assign(F2,OutFile);
  ReWrite(F2,1);
  B1P:=1;
  B1S:=1;
  B2P:=0;
  B2S:=BlockSize;
  WasSpace:=False;
  While Get(B) Do Begin
    If B=32 Then Begin
      If Not WasSpace Then Begin
        WasSpace:=True;
        Put(B);
      End;
    End Else Begin
      WasSpace:=False;
      Put(B);
    End;
  End;
  FlushIt;
  Close(F1);
  Close(F2);
End;
Begin
  Solve;
End.
