{$I-,Q-,R-,S-,V-,X-}
Program BusinessNet;
Const
  InFile='NALOG.IN';
  OutFile='NALOG.OUT';
  MaxN=102;
  Horz=4;
  HorzReps=24;
Type
  TDir=(_U,_UR,_R,_DR,_D,_DL,_L,_UL);
  TRep=Array[0..Horz-1]Of Byte;
Const
  DirDX:Array[TDir]Of LongInt=(0,+1,+1,+1,0,-1,-1,-1);
  DirDY:Array[TDir]Of LongInt=(-1,-1,0,+1,+1,+1,0,-1);
Var
  N:Word;
  Conn:Array[0..Horz-1,1..MaxN,TDir]Of Boolean;
  Best:Array[1..MaxN,0..HorzReps-1]Of Word;
  How:Array[1..MaxN,0..HorzReps-1]Of Record
    Prev:Byte;
    Where:TRep;
  End;
  Res:Array[0..Horz-1,1..MaxN]Of Word;
Procedure Load;
Var
  I,M:LongInt;
  DX,DY,X1,Y1,X2,Y2:LongInt;
  DD:TDir;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  If Not SeekEOF Then Read(M);
  FillChar(Conn,SizeOf(Conn),False);
  For I:=1 To M Do Begin
    If Not SeekEOF Then Read(Y1,X1,Y2,X2);
    DX:=X2-X1;
    DY:=Y2-Y1;
    For DD:=Low(TDir) To High(TDir) Do
      If (DX=DirDX[DD]) And (DY=DirDY[DD]) Then Break;

    Conn[Y1-1,X1,DD]:=True;
  End;
  Close(Input);
End;
Function RepToID(R:TRep):Byte;
Var
  I,J,Cur,Step:Byte;
Begin
  Step:=HorzReps;
  Cur:=0;
  For I:=0 To Horz-1 Do Begin
    Step:=Step Div (Horz-I);
    Cur:=Cur+Step*R[I];
    For J:=I+1 To Horz-1 Do If R[J]>R[I] Then Dec(R[J]);
  End;
  RepToID:=Cur;
End;
Function IDToRep(ID:Byte):TRep;
Var
  I,J,Step:Byte;
  Cur:ShortInt;
  Was:Array[0..Horz-1]Of Boolean;
Begin
  Step:=HorzReps;
  FillChar(Was,SizeOf(Was),False);
  For I:=0 To Horz-1 Do Begin
    Step:=Step Div (Horz-I);
    Cur:=-1;
    For J:=0 To ID Div Step Do Repeat
      Inc(Cur);
    Until Not Was[Cur];
    Was[Cur]:=True;
    IDToRep[I]:=Cur;
    ID:=ID Mod Step;
  End;
End;
Procedure GetSequence(Depth:LongInt; Which:Byte);
Var
  UnR,R:TRep;
  I,J,JJ:LongInt;
  PrevNum:Array[0..Horz-1]Of Word;
Begin
  If Depth=1 Then Begin
    R:=IDToRep(Which);
    For I:=0 To Horz-1 Do Res[I,1]:=R[I]+1;
  End Else Begin
    GetSequence(Depth-1,How[Depth,Which].Prev);
    R:=IDToRep(How[Depth,Which].Prev);
    For I:=0 To Horz-1 Do PrevNum[R[I]]:=Res[I,Depth-1];
    R:=IDToRep(Which);
    For I:=0 To Horz-1 Do UnR[R[I]]:=I;
    For I:=0 To Horz-1 Do Begin
      Res[UnR[I],Depth]:=PrevNum[How[Depth,Which].Where[I]];
      For J:=1 To Depth-1 Do
        For JJ:=0 To Horz-1 Do
          If Res[JJ,J]>=Res[UnR[I],Depth] Then Inc(Res[JJ,J]);
      For J:=0 To Horz-1 Do If PrevNum[J]>=Res[UnR[I],Depth] Then Inc(PrevNum[J]);
    End;
  End;
End;
Procedure Solve;
Var
  I,J,II,JJ,JJJ:LongInt;
  R1,R2:TRep;
  CW:TRep;
  CSum:LongInt;
  RG,DoIt:Boolean;
  Sol:Word;
  SolR:Byte;
Begin
  For I:=0 To HorzReps-1 Do Begin
    R1:=IDToRep(I);
    Best[1,I]:=0;
    For J:=1 To Horz-1 Do
      If Conn[J,1,_U] And (R1[J]<R1[J-1]) Then Inc(Best[1,I]);
    For J:=0 To Horz-2 Do
      If Conn[J,1,_D] And (R1[J]<R1[J+1]) Then Inc(Best[1,I]);
  End;
  For II:=2 To N Do Begin
    For I:=0 To HorzReps-1 Do Begin
      R1:=IDToRep(I);
      Best[II,I]:=65535;
      For J:=0 To HorzReps-1 Do Begin
        R2:=IDToRep(J);
        FillChar(CW,SizeOf(CW),0);
        DoIt:=True;
        While DoIt Do Begin
          CSum:=Best[II-1,J];
          For JJ:=0 To Horz-1 Do Begin
            RG:=CW[R1[JJ]]>R2[JJ];
            If (Conn[JJ,II-1,_R] And RG) Or (Conn[JJ,II,_L] And Not RG) Then
              Inc(CSum);
          End;
          For JJ:=0 To Horz-2 Do Begin
            RG:=CW[R1[JJ]]>R2[JJ+1];
            If (Conn[JJ+1,II-1,_UR] And RG) Or (Conn[JJ,II,_DL] And Not RG) Then
              Inc(CSum);
          End;
          For JJ:=1 To Horz-1 Do Begin
            RG:=CW[R1[JJ]]>R2[JJ-1];
            If (Conn[JJ-1,II-1,_DR] And RG) Or (Conn[JJ,II,_UL] And Not RG) Then
              Inc(CSum);
          End;
          If CSum<Best[II,I] Then Begin
            Best[II,I]:=CSum;
            How[II,I].Prev:=J;
            How[II,I].Where:=CW;
          End;
          DoIt:=False;
          For JJ:=Horz-1 DownTo 0 Do Begin
            If CW[JJ]<4 Then Begin
              Inc(CW[JJ]);
              For JJJ:=JJ+1 To Horz-1 Do CW[JJJ]:=CW[JJ];
              DoIt:=True;
              Break;
            End;
          End;
        End;
      End;
      For JJ:=1 To Horz-1 Do
        If Conn[JJ,II,_U] And (R1[JJ]<R1[JJ-1]) Then Inc(Best[II,I]);
      For JJ:=0 To Horz-2 Do
        If Conn[JJ,II,_D] And (R1[JJ]<R1[JJ+1]) Then Inc(Best[II,I]);
    End;
  End;
  Sol:=65535;
  For I:=0 To HorzReps-1 Do
    If Best[N,I]<Sol Then Begin
      Sol:=Best[N,I];
      SolR:=I;
    End;
  GetSequence(N,SolR);
End;
Procedure Save;
Var
  I,J:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=0 To Horz-1 Do Begin
    For J:=1 To N Do Begin
      If J>1 Then Write(' ');
      Write(Res[I,J]);
    End;
    WriteLn;
  End;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
