#define LEN             100
#define MAX             32

#include <stdio.h>
#include <string.h>


void input ();
int solve ();
void output ();
void next (int * x);
void shift (int * a, int n);
int less (int * a, int * b);
void sub (int * a, int * b);
void init (int * l, int n);
int mod (int * a, int div);

int n [LEN], max [LEN], k, m, b, a [MAX], x [MAX], nint, answer;


main ()
 {
 	input ();
   answer = solve ();
   output ();

   return (0);
 }


void input ()
 {
   char chr;
 	FILE * file = fopen ("INPUT.TXT", "r");
   fscanf (file, "%d %d", & k, & m);

   for (int i = 0; i < k; i ++)
    fscanf (file, "%d", & a [i]);

   fscanf (file, "%d", & b);

   for (int i = 0; i < k; i ++)
    fscanf (file, "%d", & x [k - i - 1]);

   do
    chr = fgetc (file);
   while ((chr < '0') || (chr > '9'));

   init (n, 0);
   
   while ((chr >= '0') && (chr <= '9'))
    {
      shift (n, chr - '0');
      chr = fgetc (file);
    }

   init (max, 2000000000);
   
   if (less (n, max)) nint = n [0];
   else nint = -1;

   fclose (file);
 }

 
int solve ()
 {
   int start [MAX], end [MAX], cur [LEN], index1 = 0, index2 = 0, shift;
   
   memcpy (start, x, k << 2);
   memcpy (end, x, k << 2);

   if ((nint <= k) && (nint >= 0)) return (x [k - nint]);
   
   init (cur, k);
   sub (n, cur); nint -= k;

   do
    {
      next (start);
      next (end); next (end);

      index1 ++; index2 += 2;
      if (index1 == nint) return (start [0]);
      if (index2 == nint) return (end [0]);
    }
   while (memcmp (start, end, k << 2));

   init (cur, index1);
   sub (n, cur);
   shift = mod (n, index2 - index1);

   if (shift == 0)
    return (end [0]);

   for (int i = 0; i < shift; i ++)
    next (start);

   return (start [0]);
 }

 
void output ()
 {
   FILE * file = fopen ("OUTPUT.TXT", "w");

   fprintf (file, "%d", answer);
   
   fclose (file);
 }


void init (int * l, int n)
 {
 	memset (l, 0, LEN << 2);
   l [0] = n;
 }

 
void sub (int * a, int * b)
 {
   int c = 0;

   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] - b [i];
      a [i] = (10000 + c) % 10000;
      
      if (c < 0)
       {
         c /= 10000;
         c --;
       }
      else c /= 10000;
    }
 }

 
int less (int * a, int * b)
 {
 	for (int i = LEN - 1; i >= 0; i --)
    {
     if (a [i] < b [i]) return (1);
     if (a [i] > b [i]) return (0);
    }

   return (1);
 }


void shift (int * a, int n)
 {
   int c = 0;
   
   for (int i = 0; i < LEN; i ++)
    {
    	c += a [i] * 10;
      a [i] = c % 10000;
      c /= 10000;
    }

   a [0] += n;
 }


int mod (int * a, int div)
 {
   int c = 0;

   for (int i = LEN - 1; i >= 0; i --)
    c = (c * 10000 + a [i]) % div;

   return (c);
 }


void next (int * x)
 {
   int xk = b;

   for (int i = 0; i < k; i ++)
    xk = (xk + a [i] * x [i]) % m;

   memmove (x + 1, x, (k - 1) << 2);
   x [0] = xk;
 }
