#include <stdio.h>

int k, m, a[32], b;
long int X[32];
int LN, N[102];

int LB, BN[400];
int Z[32][32], ZA[32];
int R[32][32], RA[32];

long int Ans;

void input()
{
  int i, ch;
  FILE *f = fopen("INPUT.TXT", "rt");
  fscanf(f, "%d%d", &k, &m);
  for (i = 0; i < k; i++) fscanf(f, "%d", &a[i]);
  fscanf(f, "%d", &b);
  for (i = 0; i < k; i++) fscanf(f, "%ld", &X[i]);
  do ch = fgetc(f); while(ch == ' ' || ch == '\n' || ch == '\t');
  for (i = 0; ch >= '0' && ch <= '9'; i++)
  {
    N[i] = ch - '0';
    ch = fgetc(f);
  }
  LN = i;
  for (i = 0; i < LN/2; i++)
  {
    ch = N[i]; N[i] = N[LN - 1 - i]; N[LN - 1 - i] = ch;
  }
  fclose(f);
}

void output()
{
  FILE *f = fopen("OUTPUT.TXT", "wt");
  fprintf(f, "%ld", Ans);
  fclose(f);
}

int DivN2()
{
  int i, r = 0;
  for (i = LN - 1; i >= 0; i--)
  {
    N[i] += 10*r;
    r = N[i] % 2;
    N[i] /= 2;
  }
  while(LN > 0 && N[LN-1] == 0) LN--;
  return r;
}

void SubBN1()
{
  int i = 0;
  while(BN[i] == 0) BN[i++] = 1;
  BN[i] = 0;
}

void Mult(int AA[], int A[][32], int BB[], int B[][32])
{
  int i, j, j1;
  int YY[32], Y[32][32];
  for (i = 0; i < k; i++)
  {
    YY[i] = AA[i];
    for (j = 0; j < k; j++) Y[i][j] = 0;
    for (j = 0; j < k; j++)
    {
      YY[i] += A[i][j] * BB[j];
      YY[i] %= m;
      for (j1 = 0; j1 < k; j1++)
      {
        Y[i][j1] += A[i][j] * B[j][j1];
        Y[i][j1] %= m;
      }
    }
  }
  for (i = 0; i < k; i++)
  {
    AA[i] = YY[i];
    for (j = 0; j < k; j++) A[i][j] = Y[i][j];
  }
}

int main()
{
  int i, j;
  LB = 0;
  input();
  while(LN) BN[LB++] = DivN2();
  SubBN1();
  for (i = 0; i <= k-2; i++) ZA[i] = 0;
  ZA[k-1] = b;
  for (i = 0; i <= k-2; i++) for (j = 0; j < k; j++)
  {
    if (j == i+1) Z[i][j] = 1; else Z[i][j] = 0;
  }
  for (j = 0; j < k; j++) Z[k-1][j] = a[k - 1 - j];
  for (i = 0; i < k; i++) RA[i] = 0;
  for (i = 0; i < k; i++) for (j = 0; j < k; j++)
  {
    if (i == j) R[i][j] = 1; else R[i][j] = 0;
  }
  for (i = 0; i < LB; i++)
  {
    if (i > 0) Mult(ZA, Z, ZA, Z);
    if (BN[i]) Mult(RA, R, ZA, Z);
  }
  Ans = RA[0];
  for (i = 0; i < k; i++)
  {
    Ans += R[0][i] * X[i];
    Ans %= m;
  }
  output();
  return 0;
}
