#include <stdio.h>
#include <ctype.h>

typedef int Num[110];
Num N, P, Q, A, B, C, D, E, F;
void get( int *n )
{
  int c;
  int i, j;
  
  while (isspace(c = getchar()))
    ;
  do
  {
    n[++n[0]] = c - '0';
  } while (isdigit(c = getchar()));
  i = 1;
  j = n[0];
  while (i < j)
  {
    int tmp = n[i];

    n[i] = n[j];
    n[j] = tmp;
    i++;
    j--;
  }
  while ((n[n[0]] == 0) && (n[0] > 0))
    n[0]--;
}

void add( int *A, int *B, int *C )
{
  int *gr = ((B[0] > C[0]) ? B : C), *le = ((gr == B) ? C : B);
  int i;

  memcpy(A, gr, (gr[0] + 1) * sizeof(int));
  for (i = 1; i <= le[0]; i++)
  {
    A[i] += le[i];
    if (A[i] >= 10)
    {
      A[i] -= 10;
      A[i + 1]++;
    }
  }
  if (A[A[0] + 1])
    A[0]++;
  if (A[A[0]] >= 10)
  {
    A[A[0] + 1]++;
    A[A[0]] -= 10;
    A[0]++;
  }
}

void mul( int *A, int *B, int *C )
{
  int i, j;
  
  memset(A, 0, sizeof(Num));
  for (i = 1; i <= B[0]; i++)
    for (j = 1; j <= C[0]; j++)
      A[i + j - 1] += B[i] * C[j];
  A[0] = B[0] + C[0] - 1;
  for (i = 1; i <= A[0]; i++)
    if (A[i] >= 10)
    {
      A[i + 1] += A[i] / 10;
      A[i] %= 10;
    }
  if (A[A[0] + 1])
    A[0]++;
  if (A[A[0]] >= 10)
  {
    A[A[0] + 1]++;
    A[A[0]] -= 10;
    A[0]++;
  }
}

int less( int *A, int *B )
{
  int i;
  
  if (A[0] < B[0])
    return 1;
  if (A[0] > B[0])
    return 0;
  for (i = A[0]; i > 0; i--)
    if (A[i] < B[i])
      return 1;
    else if (A[i] > B[i])
      return 0;
  return 0;
}

int fr_less( int *A, int *B, int *C, int *D )
{
  Num left, right;

  mul(left, A, D);
  mul(right, B, C);
  return less(left, right);
}

int main( void )
{
  char i;
  
  freopen("Input.txT", "r", stdin);
  freopen("Output.txT", "w", stdout);
  get(N);
  get(P);
  get(Q);
  A[0] = 0;
  B[0] = 1;
  B[1] = 1;
  C[0] = 1;
  C[1] = 1;
  D[0] = 0;
  if (P[0] == 0)
    memcpy(D, N, sizeof(N));
  else
    while (1)
    {
      add(E, A, C);
      add(F, B, D);
      if (less(N, F))
        break;
      if (fr_less(P, Q, E, F))
      {
        memcpy(C, E, sizeof(E));
        memcpy(D, F, sizeof(F));
      }
      else
      {
        memcpy(A, E, sizeof(E));
        memcpy(B, F, sizeof(F));
      }
    }
  for (i = C[0]; i > 0; i--)
    putchar(C[i] + '0');
  putchar('\n');
  for (i = D[0]; i > 0; i--)
    putchar(D[i] + '0');
  putchar('\n');
  return 0;
}
