{$M 64000,0,0}
{$IFDEF NORMAL}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF RELEASE}
Program PoluSort;
 Const
   Const1 = 1000;
 Var
   Inp, Out  : Text;
   R         : Array [1..10000, 1..20] of Integer;
   M         : Array [1..10000] of LongInt;
   K, N, I, G: Integer;
   Num       : Array [1..10000] of Integer;
   Q         : Integer;
   Stop      : Boolean;
   Sum, H    : Integer;
   Count     : Integer;

Procedure Init;
Begin
  Assign(Inp ,'Input.TXT');
  Assign(Out, 'Output.TXT');
  Reset(Inp);
  ReWrite(Out);
End;

Procedure QSort(K, L: Integer);
 Var
   I, G: Integer;
   X   : Integer;
   T   : LongInt;
Begin
  If K < L Then
  Begin
    I:=K;
    G:=L;
    X:=M[(K + L) div 2];
   While I < G Do
   Begin
     While (M[I] < X)and(I < N) Do Inc(I);
     While (M[G] > X)and(G > 1) Do Dec(G);
     T:=M[I];
     M[I]:=M[G];
     M[G]:=T;
     T:=Num[I];
     Num[I]:=Num[G];
     Num[G]:=T;
     Inc(I);
     Dec(G);
   End;
    QSort(K, G);
    QSort(I, L);
  End Else
  If L - K = 1 Then
   If M[K] > M[L]
   Then Begin
     T:=M[K];
     M[K]:=M[L];
     M[L]:=T;
     T:=Num[K];
     Num[K]:=Num[L];
     Num[L]:=T;
   End;
End;

Procedure Done;
Begin
  Close(Inp);
  Close(Out);
End;

Procedure Run;
Begin
  Readln(Inp, K);
  Readln(Inp, N);
  FillChar(M, SizeOf(M), 0);
 For I:=1 To N Do
  For G:=1 To K Do
  Begin
    Read(Inp, R[I, G]);
   If R[I, G] > 0 Then
    Inc(M[R[I, G]]);
  End;
  For I:=1 To N Do
   Num[I]:=I;
  QSort(1, N);
 While Not Stop Do
 Begin
   Stop:=True;
  For I:=1 To N Do
  Begin
    Sum:=0;
   For G:=1 To I Do
    For H:=1 To K Do
     If R[G, H] = Num[I] Then Inc(Sum);
    If Sum > K Then
    Begin
     Stop:=False;
     Inc(Count);
     Q:=Num[I];
     Num[I]:=Num[I - 1];
     Num[I - 1]:=Num[I];
     If Count > Const1 Then
     Begin
       Writeln(Out, 'NO');
       Done;
       Halt(0);
     End;
   End;
  End;
 End;
 For I:=1 To N Do
  Write(Out, Num[I], ' ');
End;

Begin
  Init;
  Run;
  Done;
End.
