Program P26_15_3;
{Sort}
Const
  FInput='Input.TXT';
  FOutput='Output.TXT';
Var
  Input,Output:Text;
{----------------------------------------------------------------------------}
Procedure Init;
begin
  Assign(Input,FInput);
  Assign(Output,FOutput);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
end;
{----------------------------------------------------------------------------}
Const
  MaxN=10000+1000;
  MaxK=20+10;
Type
  TGr=array[1..MaxN] of Record
    Col:LongInt;
    Mas:Array[1..MaxK]of LongInt;
  end;
  TAns=array[1..MaxN]of LongInt;
  TMasV=array[1..MaxN]of longInt;
  TMasUse=array[1..MaxN]of Boolean;
Var
  K,N:LongInt;
  Gr:TGr;
  Result:Boolean;
  Ans:TAns;
  V:TMasV;
  Use:TMasUse;
  {}
  R1,R2,R3:LongInt;

  Procedure GetAns;
  begin
    For R3:=N downto 1 do
    begin
      {Find Ver}
      R1:=1;
      while (Use[R1])or(V[R1]>K) do
      begin
        Inc(R1);
        If R1>N then Break;
      end;
      if R1>N then
      begin
        {Ver not Found}
        Result:=False;
        Exit;
      end;
      {Add to answer}
      Ans[R3]:=R1;
      {Use ver number R1}
      With Gr[R1] do
        for R2:=1 to Col do
          V[Mas[R2]]:=V[Mas[R2]]-1;
      Use[R1]:=True;
    end;
    {OK!}
    Result:=True;
  end;

Procedure Solve;
begin
  {Zero}
  Result:=False;
  FillChar(V,sizeof(V),0);
  FillChar(Use,sizeof(Use),False);
  {Input}
  Read(Input,K,N);
  For R1:=1 to N do
    For R2:=1 to K do
    begin
      Read(Input,R3);
      If R3>0 then
      begin
        Inc(Gr[R1].Col);
        With Gr[R1] do Mas[Col]:=R3;
        Inc(V[R3]);
      end;
    end;
  {Solve}
  GetAns;
  {Output}
  if Result then
  begin
    {YES}
    For R1:=1 to N-1 do
      Write(Output,Ans[R1],' ');
    Writeln(Output,Ans[N]);
  end else
  begin
    {NO}
    Writeln(Output,'NO');
  end;
end;
{----------------------------------------------------------------------------}
begin
  Init;
  Solve;
  Done;
end.
