{$I-,Q-,R-,S-,V-,X-}
const
  max = 50;

type
  tlong = array[1..max] of word;

var
  k: byte;
  m, b, beg, en, cur, un, cyc, c1, c2, rn: word;
  x: array[0..30] of longint;
  a: array[0..29] of longint;
  u: array[1..350] of tlong;
  d: array[1..2000] of integer;
  r, y: tlong;
  st: string;
  f: integer;

var
  n: tlong;

function get(i: integer): longint;
begin
  get := x[(i+(k+1)) mod (k+1)];
end;

procedure clear(var x: tlong);
var
  c1: integer;
begin
  for c1 := 1 to max do x[c1] := 0;
end;

procedure readlong(var x: tlong);
var
  st: string;
  c, b: integer;
begin
  readln(st); b := 0;
  while st <> '' do begin
    inc(b);
    if length(st) > 4 then begin
      val(copy(st, length(st)-3, 4), x[b], c);
      delete(st, length(st)-3, 4);
    end else begin
      val(copy(st, 1, length(st)), x[b], c); st := '';
    end;
  end;
end;

procedure plus(x, y: tlong; var z: tlong);
var
  c, c1: word;
begin
  c := 0;
  for c1 := 1 to max do begin
    c := x[c1]+y[c1]+c;
    z[c1] := c mod 10000; c := c div 10000;
  end;
end;

procedure minus(x, y: tlong; var z: tlong);
var
  c1: word;
  c: integer;
begin
  c := 0;
  for c1 := 1 to max do begin
    c := x[c1]-y[c1]-c;
    z[c1] := (c+10000) mod 10000;
    if c < 0 then c := 1 else c := 0;
  end;
end;

function menshe(x, y: tlong): boolean;
var
  c1, c2: byte;
begin
  c1 := max; c2 := max; menshe := true;
  while (x[c1] = 0) and (c1 > 0) do dec(c1);
  while (y[c2] = 0) and (c2 > 0) do dec(c2);
  if c1 < c2 then begin
    menshe := true;
  end else if c1 > c2 then begin
    menshe := false;
  end else begin
    for c1 := c2 downto 1 do begin
      if x[c1] > y[c1] then begin
        menshe := false; exit;
      end else if x[c1] < y[c1] then begin
        menshe := true; exit;
      end;
    end;
  end;
end;

procedure umnozh(x, y: tlong; var z: tlong);
var
  c1, c2: byte;
  a: longint;
  t: tlong;
begin
  clear(z); a := 0;
  for c1 := 1 to max do begin
    for c2 := 1 to max do begin
      a := longint(x[c2])*y[c1]+a;
      z[c2] := z[c2]+(a mod 10000);
      a := a div 10000;
    end;
  end;
end;

function pusto(x: tlong): boolean;
var
  c1: integer;
begin
  pusto := true;
  for c1 := 2 to max do if x[c1] <> 0 then begin
    pusto := false; exit;
  end;
end;

procedure findcycle;
var
  c1, c2, c3: integer;
  t: boolean;
begin
  for c1 := 1 to 1000 do begin
    for c2 := 1 to (2000-c1) div 2 do begin
      t := true;
      for c3 := c1+c2 to 2000 do begin
        if d[c3] <> d[c1+(c3-c1) mod c2] then begin
          t := false; break;
        end;
      end;
      if t then begin
        cyc := c2; f := c1; exit;
      end;
    end;
  end;
end;

begin
  cur := 0; rn := 0;
  assign(input, 'INPUT.TXT'); reset(input);
  assign(output, 'OUTPUT.TXT'); rewrite(output);
  read(k, m);
  for c1 := 0 to k-1 do read(a[c1]);
  read(b);
  for c1 := 0 to k-2 do
    read(x[c1]);
  readln(x[k-1]);
  readlong(n); cur := k;
  beg := 0; en := k-1; x[en] := 0;
  for c2 := 1 to k do begin
    en := (en+1) mod (k+1); inc(cur); x[en] := 0;
    for c1 := 0 to k-1 do begin
      x[en] := x[en]+(a[c1]*get(en-c1-1)) mod m;
    end;
    x[en] := (x[en]+b) mod m;
    if (cur = n[1]) and (pusto(n)) then begin
      writeln(x[en]); close(input); close(output); halt;
    end;
    beg := (beg+1) mod (k+1);
  end;
  for c2 := 1 to 2000 do begin
    en := (en+1) mod (k+1); inc(cur); x[en] := 0;
    for c1 := 0 to k-1 do begin
      x[en] := x[en]+(a[c1]*get(en-c1-1)) mod m;
    end;
    x[en] := (x[en]+b) mod m;
    if (cur = n[1]) and (pusto(n)) then begin
      writeln(x[en]); close(input); close(output); halt;
    end;
    inc(rn); d[rn] := x[en];
    beg := (beg+1) mod (k+1);
  end;
  findcycle;
  clear(r); r[1] := f+2*k-1;
  minus(n, r, y); n := y;
  un := 1; clear(u[1]); u[1, 1] := cyc;
  while menshe(u[un], n) do begin
    umnozh(u[un], u[1], u[un+1]);
    inc(un);
  end;
  clear(y); dec(un);
  while un > 0 do begin
    while menshe(y, n) do begin
      plus(y, u[un], r); y := r;
    end;
    minus(y, u[un], r); y := r;
    dec(un);
  end;
  minus(n, y, r);
  if r[1] = 0 then r[1] := cyc;
  writeln(d[r[1]]);
  close(input); close(output);
end.
