{$I-,Q-,R-,S-,V-,X-}
uses sysutils;

var
  n, p, k, n1, n2, f1, f2: qword;
  t, t1: extended;
  breaktime: double;

procedure sokrat(var n1, n2: qword);
var
  c1: integer;
begin
  c1 := 2;
  while ((n1 mod 2) = 0) and ((n2 mod 2) = 0) do begin
    n1 := n1 div 2; n2 := n2 div 2;
  end;
  c1 := 3;
  while c1 < sqrt(c1) do begin
    if ((n1 mod c1) = 0) and ((n2 mod c1) = 0) then begin
      n1 := n1 div c1; n2 := n2 div c1;
    end else
      c1 := c1+2;
  end;
end;

begin
  breaktime := now+(1/(24*60*60)*14);
  assign(input, 'Input.txT'); reset(input);
  assign(output, 'Output.txT'); rewrite(output);
  read(n, p, k); n1 := p; n2 := k;
  f1 := 0; t := p/k;
  while (n2 > 1) do begin
    if now >= breaktime then break;
      dec(n2);
      while (n1 > 1) and (n1/n2 > t) do begin
        dec(n1);
      end;
      inc(n1);
      if (f1 = 0) or (n1/n2 < t1) then begin
        t1 := n1/n2; f1 := n1; f2 := n2;
      end;
  end;
  if p*((n div k)+1)/(k*(n div k)) < t1 then begin
    f1 := p*((n div k)+1); f2 := (k*(n div k));
  end;
  sokrat(f1, f2);
  writeln(f1); writeln(f2);
  close(input); close(output);
end.
