{$I-,Q-,R-,S-,V-,X-}
Program PseudoRandomGenerator;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  MaxLong=120;
  MaxK=32;
Type
  TLong=Array[0..MaxLong]Of Byte;
Var
  K,M:LongInt;
  A,X:Array[1..MaxK]Of LongInt;
  B:LongInt;
  N:TLong;
  Cur,Cur2:Array[0..MaxK]Of LongInt;
  Res:LongInt;
Function GOE(Var A,B:TLong; Shift:LongInt):Boolean;
Var
  I:LongInt;
Begin
  For I:=MaxLong DownTo 0 Do
    If (I+Shift>MaxLong) Then Begin If B[I]>0 Then Begin GOE:=False; Exit; End; End
    Else If (B[I]>A[I+Shift]) Then Begin GOE:=False; Exit; End
    Else If (B[I]<A[I+Shift]) Then Begin GOE:=True; Exit; End;
  GOE:=True;
End;
Procedure Sub(Var A,B:TLong; Shift:LongInt);
Var
  I,R,P:LongInt;
Begin
  P:=0;
  For I:=0 To MaxLong-Shift Do Begin
    R:=A[I+Shift]-B[I]-P;
    If R<0 Then Begin
      A[I+Shift]:=R+10;
      P:=1;
    End Else Begin
      A[I+Shift]:=R;
      P:=0;
    End;
  End;
End;
Procedure Remainder(Var P,Q:TLong);
Var
  I:LongInt;
Begin
  For I:=MaxLong DownTo 0 Do If P[I]>0 Then Break Else If I=0 Then Exit;
  Repeat
    While GOE(P,Q,I) Do Sub(P,Q,I);
    If I>0 Then Dec(I) Else Exit;
  Until False;
End;
Procedure ReadLong(Var F:Text; Var L:TLong);
Var
  I,CP,J:LongInt;
  Ch:Char;
Begin
  FillChar(L,SizeOf(L),0);
  CP:=0;
  While Not EOF(F) Do Begin
    Read(F,Ch);
    If (Ch<'0') Or (Ch>'9') Then Break;
    L[CP]:=Ord(Ch)-48;
    Inc(CP);
  End;
  For I:=0 To CP Div 2-1 Do Begin
    J:=L[I];
    L[I]:=L[CP-1-I];
    L[CP-1-I]:=J;
  End;
End;
Procedure WriteLong(Var F:Text; Var L:TLong);
Var
  I:LongInt;
Begin
  For I:=MaxLong DownTo 0 Do If (I=0) Or (L[I]>0) Then Break;
  For I:=I DownTo 0 Do Write(F,L[I]);
End;
Procedure Load;
Var
  I:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(K);
  If Not SeekEOF Then Read(M);
  For I:=1 To K Do
    If Not SeekEOF Then Read(A[I]);
  If Not SeekEOF Then Read(B);
  For I:=1 To K Do
    If Not SeekEOF Then Read(X[I]);
  If Not SeekEOF Then ReadLong(Input,N);
  Close(Input);
End;
{Procedure FillME;
Var
  I,J:LongInt;
Begin
  ME[0]:=0;
  For I:=1 To K Do begin
    J:=ME[I-1];
    ME[I]:=J+1;
    While (ME[I]>0) And ((ME[I]=I) Or (X[I]<>X[ME[I]])) Do Begin
      If (J=0) Then ME[I]:=0 Else Begin
        J:=ME[J];
        ME[I]:=J+1;
      End;
    End;
  End;
End;}
Procedure Solve;
Var
  HowMuch:LongInt;
  CPos,CPos2:LongInt;
  Next:LongInt;
  I,J:LongInt;
  CNum,CNum2:LongInt;
  Need:LongInt;
  RR:TLong;
Begin
  {FillME;
  For I:=1 To K Do Cur[I]:=X[I];
  CPos:=0;
  CNum:=K;
  HowMuch:=0;
  Repeat
    Cur[CPos]:=B;
    For I:=1 To K Do
      Cur[CPos]:=(Cur[CPos]+A[I]*Cur[(CPos+K+1-I) Mod (K+1)]) Mod M;
    Inc(CNum);
    If CNum Mod 1000=0 Then WriteLn(CNum);
    J:=HowMuch;
    Inc(HowMuch);
    While (HowMuch>0) And (Cur[CPos]<>X[HowMuch]) Do Begin
      If J=0 Then HowMuch:=0 Else Begin
        J:=ME[J];
        HowMuch:=J+1;
      End;
    End;
    CPos:=(CPos+1) Mod (K+1);
  Until HowMuch>=K;
  WriteLn(CNum-K);}
  CNum:=K;
  CNum2:=K;
  For I:=1 To K Do Begin
    Cur[I]:=X[I];
    Cur2[I]:=X[I];
  End;
  CPos:=0;
  CPos2:=0;
  Repeat
    Cur[CPos]:=B;
    For I:=1 To K Do
      Cur[CPos]:=(Cur[CPos]+A[I]*Cur[(CPos+K+1-I) Mod (K+1)]) Mod M;
    Cur2[CPos2]:=B;
    For I:=1 To K Do
      Cur2[CPos2]:=(Cur2[CPos2]+A[I]*Cur2[(CPos2+K+1-I) Mod (K+1)]) Mod M;
    CPos2:=(CPos2+1) Mod (K+1);
    Cur2[CPos2]:=B;
    For I:=1 To K Do
      Cur2[CPos2]:=(Cur2[CPos2]+A[I]*Cur2[(CPos2+K+1-I) Mod (K+1)]) Mod M;
    CPos:=(CPos+1) Mod (K+1);
    CPos2:=(CPos2+1) Mod (K+1);
    Inc(CNum);
    Inc(CNum2,2);
    For HowMuch:=0 To K Do If (HowMuch=K) Or (Cur[(CPos+HowMuch+1) Mod (K+1)]<>Cur2[(CPos2+HowMuch+1) Mod (K+1)]) Then Break;
  Until HowMuch>=K;
  FillChar(RR,SizeOf(RR),0);
  J:=CNum;
  For I:=0 To MaxLong Do Begin
    RR[I]:=J Mod 10;
    J:=J Div 10;
  End;
  If GOE(N,RR,0) Then Begin
    Sub(N,RR,0);
    FillChar(RR,SizeOf(RR),0);
    J:=CNum2-CNum;
    For I:=0 To MaxLong Do Begin
      RR[I]:=J Mod 10;
      J:=J Div 10;
    End;
    Remainder(N,RR);
    Need:=CNum;
  End Else Need:=0;
  J:=0;
  For I:=MaxLong DownTo 0 Do Begin
    J:=J*10+N[I];
  End;
  Need:=Need+J;
  If Need<=K Then Res:=X[K] Else Begin
    For I:=1 To K Do Cur[I]:=X[I];
    CPos:=0;
    For J:=1 To Need-K Do Begin
      Cur[CPos]:=B;
      For I:=1 To K Do
        Cur[CPos]:=(Cur[CPos]+A[I]*Cur[(CPos+K+1-I) Mod (K+1)]) Mod M;
      If J<Need-K Then CPos:=(CPos+1) Mod (K+1);
    End;
    Res:=Cur[CPos];
  End;
End;
Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Res);
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
