{$I-,Q-,R-,S-,V-,X-}
Program NormalFractions;
Const
  InFile='Input.txT';
  OutFile='Output.txT';
  MaxLong=60;
  MMaxLong=2*MaxLong;
Type
  TLong=Array[0..MMaxLong]Of Word;
Var
  P,Q,N:TLong;
  AP,AQ:TLong;
  I:LongInt;
Procedure ReadLong(Var F:Text; Var L:TLong);
Var
  I,CP,J:LongInt;
  Ch:Char;
Begin
  FillChar(L,SizeOf(L),0);
  CP:=0;
  While Not EOF(F) Do Begin
    Read(F,Ch);
    If (Ch<'0') Or (Ch>'9') Then Break;
    L[CP]:=Ord(Ch)-48;
    Inc(CP);
  End;
  For I:=0 To CP Div 2-1 Do Begin
    J:=L[I];
    L[I]:=L[CP-1-I];
    L[CP-1-I]:=J;
  End;
End;
Procedure WriteLong(Var F:Text; Var L:TLong);
Var
  I:LongInt;
Begin
  For I:=MaxLong DownTo 0 Do If (I=0) Or (L[I]>0) Then Break;
  For I:=I DownTo 0 Do Write(F,L[I]);
End;
Procedure Load;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  If Not SeekEOF Then ReadLong(Input,N);
  If Not SeekEOF Then ReadLong(Input,P);
  If Not SeekEOF Then ReadLong(Input,Q);
  Close(Input);
End;
Function GOE(Var A,B:TLong; Shift:LongInt):Boolean;
Var
  I:LongInt;
Begin
  For I:=MaxLong DownTo 0 Do
    If (I+Shift>MaxLong) Then Begin If B[I]>0 Then Begin GOE:=False; Exit; End; End
    Else If (B[I]>A[I+Shift]) Then Begin GOE:=False; Exit; End
    Else If (B[I]<A[I+Shift]) Then Begin GOE:=True; Exit; End;
  GOE:=True;
End;
Function GOEM(Var A,B:TLong; Shift:LongInt):Boolean;
Var
  I:LongInt;
Begin
  For I:=MMaxLong DownTo 0 Do
    If (I+Shift>MMaxLong) Then Begin If B[I]>0 Then Begin GOEM:=False; Exit; End; End
    Else If (B[I]>A[I+Shift]) Then Begin GOEM:=False; Exit; End
    Else If (B[I]<A[I+Shift]) Then Begin GOEM:=True; Exit; End;
  GOEM:=True;
End;
Procedure Sub(Var A,B:TLong; Shift:LongInt);
Var
  I,R,P:LongInt;
Begin
  P:=0;
  For I:=0 To MaxLong-Shift Do Begin
    R:=A[I+Shift]-B[I]-P;
    If R<0 Then Begin
      A[I+Shift]:=R+10;
      P:=1;
    End Else Begin
      A[I+Shift]:=R;
      P:=0;
    End;
  End;
End;
Procedure Remainder(Var P,Q:TLong);
Var
  I:LongInt;
Begin
  For I:=MaxLong DownTo 0 Do If P[I]>0 Then Break Else If I=0 Then Exit;
  Repeat
    While GOE(P,Q,I) Do Sub(P,Q,I);
    If I>0 Then Dec(I) Else Exit;
  Until False;
End;
Function Zero(Var A:TLong):Boolean;
Var
  I:LongInt;
Begin
  Zero:=False;
  For I:=0 To MaxLong Do If A[I]>0 Then Exit;
  Zero:=True;
End;
Procedure GCD(P,Q:TLong; Var R:TLong);
Begin
  Repeat
    If GOE(P,Q,0) Then
      If Zero(Q) Then Begin R:=P; Exit; End Else Remainder(P,Q)
    Else If Zero(P) Then Begin R:=Q; Exit; End Else Remainder(Q,P);
  Until False;
End;
Procedure Divide(Var P,Q:TLong);
Var
  I:LongInt;
  R:TLong;
Begin
  FillChar(R,SizeOf(R),0);
  For I:=MaxLong DownTo 0 Do If P[I]>0 Then Break Else If I=0 Then Exit;
  Repeat
    While GOE(P,Q,I) Do Begin
      Sub(P,Q,I);
      Inc(R[I]);
    End;
    If I>0 Then Dec(I) Else Begin P:=R; Exit; End;
  Until False;
End;
Procedure NormalizeFraction(Var P,Q:TLong);
Var
  Z:TLong;
Begin
  GCD(P,Q,Z);
  Divide(P,Z);
  Divide(Q,Z);
End;
Procedure Add(Var A,B:TLong);
Var
  I:LongInt;
  R,P:LongInt;
Begin
  P:=0;
  For I:=0 To MaxLong Do Begin
    R:=A[I]+B[I]+P;
    If R>=10 Then Begin
      P:=1;
      A[I]:=R-10;
    End Else Begin
      P:=0;
      A[I]:=R;
    End;
  End;
End;
Procedure Mul(Var A,B,C:TLong);
Var
  I,J,R,P:LongInt;
Begin
  FillChar(C,SizeOf(C),0);
  For I:=0 To MaxLong Do Begin
    P:=0;
    For J:=0 To MaxLong Do Begin
      R:=C[I+J]+A[I]*B[J]+P;
      C[I+J]:=R Mod 10;
      P:=R Div 10;
    End;
  End;
End;
Function FractionGOE(Var AP,AQ,BP,BQ:TLong):Boolean;
Var
  Z1,Z2:TLong;
Begin
  Mul(AP,BQ,Z1);
  Mul(AQ,BP,Z2);
  FractionGOE:=GOEM(Z1,Z2,0);
End;
Procedure Solve;
Var
  PL,QL,PR,QR,PP,QQ:TLong;
  AA,AAA:TLong;
Begin
  FillChar(AA,SizeOf(AA),0);
  For I:=0 To 7 Do AA[I]:=Random(10);
  Mul(AA,Q,AAA);
  Add(P,AAA);
  NormalizeFraction(P,Q);
  PL:=P;
  Divide(PL,Q);
  PR:=PL;
  FillChar(QL,SizeOf(QL),0);
  QL[0]:=1;
  QR:=QL;
  Add(PR,QR);
  Repeat
    PP:=PL;
    Add(PP,PR);
    QQ:=QL;
    Add(QQ,QR);
    NormalizeFraction(PP,QQ);
    If Not GOE(N,QQ,0) Then Break;
    Case FractionGOE(P,Q,PP,QQ) Of
      True:Begin PL:=PP; QL:=QQ; End;
      False:Begin PR:=PP; QR:=QQ; End;
    End;
  Until False;
  AP:=PR;
  AQ:=QR;
  Mul(AA,AQ,AAA);
  Sub(AP,AAA,0);
End;
Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLong(Output,AP);
  WriteLn;
  WriteLong(Output,AQ);
  WriteLn;
  Close(Output);
End;
Begin
  RandSeed:=4515431;
  Load;
  Solve;
  Save;
End.
