{$I-,Q-,R-,S-,V-,X-}
Program TheSecretTask;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  MaxN=17;
Var
  N:Byte;
  Conn:Array[1..MaxN,1..MaxN]Of Boolean;
  Way:Array[1..MaxN,1..MaxN]Of Byte;
  Pow:Array[1..MaxN]Of Byte;
Procedure Load;
Var
  I,J,B:Byte;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  FillChar(Pow,SizeOf(Pow),0);
  For I:=1 To N Do
    For J:=1 To N Do
      If Not SeekEOF Then Begin
        Read(B);
        Conn[I,J]:=(B>0);
        Inc(Pow[I],B);
      End;
  Close(Input);
End;
Procedure FillWays;
Var
  I,J,K,L:Byte;
Begin
  For I:=1 To N Do
    For J:=1 To N Do If Conn[I,J] Or (I=J) Then Way[I,J]:=J Else Way[I,J]:=0;
  For I:=1 To N Do
    For J:=1 To N Do
      For K:=1 To N Do If Conn[J,K] Then
        For L:=1 To N Do
          If (Way[K,L]>0) And (Way[J,L]<=0) Then Way[J,L]:=K;
End;
Procedure Solve;
Const
  _Bad=1;
  _Guard=2;
  _Free=3;
Var
  K:Byte;
  Start:Byte;
  I,J,II:Byte;
  Some:Byte;
  Where:Array[1..MaxN]Of Byte;
  State:Array[1..MaxN]Of Byte;
  NumBad:Byte;
  Ok:Boolean;
Label Lab;
Procedure Go(ID:Byte; Dst:Byte);
Var
  Src:Byte;
Begin
  Src:=Where[ID];
  While Src<>Dst Do Begin
    Src:=Way[Src,Dst];
    WriteLn(ID,' ',Src);
  End;
  Where[ID]:=Src;
End;
Function AnyAt(Pos:Byte):Byte;
Var
  I:Byte;
Begin
  AnyAt:=0;
  For I:=1 To K Do If Where[I]=Pos Then AnyAt:=I;
End;
Function CanMove(Pos1,Pos2:Byte):Boolean;
Var
  I,NGs:Byte;
Begin
  NGs:=0;
  For I:=1 To K Do If Where[I]=Pos1 Then Inc(NGs);
  If NGs>1 Then Begin CanMove:=True; Exit; End;
  For I:=1 To N Do If Conn[I,Pos1] And (I<>Pos2) And (State[I]=_Bad) Then Begin CanMove:=False; Exit; End;
  CanMove:=True;
End;
Begin
  If N=1 Then Begin
    Assign(Output,OutFile);
    ReWrite(Output);
    WriteLn(1);
    WriteLn(0,' ',0);
    Close(Output);
    Exit;
  End;
  FillWays;
  For K:=1 To N Do Begin
    For Start:=1 To N Do If Pow[Start]<=K Then Begin
      Assign(Output,OutFile);
      ReWrite(Output);
      WriteLn(K);
      J:=0;
      FillChar(Where,SizeOf(Where),1);
      For I:=1 To N Do
        If Conn[I,Start] Then Begin
          Inc(J);
          Go(J,I);
          Some:=I;
        End;
      For I:=Pow[Start]+1 To K Do Begin
        Go(I,Some);
      End;
      J:=AnyAt(Some);
      Go(J,Start);
      Go(J,Some);
      FillChar(State,SizeOf(State),_Bad);
      NumBad:=N;
      State[Start]:=_Free;
      Dec(NumBad);
      For I:=1 To K Do If State[Where[I]]=_Bad Then Begin
        State[Where[I]]:=_Guard;
        Dec(NumBad);
      End;
      {cycle using label}
      Lab:
        {Searching for good move}
        For I:=1 To N Do
          If State[I]=_Guard Then Begin
            For J:=1 To N Do If Conn[I,J] Then
              If (State[J]=_Bad) And CanMove(I,J) Then Begin
                Go(AnyAt(I),J);
                If AnyAt(I)=0 Then State[I]:=_Free;
                State[J]:=_Guard;
                Dec(NumBad);
                Goto Lab;
              End;
          End;
        {Searching for unused guard}
        For I:=1 To K Do Begin
          Ok:=True;
          For J:=1 To N Do If Conn[Where[I],J] And Not CanMove(Where[I],J) Then Begin Ok:=False; Break; End;
          If Ok Then Begin
            {Yeah, we've got an unused guard!}
            For II:=1 To K Do If II<>I Then Begin
              For J:=1 To N Do If Conn[Where[II],J] And (State[J]=_Bad) Then Begin
                Go(I,J);
                If AnyAt(I)=0 Then State[I]:=_Free;
                State[J]:=_Guard;
                Dec(NumBad);
                Goto Lab;
              End;
            End;
          End;
        End;
      {end of cycle using label}
      WriteLn(0,' ',0);
      Close(Output);
      If NumBad=0 Then Exit;
    End;
  End;
End;
Begin
  Load;
  Solve;
End.
