{$I-,Q-,R-,S-,V-,X-}
var
  n, p, q, np, nq: int64;

procedure ReadAll;
begin
  Assign(Input, 'Input.txT'); Reset(Input);

  Read(n);
  Read(p);
  Read(q);

  Close(Input);
end;

procedure Out;
begin
  Assign(Output, 'Output.txT'); ReWrite(Output);

  WriteLn(np);
  WriteLn(nq);

  Close(Output);
end;

procedure Solve;
var
  k: int64;
  pq, pp, qp, qq, p0, q0, p1, q1: int64;
begin
  pq := 0; pp := 1;
  qp := 0; qq := 1;
  while ((p>0) and (q>0)) do begin
    if (p>=q) and (q<>0) then begin
      k := p div q;
      p := p - (k*q);
      pp := pp - (k*qp);
      pq := pq - (k*qq);
    end;
    if (q>=p) and (p<>0) then begin
      k := q div p;
      q := q - (k*p);
      qq := qq - (k*pq);
      qp := qp - (k*pp);
    end;
  end;

  if (p>0) then begin
    p1 := pp;
    q1 := pq;
    p0 := qp;
    q0 := qq;
  end else begin
    p1 := qp;
    q1 := qq;
    p0 := pp;
    q0 := pq;
  end;

  if (p0<0) then begin
    p0 := -p0; q0 := -q0;
  end;

  np := q1;
  nq := -p1;
  if (p0=0) then exit;

  k := (n - nq) div p0;

  np := np - (k*q0);
  nq := nq + (k*p0);

  while (nq>n) do begin
    np := np + (q0);
    nq := nq - (p0);
  end;
  while (nq<0) do begin
    np := np - (q0);
    nq := nq + (p0);
  end;

  if (q0<0) then begin
    p0 := -p0; q0 := -q0;
  end;
  if (q0=0) then exit;
  while (np<1) do begin
    np := np + (q0);
    nq := nq - (p0);
  end;
end;

begin
  ReadAll;
  Solve;
  Out;
end.
