{$ifdef check}
{$i+,n+,q+,r+,s+}
{$else}
{$i-,n+,q-,r-,s-}
{$endif}
const eps=1e-5;
var f:text;
    m,n:integer;
    v1:array[1..100] of double;
    v2:array[1..100] of double;
    {$ifdef check} aa,{$endif}
    a:array[1..200,1..400] of double;
    {$ifdef check} bb,{$endif}
    b:array[1..200] of double;
    x:array[1..400] of double;
    cikl:array[1..400,0..3] of byte;
    nx:integer;
    nc:integer;
    i:integer;

procedure osob;
var i:integer;
    s,ss:double;
begin
if (n=1)or(m=1) then begin
   s:=0;
   for i:=1 to m*n do begin s:=s+v1[i]*v1[i];s:=s+v2[i]*v2[i]; end;
   writeln(f,s:10:10);writeln(f,0);
   close(f);halt;
end;
if (m=2)and(n=2) then begin
   s:=0;
   for i:=1 to 2 do s:=s+v2[i];
   s:=s+v1[1];s:=s+v1[3];
   s:=s/4;
   ss:=0;
   ss:=ss+(v2[1]-s)*(v2[1]-s);
   ss:=ss+(v2[2]-s)*(v2[2]-s);
   ss:=ss+(v1[1]-s)*(v1[1]-s);
   ss:=ss+(v1[3]-s)*(v1[3]-s);
   writeln(f,ss:10:10);
   writeln(f,1);
   writeln(f,-s:10:10,' 1 2 3 4');
   close(f);halt;
end;
end;

function numb(x,y:integer):integer;
begin numb:=(x-1)*m+y; end;

procedure findcicles;
var i,j,k,l,x:integer;
begin
nc:=0;
for i:=1 to n-1 do {Hor and}
    for j:=1 to m-1 do { vert size}
        for k:=1 to n-i do    {Beg }
            for l:=1 to m-j do begin {points}
                inc(nc);  {found cicl}
                cikl[nc,0]:=k;cikl[nc,1]:=l;
                cikl[nc,2]:=k+i;cikl[nc,3]:=l+j;
                for x:=l to l+j do begin
                    a[numb(k,x),nc]:=1;
                    a[numb(k+i,x),nc]:=1;
                end;
                for x:=k to k+i do begin
                    a[numb(l,x),nc]:=1;
                    a[numb(l+j,x),nc]:=1;
                end;
                if nc=400 then exit;
            end;
end;

procedure gauss;
var i,jj,j,k:integer;
    max:double;
    imax:integer;
    d:double;
    tt:double;
begin
for j:=1 to 2*m*n do begin
    max:=-1;
    for i:=j to 2*m*n do
        if a[j,i]>max then begin max:=a[j,i];imax:=i; end;
    if max<eps then break;
    for i:=j to nc do begin
        tt:=a[i,j];a[i,j]:=a[i,imax];a[i,imax]:=tt;
    end;
    tt:=b[j];b[j]:=b[imax];b[imax]:=tt;
    for i:=j+1 to 2*m*n do begin
        d:=a[j,i]/a[j,j];
        for k:=j to nc do
            a[k,i]:=a[k,i]-a[k,j]*d;
        b[i]:=b[i]-b[j]*d;
    end;
end;
{$ifdef check}writeln('Finished at ',j);{$endif}
jj:=j;
j:=jj+1;
repeat
   dec(j);
   max:=-1;
   for i:=j to nc do if a[i,j]>max then begin max:=a[i,j];imax:=i; end;
until max>eps;
for i:=j to nc do x[i]:=0;
x[imax]:=b[j]/a[imax,j];
for i:=j-1 downto 1 do begin
    x[i]:=b[i];
    for j:=i+1 to nc do x[i]:=x[i]-x[j]*a[j,i];
    x[i]:=x[i]/a[i,i];
end;
end;

{$ifdef check}
procedure checksol;
var i,j:integer;
    s:double;
begin
writeln('---');
for j:=1 to 2*m*n do begin
    s:=0;
    for i:=1 to nc do s:=s+x[i]*aa[i,j];
    if abs(s-bb[j])<eps then writeln('Wrong');
end;
writeln('Done.');
end;
{$endif}

procedure oout(k,l,i,j:integer);
var x:integer;
begin
write(f,(i-k+1)+(j-l)+(l-k)+(j-l),' ');
for x:=k to i do write(f,numb(x,l),' ');
for x:=l+1 to j do write(f,numb(i,x),' ');
for x:=i-1 downto k do write(f,numb(x,j),' ');
for x:=j-1 downto l+1 do write(f,numb(k,x),' ');
end;

procedure out;
var i,nn:integer;
begin
nn:=0;
writeln(f,0);
for i:=1 to nc do if x[i]>eps then inc(nn);
writeln(f,nn);
for i:=1 to nc do if x[i]>eps then begin
    write(f,x[i]:5:5,' ');
    oout(cikl[i,0],cikl[i,1],cikl[i,2],cikl[i,3]);
    writeln(f);
end;
end;

begin
assign(f,'input.txt');reset(f);
read(f,n,m);
for i:=1 to n*m do read(f,v1[i]);
for i:=1 to n*m do read(f,v2[i]);
for i:=1 to m*n do b[i]:=v1[i];
for i:=1 to m*n do b[i+m*n]:=v2[i];
assign(f,'output.txt');rewrite(f);
osob;
fillchar(a,sizeof(a),0);
findcicles;
{$ifdef check}
{writeln('found ',nc,' cikles');
writeln('have ',2*m*n,' equations');}
{$endif}
{$ifdef check}
aa:=a;bb:=b;
{$endif}
gauss;
{$ifdef check}
checksol;
{$endif}
out;
close(f);
end.
