{const MaxN =100; MaxWay = MaxN*MaxN;
type town = record n: integer;
a: array [0..maxn-1, 0..maxn-1] of longint;
x: array [0..maxn-1, 0..1] of longint; end;
way = record m: longint; w: array [0..MaxWay-1] of byte;  end;
}
Function MyWay(var t: Town; var w: Way): double;
var
  d: array [0..MaxN, 0..MaxN] of double;
  aa: array [0..MaxN, 0..MaxN] of boolean;
  i, j, ii, jj: integer;
  x1, y1, x2, y2, l: double;
  k, kk: integer;
  fr, sv: set of byte;
  dn: boolean;
  ad, dd: double;
  cc: array [0..MaxN] of integer;

procedure euler(v: integer);
var k: integer;
begin
  for k := 0 to t.n-1 do if aa[v, k] then begin
    aa[v, k] := false;
    euler(k);
  end;

  w.w[w.m] := v;
  inc(w.m);
end;

begin
  fillchar(w, sizeof(w), 0); MyWay := 0;

  for i := 0 to t.n-1 do for j := 0 to t.n-1 do begin
    x1 := t.x[i][0]; y1 := t.x[i][1];
    x2 := t.x[j][0]; y2 := t.x[j][1];
    d[i][j] := sqrt(sqr(x1-x2) + sqr(y1-y2));
  end;

  fillchar(aa, sizeof(aa), 0);
  fr := [0..t.n-1]; sv := [];

  ii := -1;
  for i := 0 to t.n-1 do for j := i+1 to t.n-1 do begin
    if (t.a[i, j] >0) then begin
       if (ii<0) or (d[ii,jj]>d[i,j]) then begin
         ii := i; jj := j;
       end;
    end;
  end;

  if (ii<0) then exit;
  Exclude(fr, ii);
  Exclude(fr, jj);
  Include(sv, ii);
  Include(sv, jj);
  aa[ii, jj] := true;
  aa[jj, ii] := true;

  while (fr<>[]) do begin
    ii := -1;
    for i := 0 to t.n-1 do if (i in fr) then begin
      for j := 0 to t.n-1 do if (j in sv) then begin
        if ((ii<0) or (d[i,j] < d[ii,jj])) then begin
          ii := i; jj := j;
        end;
      end;
    end;
    if (ii<0) then exit;
    Exclude(fr, ii);
    Include(sv, ii);
    aa[ii, jj] := true;
    aa[jj, ii] := true;
  end;

  w.m := 0;
  euler(0);

  fillchar(cc, sizeof(cc), 0);
  for i := 0 to w.m-1 do inc(cc[w.w[i]]);
  repeat
    kk := -1; dd := 0;
    for k := 0 to w.m-3 do begin
      if (cc[w.w[k+1]]>1) then begin
        ad := d[w.w[k],w.w[k+1]]+d[w.w[k+1],w.w[k+2]]-d[w.w[k], w.w[k+2]];
        if ((kk<0) or (ad > dd)) then begin
          dd := ad;
          kk := k;
        end;
      end;
    end;

    if (kk>=0) then begin
      dec(cc[w.w[kk+1]]);
      for i := kk+1 to w.m-2 do w.w[i] := w.w[i+1];
      dec(w.m);
    end;
  until ((kk<0) or (w.m<2));

  l := 0;
  for i := 0 to w.m-2 do l := l + d[w.w[i], w.w[i+1]];
  MyWay := l;
end;
{
var t: town;w: way;i: integer;
begin
 t.n := 4;
 fillchar(t.a, sizeof(t.a), 1);
 t.x[0, 0] := 1;  t.x[0, 1] := 0;
 t.x[1, 0] := 2;  t.x[1, 1] := 0;
 t.x[2, 0] := 3;  t.x[2, 1] := 0;
 t.x[3, 0] := 2;  t.x[3, 1] := 1;
 WriteLn(MyWay(t, w));
 WriteLn(w.m);
 for i := 0 to w.m-1 do write(w.w[i]:3);
 WriteLn;
end.
}