{const
  maxN=10;
  maxWay=maxN*maxN;
type
  Town=
    record
      n:integer;
      a:array[0..maxN-1,0..maxN-1]of longint;
      x:array[0..maxN-1,0..1]of longint;
    end;
type
  Way=
    record
      m:longint;
      w:array[0..maxWay-1]of byte;
    end;}
var
waveDist:array[0..maxN-1]of double;
waveNext:array[0..maxN-1]of integer;
marked:array[0..maxn-1]of integer;
dist:array[0..maxN-1,0..maxN-1]of double;
function myWay(var t:Town;var w:Way):double;
procedure countDist;
var i,j:integer;
    deltaX,deltaY:double;
begin
  for i:=0 to T.n-1 do
    for j:=i to T.n-1 do
      if T.a[i,j]=1 then
        begin
          deltaX:=(T.x[i,0])-(T.x[j,0]);
          deltaY:=(t.x[i,1])-(T.x[j,1]);
          dist[i,j]:=sqrt(deltaX*deltaX+deltaY*deltaY);
          dist[j,i]:=dist[i,j];
        end
      else
        begin
          dist[i,j]:=1.0e16;dist[j,i]:=1.0e16;
        end;
end;

procedure wave(d:double;perek,p:integer);
var i,j:integer;
begin
  if (waveDist[perek]>0)and(waveDist[perek]<d) then exit;
  waveDist[perek]:=d;
  waveNext[perek]:=p;
  for i:=0 to t.n-1 do
    if t.a[perek,i]<>0 then
      begin
        wave(d+dist[perek,i],i,perek);
      end;
end;
procedure clearWave;
var i,j:integer;
begin
  for i:=0 to t.n-1 do waveDist[i]:=-1;
end;
var point:integer;
    i,j:integer;
    markedCount:integer;
    min:double;
    minIndex:integer;
    di:double;
begin
  countDist;
  point:=0;
  markedCount:=0;
  w.m:=1;
  w.w[0]:=0;
  if t.n=1 then
    begin
      exit;
      myWAY:=0;
    end;
  repeat
    marked[point]:=1;inc(markedCount);if markedCount=t.n then break;
    clearWave;
    min:=1.0e30;
    wave(0,0,-1);
    for i:=0 to t.n-1 do
      if (waveDist[i]<min)and(marked[i]=0) then
        begin
          min:=waveDist[i];
          minIndex:=i;
        end;
    wave(0,minIndex,-1);
    while waveNext[point]<>-1 do
      begin
        point:=waveNext[point];
        w.w[w.m]:=point;
        inc(w.m);
      end;
  until markedCount=t.n;
  clearWave;
  wave(0,0,-1);
  while waveNext[point]<>-1 do
    begin
      point:=waveNext[point];
      w.w[w.m]:=point;
      inc(w.m);
    end;
  di:=0;
  for i:=1 to w.m do di:=di+dist[w.w[i-1],w.w[i]];
  myWay:=di;
end;


