#include <stdio.h>
#include <string.h>

int N;
FILE *fin, *fout;


struct Words
{
  int K;
  char W[30][30];
};

int SPK2[2][2][2] = {{{-1, -1}, {-1, -1}}, {{-1, -1}, {-1, -1}}};
Words SP[3][2] = {{
    {-1, {"", "⪨", "", "⮭",
    "", "䨮⮢", "宩", "ᨢ", "", ""}},
    {-1, {"", "让", "", "쪨",
    "᮪", "", "ᨭ", "訩", "", ""}}
       },{
    {-1, {"", "७", "", "᫮", "", ""}},
    {-1, {"", "祫", "稪", "", "",
    "ࠪ", "", "", "", "", ""}}
       },{
    {-1, {"", "㯠", "ᯨ", "",
    "", "ࠥ", "⠥", ""}},
    {-1, {"", "⮨", "", "룠",
    "ᨤ", "ᬮ", "", "", ""}}
       }};

Words S1[2] = {{-1, {".", "!", ".", ".", "⫮.", ""}},
    {0, {"⠫.", ".", ".", ".", ".", ""}}};

char PPP[30];
char *CapWrd(char *word)
{
  int i;
  const char X[] = "񦧨";
  const char Y[] = "";
  strcpy(PPP, word);
  for (i = 0; X[i]; i++) if (PPP[0] == X[i]) {PPP[0] = Y[i]; break;}
  return PPP;
}

int GetB()
{
  int b;
  fscanf(fin, "%d", &b);
  N--;
  return b;
}

int Cap = -1;
int IncrWord(Words &w)
{
  int rr = 0;
  w.K++;
  if (w.K < 0) w.K = 0;
  else if (w.W[w.K][0] == 0) {w.K = 0; rr = 1;}
  return rr;
}

int PutWord(Words &w, int b = 1)
{
  int rr = 0;
  if (b) w.K++;
  if (w.K < 0) w.K = 0;
  else if (w.W[w.K][0] == 0) {w.K = 0; rr = 1;}
  if (Cap >= 0) fprintf(fout, " ");
  if (Cap) fprintf(fout, "%s", CapWrd(w.W[w.K]));
  else fprintf(fout, "%s", w.W[w.K]);
  char ch = w.W[w.K][strlen(w.W[w.K])-1];
  if (ch == '.' || ch == '!' || ch == '?') Cap = 1;
  else Cap = 0;
  return rr;
}

void PutPrep(char pr[])
{
  fprintf(fout, "%s", pr);
  if (pr[0] == '.' || pr[0] == '!' || pr[0] == '?') Cap = 1;
}


int main()
{
  int i, j, k;
  fin = fopen("INPUT.TXT", "rt");
  fout = fopen("OUTPUT.TXT", "wt");
  fscanf(fin, "%d", &N);
  while(N > 0)
  {
    if (N == 1) PutWord(S1[GetB()]);
    else if (N == 2 || N == 4)
    {
      int b1 = GetB();
      int b2 = GetB();
      int L = 0;
      if (SPK2[b1][b2][0] == SP[1][b1].K && SPK2[b1][b2][1] == SP[2][b2].K) L = 1;
      SPK2[b1][b2][0] = SP[1][b1].K;
      SPK2[b1][b2][1] = SP[2][b2].K;
      if (PutWord(SP[1][b1], L))
      {
        IncrWord(SP[2][0]);
        IncrWord(SP[2][1]);
      }
      PutWord(SP[2][b2], 0);
      PutPrep(".");
    }
    else
    {
      if (PutWord(SP[0][GetB()]))
      {
        int bb = 0;
        if (IncrWord(SP[1][0])) bb = 1;
        if (IncrWord(SP[1][1])) bb = 1;
        if (bb)
        {
          IncrWord(SP[2][0]);
          IncrWord(SP[2][1]);
        }
      }
      if (N >= 0) PutWord(SP[1][GetB()], 0);
      if (N >= 0) PutWord(SP[2][GetB()], 0);
      PutPrep(".");
    }
  }
  fclose(fin);
  fclose(fout);
  return 0;
}
