{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T+,V+,X+.Y+}
{$M 65520,0,655360}

uses crt;
const inputf = 'INPUT.TXT';
     outputf = 'OUTPUT.TXT';
     maxn = 100;
     maxp = 100; { Monte }
       tv = 8;
       pi = 3.1415926535897932384626433832795;
type pixel = record
               x,y : extended
             end;
     line = record
              a,b,c : extended
            end;
type tr = record
            l1,l2,l3 : line;
            p1,p2,p3 : pixel
          end;
var i,j,bt,n,max : longint;
        ms : array [1..maxn] of tr;
        sp : array [1..maxn] of extended;
     xp,yp : extended;

procedure readf;
begin
  assign(input,inputf);
  reset(input);
  readln(n);
  for i:=1 to n do
   begin
     readln(ms[i].p1.x,ms[i].p1.y,ms[i].p2.x,ms[i].p2.y,ms[i].p3.x,ms[i].p3.y);
   end;
  close(input)
end;

procedure writef;
begin
  assign(output,outputf);
  rewrite(output);
{  writeln(max);}
  write(xp:11:11,' ',yp:11:11);
  flush(output);
  close(output)
end;

function str(x1,y1,x2,y2,x3,y3 : extended) : extended;
begin
  str:=abs(((x1*(y2-y3))+(x2*(y3-y1))+(x3*(y1-y2)))/2)
end;

function rastp(x,y : extended;p2 : pixel) : extended;
begin
  rastp:=sqrt(sqr(x-p2.x)+sqr(y-p2.y))
end;

function pvin(x,y : extended;t : tr;v : byte) : boolean;
var s1,s2,s3,S4,max : extended;
begin
 s4:=sp[v];
 if (s4=0) then
  begin
    if (t.p1.x=t.p2.x) and (t.p2.x=t.p3.x) and (t.p3.x=t.p1.x) and
     (t.p1.y=t.p2.y) and (t.p2.y=t.p3.y) and (t.p3.y=t.p1.y) then
     begin
       if (x=t.p1.x) and (y=t.p1.y) then pvin:=true else pvin:=false;
       exit
     end else
     begin
       if (rastp(x,y,t.p1)+rastp(x,y,t.p2)=rastp(t.p1.x,t.p1.y,t.p2)) or
        (rastp(x,y,t.p2)+rastp(x,y,t.p3)=rastp(t.p2.x,t.p2.y,t.p3)) or
         (rastp(x,y,t.p3)+rastp(x,y,t.p1)=rastp(t.p3.x,t.p3.y,t.p1))
         then pvin:=true else pvin:=false;
       exit
     end
  end;
 s1:=str(x,y,t.p1.x,t.p1.y,t.p2.x,t.p2.y);
 s2:=str(x,y,t.p2.x,t.p2.y,t.p3.x,t.p3.y);
 s3:=str(x,y,t.p3.x,t.p3.y,t.p1.x,t.p1.y);
 if s1+s2+s3=s4 then pvin:=true
  else pvin:=false
end;

function maxt(x,y : extended) : byte;
var m,i : byte;
begin m:=0;
{  for j:=1 to 100 do}
  for i:=1 to n do
   if pvin(x,y,ms[i],i) then inc(m);
   maxt:=m
end;

procedure srav(x,y : extended);
var d : byte;
begin
  d:=maxt(x,y);
  if d>max then
   begin
     max:=d; xp:=x; yp:=y
   end
end;

procedure pvver;
var i,d1,d2,d3 : byte;
begin
  for i:=1 to n do
   begin
     srav(ms[i].p1.x,ms[i].p1.y);
     srav(ms[i].p2.x,ms[i].p2.y);
     srav(ms[i].p3.x,ms[i].p3.y)
   end
end;

procedure par(x1,y1,x2,y2 : extended;var l : line);
begin
  l.a:=y1-y2;
  l.b:=x2-x1;
  l.c:=(x1*y2)-(y1*x2)
end;

procedure perp(l1,l2 : line;var x,y : extended);
       var d : extended;
begin d:=(l1.a*l2.b)-(l2.a*l1.b);
  x:=((l1.b*l2.c)-(l2.b*l1.c))/d;
  y:=((l2.a*l1.c)-(l2.c*l1.a))/d
end;

procedure change(var a,b : extended);
var k : extended;
begin
  k:=a; a:=b; b:=k
end;

function pero(x11,y11,x12,y12,x21,y21,x22,y22 : extended;var x,y : extended) : boolean;
var l1,l2 : line;

begin
  par(x11,y11,x12,y12,l1);
  par(x21,y21,x22,y22,l2);
  if l1.a*l2.b=l2.a*l1.b then
   begin
     pero:=false;
     exit
   end;
  perp(l1,l2,x,y);
  if x11>x12 then change(x11,x12);
  if x21>x22 then change(x21,x22);
  if (x>=x11) and (x<=x12) and (x>=x21) and (x<=x22) then pero:=true
   else pero:=false
end;

procedure pvper;
var x,y : extended;
begin
  for i:=1 to n-1 do
   for j:=i+1 to n do
    begin
      if pero(ms[i].p1.x,ms[i].p1.y,ms[i].p2.x,ms[i].p2.y,ms[j].p1.x,ms[j].p1.y,ms[j].p2.x,ms[j].p2.y,x,y)
       then srav(x,y);
      if pero(ms[i].p1.x,ms[i].p1.y,ms[i].p2.x,ms[i].p2.y,ms[j].p2.x,ms[j].p2.y,ms[j].p3.x,ms[j].p3.y,x,y)
       then srav(x,y);
      if pero(ms[i].p1.x,ms[i].p1.y,ms[i].p2.x,ms[i].p2.y,ms[j].p1.x,ms[j].p1.y,ms[j].p3.x,ms[j].p3.y,x,y)
       then srav(x,y);
      if pero(ms[i].p2.x,ms[i].p2.y,ms[i].p3.x,ms[i].p3.y,ms[j].p1.x,ms[j].p1.y,ms[j].p2.x,ms[j].p2.y,x,y)
       then srav(x,y);
      if pero(ms[i].p2.x,ms[i].p2.y,ms[i].p3.x,ms[i].p3.y,ms[j].p2.x,ms[j].p2.y,ms[j].p3.x,ms[j].p3.y,x,y)
       then srav(x,y);
      if pero(ms[i].p2.x,ms[i].p2.y,ms[i].p3.x,ms[i].p3.y,ms[j].p1.x,ms[j].p1.y,ms[j].p3.x,ms[j].p3.y,x,y)
       then srav(x,y);
      if pero(ms[i].p3.x,ms[i].p3.y,ms[i].p1.x,ms[i].p1.y,ms[j].p1.x,ms[j].p1.y,ms[j].p2.x,ms[j].p2.y,x,y)
       then srav(x,y);
      if pero(ms[i].p3.x,ms[i].p3.y,ms[i].p1.x,ms[i].p1.y,ms[j].p2.x,ms[j].p2.y,ms[j].p3.x,ms[j].p3.y,x,y)
       then srav(x,y);
      if pero(ms[i].p3.x,ms[i].p3.y,ms[i].p1.x,ms[i].p1.y,ms[j].p1.x,ms[j].p1.y,ms[j].p3.x,ms[j].p3.y,x,y)
       then srav(x,y)
    end
end;

begin
  readf;
  for i:=1 to n do sp[i]:=str(ms[i].p1.x,ms[i].p1.y,ms[i].p2.x,ms[i].p2.y,ms[i].p3.x,ms[i].p3.y);
  max:=0;
  pvver;
  pvper;
  writef
end.
