{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Program Triangle;
 Const
   Eps = 0.0001;
 Var
   Inp, Out: Text;
   A       : Array [1..100] of Record
                                 X1, Y1, X2, Y2, X3, Y3: Double;
                               End;
   N       : Integer;
   I, G    : Integer;
   X, Y    : Double;
   XM, YM  : Double;
   A1, B1  : Double;
   A2, B2  : Double;
   C1, C2  : Double;
   K, KMax : Integer;

Procedure Init;
Begin
  Assign(Inp, 'INPUT.TXT');
  Assign(Out, 'OUTPUT.TXT');
  Reset(Inp);
  ReWrite(Out);
End;

Procedure Done;
Begin
  Close(Inp);
  Close(Out);
End;

Function Min(A, B, C: Double): Double;
 Var
   M: Double;
Begin
 If B > C
  Then M:=C
  Else M:=B;
 If A > M
  Then Min:=M
  Else Min:=A;
End;

Function Max(A, B, C: Double): Double;
 Var
   M: Double;
Begin
 If B < C
  Then M:=C
  Else M:=B;
 If A < M
  Then Max:=M
  Else Max:=A;
End;

Function Min2(A, B: Double): Double;
Begin
  If A > B Then Min2:=B
           Else Min2:=A;
End;

Function Max2(A, B: Double): Double;
Begin
  If A < B Then Max2:=B
           Else Max2:=A;
End;

Function INN(X, Y: Double; I: Integer): Boolean;
 Var
   A1, B1, C1: Double;
   A2, B2, C2: Double;
   A3, B3, C3: Double;
Begin
  INN:=False;
  A1:=A[I].Y1 - A[I].Y2;
  B1:=A[I].X2 - A[I].X1;
  C1:=-A[I].X1*B1 - A[I].Y1*A1;
  A2:=A[I].Y2 - A[I].Y3;
  B2:=A[I].X3 - A[I].X2;
  C2:=-A[I].X2*B2 - A[I].Y2*A2;
  A3:=A[I].Y1 - A[I].Y3;
  B3:=A[I].X3 - A[I].X1;
  C3:=-A[I].X1*B3 - A[I].Y1*A3;
 If(((A1*A[I].X3 + B1*A[I].Y3 + C1)*(A1*X + B1*Y + C1) > 0)And
    ((A2*A[I].X1 + B2*A[I].Y1 + C2)*(A2*X + B2*Y + C2) > 0)And
    ((A3*A[I].X2 + B3*A[I].Y2 + C3)*(A3*X + B3*Y + C3) > 0))
 Then INN:=True;
 If (A1*X + B1*Y + C1 = 0)And(X > Min2(A[I].X1, A[I].X2))And(X < Max2(A[I].X1, A[I].X2))And
    (Y > Min2(A[I].Y1, A[I].Y2))And(Y < Max2(A[I].Y1, A[I].Y2)) Then
    INN:=True;
 If (A2*X + B2*Y + C2 = 0)And(X > Min2(A[I].X2, A[I].X3))And(X < Max2(A[I].X2, A[I].X3))And
    (Y > Min2(A[I].Y2, A[I].Y3))And(Y < Max2(A[I].Y2, A[I].Y3)) Then
    INN:=True;
 If (A3*X + B3*Y + C3 = 0)And(X > Min2(A[I].X1, A[I].X3))And(X < Max2(A[I].X1, A[I].X3))And
    (Y > Min2(A[I].Y1, A[I].Y3))And(Y < Max2(A[I].Y1, A[I].Y3)) Then
    INN:=True;
End;

Procedure Prov(X, Y: Double; Var K: Integer);
 Var
   I: Integer;
Begin
  K:=0;
 For I:=1 To N Do
  If INN(X, Y, I)
  Then Inc(K);
End;

Procedure Run;
Begin
  Readln(Inp, N);
 For I:=1 To N Do
   Read(Inp, A[I].X1, A[I].Y1, A[I].X2, A[I].Y2, A[I].X3, A[I].Y3);
 For I:=1 To N - 1 Do
 Begin
   A1:=A[I].Y1 - A[I].Y2;
   B1:=A[I].X2 - A[I].X1;
   C1:=-A[I].X1*B1 - A[I].Y1*A1;
  For G:=I + 1 To N Do
  Begin
    A2:=A[G].Y1 - A[G].Y2;
    B2:=A[G].X2 - A[G].X1;
    C2:=-A[G].X1*B2 - A[G].Y1*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
    A2:=A[G].Y1 - A[G].Y3;
    B2:=A[G].X3 - A[G].X1;
    C2:=-A[G].X3*B2 - A[G].Y3*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
    A2:=A[G].Y2 - A[G].Y3;
    B2:=A[G].X3 - A[G].X2;
    C2:=-A[G].X2*B2 - A[G].Y2*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
  End;
   A1:=A[I].Y1 - A[I].Y3;
   B1:=A[I].X3 - A[I].X1;
   C1:=-A[I].X1*B1 - A[I].Y1*A1;
  For G:=I + 1 To N Do
  Begin
    A2:=A[G].Y1 - A[G].Y2;
    B2:=A[G].X2 - A[G].X1;
    C2:=-A[G].X1*B2 - A[G].Y1*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
    A2:=A[G].Y1 - A[G].Y3;
    B2:=A[G].X3 - A[G].X1;
    C2:=-A[G].X3*B2 - A[G].Y3*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
    A2:=A[G].Y2 - A[G].Y3;
    B2:=A[G].X3 - A[G].X2;
    C2:=-A[G].X2*B2 - A[G].Y2*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
  End;
   A1:=A[I].Y2 - A[I].Y3;
   B1:=A[I].X3 - A[I].X2;
   C1:=-A[I].X2*B1 - A[I].Y2*A1;
  For G:=I + 1 To N Do
  Begin
    A2:=A[G].Y1 - A[G].Y2;
    B2:=A[G].X2 - A[G].X1;
    C2:=-A[G].X1*B2 - A[G].Y1*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
    A2:=A[G].Y1 - A[G].Y3;
    B2:=A[G].X3 - A[G].X1;
    C2:=-A[G].X3*B2 - A[G].Y3*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
    A2:=A[G].Y2 - A[G].Y3;
    B2:=A[G].X3 - A[G].X2;
    C2:=-A[G].X2*B2 - A[G].Y2*A2;
    Y:=(C1*A2 - C2*A1)/(B2*A1 - B1*A2 + 0.000001);
    X:=(C1 - B1*Y)/(A1 + 0.000001);
    Prov(X, Y, K);
   If K > KMax Then
   Begin
    XM:=X;
    YM:=Y;
    KMax:=K;
   End;
  End;
 End;
  Writeln(Out, XM:0:4, ' ', YM:0:4);
End;

Begin
  Init;
  Run;
  Done;
End.
