Const
  FInput='INPUT.TXT';
  FOutput='OUTPUT.TXT';
Var
  Input,Output:Text;
{----------------------------------------------------------------------------}
Procedure Init;
begin
  Assign(Input,FInput);
  Assign(Output,FOutput);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
end;
{----------------------------------------------------------------------------}
Const
  MaxN=100+20;
Type
  TPixel=Extended;
  TMasCoo=array[1..MaxN,1..3]of TPixel;
Const
  Eps:TPixel=1E-10;
Var
  N:LongInt;
  X,Y:TMasCoo;
  BestResult:LongInt;
  ResX,ResY:TPixel;
  {}
  Result:LongInt;
  X1,Y1:TPixel;

  Function S(X1,Y1, X2,Y2, X3,Y3:TPixel):Extended;
  begin
    S:=( X1*(Y2-Y3) + X2*(Y3-Y1) + X3*(Y1-Y2) )/2;
  end;

  Function IsInside(Num:LongInt; X1,Y1:Extended):Boolean;
  Var
    S1,S2,S3,SN,Summ:Extended;
  begin
    IsInside:=True;
    SN:=Abs( S(X[Num,1],Y[Num,1], X[Num,2],Y[Num,2], X[Num,3],Y[Num,3]) );
    S1:=Abs( S(X1,Y1, X[Num,2],Y[Num,2], X[Num,3],Y[Num,3]) );
    S2:=Abs( S(X[Num,1],Y[Num,1], X1,Y1, X[Num,3],Y[Num,3]) );
    S3:=Abs( S(X[Num,1],Y[Num,1], X[Num,2],Y[Num,2], X1,Y1) );
    Summ:=S1+S2+S3;
    If SN<(Summ-Eps) then IsInside:=False;
  end;

Procedure Solve;
Var
  R,R2,R3:LongInt;
begin
  {Zero}
  {Input}
  Read(Input,N);
  For R:=1 to N do
  begin
    Read(Input,X[R,1],Y[R,1]);
    Read(Input,X[R,2],Y[R,2]);
    Read(Input,X[R,3],Y[R,3]);
  end;
  {Solve}
  BestResult:=0;
  For R:=1 to N do
    For R2:=1 to 3 do
    begin
      Result:=0;
      X1:=X[R,R2]; Y1:=Y[R,R2];
      For R3:=1 to N do
        If IsInside(R3,X1,Y1) then Inc(Result);
      If BestResult<Result then
      begin
        BestResult:=Result;
        ResX:=X1;
        ResY:=Y1;
      end;
    end;
  {Output}
  Writeln(Output,ResX:1:12,' ',ResY:1:12);
end;
{----------------------------------------------------------------------------}
begin
  Init;
  Solve;
  Done;
end.
