{$I-,Q-,R-,S-,V-,X-}
const
  eps = 1e-8;
type
  float = double;
  t3dp = record
    x,y,z: float;
  end;
var
  p: array[0..5] of t3dp;
  t,d: array[0..5] of float;
  s: t3dp;
procedure init;
var i: integer;
  f: file;
begin
  assign(f,'INPUT.TXT'); reset(f);
  randseed:= filesize(f);
  close(f);
  assign(input,'INPUT.TXT'); reset(input);
  for i:= 1 to 4 do read(p[i].x,p[i].y,p[i].z);
  for i:= 2 to 4 do read(t[i]);
  close(input);
end;
function dist(a,b: t3dp): float;
begin
  dist:= sqrt(sqr(a.x-b.x)+sqr(a.y-b.y)+sqr(a.z-b.z));
end;
procedure solve;
var n: t3dp;
  sl,l,q,w,e: float;
  pc,i: integer;
begin
  s.x:= 0.0; s.y:= 0.0; s.z:= 0.0; l:= 0;
  for i:= 1 to 4 do l:= l+abs(p[i].x)+abs(p[i].y)+abs(p[i].z);
  sl:= l; e:= 0.0; q:= dist(s,p[1]);
  for i:= 2 to 4 do e:= e+sqr(q+t[i]-dist(s,p[i])); w:= e;
  e:= 1e+40;
  repeat l:= sl/10; pc:= 0;
    repeat inc(pc);
      n.x:= s.x+(random-0.5)*l;
      n.y:= s.y+(random-0.5)*l;
      n.z:= s.z+(random-0.5)*l;
      q:= dist(n,p[1]); w:= 0.0;
      for i:= 2 to 4 do w:= w+sqr(q+t[i]-dist(n,p[i]));
      if w<e then
      begin
        e:= w;
        s:= n;
      end else begin
        l:= l/100.0;
      end;
    until(pc>100);
  until(w<eps);
end;
procedure done;
var i: integer;
begin
  assign(output,'OUTPUT.TXT'); rewrite(output);
  writeln(s.x:0:5,#32,s.y:0:5,#32,s.z:0:5);
  close(output);
end;
begin
  init;
  solve;
  done;
end.
