#include <stdio.h>

int N;
int L[3][500];
int A[3][500][500];
int B[3][500][500];

int M;
int C[500], D[500];
int R[10001];

void input()
{
  int i;
  FILE *f = fopen("INPUT.TXT", "rt");
  fscanf(f, "%d%d", &N, &M);
  for (i = 0; i < N; i++) {L[0][i] = 0; L[1][i] = 0; L[2][i] = 0;}
  for (i = 0; i < M; i++)
  {
    int a, b, c;
    fscanf(f, "%d%d%d", &a, &b, &c);
    A[c-1][a-1][L[c-1][a-1]] = b-1;
    B[c-1][a-1][L[c-1][a-1]] = i;
    L[c-1][a-1]++;
    if (a != b)
    {
      A[c-1][b-1][L[c-1][b-1]] = a-1;
      B[c-1][b-1][L[c-1][b-1]] = i;
      L[c-1][b-1]++;
    }
  }
  fclose(f);
}

void output()
{
  int i, K = 0;
  FILE *f = fopen("OUTPUT.TXT", "wt");
  for (i = 0; i < M; i++) if (!R[i]) K++;
  fprintf(f, "%d\n", K);
  for (i = 0; i < M; i++) if (!R[i]) fprintf(f, "%d ", i+1);
  fclose(f);
}

void Find(int z, int u)
{
  int i;
  C[z] = u;
  for (i = 0; i < L[2][z]; i++)
  {
    if (!C[A[2][z][i]])
    {
      R[B[2][z][i]] = 1;
      Find(A[2][z][i], u);
    }
  }
}

void Find1(int z, int Y)
{
  int i;
  for (i = 0; i < L[Y][z]; i++)
  {
    if (D[z] != D[A[Y][z][i]])
    {
      R[B[Y][z][i]] = 1;
      int CC = D[A[Y][z][i]];
      int j;
      for (j = 0; j < N; j++) if (D[j] == CC) D[j] = D[z];
    }
  }
}

int main()
{
  int i, j, u = 1;
  input();
  for (i = 0; i < M; i++) R[i] = 0;
  for (i = 0; i < N; i++) C[i] = 0;
  for (i = 0; i < N; i++) if (!C[i]) Find(i, u++);
  for (i = 0; i < N; i++) D[i] = C[i];
  for (i = 0; i < N; i++) Find1(i, 0);
  for (i = 0; i < N; i++) D[i] = C[i];
  for (i = 0; i < N; i++) Find1(i, 1);
  output();
  return 0;
}
