#define MAX 						512

#include <stdio.h>
#include <string.h>


void input ();
void solve ();
void output ();
void prim (int color);
int check ();

int n, m, ways [20000] [3], outsiders [20000], answer = 1, deleters = 0;
int component [MAX], save [MAX];


main ()
 {
 	input ();
   solve ();
   output ();

   return (0);
 }


void input ()
 {
   FILE * file = fopen ("INPUT.TXT", "r");
   fscanf (file, "%d %d", & n, & m);

   for (int i = 0; i < m; i ++)
    {
      fscanf (file, "%d %d %d", & ways [i] [0], & ways [i] [1], & ways [i] [2]);
      ways [i] [0] --; ways [i] [1] --;
    }

   fclose (file);
 }

 
void solve ()
 {
 	for (int i = 0; i < n; i ++)
    component [i] = i;

   memset (outsiders, 0, 80000);
   prim (3);
   memcpy (save, component, n << 2);
   prim (1);
   answer &= check ();
   memcpy (component, save, n << 2);
   prim (2);
   answer &= check ();   
 }

 
void output ()
 {
 	FILE * file = fopen ("OUTPUT.TXT", "w");
   
   if (! answer)
    fprintf (file, "-1");
   else
    {
	   fprintf (file, "%d\n", deleters);

      for (int i = 0; i < m; i ++)
       if (outsiders [i])
        fprintf (file, "%d ", i + 1);
    }
    
   fclose (file);
 }


void prim (int color)
 {
   int change;
   
   for (int i = 0; i < m; i ++)
     if (ways [i] [2] == color)
      {
       if (component [ways [i] [0]] != component [ways [i] [1]])
        {
          change = component [ways [i] [1]];
          
          for (int j = 0; j < n; j ++)
           if (component [j] == change)
            component [j] = component [ways [i] [0]];
        }
       else outsiders [i] = 1, deleters ++;
      }
 }


int check ()
 {
 	for (int i = 0; i < n; i ++)
    if (component [i] != component [0])
     return (0);

   return (1);
 }
 
