#define MAX						128
#define INF						2000000000

#include <stdio.h>
#include <string.h>

void solve ();
int deixtra ();
int choose_max ();

int n, matrix [MAX] [MAX], boy [MAX], been [MAX], max, tests;


main ()
 {
   FILE * fin = fopen ("DETAILS.DAT", "r");
   FILE * fout = fopen ("DETAILS.SOL", "w");

   fscanf (fin, "%d", & tests);

   for (int i = 0; i < tests; i ++)
    {
    	fscanf (fin, "%d", & n);

      for (int i = 0; i < n; i ++)
       {
	     fscanf (fin, "%d", & matrix [i] [0]);
        
	     for (int j = 1; j < n; j ++)
         fscanf (fin, ",%d", & matrix [i] [j]);
       }

      solve ();

      for (int i = 0; i < n; i ++)
       fprintf (fout, "%d ", boy [i] + 1);

      fprintf (fout, "\n%d\n", max);
    }

   fclose (fin);
   fclose (fout);

   return (0);
 }



void solve ()
 {
   int min;
   memset (been, 0, n << 2);
   
   for (int i = 0; i < n; i ++)
    {
     min = INF;
     
     for (int j = 0; j < n; j ++)
      if ((! been [j]) && (matrix [i] [j] < min))
       {
         min = matrix [i] [j];
         boy [i] = j;
       }

     been [boy [i]] = 1;
    }

   int time = 1000000 / n / n / tests;
   max = choose_max ();
   
   for (int i = 0; i < time; i ++)
    {
      for (int j = 0; j < n; j ++)
	    for (int k = 0; k < n; k ++)
        if ((matrix [j] [boy [j]] == max) || (matrix [k] [boy [k]] == max))
         if ((matrix [j] [boy [k]] < max) && (matrix [k] [boy [j]] < max))
          {
            boy [j] ^= boy [k];
            boy [k] ^= boy [j];
            boy [j] ^= boy [k];
            max = choose_max ();
          }
    }
 }


int choose_max ()
 {
   int max = -1;

   for (int i = 0; i < n; i ++)
    if (max < matrix [i] [boy [i]])
     max = matrix [i] [boy [i]];

   return (max);
 }
 

