#include <stdio.h>

int N;
int c[501][501];
int num[501][501];

int tr[501][501];
int mark[501], total;
int oldmark[501], oldtotal;

void add( int col )
{
  int i, j;

restart:
  for (i = 1; i <= N; i++)
    if (mark[i])
      for (j = 1; j <= N; j++)
        if (!mark[j] && c[i][j] == col)
        {
          mark[j] = 1;
          total++;
          tr[i][j] = tr[j][i] = 1;
          goto restart;
        }
}

int main( void )
{
  int M, i, j;

  freopen("INPUT.TXT", "r", stdin);
  freopen("OUTPUT.TXT", "w", stdout);
  scanf("%i %i", &N, &M);
  for (i = 1; i <= M; i++)
  {
    int x, y, color;

    scanf("%i %i %i", &x, &y, &color);
    num[x][y] = num[y][x] = i;
    c[x][y] = c[y][x] = color;
  }
  mark[1] = 1;
  total++;
  add(3);
  oldtotal = total;
  memcpy(oldmark, mark, sizeof(mark));
  add(1);
  if (total < N)
  {
    printf("-1");
    return 0;
  }
  total = oldtotal;
  memcpy(mark, oldmark, sizeof(oldmark));
  add(2);
  if (total < N)
  {
    printf("-1");
    return 0;
  }
  else
  {
    int cnt = 0;
    
    for (i = 1; i <= N; i++)
      for (j = i + 1; j <= N; j++)
        if (c[i][j] && !tr[i][j])
          cnt++;
    printf("%i\n", cnt);
    for (i = 1; i <= N; i++)
      for (j = i + 1; j <= N; j++)
        if (c[i][j] && !tr[i][j])
          printf("%i ", num[i][j]);
  }
  return 0;
}

