#include <stdio.h>

int num[201][201];
int c[201][201];
int mark[201];
int N;

void dfs( int i )
{
  int j;
  
  if (mark[i])
    return;
  mark[i] = 1;
  for (j = 1; j <= N; j++)
    if (c[i][j])
      dfs(j);
}

int main( void )
{
  int A, B, M, costA = 0, costB = 0, i, j, k;
  
  freopen("output.txt", "r", stdin);
  freopen("input.txt", "w", stdout);
  scanf("%i %i %i %i", &N, &A, &B, &M);
  for (i = 1; i <= M; i++)
  {
    int x, y, tr;

    scanf("%i %i %i", &x, &y, &tr);
    num[x][y] = num[y][x] = i;
    c[x][y] = c[y][x] = tr;
  }
  dfs(A);
  for (i = 1; i <= N; i++)
    if (!mark[i])
    {
      int j;

      for (j = 1; j <= N; j++)
        c[i][j] = c[j][i] = 0;
    }
  for (i = 1; i <= N; i++)
    for (j = 1; j <= N; j++)
      if ((j != A) && (j != B))
      {
        int cnt = 0;

        for (k = 1; k <= N; k++)
          cnt += c[j][k];
        if (cnt == 1)
          for (k = 1; k <= N; k++)
            c[j][k] = c[k][j] = 0;
      }
  for (i = 1; i <= N; i++)
    costA += c[A][i], costB += c[B][i];
  if (costA < costB)
  {
    int cnt = 0;
    
    for (i = 1; i <= N; i++)
      if (c[A][i])
        cnt++;
    printf("%i %i\n", cnt, costA);
    for (i = 1; i <= N; i++)
      if (c[A][i])
        printf("%i ", num[A][i]);
  }
  else
  {
    int cnt = 0;
    
    for (i = 1; i <= N; i++)
      if (c[B][i])
        cnt++;
    printf("%i %i\n", cnt, costB);
    for (i = 1; i <= N; i++)
      if (c[B][i])
        printf("%i ", num[B][i]);
  }
  return 0;
}

