#include <stdio.h>
#include <ctype.h>

typedef int Num[61];

Num w[201][102];
int K[2000];

void add( int *a, int *b )
{
  int i, len = (a[0] > b[0] ? a[0] : b[0]);

  for (i = 1; i <= b[0]; i++)
    a[i] += b[i];
  for (i = 1; i <= len; i++)
    if (a[i] >= 10)
    {
      a[i] -= 10;
      a[i + 1]++;
    }
  a[0] = len;
  if (a[a[0] + 1])
    a[0]++;
}

void sub( int *a, int *b )
{
  int i;

  for (i = 1; i <= b[0]; i++)
  {
    a[i] -= b[i];
    if (a[i] < 0)
    {
      a[i] += 10;
      a[i + 1]--;
    }
  }
  while (!a[a[0]] && (a[0] > 1))
    a[0]--;
}

int less( int *a, int *b )
{
  int i;

  if (a[0] < b[0])
    return 1;
  if (a[0] > b[0])
    return 0;
  for (i = a[0]; i > 0; i--)
    if (a[i] < b[i])
      return 1;
    else if (a[i] > b[i])
      return 0;
  return 0;
}

int main( void )
{
  int N, i, j, h = 0;
  int c;
  
  freopen("INPUT.TXT", "r", stdin);
  freopen("OUTPUT.TXT", "w", stdout);
  scanf("%i", &N);
  while (isspace(c = getchar()))
    ;
  K[0] = 0;
  do
  {
    K[++K[0]] = c - '0';
  } while (isdigit(c = getchar()));
  i = 1;
  j = K[0];
  while (i < j)
  {
    int tmp = K[i];

    K[i] = K[j];
    K[j] = tmp;
    i++;
    j--;
  }
  
  w[0][0][0] = 1;
  w[0][0][1] = 1;
  for (i = 0; i < 2 * N; i++)
  {
    add(w[i + 1][1], w[i][0]);
    for (j = 1; j <= N; j++)
      add(w[i + 1][j + 1], w[i][j]),
      add(w[i + 1][j - 1], w[i][j]);
  }
  
  if (!less(K, w[2 * N][0]))
    printf("No solution for this testcase.\n");
  else
    for (i = 2 * N; i > 0; i--)
      if (less(K, w[i - 1][h + 1]))
	putchar('('), h++;
      else
	putchar(')'), sub(K, w[i - 1][h + 1]), h--;
  putchar('\n');
  return 0;
}

