Const
  FInput='INPUT.TXT';
  FOutput='OUTPUT.TXT';
Var
  Input,Output:Text;
{----------------------------------------------------------------------------}
Procedure Init;
begin
  Assign(Input,FInput);
  Assign(Output,FOutput);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
end;
{----------------------------------------------------------------------------}
Const
  MaxN=100+10;
  Max2N=2*MaxN;
  Max=100;
Type
  TLong=array[0..Max]of Byte;
Var
  Ans:String;
  Result:Boolean;
  N:LongInt;
  K:TLong;
  T:array[0..Max2N,0..MaxN]of TLong;
  {}

  {Long Arithmetic}
  Procedure ReadK;
  Var
    Ch:Char;
    R,R2:LongInt;
    S:String;
  begin
    Repeat Read(Input,Ch) Until (Ch in ['0'..'9']);
    K[0]:=0;
    While (Ch in ['0'..'9']) do
    begin
      Inc(K[0]);
      K[Max-K[0]+1]:=Ord(Ch)-Ord('0');
      Read(Input,Ch);
    end;
    For R:=Max downto Max-K[0] div 2+1 do
    begin
      R2:=K[R];
      K[R]:=K[Max-(Max-R)-1];
      K[Max-(Max-R)-1]:=R2;
    end;
  end;

  Procedure LongAddLong(Var A,B:TLong);
  Var
    O,R:Integer;
  begin
    O:=0;
    R:=Max;
    Repeat
      O:=A[R]+B[R]+O;
      A[R]:=O mod 10;
      O:=O div 10;
      Dec(R);
    Until (O=0);
    A[0]:=Max-R;
  end;

  Procedure LongSubInteger(Var A:TLong;B:Integer);
  Var
    R,O,P:Integer;
  begin
    R:=Max;
    O:=0;
    Repeat
      O:=(B mod 10)+O;
      P:=A[R]-O;
      If P<0 then
      begin
        A[R]:=A[R]+10-O;
        O:=abs(P);
      end else
      begin
        O:=0;
        A[R]:=P;
      end;
      B:=B div 10;
      Dec(R);
    Until (O=0);
    If A[R+1]<>0 then A[0]:=Max-R else A[0]:=Max-(R+1);
  end;

  Procedure LongSubLong(Var A,B:TLong);
  Var
    O,R,P:Integer;
  begin
    R:=Max;
    O:=0;
    Repeat
      P:=A[R]-B[R]-O;
      If P<0 then
      begin
        A[R]:=A[R]+10-B[R]-O;
        O:=Abs(P);
      end else
      begin
        A[R]:=P;
        O:=0;
      end;
      Dec(R);
    until (O=0);
    If A[R+1]<>0 then A[0]:=Max-R else A[0]:=Max-(R+1);
  end;

  Function CheckLong(A,B:TLong):Boolean;
  Var
    R:Integer;
  begin
    CheckLong:=False;
    {if ((i>b[0]) and (a[i]>0)) then begin gr := true; exit; end;}
    if (A[0]>B[0]) then R:=Max-A[0]+1 else R:=Max-B[0]+1;
    While R<=100 do
    begin
      If ((Max-R+1>A[0])and(B[R]>0)) then
      begin
        CheckLong:=False;
        Exit;
      end;
      If (A[R]<B[R]) then
      begin
        CheckLong:=False;
        Exit;
      end;
      If ((Max-R+1>B[0])and(A[R]>0)) then
      begin
        CheckLong:=True;
        Exit;
      end;
      If (A[R]>B[R]) then
      begin
        CheckLong:=True;
        Exit;
      end;
      Inc(R);
    end;
  end;
  {End Long Arithmetic}

  Procedure Table;
  Var
    R1,R2:LongInt;
  begin
    FillChar(T,SizeOf(T),0);
    T[0,0][1]:=1;
    T[0,0][Max]:=1;
    T[1,1][1]:=1;
    T[1,1][Max]:=1;
    For R1:=2 to (2*N) do
      For R2:=0 to N do
      begin
        If R2>0 then LongAddLong(T[R1,R2],T[R1-1,R2-1]);
        If R2<N then LongAddLong(T[R1,R2],T[R1-1,R2+1]);
      end;
  end;

Procedure Solve;
Var
  R,R1:LongInt;
  Col,Sum:LongInt;
  A:TLong;
begin
  {Zero}
  Result:=True;
  FillChar(K,SizeOf(K),0);
  {Input}
  ReadLn(Input,N);
  ReadK;
  {Solve}
  Table;
  Ans:='(';
  LongSubInteger(K,1);
  Sum:=1;
  Col:=1;
  While Col<(2*N) do
  begin
    A:=T[2*N-Col-1][Sum+1];
    If (Sum<N)and(CheckLong(A,K)) then
    begin
      Ans:=Ans+'(';
      Col:=Col+1;
      Sum:=Sum+1;
    end else
    begin
      If Sum<1 then
      begin
        Result:=False;
        Break;
      end;
      Ans:=Ans+')';
      LongSubLong(K,T[(2*N)-Col-1][Sum+1]);
      Col:=Col+1;
      Sum:=Sum-1;
    end;
  end;
  {Output}
  If Result then
  begin
    Write(Output,Ans);
  end else Writeln(Output,'No solution for this testcase.');
end;
{----------------------------------------------------------------------------}
begin
  Init;
  Solve;
  Done;
end.
