type string25 = string[25];
var F: text;
N,I,J,Z: integer;
R,S: string;
A: array [0..200,0..101] of string25;
const Zero: string25 = #0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0;

procedure Summ256(A,B: string25; var C: string25);
var I,J: integer;
begin
 J:=0;
 for I:=25 downto 1 do
 begin
  J:=J+Integer(A[I])+Integer(B[I]);
  A[I]:=Char(J);
  J:=J shr 8;
 end;
 C:=A;
end;

procedure Sub256(A,B: string25; var C: string25);
var I,J: integer;
begin
 J:=0;
 for I:=25 downto 1 do
 begin
  J:=J+Integer(A[I])-Integer(B[I]);
  A[I]:=Char(J);
  J:=J shr 8;
 end;
 C:=A;
end;

procedure Mul256(A: string25; N: byte; var C: string25);
var B: string25;
I: integer;
begin
 FillChar(B[1],25,0);
 B[0]:=#25;
 for I:=1 to N do
 begin
  Summ256(A,B,B);
 end;
 C:=B;
end;

procedure DecTo256(var S: string);
var A,B: string25;
I: integer;
begin
 FillChar(B[1],25,0);
 B[0]:=#25;
 A:=B;
 for I:=1 to Length(S) do
 begin
  Mul256(B,10,B);
  A[25]:=Char(Byte(S[I])-48);
  Summ256(A,B,B);
 end;
 S:=B;
end;

procedure Cannot;
begin
 Assign(F,'output.txt');
 Rewrite(F);
 Writeln(f,'No solution for this testcase.');
 Close(F);
 Halt(0);
end;

begin
 Assign(F,'input.txt');
 Reset(F);
 Readln(F,N);
 Readln(F,S);
 Close(F);
 if Length(S)>60 then Cannot;
 DecTo256(S);
 for I:=0 to 200 do
 for J:=0 to 101 do
 begin
  A[I,J,0]:=#25;
  for Z:=1 to 25 do A[I,J,Z]:=#0;
 end;
 A[0,0,25]:=#1;
 for I:=1 to 2*N do
 begin
  A[I,0]:=A[I-1,1];
  for J:=1 to N-Abs(I-N) do Summ256(A[I-1,J-1],A[I-1,J+1],A[I,J]);
 end;
 if S>A[2*N,0] then Cannot;
 R:='(';
 I:=2*N-1;
 J:=1;
 repeat
  if J=0 then
  begin
   Inc(J);
   R:=R+'(';
  end else
  if (A[I-1,J+1]>=S) and (A[I-1,J+1]<>Zero) then
  begin
   Inc(J);
   R:=R+'(';
  end else
  begin
   Sub256(S,A[I-1,J+1],S);
   Dec(J);
   R:=R+')';
  end;
  Dec(I);
 until I=0;
 Assign(F,'output.txt');
 Rewrite(F);
 Writeln(F,R);
 Close(F);
end.
