{$I-,Q-,R-,S-,V-,X-}
Program Hackers2;
Const
  InFile='output.txt';
  OutFile='input.txt';
  MaxN=202;
Var
  N,A,B:LongInt;
  NOut:Array[1..MaxN]Of Byte;
  Out:Array[1..MaxN,1..MaxN]Of Byte;
  Width:Array[1..MaxN,1..MaxN]Of LongInt;
  Number:Array[1..MaxN,1..MaxN]Of LongInt;
  Thd:Array[1..MaxN,1..MaxN]Of LongInt;
  Cut:Array[1..MaxN]Of LongInt;
  Front:Array[1..MaxN]Of Byte;
  Prev:Array[1..MaxN]Of Byte;
  How:Array[1..MaxN]Of Byte;
  Res:LongInt;
  ResNum:LongInt;
  ResDel:Array[1..MaxN*MaxN]Of LongInt;
  FrHead,FrTail:LongInt;
Procedure Load;
Var
  I,M,Src,Dst,Wdt:LongInt;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,A,B);
  If Not SeekEOF Then Read(M);
  FillChar(NOut,SizeOf(NOut),0);
  For I:=1 To M Do If Not SeekEOF Then Begin
    Read(Src,Dst,Wdt);
    Inc(NOut[Src]);
    Out[Src][NOut[Src]]:=Dst;
    Width[Src][NOut[Src]]:=Wdt;
    Number[Src][NOut[Src]]:=I;
    Inc(NOut[Dst]);
    Out[Dst][NOut[Dst]]:=Src;
    Width[Dst][NOut[Dst]]:=Wdt;
    Number[Dst][NOut[Dst]]:=I;
  End;
  Close(Input);
End;
Function Min(A,B:LongInt):LongInt;
Begin
  If A<B Then Min:=A Else Min:=B;
End;
Procedure GetThread;
Var
  Cur,I:LongInt;
Begin
  FillChar(Thd,SizeOf(Thd),0);
  Repeat
    FrHead:=2;
    FrTail:=1;
    FillChar(Cut,SizeOf(Cut),0);
    Cut[A]:=MaxLongInt;
    Front[FrTail]:=A;
    While FrTail<FrHead Do Begin
      Cur:=Front[FrTail];
      Inc(FrTail);
      For I:=1 To NOut[Cur] Do If (Thd[Cur][I]<Width[Cur][I]) And (Cut[Out[Cur][I]]=0) Then Begin
        Front[FrHead]:=Out[Cur][I];
        Prev[Out[Cur][I]]:=Cur;
        How[Out[Cur][I]]:=I;
        Cut[Out[Cur][I]]:=Min(Cut[Cur],Width[Cur][I]-Thd[Cur][I]);
        Inc(FrHead);
      End;
    End;
    If Cut[B]>0 Then Begin
      Cur:=B;
      While Cur<>A Do Begin
        Inc(Thd[Prev[Cur]][How[Cur]],Cut[B]);
        For I:=1 To NOut[Cur] Do If Out[Cur][I]=Prev[Cur] Then Dec(Thd[Cur][I],Cut[B]);
        Cur:=Prev[Cur];
      End;
    End;
  Until Cut[B]=0;
End;
Procedure HeapSort;
Var
  CNum:LongInt;
Procedure Swap(A,B:LongInt);
Var
  T:LongInt;
Begin
  T:=ResDel[A];
  ResDel[A]:=ResDel[B];
  ResDel[B]:=T;
End;
Procedure FlowUp(A:LongInt);
Begin
  While (A>1) And (ResDel[A Div 2]<ResDel[A]) Do Begin
    Swap(A,A Div 2);
    A:=A Div 2;
  End;
End;
Procedure FlowDown(A:LongInt);
Begin
  While ((2*A<=CNum) And (ResDel[2*A]>ResDel[A])) Or ((2*A+1<=CNum) And (ResDel[2*A+1]>ResDel[A])) Do Begin
    If (2*A=CNum) Or (ResDel[2*A]>ResDel[2*A+1]) Then Begin
      Swap(A,2*A);
      A:=2*A;
    End Else Begin
      Swap(A,2*A+1);
      A:=2*A+1;
    End;
  End;
End;
Begin
  For CNum:=1 To ResNum Do FlowUp(CNum);
  For CNum:=ResNum-1 DownTo 1 Do Begin
    Swap(1,CNum+1);
    FlowDown(1);
  End;
End;
Procedure Solve;
Var
  I,J:LongInt;
Begin
  GetThread;
  Res:=0;
  ResNum:=0;
  For I:=1 To N Do If Cut[I]>0 Then
    For J:=1 To NOut[I] Do If Cut[Out[I][J]]=0 Then Begin
      Inc(Res,Width[I][J]);
      Inc(ResNum);
      ResDel[ResNum]:=Number[I][J];
    End;
  HeapSort;
End;
Procedure Save;
Var
  I:LongInt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(ResNum,' ',Res);
  For I:=1 To ResNum Do Begin
    If I>1 Then Write(' ');
    Write(ResDel[I]);
  End;
  WriteLn;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
