{$I-,Q-,R-,S-,V-,X-}
Program TheDetails;
Const
  InFile='DETAILS.DAT';
  OutFile='DETAILS.SOL';
  MaxN=102;
Var
  N:Byte;
  T:Array[1..MaxN,1..MaxN]Of LongInt;
  PairD:Array[1..MaxN]Of LongInt;
  PairS:Array[1..MaxN]Of LongInt;
  MT:LongInt;
  CurMax:LongInt;
  CurTest,NTests:LongInt;
  Front:Array[1..MaxN]Of LongInt;
  Mark:Array[1..MaxN]Of Boolean;
  Prev:Array[1..MaxN]Of LongInt;
  FrHead,FrTail:LongInt;
Procedure Prepare;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Assign(Output,OutFile);
  ReWrite(Output);
  Read(NTests);
End;
Procedure Load;
Var
  I,J:LongInt;
  Ch:Char;
  St:String;
  Err:Word;
Begin
  Read(N);
  MT:=0;
  For I:=1 To N Do
    For J:=1 To N Do Begin
      If Not SeekEOF Then;
      St:='';
      Repeat
        Read(Ch);
        Case Ch Of
          ',':Break;
          '0'..'9':St:=St+Ch;
        End;
      Until SeekEOLN Or EOF;
      Val(St,T[I][J],Err);
      If T[I][J]>MT Then MT:=T[I][J];
    End;
End;
Function FindPairs:Boolean;
Var
  JJ,Cur,I,J:LongInt;
  Found:Boolean;
Begin
  FillChar(PairD,SizeOf(PairD),0);
  FillChar(PairS,SizeOf(PairS),0);
  FindPairs:=False;
  For I:=1 To N Do Begin
    FrHead:=2;
    FrTail:=1;
    Front[FrTail]:=I;
    FillChar(Mark,SizeOf(Mark),False);
    Mark[I]:=True;
    Found:=False;
    Prev[I]:=0;
    While FrTail<FrHead Do Begin
      Cur:=Front[FrTail];
      Inc(FrTail);
      For J:=1 To N Do If (T[J][Cur]<=CurMax) Then Begin
        If PairS[J]=0 Then Begin
          Found:=True;
          FrTail:=FrHead;
          Break;
        End;
        If Not Mark[PairS[J]] Then Begin
          Mark[PairS[J]]:=True;
          Prev[PairS[J]]:=Cur;
          Front[FrHead]:=PairS[J];
          Inc(FrHead);
        End;
      End;
    End;
    If Found Then Begin
      Repeat
        JJ:=PairD[Cur];
        PairS[J]:=Cur;
        PairD[Cur]:=J;
        J:=JJ;
        Cur:=Prev[Cur];
      Until Cur=0;
    End Else Exit;
  End;
  FindPairs:=True;
End;
Procedure Solve;
Var
  Left,Right:LongInt;
Begin
  Left:=0;
  Right:=MT;
  While Right-Left>1 Do Begin
    CurMax:=(Right+Left+1) Div 2;
    If FindPairs Then Begin
      Right:=CurMax;
    End Else Begin
      Left:=CurMax;
    End;
  End;
  CurMax:=Right;
  If FindPairs Then;
End;
Procedure Save;
Var
  I:LongInt;
Begin
  For I:=1 To N Do Begin
    If I>1 Then Write(' ');
    Write(PairS[I]);
  End;
  WriteLn;
  WriteLn(CurMax);
End;
Procedure CloseAll;
Begin
  Close(Input);
  Close(Output);
End;
Begin
  Prepare;
  For CurTest:=1 To NTests Do Begin
    Load;
    Solve;
    Save;
  End;
  CloseAll;
End.
