{$I-,Q-,R-,S-,V-,X-}
Program LittleBrackets;
Const
  InFile='INPUT.TXT';
  OutFile='OUTPUT.TXT';
  MaxLong=100;
  MaxN=102;
Type
  TLong=Array[1..MaxLong]Of Byte;
Var
  D:Array[0..2*MaxN,0..MaxN]Of TLong;
  N:Byte;
  K:TLong;
Procedure Zero(Var L:TLong);
Begin
  FillChar(L,SizeOf(L),0);
End;
Procedure One(Var L:TLong);
Begin
  Zero(L);
  L[1]:=1;
End;
Procedure Add(Var A,B:TLong);
Var
  I:LongInt;
  R,P:LongInt;
Begin
  P:=0;
  For I:=1 To MaxLong Do Begin
    R:=A[I]+B[I]+P;
    If R>=10 Then Begin
      A[I]:=R-10;
      P:=1;
    End Else Begin
      A[I]:=R;
      P:=0;
    End;
  End;
End;
Function Compare(Var A,B:TLong):ShortInt;
Var
  I:LongInt;
Begin
  For I:=MaxLong DownTo 1 Do
    If A[I]>B[I] Then Begin Compare:=1; Exit; End Else
      If A[I]<B[I] Then Begin Compare:=-1; Exit; End;
  Compare:=0;
End;
Procedure Sub(Var A,B:TLong);
Var
  I,R,P:LongInt;
Begin
  P:=0;
  For I:=1 To MaxLong Do Begin
    R:=LongInt(A[I])-B[I]-P;
    If R<0 Then Begin
      P:=1;
      A[I]:=R+10;
    End Else Begin
      P:=0;
      A[I]:=R;
    End;
  End;
End;
Procedure ReadLong(Var L:TLong);
Var
  I,J,CMax:LongInt;
  Ch:Char;
Begin
  Zero(L);
  CMax:=0;
  Repeat
    If EOF Then Break;
    Read(Ch);
    If (Ch<'0') Or (Ch>'9') Then Break;
    If (Ch='0') And (CMax=0) Then Continue;
    If CMax<MaxLong Then Begin
      Inc(CMax);
      L[CMax]:=Ord(Ch)-Ord('0');
    End;
  Until False;
  For I:=1 To CMax Div 2 Do Begin
    J:=L[I];
    L[I]:=L[CMax+1-I];
    L[CMax+1-I]:=J;
  End;
End;
Procedure Load;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  If Not SeekEOF Then ReadLong(K);
  Close(Input);
End;
Procedure Solve;
Var
  I,J:LongInt;
Begin
  FillChar(D,SizeOf(D),0);
  One(D[0][0]);
  For I:=1 To 2*N Do
    For J:=0 To N Do
      If J=0 Then D[I][J]:=D[I-1][J+1] Else
        If J=N Then D[I][J]:=D[I-1][J-1] Else Begin
          D[I][J]:=D[I-1][J+1];
          Add(D[I][J],D[I-1][J-1]);
        End;
  {For I:=MaxLong DownTo 1 Do If D[2*N][0][I]>0 Then Break;
  For I:=I DownTo 1 Do Write(D[2*N][0][I]);
  WriteLn;}
  Assign(Output,OutFile);
  ReWrite(Output);
  If Compare(K,D[2*N][0])>0 Then Begin
    WriteLn('No solution for this testcase.');
  End Else Begin
    J:=0;
    For I:=2*N DownTo 1 Do
      If J=0 Then Begin Write('('); Inc(J); End Else
        If J=N Then Begin Write(')'); Dec(J); End Else Begin
          If Compare(K,D[I-1][J+1])<=0 Then Begin
            Write('(');
            Inc(J);
          End Else Begin
            Write(')');
            Sub(K,D[I-1][J+1]);
            Dec(J);
          End;
        End;
    WriteLn;
  End;
  Close(Output);
End;
Begin
  Load;
  Solve;
End.
