{$UNDEF DEBUG}
{$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}



Const
  InpF='INPUT.TXT';
  OutpF='OUTPUT.TXT';
  DebugPath='C:\work\day29\1\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=15;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}

 Const
  MaxN=500;
  MaxM=10000;
 var
  N, M: Word;
  A: Array [1..MaxM, 0..2] of Word;
  C: Array [1..MaxM] of Boolean;
  B: Array [1..MaxN, 1..3] of Word;
  D: Array [1..MaxN] of Boolean;
  CCount: Integer;

Procedure init;
 var i, j: Integer;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  Read(N, M);
  for i:=1 to M do
   Read(A[i, 0], A[i, 1], A[i, 2]);
  close(Input);
 End;

Procedure solve;
 var i, j, q: Integer;
     W: Array [1..3] of Integer;
     NotOk: Boolean;
 Begin
  FillChar(C, SizeOf(C), True);
  CCount:=M;
  FillChar(D, SizeOf(D), False);
  D[1]:=True;
  For q:=1 to N-1 do begin
    FillChar(B, SizeOf(B), 0);
    For j:=1 to M do begin
     if D[A[j, 1]] and (Not D[A[j, 0]]) Then  B[A[j, 0]] [A[j, 2]]:=j;
     if D[A[j, 0]] and (Not D[A[j, 1]]) Then  B[A[j, 1]] [A[j, 2]]:=j;
    End;
    NotOk:=True;
    For i:=1 to N do
     if NotOk And (B[i][3]<>0) Then begin
      D[i]:=True;
      C[B[i][3]]:=False;
      Dec(CCount);
      NotOk:=False;
     End;

    if NotOk Then
     For i:=1 to N do
      if NotOk And (B[i][1]<>0) And (B[i][2]<>0) Then begin
       D[i]:=True;
       C[B[i][1]]:=False;
       C[B[i][2]]:=False;
       Dec(CCount, 2);
       NotOk:=False;
      End;
   End;
 End;

procedure done;
 Var i: Integer;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  WriteLn(CCount);
  for i:=1 to M do
   if C[i] Then
    Write(i, ' ');
  close(Output);
 End;

begin
 Init;
 Solve;
 Done;
End.

