#define MAX									4005
#define LEN									2002

#include <stdio.h>

void input ();
void solve ();
void output ();
int wave (int x, int y);
int been (int x, int y);
void put (int x, int y);

char array [MAX] [MAX / 8];
int list [100], ptr = 0, n, answer;
int x [100], y [100], xs, ys, xe, ye;


main ()
 {
   input ();
   solve ();
   output ();

   return (0);
 }


void input ()
 {
 	FILE * file = fopen ("OUTPUT.TXT", "r");
   fscanf (file, "%d %d %d %d %d", & xs, & ys, & xe, & ye, & n);

   for (int i = 0; i < n; i ++)
    fscanf (file, "%d %d", & x [i], & y [i]);
    
   fclose (file);
 }

 
void solve ()
 {
   for (int i = 0; i < MAX; i ++)
	 for (int j = 0; j < MAX / 8; j ++)
     array [i] [j] = 0;

   answer = wave (xs, ys);
 }


void output ()
 {
 	FILE * file = fopen ("INPUT.TXT", "w");

   if (answer)
    {
	   fprintf (file, "%d\n", ptr);

	   for (ptr --; ptr >= 0; ptr --)
   	 fprintf (file, "%d ", list [ptr] + 1);
    }
   else fprintf (file, "-1");
    
   fclose (file);
 }


int wave (int xc, int yc)
 {
   if ((xc == xe) && (yc == ye))
    return (1);

   put (xc, yc);

   for (int i = 0; i < n; i ++)
    if (! been (2 * x [i] - xc, 2 * y [i] - yc))
     if (wave (2 * x [i] - xc, 2 * y [i] - yc))
      {
        list [ptr ++] = i;
        return (1);
      }

   return (0);
 }


int been (int x, int y)
 {
   if ((x <= -LEN) || (x >= LEN) || (y <= -LEN) || (y >= LEN))
    return (1);

   int i = x + LEN, j = y + LEN;

   switch (j % 8)
    {
    	case 0: return (array [i] [j / 8] & 1);
    	case 1: return (array [i] [j / 8] & 2);
    	case 2: return (array [i] [j / 8] & 4);
    	case 3: return (array [i] [j / 8] & 8);
    	case 4: return (array [i] [j / 8] & 16);
    	case 5: return (array [i] [j / 8] & 32);
    	case 6: return (array [i] [j / 8] & 64);
    	case 7: return (array [i] [j / 8] & 128);
    }
 }


void put (int x, int y)
 {
   int i = x + LEN, j = y + LEN;

   switch (j % 8)
    {
      case 0: array [i] [j / 8] |= 1; break;
      case 1: array [i] [j / 8] |= 2; break;
      case 2: array [i] [j / 8] |= 4; break;
      case 3: array [i] [j / 8] |= 8; break;
      case 4: array [i] [j / 8] |= 16; break;
      case 5: array [i] [j / 8] |= 32; break;
      case 6: array [i] [j / 8] |= 64; break;
      case 7: array [i] [j / 8] |= 128; break;
    }
 } 
