#include <stdio.h>
#include <math.h>

int N, XA, YA, XB, YB, X[50], Y[50];
int Ans;

struct List
{
  List(int k1 = 0, List *L = 0) : k(k1), next(L) {}

  int k;
  List *next;
};

void Remove(List *L) {if (L) {Remove(L->next); delete L;}}

struct VCT
{
  VCT() : L(0) {}

  long x, y;
  List *L;
} V[52];

List* AddList(List *A, List *B)
{
  if (B)
  {
    List *C = new List(B->k, A);
    A = C;
    B = B->next;
    while(B)
    {
      C->next = new List(B->k, C->next);
      C = C->next;
      B = B->next;
    }
  }
  return A;
}

List* AddBackList(List *A, List *B)
{
  while(B)
  {
    A = new List(B->k, A);
    B = B->next;
  }
  return A;
}

void input()
{
  int i;
  FILE *f = fopen("OUTPUT.TXT", "rt");
  fscanf(f, "%d%d%d%d%d", &XA, &YA, &XB, &YB, &N);
  for (i = 0; i < N; i++) fscanf(f, "%d%d", &X[i], &Y[i]);
  fclose(f);
}

void output()
{
  long int k;
  FILE *f = fopen("INPUT.TXT", "wt");
  if (Ans < 0) fprintf(f, "-1");
  else
  {
    List *L = V[Ans].L;
    while(L) {L = L->next; k++;}
    fprintf(f, "%ld\n", k);
    L = V[Ans].L;
    while(L)
    {
      fprintf(f, "%d ", L->k + 1);
      L = L->next;
    }
  }
  fclose(f);
}

int main()
{
  int i, j, k, t, bb;
  input();
  V[0].x = XA - XB; V[0].y = YA - YB;
  V[1].x = XA + XB - 2L*(long)X[0]; V[1].y = YA + YB - 2L*(long)Y[0];
  V[1].L = new List(0);
  for (i = 1; i < N; i++)
  {
    V[i+1].x = 2*(X[i] - X[0]); V[i+1].y = 2*(Y[i] - Y[0]);
    V[i+1].L = new List(0, new List(i));
  }
  do
  {
    bb = 0;
    for (i = 0; i < N+1; i++) if (V[i].x) for (j = 2; j < N+1; j++) if (i != j)
    {
      if (!V[i].x) break;
      if (V[j].x && labs(V[i].x) >= labs(V[j].x))
      {
        int t = labs(V[i].x) / labs(V[j].x);
        bb = 1;
        if (V[i].x*V[j].x < 0)
        {
          V[i].x += V[j].x * t;
          V[i].y += V[j].y * t;
          for (k = 0; k < t; k++) V[i].L = AddList(V[i].L, V[j].L);
        }
        else
        {
          V[i].x -= V[j].x * t;
          V[i].y -= V[j].y * t;
          for (k = 0; k < t; k++) V[i].L = AddBackList(V[i].L, V[j].L);
        }
        
      }
    }
  }
  while(bb);
  do
  {
    bb = 0;
    for (i = 0; i < N+1; i++) if (!V[i].x && V[i].y) for (j = 2; j < N+1; j++) if (i != j)
    {
      if (V[i].x || !V[i].y) break;
      if (!V[j].x && V[j].y && labs(V[i].y) >= labs(V[j].y))
      {
        t = labs(V[i].y) / labs(V[j].y);
        bb = 1;
        if (V[i].y*V[j].y < 0)
        {
          V[i].x += V[j].x * t;
          V[i].y += V[j].y * t;
          for (k = 0; k < t; k++) V[i].L = AddList(V[i].L, V[j].L);
        }
        else
        {
          V[i].x -= V[j].x * t;
          V[i].y -= V[j].y * t;
          for (k = 0; k < t; k++) V[i].L = AddBackList(V[i].L, V[j].L);
        }
      }
    }
  }
  while(bb);
  Ans = -1;
  for (k = 0; k < 2; k++)
  {
    if (V[k].x == 0 && V[k].y == 0) {Ans = k; break;}
  }
  output();
  for (i = 0; i < N+1; i++) Remove(V[i].L);
  return 0;
}
