{$I-,Q-,R-,S-,V-,X-}
uses sysutils;

type
  trec = record
    x, y, l: longint;
    p: byte;
    s: word;
  end;

const
  max = 270000;

var
  fx, fy: integer;
  n, c1: byte;
  p: array[1..50, 1..2] of integer;
  st: array[1..max] of trec;
  b, e: longint;
  breaktime: double;

procedure add(x, y, l: longint; p: byte; s: word);
var
  a: longint;
begin
  if (x = fx) and (y = fy) then begin
    writeln(s);
    write(p, ' ');
    a := l;
    while a <> 1 do begin
      write(st[a].p, ' '); a := st[a].l;
    end;
    close(output); halt;
  end;
  inc(e);
  st[e].x := x; st[e].y := y; st[e].l := l;
  st[e].p := p; st[e].s := s;
end;

begin
  breaktime := now+(9.5/(24*60*60));
  assign(input, 'OUTPUT.TXT'); reset(input);
  assign(output, 'INPUT.TXT'); rewrite(output);
  b := 1; e := 1;
  read(fx, fy, st[1].x, st[1].y); st[1].l := 0; st[1].p := 0; st[1].s := 0;
  if (fx = st[1].x) and (fy = st[1].y) then begin
    writeln(0); close(output); halt;
  end;
  read(n);
  for c1 := 1 to n do begin
    read(p[c1, 1], p[c1, 2]);
  end;
  while b <= e do begin
    if now >= breaktime then begin
      writeln('-1'); close(output); halt;
    end;
    for c1 := 1 to n do if c1 <> st[b].p then begin
      add(st[b].x+2*(p[c1, 1]-st[b].x),
          st[b].y+2*(p[c1, 2]-st[b].y),
          b, c1, st[b].s+1);
    end;
    inc(b);
  end;
  writeln('-1'); close(output); halt;
end.
