{$I-,Q-,R-,S-,V-,X-}
Program Spaceship;
Const
  InFile='OUTPUT.TXT';
  OutFile='INPUT.TXT';
  MaxN=52;
  MaxJ=100002;
Var
  X1,Y1,X2,Y2:LongInt;
  N:Byte;
  Pl:Array[1..MaxN,0..1]Of LongInt;
  NJ:LongInt;
  Ju:Array[1..MaxJ]Of Byte;
Procedure Load;
Var
  I:Byte;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(X1,Y1,X2,Y2);
  If Not SeekEOF Then Read(N);
  For I:=1 To N Do
    If Not SeekEOF Then Read(Pl[I][0],Pl[I][1]);
  Close(Input);
End;
Procedure Euclid(A,B:LongInt; Var D,E,F:LongInt);
Var
  T,TE,TF,E1,F1,E2,F2:LongInt;
Begin
  E1:=1;
  F1:=0;
  E2:=0;
  F2:=1;
  While B>0 Do Begin
    T:=A Mod B;
    TE:=E1-E2*(A Div B);
    TF:=F1-F2*(A Div B);
    A:=B;
    E1:=E2;
    F1:=F2;
    B:=T;
    E2:=TE;
    F2:=TF;
  End;
  D:=A;
  E:=E1;
  F:=F1;
End;
Procedure Jump(Over:Byte);
Begin
  If NJ<MaxJ Then Begin
    Inc(NJ);
    Ju[NJ]:=Over;
  End;
  X1:=2*Pl[Over][0]-X1;
  Y1:=2*Pl[Over][1]-Y1;
End;
Procedure Solve;
Var
  HowMany,II,JJ,I,J:LongInt;
  D,E,F,DX1,DY1,DX2,DY2:LongInt;
Label Lab,Lab2;
Begin
  NJ:=0;
  For I:=2 To N Do
    For J:=2 To N Do Begin
      DX1:=2*(Pl[I][0]-Pl[1][0]);
      DY1:=2*(Pl[I][1]-Pl[1][1]);
      DX2:=2*(Pl[J][0]-Pl[1][0]);
      DY2:=2*(Pl[J][1]-Pl[1][1]);
      Euclid(DX1,DX2,D,E,F);
      If (X2-X1) Mod D=0 Then Goto Lab;
    End;
  NJ:=-1;
  Exit;
  Lab:
  While E>DX2 Do Begin Dec(E,DX2); Inc(F,DX1); End;
  While E<0 Do Begin Inc(E,DX2); Dec(F,DX1); End;
  HowMany:=(X2-X1) Div D;
  For II:=1 To HowMany*Abs(E) Do
    If E>0 Then Begin
      Jump(1);
      Jump(I);
    End Else Begin
      Jump(I);
      Jump(1);
    End;
  For II:=1 To HowMany*Abs(F) Do
    If F>0 Then Begin
      Jump(1);
      Jump(J);
    End Else Begin
      Jump(J);
      Jump(1);
    End;
  For I:=2 To N Do
    For J:=2 To N Do Begin
      DX1:=2*(Pl[I][0]-Pl[1][0]);
      DY1:=2*(Pl[I][1]-Pl[1][1]);
      DX2:=2*(Pl[J][0]-Pl[1][0]);
      DY2:=2*(Pl[J][1]-Pl[1][1]);
      D:=-DX1*DY2+DX2*DY1;
      If D=0 Then Continue;
      E:=DX2;
      F:=-DX1;
      If (Y2-Y1) Mod D=0 Then Goto Lab2;
    End;
  For I:=2 To N Do Begin
      DX1:=2*(Pl[I][0]-Pl[1][0]);
      DY1:=2*(Pl[I][1]-Pl[1][1]);
      D:=DY1;
      If D=0 Then Continue;
      E:=(Y2-Y1) Div D;
      F:=0;
      If (DX1=0) And ((Y2-Y1) Mod D=0) Then Goto Lab2;
  End;
  NJ:=-1;
  Exit;
  Lab2:
  HowMany:=(Y2-Y1) Div D;
  For II:=1 To HowMany*Abs(E) Do Begin
    Jump(1);
    Jump(I);
  End;
  For II:=1 To HowMany*Abs(F) Do Begin
    Jump(J);
    Jump(1);
  End;
End;
Procedure Save;
Var
  I:LongINt;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(NJ);
  If NJ>0 Then Begin
    For I:=1 To NJ Do Begin
      If I>1 Then Write(' ');
      Write(Ju[I]);
    End;
    WriteLn;
  End;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
