{$UNDEF DEBUG}
{$DEFINE TIMELIMIT}

{$IFDEF TIMELIMIT}
Uses Sysutils;
{$ENDIF}



Const
  InpF='OUTPUT.TXT';
  OutpF='INPUT.TXT';
  DebugPath='c:\work\30\';
 {$IFDEF DEBUG}
  Inp=DebugPath+InpF;
  Outp=DebugPath+OutpF;
 {$ELSE}
  Inp=InpF;
  Outp=OutpF;
 {$ENDIF}
 {$IFDEF TIMELIMIT}
  TimeLimit=9;
 {$ENDIF}


 {$IFDEF TIMELIMIT}
  var
   Break: TDatetime;
 {$ENDIF}


Const
 MaxN=50;
 MaxM=100000;
Type
 TPoint = Record
           X, Y: Longint;
          End;

var
 N: Word;
 S, D: TPoint;
 A: Array [1..MaxN] of TPoint;
 B: Array [1..MaxM] of Byte;
 M: Longint;
 tt: Word;

Procedure init;
 var i, j: Integer;
 Begin
  {$IFDEF TIMELIMIT}
  Break:=Time+TimeLimit/24/3600;
  {$ENDIF}
  Assign(Input, Inp);
  reset(input);
  Read(S.X, S.Y, D.X, D.Y);
  read(N);
  For i:=1 to N do
   Read(A[i].X, A[i].Y);
  close(Input);
End;

procedure done;
 var i: Longint;
 Begin
  Assign(Output, Outp);
  rewrite(Output);
  WriteLn(M);
  for i:=1 to M do Write(B[i], ' ');
  close(Output);
  Halt(0);
 End;


Function KMove(Var A, B, C: TPoint; var L: Longint): Longint;
 Begin
  C.X:=B.X*2-A.X;
  C.Y:=B.Y*2-A.Y;
  L:=Sqr(C.X-D.X) + Sqr(C.Y-D.Y);
  KMove:=L;
 End;

Procedure Add(q: Integer);
 Begin
  inc(M);
  B[M]:=q;
 End;

Procedure solve;
 var i, j, k: Integer;
     q, w, e: TPoint;
     R, R1, P: Longint;
 Begin
  M:=0;
  R:=Sqr(S.X-D.X) + Sqr(S.Y-D.Y);
  tt:=0;
  While R>0 do Begin
   tt:=(tt+1) and $FFF;
   if (M=MaxM) or ((tt=0) and (Time>=Break)) Then begin
    m:=-1;
    Done;
   End;

   R1:=R;
   for i:=1 to N do
    if KMove(S, A[i], Q, P)<R Then begin
     R:=P;
     S:=Q;
     Add(i);
    End;

   for i:=1 to N do begin
    KMove(S, A[i], Q, P);
    for j:=1 to N do if i<>j Then
     if KMove(Q, A[j], W, P)<R Then begin
      R:=P;
      S:=W;
      Add(i);
      Add(j);
     End;
   end;


   for i:=1 to N do begin
    KMove(S, A[i], Q, P);
    for j:=1 to N do if i<>j Then begin
     KMove(Q, A[j], W, P);
     for k:=1 to N do if (k<>j) Then
      if KMove(W, A[k], E, P)<R Then begin
       R:=P;
       S:=E;
       Add(i);
       Add(j);
       Add(k);
      End;
    end;
   end;
   if R1=R Then
    KMove(S, A[random(N)+1], S, R);
  End;
 End;

begin
 Init;
 Solve;
 Done;
End.

